#
# Copyright (c) 2016,... NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions::ResponseException that will be thrown
##          when there are errors with AVA APISets
##
## @author nsesha@netapp.com, dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::AVAException.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception for when a method fails for AVA APISets

=head1 See Also

Package inherits from the following modules. See these modules for further
interface detail.

B<NACL/APISet/Exceptions/ResponseException>

=head1 NACL::APISet::Exceptions::AVAException

=head2 Expected use

Use when AVA APISet fails

=head2 Usage

Same as for exceptions defined by ResponseException

=head2 Base Class

NACL::APISet::Exceptions::ResponseException

=cut

package NACL::APISet::Exceptions::AVAException;
use base qw(NACL::APISet::Exceptions::ResponseException);
1;
