#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when information
##          about the required version attribute could not be found
##
## @author pressley@netapp.com, Isshwarya.M@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::AttributeDiscoveryFailed.pm

=head1 Author

David Pressley, Isshwarya.M@netapp.com

=head1 Description

An exception for when the required version attribute could not be found

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::APISet::Exceptions::AttributeDiscoveryFailed

=head2 Expected use

Use when the required version attribute couldn't be found in the vesion object
even after discovery also

=head2 Base Class

NATE::BaseException

=cut

package NACL::APISet::Exceptions::AttributeDiscoveryFailed;
use base qw(NATE::BaseException);
1;
