#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a 
##          method detects that it can't find CDEF files.
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::CDEFNotFoundException.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception for when a method detects that it can't find CDEF files.

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NATE/BaseException.pm>

=head1 NACL::APISet::Exceptions::CDEFNotFoundException

=head2 Expected use

Use when a method detects that it can't find CDEF files

=head2 Usage

Same as for exceptions defined by BaseException

=head2 Base Class

NATE::BaseException

=cut

package NACL::APISet::Exceptions::CDEFNotFoundException;
use base qw(NATE::BaseException);
1;
