#
# $Id: //depot/prod/test/nacldev/lib/NACL/APISet/Exceptions/CapabilityException.pm#1 $
#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions::ResponseException that will be thrown when a command
##          is called but the user does not have the appropriate
##          capability to execute the command 
##
## @author dl-sm-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::CapabilityException.pm

=head1 Author

dl-sm-nacl-dev@netapp.com

=head1 Description

An exception for when a called method is called with the user not having
the corresponding capability 


=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NACL/APISet/Exceptions/ResponseException.pm>

=head1 NACL::APISet::Exceptions::CapabilityException

=head2 Expected use

Use when a command is called but the user does not have the appropriate
capability to execute the command


=head2 Usage

Same as for exceptions defined by ResponseException

=head2 Base Class

NACL::APISet::Exceptions::ResponseException

=cut

package NACL::APISet::Exceptions::CapabilityException;
use base qw(NACL::APISet::Exceptions::ResponseException);

1;
