#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a 
##          connection cannot be established.
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::ConnectionFailedException.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception for when a connection cannot be established.

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NATE/BaseException.pm>

=head1 NACL::APISet::Exceptions::ConnectionFailedException

=head2 Expected use

Use when a connection cannot be established.

=head2 Usage

Same as for exceptions defined by BaseException

=head2 Base Class

NATE::BaseException

=cut

package NACL::APISet::Exceptions::ConnectionFailedException;
use base qw(NATE::BaseException);
1;
