#
# Copyright (c) 2009-2012 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions:CommandFailedException that will be thrown
##          when a 'vol destroy' command failed to destroy inconsistent volume
##
##
## @author dl-nacl-dev@netapp.com
## @status public
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::InconsistentVolume

=head1 Author

dl-nacl-dev@netapp

=head1 Description

An exception that is thrown when 'vol destroy' command is failed
to destroy inconsistent volume.

=head1 See Also

Package inherits from the following modules. See these modules for further
interface detail.

B<NACL/APISet/Exceptions/CommandFailedException.pm>

=head1 NACL::Exceptions::InconsistentVolume

=head2 Expected use

This exception will be thrown, when volume is marked inconsistent,
there by failing 'vol destroy' command execution in 7-mode.

=head2 Usage

Same as for exceptions defined by L<ResponseException|lib-NACL-APISet-Exceptions-ResponseException-pm>

=head2 Base Class

NACL::APISet::Exceptions::CommandFailedException

=cut

package NACL::APISet::Exceptions::InconsistentVolume;
use base qw(NACL::APISet::Exceptions::CommandFailedException);
1;
