#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a particular
##          CDEF structure is found to be invalid or not in the expected
##          format
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::InvalidCDEFException

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception for when the structure of a CDEF is found to be invalid.

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::APISet::Exceptions::InvalidCDEFException.pm

=head2 Expected use

Use when a CDEF structure is not in the expected format

=head2 Usage

Same as for exceptions defined by BaseException.pm

=head2 Base Class

NATE::BaseException

=cut

package NACL::APISet::Exceptions::InvalidCDEFException;
use base qw(NATE::BaseException);
1;
