#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a 
##          invalid input request is specified on SNMP APISet object
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::InvalidInputRequest.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception for invoking an invalid PDU or specifying invalid inputs 
on SNMP APISet class in which case no input request in sent at all.

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NATE/BaseException.pm>

=head1 NACL::APISet::Exceptions::InvalidInputRequest

=head2 Expected use

Use when the SNMP input request PDU couldn't be sent

=head2 Usage

Same as for exceptions defined by BaseException

=head2 Base Class

NATE::BaseException

=cut

package NACL::APISet::Exceptions::InvalidInputRequest;
use base qw(NATE::BaseException);
1;
