#
# Copyright (c) 2009-2011 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions::InvalidParamValueException that will be
##          thrown if a Nodescope command is issued against an invalid
##          node.
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::InvalidNodescopeNodeException.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception to be thrown if a Nodescope command is issued against an invalid
node.

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NACL/APISet/Exceptions/InvalidParamValueException>

=head1 NACL::APISet::Exceptions::InvalidNodescopeNodeException

=head2 Expected use

Use if a Nodescope command is issued against an invalid node.

=head2 Usage

Same as for exceptions defined by InvalidParamValueException

=head2 Base Class

NACL::APISet::Exceptions::InvalidParamValueException

=cut

package NACL::APISet::Exceptions::InvalidNodescopeNodeException;
use base qw(NACL::APISet::Exceptions::InvalidParamValueException);
1;
