#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a particular
##          XML structure is found to be invalid while processing it.
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::InvalidXMLException

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception for when the structure of a XML is found to be invalid.

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::APISet::Exceptions::InvalidXMLException.pm

=head2 Expected use

Use when a XML structure is tried to parse and $@ is populated with error on
using XML libraries

=head2 Usage

Same as for exceptions defined by BaseException.pm

=head2 Base Class

NATE::BaseException

=cut

package NACL::APISet::Exceptions::InvalidXMLException;
use base qw(NATE::BaseException);
1;
