#
# Copyright (c) 2009-2013 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions::ResponseException that will be thrown when a command
##          spawned a Job that eventually failed.
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::JobFailedException.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception when a command spawned a Job that fails

=head1 See Also

Package inherits from the following modules. See these modules for further
interface detail.

B<NACL/APISet/Exceptions/ResponseException.pm>

=head1 NACL::APISet::Exceptions::JobFailedException

=head2 Expected use

Use when a command is expected to spawn a Job.

=head2 Usage

Same as for exceptions defined by ResponseException

=head2 Base Class

NACL::APISet::Exceptions::ResponseException

=cut

package NACL::APISet::Exceptions::JobFailedException;
use base qw(NACL::APISet::Exceptions::ResponseException);
1;
