#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a method
##          doesn't have a corresponding entry in the CDEF file.
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::MethodNotFoundException.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception for when a called method doesn't have a corresponding entry 
in the CDEF file.

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::APISet::Exceptions::MethodNotFoundException

=head2 Expected use

Use when a method doesn't have a corresponding entry in the CDEF file.

=head2 Usage

Same as for exceptions defined by BaseException.pm

=head2 Base Class

NATE::BaseException

=cut

package NACL::APISet::Exceptions::MethodNotFoundException;
use base qw(NATE::BaseException);
1;
