#
# Copyright (c) 2009-2012 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions::ResponseException that will be thrown
#           when a mgwd has crashed.
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::MgwdCrashedException

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception for when mgwd has crashed

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

L<NACL::APISet::Exceptions::ResponseException|lib-NACL-APISet-Exceptions-ResponseException-pm>
=head1 NACL::APISet::Exceptions::MgwdCrashedException

=head2 Expected use

Use when a mgwd crash has occured.

=head2 Usage

Same as for exceptions defined by ResponseException

=head2 Base Class

NACL::APISet::Exceptions::ResponseException

=cut

package NACL::APISet::Exceptions::MgwdCrashedException;
use base qw(NACL::APISet::Exceptions::ResponseException);
1;
