#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a method
##          doesn't have a schema object when one is expected.
##
## @author pressley@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::MissingSchema.pm

=head1 Author

David Pressley

=head1 Description

An exception for when a method detects doesn't have a schema object
when one is expected.

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::APISet::Exceptions::MissingSchema

=head2 Expected use

Use when a method detects that it can not get/create a Schema object

=head2 Base Class

NATE::BaseException

=cut

package NACL::APISet::Exceptions::MissingSchema;
use base qw(NATE::BaseException);
1;
