#
# $Id: //depot/prod/test/main/lib/NACL/APISet/Exceptions/MissingValueException.pm#1 $
#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions:ResponseException that will be thrown
##          when a command is called without providing the value for
##          one or more required parameters.
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::Exceptions::MissingValueException.pm

=head1 Author

dl-nacl-dev@netapp.cp,

=head1 Description

An exception for when a command is called without providing the value for one or more required parameters.

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NACL/APISet/Exceptions/ResponseException.pm>

=head1 NACL::Exceptions::MissingValueException

=head2 Expected use

Use when a command is called without providing the value for one or more required parameters.

=head2 Usage

Same as for exceptions defined by ResponseException

=head2 Base Class

NACL::APISet::Exceptions::ResponseException

=cut

package NACL::APISet::Exceptions::MissingValueException;
use base qw(NACL::APISet::Exceptions::ResponseException);
1;
