#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a method
##          doesn't have a version object when one is expected.
##
## @author pressley@netapp.com, Isshwarya.M @netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::MissingVersionManager.pm

=head1 Author

David Pressley, Isshwarya Makudeswaran

=head1 Description

An exception for when a method detects doesn't have a version object
when one is expected.

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::APISet::Exceptions::MissingVersionManager

=head2 Expected use

Use when the accessor method for getting teh version object is not able to
find it

=head2 Base Class

NATE::BaseException

=cut

package NACL::APISet::Exceptions::MissingVersionManager;
use base qw(NATE::BaseException);
1;
