#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a
##          matching API version is not found
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::NoMatchingAPIException.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception for when a matching API version is not found.

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::APISet::Exceptions::NoMatchingAPIException

=head2 Expected use

Use when a matching API version is not found.

=head2 Usage

Same as for exceptions defined by BaseException.pm

=head2 Base Class

NATE::BaseException

=cut

package NACL::APISet::Exceptions::NoMatchingAPIException;
use base qw(NATE::BaseException);
1;
