#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions:CommandFailedException that will be thrown 
##          when a command produces no matching results for the query
##
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::NoMatchingEntriesException.pm

=head1 Author

dl-nacl-dev@netapp

=head1 Description

An exception that is thrown when a command (usually a show or get command) 
produces no matching results for the query

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NACL/APISet/Exceptions/CommandFailedException.pm>

=head1 NACL::Exceptions::NoMatchingEntriesException

=head2 Expected use

When no matching results are produced by the query command

=head2 Usage

Same as for exceptions defined by L<ResponseException|lib-NACL-APISet-Exceptions-ResponseException-pm>

=head2 Base Class

NACL::APISet::Exceptions::CommandFailedException

=cut

package NACL::APISet::Exceptions::NoMatchingEntriesException;
use base qw(NACL::APISet::Exceptions::CommandFailedException);
1;
