#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a 
##          invalid PDU method name is invoked on the SNMP APISet class
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::ObjectRetrievalFailed.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception when the specified SNMP object instance couldn't be retrieved

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NACL/APISet/Exceptions/ResponseException.pm>

=head1 NACL::APISet::Exceptions::ObjectRetrievalFailed

=head2 Expected use

Use when ASN.1 type tag in the response PDU corresponds to noSuchObject,
noSuchInstance and endOfMibView which SNMPv2c and SNMPv3 ignores them
from treating as error cases.

=head2 Usage

Same as for exceptions defined by BaseException

=head2 Base Class

NATE::BaseException

=cut

package NACL::APISet::Exceptions::ObjectRetrievalFailed;
use base qw(NACL::APISet::Exceptions::ResponseException);
1;
