#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions::ResponseException that will be thrown when 
##          a command is called with an option that exists in the
##          CDEFs but for which parsing has not been implemented
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::ParserOptionNotImplementedException.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception for when a command is called with an option that exists in the
CDEFs but for which parsing has not been implemented.

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NACL/APISet/Exceptions/ResponseException.pm>

=head1 NACL::APISet::Exceptions::ParserOptionNotImplementedException

=head2 Expected use

Use when a command is called with an option that exists in the CDEFs but for 
which parsing has not been implemented

=head2 Usage

Same as for exceptions defined by ResponseException

=head2 Base Class

NACL::APISet::Exceptions::ResponseException

=cut

package NACL::APISet::Exceptions::ParserOptionNotImplementedException;
use base qw(NACL::APISet::Exceptions::ResponseException);
1;
