#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions::ResponseException that will be thrown when 
##          an invalid index is provided in a call to get_row
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::RowNotFoundException.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception for when an invalid index is provided in a call to get_row

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NACL/APISet/Exceptions/ResponseException.pm>

=head1 NACL::APISet::Exceptions::RowNotFoundException

=head2 Expected use

Use when an invalid index is provided in a call to get_row

=head2 Usage

Same as for exceptions defined by ResponseException

=head2 Base Class

NACL::APISet::Exceptions::ResponseException

=cut

package NACL::APISet::Exceptions::RowNotFoundException;
use base qw(NACL::APISet::Exceptions::ResponseException);
1;
