#
# $Id: //depot/prod/test/nacldev/lib/NACL/APISet/Exceptions/ServiceException.pm#1 $
#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions::ResponseException that will be thrown when a command
##          is called but the corresponding service is inactive.
##
## @author dl-sm-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::ServiceException.pm

=head1 Author

dl-sm-nacl-dev@netapp.com

=head1 Description

An exception for when a command is called but the corresponding service
is inactive 


=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NACL/APISet/Exceptions/ResponseException.pm>

=head1 NACL::APISet::Exceptions::ServiceException

=head2 Expected use

Use when a method is called with a parameter not found in the CDEF entry.

=head2 Usage

Same as for exceptions defined by ResponseException

=head2 Base Class

NACL::APISet::Exceptions::ResponseException

=cut

package NACL::APISet::Exceptions::ServiceException;
use base qw(NACL::APISet::Exceptions::ResponseException);

1;
