#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions::ResponseException that will be thrown if 
##          no status is returned after a call to get_exit_status()
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::StatusNotFoundException.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception to be thrown when no status is returned after a call to 
get_exit_status().

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NACL/APISet/Exceptions/ResponseException.pm>

=head1 NACL::APISet::Exceptions::StatusNotFoundException

=head2 Expected use

Use if no status is returned after a call to get_exit_status()

=head2 Base Class

NACL::APISet::Exceptions::ResponseException

=cut

package NACL::APISet::Exceptions::StatusNotFoundException;
use base qw(NACL::APISet::Exceptions::ResponseException);
1;
