#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions::ResponseException that will be thrown when 
##          command output is not in the expected format.
##          This also included cases where command output is
##          expected but we get none or when we get command output
##          when it is not expected.
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::UnexpectedOutputException.pm

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception for when command output is not in the expected format.
This also included cases where command output is expected but we get none 
or when we get command output when it is not expected.

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NACL/APISet/Exceptions/ResponseException.pm>

=head1 NACL::APISet::Exceptions::UnexpectedOutputException

=head2 Expected use

Use when command output is not in the expected format. This includes
cases where command output is expected but we get none or when we get command 
output when it is not expected.

=head2 Usage

Same as for exceptions defined by ResponseException

=head2 Base Class

NACL::APISet::Exceptions::ResponseException

=cut

package NACL::APISet::Exceptions::UnexpectedOutputException;
use base qw(NACL::APISet::Exceptions::ResponseException);
1;
