#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions:ResponseException that will be thrown 
##          when a particular option's execution is not supported.
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::Exceptions::UnsupportedOptionException.pm

=head1 Author

dl-nacl-dev@netapp.cp,

=head1 Description

An exception for when a particular option's execution is not supported.

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

B<NACL/APISet/Exceptions/ResponseException.pm>

=head1 NACL::Exceptions::UnsupportedOptionException

=head2 Expected use

Use when a particular option's execution is not supported.

=head2 Usage

Same as for exceptions defined by ResponseException

=head2 Base Class

NACL::APISet::Exceptions::ResponseException

=cut

package NACL::APISet::Exceptions::UnsupportedOptionException;
use base qw(NACL::APISet::Exceptions::ResponseException);
1;
