#
# Copyright (c) 2016 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::APISet::Exceptions:CommandFailedException that will be thrown
##          when 'wreck' command fails to restrict a volume.
##
##
## @author dl-nacl-dev@netapp.com
## @status public
## @pod here

=pod

=head1 Package Name

NACL::APISet::Exceptions::VolumeNotRestrictedException

=head1 Author

dl-nacl-dev@netapp

=head1 Description

An exception that is thrown when 'wreck' command fails to restrict a volume.

=head1 See Also

Package inherits from the following modules. See these modules for further
interface detail.

B<NACL/APISet/Exceptions/CommandFailedException.pm>

=head1 NACL::Exceptions::VolumeNotRestrictedException

=head2 Expected use

This exception will be thrown, when volume is marked in use by other operations/mounted volume,
there by failing 'wreck' command execution in 7-mode.

=head2 Usage

Same as for exceptions defined by L<ResponseException|lib-NACL-APISet-Exceptions-ResponseException-pm>

=head2 Base Class

NACL::APISet::Exceptions::CommandFailedException

=cut

package NACL::APISet::Exceptions::VolumeNotRestrictedException;
use base qw(NACL::APISet::Exceptions::CommandFailedException);
1;

