
#
# Copyright (c) 2001-2009 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary API Set for Freebsd CLI commands
## @author Isshwarya.M@netapp.com, anerudh@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

package NACL::APISet::Host::CLI::Freebsd;

#
# Compiler Directives
#
use strict;
use warnings;

use base qw(NACL::APISet::Host::CLI);

#
# Module imports - APISet
#
use NACL::APISet::Session::CLI::Freebsd;
use NACL::APISet::Session::CLI::CMode::Shell;
use NACL::APISet::Session::CLI::7Mode::Shell;

#
# NATE imports
#
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Params::Validate qw(:all);
use Data::Dumper;

=head1 NAME

NACL::APISet::Host::CLI::Freebsd - API Set for Freebsd CLI commands

=head1 SYNOPSIS

use NACL::APISet::Host::CLI::Freebsd;

=head1 DESCRIPTION

A C<NACL::APISet::Host::CLI::Freebsd> is used to connect to and send CLI commands
to the Freebsd Host.

=head1 CONSTRUCTORS

=head2 new

Returns a reference to a newly created C<NACL::APISet::Host::CLI::Freebsd>.

=over

=item Synopsis

 $api_set_obj = NACL::APISet::Host::CLI::Freebsd->new( %args );

=item Arguments

=over

=item %args

(Optional)
Parameters passed to parent classes.  See NACL::APISet and
NACL::APISet::Host::CLI for details.

=back

=item Returns

A reference to a new API Set.

=back

=head1 AUTHOR/MAINTAINER

=over

=item NACL Development (dl-nacl-dev@netapp.com)

=back


=cut

1;
