#Copyright (c) 2017 Network Appliance, Inc.
#All rights reserved.
#
## @summary Routines to parse Linux echo command output
##
## @description
##    This is a library to parse the raw output of linux echo command.
##
## @synopsis
##    use NACL::APISet::Host::CLI::Linux::Redhat::echo;
##
##    echo(%args);
##
## @author dl-nacl-dev@netapp.com
##
## @status public
#
package NACL::APISet::Host::CLI::Linux::Redhat::echo;

use strict;
use warnings;

#Include exceptions which will be thrown
use NACL::APISet::Exceptions::CommandFailedException qw(:try);

sub echo {
    my %args = @_;

    my $error_message;
    my $resp = $args{response_object};
    my $output = $resp->get_processed_output();
    my $error_level = $resp->get_execution_status();
    if($error_level) {
        NACL::APISet::Exceptions::CommandFailedException->throw(text=>$output,response_object => $resp);
    }
    return [];
}

1;
