#Copyright (c) 2011 Network Appliance, Inc.
#All rights reserved.
#
## @summary Routines to parse Linux mkinitrd command output
##
## @description
##    This is a library to parse the raw output of Linux mkinitrd command.
##
## @synopsis
##    use NACL::APISet::Host::CLI::Linux::mkinitrd;
##
##    mkrinitrd(%args);
##
## @author sheethal(sheethal@netapp.com), dl-nacl-dev@netapp.com
##
## @status public
#
package NACL::APISet::Host::CLI::Linux::Redhat::mkinitrd;

use strict;
use warnings;

#Include exceptions which will be thrown
use NACL::APISet::Exceptions::CommandFailedException qw(:try);


sub mkinitrd {
    my %args = @_;
    my $error_message;
    my $resp = $args{response_object};
    my $output = $resp->get_processed_output();
    my $error_level = $resp->get_execution_status();
    if($error_level) {
        NACL::APISet::Exceptions::CommandFailedException->throw(text=>$output,response_object => $resp);
    }
    return [];
}

1;
