#$Id: //depot/prod/test/nacldev/lib/NACL/APISet/Host/CLI/Linux/Redhat/start_udev.pm#1 $
#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
# Any use, modification, or distribution is prohibited
# without prior written consent from NetApp, Inc.
#
## @summary start_udev command output
##
## @description
##   This library supports error checking for kenv command, but output parsing is not supported as of now.
##
## @synopsis
##    use NACL::APISet::Host::CLI::Linux::Redhat::start_udev;
##
##    start_udev(%args);
##
## @author skotagir@netapp.com,dl-nacl-dev@netapp.com
##
## @status public
#

package NACL::APISet::Host::CLI::Linux::Redhat::start_udev;

#Include exceptions which will be thrown
use NACL::APISet::Exceptions::CommandFailedException qw(:try);

use strict;

sub _check_error {
    my %args        = @_;
    my $resp        = $args{response_object};
    my $raw_output  = $args{raw_output};
    my $error_level = $resp->get_execution_status();
    if ($error_level) {
        NACL::APISet::Exceptions::CommandFailedException->throw(
            text => $raw_output,
            response_object => $resp
        );
    }

} ## end sub _check_error

## @name ::start_udev
##
## @summary Parses the raw output from the "start_udev" command
##
## @description
##    This method can be used for parsing the raw output obtained after calling
##    the method from start_udev with any of its options as described in the
##    corresponding cdef file 'start_udev.cdefs'
## @synopsis
##      start_udev(%args);
## INPUTS TO METHOD CALL 'start_udev' ON APISET OBJECT
## <table border = "1" >
## <tr> <th> OPTION </th> <th> PROGRAMMATIC NAME </th> <th> BOOLEAN OPTION </th> </tr>
## </table>
## @arg %args Required:
## response_object => The response object that was constructed (containing the
##                    raw output, command line constructed and execution status)
## @return
##Returns: Output parsing is not supported.

sub start_udev {
    my %args   = @_;
    my $resp   = $args{response_object};
    my $output = $resp->get_processed_output();
    _check_error( raw_output => $output, response_object => $resp );
    return [];
} ## end sub start_udev
1;

