# $Id: //depot/prod/test/main/lib/NACL/APISet/Host/CLI/ONTAPSelectDeploy.pm#3 $

#
# Copyright (c) 2016 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
## @summary API Set for ONTAPSelectDeploy CLI commands
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

package NACL::APISet::Host::CLI::ONTAPSelectDeploy;

#
# Compiler Directives
#
use strict;
use warnings;

use base qw(NACL::APISet::Host::CLI);

#
# APISet imports
#
use NACL::APISet::Session::CLI::ONTAPSelectDeploy;

#
# NATE imports
#
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Params::Validate qw(:all);
use Data::Dumper;

1;

##############################################################################
#                                    POD here
##############################################################################

=head1 NAME

NACL::APISet::Host::CLI::ONTAPSelectDeploy - API Set for ONTAPSelectDeploy CLI commands

=head1 SYNOPSIS

use NACL::APISet::Host::CLI::ONTAPSelectDeploy;

=head1 DESCRIPTION

A C<NACL::APISet::Host::CLI::ONTAPSelectDeploy> is used to connect to and send CLI commands
to the ONTAPSelectDeploy Host.

=head1 CONSTRUCTORS

=head2 new

Returns a reference to a newly created C<NACL::APISet::Host::CLI::ONTAPSelectDeploy>.

=over

=item Synopsis

 $api_set_obj = NACL::APISet::Host::CLI::ONTAPSelectDeploy->new( %args );

=item Arguments

=over

=item %args

(Optional)
Parameters passed to parent classes.  See NACL::APISet and
NACL::APISet::Host::CLI for details.

=back

=item Returns

A reference to a new ONTAPSelectDeploy API Set.

=back

=head1 AUTHOR/MAINTAINER

=over

=item NACL Development (dl-nacl-dev@netapp.com)

=back

$Id: //depot/prod/test/main/lib/NACL/APISet/Host/CLI/ONTAPSelectDeploy.pm#3 $

=cut

