# $Id$
#
#Copyright (c) 2011-2012 Network Appliance, Inc.
#All rights reserved.
#
## @summary Routines to parse Linux cat command output
##
## @description
##    This library supports error checking for cat command, but output parsing is not supported as of now..
##
## @synopsis
##    use NACL::APISet::Host::CLI::Linux::Redhat::cat;
##
##    cat(%args);
##
## @author Anupama(anupamap@netapp.com), dl-nacl-dev@netapp.com
##
## @status public
#
package NACL::APISet::Host::CLI::Unix::cat;

use strict;
use warnings;

#Include exceptions which will be thrown
use NACL::APISet::Exceptions::InvalidParamValueException;
use NACL::APISet::Exceptions::InvalidParamException;

sub _check_error {
    my %args          = @_;
    my $raw_output    = $args{raw_output};
    my $resp       = $args{response_object};
    my $error_message;
    my $error         = undef;
    if ($raw_output =~ /cat: .* No such file or directory/) {
        $error          = "InvalidParamValue";
        $error_message = $raw_output;
    } elsif ($raw_output =~ /(cat: invalid option .*)/) {
        $error          = "InvalidParam";
        $error_message = $raw_output;
    }

    if ($error) {
        $error = 'NACL::APISet::Exceptions::' . $error . 'Exception';
        $error->throw(text => $error_message, response_object => $resp);
    }

} ## end sub _check_error

sub cat {
    my %args = @_;
    my $error_message;
    my $resp        = $args{response_object};
    my $output      = $resp->get_processed_output();
    my $command     = $resp->get_actual_command();
    my $error_level = $resp->get_execution_status();
    _check_error("raw_output" => $output, 'response_object' => $resp );

    #Output is not required to be parsed
    return [];

} ## end sub cat

1;

