# $Id$
# Copyright (c) 2001-2014 Network Appliance, Inc.
# All rights reserved.
#
## @summary
##  Global Constants used to fetch 7-mode transition tool details.
##
## @description
##  Using this library, user can fetch the 7-mode transition tool details.
##
## @synopsis
##  use NACL::APISet::Host::GUI::SMTT::V1_4::GlobalConst;
##
## @status Review
## @author rohit4@netapp.com, dl-nacl-dev@netapp.com
## @pod here

package NACL::APISet::Host::GUI::SMTT::V1_4::GlobalConst;

use Exporter 'import';

our @EXPORT = qw (

    $GENERIC_WAIT $GENERIC_PRECHECKS_WAIT $GENERIC_VOLUMEPAIR_LOAD
    $SEL_DEBUG_LOGS
    $NAVIGATE_TRANSITION_CREATE $NAVIGATE_TRANSITION_STORAGE
    $LOGIN_USERNAME $LOGIN_PASSWORD $LOGIN_BUTTON
    $HOSTNAME $HOST_USERNAME $HOST_PASSWORD $HOST_ADD
    $NEW_TRANSITION_PROJECT_NAME_MESSAGE $PROJECT_NAME $MULTIPATH_IP $DATA_COPY_IP
    $PROJECT_SELECTOR $PROJECT_NAME $PROJECT_NAME_CHANGE $PROJECT_NAME_SAVE
    $PROJECT_NAME_INPUT $SUBPROJECT_NAME_INPUT
    $GENERIC_VFILER_SELECTOR $GENERIC_VOLUME $GENERIC_CHECKBOX $GENERIC_VOLUME_STANDALONE_SELECTOR
    $GENERIC_VOLUME_STAGGERED_SELECTOR $GENERIC_VSERVER $GENERIC_VSERVER_SELECTOR
    $GENERIC_AGGR $GENERIC_AGGR_SELECTOR $GENERIC_CMODE_VOLUME_SELECTOR $GENERIC_CLUSTER_SELECTOR
    $GENERIC_SMODE_HOSTNAME $GENERIC_CMODE_HOSTNAME
    $GENERIC_PLEASE_WAIT $GENERIC_SPINNING_ICON $GENERIC_SESSION_TAB_CLOSE $GENERIC_TAB
    $GENERIC_TAB_CLOSE $GENERIC_POPUP $GENERIC_SVM_AUDIT_PATH $GENERIC_PRECUTOVER
    $GENERIC_UPDATE $GENERIC_CUTOVER $GENERIC_POPUP_MESSAGE
    $GENERIC_POPUP_TITLE $GENERIC_POPUP_CLOSE $GENERIC_SESSION_TAB
    $GENERIC_SCHEDULE_NAME $GENERIC_SCHEDULE_DAYS_SELECT_RADIO
    $GENERIC_SCHEDULE_DAYS_SELECT $GENERIC_SCHEDULE_START_TIME_HOUR_INPUT
    $GENERIC_SCHEDULE_START_TIME_MIN_INPUT $GENERIC_SCHEDULE_DURATION_HOUR_INPUT
    $GENERIC_SCHEDULE_DURATION_MIN_INPUT $GENERIC_SCHEDULE_UPDATE_FREQUENCY_HOUR_INPUT
    $GENERIC_SCHEDULE_UPDATE_FREQUENCY_MIN_INPUT $GENERIC_STREAM_SELECTOR_RADIO
    $GENERIC_STREAM_SELECTOR $GENERIC_AUTO_CONTROL_STREAM_SELECTOR_RADIO
    $GENERIC_AUTO_CONTROL_STREAM_SELECTOR
    $GENERIC_THROTTLE_SELECTOR_RADIO $GENERIC_THROTTLE_SELECTOR
    $GENERIC_SCHEDULE_CREATE_BUTTON $GENERIC_SCHEDULE_CREATE_ERROR_MESSAGE
    $CLOSE_BUTTON $GO_TO_DASHBOARD $EDIT_CONFIGURATION $SAVE_PROJECT_AND_CONTINUE
    $CREATE_PROJECT_AND_CONTINUE $NEXT $SKIP $DASHBOARD $STORAGE_SYSTEMS
    $GET_STARTED $CREATE_SCHEDULE $RUN_PRECHECKS $SMODE_PRECHECK $SMODE_PRECHECK_NEXT_BUTTON
    $PRECHECK_SUMMARY_TEXT $CREATE_SCHEDULE_DASHBOARD
    $START $PRECUTOVER $TEST_MODE $CUTOVER $RESYNC $ADD_INFO_DURING_PRECUTOVER
    $UPDATE_NOW $PAUSE $RESUME $ABORT $DELETE_PROJECT $AUTO_REFRESH $REFRESH
    $VIEW_RESULTS
    $WAIT_FOR_PRECHECK $WAIT_FOR_START $WAIT_FOR_PAUSE_IN_BASELINE
    $WAIT_FOR_PAUSE_IN_INCREMENTAL_D_XFER $WAIT_FOR_ABORT $WAIT_FOR_UPDATE
    $WAIT_FOR_PRECUTOVER $WAIT_FOR_RESYNC $WAIT_FOR_CUTOVER
    $DASHBOARD_PROJECT_TREE_PANEL $VOLUME_TAB $DASHBOARD_VOLUME_GRID
    $VOLUME_TABLE_ORIGIN_VOLUME $VOLUME_REMOVE $NETWORKING_TAB $SCHEDULE_TAB
    $ADD_NEW_LIF_RADIO_BUTTON $EXISTING_LIF_RADIO_BUTTON $LIF_REMOVE
    $GENERIC_ORIGIN_IP_INPUT $GENERIC_TARGET_IP_INPUT $GENERIC_TARGET_GATEWAY_INPUT
    $GENERIC_TARGET_NETMASK_INPUT $GENERIC_TARGET_NODE_INPUT $GENERIC_TARGET_PORT_INPUT
    $GENERIC_SAVELIF_BUTTON $GENERIC_CANCELLIF_BUTTON $GENERIC_ADDLIF_BUTTON
    $GENERIC_LISTITEM_SELECTOR $VOLUME_TABLE_SELECTOR $SCHEDULE_SELECTOR
    $VOLUME_INFO_TABLE_SELECTOR $JOB_RESULTS
    $GENERIC_SCHEDULE_MODIFIER $GENERIC_SCHEDULE_REMOVER $CONTINUE_BUTTON
    $NAVIGATE_VOLUME_SELECTION_PAGE $NAVIGATE_IP_CONFIGURATION
    $NAVIGATE_PRECHECK $NAVIGATE_SVM_MAPPING $NAVIGATE_VOLUME_MAPPING
    $NAVIGATE_INTERFACE_MAPPING $NAVIGATE_DATA_COPY_SCHEDULE $NAVIGATE_FINAL_PRECHECK
    $NAVIGATE_SUBPROJECT_SUMMARY 
    
    $ASSESSMENT_BUTTON $APT_ADD_SYSTEMS $APT_ADD_SYSTEMS_HOSTNAME $APT_ADD_SYSTEMS_USERNAME
    $APT_ADD_SYSTEMS_PASSWORD $APT_ADD_SYSTEMS_TYPE $APT_SELECT_SYSTEM $MIGRATE_BUTTON
    $APT_FILE_PREFIX_SYSTEM $APT_WAIT_FOR_REPORT $APT_SELECT_TARGET_CLUSTER $APT_ADD_SYSTEMS_BUTTON
);

# Generic constants
$GENERIC_WAIT            = 5000; ## In ms
$GENERIC_PRECHECKS_WAIT  = 1800; ## In secs
$GENERIC_VOLUMEPAIR_LOAD = 180;  ## In secs

# If enabled then Selenium will run with debug mode on
$SEL_DEBUG_LOGS = 1;

# Navigation details
$NAVIGATE_TRANSITION_CREATE             = "Get Started:Next";
$NAVIGATE_TRANSITION_STORAGE            = "Storage Systems";

# Login Page
$LOGIN_USERNAME                         = "gwt-debug-username-input";
$LOGIN_PASSWORD                         = "gwt-debug-password-input";
$LOGIN_BUTTON                           = "gwt-debug-login";

# Credentials Add Page
$HOSTNAME                               = "gwt-debug-hostname-input";
$HOST_USERNAME                          = "gwt-debug-hostusername-input";
$HOST_PASSWORD                          = "gwt-debug-hostpassword-input";
$HOST_ADD                               = "gwt-debug-add";

# Session creation
$NEW_TRANSITION_PROJECT_NAME_MESSAGE    = "/following-sibling::div/div/following-sibling::div/div/div/div/div/div/table/tbody/tr/td/div/table/tbody/tr/td/div";
$PROJECT_NAME                           = "gwt-debug-projectname-input";
$MULTIPATH_IP                           = "gwt-debug-multipathip-input";
$DATA_COPY_IP                           = "gwt-debug-datacopyip-input";
$PROJECT_SELECTOR                       = "//div[starts-with(\@id,'gwt-debug-projecttreepanel__gwt-debug-projecttreepanel')]";
$PROJECT_NAME                           = "/span[2]";
$PROJECT_NAME_CHANGE                    = "//a[contains(text(),'Edit')]";
$PROJECT_NAME_SAVE                      = "//a[contains(text(),'Save')]";
$PROJECT_NAME_INPUT                     = "gwt-debug-projectname-input";
$SUBPROJECT_NAME_INPUT                  = "gwt-debug-subprojectname-input";

# Dashboard Page
$DASHBOARD_PROJECT_TREE_PANEL           = "gwt-debug-projecttreepanel";
$VOLUME_TAB                             = "//li[\@id='gwt-debug-dashboardtabpanel__gwt-debug-volumetab']";
$SCHEDULE_TAB                           = "//li[\@id='gwt-debug-dashboardtabpanel__gwt-debug-scheduletab']";
$NETWORKING_TAB                         = "//li[\@id='gwt-debug-dashboardtabpanel__gwt-debug-liftab']";
$DASHBOARD_VOLUME_GRID                  = "//*[\@id='gwt-debug-volStatusGrid']";
$VOLUME_TABLE_ORIGIN_VOLUME             = "//div/following::div[contains(text(),'XXYYZZ')]";
$VOLUME_REMOVE                          = $VOLUME_TABLE_ORIGIN_VOLUME."/following::span/parent::div/span";
$ADD_NEW_LIF_RADIO_BUTTON               = "//div[\@id='gwt-debug-newLifRadioButton']/input[\@type='radio']";
$EXISTING_LIF_RADIO_BUTTON              = "//div[\@id='gwt-debug-existingIPRadioButton']/input[\@type='radio']";
$LIF_REMOVE                             = "//div/following::div[contains(text(),'XXYYZZ')]/following::span/parent::div//img[\@alt='Remove']";
$VOLUME_TABLE_SELECTOR                  = "//div[2]/div/div[2]/div[2]/div/div[2]/div/div/div/div/div[2]/div/div[ROW_NUMBER]/table/tbody/tr/td[COLUMN_NUMBER]";
$SCHEDULE_SELECTOR                      = "//div[2]/div[2]/div/div[2]/div[2]/div/div/div/div[2]/div/div[ROW_NUMBER]/table/tbody/tr/td[COLUMN_NUMBER]";
$VOLUME_INFO_TABLE_SELECTOR             = "//td[2]/div/div[2]/div/div/div/div/div[2]/div/div[ROW_NUMBER]/table/tbody/tr/td[COLUMN_NUMBER]/div";
$JOB_RESULTS                            = "//div[1]/div/div[2]/div[1]/div/div[2]/div[1]/div/div[1]/div[1]/div[2]/div/div[ROW_NUMBER]/table/tbody/tr/td[COLUMN_NUMBER]/div/div";

# Generic selectors
$GENERIC_VFILER_SELECTOR                = "//div[starts-with(\@id,'gwt-debug-controllerlist__gwt-debug-controllerlist_XXYYZZ')]";
$GENERIC_VOLUME                         = "//div[\@title='XXYYZZ']";
$GENERIC_CHECKBOX                       = "input[starts-with(\@type,'checkbox')]";
$GENERIC_VOLUME_STANDALONE_SELECTOR     = $GENERIC_VOLUME."/following::input/parent::div/input";
$GENERIC_VOLUME_STAGGERED_SELECTOR      = $GENERIC_VOLUME."/following::input/following::input/parent::div/input";
$GENERIC_VSERVER                        = "//td/following::div[contains(text(),'XXYYZZ')]/parent::div/parent::td/preceding-sibling::td//";
$GENERIC_VSERVER_SELECTOR               = $GENERIC_VSERVER.$GENERIC_CHECKBOX;
$GENERIC_AGGR                           = "//div[contains(text(),'XXYYZZ')]/parent::div/parent::td/following-sibling::td/following-sibling::td//img"; # Here XXYYZZ specifies the volume name
$GENERIC_AGGR_SELECTOR                  = "//div[(\@role='listitem') and  contains(text(),'XXYYZZ')]";
$GENERIC_CMODE_VOLUME_SELECTOR          = "//div[contains(text(),'XXYYZZ')]/parent::div/parent::td/following-sibling::td/following-sibling::td/following-sibling::td//input";
$GENERIC_CLUSTER_SELECTOR               = "//td/div[contains(text(),'XXYYZZ')]";
$GENERIC_SMODE_HOSTNAME                 = "//div[contains(text(),'XXYYZZ')]/parent::div/parent::td/following-sibling::td/div";
$GENERIC_CMODE_HOSTNAME                 = "//div[contains(text(),'XXYYZZ')]/parent::td/following-sibling::td/div";

$GENERIC_SPINNING_ICON                  = "//img[\@title='Loading...']";
$GENERIC_PLEASE_WAIT                    = "//div[\@class='ext-el-mask-msg']/div/b/span[contains(text(),'Loading')]";
$GENERIC_SESSION_TAB                    = "//li[\@id='gwt-debug-tabpanel__gwt-debug-XXYYZZ#id#antonov#tab']/a[2]/em/span/span";
$GENERIC_SESSION_TAB_CLOSE              = "//li[\@id='gwt-debug-tabpanel__gwt-debug-XXYYZZ#id#antonov#tab']/a";
$GENERIC_TAB                            = "//li[\@id='gwt-debug-tabpanel__gwt-debug-XXYYZZ']/a[2]/em/span/span";
$GENERIC_TAB_CLOSE                      = "//li[\@id='gwt-debug-tabpanel__gwt-debug-XXYYZZ']/a";
$GENERIC_POPUP                          = "//div[\@class='x-shadow x-ignore']";
$GENERIC_SVM_AUDIT_PATH                 = "//div/div/div/span/b[contains(text(),'SVM Audit Logs')]";
$GENERIC_PRECUTOVER                     = "gwt-debug-kerberosDialog";
$GENERIC_UPDATE                         = "gwt-debug-updatenowbutton";
$GENERIC_CUTOVER                        = "//div/p[contains(text(),'The origin volumes will be made offline.')]";
$GENERIC_POPUP_MESSAGE                  = "/following-sibling::div/div/following-sibling::div/div/div/div/div/div/span";
$GENERIC_POPUP_TITLE                    = "/following-sibling::div//span";
$GENERIC_POPUP_CLOSE                    = "/following-sibling::div//button";

$GENERIC_SCHEDULE_NAME                          = "gwt-debug-scheduleName-input";
$GENERIC_SCHEDULE_DAYS_SELECT_RADIO             = "gwt-debug-daysRadioBtn";
$GENERIC_SCHEDULE_DAYS_SELECT                   = "//div[\@id='XXYYZZCheckbox']/input";
$GENERIC_SCHEDULE_START_TIME_HOUR_INPUT         = "//div[\@id='gwt-debug-startTimeHour']/img";
$GENERIC_SCHEDULE_START_TIME_MIN_INPUT          = "//div[\@id='gwt-debug-startTimeMin']/img";
$GENERIC_SCHEDULE_DURATION_HOUR_INPUT           = "gwt-debug-durationHour-input";
$GENERIC_SCHEDULE_DURATION_MIN_INPUT            = "//div[\@id='gwt-debug-durationMin']/img";
$GENERIC_SCHEDULE_UPDATE_FREQUENCY_HOUR_INPUT   = "gwt-debug-updateFrequencyHour-input";
$GENERIC_SCHEDULE_UPDATE_FREQUENCY_MIN_INPUT    = "//div[\@id='gwt-debug-updateFrequencyMin']/img";

$GENERIC_STREAM_SELECTOR_RADIO                  = "//div[\@id='gwt-debug-specificStream']/input";
$GENERIC_STREAM_SELECTOR                        = "gwt-debug-streamsMaxCap-input";
$GENERIC_AUTO_CONTROL_STREAM_SELECTOR_RADIO     = "//div[\@id='gwt-debug-autoControlStreams']/input";
$GENERIC_AUTO_CONTROL_STREAM_SELECTOR           = "gwt-debug-streamsPercentage-input";
$GENERIC_THROTTLE_SELECTOR_RADIO                = "//div[\@id='gwt-debug-specificThrottle']/input";
$GENERIC_THROTTLE_SELECTOR                      = "gwt-debug-throttle-input";
$GENERIC_SCHEDULE_CREATE_BUTTON                 = "gwt-debug-createSchedule";
$GENERIC_SCHEDULE_CREATE_ERROR_MESSAGE          = "//div[\@id='gwt-debug-errorMessage']/span";

$GENERIC_ORIGIN_IP_INPUT                ="gwt-debug-originIP-input";
$GENERIC_TARGET_IP_INPUT                ="gwt-debug-targetIP-input";
$GENERIC_TARGET_GATEWAY_INPUT           ="gwt-debug-gateway-input";
$GENERIC_TARGET_NETMASK_INPUT           ="gwt-debug-netmask-input";
$GENERIC_TARGET_NODE_INPUT              ="gwt-debug-targetNode-input";
$GENERIC_TARGET_PORT_INPUT              ="gwt-debug-targetPort-input";
$GENERIC_SAVELIF_BUTTON                 ="gwt-debug-saveLIF";
$GENERIC_CANCELLIF_BUTTON               ="gwt-debug-cancelLIF";
$GENERIC_ADDLIF_BUTTON                  ="gwt-debug-addlif";
$GENERIC_LISTITEM_SELECTOR              ="//div[(\@role='listitem') and  contains(text(),'XXYYZZ')]";
$GENERIC_SCHEDULE_MODIFIER              ="//div[contains(text(),'XXYYZZ')]/parent::div/parent::td/following::td/following::td/following::td/following::td/following::td/following::td/following::td/following::td//following::td/div/div/table/tbody/tr/td[1]/div/span";
$GENERIC_SCHEDULE_REMOVER               ="//div[contains(text(),'XXYYZZ')]/parent::div/parent::td/following::td/following::td/following::td/following::td/following::td/following::td/following::td/following::td//following::td/div/div/table/tbody/tr/td[2]/div/span";

# Button Id's
$CLOSE_BUTTON                           ="gwt-debug-closeButton";
$CONTINUE_BUTTON                        ="gwt-debug-continueButton";
$GO_TO_DASHBOARD                        = "gwt-debug-gotodashboard";
$EDIT_CONFIGURATION                     = "gwt-debug-editconfiguration";
$SAVE_PROJECT_AND_CONTINUE              = "gwt-debug-updateproject";
$CREATE_PROJECT_AND_CONTINUE            = "gwt-debug-createproject";
$NEXT                                   = "gwt-debug-next";
$SKIP                                   = "gwt-debug-skip";
$DASHBOARD                              = "gwt-debug-dashboard";
$STORAGE_SYSTEMS                        = "gwt-debug-systemmanagement";
$GET_STARTED                            = "gwt-debug-getstarted";
$CREATE_SCHEDULE                        = "gwt-debug-invokeSchedule";
$CREATE_SCHEDULE_DASHBOARD              = "gwt-debug-addScheduleDashboard";
$RUN_PRECHECKS                          = "gwt-debug-precheckbutton";
$SMODE_PRECHECK                         = "gwt-debug-precheck";
$SMODE_PRECHECK_NEXT_BUTTON             = "gwt-debug-nextButton";
$PRECHECK_SUMMARY_TEXT                  = "gwt-debug-summaryText";
$START                                  = "gwt-debug-startbutton";
$PRECUTOVER                             = "gwt-debug-configbutton";
$TEST_MODE                              = "//div[\@id='gwt-debug-testmode']/input";
$CUTOVER                                = "gwt-debug-completebutton";
$RESYNC                                 = "gwt-debug-finishbutton";
$ADD_INFO_DURING_PRECUTOVER             = "//div/label/span[contains(text(),'Customize the number of concurrent')]/parent::label/parent::div/input";
$UPDATE_NOW                             = "gwt-debug-updatebutton";
$PAUSE                                  = "gwt-debug-pausebutton";
$RESUME                                 = "gwt-debug-resumebutton";
$ABORT                                  = "gwt-debug-abortbutton";
$DELETE_PROJECT                         = "gwt-debug-deletebutton";
$AUTO_REFRESH                           = "//div[\@id='gwt-debug-autorefresh']/input";
$REFRESH                                = "gwt-debug-refreshbutton";
$VIEW_RESULTS                           = "gwt-debug-ViewDetailedResults";

# Wait Id's
$WAIT_FOR_PRECHECK                      = "precheck-status:prechecks completed";
$WAIT_FOR_START                         = "baseline-status:baseline data copy completed";
$WAIT_FOR_PAUSE_IN_BASELINE             = "baseline-status:baseline data copy paused";
$WAIT_FOR_PAUSE_IN_INCREMENTAL_D_XFER   = "incremental-status:incremental data copy paused";
$WAIT_FOR_ABORT                         = "cutover-status:transition aborted";
$WAIT_FOR_UPDATE                        = "";
$WAIT_FOR_PRECUTOVER                    = "config-status:apply configuration completed";
$WAIT_FOR_RESYNC                        = "config-status:apply configuration completed";
$WAIT_FOR_CUTOVER                       = "cutover-status:transition completed";

# Id's for set_page
$NAVIGATE_VOLUME_SELECTION_PAGE         = $EDIT_CONFIGURATION;
$NAVIGATE_IP_CONFIGURATION              = $NAVIGATE_VOLUME_SELECTION_PAGE_SESSION_EXISITNG.":".$SAVE_PROJECT_AND_CONTINUE;
$NAVIGATE_PRECHECK                      = $NAVIGATE_IP_CONFIGURATION.":".$NEXT;
$NAVIGATE_SVM_MAPPING                   = $NAVIGATE_PRECHECK.":".$SKIP;
$NAVIGATE_VOLUME_MAPPING                = $NAVIGATE_SVM_MAPPING.":".$NEXT;
$NAVIGATE_INTERFACE_MAPPING             = $NAVIGATE_VOLUME_MAPPING.":".$NEXT;
$NAVIGATE_DATA_COPY_SCHEDULE            = $NAVIGATE_INTERFACE_MAPPING.":".$NEXT;
$NAVIGATE_FINAL_PRECHECK                = $NAVIGATE_DATA_COPY_SCHEDULE.":".$NEXT;
$NAVIGATE_SUBPROJECT_SUMMARY            = $NAVIGATE_FINAL_PRECHECK.":".$SKIP;

$ASSESSMENT_BUTTON			= "gwt-debug-AssessmentButton";
$APT_ADD_SYSTEMS			= "Add Systems";
$APT_ADD_SYSTEMS_HOSTNAME		= "gwt-debug-Name-input";
$APT_ADD_SYSTEMS_USERNAME		= "gwt-debug-username-input";
$APT_ADD_SYSTEMS_PASSWORD		= "gwt-debug-password-input";
$APT_ADD_SYSTEMS_TYPE			= "//div[4]/div/div/img";
$APT_SELECT_SYSTEM                      = "//div[contains(text(),'XXYYZZ')]/parent::td/preceding-sibling::td";
$APT_FILE_PREFIX_SYSTEM                 = "//div[3]/div/div/input";
$APT_WAIT_FOR_REPORT                    = "//span/b[contains(text(),'Transition Assessment Report generation is in progress')]";
$APT_SELECT_TARGET_CLUSTER              = "//div/div/img";
$APT_ADD_SYSTEMS_BUTTON			= "//div[2]/div[2]/div/div/div/div/div/table/tbody/tr/td/table/tbody/tr/td/table/tbody/tr[2]/td[2]/em/button";

$MIGRATE_BUTTON				= "gwt-debug-MigrationButton";
1;
