# $Id$
# Copyright (c) 2001-2016 Network Appliance, Inc.
# All rights reserved.
#
## @summary
##  Global Constants used to fetch 7-mode transition tool details.
##
## @description
##  Using this library, user can fetch the 7-mode transition tool web elements.
##
## @synopsis
##  use NACL::APISet::Host::GUI::SMTT::V3_1::GlobalConst;
##
## @status Review
## @author santosh6@netapp.com, rohit4@netapp.com, dl-nacl-dev@netapp.com
##
## @change     2015-06-24 santosh6 : Added ID's for CFT
## @change     2015-07-13 santosh6 : Added ID's to support parsed output for CFT commands
## @change     2016-02-24 dinoc    : Added changes for V3.0
## @change     2016-03-21 ashan    : Added changes for Plan Configuration
## @change     2016-07-18 dinoc    : Added changes for V3.1
##
## @pod here

package NACL::APISet::Host::GUI::SMTT::V3_1::GlobalConst;

use Exporter 'import';

our @EXPORT = qw (

    $GENERIC_WAIT $GENERIC_PRECHECKS_WAIT $GENERIC_VOLUMEPAIR_LOAD
    $SEL_DEBUG_LOGS
    $NAVIGATE_TRANSITION_CREATE $NAVIGATE_TRANSITION_STORAGE
    $LOGIN_USERNAME $LOGIN_PASSWORD $LOGIN_BUTTON
    $HOSTNAME $HOST_USERNAME $HOST_PASSWORD $HOST_ADD
    $NEW_TRANSITION_PROJECT_NAME_MESSAGE $PROJECT_NAME $MULTIPATH_IP $DATA_COPY_IP
    $PROJECT_SELECTOR $PROJECT_NAME $PROJECT_NAME_CHANGE $PROJECT_NAME_SAVE
    $PROJECT_NAME_INPUT $SUBPROJECT_NAME_INPUT
    $GENERIC_VFILER_SELECTOR $GENERIC_VOLUME $GENERIC_CHECKBOX $GENERIC_VOLUME_STANDALONE_SELECTOR
    $GENERIC_VOLUME_STAGGERED_SELECTOR $GENERIC_VSERVER $GENERIC_VSERVER_SELECTOR
    $GENERIC_AGGR $GENERIC_AGGR_SELECTOR $GENERIC_CMODE_VOLUME_SELECTOR $GENERIC_CLUSTER_SELECTOR
    $GENERIC_SMODE_HOSTNAME $GENERIC_CMODE_HOSTNAME
    $GENERIC_PLEASE_WAIT $GENERIC_SPINNING_ICON $GENERIC_SESSION_TAB_CLOSE $GENERIC_TAB
    $GENERIC_TAB_CLOSE $GENERIC_POPUP $GENERIC_SVM_AUDIT_PATH $GENERIC_PRECUTOVER
    $GENERIC_UPDATE $GENERIC_CUTOVER $GENERIC_POPUP_MESSAGE
    $GENERIC_POPUP_TITLE $GENERIC_POPUP_CLOSE $GENERIC_SESSION_TAB
    $GENERIC_SCHEDULE_NAME $GENERIC_SCHEDULE_DAYS_SELECT_RADIO
    $GENERIC_SCHEDULE_DAYS_SELECT $GENERIC_SCHEDULE_START_TIME_HOUR_INPUT
    $GENERIC_SCHEDULE_START_TIME_MIN_INPUT $GENERIC_SCHEDULE_DURATION_HOUR_INPUT
    $GENERIC_SCHEDULE_DURATION_MIN_INPUT $GENERIC_SCHEDULE_UPDATE_FREQUENCY_HOUR_INPUT
    $GENERIC_SCHEDULE_UPDATE_FREQUENCY_MIN_INPUT $GENERIC_STREAM_SELECTOR_RADIO
    $GENERIC_STREAM_SELECTOR $GENERIC_AUTO_CONTROL_STREAM_SELECTOR_RADIO
    $GENERIC_AUTO_CONTROL_STREAM_SELECTOR $CFT_PROJECT_NAME $SAVE_PROJECT
    $GENERIC_THROTTLE_SELECTOR_RADIO $GENERIC_THROTTLE_SELECTOR
    $GENERIC_SCHEDULE_CREATE_BUTTON $GENERIC_SCHEDULE_CREATE_ERROR_MESSAGE
    $CLOSE_BUTTON $GO_TO_DASHBOARD $EDIT_CONFIGURATION $SAVE_PROJECT_AND_CONTINUE
    $CREATE_PROJECT_AND_CONTINUE $NEXT $SKIP $DASHBOARD $STORAGE_SYSTEMS
    $GET_STARTED $CREATE_SCHEDULE $RUN_PRECHECKS $SMODE_PRECHECK $SMODE_PRECHECK_NEXT_BUTTON
    $PRECHECK_SUMMARY_TEXT $CREATE_SCHEDULE_DASHBOARD
    $START $PRECUTOVER $TEST_MODE $CUTOVER $RESYNC $ADD_INFO_DURING_PRECUTOVER
    $UPDATE_NOW $PAUSE $RESUME $ABORT $DELETE_PROJECT $AUTO_REFRESH $REFRESH
    $VIEW_RESULTS $HAPAIRGRID_GROUPID $GENERIC_RETRIEVING_WAIT
    $WAIT_FOR_PRECHECK $WAIT_FOR_START $WAIT_FOR_PAUSE_IN_BASELINE
    $WAIT_FOR_PAUSE_IN_INCREMENTAL_D_XFER $WAIT_FOR_ABORT $WAIT_FOR_UPDATE
    $WAIT_FOR_PRECUTOVER $WAIT_FOR_RESYNC $WAIT_FOR_CUTOVER
    $DASHBOARD_PROJECT_TREE_PANEL $VOLUME_TAB $DASHBOARD_VOLUME_GRID
    $VOLUME_TABLE_ORIGIN_VOLUME $VOLUME_REMOVE $NETWORKING_TAB $SCHEDULE_TAB
    $ADD_NEW_LIF_RADIO_BUTTON $EXISTING_LIF_RADIO_BUTTON $LIF_REMOVE
    $GENERIC_ORIGIN_IP_INPUT $GENERIC_TARGET_IP_INPUT $GENERIC_TARGET_GATEWAY_INPUT
    $GENERIC_TARGET_NETMASK_INPUT $GENERIC_TARGET_NODE_INPUT $GENERIC_TARGET_PORT_INPUT
    $GENERIC_SAVELIF_BUTTON $GENERIC_CANCELLIF_BUTTON $GENERIC_ADDLIF_BUTTON
    $GENERIC_LISTITEM_SELECTOR $VOLUME_TABLE_SELECTOR $SCHEDULE_SELECTOR
    $VOLUME_INFO_TABLE_SELECTOR $JOB_RESULTS $CANCEL_ROLLBACK
    $GENERIC_SCHEDULE_MODIFIER $GENERIC_SCHEDULE_REMOVER $CONTINUE_BUTTON
    $NAVIGATE_VOLUME_SELECTION_PAGE $NAVIGATE_IP_CONFIGURATION
    $NAVIGATE_PRECHECK $NAVIGATE_SVM_MAPPING $NAVIGATE_VOLUME_MAPPING
    $NAVIGATE_INTERFACE_MAPPING $NAVIGATE_DATA_COPY_SCHEDULE $NAVIGATE_FINAL_PRECHECK
    $NAVIGATE_SUBPROJECT_SUMMARY $CBT_CMODE_HOSTNAME
    $ASSESSMENT_BUTTON $APT_ADD_SYSTEMS $APT_ADD_SYSTEMS_HOSTNAME $APT_ADD_SYSTEMS_USERNAME
    $APT_ADD_SYSTEMS_PASSWORD $APT_ADD_SYSTEMS_TYPE $APT_SELECT_SYSTEM $MIGRATE_BUTTON
    $APT_FILE_PREFIX_SYSTEM $APT_WAIT_FOR_REPORT $APT_SELECT_TARGET_CLUSTER $APT_ADD_SYSTEMS_BUTTON
    $MIGRATION_DASHBOARD_LINK $CLUSTER_SELECTOR $CFT_CLUSTER $CLUSTER_HA_SELECTOR
    $CFT_VFILER $GENERIC_VSM $GENERIC_VSM_SELECTOR $CFT_VSM_MAPPING_SAVE
    $CFT_SMODE_SELECTOR $PROJECT_EDIT_CONFIG $EDIT_SELECT_TARGET_CLUSTER
    $EDIT_SVM_MAPPING $EDIT_LIF_CONFIG $CFT_EDIT_CLUSTER $GENERIC_PROJECT_TAB
    $GENERIC_PROJECT_TAB_CLOSE $SECONDARY_CLUS_NODE $PRIMARY_CLUS_NODE
    $SWAP_BUTTON $VFILER_GRID $VFILER_SELECTOR $VSM_DROP_DOWN
    $VSM_MAPPING_SAVE $CFT_PRECHECK_BUTTON $CFT_VIEW_DETAIL_BUTTON $CFT_JOB_RESULT_CLOSE
    $CFT_APPLY_CONFIG $CFT_EXPORT $CFT_VERIFY_CABLING $CFT_IMPORT $CFT_COMMIT
    $CREATE_NEW_GROUP $GROUP_NAME $GROUP_DESC $REVERT_BUTTON $CANCEL_REVERT
    $GENERATE_MANUAL_STEPS $VERIFY_SEVEN_MODE $SELECT_GROUP $EXISTING_GROUP
    $REVERT_IP $RESULT_ID $MSG_TYPE $MSG_INFO $AFFECTED_OBJ $REVERT_STEP $REVERT_MSG
    $GENERIC_REVERT_MSG $SEVEN_MODE_AGGR $CMODE_AGGR_MSG $DISK_SERIAL_NUMBER
    $DISK_REVERT_MSG $CMODE_AGGR_REVERT_MSG $GENERIC_REVERT_MSG $GENERIC_REVERT
    $S_CONTROLLER_NAME $REVERT_DASHBOARD $REVERT_PRECHECK $GENERATE_REVERT_MANUAL
    $PRECHECK_SUCCESS $APPLY_SVM_SUCCESS $EXPORT_SUCCESS $VERIFY_CABLE_SUCCESS
    $IMPORT_SUCCESS $COMMIT_SUCCESS $REVERT_SUCCESS $CFT_MODIFY $PROJECT_DELETE
    $CFT_REVERT_STEPS_CLOSE $CBT_GET_STARTED $CBT_STORAGE_SYSTEMS $CBT_NEXT
    $PROJECT_DETAILS $DASHBOARD_CLUSTER_IP $VIEW_ROLLBACK_STEP_RESULTS
    $MSG_STEP $CLUSTER_COMMAND $CLUSTERSHELL $SEVEN_MODE_CONTROLLER
    $SEVEN_MODE_COMMAND $SEVEN_MODE_IP $S_MODE_COMMAND $DASHBOARD_S_IP
    $REVERT_COMMAND $CMODE_CONFIRM_EXECUTION $SMODE_CONFIRM_EXECUTION
    $CABLING_CONFIRM $CFT_CHECKBOX_CONFIRM $STREAM_ROW $PRECHECK_MSG
    $MSG_COUNT $ROW_ELEMENT $REVERT_ROW $REVERT_TITLE $ERROR_ROW_ELEMENT
    $CFT_CHECK_READINESS $FLEX_CONFIG_NEXT $CFT_YES_BUTTON $CFT_CHECKBOX_MESSAGE 
    $PROJECT_HISTORY_TAB $PLAN_DESIGN_CFT_RADIO_BUTTON $PLAN_DESIGN_CBT_RADIO_BUTTON
    $START_PLAN $MIGRATION_CBT_TAB $MIGRATION_CFT_TAB $SELECT_ALL_CONF $DESELECT_ALL_CONF 
    $SAVE_CONF_CHANGES $CIFS_LOCAL_USERS_AND_GROUPS $HOME_DIR_PATHS $WIDELINKS $CIFS_SHARE_ACLS
    $CIFS_OPTIONS $CIFS_USER_MAPPING_CONF $AUDIT_CONFIGURATION $PREFERRED_DOMAIN_CONTROLLERS_LIST 
    $SVM_CONF_CIFS $VOLUME_CONF_CIFS $VOLUME_CONF_SAN $IGROUPS_LUN_MAPPING 
    $NETGROUPS $UNIX_USERS_AND_GROUPS $NIS_CONFIGURATION $DNS_CONFIGURATION $LDAP_CONFIGURATION
    $NAME_SERVICE_SWITCH_CONF $NAME_MAPPING_SWITCH_CONF $HOST_CONFIGURATION $NAME_SERVICES
    $NFS_EXPORTS $NFS_OPTIONS $SVM_CONF_NFS $VOLUME_CONF_NFS $CONSOLIDATE_NFS_EXPORT_POLICIES
    $REUSE_EXPORT_POLICIES $CONSOLIDATE_NFS_EXPORT_POLICIES $REUSE_SNAPSHOT_POLICIES
    $VOLPAIR_SMODE_SYSTEM_SELECT $VOLPAIR_CMODE_SYSTEM_SELECT $PROJECT_MODIFY
    $PROJECT_RENAME $PROJECT_SAVE $EDIT_OK_BUTTON $EDIT_DATA_IP $GENERIC_POPUP_COMMIT
    $CHOOSE_NODE_PORT $GENERIC_HOME_NODE $EDIT_HOME_PORT $GENERIC_SAVE_NODE $VFILERHOSTNAME
    $VFILERHOST_SAVE $DELETE_CRED $DELETE_SICON $DELETE_CICON $SVM_PLAN_CONFIG
    $PROJECT_CFT_EDIT $CFT_EDIT_CONFIGURATION $CFT_EDIT_PLAN_CONFIG $SVM_CONF_SNAPSHOT $SNAPSHOT_SCHEDULES
    $CONSOLIDATE_7MODE_SNAP_POLICIES $SNAPSHOT_SCHEDULES_CONF $OPERATION_RESULT
    $OPERATION_TABLE_ORIGIN_OPERATION $PLAN_CONFIGURATION_TAB $PROJECT_INSIDE_EDIT
    $SWITCH_SVM_TAB $SWITCH_MAP_VOLUMES_TAB $SWITCH_SOURCE_VOLUMES_TAB $SWITCH_DATA_IP_TAB
    $SWITCH_NETWORK_TAB $SWITCH_CONFIGURE_SCHEDULE_TAB $SWITCH_PLAN_CONFIG_TAB
    $MIGRATION_TAB $EDIT_SVM $EDIT_PLAN_CONFIG $EDIT_TARGET_VOLUME $EDIT_CONFIG_SCHEDULE
    $SCHEDULE_REMOVE $EDIT_SOURCE_VOLUMES PROJECT_INSIDE_EDIT $EDIT_SCHEDULE
    $GENERIC_SVM_INPUT $GENERIC_LIF_EDIT $GENERIC_LIF_REMOVE $GENERIC_LIF_IP
    $GENERIC_SMODE_LIF_SELECT $GENERIC_SMODE_LIF $PROJECT_CFT_EDIT $GENERIC_CLUSTER_EDIT
    $SWITCH_CFT_SOURCE_TAB $SWITCH_CFT_CLUSTER_TAB $SWITCH_MAP_SVMS_TAB $SWITCH_CFT_NETWORK_TAB
    $SWITCH_CFT_PLAN_CONFIG_TAB $SOURCE_VOLUME_EDIT $SVM_EDIT $SCHEDULE_EDIT $GENERIC_SCHEDULE_NAME_EDIT
    $MOVE_PROJECT $GROUP_MOVE $GROUPNAME_VALID $GROUPNAME_VALID_SPLCHAR $GROUP_EXIST 
    $PROJECT_EXIST $CFT_ASSESSMENT $CFT_HOST_REMEDY $CFT_FC_SAN_NA $TRANS_LIF_IP
    $TRANS_LIF_GATEWAY $TRANS_LIF_NETMASK $TRANS_LIF_NODE $TRANS_LIF_PORT
    $TEST_MODE_ID $GENERIC_MOUNT_VOLUME $EDIT_VOLUME_MOUNT $EDIT_AGGR_MOUNT
    $EDIT_DASHBOARD_MOUNT
);

# Generic constants
$GENERIC_WAIT            = 5000; ## In ms
$GENERIC_PRECHECKS_WAIT  = 1800; ## In secs
$GENERIC_VOLUMEPAIR_LOAD = 180;  ## In secs

# If enabled then Selenium will run with debug mode on
$SEL_DEBUG_LOGS = 1;

# Navigation details
$NAVIGATE_TRANSITION_CREATE             = "Get Started:Next";
$NAVIGATE_TRANSITION_STORAGE            = "gwt-debug-StorageSyatems";
$PLAN_DESIGN_CBT_RADIO_BUTTON           = "gwt-debug-cbtRadioButtonDebugId";
$PLAN_DESIGN_CFT_RADIO_BUTTON           = "gwt-debug-cftRadioButtonDebugId";
$START_PLAN                             = "gwt-debug-startPlanningButtonDebugId";
$CFT_ASSESSMENT                         = "//div[\@id='gwt-debug-assessmentCheckBox']/input";
$CFT_HOST_REMEDY                        = "//div[\@id='gwt-debug-hostRemediationCheckBox']/input";
$CFT_FC_SAN_NA                          = "//div[\@id='gwt-debug-zoningNotApplicableCheckBox']/input";

# Login Page
$LOGIN_USERNAME                         = "gwt-debug-username-input";
$LOGIN_PASSWORD                         = "gwt-debug-password-input";
$LOGIN_BUTTON                           = "gwt-debug-login";

# Credentials Add Page
$HOSTNAME                               = "gwt-debug-storageSystemName-input";
$VFILERHOSTNAME                         = "gwt-debug-hostname-input";
$HOST_USERNAME                          = "gwt-debug-hostusername-input";
$HOST_PASSWORD                          = "gwt-debug-hostpassword-input";
$HOST_ADD                               = "gwt-debug-add";
$VFILERHOST_SAVE                        = "gwt-debug-save";
$DELETE_CRED                            = "//tr/td/following::div[contains(text(),'XXYYZZ')]/../following::";
$DELETE_SICON                           = "div[\@id='gwt-debug-Delete_IconXXYYZZ']";
$DELETE_CICON                           = "div[\@id='gwt-debug-DeleteIconXXYYZZ']";

# Session creation
$NEW_TRANSITION_PROJECT_NAME_MESSAGE    = "/following-sibling::div/div/following-sibling::div/div/div/div/div/div/table/tbody/tr/td/div/table/tbody/tr/td/div";
$PROJECT_NAME                           = "gwt-debug-projectname-input";
$MULTIPATH_IP                           = "gwt-debug-multipathip-input";
$DATA_COPY_IP                           = "gwt-debug-datacopyip-input";
$PROJECT_SELECTOR                       = "//div[starts-with(\@id,'gwt-debug-projecttreepanel__gwt-debug-projecttreepanel')]";
$PROJECT_NAME                           = "/span[2]";
$PROJECT_NAME_CHANGE                    = "//a[contains(text(),'Edit')]";
$PROJECT_NAME_SAVE                      = "//a[contains(text(),'Save')]";
$SUBPROJECT_NAME_INPUT                  = "gwt-debug-subprojectname-input";
$PROJECT_MODIFY                         = "//td/following::div[contains(text(),'XXYYZZ')]/../parent::td/following-sibling::td/following::table[\@id='gwt-debug-ModifyButton']";
$PROJECT_RENAME                         = "gwt-debug-RenameProject";
$PROJECT_NAME_INPUT                     = "gwt-debug-ProjectName-input";
$PROJECT_SAVE                           = "//td/em/following::span[contains(text(),'Save')]";
$EDIT_OK_BUTTON                         = "//em/button[contains(text(),'OK')]";
$EDIT_DATA_IP                           = "gwt-debug-EditDataCopyIP";
$EDIT_SVM                               = "gwt-debug-EditClusterSVM";
$EDIT_PLAN_CONFIG                       = "gwt-debug-EditPlanConfiguration";
$EDIT_TARGET_VOLUME                     = "gwt-debug-EditVolumeMapping";
$EDIT_CONFIG_SCHEDULE                   = "gwt-debug-EditScheduleConfiguration";
$EDIT_SOURCE_VOLUMES                    = "gwt-debug-EditSourceVolumes";
$SWITCH_SVM_TAB                         = "gwt-debug-wizard-Select SVM";
$SWITCH_SOURCE_VOLUMES_TAB              = "gwt-debug-wizard-Select Source Volumes";
$SWITCH_DATA_IP_TAB                     = "gwt-debug-wizard-Select Data Copy IP";
$SWITCH_MAP_VOLUMES_TAB                 = "gwt-debug-wizard-Map Volumes";
$SWITCH_NETWORK_TAB                     = "gwt-debug-wizard-Network Configuration";
$SWITCH_CONFIGURE_SCHEDULE_TAB          = "gwt-debug-wizard-Configure Schedule";
$SWITCH_PLAN_CONFIG_TAB                 = "gwt-debug-wizard-Plan Configuration";
$SWITCH_CFT_SOURCE_TAB                  = "gwt-debug-wizard-Select Source Systems";
$SWITCH_CFT_CLUSTER_TAB                 = "gwt-debug-wizard-Select Cluster \& Map Nodes";
$SWITCH_MAP_SVMS_TAB                    = "gwt-debug-wizard-Map SVMs and Volumes";
$SWITCH_CFT_NETWORK_TAB                 = "gwt-debug-wizard-Configure Networking";

#Project creation
$CFT_PROJECT_NAME                       = "gwt-debug-ProjectName-input";
$SAVE_PROJECT                           = "gwt-debug-SaveBtn";

# Dashboard Page
$DASHBOARD_PROJECT_TREE_PANEL           = "gwt-debug-projecttreepanel";
$MIGRATION_CBT_TAB                      = "gwt-debug-ProjectTabPanle__gwt-debug-TabItemId";
$MIGRATION_CFT_TAB                      = "gwt-debug-ProjectTabPanle__gwt-debug-TabItemId";
$VOLUME_TAB                             = "//li[\@id='gwt-debug-dashboardtabpanel__gwt-debug-volumetab']";
$SCHEDULE_TAB                           = "//li[\@id='gwt-debug-dashboardtabpanel__gwt-debug-scheduletab']";
$NETWORKING_TAB                         = "gwt-debug-EditNetworkConfiguration";
$DASHBOARD_VOLUME_GRID                  = "//*[\@id='gwt-debug-volStatusGrid']";
$VOLUME_TABLE_ORIGIN_VOLUME             = "//div/following::div[contains(text(),'XXYYZZ')]";
$VOLPAIR_SMODE_SYSTEM_SELECT            = "gwt-debug-controllerlist__gwt-debug-controllerlist_XXYYZZ";
$VOLPAIR_CMODE_SYSTEM_SELECT            = "//div[contains(text(),'XXYYZZ')]/ancestor::tr";
$VOLUME_REMOVE                          = $VOLUME_TABLE_ORIGIN_VOLUME."/following::span/parent::div/span";
$ADD_NEW_LIF_RADIO_BUTTON               = "//div[\@id='gwt-debug-newLifRadioButton']/input[\@type='radio']";
$CHOOSE_NODE_PORT                       = "//button/b/following::span[contains(text(),'Choose Node and Port')]";
$EXISTING_LIF_RADIO_BUTTON              = "//td/following::div[contains(text(),'XXYYZZ')]/../ancestor::table/descendant::td/descendant::div/input[\@type='checkbox']";
$SCHEDULE_REMOVE                        = "//tr/td/following::div[contains(text(),'XXYYZZ')]/following::span/parent::div//img[\@alt='Remove']";
$EDIT_SCHEDULE                          = "//tr/td/following::div[contains(text(),'XXYYZZ')]/../following::span/img";
$VOLUME_TABLE_SELECTOR                  = "//div[2]/div/div[2]/div[2]/div/div[2]/div/div/div/div/div[2]/div/div[ROW_NUMBER]/table/tbody/tr/td[COLUMN_NUMBER]";
$SCHEDULE_SELECTOR                      = "//div[2]/div[2]/div/div[2]/div[2]/div/div/div/div[2]/div/div[ROW_NUMBER]/table/tbody/tr/td[COLUMN_NUMBER]";
$VOLUME_INFO_TABLE_SELECTOR             = "//td[2]/div/div[2]/div/div/div/div/div[2]/div/div[ROW_NUMBER]/table/tbody/tr/td[COLUMN_NUMBER]/div";
$JOB_RESULTS                            = "//div[1]/div/div[2]/div[1]/div/div[2]/div[1]/div/div[1]/div[1]/div[2]/div/div[ROW_NUMBER]/table/tbody/tr/td[COLUMN_NUMBER]/div/div";
$CFT_YES_BUTTON                         = "gwt-debug-yesButton";
$OPERATION_TABLE_ORIGIN_OPERATION		= "//tr/following::div[contains(text(),'XXYYZZ')]";
$OPERATION_RESULT						= $OPERATION_TABLE_ORIGIN_OPERATION."/../parent::tr/following::div/a[\@id='gwt-debug-viewResultsLink']";
$LIF_REMOVE								= "//div/following::div[contains(text(),'XXYYZZ')]/../ancestor::table/descendant::td/following::table/tbody/tr/td[2]/div";
$PLAN_CONFIGURATION_TAB					= "//span[contains(text(), 'Configuration Planning')]";
$SVM_EDIT								= "gwt-debug-EditClusterSVM";
$SCHEDULE_EDIT							= "gwt-debug-EditScheduleConfiguration";
$SOURCE_VOLUME_EDIT                     = "gwt-debug-EditSourceVolumes";
$GENERIC_SCHEDULE_NAME_EDIT             = "//tr/td/following::div[contains(text(),'XX')]/../following::span/img";
#Plan Configuration
$SELECT_ALL_CONF			            = "gwt-debug-SelectAllDebugId";
$DESELECT_ALL_CONF			            = "gwt-debug-DeselectAllDebugId";
$SAVE_CONF_CHANGES			            = "gwt-debug-saveConfigButton";
$SVM_CONF_CIFS                          = "//*[\@id='gwt-debug-SVMConfiguration-gp-groupid-0-hd']/div/div/div";
$GROUPID_SVM_0                          = "//div[\@id='gwt-debug-SVMConfiguration-gp-groupid-0']/div[2]";
$CIFS_OPTIONS                           = "$GROUPID_SVM_0"."/div[1]/table/tbody/tr/td[1]/div/div";
$CIFS_USER_MAPPING_CONF                 = "$GROUPID_SVM_0"."/div[2]/table/tbody/tr/td[1]/div/div";
$WIDELINKS                              = "$GROUPID_SVM_0"."/div[3]/table/tbody/tr/td[1]/div/div";
$CIFS_LOCAL_USERS_AND_GROUPS            = "$GROUPID_SVM_0"."/div[4]/table/tbody/tr/td[1]/div/div";
$PREFERRED_DOMAIN_CONTROLLERS_LIST      = "$GROUPID_SVM_0"."/div[5]/table/tbody/tr/td[1]/div/div";
$AUDIT_CONFIGURATION                    = "$GROUPID_SVM_0"."/div[6]/table/tbody/tr/td[1]/div/div";

$SVM_CONF_NFS                           = "//*[\@id='gwt-debug-SVMConfiguration-gp-groupid-1-hd']/div/div/div";
$NFS_OPTIONS                            = "//div[\@id='gwt-debug-SVMConfiguration-gp-groupid-1']/div[2]/div[1]/table/tbody/tr/td[1]/div/div";

$NAME_SERVICES                            = "//*[\@id='gwt-debug-SVMConfiguration-gp-groupid-2-hd']/div/div/div";
$GROUPID_SVM_2                            = "//div[\@id='gwt-debug-SVMConfiguration-gp-groupid-2']/div[2]";
$UNIX_USERS_AND_GROUPS                    = "$GROUPID_SVM_2"."/div[1]/table/tbody/tr/td[1]/div/div";
$NAME_SERVICE_SWITCH_CONF                = "$GROUPID_SVM_2"."/div[2]/table/tbody/tr/td[1]/div/div";
$HOST_CONFIGURATION                        = "$GROUPID_SVM_2"."/div[3]/table/tbody/tr/td[1]/div/div";
$NETGROUPS                                = "$GROUPID_SVM_2"."/div[4]/table/tbody/tr/td[1]/div/div";
$NIS_CONFIGURATION                        = "$GROUPID_SVM_2"."/div[5]/table/tbody/tr/td[1]/div/div";
$DNS_CONFIGURATION                        = "$GROUPID_SVM_2"."/div[6]/table/tbody/tr/td[1]/div/div";
$LDAP_CONFIGURATION                        = "$GROUPID_SVM_2"."/div[7]/table/tbody/tr/td[1]/div/div";
$NAME_MAPPING_SWITCH_CONF                = "$GROUPID_SVM_2"."/div[8]/table/tbody/tr/td[1]/div/div";

$VOLUME_CONF_CIFS                        = "//*[\@id='gwt-debug-VolumeConfiguration-gp-groupid-0-hd']/div/div/div";
$GROUPID_VOL_0                            = "//div[\@id='gwt-debug-VolumeConfiguration-gp-groupid-0']/div[2]";
$CIFS_SHARE_ACLS                        = "$GROUPID_VOL_0"."/div[1]/table/tbody/tr/td[1]/div/div";
$HOME_DIR_PATHS                            = "$GROUPID_VOL_0"."/div[2]/table/tbody/tr/td[1]/div/div";
$SYMLINKS                                = "$GROUPID_VOL_0"."/div[3]/table/tbody/tr/td[1]/div/div";

$VOLUME_CONF_NFS                        = "//*[\@id='gwt-debug-VolumeConfiguration-gp-groupid-1-hd']/div/div/div";
$GROUPID_VOL_1                            = "//div[\@id='gwt-debug-VolumeConfiguration-gp-groupid-1']/div[2]";
$NFS_EXPORTS                            = $GROUPID_VOL_1."/div[1]/table/tbody/tr/td[1]/div/div";
$CONSOLIDATE_NFS_EXPORT_POLICIES        = $GROUPID_VOL_1."/div[2]/table/tbody/tr/td[1]/div/div";
$REUSE_EXPORT_POLICIES                    = $GROUPID_VOL_1."/div[3]/table/tbody/tr/td[1]/div/div";

$VOLUME_CONF_SAN                        = "//*[\@id='gwt-debug-VolumeConfiguration-gp-groupid-2-hd']/div/div/div";
$IGROUPS_LUN_MAPPING                    = "//div[\@id='gwt-debug-VolumeConfiguration-gp-groupid-2']/div[2]/div[1]/table/tbody/tr/td[1]/div/div";

$SNAPSHOT_SCHEDULES_CONF                = "//*[\@id='gwt-debug-VolumeConfiguration-gp-groupid-3-hd']/div/div/div";
$GROUPID_VOL_3                            = "//div[\@id='gwt-debug-VolumeConfiguration-gp-groupid-3']/div[2]";
$SNAPSHOT_SCHEDULES                        = $GROUPID_VOL_3."/div[1]/table/tbody/tr/td[1]/div/div";
$REUSE_SNAPSHOT_POLICIES                = $GROUPID_VOL_3."/div[2]/table/tbody/tr/td[1]/div/div";
$CONSOLIDATE_7MODE_SNAP_POLICIES        = $GROUPID_VOL_3."/div[3]/table/tbody/tr/td[1]/div/div";

# Generic selectors
$GENERIC_VFILER_SELECTOR                = "//div[starts-with(\@id,'gwt-debug-controllerlist__gwt-debug-controllerlist_XXYYZZ')]";
$GENERIC_VOLUME                         = "//table/tbody/tr/td/div/div[contains(text(),'XXYYZZ')]";
$GENERIC_CHECKBOX                       = "input[\@type='checkbox']";
$GENERIC_VOLUME_STANDALONE_SELECTOR     = "//table/tbody/tr/td/div[contains(text(),'XXYYZZ')]/following::input/parent::div/input";
$GENERIC_VOLUME_STAGGERED_SELECTOR      = $GENERIC_VOLUME."/following::input/following::input/parent::div/input";
$GENERIC_VSERVER                        = "//td/following::div[contains(text(),'XXYYZZ')]/ancestor::tr/descendant::";
$GENERIC_VSERVER_SELECTOR               = $GENERIC_VSERVER.$GENERIC_CHECKBOX;
$GENERIC_MOUNT_VOLUME                   = "//table/tbody/tr/td/div[contains(text(),'Select Target Volume mount policy')]";
$GENERIC_AGGR                           = "//div[contains(text(),'XXYYZZ')]/parent::div/parent::td/following-sibling::td/following-sibling::td//img"; # Here XXYYZZ specifies the volume name
$GENERIC_AGGR_SELECTOR                  = "//div[(\@role='listitem') and  contains(text(),'XXYYZZ')]";
$GENERIC_CMODE_VOLUME_SELECTOR          = "//div[contains(text(),'XXYYZZ')]/parent::div/parent::td/following-sibling::td/following-sibling::td/following-sibling::td//input";
$GENERIC_CLUSTER_SELECTOR               = "//td/div/div[contains(text(),'XXYYZZ')]";
$GENERIC_SMODE_HOSTNAME                 = "//div[contains(text(),'XXYYZZ')]";
$GENERIC_CMODE_HOSTNAME                 = "//div[contains(text(),'XXYYZZ')]";
$CBT_CMODE_HOSTNAME                     = "//div[contains(text(),'XXYYZZ')]/parent::td/following-sibling::td/div";
$EDIT_VOLUME_MOUNT                      = $GENERIC_MOUNT_VOLUME."/../following-sibling::td/div[\@id='gwt-debug-mountPolicyCombo']/img";
$EDIT_DASHBOARD_MOUNT                   = $GENERIC_MOUNT_VOLUME."/../following-sibling::td/div[\@id='gwt-debug-bashBordMountPolicyCombo']/img";
$EDIT_AGGR_MOUNT                        = $GENERIC_VOLUME."/../../../td/following::div[contains(\@role,'combobox')]/img";

$GENERIC_SPINNING_ICON                  = "//img[\@title='Loading...']";
$GENERIC_PLEASE_WAIT                    = "//div[\@class='ext-el-mask-msg']/div/b/span[contains(text(),'Loading')]";
$GENERIC_SESSION_TAB                    = "//li[\@id='gwt-debug-tabpanel__gwt-debug-XXYYZZ#id#antonov#tab']/a[2]/em/span/span";
$GENERIC_SESSION_TAB_CLOSE              = "//li[\@id='gwt-debug-tabpanel__gwt-debug-XXYYZZ#id#antonov#tab']/a";
$GENERIC_TAB                            = "//li[\@id='gwt-debug-tabpanel__gwt-debug-XXYYZZ']/a[2]/em/span/span";
$GENERIC_TAB_CLOSE                      = "//li[\@id='gwt-debug-tabpanel__gwt-debug-XXYYZZ']/a";
$GENERIC_POPUP                          = "//div[\@class='x-shadow x-ignore']";
$GENERIC_SVM_AUDIT_PATH                 = "//div/div/div/span/b[contains(text(),'SVM Audit Logs')]";
$GENERIC_PRECUTOVER                     = "gwt-debug-kerberosDialog";
$GENERIC_UPDATE                         = "gwt-debug-updatenowbutton";
$GENERIC_CUTOVER                        = "//div/span[contains(text(),'Take source volumes offline after transition')]";
$GENERIC_POPUP_MESSAGE                  = "/following-sibling::div/div/following-sibling::div/div/div/div/div/div/span";
$GENERIC_POPUP_COMMIT                   = "/following-sibling::div/div/following-sibling::div/div/div/div/";
$GENERIC_POPUP_TITLE                    = "/following-sibling::div//span";
$GENERIC_POPUP_CLOSE                    = "/following-sibling::div//button";

$GENERIC_SCHEDULE_NAME                          = "gwt-debug-scheduleName-input";
$GENERIC_SCHEDULE_DAYS_SELECT_RADIO             = "gwt-debug-daysRadioBtn";
$GENERIC_SCHEDULE_DAYS_SELECT                   = "//*[\@id='XXYYZZCheckbox']";
$GENERIC_SCHEDULE_START_TIME_HOUR_INPUT         = "gwt-debug-startTimeHour-input";
$GENERIC_SCHEDULE_START_TIME_MIN_INPUT          = "gwt-debug-startTimeMin-input";
$GENERIC_SCHEDULE_DURATION_HOUR_INPUT           = "gwt-debug-durationHour-input";
$GENERIC_SCHEDULE_DURATION_MIN_INPUT            = "gwt-debug-durationMin-input";
$GENERIC_SCHEDULE_UPDATE_FREQUENCY_HOUR_INPUT   = "gwt-debug-updateFrequencyHour-input";
$GENERIC_SCHEDULE_UPDATE_FREQUENCY_MIN_INPUT    = "gwt-debug-updateFrequencyMin-input";

$GENERIC_STREAM_SELECTOR_RADIO                  = "//div[\@id='gwt-debug-specificStream']/input";
$GENERIC_STREAM_SELECTOR                        = "gwt-debug-streamsMaxCap-input";
$GENERIC_AUTO_CONTROL_STREAM_SELECTOR_RADIO     = "//div[\@id='gwt-debug-autoControlStreams']/input";
$GENERIC_AUTO_CONTROL_STREAM_SELECTOR           = "gwt-debug-streamsPercentage-input";
$GENERIC_THROTTLE_SELECTOR_RADIO                = "gwt-debug-specificThrottle";
$GENERIC_THROTTLE_SELECTOR                      = "gwt-debug-throttle-input";
$GENERIC_SCHEDULE_CREATE_BUTTON                 = "gwt-debug-createSchedule";
$GENERIC_SCHEDULE_CREATE_ERROR_MESSAGE          = "//div[\@id='gwt-debug-errorMessage']/span";

$GENERIC_ORIGIN_IP_INPUT                ="gwt-debug-originIP-input";
$GENERIC_TARGET_IP_INPUT                ="gwt-debug-targetIPAddressTxtFld-input";
$GENERIC_TARGET_GATEWAY_INPUT           ="//input[\@id='gwt-debug-dftGatewayTxtFld-input']";
$GENERIC_TARGET_NETMASK_INPUT           ="//input[\@id='gwt-debug-netmaskTxtFld-input']";
$GENERIC_SVM_INPUT                      ="gwt-debug-svmComboBoxFld-input";
$GENERIC_TARGET_NODE_INPUT              ="gwt-debug-svmNodeComboBoxFld-input";
$GENERIC_TARGET_PORT_INPUT              ="gwt-debug-svmNodePortComboBoxFld-input";
$GENERIC_SAVELIF_BUTTON                 ="gwt-debug-saveBtn";
$GENERIC_SMODE_LIF                      ="gwt-debug-add7ModeLifBtn";
$GENERIC_SMODE_LIF_SELECT               ="//td/div[contains(text(),'XXYYZZ')]/../preceding-sibling::td/div/div[\@class='x-grid3-row-checker']";
$GENERIC_CANCELLIF_BUTTON               ="gwt-debug-cancelLIF";
$GENERIC_ADDLIF_BUTTON                  ="gwt-debug-addlif";
$GENERIC_LIF_IP                         = "//td/div[contains(text(),'XXYYZZ')]";
$TRANS_LIF_IP                           = "//tr/td/div[contains(text(),'XXYYZZ')]";
$TRANS_LIF_GATEWAY                      = "/../following-sibling::td/div/div[\@id='gwt-debug-dfltGatewayTxtFld']/input";
$TRANS_LIF_NETMASK                      = "/../following-sibling::td/div/div[\@id='gwt-debug-netmaskTxtfld']/input";
$TRANS_LIF_NODE                         = "/../following-sibling::td/div/div[\@id='gwt-debug-svmNodeComboBoxFld']/input";
$TRANS_LIF_PORT                         = "/../following-sibling::td/div/div[\@id='gwt-debug-svnNodePortComboBoxFld']/input";
$GENERIC_LIF_EDIT                       = "/following::div[\@id='gwt-debug-editLifBtn']";
$GENERIC_LIF_REMOVE                     = "/following::div[\@id='gwt-debug-removeLifBtn']";
$GENERIC_HOME_NODE                      ="gwt-debug-node_XXYYZZ";
$GENERIC_SAVE_NODE                      ="gwt-debug-saveNodePort";
$GENERIC_CLUSTER_EDIT                   ="gwt-debug-EditCluster";
$GENERIC_LISTITEM_SELECTOR              ="//div[(\@role='listitem') and  contains(text(),'XXYYZZ')]";
$GENERIC_SCHEDULE_MODIFIER              ="//div[contains(text(),'XXYYZZ')]/parent::div/parent::td/following::td/following::td/following::td/following::td/following::td/following::td/following::td/following::td//following::td/div/div/table/tbody/tr/td[1]/div/span";
$GENERIC_SCHEDULE_REMOVER               ="//div[contains(text(),'XXYYZZ')]/parent::div/parent::td/following::td/following::td/following::td/following::td/following::td/following::td/following::td/following::td//following::td/div/div/table/tbody/tr/td[2]/div/span";

# Button Id's
$CLOSE_BUTTON                           ="gwt-debug-closeButton";
$CONTINUE_BUTTON                        ="gwt-debug-continueButton";
$GO_TO_DASHBOARD                        = "gwt-debug-gotodashboard";
$EDIT_CONFIGURATION                     = "gwt-debug-editconfiguration";
$SAVE_PROJECT_AND_CONTINUE              = "gwt-debug-updateproject";
$CREATE_PROJECT_AND_CONTINUE            = "gwt-debug-createproject";
$NEXT                                   = "gwt-debug-nextButton";
$CBT_NEXT                               = "gwt-debug-next";
$SKIP                                   = "gwt-debug-skip";
$DASHBOARD                              = "gwt-debug-MigrationDashboardLnk";
$STORAGE_SYSTEMS                        = "gwt-debug-StorageSyatems";
$CBT_STORAGE_SYSTEMS                    = "gwt-debug-StorageSyatems";
$GET_STARTED                            = "gwt-debug-GetStartedBtn";
$CBT_GET_STARTED                        = "gwt-debug-getstarted";
$CREATE_SCHEDULE                        = "gwt-debug-invokeSchedule";
$CREATE_SCHEDULE_DASHBOARD              = "gwt-debug-addScheduleDashboard";
$RUN_PRECHECKS                          = "gwt-debug-precheckbutton";
$SMODE_PRECHECK                         = "gwt-debug-precheck";
$SMODE_PRECHECK_NEXT_BUTTON             = "gwt-debug-nextButton";
$PRECHECK_SUMMARY_TEXT                  = "gwt-debug-summaryText";
$START                                  = "gwt-debug-startbutton";
$PRECUTOVER                             = "gwt-debug-configbutton";
$TEST_MODE_ID                           = "gwt-debug-testmode";
$TEST_MODE                              = "//table/following::div[\@id='$TEST_MODE_ID']/input";
$CUTOVER                                = "gwt-debug-completebutton";
$RESYNC                                 = "gwt-debug-finishbutton";
$ADD_INFO_DURING_PRECUTOVER             = "//div/label/span[contains(text(),'Customize the number of concurrent')]/parent::label/parent::div/input";
$UPDATE_NOW                             = "gwt-debug-updatebutton";
$PAUSE                                  = "gwt-debug-pausebutton";
$RESUME                                 = "gwt-debug-resumebutton";
$ABORT                                  = "gwt-debug-abortbutton";
$DELETE_PROJECT                         = "gwt-debug-deletebutton";
$AUTO_REFRESH                           = "//div[\@id='gwt-debug-autorefresh']/input";
$REFRESH                                = "gwt-debug-refreshbutton";
$VIEW_RESULTS                           = "gwt-debug-ViewDetailedResults";
$VIEW_ROLLBACK_STEP_RESULTS             = "gwt-debug-ViewRollbackStepResults";

# Wait Id's
$WAIT_FOR_PRECHECK                      = "precheck-status:prechecks completed";
$WAIT_FOR_START                         = "baseline-status:baseline data copy completed";
$WAIT_FOR_PAUSE_IN_BASELINE             = "baseline-status:baseline data copy paused";
$WAIT_FOR_PAUSE_IN_INCREMENTAL_D_XFER   = "incremental-status:incremental data copy paused";
$WAIT_FOR_ABORT                         = "cutover-status:transition aborted";
$WAIT_FOR_UPDATE                        = "";
$WAIT_FOR_PRECUTOVER                    = "config-status:apply configuration completed";
$WAIT_FOR_RESYNC                        = "config-status:apply configuration completed";
$WAIT_FOR_CUTOVER                       = "cutover-status:transition completed";

# Id's for set_page
$NAVIGATE_VOLUME_SELECTION_PAGE         = $EDIT_CONFIGURATION;
$NAVIGATE_IP_CONFIGURATION              = $NAVIGATE_VOLUME_SELECTION_PAGE_SESSION_EXISITNG.":".$SAVE_PROJECT_AND_CONTINUE;
$NAVIGATE_PRECHECK                      = $NAVIGATE_IP_CONFIGURATION.":".$NEXT;
$NAVIGATE_SVM_MAPPING                   = $NAVIGATE_PRECHECK.":".$SKIP;
$NAVIGATE_VOLUME_MAPPING                = $NAVIGATE_SVM_MAPPING.":".$NEXT;
$NAVIGATE_INTERFACE_MAPPING             = $NAVIGATE_VOLUME_MAPPING.":".$NEXT;
$NAVIGATE_DATA_COPY_SCHEDULE            = $NAVIGATE_INTERFACE_MAPPING.":".$NEXT;
$NAVIGATE_FINAL_PRECHECK                = $NAVIGATE_DATA_COPY_SCHEDULE.":".$NEXT;
$NAVIGATE_SUBPROJECT_SUMMARY            = $NAVIGATE_FINAL_PRECHECK.":".$SKIP;

$ASSESSMENT_BUTTON                      = "gwt-debug-AssessmentButton";
$APT_ADD_SYSTEMS                        = "Add Systems";
$APT_ADD_SYSTEMS_HOSTNAME               = "gwt-debug-Name-input";
$APT_ADD_SYSTEMS_USERNAME               = "gwt-debug-username-input";
$APT_ADD_SYSTEMS_PASSWORD               = "gwt-debug-password-input";
$APT_ADD_SYSTEMS_TYPE                   = "//div[4]/div/div/input";
$APT_SELECT_SYSTEM                      = "//div[contains(text(),'XXYYZZ')]/parent::td/preceding-sibling::td";
$APT_FILE_PREFIX_SYSTEM                 = "//div[3]/div/div/input";
$APT_WAIT_FOR_REPORT                    = "//span/b[contains(text(),'Transition Assessment Report generation is in progress')]";
$APT_SELECT_TARGET_CLUSTER              = "//div/div/img";
$APT_ADD_SYSTEMS_BUTTON                 = "//div[2]/div[2]/div/div/div/div/div/table/tbody/tr/td/table/tbody/tr/td/table/tbody/tr[2]/td[2]/em/button";


#Id's for CFT
$HAPAIRGRID_GROUPID                     = "//*[\@id='gwt-debug-haPairgrid-gp-groupid-XXYYZZ-hd']/div/div/div";
$GENERIC_RETRIEVING_WAIT                = "//div[\@class='ext-el-mask-msg']";
$MIGRATION_DASHBOARD_LINK               = "gwt-debug-MigrationDashboardLnk";
$MIGRATION_TAB                          = "gwt-debug-tabpanel__gwt-debug-Migration";
$CLUSTER_SELECTOR                       = "//div[\@class='x-grid3-body']/div[XXYYZZ]";
$CFT_CLUSTER                            = "//table/tbody/tr/td/div/div/span[contains(text(),'XXYYZZ')]";
$CLUSTER_HA_SELECTOR                    = "//*[\@id='gwt-debug-clusterNodeGrid-gp-groupid-XXYYZZ-hd']/div/div/div";
$CFT_VFILER                             = "//div[contains (text(),'XXYYZZ')]/parent::td/parent::tr/parent::tbody/parent::table/parent::div/parent::div/parent::td/following-sibling::td/div/div/table/tbody/tr/td";
$GENERIC_VSM                            = "//div[\@id='gwt-debug-SvmComboBoxXXYYZZ']";
$GENERIC_VSM_SELECTOR                   = "//div[(\@role='listitem') and  contains(text(),'XXYYZZ')]";
$CFT_VSM_MAPPING_SAVE                   = "//parent::td/parent::tr/parent::tbody/parent::table/parent::div/parent::div/parent::td/following-sibling::td/following-sibling::td/div/div/table/tbody/tr/td/table[\@id='gwt-debug-SaveBtn']";
$CFT_SMODE_SELECTOR                     = "//div[ (\@id='gwt-debug-VfilerToSvmMappingGrid-gp-groupid-XXXX-hd')]/div[contains(text(),'YYYY (ZZZZ)') ]";
$EDIT_SELECT_TARGET_CLUSTER             = "gwt-debug-EditCluster";
$EDIT_SVM_MAPPING                       = "gwt-debug-EditSVM";
$EDIT_LIF_CONFIG                        = "gwt-debug-editLifConfigDebugId";
$EDIT_HOME_PORT                         = "//td/following::div[contains(text(),'XXYYZZ')]/../../td/div/";
$PROJECT_INSIDE_EDIT                    = "gwt-debug-editconfiguration";
$PROJECT_EDIT_CONFIG                    = "//td/following::div[contains(text(),'XXYYZZ')]/../parent::td/following-sibling::td/following::table[\@id='gwt-debug-EditGroupButton']";
$PROJECT_CFT_EDIT                       = "gwt-debug-EditProjectButton";
$CFT_MODIFY                             = "//td/following::div[contains(text(),'XXYYZZ')]/../parent::td/following-sibling::td/following::table[\@id='gwt-debug-ModifyButton']";
$CFT_EDIT_CLUSTER                       = "gwt-debug-Cluster_nameXXYYZZ";
$GENERIC_PROJECT_TAB                    = "//li[\@id='gwt-debug-tabpanel__gwt-debug-XXYYZZ']/a[2]/em/span/span";
$GENERIC_PROJECT_TAB_CLOSE              = "//li[\@id='gwt-debug-tabpanel__gwt-debug-XXYYZZ']/a[1]";
$SECONDARY_CLUS_NODE                    = "//div[\@id='gwt-debug-TargetClusterNodeSecondary'  and contains(text(),'XXYYZZ')]";
$PRIMARY_CLUS_NODE                      = "//div[\@id='gwt-debug-TargetClusterNodePrimary'  and contains(text(),'XXYYZZ')]";
$SWAP_BUTTON                            = "//*[\@id='gwt-debug-swapNodeMappingButton']/tbody/tr[2]/td[2]/em/button";
$VFILER_GRID                            = "//div[\@id='gwt-debug-VfilerToSvmMappingGrid-gp-groupid-XXYYZZ-bd']";
$VFILER_SELECTOR                        = "/div[XXYYZZ]/table/tbody/tr/td[3]/div/div/table/tbody/tr/td[2]";
$VSM_DROP_DOWN                          = "/div[XXYYZZ]/table/tbody/tr/td[4]/div/div/table/tbody/tr/td/div/input";
$VSM_MAPPING_SAVE                       = "//div[XXYYZZ]/table/tbody/tr/td[6]/div/div/table/tbody/tr/td/table[\@id='gwt-debug-SaveBtn']";
$CFT_PRECHECK_BUTTON                    = "gwt-debug-RunPrecheckButton";
$CFT_CHECK_READINESS                    = "gwt-debug-CutoverReadinessCheckButton";
$CFT_APPLY_CONFIG                       = "gwt-debug-SVMProvisionButton";
$CFT_EXPORT                             = "gwt-debug-ExportButton";
$CFT_VERIFY_CABLING                     = "gwt-debug-CablingButton";
$CFT_IMPORT                             = "gwt-debug-ImportButton";
$CFT_COMMIT                             = "gwt-debug-CommitButton";
$REVERT_DASHBOARD                       = "gwt-debug-RollbackButton";
$REVERT_PRECHECK                        = "gwt-debug-RollbackPrecheckButton";
$CFT_VIEW_DETAIL_BUTTON                 = "//*[\@id='gwt-debug-ViewDetailedResults']/tbody/tr[2]/td[2]/em/button";
$CFT_JOB_RESULT_CLOSE                   = "//*[\@id='gwt-debug-clsoeBtn']/tbody/tr[2]/td[2]/em/button";
$CFT_REVERT_STEPS_CLOSE                 = "//*[\@id='gwt-debug-CloseBtn']/tbody/tr[2]/td[2]/em/button";
$CREATE_NEW_GROUP                       = "gwt-debug-NewProjectGrpRadioBtn";
$GROUP_NAME                             = "gwt-debug-ProjectGrpName-input";
$GROUP_DESC                             = "gwt-debug-PrjectGrpDesc-input";
$MOVE_PROJECT                           = "//td/div/div[\@id='gwt-debug-XXYYZZ']/../../preceding-sibling::td/div/div";
$GROUP_MOVE                             = "gwt-debug-MoveProjectsToAnotherGroup";
$REVERT_BUTTON                          = "//*[\@id='gwt-debug-RevertButton']/tbody/tr[2]/td[2]/em/button";
$CANCEL_REVERT                          = "//*[\@id='gwt-debug-CanceRevertButton']/tbody/tr[2]/td[2]/em/button";
$GENERATE_MANUAL_STEPS                  = "gwt-debug-GenerateRollbackSteps";
$VERIFY_SEVEN_MODE                      = "//*[\@id='gwt-debug-Verify7ModeRollbackButton']/tbody/tr[2]/td[2]/em/button";
$EXISTING_GROUP                         = "//div[(\@role='listitem') and  contains(text(),'XXYYZZ')]";
$SELECT_GROUP                           = "gwt-debug-ChooseProjectGrp-input";
$REVERT_IP                              = "//div[\@id='gwt-debug-AffectedCommonResourceGrid']/div/div/div[2]/div/div[XXYYZZ]/table/tbody/tr/td[2]/div/div";
$RESULT_ID                              = "//div[\@id='gwt-debug-precheckresult']/div[1]/div[1]/div[2]/div/div[XXYYZZ]/table/tbody/tr/td[1]/div/div";
$MSG_INFO                               = "//div[\@id='gwt-debug-precheckresult']/div[1]/div[1]/div[2]/div/div[XXYYZZ]/table/tbody/tr/td[3]/div/div";
$AFFECTED_OBJ                           = "//div[\@id='gwt-debug-RollbackResultGridID']/div[1]/div[1]/div[2]/div/div[XXYYZZ]/table/tbody/tr/td[3]/div/a[\@id='gwt-debug-affectedobjects']";
$REVERT_STEP                            = "//div[\@id='gwt-debug-AffectedCommonResourceGrid']/div/div/div[2]/div/div[XXYYZZ]/table/tbody/tr[2]/td/div/div/div/div/div/div/div/div/div/table/tbody/tr/td/div/span[contains(text(),'Revert Step')]";
$SEVEN_MODE_AGGR                        = "//span[contains(text(),'7-Mode Aggregate')]";
$DISK_SERIAL_NUMBER                     = "//span[contains(text(),'Disk Serial Number')]";
$S_CONTROLLER_NAME                      = "//span[contains(text(),'7-Mode Controller Name')]";
$GENERATE_REVERT_MANUAL                 = "//span[contains(text(),'Rollback Steps Report for the Project')]";
$GENERIC_REVERT                         = "//div[\@id='gwt-debug-AffectedCommonResourceGrid']/div/div/div[2]/div/div[XXYYZZ]";
$GENERIC_REVERT_MSG                     = "/table/tbody/tr[2]/td/div/div/div/div/div/div[2]/div/div[XXYYZZ]/table/tbody/tr/td/div/div";
$CMODE_AGGR_REVERT_MSG                  = "/table/tbody/tr[2]/td/div/div/div/div/div/div/div/div[XXYYZZ]/table/tbody/tr/td[3]/div/div";
$DISK_REVERT_MSG                        = "/table/tbody/tr[2]/td/div/div/div/div/div/div/div/div[XXYYZZ]/table/tbody/tr/td[2]/div/div";
$PRECHECK_SUCCESS                       = "gwt-debug-PlanningState:Precheck Successful";
$APPLY_SVM_SUCCESS                      = "gwt-debug-SVMProvisionState:SVM Configuration Successful";
$EXPORT_SUCCESS                         = "gwt-debug-ExportState:Successful";
$VERIFY_CABLE_SUCCESS                   = "gwt-debug-CablingState:Cabling Verify Successful";
$IMPORT_SUCCESS                         = "gwt-debug-ImportState:Successful";
$COMMIT_SUCCESS                         = "gwt-debug-CommitState:Successful";
$REVERT_SUCCESS                         = "gwt-debug-Revert7ModeState:Reverted";
$PROJECT_DELETE                         = "gwt-debug-DeleteProject";
$PROJECT_HISTORY_TAB                    = "//span[contains(text(),'Operation History')]";

$MIGRATE_BUTTON                         = "gwt-debug-MigrationButton";
$PROJECT_DETAILS                        = "//div/ul/li[1]/a[2]/em/span/span[contains(text(),'Project Details')]";
$DASHBOARD_CLUSTER_IP                   = "//div[contains(text(),'Target Cluster')]/parent::div/div/table/tbody/tr/td/table/tbody/tr/td/div";
$DASHBOARD_S_IP                         = "//div[contains(text(),'7-Mode Controllers')]/parent::div/div/table/tbody/tr/td/table/tbody/tr/td/div";
$MSG_TYPE                               = "//div[\@id='gwt-debug-RollbackResultGridID']/div[1]/div[1]/div[2]/div/div[XXYYZZ]/table/tbody/tr/td[1]/div/div";
$MSG_STEP                               = "//div[\@id='gwt-debug-RollbackResultGridID']/div[1]/div[1]/div[2]/div/div[XXYYZZ]/table/tbody/tr/td[1]/div/";
$CLUSTERSHELL                           = "//span[contains(text(),'Clustershell Command')]";
$SEVEN_MODE_CONTROLLER                  = "//span[contains(text(),'7-Mode Controller')]";
$S_MODE_COMMAND                         = "//span[contains(text(),'7-Mode Command')]";
$REVERT_COMMAND                         = "//div[\@id='gwt-debug-AffectedObjectGrid']/div[2]/div[2]/div/div/div/div[2]/div/div[XXYYZZ]/table/tbody/tr/td[1]/div/div";
$SEVEN_MODE_COMMAND                     = "//div[\@id='gwt-debug-AffectedCommonResourceGrid']/div/div/div[2]/div/div[XXYYZZ]/table/tbody/tr/td[2]/div/div";
$SEVEN_MODE_IP                          = "//div[\@id='gwt-debug-AffectedCommonResourceGrid']/div/div/div[2]/div/div[XXYYZZ]/table/tbody/tr/td[1]/div/div";
$CMODE_CONFIRM_EXECUTION                = "//*[\@id='gwt-debug-ConfirmCommandsOnTargetState']/tbody/tr[2]/td[2]/em/button";
$SMODE_CONFIRM_EXECUTION                = "//*[\@id='gwt-debug-ConfirmCommandsOn7ModeState']/tbody/tr[2]/td[2]/em/button";
$CABLING_CONFIRM                        = "//*[\@id='gwt-debug-ConfirmCablingState']/tbody/tr[2]/td[2]/em/button";
$CFT_CHECKBOX_MESSAGE                   = "//*[\@id='gwt-debug-disconnectClientAccessCheckbox']/label";
$CFT_CHECKBOX_CONFIRM                   = "//*[\@type='checkbox']";
$STREAM_ROW                             = "//div[\@id='gwt-debug-streamingStepGrid-gp-groupid-XXYYZZ']";
$PRECHECK_MSG                           = "//div[2]/div[ROW_NUMBER]/table/tbody/tr/td[COLUMN_NUMBER]/div/div";
$MSG_COUNT                              = $STREAM_ROW."//div/div/p/span";
$ROW_ELEMENT                            = "//*[\@id='gwt-debug-streamingStepGrid-gp-groupid-XXYYZZ-hd']/div/p";
$ERROR_ROW_ELEMENT                      = "//*[\@id='gwt-debug-streamingStepGrid-gp-groupid-XXYYZZ-hd']/div/div/p";
$REVERT_ROW                             = "//div[2]/div[ROW_NUMBER]/table/tbody/tr/td[COLUMN_NUMBER]/div/";
$REVERT_TITLE                           = $STREAM_ROW."//div/div/p[contains(text(),'Generating the rollback steps')]";
$CANCEL_ROLLBACK                        = "//*[\@id='gwt-debug-CanceRollbackButton']/tbody/tr[2]/td[2]/em/button";
$FLEX_CONFIG_NEXT                       = "gwt-debug-NextButtonDebugId";
$SVM_PLAN_CONFIG                        = "//div[(\@id='gwt-debug-SVM_nameXX') and  contains(text(),'YY')]";
$PROJECT_CFT_EDIT                       = "gwt-debug-EditProjectButton";
$CFT_EDIT_PLAN_CONFIG                   = "gwt-debug-EditConfigButton" ;

$GROUPNAME_VALID                        = "//div[contains(font/text()[1], 'The maximum number of characters allowed in a project group name is')]";
$GROUPNAME_VALID_SPLCHAR                = "//div[contains(font/text()[1], 'are not allowed in the project group name.')]";
$GROUP_EXIST                            = "//div[contains(font/text()[1], 'Error:A project group with the name')]";
$PROJECT_EXIST                          = "//div[contains(font/text()[1], 'Error:A project with the name')]";  

1;
