#$Id$
# Copyright (c) 2009 Network Appliance, Inc.
# All rights reserved.
#
## @summary
##  Global Constants used to fetch System Manager details.
##
## @description
##  Using this library, user can fetch the System Manger details.
##
## @synopsis
##  use NACL::APISet::Host::GUI::SysManager::GConst;
##
## @status public
##
## @author      Arun William. arunw@netapp.com
## @change
##  

package NACL::APISet::Host::GUI::SysManager::GConst;

use FindBin;
use Cwd;

use Exporter 'import';

our @EXPORT = qw ( $APISET_OBJ $SYSTEM_IP_KEY $SYSTEM_NAME_KEY $SYSTEM_USERNAME_KEY $SYSTEM_PASSWORD_KEY $SYSTEM_TYPE_KEY $SYSTEM_NODECOUNT_KEY $SYSTEM_VSERVER_NAME $SYSTEM_TYPE_HA $SYSTEM_TYPE_SINGLE $SYSTEM_TYPE_VSERVER $SYSTEM_TYPE_CMODE $TESTDATA_FILENAME $TESTDATA_MODULE_SHEET $TESTDATA_PARAM_SHEET $TESTDATA_DYNAMIC_SHEET $TESTDATA_MODULE_TITLE $TESTDATA_ENABLED_TITLE $TESTDATA_PARAM_TITLE $TESTDATA_VAL_TITLE $TESTDATA_SERVERDETAIL_TITLE $TESTDATA_SERVERVALUES_TITLE $TESTDATA_DESC_TITLE $TESTDATA_TC_TITLE $TESTDATA_CAT_TITLE $TESTDATA_MODE_TITLE $PLAN_FILENAME $JOB_FILENAME $PARAM_VERSION $PARAM_CATEGORY $PARAM_MODE $PARAM_TESTBEDDIR $PARAM_BROWSER $PARAM_SMSERVERIP $PARAM_NORMAL_AGGR $PARAM_SNAPLOCK_AGGR $PARAM_NORMAL_AGGR1 $PARAM_NORMAL_AGGR2 $PARAM_NORMAL_AGGR3 $PARAM_SELPORT $PARAM_SMURL $PARAM_CLUSTERDETAIL $PARAM_NODECOUNT $PARAM_NODE $PARAM_VSERVER  $PARAM_CIFSADDETAILS $PARAM_CIFSWINSDETAILS $PARAM_NFSCLIENTDETAILS $PARAM_TRAPHOSTS $PARAM_MAILHOSTS $PARAM_TIMEZONE $PARAM_TIMEDSERVERS $PARAM_LICENSES $PARAM_SSLCERTIFICATEDETAILS $PARAM_DP_SOURCE_FILER $PARAM_DP_DEST_FILER $PARAM_DP_DEST_FILER_DIFF_CLUSTER $VSERVER_DUM $GENERIC_WAIT $PARAM_METHOD_TIMEOUT $PARAM_CLIENT_DETAILS $PARAM_QC_DATA $PARAM_INTERFACES);

# Test Data Excel file name
$TESTDATA_FILENAME= "TestData.xls";

#Hash Key for APISET object
$APISET_OBJ = "NACLobj";

# Hash keys used by System Details Hash
$SYSTEM_IP_KEY = "systemIp";
$SYSTEM_NAME_KEY = "systemName";
$SYSTEM_USERNAME_KEY = "systemUsername";
$SYSTEM_PASSWORD_KEY = "systemPassword";
$SYSTEM_TYPE_KEY = "type";
$SYSTEM_NODECOUNT_KEY = "nodeCount";
$SYSTEM_VSERVER_NAME = "vserver_name";

# Values for System Type
$SYSTEM_TYPE_HA = "HA Pair";
$SYSTEM_TYPE_SINGLE = "Storage Controller";
$SYSTEM_TYPE_VSERVER = "Vserver"; #This is for future use - vserver admin scope
$SYSTEM_TYPE_CMODE = "Cluster";

# Sheet names in Test Data Excel
$TESTDATA_MODULE_SHEET = "Modules";
$TESTDATA_PARAM_SHEET = "Parameters";
$TESTDATA_DYNAMIC_SHEET = "Dynamic";

# Title names for columns in Test Data Excel
$TESTDATA_MODULE_TITLE = "Module";
$TESTDATA_ENABLED_TITLE = "Enabled";
$TESTDATA_PARAM_TITLE = "Parameter";
$TESTDATA_VAL_TITLE = "Value";
$TESTDATA_SERVERDETAIL_TITLE = "DynamicParams";
$TESTDATA_SERVERVALUES_TITLE = "InputValues";
$TESTDATA_DESC_TITLE = "Description";
$TESTDATA_TC_TITLE = "Testcase";
$TESTDATA_CAT_TITLE = "Category";
$TESTDATA_MODE_TITLE = "Mode";

# Config files
$PLAN_FILENAME= "sm.plan";
$JOB_FILENAME= "sm.job";

#Parameters
$PARAM_VERSION = "VERSION";
$PARAM_CATEGORY = "CATEGORY";
$PARAM_MODE  = "MODE";
$PARAM_TESTBEDDIR  = "TESTBEDDIR";
$PARAM_BROWSER = "BROWSER";
$PARAM_SMSERVERIP = "SMSERVERIP";
$PARAM_NORMAL_AGGR = "NORMAL_AGGR";
$PARAM_SNAPLOCK_AGGR = "SNAPLOCK_AGGR";
$PARAM_NORMAL_AGGR1 = "NORMAL_AGGR1";
$PARAM_NORMAL_AGGR2 = "NORMAL_AGGR2";
$PARAM_NORMAL_AGGR3 = "NORMAL_AGGR3";
$PARAM_SELPORT = "SELPORT";
$PARAM_SMURL = "SMURL";
$PARAM_CLUSTERDETAIL = "CLUSTERDETAIL";
$PARAM_NODECOUNT = "NODECOUNT";
$PARAM_NODE = "NODE";
$PARAM_VSERVER = "VSERVER";

$PARAM_CIFSADDETAILS = "CIFSADDETAILS";
$PARAM_CIFSWINSDETAILS = "CIFSWINSDETAILS";
$PARAM_NFSCLIENTDETAILS = "NFSCLIENTDETAILS";

$PARAM_TRAPHOSTS="TRAPHOSTS";
$PARAM_MAILHOSTS="MAILHOSTS";
$PARAM_TIMEZONE="TIMEZONE";
$PARAM_TIMEDSERVERS="TIMEDSERVERS";
$PARAM_LICENSES="LICENSES";
$PARAM_SSLCERTIFICATEDETAILS="SSL_CERTIFICATE_DETAILS";

$PARAM_DP_SOURCE_FILER = "DP_SOURCE_FILER";
$PARAM_DP_DEST_FILER = "DP_DEST_FILER";
$PARAM_DP_DEST_FILER_DIFF_CLUSTER = "DP_DEST_FILER_DIFF_CLUSTER";

$PARAM_METHOD_TIMEOUT = "METHOD_TIMEOUT";
$PARAM_QC_DATA = "QC_DATA";
$PARAM_CLIENT_DETAILS = "CLIENT_DETAILS";
$PARAM_INTERFACES = "INTERFACES";

#Vserver
$VSERVER_DUM= "dumour";
$GENERIC_WAIT = 400000;

1;
