#
# Copyright (c) 2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary API Set for VPserver SOAP commands
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

package NACL::APISet::Host::SOAP::VPserver;

#
# Compiler Directives
#
use strict;
use warnings;

use base qw(NACL::APISet::Host::SOAP);
#
# Module imports - APISet
#
use NACL::APISet::Session::SOAP::VPserver;

=head1 NAME

NACL::APISet::Host::SOAP::VPserver - API Set for VPserver SOAP commands

=head1 SYNOPSIS

use NACL::APISet::Host::SOAP::VPserver;

=head1 DESCRIPTION

A C<NACL::APISet::Host::SOAP::VPserver> is used to connect to and send SOAP commands
to the VPserver Host.

=head1 CONSTRUCTORS

=head2 new

Returns a reference to a newly created C<NACL::APISet::Host::SOAP::VPserver>.

=over

=item Synopsis

 $api_set_obj = NACL::APISet::Host::SOAP::VPserver->new( %args );

=item Arguments

=over

=item %args

(Optional)
Parameters passed to parent classes. See NACL::APISet and
NACL::APISet::Host::SOAP for details.

=back

=item Returns

A reference to a new API Set.

=back

=head1 METHODS

=head2 NOTE

For documentation of method calls please refer to the api documentation on the VPserver.
The documentation is available through a browser link on the VPserver located at: https://<hostname>:9083/
All paramters specified for these commands should be specified as an array of NATE::SOAP::Data
objects; or, the parameters should be passed in as an array of structured hashes references, defined by the specific
API you intend to run.

=head1 AUTHOR/MAINTAINER

=over

=item NACL Development (dl-nacl-dev@netapp.com)

=back

=cut

1;
