# $Id: //depot/prod/test/nacldev/lib/NACL/APISet/Host/VMAPI/ESX.pm $
#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
## @summary Initialize VIM APISet object construction
## @author bkprasha@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here
package NACL::APISet::Host::VMAPI::ESX;

#
#APISet imports
#
use base qw(NACL::APISet::Host::VMAPI);
use NACL::APISet::Session::VMAPI::ESX;
#
#
#
use VMware::VIRuntime;
use VMware::VILib;
use VMware::VIExt;
#
#Nate imports
#
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
#
#CPAN imports
#
use Data::Dumper;

sub new {
    $Log->enter() if $may_enter;
    
    my ($class, %args) = @_;
    my $self = {};

    $self = NACL::APISet::validate_params(
        $class,
        params => \%args,
        spec => {
            version => { type => SCALAR, optional => 1 }
        }
    );

    bless $self, $class;
	
	$Log->exit() if $may_exit;
	
    return $self;
}


##############################################################################
#                                    POD here
##############################################################################

=head1 NAME

NACL::APISet::Host::VMAPI::ESX - Initialize VIM APISet object construction

=head1 SYNOPSIS

 use NACL::APISet::Host::VMAPI::ESX;

=head1 DESCRIPTION

A C<NACL::APISet::Host::VMAPI::ESX> is used to initialize VIM object construction. 
This is further subclassed to VMAPI to call the methods as specified by the user
on the ESX pointed to by the constructed VIM object.

=head1 EXCEPTIONS

None

=head1 Constructors

=head2 new

Returns a reference to a newly created C<NACL::APISet::Host::VMAPI::ESX>.  

=over

=item Synopsis

$api_esx_pkg = NACL::APISet::Host::VMAPI::ESX->new( %args );

=item Arguments

=back

# $Id: //depot/prod/test/nacldev/lib/NACL/APISet/Host/VMAPI/ESX.pm $

=cut

1;
