# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary Routines to manipulate flexgroup file placement options
##
## @description
##    This library is to turn on and off flexgroup deterministic placement on a node.
##
## @synopsis
##    flexgroup_placement(%args);
##
##
## @author rishis@netapp.com
## @status public

package NACL::APISet::Node::CLI::7Mode::default::flexgroup_placement;

use strict;
use warnings;
use NATE::BaseException qw(:try);
use NACL::APISet::Response::CLI::ParserUtils;
use NACL::APISet::Response::CLI::CannedParsers;
use NACL::APISet::Exceptions::CommandFailedException ':try';

my %method_hash = (
    flexgroup_placement => {cmd_pass_string => 'ok',},
);

parser_method_builder(__PACKAGE__, %method_hash);
1;

## @name :: flexgroup_placement
##
## @summary Modify flexgroup placement at node level
##
## @description Enable/Disable flexgroup placement at node level
##
## @synopsis
##      flexgroup_placement (%args);
## INPUTS TO METHOD CALL 'flexgroup_placement' ON APISET OBJECT
## <table border = "1" >
## <tr> <th> OPTION </th> <th> PROGRAMMATIC NAME </th> </tr>
## <tr> <td> No switch for this key </td> <td> 'enable' </td> </tr> 
## </table>
## @arg %args Required:
## response_object => The response object that was constructed (containing the
##                    raw output, command line constructed and execution status)
## @return
##  Null in case of success. Exception in case of failure
## @examples

