# $Id$
# ----------------------------------------------------------------------------
# # Copyright (c) 2014 Network Appliance, Inc.
# All rights reserved.
# ----------------------------------------------------------------------------
## @summary
##
##
## @description
##
##
## @synopsis
##      use SmVservers;
##
##      clickVserver(%args);
##      closeVserver(%args);
##      createVserver(%args);
##      deleteVserver(%args);
##      editVserver(%args);
##      getVserverDetails(%args);
##      getVserverPeerDetails(%args);
##TODO:      reEnrtyProtoclSetUp(%args);
##      refreshVserver(%args);
##      setVserverOperation(%args);
##      setVserverTab(%args);
##      startVserver(%args);
##      stopVserver(%args);
##
## @status shared
## @author ng-sysmgr-automation-core
## @change 18/2/2015 : neelkant : Initial template converted form base java library.
## @pod here

=head1 NAME

NACL::APISet::Node::GUI::CMode::SmVserver

=head1 DESCRIPTION

NACL::APISet::Node::GUI::CMode::SmVserver

=cut

package NACL::APISet::Node::GUI::CMode::SmVserver;

# Compiler directives.
use strict;
use warnings;

# Common Module imports.
use Cwd qw(abs_path);
use Data::Dumper;
use NATE::ParamSet;
use Params::Validate qw(validate_with UNDEF SCALAR ARRAYREF );
use Selenium::Remote::WDKeys;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

# NACL Module imports.
use NACL::APISet::Node::GUI::CMode::GlobalConst;

# NATE Exception Module import.
use NATE::BaseException qw(:try);

# Export required items
use Exporter 'import';

# Export all the public libraries
our @EXPORT = qw (
  clickVserver
  closeVserver
  createVserver
  deleteVserver
  editVserver
  getVserverDetails
  getVserverPeerDetails
  getVserverOperation
  reEnrtyProtoclSetUp
  refreshVserver
  setClusterName
  setVserverOperation
  setVserverTab
  startVserver
  stopVserver
);

# Declare the Global Varibales
our $VSERVER_CREATE_PROTOCOL_CHECKBOX_NFS = undef;
our $VSERVER_CREATE_PROTOCOL_CHECKBOX_ISCSI= undef;
our $VSERVER_CREATE_PROTOCOL_CHECKBOX_CIFS = undef;
our $VSERVER_CREATE_PROTOCOL_CHECKBOX_FC = undef;
our $VSERVER_CREATE_DATA_INT_FIELD = undef;
our $VSERVER_CREATE_PORT_BROWSE_BTN = undef;
our $VSERVER_CREATE_NET_PORT_INT_GRID = undef;
our $elementIdOrXpath     = undef;
our $startTime            = undef;
our $vserver              = undef;
our $vserverOperation     = undef;

=head1 METHODS

=head2 clickVserver

Returns boolean

=over

=item Options

=over

=item C<< vserver => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub clickVserver {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params => \@_,
        spec   => { 'vserver'  => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );
    my $vserverPageID = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} .
                        "VserverPageVserverGrid";
    $self->setVserverTab( 'vserver' => $args{'vserver'});
    $self->reset_filters($vserverPageID, ["Name:"]);
    $self->set_filters($vserverPageID, ["Name:$args{'vserver'}"]);
    $self->click_row_with_texts( $vserverPageID, $args{'vserver'} );
    $self->wait_for_loading();
    return 1;
} ## end clickVserver

=head2 closeVserver

Returns void

=over

=item Options

=over


=back

=back

=over

=back

=cut

sub closeVserver {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = @_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Closing Vserver Create Dialog");
    my $cancelButton =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "VserverSetupDialogCancelButton";
    my $cancelConfirm =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "VserverSetupCancelConfirmationDialogYes";

    if ( $self->is_element_present($cancelButton) ) {
        $Log->comment("Clicking on Vserver Create dialog cancel button");
        $self->_find_element($cancelButton)->click();
    }
    $self->wait_for_loading();
    if ( $self->is_element_present($cancelConfirm) ) {
        $Log->comment(
            "Clicking on Vserver Create Cancel dialog Yes button");
        $self->_find_element($cancelConfirm)->click();
    }
    $self->wait_for_loading();
    if ( $self->is_element_present($GENERIC_DIALOG2_OK_BUTTON) ) {
        $Log->comment("Clicking on Vserver Create dialog final OK button");
        $self->_find_element($GENERIC_DIALOG2_OK_BUTTON)->click();
    }
    $Log->exit() if $may_exit;

} ## end closeVserver

=head2 createVserver

Returns void

=over

=item Options

=over

=item C<< vserver => SCALAR >>

 (Required)

=item C<< is-repository => BOOLEAN >>

 (Optional)

=item C<< protocol => ARRAYREF >>

 (Optional)

=item C<< language => SCALAR >>

 (Optional)

=item C<< aggregate => SCALAR >>

 (Optional)

=item C<< rootvolume-security-style => SCALAR >>

 (Optional)

=item C<< ddns => SCALAR >>

 (Optional)

=item C<< dnsDomain => SCALAR >>

 (Optional)

=item C<< dnsServer => SCALAR >>

 (Optional)

=item C<< rorule => SCALAR >>

 (Optional)

=item C<< rwrule => SCALAR >>

 (Optional)

=item C<< adDetails => SCALAR >>

 (Optional)

=item C<< cifsDomain => SCALAR >>

 (Optional)

=item C<< cifsPassword => SCALAR >>

 (Optional)

=item C<< cifsServer => SCALAR >>

 (Optional)

=item C<< cifsUserName => SCALAR >>

 (Optional)

=item C<< clientSpec => SCALAR >>

 (Optional)

=item C<< exportName => SCALAR >>

 (Optional)

=item C<< exportPermission => SCALAR >>

 (Optional)

=item C<< exportSize => SCALAR >>

 (Optional)

=item C<< exportSizeUnit => SCALAR >>

 (Optional)

=item C<< fcLifNode => SCALAR >>

 (Optional)

=item C<< fcoeAdvanced => SCALAR >>

 (Optional)

=item C<< fcoeInterfaceName => SCALAR >>

 (Optional)

=item C<< fcoeLifNode => SCALAR >>

 (Optional)

=item C<< fcoePort => SCALAR >>

 (Optional)

=item C<< fcoeportSets => SCALAR >>

 (Optional)

=item C<< fcpAdvanced => SCALAR >>

 (Optional)

=item C<< fcpInterfaceName => SCALAR >>

 (Optional)

=item C<< fcpPort => SCALAR >>

 (Optional)

=item C<< fcpportSets => SCALAR >>

 (Optional)

=item C<< ipSpace => SCALAR >>

 (Optional)

=item C<< iscsiAdvanced => SCALAR >>

 (Optional)

=item C<< iscsiIP => SCALAR >>

 (Optional)

=item C<< iscsiInterfaceName => SCALAR >>

 (Optional)

=item C<< iscsiPort => SCALAR >>

 (Optional)

=item C<< lifNode => SCALAR >>

 (Optional)

=item C<< lunInitiator => SCALAR >>

 (Optional)

=item C<< lunInitiatorFC => SCALAR >>

 (Optional)

=item C<< lunOS => SCALAR >>

 (Optional)

=item C<< lunOSFC => SCALAR >>

 (Optional)

=item C<< lunProv => SCALAR >>

 (Optional)

=item C<< lunProvFC => SCALAR >>

 (Optional)

=item C<< lunSizeUnit => SCALAR >>

 (Optional)

=item C<< lunSizeUnitFC => SCALAR >>

 (Optional)

=item C<< manualIPCIFS => SCALAR >>

 (Optional)

=item C<< manualIPCIFSAddress => SCALAR >>

 (Optional)

=item C<< manualIPIscsi => SCALAR >>

 (Optional)

=item C<< manualIPIscsiAddress => SCALAR >>

 (Optional)

=item C<< manualIPNFS => SCALAR >>

 (Optional)

=item C<< manualIPNFSAddress => SCALAR >>

 (Optional)

=item C<< manualIPVSAddress => SCALAR >>

 (Optional)

=item C<< manualIPVsAdmin => SCALAR >>

 (Optional)

=item C<< newLifMgt => SCALAR >>

 (Optional)

=item C<< nisDomain => SCALAR >>

 (Optional)

=item C<< nisServer => SCALAR >>

 (Optional)

=item C<< noRetain => SCALAR >>

 (Optional)

=item C<< node => SCALAR >>

 (Optional)

=item C<< orgUnit => SCALAR >>

 (Optional)

=item C<< port => SCALAR >>

 (Optional)

=item C<< portSets => SCALAR >>

 (Optional)

=item C<< removeUser => SCALAR >>

 (Optional)

=item C<< shareName => SCALAR >>

 (Optional)

=item C<< sharePermission => SCALAR >>

 (Optional)

=item C<< shareSize => SCALAR >>

 (Optional)

=item C<< shareSizeUnit => SCALAR >>

 (Optional)

=item C<< shareUser => SCALAR >>

 (Optional)

=item C<< smb => SCALAR >>

 (Optional)

=item C<< subnet => SCALAR >>

 (Optional)

=item C<< superUser => SCALAR >>

 (Optional)

=item C<< targetAlias => SCALAR >>

 (Optional)

=item C<< vsAdmin => SCALAR >>

 (Optional)

=item C<< vsAdminPasswd => SCALAR >>

 (Optional)

=item C<< vsAdminPasswdConfirm => SCALAR >>

 (Optional)

=item C<< vsMgtLif => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub createVserver {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = @_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Creating Vserver from System Manager");
    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;
    my $execution_time = time;

    try {
        $self->setVserverTab( 'vserver' => $args{'vserver'});
        $Log->comment("Setting Vserver Create Button");
        $self->setVserverOperation( 'operation' => "Create", );
        $elementIdOrXpath = $self->getVserverOperation();
        $startTime        = $self->click_EventTime($elementIdOrXpath);
        $Log->comment("Wait for 2 LOADING and 1 FETCHING");
        $self->wait_for_element_not_present($LOADING);
        $self->wait_for_element_not_present($LOADING);
        $self->wait_for_element_not_present($FETCHING);
        $self->captureResponseTime( $startTime,
            $methodName . "_initial_loading" );
        $Log->comment( "Entering vserver Name: " . $args{'vserver'} );
        $self->_find_element( "gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "vserverSetupCreatePageVserverName-input" )
          ->send_keys( $args{'vserver'} );

        unless ( exists( $args{'ipspace'}) ) {
            $args{'ipspace'} = 'Default';
        }
        if ( $self->_find_element(
                    "gwt-debug-" . $self->{$SYSTEM_NAME_KEY}
                  . "vserverSetupCreatePageVserverIpSpace-input")->is_enabled())
          {
            $Log->comment( "Entering ipspace: " . $args{'ipspace'} );
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "vserverSetupCreatePageVserverIpSpace-input" )
              ->send_keys( $args{'ipspace'} );
            $Log->comment(
                "Selecting ipspace from drop down: " . $args{'ipspace'} );
            $self->_find_element(
                    "//div[contains(\@class,'x-combo-list-item') and text()='"
                  . $args{'ipspace'}
                  . "']" )->click();
        }

        if ( exists( $args{'is-repository'} ) 
                 and $args{'is-repository'} =~ /1|true/i ) {
            $Log->comment( "Selecting Volume Type: Inifinite(CR) Vol: $args{'is-repository'}");
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "VserverSetupCreateNamePanelVSIVRadio" )->click();
        } else {
            $Log->comment( "Selecting Volume Type: Flex Vol");
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "VserverSetupCreateNamePanelVSFVRadio" )->click();
        }

        if ( grep( /cifs/i, @{ $args{'protocol'} } ) ) {
            $Log->comment("Selecting the protocol CIFS");
            $self->click($VSERVER_CREATE_PROTOCOL_CHECKBOX_CIFS);
        }

        if ( grep( /nfs/i, @{ $args{'protocol'} } ) ) {
            $Log->comment("Selecting the protocol NFS");
            $self->click($VSERVER_CREATE_PROTOCOL_CHECKBOX_NFS);
        }

        if ( grep( /iscsi/i, @{ $args{'protocol'} } ) ) {
            $Log->comment("Selecting the protocol iSCSI");
            $self->click($VSERVER_CREATE_PROTOCOL_CHECKBOX_ISCSI);
        }

        if ( grep( /fcp|fcoe/i, @{ $args{'protocol'} } ) ) {
            $Log->comment("Selecting the protocol FCP/FCoE");
            $self->click($VSERVER_CREATE_PROTOCOL_CHECKBOX_FC);
        }

        if ( exists $args{'language'} ) {
            $Log->comment( "Selecting the language: " . $args{'language'} );
            $self->_find_element( "gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "vserverSetupCreatePageLanguageComboBox-input" )->click();
            $self->_find_element( "//div[contains(\@class,'x-combo-list-inner')]"
              . "/div[contains(text(),'"
              . $args{'language'}
              . "')]" )->click();
        }
        if ( exists( $args{'rootvolume-security-style'} ) ) {
            if ( $args{'rootvolume-security-style'} =~ /mixed/i ) {
                $Log->comment(
                    "OCSM supports only NTFS and UNIX security styles"
                  . "\nSetting security style to UNIX");
                $args{'rootvolume-security-style'} = 'UNIX';
            }
            $Log->comment(
                "Selecting the Security Style: " . $args{'rootvolume-security-style'} );
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "vserverSetupCreatePageSecutiryStyleComboBox-input" )
              ->click();
            $self->_find_element(
                    "//div[contains(\@class,'x-combo-list-inner')]"
                  . "/div[contains(text(),'"
                  . uc($args{'rootvolume-security-style'})
                  . "')]" )->click();
        }

        $Log->comment( "Selecting the Aggregate: " . $args{'aggregate'} );
        $self->_find_element( "gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "vserverSetupCreatePagerootAggrCombo-input" )->click();
        $self->_find_element( "//table/tbody/tr/td[contains(\@title,'"
              . $args{'aggregate'}
              . "')]" )->click();

        if (    exists( $args{'dnsDomain'} )
            and exists( $args{'dnsServer'} ) ) {
            $Log->comment( "Entering dns domain: " . $args{'dnsDomain'} );
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "vserverSetupCreatePageDnsSearchDomainField-input" )
              ->clear();
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "vserverSetupCreatePageDnsSearchDomainField-input" )
              ->send_keys( $args{'dnsDomain'} );
            $Log->comment( "Entering dns server: " . $args{'dnsServer'} );
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "vserverSetupCreatePageDnsNameServerField-input" )->clear();
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "vserverSetupCreatePageDnsNameServerField-input" )
              ->send_keys( $args{'dnsServer'} );
        }

        if ( exists( $args{'ddns'} ) ) {
            $Log->comment("Clicking DDNS Combobox");
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "vserverSetupCreatePageDynamicDNSComboBox-input" )->click();
            $Log->comment( "Selecting the " . $args{'ddns'} );
            $self->mouseOvertoElement(
                $self->_find_element(
                        "//div[contains"
                      . "(\@class,'x-combo-list-item') and text()='"
                      . $args{'ddns'} . "']"
                )
            );
            $self->_find_element( "//div[contains"
                  . "(\@class,'x-combo-list-item') and text()='"
                  . $args{'ddns'}
                  . "']" )->click();
            if ( $self->is_element_present(
                   "gwt-debug-"
                   . $self->{$SYSTEM_NAME_KEY}
                   . "vserverSetupCreatePageWarningMessageLabelField")) {
                $Log->comment("Cheking for the error msg for CIFS DDNS");
                my $CIFSWarningMSG =
                  $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "vserverSetupCreatePageWarningMessageLabelField" )
                  ->get_text();
                $Log->comment(
                    "Warning msg coming for CIFS " . $CIFSWarningMSG );
            }
            $Log->comment( "Getting Domain name(FQDN) for " . $args{'ddns'} );
        }
        if (
            $self->is_element_present(
                "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "VserverSetupDialogSubmitButton"
            )
          )
        {
            $Log->comment( "Clicking on Submit button in SVM Details page and "
                  . "\nWait for CREATING SVM element not present "
                  . "\nWait for UPDATING SVM element not present "
                  . "\nWait for SETTING Up DNS settings element not present" );
            $elementIdOrXpath =
              $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "VserverSetupDialogSubmitButton" );
            $startTime = $self->click_EventTime($elementIdOrXpath);
            $self->wait_for_element_not_present($CREATING);
            $self->wait_for_element_not_present($UPDATING);
            $self->wait_for_element_not_present($SETTING);
            $self->captureResponseTime( $startTime,
                $methodName . "_createVserver" );
        }

        if ( $self->_find_element(
           "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} .
           "VserverSetupDialogSkipButton")->is_enabled()
        ) {
            $self->check_for_error();
        }

        if ( grep( /cifs|nfs/i, @{ $args{'protocol'} } ) ) {
            $startTime = $self->captureStartTime();
            $Log->comment( "Wait for 'LOADING domain names and IP "
                  . "address element' not present, in Configure CIFS/NFS protocol page"
            );
            $self->eventWaitingTime( $LOADING, $startTime,
                $methodName . "_loading_dns_IP_address" );

            if ( grep( /cifs/i, @{ $args{'protocol'} } ) ) {
                $Log->comment("Configuring CIFS Protocol");
                $self->wait_for_element_present($VSERVER_CREATE_DATA_INT_FIELD);

                if ( exists($args{'subnet'})) {
                    $Log->comment("Clicking on Subnet text box");
                    $self->_find_element("//div[contains(\@id,'subnetPortInterfacePanelSubnetInfoCombo')]")->click();
                    $Log->comment( "Selecting Subnet: " . $args{'subnet'} );
                    $self->_find_element("//div[contains(\@class,'ellipsis') and text()='" . $args{'subnet'} . "']")->click();
                }
                if ( exists($args{'node'}) and exists($args{'port'}) ) {
                    $startTime = $self->click_EventTime($elementIdOrXpath);
                    $self->eventWaitingTime( $RETRIEVING, $startTime, $methodName . "_retrieving_nodes_in_select_port_cifs_nfs" );
                    $Log->comment( "clicking on node: " . $args{'node'} );

                    $Log->comment("Select port for LIF configuration");
                    $self->click($VSERVER_CREATE_PORT_BROWSE_BTN);
                    $self->wait_for_loading();
                    $Log->comment( "Select Node containing port: ". $args{'node'});
                    $startTime = $self->captureStartTime();
                    $self->click_row_with_texts($VSERVER_CREATE_NET_PORT_INT_GRID, 1,1, $args{'node'});
                    $self->eventWaitingTime( $LOADING_WITHOUT_TEXT, $startTime, $methodName . "_loading_ports_in_select_port_cifs_nfs" );
            
                    $self->wait_for_loading();
                    $Log->comment( "Clicking on the port " . $args{'port'});
                    $self->click_row_with_texts($VSERVER_CREATE_NET_PORT_INT_GRID, $args{'port'});

                    $Log->comment( "Clicking on Port Browse dialog OK Button");
                    $self->click($GENERIC_DIALOG2_OK_BUTTON);
                }   
                if ( exists( $args{'cifsServer'} ) ) {
                    $Log->comment(
                        "Entering cifsServer: " . $args{'cifsServer'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasCifsConfigPanelCifsServerNameTextField-input"
                    )->clear();
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasCifsConfigPanelCifsServerNameTextField-input"
                    )->send_keys( $args{'cifsServer'} );
                    $Log->comment(
                        "Entering cifs Domain: " . $args{'cifsDomain'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasCifsConfigPanelActiveDirTextField-input"
                    )->send_keys( $args{'cifsDomain'} );

                    if ( exists( $args{'orgUnit'} ) ) {
                        $Log->comment(
                           "Entering cifsServer: " . $args{'orgUnit'} );
                         $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                             . "VserverSetupNasCifsConfigPanelOrgTextField-input"
                        )->clear();
                         $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                             . "VserverSetupNasCifsConfigPanelOrgTextField-input"
                        )->send_keys( $args{'orgUnit'} );
                    }
                     $Log->comment(
                        "Entering cifs Username: " . $args{'cifsUserName'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasCifsConfigPanelAdminNameTextField-input"
                    )->send_keys( $args{'cifsUserName'} );
                    $Log->comment(
                        "Entering cifs Password: " . $args{'cifsPassword'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasCifsConfigPanelAdminPassTextField-input"
                    )->send_keys( $args{'cifsPassword'} );
             }
                if ( exists( $args{'shareName'} ) ) {
                    $Log->comment(
                        "Entering Share Name: " . $args{'shareName'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "CifsConfigPanelExportTextField-input" )
                      ->send_keys( $args{'shareName'} );
                    $Log->comment(
                        "Entering Share Size: " . $args{'shareSize'} );
                    $self->_find_element(
"//div/table/tbody/tr[3]/td[2]/div/table/tbody/tr/td/div/input"
                    )->send_keys( $args{'shareSize'} );
                    $Log->comment( "Selecting Share Size Unit: "
                          . $args{'shareSizeUnit'} );
                    $self->_find_element(
                        "//td[2]/div/table/tbody/tr/td[2]/div/img")
                      ->click();
                    $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'shareSizeUnit'}
                          . "']" )->click();
                    if ( exists( $args{'sharePermission'} ) ) {
                        $Log->comment("Clicking On Change Button");
                        $elementIdOrXpath = $self->_find_element(
                            "//span[contains(text(),'Change')]");
                        $startTime =
                          $self->click_EventTime($elementIdOrXpath);
                        $Log->comment(
                            "Wait for LOADING element not present");
                        $self->eventWaitingTime( $LOADING, $startTime,
                            $methodName . "_share_permission" );
                        if ( exists( $args{'shareUser'} ) ) {
                            $Log->comment(
                                "Clicking On User/Group ADD Button");
                            $elementIdOrXpath =
                              $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "CifsShareManageEditShareDialogPermissionTabAddBtn"
                              );
                            $startTime =
                              $self->click_EventTime($elementIdOrXpath);
                            $Log->comment(
                                "Wait for LOADING element not present");
                            $self->eventWaitingTime( $LOADING, $startTime,
                                $methodName . "_share_user" );
                            $Log->comment( "Entering User/Group: "
                                  . $args{'shareUser'} );
                            $self->_find_element("//form/div/div/div/input")
                              ->send_keys( $args{'shareUser'} );
                            $Log->comment(
                                "Clicking On User/Group ADD OK Button");
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "CifsShareManageAddUserGroupDialogOkBtn"
                            )->click();
                            sleep(2);
                        }
                        if ( exists( $args{'removeUser'} ) ) {
                            $Log->comment( "Removing the user "
                                  . $args{'removeUser'} );
                            $Log->comment(
                                "Selecting the user navigate remove");
                            $self->_find_element(
                                    "//div[contains(\@id,'gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "CifsShareManageEditShareDialogPermissionTabUserListView')]/div[text()='"
                                  . $args{'removeUser'}
                                  . "']" )->click();
                            $Log->comment("Clicking on the remove buttton");
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "CifsShareManageEditShareDialogPermissionTabRemoveBtn"
                            )->click();
                        }
                        $Log->comment(
                            "Clicking On User/Group ADD Save Button");
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "CifsShareManageEditShareDialogOkBtn" )
                          ->click();
                    }
                }
                if ( exists( $args{'smb'} ) ) {
                    my $allShare =
                        "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "VserverSetupNasCifsConfigPanelEncryptDataChkBox']/input";
                    my $thisShare =
                        "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "VserverSetupNasCifsConfigPanelEncryptShareChkBoxCheckBox']/input";
                    if (   $self->is_checked( $self->_find_element($allShare))
                        || $self->is_checked( $self->_find_element($thisShare))
                    ) {
                        NATE::BaseException->throw("None of the SMB checkbox
                            should be enabled by default");
                    } else {
                            $Log->comment(
                                "Verified default values for SMB encryption");
                    }
                    if ( $args{'smb'} =~ /allShare/ ) {
                        $Log->comment("Enabiling all shares checkbox");
                        $self->_find_element($allShare)->click();
                        if ( !$self->is_element_present(
                                $thisShare
                                  . "[contains(\@checked,'') and contains(\@disabled,'')]"
                            )) {
                            NATE::BaseException->throw(
                                "Thisshare checkbox should be checked" 
                              . " and disabled upon selecting all share"
                            );
                            
                        } else {
                            $Log->comment(
                                    "Verified this share option is disabled"
                                  . " upon selecting all shares option"
                            );
                        }
                    }
                    if ( $args{'smb'} =~ /thisShare/ ) {
                        $Log->comment("Enabiling this shares checkbox");
                        $self->_find_element($thisShare)->click();
                        if (
                            $self->is_element_present(
                                $allShare . "[contains(\@checked,'')]"
                            )
                            || $self->is_element_present(
                                $allShare . "[contains(\@disabled,'')]"
                            )
                          )
                        {
                            $Log->comment( "All shares checkbox is still " 
                                         . " enabled upon selecting thisshare");
                        } else {
                            NATE::BaseException->throw(
                                "All shares checkbox should not "
                              . "get enabled upon selecting thisshare" );
                        }
                    }
                }
                my $manualIPAutoRadio =
                    "//div[\@id='gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "cifssubnetPortInterfacePanelAutoSelectRadio']/input";
                my $manualIPSpecificRadio =
                    "//div[\@id='gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "cifssubnetPortInterfacePanelSpecificIPRadio']/input";
                my $manualIPSpecificInput =
                    "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "cifssubnetPortInterfacePanelIpAddressTextField-input";
                if ( exists( $args{'manualIPCIFS'} ) ) {
                    if ( !$self->is_selected(
                            $self->_find_element($manualIPAutoRadio))) {
                        NATE::BaseException->throw( 
                            "Auto Select IPAddress is not selected by default");
                    }
                    $Log->comment("Selecting specific radio button");
                    $self->_find_element($manualIPSpecificRadio)->click();
                    $Log->comment( "Entering specific IPAddress: "
                          . $args{'manualIPCIFS'} );
                    $self->_find_element($manualIPSpecificInput)->clear();
                    $self->_find_element($manualIPSpecificInput)
                      ->send_keys( $args{'manualIPCIFS'} );
                }
            }
            if ( grep( /nfs/i, @{ $args{'protocol'} } ) ) {
                    $Log->comment("Clicking on Subnet text box");
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "nfssubnetPortInterfacePanelSubnetInfoCombo-input"
                    )->click();
                    $Log->comment( "Selecting Subnet: " . $args{'subnet'} );
                    $self->_find_element(
                        "//div[contains(\@class,'ellipsis') and text()='"
                          . $args{'subnet'}
                          . "']" )->click();
                    $Log->comment("clicking on browse");
                    $elementIdOrXpath = $self->_find_element(
                        "//button[contains(text(),'Browse')]");
                    $startTime = $self->click_EventTime($elementIdOrXpath);
                    $Log->comment("Wait for LOADING element not present");
                    $self->eventWaitingTime( $LOADING, $startTime,
                        $methodName . "_nfs_subnet_browse" );
                    $Log->comment( "clicking on node: " . $args{'node'} );
                    $self->_double_click(
                                "//div[contains(\@id,'gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "NetworkPortInterfaceGrid')]/div/span[contains(\@class,'x-tree3-node-text') and text()='"
                              . $args{'node'} . "']"
                    );
                    $self->wait_for_element_not_present($LOADING);
                    $Log->comment(
                        "Clicking on the port " . $args{'port'} );
                    $self->_find_element(
                        "//div[contains(\@class,'x-tree3-el')]/span"
                      . "[contains(\@class,'x-tree3-node-text') and text()='"
                      . $args{'port'}
                      . "']" )->click();
                    $Log->comment("Clicking on ok");
                    $self->_find_element($GENERIC_DIALOG2_OK_BUTTON)->click();
                    my $manualIPAutoRadio =
                        "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "nfssubnetPortInterfacePanelAutoSelectRadio']/input";
                    my $manualIPSpecificRadio =
                        "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "nfssubnetPortInterfacePanelSpecificIPRadio']/input";
                    my $manualIPSpecificInput =
                        "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "nfssubnetPortInterfacePanelIpAddressTextField-input";

                    if ( exists( $args{'manualIPNFS'} )) {
                        if (
                            !$self->is_selected(
                                $self->_find_element($manualIPAutoRadio)
                            )
                          ) {
                            NATE::BaseException->throw(
                               "Auto Select IPAddress is not selected by default");
                        }
                        if ( $args{'manualIPNFS'} =~ /specific/ ) {
                            $Log->comment(
                                "Selecting specific radio button");
                            $self->_find_element($manualIPSpecificRadio)
                              ->click();
                            $Log->comment( "Entering specific IPAddress: "
                                  . $args{'manualIPNFS'} );
                            $self->_find_element($manualIPSpecificInput)
                              ->clear();
                            $self->_find_element($manualIPSpecificInput)
                              ->send_keys( $args{'manualIPNFS'} );
                        }
                    } elsif ( exists( $args{'manualIPNFS'} ) ) {
                        $Log->comment("Selecting specific radio button");
                        $self->_find_element($manualIPSpecificRadio)
                          ->click();
                        my @ipAddress =
                          split( /,/, $args{'manualIPNFS'} );
                        for ( my $i = 0 ; $i < @ipAddress ; $i++ ) {
                            $self->_find_element($manualIPSpecificInput)
                              ->clear();
                            $Log->comment( "Entering specific IPAddress: "
                                  . $ipAddress[$i] );
                            $self->_find_element($manualIPSpecificInput)
                              ->send_keys( $ipAddress[$i] );
                            if ( $i == ( @ipAddress - 1 ) ) {
                                last;
                            } else {
                                $Log->comment(
                                    "Clicking on Submit Button in Configure NFS page");
                                $self->_find_element( "gwt-debug-"
                                      . $self->{$SYSTEM_NAME_KEY}
                                      . "VserverSetupDialogSubmitButton" )->click();
                                $self->check_for_error();
                            }
                        }
                    } elsif ( exists( $args{'noRetain'} ) ) {
                        if ( $self->is_checked(
                                $self->_find_element(
                                   "//div[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY}
                                   . "VserverSetupNasDataInterfacePanelDataIntfCheckboxCheckBox']/input"
                        ))) {
                            $Log->comment(
                                "Clicking Retain CheckBox as NFS and CIFS config is different");
                            $self->_find_element( "//div[\@id='gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "VserverSetupNasDataInterfacePanelDataIntfCheckboxCheckBox']/input"
                            )->click();
                        }
                        $Log->comment("Clicking on Subnet text box");
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "nfssubnetPortInterfacePanelSubnetInfoCombo-input"
                        )->click();
                        sleep(2);
                        $Log->comment( "Selecting Subnet: " . $args{'subnet'} );
                        $self->_find_element(
                            "//div[contains(\@class,'ellipsis') and text()='"
                              . $args{'subnet'}
                              . "']" )->click();
                        $Log->comment("Clicking on browse");
                        $elementIdOrXpath = $self->_find_element(
                          "//table/tbody/tr[2]/td[2]/em/button"
                        );
                        $startTime = $self->click_EventTime($elementIdOrXpath);
                        $self->eventWaitingTime( $RETRIEVING, $startTime,
                            $methodName . "_subnet" );
                        $Log->comment( "clicking on node: " . $args{'node'} );
                        $self->_double_click(
                                    "//div[contains(\@id,'gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "NetworkPortInterfaceGrid')]//span[contains(\@class,'x-tree3-node-text') and text()='"
                                  . $args{'node'} . "']"
                        );
                        $self->wait_for_element_not_present($LOADING);
                        $self->wait_for_element_not_present($RETRIEVING);
                        $Log->comment( "Clicking on the port " . $args{'port'} );
                        $self->_find_element(
                                "//div[contains(\@class,'x-tree3-el')]//span"
                              . "[contains(\@class,'x-tree3-node-text') and text()='"
                              . $args{'port'}
                              . "']" )->click();
                        $Log->comment("Clicking on ok");
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "NetworkPortSelectDialogOkButton" )->click();
                        my $manualIPAutoRadio =
                            "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "nfssubnetPortInterfacePanelAutoSelectRadio']/input";
                        my $manualIPSpecificRadio =
                            "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "nfssubnetPortInterfacePanelSpecificIPRadio']/input";
                        my $manualIPSpecificInput =
                            "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "nfssubnetPortInterfacePanelIpAddressTextField-input";

                        if ( exists( $args{'manualIPNFS'} )
                            && !$args{'manualIPNFS'} =~ /negative/ )
                        {
                            if (
                                !$self->is_selected(
                                    $self->_find_element($manualIPAutoRadio)
                                )
                              )
                            {
                                $Log->comment( "Auto Select IPAddress is not selected by default");
                                $self->closeVserver();
                                $Log->exit() if $may_exit;
                                return 0;
                            }
                            if ( $args{'manualIPNFS'} =~ /specific/ ) {
                                $Log->comment(
                                    "Selecting specific radio button");
                                $self->_find_element($manualIPSpecificRadio)
                                  ->click();
                                $Log->comment( "Entering specific IPAddress: "
                                      . $args{'manualIPNFS'} );
                                $self->_find_element($manualIPSpecificInput)
                                  ->clear();
                                $self->_find_element($manualIPSpecificInput)
                                  ->send_keys( $args{'manualIPNFS'} );
                            }
                        }
                    }
                    if ( exists( $args{'nisDomain'} )
                     and exists( $args{'nisServer'} ) ) {
                        $Log->comment("NIS configuration details");
                        if (
                            !$self->is_element_present(
                                    "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "VserverSetupNasConfigNisPanelDomainNameFieldTextArea-input"
                            )
                          )
                        {
                            $self->send_keys( KEYS->{PAGE_DOWN} );
                            sleep(2);
                            $self->click(
                                $self->_find_element(
                                        "//fieldset[\@id='gwt-debug-"
                                      . $self->{$SYSTEM_NAME_KEY}
                                      . "VserverSetupNasConfigNisPanelNisConfigFieldSet']/legend/div"
                                )
                            )->perform();
                        }
                        sleep(2);
                        $Log->comment(
                            "Entering NIS Details: " . $args{'nisDomain'} );
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "VserverSetupNasConfigNisPanelDomainNameFieldTextArea-input"
                        )->clear();
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "VserverSetupNasConfigNisPanelDomainNameFieldTextArea-input"
                        )->send_keys( $args{'nisDomain'} );
                        $Log->comment(
                            "Entering NIS Details: " . $args{'nisServer'} );
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "VserverSetupNasConfigNisPanelIpAddressesFieldTextArea-input"
                        )->clear();
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "VserverSetupNasConfigNisPanelIpAddressesFieldTextArea-input"
                        )->send_keys( $args{'nisServer'} );

                        if ( exists( $args{'exportName'} ) ) {
                            $Log->comment( "Entering Export Name: "
                                  . $args{'exportName'} );
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "VserverSetupNasConfigNisPanelNfsExportAsFieldTextField-input"
                            )->send_keys( $args{'exportName'} );
                            $Log->comment( "Entering Export Size: "
                                  . $args{'exportSize'} );
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "VserverSetupNasConfigNisPanelNfsVolumeSizeFieldTextField-input"
                            )->send_keys( $args{'exportSize'} );
                            $Log->comment( "Selecting Export Size Unit: "
                                  . $args{'exportSizeUnit'} );
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "VserverSetupNasConfigNisPanelNfsVolumeStorageUnitFieldSimpleComboBox-input"
                            )->click();
                            $self->_find_element( "//div[contains(\@class,'x-combo-list-item') and text()='"
                                  . $args{'exportSizeUnit'}
                                  . "']" )->click();
                            if ( exists( $args{'exportPermission'} ) ) {
                                $Log->comment("Clicking On Change Button");
                                $self->_find_element( "gwt-debug-"
                                      . $self->{$SYSTEM_NAME_KEY}
                                      . "VserverSetupNasConfigNisPanelNfsExportPolicyChangeLinkCustomLink"
                                )->click();
                                $self->wait_for_element_not_present($LOADING);
                                $Log->comment( "Entering Client Specification: "
                                      . $args{'clientSpec'} );
                                $self->_find_element( "gwt-debug-"
                                      . $self->{$SYSTEM_NAME_KEY}
                                      . "CreateModifyRuleDialogClientSpec-input"
                                )->clear();
                                $self->_find_element( "gwt-debug-"
                                      . $self->{$SYSTEM_NAME_KEY}
                                      . "CreateModifyRuleDialogClientSpec-input"
                                )->send_keys( $args{'clientSpec'} );
                                if ( exists( $args{'protocol'} ) ) {
                                    $Log->comment(
                                        "Spliting the Access Protocols ");
                                    my @protocols = @{$args{'protocol'}};
                                    for ( my $i = 0 ; $i < @protocols ; $i++ ) {
                                        if ( $protocols[$i] =~ /CIFS/ ) {
                                            $Log->comment("Disabling CIFS");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "CreateModifyRuleDialogCifsChkBox']/input"
                                            )->click();
                                        }
                                        elsif ( $protocols[$i] =~ /NFSv3/ ) {
                                            $Log->comment("Disabling NFSv3");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "nfsv3CheckBOx']/input" )
                                              ->click();
                                        }
                                        elsif ( $protocols[$i] =~ /NFSv4/ ) {
                                            $Log->comment("Disabling NFSv4");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "nfsv4CheckBOx']/input" )
                                              ->click();
                                        }
                                        elsif ( $protocols[$i] =~ /NFS/ ) {
                                            $Log->comment("Disabling NFS");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "nfsCheckBOx']/input" )
                                              ->click();
                                        }
                                        elsif ( $protocols[$i] =~ /Flexcache/ )
                                        {
                                            $Log->comment(
                                                "Disabling Flexcache");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "CreateModifyRuleDialogFlexcacheChkBox']/input"
                                            )->click();
                                        }
                                    }
                                }
                                if ( exists( $args{'rorule'} ) ) {
                                    $Log->comment(
                                        "Enabiling Read only Check Box");
                                    $self->_find_element(
                                            "//div[\@id='gwt-debug-"
                                          . $self->{$SYSTEM_NAME_KEY}
                                          . "CreateModifyRuleDialogReadOnlyCheckBox']/input"
                                    )->click();
                                    $Log->comment( "Spliting the Access Details RO");
                                    my @protocols = split( /:/, $args{'rorule'} );
                                    for ( my $i = 0 ; $i < @protocols ; $i++) {
                                        if ( $protocols[$i] =~ /UNIX/i ) {
                                            $Log->comment("Disabling UNIX");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "CreateModifyRuleDialogRoRuleUnixChkBox']/input"
                                            )->click();
                                        } elsif ( $protocols[$i] =~ /(Kerberos 5)|(krb5)/ ) {
                                            $Log->comment(
                                                "Disabling Kerberos 5");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "CreateModifyRuleDialogRoRuleKerberos5ChkBox']/input"
                                            )->click();
                                        } elsif ( $protocols[$i] =~
                                            /(Kerberos 5i)|(krb5i)/ ) {
                                            $Log->comment(
                                                "Disabling Kerberos 5i");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "CreateModifyRuleDialogRoRuleKerberos5iChkBox']/input"
                                            )->click();
                                        } elsif ( $protocols[$i] =~ /NTLM/i ) {
                                            $Log->comment("Disabling NTLM");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "CreateModifyRuleDialogRoRuleNtlmChkBox']/input"
                                            )->click();
                                        }
                                    }
                                }
                                if ( exists( $args{'rwrule'} ) ) {
                                    if ( $args{'rwrule'} =~ /disable|none/ ) {
                                        $Log->comment(
                                            "Disabling Read Write Check Box"
                                        );
                                        $self->_find_element(
                                                "//div[\@id='gwt-debug-"
                                              . $self->{$SYSTEM_NAME_KEY}
                                              . "CreateModifyRuleDialogReadWriteCheckBox']/input"
                                        )->click();
                                    } else {
                                        $Log->comment( "Spliting the Access Details RW");
                                        my @protocols = split( /:/, $args{'rwrule'} );
                                        for ( my $i = 0 ; $i < @protocols ; $i++) {
                                            if ( $protocols[$i] =~ /UNIX/i ) {
                                                $Log->comment(
                                                    "Disabling UNIX");
                                                $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                      . $self->{$SYSTEM_NAME_KEY}
                                                      . "CreateModifyRuleDialogRoRuleUnixChkBox']/input"
                                                )->click();
                                            } elsif ( $protocols[$i] =~ /(Kerberos 5)|(krb5)/ ) {
                                                $Log->comment(
                                                    "Disabling Kerberos 5");
                                                $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                      . $self->{$SYSTEM_NAME_KEY}
                                                      . "CreateModifyRuleDialogRoRuleKerberos5ChkBox']/input"
                                                )->click();
                                            } elsif ( $protocols[$i] =~ /(Kerberos 5i)/ ) {
                                                $Log->comment(
                                                    "Disabling Kerberos 5i"
                                                );
                                                $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                      . $self->{$SYSTEM_NAME_KEY}
                                                      . "CreateModifyRuleDialogRoRuleKerberos5iChkBox']/input"
                                                )->click();
                                            } elsif ( $protocols[$i] =~ /NTLM/i ) {
                                                $Log->comment(
                                                    "Disabling NTLM");
                                                $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                      . $self->{$SYSTEM_NAME_KEY}
                                                      . "CreateModifyRuleDialogRoRuleNtlmChkBox']/input"
                                                )->click();
                                            }
                                        }
                                    }
                                }
                                if ( exists( $args{'superUser'} ) ) {
                                    $Log->comment("Enabling SuperUser Access");
                                    $self->_find_element(
                                            "//div[\@id='gwt-debug-"
                                          . $self->{$SYSTEM_NAME_KEY}
                                          . "CreateModifyRuleDialogRuleLabelSuperUserCheckBox']/input"
                                    )->click();
                                }
                                $Log->comment( "Clicking on Modify Export Rule Dialog OK Button");
                                $self->_find_element( "gwt-debug-"
                                      . $self->{$SYSTEM_NAME_KEY}
                                      . "CreateModifyRuleDialogOkBtn" )
                                  ->click();
                                $self->wait_for_element_not_present($LOADING);
                            }
                        }
                    }
             }   

             if ( $self->is_element_present(
                            "gwt-debug-" . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupDialogSubmitButton") ) {

                    $Log->comment(
                        "Clicking on Submit & Continue Button in Configure CIFS/NFS page");
                    $elementIdOrXpath =
                      $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupDialogSubmitButton" );
                    $startTime = $self->click_EventTime($elementIdOrXpath);
                    $Log->comment("Wait for CREATING element not present");
                    $self->eventWaitingTime( $CREATING, $startTime,
                        $methodName . "_configure_cifs_nfs_submit" );
                    if (   ( exists( $args{'shareName'} ) )
                        || ( exists( $args{'exportName'} ) ) )
                    {
                        $self->wait_for_element_not_present($PROVISIONING);
                        $self->wait_for_element_not_present($CREATING);
                    }
             } else {
                 if (
                    $self->is_element_present(
                            "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupDialogSkipButton"
                    )
                  )
                 {
                    $Log->comment("Clicking on skip Button");
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupDialogSkipButton" )->click();
                 }
             }
             $startTime = $self->captureStartTime();
             $self->wait_for_element_not_present($CREATING);
             $self->wait_for_element_not_present($LOADING);
             $self->captureResponseTime( $startTime, $methodName .  "_NFS_CIFS_Configuration");
        }
        if ( grep( /iscsi/i, @{ $args{'protocol'} } ) ) {
            $startTime = $self->captureStartTime();
            $Log->comment( "Wait for 3 RETRIEVING : "
                  . "Retrieving Nodes in down starte, "
                  . "Retrieving HA Pairs and "
                  . "Retrieving Ports "
                  . " in Configure iSCSI page" );
            $self->wait_for_element_not_present($RETRIEVING);
            $self->wait_for_element_not_present($RETRIEVING);
            $self->wait_for_element_not_present($RETRIEVING);
            $self->captureResponseTime( $startTime,
                $methodName . "_loading_iscsi" );
            my $Warning =
              "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "IscsiPageValidationError";
            if ( $self->is_element_present($Warning) ) {
                my $text = $self->_find_element($Warning)->get_text();
                $Log->comment($text);
                if (
                    $self->is_element_present(
                            "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupDialogSkipButton"
                    )
                  )
                {
                    $Log->comment("Clicking on skip Button");
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupDialogSkipButton" )->click();
                }
            }
            else {
                $Log->comment("Configuring iScsi Protocol");
                $Log->comment(
                    "Entering targetAlias: " . $args{'targetAlias'} );
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "IscsiPageTargetAliasTextField-input" )
                  ->send_keys( $args{'targetAlias'} );
                $Log->comment( "Entering lifNode: " . $args{'lifNode'} );
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "IscsiPageIntfPerNodeField-input" )->clear();
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "IscsiPageIntfPerNodeField-input" )
                  ->send_keys( $args{'lifNode'} );
                if (
                    $self->is_element_present(
                        "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "iscsiVerticalPanel"
                    )
                  )
                {
                    $Log->comment("Clicking on Vertical Panel");
                    $self->_find_element(
                        "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "iscsiVerticalPanel" )
                      ->click();
                    $self->wait_for_element_not_present($RETRIEVING);
                }
                if ( exists( $args{'lunProv'} ) ) {
                    $Log->comment( "Entering lun prov: " . $args{'lunProv'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "IscsiPageSizeTextField-input" )
                      ->send_keys( $args{'lunProv'} );
                    $Log->comment(
                        "Selecting Lun size Unit: " . $args{'lunSizeUnit'} );
                    $self->_find_element( "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "IscsiPageSizeValuesCombo']/img" )->click();
                    $self->_find_element( "//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'lunSizeUnit'}
                          . "']" )->click();
                    $Log->comment( "Selecting Lun OS Type: " . $args{'lunOS'} );
                    $self->_find_element( "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "IscsiPageLunOsTypesCombo']/img" )->click();
                    $self->_find_element( "//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'lunOS'}
                          . "']" )->click();
                    $Log->comment(
                        "Entering initiator: " . $args{'lunInitiator'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "IscsiPageHostInitiatorTextField-input" )
                      ->send_keys( $args{'lunInitiator'} );
                }
                if ( exists( $args{'subnet'} ) ) {
                    $Log->comment("Clicking on Subnet text box");
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "IscsiPageSubnetCombobox-input" )->click();
                    $Log->comment( "Selecting Subnet: " . $args{'subnet'} );
                    $Log->comment(
                        "And waiting for \"Retrieving best suited ports\" element not present"
                    );
                    $elementIdOrXpath = $self->_find_element(
                            "//div[contains(\@class,'ellipsis') and text()='"
                          . $args{'subnet'}
                          . "']" );
                    $startTime = $self->click_EventTime($elementIdOrXpath);
                    $self->eventWaitingTime( $RETRIEVING, $startTime,
                        $methodName . "_iscsiVerticalPanel" );
                }
                my $manualIPAutoRadio =
                    "//div[\@id='gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "IscsiPageAutoSelectRadio']/input";
                my $manualIPSpecificRadio =
                    "//div[\@id='gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "IscsiPageSpecificIPRadio']/input";
                my $manualIPSpecificInput =
                    "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "IscsiPageStartingIpTextField-input";
                if ( exists( $args{'manualIPIscsi'} ) ) {
                    if (
                        !$self->is_selected(
                            $self->_find_element($manualIPAutoRadio)
                        )
                      )
                    {
                        NATE::BaseException->throw(
                            "Auto Select IPAddress is not selected by default");
                    }
                    $Log->comment("Selecting specific radio button");
                    $self->_find_element($manualIPSpecificRadio)->click();
                    $Log->comment( "Entering specific IPAddress: "
                          . $args{'manualIPIscsi'} );
                    $self->_find_element($manualIPSpecificInput)->clear();
                    $self->_find_element($manualIPSpecificInput)
                      ->send_keys( $args{'manualIPIscsi'} );
                }
            }
            if ( exists( $args{'iscsiAdvanced'} ) ) {
                $Log->comment("Clicking on Vertical Panel");
                $self->_find_element(
                    "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "iscsiVerticalPanel" )
                  ->click();
                $self->wait_for_element_not_present($RETRIEVING);
                $Log->comment("Clicking on Advanced Setting CheckBox");
                $self->_find_element( "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "IscsiPageAdvancedSettingsCheckbox']/input" )->click();
                if ( exists( $args{'portSets'} ) ) {
                    $Log->comment(
                        "Entering number of portsets: " . $args{'portSets'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "iscsiPortsetSpinner-spinnerField-input" )->clear();
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "iscsiPortsetSpinner-spinnerField-input" )
                      ->send_keys( $args{'portSets'} );
                }
                if ( exists( $args{'iscsiInterfaceName'} ) ) {
                    $self->_find_element(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div"
                    )->click();
                    $Log->comment("Double Clicking the interface row");
                    $self->_double_click(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div"
                    );
                    $self->wait_for_element_not_present($LOADING);
                    $Log->comment( "Entering interface name: "
                          . $args{'iscsiInterfaceName'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "iscsiInterfaceNameCol-input" )->clear();
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "iscsiInterfaceNameCol-input" )
                      ->send_keys( $args{'iscsiInterfaceName'} );
                }
                if ( exists( $args{'iscsiPort'} ) ) {
                    $Log->comment("Clicking on port selection");
                    $self->_find_element(
                        "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "iscsiHomeportCol-input" )
                      ->click();
                    $Log->comment( "Selecting port: " . $args{'iscsiPort'} );
                    $self->_find_element(
                       "//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'iscsiPort'}
                          . "']" )->click();
                    $Log->comment("Clicking On Save Button");
                    $self->_find_element("//button[text()='Save']")->click();
                }
                if ( exists( $args{'iscsiIP'} ) ) {
                    $self->_find_element(
                        "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "iscsiPpAddrCol-input" )
                      ->clear();
                    $Log->comment(
                        "Entering iscsi ipaddress: " . $args{'iscsiIP'} );
                    $self->_find_element(
                        "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "iscsiPpAddrCol-input" )
                      ->send_keys( $args{'iscsiIP'} );
                }
                if ( $self->is_element_present("//button[text()='Save']") ) {
                    $Log->comment("Clicking on Save button");
                    $self->_find_element("//button[text()='Save']")->click();
                    $self->_check_for_errordialog();
                }
            }

            if ( $self->is_element_present(
                        "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "VserverSetupDialogSubmitButton" ) ) {
                $Log->comment("Clicking on Submit Button");
                $elementIdOrXpath =
                  $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "VserverSetupDialogSubmitButton" );
                $Log->comment("Clicking On Submit Button");
                $Log->comment( " and wait for "
                      . "Validating duplicate portsets "
                      . "Configuring iSCSI Data LIFs "
                      . "Configuring LIFs "
                      . "& Starting iscsi service" );
                $startTime = $self->click_EventTime($elementIdOrXpath);
                $self->wait_for_element_not_present($VALIDATING);
                $self->wait_for_element_not_present($CONFIGURING);
                $self->wait_for_element_not_present($RETRIEVING);
                $self->wait_for_element_not_present($STARTING);
                $self->captureResponseTime( $startTime,
                    $methodName . "_iSCSI_config" );
            }
            $self->_check_for_errordialog()
        }
        if ( grep( /fcp|fcoe/i, @{ $args{'protocol'} } )  ) {
            $Log->comment("Configuring FC/FCoE Protocols");
                $Log->comment("Configuring FC Page Config CheckBox");
                $self->_find_element( "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "fcPageConfigCheckbox']/input" )->click();
                $Log->comment(
                    "Entering FC Lif Per Node: " . $args{'fcLifNode'} );
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "fcPageIntfPerNodeField-input" )->clear();
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "fcPageIntfPerNodeField-input" )
                  ->send_keys( $args{'fcLifNode'} );
                $Log->comment("Clicking on Text Box");
                $self->_find_element(
"//td[3]/div/table/tbody/tr[2]/td[2]/div/table/tbody/tr/td/div/input"
                )->click();
                $self->wait_for_element_not_present($LOADING);

                if ( exists( $args{'lunProvFC'} ) ) {
                    $Log->comment( "Entering lun prov: " . $args{'lunProvFC'} );
                    $self->_find_element(
"//td[3]/div/table/tbody/tr[2]/td[2]/div/table/tbody/tr/td/div/input"
                    )->send_keys( $args{'lunProvFC'} );
                    $Log->comment(
                        "Selecting Lun size Unit: " . $args{'lunSizeUnitFC'} );
                    $self->_find_element(
"//td[3]/div/table/tbody/tr[2]/td[2]/div/table/tbody/tr/td[2]/div/img"
                    )->click();
                    $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'lunSizeUnitFC'}
                          . "']" )->click();
                    $Log->comment(
                        "Selecting Lun OS Type: " . $args{'lunOSFC'} );
                    $self->_find_element(
                        "//td[3]/div/table/tbody/tr[3]/td[2]/div/img")->click();
                    $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'lunOSFC'}
                          . "']" )->click();
                    $Log->comment(
                        "Entering initiator: " . $args{'lunInitiatorFC'} );
                    $self->_find_element(
                        "//td[3]/div/table/tbody/tr[4]/td[2]/div/input")
                      ->send_keys( $args{'lunInitiatorFC'} );
                }
                if ( exists( $args{'fcpAdvanced'} ) ) {
                    $Log->comment("Clicking on Advanced Setting CheckBox");
                    $self->_find_element( "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcPageAdvancedSettingsCheckbox']/input" )->click();
                    $Log->comment( "Entering number of portsets: "
                          . $args{'fcpportSets'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcPortsetSpinner-spinnerField-input" )->clear();
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcPortsetSpinner-spinnerField-input" )
                      ->send_keys( $args{'fcpportSets'} );
                    if ( exists( $args{'fcpInterfaceName'} ) ) {
                        $self->_find_element(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div"
                        )->click();
                        sleep(5);
                        $Log->comment("Double Clicking the interface row");
                        $self->_double_click(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div"
                        );
                        sleep(5);
                        $Log->comment( "Entering interface name: "
                              . $args{'fcpInterfaceName'} );
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "fcInterfaceNameCol-input" )->clear();
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "fcInterfaceNameCol-input" )
                          ->send_keys( $args{'fcpInterfaceName'} );

                        if ( exists( $args{'fcpPort'} ) ) {
                            $Log->comment("Clicking on port selection");
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "fcHomeportCol-input" )->click();
                            $Log->comment(
                                "Selecting port: " . $args{'fcpPort'} );
                            $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                                  . $args{'fcpPort'}
                                  . "']" )->click();
                        }
                        $Log->comment("Clicking On Save Button");
                        $self->_find_element("gwt-debug-saveButton")->click();
                    }
                }
            
            if ( exists( $args{'fcoe'} ) ) {
                    $Log->comment("Clicking on FCoE Config CheckBox");
                    $self->_find_element( "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcoePageConfigCheckbox']/input" )->click();
                    $Log->comment(
                        "Entering fcoe lif per node: " . $args{'fcoeLifNode'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcoePageIntfPerNodeField-input" )->clear();
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcoePageIntfPerNodeField-input" )
                      ->send_keys( $args{'fcoeLifNode'} );
                    $Log->comment("Clicking on Text Box");
                    $self->_find_element(
"//tr[2]/td/div/div[2]/div/form/div[3]/table/tbody/tr/td/div/table/tbody/tr/td/div/table/tbody/tr/td[3]/div/table/tbody/tr[2]/td[2]/div/table/tbody/tr/td/div/input"
                    )->click();
                    $self->wait_for_element_not_present($LOADING);

                    if ( exists( $args{'lunProvFC'} ) ) {
                        $Log->comment(
                            "Entering lun prov: " . $args{'lunProvFC'} );
                        $self->_find_element(
"//tr[2]/td/div/div[2]/div/form/div[3]/table/tbody/tr/td/div/table/tbody/tr/td/div/table/tbody/tr/td[3]/div/table/tbody/tr[2]/td[2]/div/table/tbody/tr/td/div/input"
                        )->send_keys( $args{'lunProvFC'} );
                        $Log->comment( "Selecting Lun size Unit: "
                              . $args{'lunSizeUnitFC'} );
                        $self->_find_element(
"//tr[2]/td/div/div[2]/div/form/div[3]/table/tbody/tr/td/div/table/tbody/tr/td/div/table/tbody/tr/td[3]/div/table/tbody/tr[2]/td[2]/div/table/tbody/tr/td[2]/div/img"
                        )->click();
                        $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                              . $args{'lunSizeUnitFC'}
                              . "']" )->click();
                        $Log->comment(
                            "Selecting Lun OS Type: " . $args{'lunOSFC'} );
                        $self->_find_element(
"//tr[2]/td/div/div[2]/div/form/div[3]/table/tbody/tr/td/div/table/tbody/tr/td/div/table/tbody/tr/td[3]/div/table/tbody/tr[3]/td[2]/div/img"
                        )->click();
                        $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                              . $args{'lunOSFC'}
                              . "']" )->click();
                        $Log->comment(
                            "Entering initiator: " . $args{'lunInitiatorFC'} );
                        $self->_find_element(
"//tr[2]/td/div/div[2]/div/form/div[3]/table/tbody/tr/td/div/table/tbody/tr/td/div/table/tbody/tr/td[3]/div/table/tbody/tr[4]/td[2]/div/input"
                        )->send_keys( $args{'lunInitiatorFC'} );
                    }
                    if ( exists( $args{'fcoeAdvanced'} ) ) {
                        $Log->comment("Clicking on Advanced Setting CheckBox");
                        $self->_find_element( "//div[\@id='gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "fcoePageAdvancedSettingsCheckbox']/input" )
                          ->click();
                        $Log->comment( "Entering number of portsets: "
                              . $args{'fcoeportSets'} );
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "fcoePortsetSpinner-spinnerField-input" )
                          ->clear();
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "fcPortsetSpinner-spinnerField-input" )
                          ->send_keys( $args{'fcoeportSets'} );
                        if ( exists( $args{'fcoeInterfaceName'} ) ) {
                            $self->_find_element(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div"
                            )->click();
                            $Log->comment("Double Clicking the interface row");
                            $self->_double_click(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div"
                            );
                            $self->wait_for_element_not_present($LOADING);
                            $Log->comment( "Entering interface name: "
                                  . $args{'fcoeInterfaceName'} );
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "fcoeInterfaceNameCol-input" )->clear();
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "fcoeInterfaceNameCol-input" )
                              ->send_keys( $args{'fcoeInterfaceName'} );
                            if ( exists( $args{'fcoePort'} ) ) {
                                $Log->comment("Clicking on port selection");
                                $self->_find_element( "gwt-debug-"
                                      . $self->{$SYSTEM_NAME_KEY}
                                      . "fcoeHomeportCol-input" )->click();
                                $Log->comment(
                                    "Selecting port: " . $args{'fcoePort'} );
                                $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                                      . $args{'fcoePort'}
                                      . "']" )->click();
                            }
                            $Log->comment("Clicking On Save Button");
                            $self->_find_element("//button[text()='Save']")->click();
                        }
                    }
               }
            if (
                $self->is_element_present(
                        "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "VserverSetupDialogSubmitButton"
                )
              )
            {
                $Log->comment("Clicking On Submit Button");
                $elementIdOrXpath =
                  $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "VserverSetupDialogSubmitButton" );
                $startTime = $self->click_EventTime($elementIdOrXpath);
                $self->wait_for_element_not_present($CREATING);
                $self->captureResponseTime( $startTime,
                    $methodName . "_fcp_creating" );
            }
            $self->wait_for_element_not_present($LOADING);
            $self->_check_for_errordialog();
            $self->wait_for_element_not_present($VALIDATING);
            $self->wait_for_element_not_present($ADDING);
            $self->wait_for_element_not_present($LOADING);
        }
        if ( exists($args{'vsAdmin'}) and
            $args{'vsAdmin'} =~ /y|yes|1/i ) {
            $Log->comment(
                "Entering vsAdmin Password: " . $args{'vsAdminPasswd'} );
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY} .  "VserverSetupAdminPageVserverSetupAdminPageNameAdminPasswordTextField-input" )->send_keys( $args{'vsAdminPasswd'} );

            if ( exists( $args{'vsAdminPasswdConfirm'} ) ) {
              $Log->comment( "Entering vsAdmin Confirm Password: " . $args{'vsAdminPasswdConfirm'} );
              $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "VserverSetupAdminPageVserverSetupAdminPageConfirmAdminPasswordTextField-input")->send_keys( $args{'vsAdminPasswdConfirm'} );
 
            }
            else {
            $Log->comment( "Entering vsAdmin Confirm Password: " . $args{'vsAdminPasswd'} );
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "VserverSetupAdminPageVserverSetupAdminPageConfirmAdminPasswordTextField-input")->send_keys( $args{'vsAdminPasswd'} );
             }
        } else {
            if (
                $self->is_element_present(
                    "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "VserverSetupDialogSkipButton"
                )
              )
            {
                $Log->comment("Clicking On Skip Button");
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "VserverSetupDialogSkipButton" )->click();
            }
        }
        if ( exists( $args{'newLifMgt'} ) ) {
            my $checkbox =
                "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "VserverSetupAdminPageVserverSetupAdminPageNewDataLifCheckBox']/input";
            if ( $args{'newLifMgt'} =~ /yes/ ) {
                if ( $self->is_checked( $self->_find_element($checkbox) ) ) {
                    $Log->comment("Check Box already selected");
                }
                else {
                    $Log->comment(
                        "Check Box not already selected so clicking Checkbox");
                    $self->_find_element($checkbox)->click();
                }
            }
            else {
                if ( $self->is_checked( $self->_find_element($checkbox) ) ) {

                    $Log->exit() if $may_exit;
                    $Log->comment(
                        "Check Box already selected But New Lif mgt is false");
                    $self->_find_element($checkbox)->click();
                }
                else {
                    $Log->comment("Check Box not already selected");
                }
            }
        }
        if ( exists( $args{'vsMgtLif'} ) ) {
            sleep(5);
            $Log->comment("Clicking on Subnet text box");
            $self->_find_element(
                "//div[4]/div[2]/div/form/table/tbody/tr/td[2]/div/img")
              ->click();
            $Log->comment( "Selecting Subnet: " . $args{'subnet'} );
            $self->_find_element(
                    "//div[contains(\@class,'ellipsis') and text()='"
                  . $args{'subnet'}
                  . "']" )->click();
            sleep(3);
            if ( exists( $args{'node'} ) ) {
                $Log->comment(
                    "Clicking on browse" . " and wait for Retrieving Nodes" );
                $elementIdOrXpath = $self->_find_element(
"//div[4]/div[2]/div/form/table/tbody/tr[3]/td[2]/div/table/tbody/tr/td[2]/table/tbody/tr[2]/td[2]/em/button"
                );
                $startTime = $self->click_EventTime($elementIdOrXpath);
                $self->eventWaitingTime( $RETRIEVING, $startTime,
                    $methodName . "_browse_vs-mgmt_port" );
                $Log->comment( "clicking on node: " . $args{'node'} );
                $self->_double_click(
                            "//div[contains(\@id,'gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "NetworkPortInterfaceGrid')]/div/span[contains(\@class,'x-tree3-node-text') and text()='"
                          . $args{'node'} . "']"
                );
                sleep(3);
                $Log->comment( "Clicking on the port " . $args{'port'} );
                $self->_find_element(
"//div[contains(\@class,'x-tree3-el')]/span[contains(\@class,'x-tree3-node-text') and text()='"
                      . $args{'port'}
                      . "']" )->click();
                $Log->comment("Clicking on ok");
                $self->_find_element($GENERIC_DIALOG2_OK_BUTTON)->click();
            }
            my $manualIPAutoRadio =
                "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "subnetPortInterfacePanelAutoSelectRadio']/input";
            my $manualIPSpecificRadio =
                "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "subnetPortInterfacePanelSpecificIPRadio']/input";
            my $manualIPSpecificInput =
                "gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "subnetPortInterfacePanelIpAddressTextField-input";
            if ( exists( $args{'manualIPVsAdmin'} )
                && !$args{'manualIPVsAdmin'} =~ /negative/ )
            {
                if (
                    !$self->is_selected(
                        $self->_find_element($manualIPAutoRadio)
                    )
                  )
                {
                    NATE::BaseException->throw(
                        "Auto Select IPAddress is not selected by default");
                }
                if ( $args{'manualIPVsAdmin'} =~ /specific/ ) {
                    $Log->comment("Selecting specific radio button");
                    $self->_find_element($manualIPSpecificRadio)->click();
                    $Log->comment( "Entering specific IPAddress: "
                          . $args{'manualIPVSAddress'} );
                    $self->_find_element($manualIPSpecificInput)->clear();
                    $self->_find_element($manualIPSpecificInput)
                      ->send_keys( $args{'manualIPVSAddress'} );
                }
            }
            elsif ( exists( $args{'manualIPVsAdmin'} )
                && $args{'manualIPVsAdmin'} =~ /negative/ )
            {
                $Log->comment("Selecting specific radio button");
                $self->_find_element($manualIPSpecificRadio)->click();
                my @ipAddress = split( /,/, $args{'manualIPVSAddress'} );
                for ( my $i = 0 ; $i < @ipAddress ; $i++ ) {
                    $self->_find_element($manualIPSpecificInput)->clear();
                    $Log->comment(
                        "Entering specific IPAddress: " . $ipAddress[$i] );
                    $self->_find_element($manualIPSpecificInput)
                      ->send_keys( $ipAddress[$i] );
                    if ( $i == ( @ipAddress - 1 ) ) {
                        last;
                    }
                    else {
                        $Log->comment("Clicking on Submit Button in Configure VsAdmin page");
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "VserverSetupDialogSubmitButton" )->click();
                        $self->check_for_error();
                    }
                }
            }
        }
        if (
            $self->is_element_present(
                "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "VserverSetupDialogSubmitButton"
            )
          )
        {
            $Log->comment( "Clicking On Submit Button "
                  . "and wait for "
                  . "Validating interface name "
                  . "Updating the SVM administrator password "
                  . "Unlocking the SVM administrator and"
                  . "Creating SVM Management LIF " );
            $elementIdOrXpath =
              $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "VserverSetupDialogSubmitButton" );
            $startTime = $self->click_EventTime($elementIdOrXpath);
            $self->wait_for_element_not_present($VALIDATING);
            $self->wait_for_element_not_present($UPDATING);
            $self->wait_for_element_not_present($UNLOCKING);
            $self->wait_for_element_not_present($CREATING);
            $self->captureResponseTime( $startTime,
                $methodName . "_vsmMgtLifCreate" );
        }
        $self->_check_for_errordialog();
        if ( exists( $args{'is-repository'} )
            && $args{'is-repository'} =~ /infinite/ )
        {
            $self->wait_for_element_not_present($LOADING);
            $self->wait_for_element_not_present($FETCHING);
            $Log->comment("Selecting Aggregate for infine vol-type");
            if ( exists( $args{'aggregate'} ) ) {
                $Log->comment( "aggrlist contains" . $args{'aggregate'} );
                my @totalRows;
                @totalRows =
                  $self->find_elements( "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "VserverResourceAllocationPanelGridAggrsCustomGrid']/div/div/div[2]/div/div"
                  );
                for ( my $i = 0 ; $i < @totalRows ; $i++ ) {
                    my $element =
                        "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "VserverResourceAllocationPanelGridAggrsCustomGrid']/div/div/div[2]/div/div["
                      . ( $i . 1 )
                      . "]/table/tbody/tr/td/div/div/table/tbody/tr/td/div/input";
                    if ( $self->is_selected( $self->_find_element($element) ) )
                    {
                        $Log->comment(
                            "de-selecting " . $totalRows[$i]->get_text() );
                        $self->_find_element($element)->click();
                    }
                }
                my @temp = split( /,/, $args{'aggregate'} );
                for ( my $i = 0 ; $i < @temp ; $i++ ) {
                    my $aggr =
                      uc( substr( $temp[$i], 0, 1 ) ) . substr( $temp[$i], 1 );
                    my $aggrxpath =
                        "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "VserverResourceAllocationPanel"
                      . $aggr
                      . "CheckBox']/input";
                    $Log->comment( "Selecting aggregate " . $aggr );
                    $self->_find_element($aggrxpath)->click();
                }
                if (
                    $self->is_element_present(
                            "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupDialogSubmitButton"
                    )
                  )
                {
                    $Log->comment(
"Clicking On Submit Button on Infinite Volume Aggregate selection page"
                    );
                    $elementIdOrXpath =
                      $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupDialogSubmitButton" );
                    $startTime = $self->click_EventTime($elementIdOrXpath);
                    $self->wait_for_element_not_present($UPDATING);
                    $self->captureResponseTime( $startTime,
                        $methodName . "_infiniteVolCreate" );
                }
                $self->_check_for_errordialog();
            } else {
                if (
                    $self->is_element_present(
                            "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupDialogSkipButton"
                    )
                  )
                {
                    $Log->comment("Clicking On Skip Button");
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupDialogSkipButton" )->click();
                }
            }
        }

        if ( $self->is_element_present( $GENERIC_DIALOG2_OK_BUTTON )) {
            $Log->comment("Clicking On Final OK Button");
            $self->_find_element($GENERIC_DIALOG2_OK_BUTTON)
              ->click();
        }

        if ( exists( $args{'smb'} ) ) {

            my $smbVerify = 0;
            my @smbValues;
            my @elements =
                 $self->find_elements(
                   "//table/tbody[tr/td/label[contains(text(),'SVM"
                  . " Name')]]//tr[contains(text(),'SMB Encryption:')]");

            foreach my $element (@elements) {   
                push( @smbValues, $element->get_text() );
            }

            $Log->comment( "SMB Values in summary page: " . \@smbValues );
            if ( $args{'smb'} =~ /allShare/ && !exists( $args{'shareName'} ) ) {
                if ( @smbValues == 1 && $smbValues[0] =~ /Enabled/ ) {
                    $Log->comment("Verified summary page for CIFS SMB values");
                    $smbVerify = 1;
                }
            } elsif ( $args{'smb'} =~ /allShare/ && exists( $args{'shareName'} ) ) {
                if (   @smbValues == 2
                    && $smbValues[0] =~ /Enabled/
                    && $smbValues[1] =~ /Enabled/ )
                {
                    $Log->comment("Verified summary page for CIFS SMB values");
                    $smbVerify = 1;
                }
            }
            elsif ( $args{'smb'} =~ /thisShare/
                && !exists( $args{'shareName'} ) )
            {
                if ( @smbValues == 1 && $smbValues[0] =~ /Disabled/ ) {
                    $Log->comment("Verified summary page for CIFS SMB values");
                    $smbVerify = 1;
                }
            }
            elsif ( $args{'smb'} =~ /thisShare/
                && exists( $args{'shareName'} ) )
            {
                if (   @smbValues == 2
                    && $smbValues[0] =~ /Disabled/
                    && $smbValues[1] =~ /Enabled/ )
                {
                    $Log->comment("Verified summary page for CIFS SMB values");
                    $smbVerify = 1;
                }
            }
            if ( !$smbVerify ) {
                NATE::BaseException->throw(
                    "Failed navigate Verify summary page for CIFS SMB values");
            }
        }
    }
    catch NATE::BaseException with {
        my $e = shift;
        $self->clear_window();
        $Log->exit() if $may_exit;
        $e->throw();
    };

    return {execution_time => time - $execution_time};

} ## end createVserver

=head2 deleteVserver

Returns boolean

=over

=item Options

=over

=item C<< vserver => SCALAR >>

 (Required)

=back

=back

=over

=back

=cut

sub deleteVserver {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'vserver' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );
    my $execution_time = time;
    $Log->comment("Deleting vserver");
    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;

    try {
        $self->refreshVserver();
        $self->clickVserver( 'vserver'  => $args{'vserver'} );
        $self->setVserverOperation( 'operation' => "Delete", );
        $elementIdOrXpath = $self->getVserverOperation();
        my $elementID = $elementIdOrXpath->get_attribute("id");
        if ( not $self->is_button_enabled($elementID) ) {
            NATE::BaseException->throw(
                "The Button \"$elementID\" is not enabled");
        }

        $startTime = $self->click_EventTime($elementIdOrXpath);
        $self->eventWaitingTime( $LOADING, $startTime,
            $methodName . "_initial_loading" );
        $self->check_for_error();
        $self->_find_element( "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "ConfirmationDialogCheckBox1']/input" )->click();
        $elementIdOrXpath = $self->_find_element(
            "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ConfirmationDialogOKButton" );
        $startTime = $self->click_EventTime($elementIdOrXpath);
        $self->check_for_error();
    }
    catch NATE::BaseException with {
        my $e = shift;
        $Log->comment( "Unable navigate Delete Vserver " . $e->text() );
        my $cancel =
          "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ConfirmationDialogCancelButton";
        if ( $self->is_element_present($cancel) ) {
            $self->_find_element($cancel)->click();
        }
        if ( $self->is_element_present($GENERIC_DIALOG2_OK_BUTTON) ) {
            $Log->comment("Clicking on Confirmation Dialog");
            $self->_find_element($GENERIC_DIALOG2_OK_BUTTON)->click();
        }
        $Log->exit() if $may_exit;
        $e->throw();
    };
    $Log->comment("Wait for LOADING element not present");
    $self->eventWaitingTime( $LOADING, $startTime,
        $methodName . "_deleteVserver" );

    return {execution_time => time - $execution_time};
} ## end deleteVserver


=head2 editVserver

Returns String

=over

=item Options

=over

=item C<< vserver => SCALAR >>

 (Optional)

=item C<< nm-switch => ARRAYREF >>

 (Optional)

=item C<< ns-switch => ARRAYREF >>

 (Optional)

=item C<< newname => SCALAR >>

 (Optional)

=item C<< allowed-protocols => ARRAYREF >>

 (Optional)

=item C<< disallowed-protocols => ARRAYREF >>

 (Optional)

=item C<< protocol => ARRAYREF >>

 (Optional)

=item C<< aggr-list => ARRAYREF >>

 (Optional)

=back

=back

=over

=back

=cut

sub editVserver {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params => \@_,
        spec   => { 'vserver' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );
    my $execution_time = time;

    $Log->comment("Editing Vserver");
    $self->refreshVserver();

    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName    = $subname;

    try {
        $self->clickVserver( 'vserver'  => $args{'vserver'} );
        $self->wait_for_element_not_present($LOADING);
        $self->setVserverOperation( 'operation' => "Edit" );
        $elementIdOrXpath = $self->getVserverOperation();
        $startTime        = $self->click_EventTime($elementIdOrXpath);
        $self->eventWaitingTime( $LOADING, $startTime,
            $methodName . "_initial_loading" );
        $self->wait_for_element_not_present($LOADING);

        if ( exists( $args{'newname'} ) ) {
            $Log->comment("Entering vserver Name");
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "EditVserverDetailsPageVserverRenameField-input" )->clear();
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "EditVserverDetailsPageVserverRenameField-input" )
              ->send_keys( $args{'newname'} );
        }

        if ( exists( $args{'protocol'} ) and 
             !exists( $args{'allowed-protocols'} ) ) {
           $args{'allowed-protocols'} = $args{'protocol'};
        }
 
        if ( exists( $args{'allowed-protocols'} ) or
             exists( $args{'disallowed-protocols'} ) ) {
            $Log->comment("Allowing Protocols : @{$args{'allowed-protocols'}}");

            my $nfs = "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "nfsCheckboxEditVserverProtocol']/input";
            my $cifs = "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "cifsCheckboxEditVserverProtocol']/input";
            my $iscsi = "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "iscsiCheckboxEditVserverProtocol']/input";
            my $fc = "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "fcpCheckboxEditVserverProtocol']/input";

            if ( grep( /nfs/, @{ $args{'allowed-protocols'} } ) ) {
                if ( $self->is_checked( $self->_find_element($nfs) ) ) {
                    $Log->comment("NFS Check Box already selected");
                } else {
                    $Log->comment("Selcting NFS checkbox");
                    $self->_find_element($nfs)->click();
                }
            }
            if ( grep( /nfs/, @{ $args{'disallowed-protocols'} } ) ) {
                if ( $self->is_checked( $self->_find_element($nfs) ) ) {
                    $Log->comment("Deselecting NFS checkbox");
                    $self->_find_element($nfs)->click();
                } else {
                    $Log->comment("NFS is already disabled");
                }
            }

            if ( grep( /cifs/, @{ $args{'allowed-protocols'} } ) ) {
                if ( $self->is_checked( $self->_find_element($cifs) ) ) {
                    $Log->comment("CIFS Check Box already selected");
                } else {
                    $Log->comment("CIFS Check Box not selected");
                    $self->_find_element($cifs)->click();
                }
            }
            if ( grep( /cifs/, @{ $args{'disallowed-protocols'} } ) ) {
                if ( $self->is_checked( $self->_find_element($nfs) ) ) {
                    $Log->comment("Deselecting CIFS checkbox");
                    $self->_find_element($cifs)->click();
                } else {
                    $Log->comment("CIFS is already disabled");
                }
            }

            if ( grep( /iscsi/, @{ $args{'allowed-protocols'} } ) ) {
                if ( $self->is_checked( $self->_find_element($iscsi) ) ) {
                    $Log->comment("iscsi Check Box already selected");
                } else {
                    $Log->comment("iscsi Check Box not selected");
                    $self->_find_element($iscsi)->click();
                }
            }
            if ( grep( /iscsi/, @{ $args{'disallowed-protocols'} } ) ) {
                if ( $self->is_element_present($iscsi) and
                     $self->is_checked( $self->_find_element($iscsi) ) ) {
                    $Log->comment("Deselecting Iscsi checkbox");
                    $self->_find_element($iscsi)->click();
                } else {
                    $Log->comment("Iscsi is already disabled");
                }
            }

            if ( grep( /fc/, @{ $args{'allowed-protocols'} } ) ) {
                if ( $self->is_checked( $self->_find_element($fc) ) ) {
                    $Log->comment("fc Check Box already selected");
                } else {
                    $Log->comment("fc Check Box not selected");
                    $self->_find_element($fc)->click();
                }
            }
            if ( grep( /fc/, @{ $args{'disallowed-protocols'} } ) ) {
                if ( $self->is_element_present($fc) and
                     $self->is_checked( $self->_find_element($fc) ) ) {
                    $Log->comment("Deselecting FC checkbox");
                    $self->_find_element($fc)->click();
                } else {
                    $Log->comment("FC is already disabled");
                }
            }
        }

        if ( exists( $args{'aggrlist'} ) 
          and !exists(  $args{'aggr-list'} ) ) {
            $args{'aggr-list'} = $args{'aggrlist'};
        } 
        if ( exists( $args{'aggr-list'} ) ) {
            $Log->comment("Clicking on Resource Allocation Tab");
            $self->_find_element(
                "//li//span[text()='Resource Allocation']")->click();
            $self->wait_for_element_not_present($LOADING);
            if ( grep( /none/, @{ $args{'aggr-list'} } ) ) {
                $Log->comment("Clicking on do not delegate radio option");
                $self->_find_element( "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "EditVserverResourceAllocationPageAllAggregatesRadio']/input"
                )->click();
            } else {
                $Log->comment("Clicking on delegate volume radio option");
                $self->_find_element( "//div[\@id='gwt-debug-"
                    . $self->{$SYSTEM_NAME_KEY}
                    . "EditVserverResourceAllocationPageSpecificAggregatesRadio']/input"
                    )->click();
                if ( grep( /all/, @{ $args{'aggr-list'} } ) ) {
                    $Log->comment("aggr-list value is all");
                    $self->_find_element( 
                       "//div[\@id='gwt-debug--DEBUG-ID-NOT-SETname']//input"
                    )->click();
                } else {
                    for ( my $i = 1 ; $i < @{ $args{'aggr-list'} } ; $i++) {
                        my @stringArray =
                          split( //, $args{'aggr-list'}->[$i] );
                        # changing aggrname to Aggrname
                        $stringArray[0] = uc( $stringArray[0] );
                        my $aggregate = join( '', @stringArray );
                        $Log->comment(
                            "Clicking On : " . $aggregate . " CheckBox" );
                        $self->_find_element( "//div[\@id='gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "VserverResourceAllocationPanel"
                              . $aggregate
                              . "CheckBox']/input" )->click();
                    }
                }
            }
        }

        if ( exists(  $args{'ns-switch'} ) ) {
            $Log->comment("Configuring Name Service Details");
            $self->_find_element("//li[3]/a[2]/em/span/span")->click();
            $self->wait_for_element_not_present($LOADING);
            $self->wait_for_element_not_present($RETRIEVING);
            my $xpath =
                "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "listViewForNameServicesEditVserverDetailsPageId']"
              . "/div[contains(\@class,'x-view-item-check')]/table/tbody/tr";
            my $fileCheck = $xpath . "[td[text()='file']]/td/input";
            my $ldapCheck = $xpath . "[td[text()='ldap']]/td/input";
            my $nisCheck  = $xpath . "[td[text()='nis']]/td/input";

            if ( grep( /none/, @{ $args{'ns-switch'} } ) ) {
                $self->_find_element( "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "EditVserverServicesPageEditVserverServicesPageNameServiceDisableMessageMessageWithIconContainer']"
                      . "/table/tbody/tr/td[2]/div" )->get_text();
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "EditVserverPropertiesDlgCancelBtn" )->click();
            }
            if ( grep( /file/, @{ $args{'ns-switch'} } ) ) {
                if ( $self->is_checked( $self->_find_element($fileCheck) ) ) {
                    $Log->comment("File Check Box already selected");
                }
                else {
                    $Log->comment(" file Check Box not selected");
                    $self->_find_element($fileCheck)->click();
                }
            } else {
                if ( $self->is_checked( $self->_find_element($fileCheck) ) ) {
                    $Log->comment(
" File Check Box already selected so need navigate De Select"
                    );
                    $self->_find_element($fileCheck)->click();
                }
            }
            if ( grep( /ldap/, @{ $args{'ns-switch'} } ) ) {
                if ( $self->is_checked( $self->_find_element($ldapCheck) ) ) {
                    $Log->comment("ldap Check Box already selected");
                }
                else {
                    $Log->comment(" ldap Check Box not selected");
                    $self->_find_element($ldapCheck)->click();
                }
            }
            else {
                if ( $self->is_checked( $self->_find_element($ldapCheck) ) ) {
                    $Log->comment(
" ldap Check Box already selected so need navigate De Select"
                    );
                    $self->_find_element($ldapCheck)->click();
                }
            }
            if ( grep( /nis/, @{ $args{'ns-switch'} } ) ) {
                if ( $self->is_checked( $self->_find_element($nisCheck) ) ) {
                    $Log->comment("NIS Check Box already selected");
                }
                else {
                    $Log->comment(" NIS Check Box not selected");
                    $self->_find_element($nisCheck)->click();
                }
            }
            else {
                if ( $self->is_checked( $self->_find_element($nisCheck) ) ) {
                    $Log->comment(
" NIS Check Box already selected so need navigate De Select"
                    );
                    $self->_find_element($nisCheck)->click();
                }
            }
        }

        if (  exists( $args{'nm-switch'} ) ) {
            $Log->comment("Configuring Name Map Details");
            my $xpath =
                "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "listViewForNameMappingSwitchesEditVserverDetailsPageId']"
              . "/div[contains(\@class,'x-view-item-check')]/table/tbody/tr";
            my $fileCheck = $xpath . "[td[text()='file']]/td/input";
            my $ldapCheck = $xpath . "[td[text()='ldap']]/td/input";
            if ( grep( /file/, @{ $args{'nm-switch'} } ) ) {
                if ( $self->is_checked( $self->_find_element($fileCheck) ) ) {
                    $Log->comment("File Check Box already selected");
                }
                else {
                    $Log->comment(" file Check Box not selected");
                    $self->_find_element($fileCheck)->click();
                }
            }
            else {
                if ( $self->is_checked( $self->_find_element($fileCheck) ) ) {
                    $Log->comment(
" File Check Box already selected so need navigate De Select"
                    );
                    $self->_find_element($fileCheck)->click();
                }
            }
            if ( grep( /ldap/, @{ $args{'nm-switch'} } ) ) {
                if ( $self->is_checked( $self->_find_element($ldapCheck) ) ) {
                    $Log->comment("ldap Check Box already selected");
                }
                else {
                    $Log->comment(" ldap Check Box not selected");
                    $self->_find_element($ldapCheck)->click();
                }
            } else {
                if ( $self->is_checked( $self->_find_element($ldapCheck) ) ) {
                    $Log->comment( "ldap Check Box already selected"
                                 . "so need navigate deSelect" );
                    $self->_find_element($ldapCheck)->click();
                }
            }
        }

        $elementIdOrXpath = $self->_find_element(
            "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EditVserverPropertiesDlgOkBtn" );

        $startTime = $self->click_EventTime($elementIdOrXpath);
        $self->eventWaitingTime( $LOADING, $startTime, $methodName );
        $self->check_for_error();

        if ( $self->is_element_present($GENERIC_DIALOG2_OK_BUTTON) ) {
            $Log->comment("Clicking on Confirmation Dialog");
            $self->_find_element($GENERIC_DIALOG2_OK_BUTTON)->click();
        }

        $self->check_for_error();
        $self->wait_for_element_not_present($LOADING);
        if ( $self->is_element_present( $GENERIC_DIALOG2_OK_BUTTON )) {
            $self->_find_element($GENERIC_DIALOG2_OK_BUTTON)->click();
        }
        $self->wait_for_element_not_present($LOADING);
    }
    catch NATE::BaseException with {
        my $e = shift;
        $self->clear_window();
        $Log->exit() if $may_exit;
        $e->throw();
    };
    $self->wait_for_element_not_present($CREATING);
    $self->wait_for_element_not_present($LOADING);

    $Log->exit() if $may_exit;
    return { execution_time => time - $execution_time};

} ## end editVserver

=head2 getVserverDetails

Returns hashref

=over

=item Options

=over

=item C<< vserver => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub getVserverDetails {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'vserver' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );
    my $execution_time = time;

    $self->clickVserver( 'vserver' => $args{'vserver'}, );
    $self->wait_for_element_not_present($LOADING);

    my $gridID = "gwt-debug-$self->{$SYSTEM_NAME_KEY}"
      . "VserverPageVserverGrid";

    my @columns = (
        "vserver-name",    "operational-state",
        "vserver-subtype", "allowed-protocols",
        "ipspace",         "is-repository-vserver",
        "is-config-locked-for-changes"
    );

    my %props = $self->getRowDataAsHashMap($gridID, \@columns );
    $Log->debug(Dumper(\%props));

    $gridID = "gwt-debug-$self->{$SYSTEM_NAME_KEY}" .
      "VserverPageVserverDetailsContainerVserverPageIdLayoutContainer";

    my @valueIds = (
        "VserverPageVserverNameServiceValueVserverPageIdLabelField",
        "VserverPageVserverNameMappingValueVserverPageIdLabelField",
        "VserverPageVserverSnapshotPolicyValueVserverPageIdLabelField",
        "VserverPageVserverNisDomainValueVserverPageIdLabelField",
        "VserverPageVserverLdapClientValueVserverPageIdLabelField",
        "VserverPageVserverLanguageValueVserverPageIdLabelField",
        "VserverPageVserverIsRepositoryVserverPageIdLabelField",
        "VserverPageVserveradminStateVserverPageIdLabelField"
    );

    my %details =
       $self->getPropertiesDataAsHashMap( $gridID, @valueIds );
    $Log->debug(Dumper(\%details));

    my $value = $self->_find_element(
      "gwt-debug-MessageWithIconContainerMessageText")->get_text();
    $details{"destination-sync-message"} = $value;

    my %values_hash = (%props,%details);

    return {execution_time => time - $execution_time,
            parsed_output  => [\%values_hash] };

} ## end getVserverDetails


=head2 getVserverOperation

Returns object

=over

=item Options

=over


=back

=back

=over

=back

=cut

sub getVserverOperation {

    my $self = shift;

    $Log->enter() if $may_enter;
    $Log->exit() if $may_exit;

    return $vserverOperation;

} ## end getVserverOperation


=head2 getVserverPeerDetails

Returns hashref

=over

=item Options

=over

=item C<< vserver => SCALAR >>

 (Required)

=back

=back

=over

=back

=cut

sub getVserverPeerDetails {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'vserver' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my $execution_time = time;

    my @columns = (
        "peer-vserver", "peer-cluster",
        "peer-state",   "vserver-peer-application"
    );

    $self->clickVserver( 'vserver' => $args{'vserver'}, );
    $self->wait_for_element_not_present($LOADING);
    my $gridID   = "gwt-debug-VserverPagePeeringDetailsTable";
    my @vservers = $self->getGridDataAsHashMap(
        'gridID'  => $gridID,
        'columns' => \@columns,
    );

    return {execution_time => time - $execution_time,
            parsed_output => \@vservers};

} ## end getVserverPeerDetails

=head2 reEnrtyProtoclSetUp

Returns void

=over

=item Options

=over

=item C<< vserver => SCALAR >>

 (Required)

=item C<< protocol => ARRAYREF >>

 (Optional)

=item C<< rorule => SCALAR >>

 (Optional)

=item C<< rwrule => SCALAR >>

 (Optional)

=item C<< adDetails => SCALAR >>

 (Optional)

=item C<< cifsDomain => SCALAR >>

 (Optional)

=item C<< cifsPassword => SCALAR >>

 (Optional)

=item C<< cifsServer => SCALAR >>

 (Optional)

=item C<< cifsUserName => SCALAR >>

 (Optional)

=item C<< clientSpec => SCALAR >>

 (Optional)

=item C<< exportName => SCALAR >>

 (Optional)

=item C<< exportPermission => SCALAR >>

 (Optional)

=item C<< exportSize => SCALAR >>

 (Optional)

=item C<< exportSizeUnit => SCALAR >>

 (Optional)

=item C<< fcLifNode => SCALAR >>

 (Optional)

=item C<< fcoeAdvanced => SCALAR >>

 (Optional)

=item C<< fcoeInterfaceName => SCALAR >>

 (Optional)

=item C<< fcoeLifNode => SCALAR >>

 (Optional)

=item C<< fcoePort => SCALAR >>

 (Optional)

=item C<< fcoeportSets => SCALAR >>

 (Optional)

=item C<< fcpAdvanced => SCALAR >>

 (Optional)

=item C<< fcpInterfaceName => SCALAR >>

 (Optional)

=item C<< fcpPort => SCALAR >>

 (Optional)

=item C<< fcpportSets => SCALAR >>

 (Optional)

=item C<< ipSpace => SCALAR >>

 (Optional)

=item C<< iscsiAdvanced => SCALAR >>

 (Optional)

=item C<< iscsiIP => SCALAR >>

 (Optional)

=item C<< iscsiInterfaceName => SCALAR >>

 (Optional)

=item C<< iscsiPort => SCALAR >>

 (Optional)

=item C<< lifNode => SCALAR >>

 (Optional)

=item C<< lunInitiator => SCALAR >>

 (Optional)

=item C<< lunInitiatorFC => SCALAR >>

 (Optional)

=item C<< lunOS => SCALAR >>

 (Optional)

=item C<< lunOSFC => SCALAR >>

 (Optional)

=item C<< lunProv => SCALAR >>

 (Optional)

=item C<< lunProvFC => SCALAR >>

 (Optional)

=item C<< lunSizeUnit => SCALAR >>

 (Optional)

=item C<< lunSizeUnitFC => SCALAR >>

 (Optional)

=item C<< manualIPCIFS => SCALAR >>

 (Optional)

=item C<< manualIPCIFSAddress => SCALAR >>

 (Optional)

=item C<< manualIPIscsi => SCALAR >>

 (Optional)

=item C<< manualIPIscsiAddress => SCALAR >>

 (Optional)

=item C<< manualIPNFS => SCALAR >>

 (Optional)

=item C<< manualIPNFSAddress => SCALAR >>

 (Optional)

=item C<< manualIPVSAddress => SCALAR >>

 (Optional)

=item C<< manualIPVsAdmin => SCALAR >>

 (Optional)

=item C<< newLifMgt => SCALAR >>

 (Optional)

=item C<< nisDomain => SCALAR >>

 (Optional)

=item C<< nisServer => SCALAR >>

 (Optional)

=item C<< noRetain => SCALAR >>

 (Optional)

=item C<< node => SCALAR >>

 (Optional)

=item C<< orgUnit => SCALAR >>

 (Optional)

=item C<< port => SCALAR >>

 (Optional)

=item C<< portSets => SCALAR >>

 (Optional)

=item C<< removeUser => SCALAR >>

 (Optional)

=item C<< shareName => SCALAR >>

 (Optional)

=item C<< sharePermission => SCALAR >>

 (Optional)

=item C<< shareSize => SCALAR >>

 (Optional)

=item C<< shareSizeUnit => SCALAR >>

 (Optional)

=item C<< shareUser => SCALAR >>

 (Optional)

=item C<< subnet => SCALAR >>

 (Optional)

=item C<< superUser => SCALAR >>

 (Optional)

=item C<< targetAlias => SCALAR >>

 (Optional)

=item C<< vsAdmin => SCALAR >>

 (Optional)

=item C<< vsAdminPasswd => SCALAR >>

 (Optional)

=item C<< vsAdminPasswdConfirm => SCALAR >>

 (Optional)

=item C<< vsMgtLif => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub reEnrtyProtoclSetUp {

    my $self = shift;

    $Log->enter() if $may_enter;
    my %args = @_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );
    my $execution_time = time;

    $Log->comment("Setting Up protocols by re enrty");
    my $nfsLink       = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "DetailsTabnfsLink";
    my $cifsLink      = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "DetailsTabcifsLink";
    my $iscsiLink     = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "DetailsTabiscsiLink";
    my $fcpLink       = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "DetailsTabfcpLink";
    my $vsadminLink   = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "vserverSetupVsAdminLink";
    my $vsmgmtLink =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "vserverSetupVsManagemnetLink";
    my $nfsRefresh =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "NfsConfigurationPageRefreshBtn";
    my $cifsRefresh =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "CifsConfigurationCModePageRefreshBtn";
    my $iscsiRefresh =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ISCSIServiceTabRefreshTabTBBtn";
    my $fcpRefresh =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "FCPMainPageRefreshPageToolBarBtn";
    my $userRefresh = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "UserPageRefreshButton";

    $Log->comment( "Selecting Vserver: " . $args{'vserver'} );
    $self->clickVserver( 'vserver' => $args{'vserver'}, );

    try {
        if ( exists( $args{'protocol'} ) ) {
            if (  grep( /cifs/i, @{ $args{'protocol'} } ))  {
                $Log->comment("Clicking on Cifs Link");
                $self->_find_element($cifsLink)->click();
                $self->wait_for_element_not_present($RETRIEVING);
                $Log->comment("Configuring CIFS Protocol");
                if ( exists( $args{'noRetain'} ) ) {
                    $Log->comment(
"Clicking Retain CheckBox as NFS and CIFS config is different"
                    );
                    $self->_find_element( "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasDataInterfacePanelDataIntfCheckboxCheckBox']/input"
                    )->click();
                }
                $Log->comment("Clicking on Subnet text box");
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "cifssubnetPortInterfacePanelSubnetInfoCombo-input" )
                  ->click();
                $Log->comment( "Selecting Subnet: " . $args{'subnet'} );
                $self->_find_element(
                        "//div[contains(\@class,'ellipsis') and text()='"
                      . $args{'subnet'}
                      . "']" )->click();
                $Log->comment("clicking on browse");
                $self->_find_element("//button[contains(text(),'Browse')]")
                  ->click();
                $self->wait_for_element_not_present($LOADING);
                $Log->comment( "clicking on node: " . $args{'node'} );
                $self->_double_click( "//div[contains(\@id,'gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "NetworkPortInterfaceGrid')]/div/span[contains(\@class,'x-tree3-node-text') and text()='"
                      . $args{'node'}
                      . "']" );
                sleep(5);
                $Log->comment( "Clicking on the port " . $args{'port'} );
                $self->_find_element(
"//div[contains(\@class,'x-tree3-el')]/span[contains(\@class,'x-tree3-node-text') and text()='"
                      . $args{'port'}
                      . "']" )->click();
                $Log->comment("Clicking on ok");
                $self->_find_element($GENERIC_DIALOG2_OK_BUTTON)->click();

                if ( exists( $args{'adDetails'} ) ) {
                    $Log->comment(
                        "Entering cifsServer: " . $args{'cifsServer'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasCifsConfigPanelCifsServerNameTextField-input"
                    )->clear();
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasCifsConfigPanelCifsServerNameTextField-input"
                    )->send_keys( $args{'cifsServer'} );
                    $Log->comment(
                        "Entering cifsServer: " . $args{'cifsDomain'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasCifsConfigPanelActiveDirTextField-input"
                    )->send_keys( $args{'cifsDomain'} );
                    $Log->comment( "Entering cifsServer: " . $args{'orgUnit'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasCifsConfigPanelOrgTextField-input" )
                      ->clear();
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasCifsConfigPanelOrgTextField-input" )
                      ->send_keys( $args{'orgUnit'} );
                    $Log->comment(
                        "Entering cifsServer: " . $args{'cifsUserName'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasCifsConfigPanelAdminNameTextField-input"
                    )->send_keys( $args{'cifsUserName'} );
                    $Log->comment(
                        "Entering cifsServer: " . $args{'cifsPassword'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasCifsConfigPanelAdminPassTextField-input"
                    )->send_keys( $args{'cifsPassword'} );
                }
                if ( exists( $args{'shareName'} ) ) {
                    $Log->comment(
                        "Entering Share Name: " . $args{'shareName'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "CifsConfigPanelExportTextField-input" )
                      ->send_keys( $args{'shareName'} );
                    $Log->comment(
                        "Entering Share Size: " . $args{'shareSize'} );
                    $self->_find_element(
                        "//tr[3]/td[2]/div/table/tbody/tr/td/div/input")
                      ->send_keys( $args{'shareSize'} );
                    $Log->comment( "Selecting Share Size Unit: "
                          . $args{'shareSizeUnit'} );
                    $self->_find_element(
                        "//td[2]/div/table/tbody/tr/td[2]/div/img")->click();
                    $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'shareSizeUnit'}
                          . "']" )->click();
                    if ( exists( $args{'sharePermission'} ) ) {
                        $Log->comment("Clicking On Change Button");
                        $self->_find_element(
                            "//span[contains(text(),'Change')]")->click();
                        $self->wait_for_element_not_present($LOADING);
                        $Log->comment("Clicking On User/Group ADD Button");
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "CifsShareManageEditShareDialogPermissionTabAddBtn"
                        )->click();
                        $self->wait_for_element_not_present($LOADING);
                        $Log->comment(
                            "Entering User/Group: " . $args{'shareUser'} );
                        $self->_find_element("//form/div/div/div/input")
                          ->send_keys( $args{'shareUser'} );
                        $Log->comment("Clicking On User/Group ADD OK Button");
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "CifsShareManageAddUserGroupDialogOkBtn" )
                          ->click();
                        sleep(2);
                        $Log->comment("Clicking On User/Group ADD Save Button");
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "CifsShareManageEditShareDialogOkBtn" )
                          ->click();
                    }
                }
                my $manualIPAutoRadio =
                    "//div[\@id='gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "cifssubnetPortInterfacePanelAutoSelectRadio']/input";
                my $manualIPSpecificRadio =
                    "//div[\@id='gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "cifssubnetPortInterfacePanelSpecificIPRadio']/input";
                my $manualIPSpecificInput =
                    "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "cifssubnetPortInterfacePanelIpAddressTextField-input";
                if ( exists( $args{'manualIPCIFS'} ) ) {
                    if (
                        !$self->is_selected(
                            $self->_find_element($manualIPAutoRadio)
                        )
                      )
                    {
                        $Log->comment(
                            "Auto Select IPAddress is not selected by default");
                        $self->closeVserver();

                        $Log->exit() if $may_exit;
                        return 0;
                    }
                    $Log->comment("Selecting specific radio button");
                    $self->_find_element($manualIPSpecificRadio)->click();
                    $Log->comment( "Entering specific IPAddress: "
                          . $args{'manualIPCIFS'} );
                    $self->_find_element($manualIPSpecificInput)->clear();
                    $self->_find_element($manualIPSpecificInput)
                      ->send_keys( $args{'manualIPCIFS'} );
                }
            }
            if ( grep( /nfs/i, @{ $args{'protocol'} } ) ) {
                $Log->comment("Clicking on NFS Link");
                $self->_find_element($nfsLink)->click();
                $self->wait_for_element_not_present($RETRIEVING);
                if ( exists( $args{'noRetain'} ) ) {
                    $Log->comment(
"Clicking Retain CheckBox as NFS and CIFS config is different"
                    );
                    $self->_find_element( "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasDataInterfacePanelDataIntfCheckboxCheckBox']/input"
                    )->click();
                }
                $Log->comment("Clicking on Subnet text box");
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "nfssubnetPortInterfacePanelSubnetInfoCombo-input" )
                  ->click();
                $Log->comment( "Selecting Subnet: " . $args{'subnet'} );
                $self->_find_element(
                        "//div[contains(\@class,'ellipsis') and text()='"
                      . $args{'subnet'}
                      . "']" )->click();
                $Log->comment("clicking on browse");
                $self->_find_element("//button[contains(text(),'Browse')]")
                  ->click();
                $self->wait_for_element_not_present($LOADING);
                $Log->comment( "clicking on node: " . $args{'node'} );
                $self->_double_click(
                            "//div[contains(\@id,'gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "NetworkPortInterfaceGrid')]/div/span[contains(\@class,'x-tree3-node-text') and text()='"
                          . $args{'node'} . "']"
                );
                $self->wait_for_element_not_present($LOADING);
                $Log->comment( "Clicking on the port " . $args{'port'} );
                $self->_find_element(
"//div[contains(\@class,'x-tree3-el')]/span[contains(\@class,'x-tree3-node-text') and text()='"
                      . $args{'port'}
                      . "']" )->click();
                $Log->comment("Clicking on ok");
                $self->_find_element($GENERIC_DIALOG2_OK_BUTTON)->click();

                if ( exists( $args{'nisDomain'} )
                 and exists( $args{'nisServer'} ) ) {
                    $Log->comment("NIS configuration details");
                    if (
                        !$self->is_element_present(
                                "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "VserverSetupNasConfigNisPanelDomainNameFieldTextArea-input"
                        )
                      )
                    {
                        $Log->comment("Opening NIS Config Details Panel");
                        $self->_find_element( "//fieldset[\@id='gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "VserverSetupNasConfigNisPanelNisConfigFieldSet']/legend/div"
                        )->click();
                    }
                    $Log->comment(
                        "Entering NIS Details: " . $args{'nisDomain'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasConfigNisPanelDomainNameFieldTextArea-input"
                    )->clear();
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasConfigNisPanelDomainNameFieldTextArea-input"
                    )->send_keys( $args{'nisDomain'} );
                    $Log->comment(
                        "Entering NIS Details: " . $args{'nisServer'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasConfigNisPanelIpAddressesFieldTextArea-input"
                    )->clear();
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "VserverSetupNasConfigNisPanelIpAddressesFieldTextArea-input"
                    )->send_keys( $args{'nisServer'} );
                    if ( exists( $args{'exportName'} ) ) {
                        $Log->comment(
                            "Entering Export Name: " . $args{'exportName'} );
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "VserverSetupNasConfigNisPanelNfsExportAsFieldTextField-input"
                        )->send_keys( $args{'exportName'} );
                        $Log->comment(
                            "Entering Export Size: " . $args{'exportSize'} );
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "VserverSetupNasConfigNisPanelNfsVolumeSizeFieldTextField-input"
                        )->send_keys( $args{'exportSize'} );
                        $Log->comment( "Selecting Export Size Unit: "
                              . $args{'exportSizeUnit'} );
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "VserverSetupNasConfigNisPanelNfsVolumeStorageUnitFieldSimpleComboBox-input"
                        )->click();
                        $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                              . $args{'exportSizeUnit'}
                              . "']" )->click();
                        if ( exists( $args{'exportPermission'} ) ) {
                            $Log->comment("Clicking On Change Button");
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "VserverSetupNasConfigNisPanelNfsExportPolicyChangeLinkCustomLink"
                            )->click();
                            $self->wait_for_element_not_present($LOADING);
                            $Log->comment( "Entering Client Specification: "
                                  . $args{'clientSpec'} );
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "CreateModifyRuleDialogClientSpec-input" )
                              ->clear();
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "CreateModifyRuleDialogClientSpec-input" )
                              ->send_keys( $args{'clientSpec'} );
                            if ( exists( $args{'protocol'} ) ) {
                                $Log->comment("Spliting the Access Protocols ");
                                my @protocols = @{$args{'protocol'}};
                                for ( my $i = 0 ; $i < @protocols ; $i++ ) {
                                    if ( $protocols[$i] =~ /CIFS/ ) {
                                        $Log->comment("Disabling CIFS");
                                        $self->_find_element(
                                                "//div[\@id='gwt-debug-"
                                              . $self->{$SYSTEM_NAME_KEY}
                                              . "CreateModifyRuleDialogCifsChkBox']/input"
                                        )->click();
                                    }
                                    elsif ( $protocols[$i] =~ /NFSv3/ ) {
                                        $Log->comment("Disabling NFSv3");
                                        $self->_find_element(
                                                "//div[\@id='gwt-debug-"
                                              . $self->{$SYSTEM_NAME_KEY}
                                              . "nfsv3CheckBOx']/input" )
                                          ->click();
                                    }
                                    elsif ( $protocols[$i] =~ /NFSv4/ ) {
                                        $Log->comment("Disabling NFSv4");
                                        $self->_find_element(
                                                "//div[\@id='gwt-debug-"
                                              . $self->{$SYSTEM_NAME_KEY}
                                              . "nfsv4CheckBOx']/input" )
                                          ->click();
                                    }
                                    elsif ( $protocols[$i] =~ /NFS/ ) {
                                        $Log->comment("Disabling NFS");
                                        $self->_find_element(
                                                "//div[\@id='gwt-debug-"
                                              . $self->{$SYSTEM_NAME_KEY}
                                              . "nfsCheckBOx']/input" )
                                          ->click();
                                    }
                                    elsif ( $protocols[$i] =~ /Flexcache/ ) {
                                        $Log->comment("Disabling Flexcache");
                                        $self->_find_element(
                                                "//div[\@id='gwt-debug-"
                                              . $self->{$SYSTEM_NAME_KEY}
                                              . "CreateModifyRuleDialogFlexcacheChkBox']/input"
                                        )->click();
                                    }
                                }
                            }
                            if ( exists( $args{'rorule'} ) ) {
                                $Log->comment(
                                    "Enabiling Read only Check Box");
                                $self->_find_element(
                                        "//div[\@id='gwt-debug-"
                                      . $self->{$SYSTEM_NAME_KEY}
                                      . "CreateModifyRuleDialogReadOnlyCheckBox']/input"
                                )->click();
                                $Log->comment("Spliting the Access Details RO");
                                my @protocols =
                                  split( /:/, $args{'rorule'} );
                                for ( my $i = 0 ; $i < @protocols ; $i++ ) {
                                    if ( $protocols[$i] =~ /UNIX/i ) {
                                        $Log->comment("Disabling UNIX");
                                        $self->_find_element(
                                                "//div[\@id='gwt-debug-"
                                              . $self->{$SYSTEM_NAME_KEY}
                                              . "CreateModifyRuleDialogRoRuleUnixChkBox']/input"
                                        )->click();
                                    }
                                    elsif ( $protocols[$i] =~ /(Kerberos 5)|(krb5)/ )
                                    {
                                        $Log->comment(
                                            "Disabling Kerberos 5");
                                        $self->_find_element(
                                                "//div[\@id='gwt-debug-"
                                              . $self->{$SYSTEM_NAME_KEY}
                                              . "CreateModifyRuleDialogRoRuleKerberos5ChkBox']/input"
                                        )->click();
                                    }
                                    elsif (
                                        $protocols[$i] =~ /(Kerberos 5i)|(krb5i)/ )
                                    {
                                        $Log->comment(
                                            "Disabling Kerberos 5i");
                                        $self->_find_element(
                                                "//div[\@id='gwt-debug-"
                                              . $self->{$SYSTEM_NAME_KEY}
                                              . "CreateModifyRuleDialogRoRuleKerberos5iChkBox']/input"
                                        )->click();
                                    }
                                    elsif ( $protocols[$i] =~ /NTLM/i ) {
                                        $Log->comment("Disabling NTLM");
                                        $self->_find_element(
                                                "//div[\@id='gwt-debug-"
                                              . $self->{$SYSTEM_NAME_KEY}
                                              . "CreateModifyRuleDialogRoRuleNtlmChkBox']/input"
                                        )->click();
                                    }
                                }
                            }
                            if ( exists( $args{'rwrule'} ) ) {
                                if ( $args{'rwrule'} =~ /disable|none/ ) {
                                    $Log->comment(
                                        "Disabling Read Write Check Box");
                                    $self->_find_element(
                                            "//div[\@id='gwt-debug-"
                                          . $self->{$SYSTEM_NAME_KEY}
                                          . "CreateModifyRuleDialogReadWriteCheckBox']/input"
                                    )->click();
                                } else {
                                    $Log->comment(
                                        "Spliting the Access Details RW");
                                    my @protocols =
                                      split( /:/,
                                        $args{'rwrule'} );
                                    for ( my $i = 0 ; $i < @protocols ; $i++) {
                                        if ( $protocols[$i] =~ /UNIX/i ) {
                                            $Log->comment("Disabling UNIX");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "CreateModifyRuleDialogRoRuleUnixChkBox']/input"
                                            )->click();
                                        } elsif ( $protocols[$i] =~ /(Kerberos 5)|(krb5)/ ) {
                                            $Log->comment(
                                                "Disabling Kerberos 5");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "CreateModifyRuleDialogRoRuleKerberos5ChkBox']/input"
                                            )->click();
                                        } elsif ( $protocols[$i] =~ /(Kerberos 5i)|(krb5i)/ ) {
                                            $Log->comment("Disabling Kerberos 5i");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "CreateModifyRuleDialogRoRuleKerberos5iChkBox']/input"
                                            )->click();
                                        }
                                        elsif ( $protocols[$i] =~ /NTLM/i ) {
                                            $Log->comment("Disabling NTLM");
                                            $self->_find_element(
                                                    "//div[\@id='gwt-debug-"
                                                  . $self->{$SYSTEM_NAME_KEY}
                                                  . "CreateModifyRuleDialogRoRuleNtlmChkBox']/input"
                                            )->click();
                                        }
                                    }
                                }
                            }
                            if ( exists( $args{'superUser'} ) ) {
                                $Log->comment("Enabiling SuperUser Access");
                                $self->_find_element( "//div[\@id='gwt-debug-"
                                      . $self->{$SYSTEM_NAME_KEY}
                                      . "CreateModifyRuleDialogRuleLabelSuperUserCheckBox']/input"
                                )->click();
                            }
                            $Log->comment( "Clicking on Modify Export Rule Dialog OK Button");
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "CreateModifyRuleDialogOkBtn" )->click();
                            $self->wait_for_element_not_present($LOADING);
                        }
                    }
                }
                my $manualIPAutoRadio =
                    "//div[\@id='gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "nfssubnetPortInterfacePanelAutoSelectRadio']/input";
                my $manualIPSpecificRadio =
                    "//div[\@id='gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "nfssubnetPortInterfacePanelSpecificIPRadio']/input";
                my $manualIPSpecificInput =
                    "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "nfssubnetPortInterfacePanelIpAddressTextField-input";
                if ( exists( $args{'manualIPNFS'} ) ) {
                    if (
                        !$self->is_selected(
                            $self->_find_element($manualIPAutoRadio)
                        )
                      )
                    {
                        $Log->comment(
                            "Auto Select IPAddress is not selected by default");
                        $self->closeVserver();

                        $Log->exit() if $may_exit;
                        return 0;
                    }
                    $Log->comment("Selecting specific radio button");
                    $self->_find_element($manualIPSpecificRadio)->click();
                    $Log->comment( "Entering specific IPAddress: "
                          . $args{'manualIPNFS'} );
                    $self->_find_element($manualIPSpecificInput)->clear();
                    $self->_find_element($manualIPSpecificInput)
                      ->send_keys( $args{'manualIPNFS'} );
                }
            }
            if ( grep( /iscsi/i, @{ $args{'protocol'} } ) ) {
                $Log->comment("Clicking on iscsi Link");
                $self->_find_element($iscsiLink)->click();
                $self->wait_for_element_not_present($RETRIEVING);
                $self->wait_for_element_not_present($RETRIEVING);
                $Log->comment("Configuring iScsi Protocol");
                if ( exists( $args{'targetAlias'} ) ) {
                    $Log->comment(
                        "Entering targetAlias: " . $args{'targetAlias'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "IscsiPageTargetAliasTextField-input" )
                      ->send_keys( $args{'targetAlias'} );
                    $Log->comment( "Entering lifNode: " . $args{'lifNode'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "IscsiPageIntfPerNodeField-input" )->clear();
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "IscsiPageIntfPerNodeField-input" )
                      ->send_keys( $args{'lifNode'} );
                    $Log->comment("Clicking on Vertical Panel");
                    $self->_find_element(
                        "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "iscsiVerticalPanel" )
                      ->click();
                    $self->wait_for_element_not_present($RETRIEVING);
                    sleep(5);
                    $self->wait_for_element_not_present($RETRIEVING);
                }
                if ( exists( $args{'lunProv'} ) ) {
                    $Log->comment( "Entering lun prov: " . $args{'lunProv'} );
                    $self->_find_element(
"//div/table/tbody/tr[2]/td[2]/div/table/tbody/tr/td/div/input"
                    )->send_keys( $args{'lunProv'} );
                    $Log->comment(
                        "Selecting Lun size Unit: " . $args{'lunSizeUnit'} );
                    $self->_find_element(
                        "//tr[2]/td[2]/div/table/tbody/tr/td[2]/div/img")
                      ->click();
                    $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'lunSizeUnit'}
                          . "']" )->click();
                    $Log->comment( "Selecting Lun OS Type: " . $args{'lunOS'} );
                    $self->_find_element(
                        "//td[2]/div/table/tbody/tr[3]/td[2]/div/img")->click();
                    $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'lunOS'}
                          . "']" )->click();
                    $Log->comment(
                        "Entering initiator: " . $args{'lunInitiator'} );
                    $self->_find_element(
                        "//td[2]/div/table/tbody/tr[4]/td[2]/div/input")
                      ->send_keys( $args{'lunInitiator'} );
                }
                if ( exists( $args{'subnet'} ) ) {
                    $Log->comment("Clicking on Subnet text box");
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "IscsiPageSubnetCombobox-input" )->click();
                    $Log->comment( "Selecting Subnet: " . $args{'subnet'} );
                    $self->_find_element(
                            "//div[contains(\@class,'ellipsis') and text()='"
                          . $args{'subnet'}
                          . "']" )->click();
                }
                my $manualIPAutoRadio =
                    "//div[\@id='gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "IscsiPageAutoSelectRadio']/input";
                my $manualIPSpecificRadio =
                    "//div[\@id='gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "IscsiPageSpecificIPRadio']/input";
                my $manualIPSpecificInput =
                    "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "IscsiPageStartingIpTextField-input";
                if ( exists( $args{'manualIPIscsi'} ) ) {
                    if (
                        !$self->is_selected(
                            $self->_find_element($manualIPAutoRadio)
                        )
                      )
                    {
                        $Log->comment(
                            "Auto Select IPAddress is not selected by default");
                        $self->closeVserver();

                        $Log->exit() if $may_exit;
                        return 0;
                    }
                    $Log->comment("Selecting specific radio button");
                    $self->_find_element($manualIPSpecificRadio)->click();
                    $Log->comment( "Entering specific IPAddress: "
                          . $args{'manualIPIscsi'} );
                    $self->_find_element($manualIPSpecificInput)->clear();
                    $self->_find_element($manualIPSpecificInput)
                      ->send_keys( $args{'manualIPIscsi'} );
                }
                if ( exists( $args{'iscsiAdvanced'} ) ) {
                    sleep(3);
                    $Log->comment("Clicking on Vertical Panel");
                    if (
                        $self->is_element_present(
                            "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "iscsiVerticalPanel"
                        )
                      )
                    {
                        $self->_find_element(
                            "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "iscsiVerticalPanel" )
                          ->click();
                        $self->wait_for_element_not_present($RETRIEVING);
                        sleep(3);
                    }
                    if ( !$self->is_checked( $self->_find_element(
                                    "//div[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY}
                                  . "IscsiPageAdvancedSettingsCheckbox']/input"))) {
                        $Log->comment("Clicking on Advanced Setting CheckBox");
                        $self->_find_element( "//div[\@id='gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "IscsiPageAdvancedSettingsCheckbox']/input" )
                          ->click();
                        sleep(2);
                    }
                    if ( exists( $args{'portSets'} ) ) {
                        $Log->comment( "Entering number of portsets: "
                              . $args{'portSets'} );
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "iscsiPortsetSpinner-spinnerField-input" )
                          ->clear();
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "iscsiPortsetSpinner-spinnerField-input" )
                          ->send_keys( $args{'portSets'} );
                    }
                    if ( exists( $args{'iscsiInterfaceEdit'} ) ) {
                        $self->_find_element(
                           "//div[contains(\@class,'x-grid3-col-interface-name')]"
                         . "/div[contains(text(),'"
                         . $args{'iscsiInterfaceEdit'}
                         . "')]" )->click();
                        $Log->comment("Double Clicking the interface row");
                        $self->_double_click(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div[contains(text(),'"
                                  . $args{'iscsiInterfaceEdit'} . "')]"
                        );
                        $self->wait_for_element_not_present($LOADING);
                        if ( exists( $args{'iscsiInterfaceRename'} ) ) {
                            $Log->comment( "Entering interface name: "
                                  . $args{'iscsiInterfaceRename'} );
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "iscsiInterfaceNameCol-input" )->clear();
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "iscsiInterfaceNameCol-input" )
                              ->send_keys( $args{'iscsiInterfaceRename'} );
                        }
                        if ( exists( $args{'iscsiPort'} ) ) {
                            $Log->comment("Clicking on port selection");
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "iscsiHomeportCol-input" )->click();
                            $Log->comment(
                                "Selecting port: " . $args{'iscsiPort'} );
                            $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                                  . $args{'iscsiPort'}
                                  . "']" )->click();
                        }
                        if ( exists( $args{'iscsiIP'} ) ) {
                            if ( !$args{'iscsiIP'} =~ /negative/ ) {
                                $self->_find_element( "gwt-debug-"
                                      . $self->{$SYSTEM_NAME_KEY}
                                      . "iscsiPpAddrCol-input" )->clear();
                                $Log->comment( "Entering iscsi ipaddress: "
                                      . $args{'iscsiIP'} );
                                $self->_find_element( "gwt-debug-"
                                      . $self->{$SYSTEM_NAME_KEY}
                                      . "iscsiPpAddrCol-input" )
                                  ->send_keys( $args{'iscsiIP'} );
                            }
                            elsif ( $args{'iscsiIP'} =~ /negative/ ) {
                                my $currentAddress =
                                  $self->_find_element( "gwt-debug-"
                                      . $self->{$SYSTEM_NAME_KEY}
                                      . "iscsiPpAddrCol-input" )
                                  ->get_attribute("value");
                                my @ipAddress =
                                  split( /,/, $args{'iscsiIPNegative'} );
                                for ( my $i = 0 ; $i < @ipAddress ; $i++ ) {
                                    if (
                                        !$self->is_element_present(
                                                "gwt-debug-"
                                              . $self->{$SYSTEM_NAME_KEY}
                                              . "iscsiPpAddrCol-input"
                                        )
                                      )
                                    {
                                        $self->_find_element(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div[contains(text(),'"
                                              . $args{'iscsiInterfaceEdit'}
                                              . "')]" )->click();
                                        $Log->comment(
                                            "Double Clicking the interface row"
                                        );
                                        $self->_double_click(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div[contains(text(),'"
                                                  . $args{'iscsiInterfaceEdit'}
                                                  . "')]"
                                        );
                                        $self->wait_for_element_not_present(
                                            $LOADING);
                                    }
                                    $self->_find_element( "gwt-debug-"
                                          . $self->{$SYSTEM_NAME_KEY}
                                          . "iscsiPpAddrCol-input" )->clear();
                                    $Log->comment( "Entering iscsi ipaddress: "
                                          . $ipAddress[$i] );
                                    $self->_find_element( "gwt-debug-"
                                          . $self->{$SYSTEM_NAME_KEY}
                                          . "iscsiPpAddrCol-input" )
                                      ->send_keys( $ipAddress[$i] );
                                    $Log->comment("Clicking on Save button");
                                    $self->_find_element(
                                        "//button[text()='Save']")->click();
                                    $self->_check_for_errordialog();
                                }
                                if (
                                    !$self->is_element_present(
                                            "gwt-debug-"
                                          . $self->{$SYSTEM_NAME_KEY}
                                          . "iscsiPpAddrCol-input"
                                    )
                                  )
                                {
                                    if (
                                        $self->is_element_present(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div[contains(text(),'"
                                              . $args{'iscsiInterfaceEdit'}
                                              . "')]"
                                        )
                                      )
                                    {
                                        $self->_find_element(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div[contains(text(),'"
                                              . $args{'iscsiInterfaceEdit'}
                                              . "')]" )->click();
                                        $Log->comment(
                                            "Double Clicking the interface row"
                                        );
                                        $self->_double_click(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div[contains(text(),'"
                                                  . $args{'iscsiInterfaceEdit'}
                                                  . "')]"
                                        );
                                    }
                                    elsif (
                                        $self->is_element_present(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div/span[contains(text(),'"
                                              . $args{'iscsiInterfaceEdit'}
                                              . "')]"
                                        )
                                      )
                                    {
                                        $self->_find_element(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div/span[contains(text(),'"
                                              . $args{'iscsiInterfaceEdit'}
                                              . "')]" )->click();
                                        $Log->comment(
                                            "Double Clicking the interface row"
                                        );
                                        $self->_double_click(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div/span[contains(text(),'"
                                                  . $args{'iscsiInterfaceEdit'}
                                                  . "')]"
                                        );
                                    }
                                    $self->wait_for_element_not_present(
                                        $LOADING);
                                }
                                if ( !exists( $args{'iscsiIPPositive'} ) ) {
                                    $self->_find_element( "gwt-debug-"
                                          . $self->{$SYSTEM_NAME_KEY}
                                          . "iscsiPpAddrCol-input" )->clear();
                                    $Log->comment(
                                        "Replacing default iscsi ipaddress: "
                                          . $currentAddress );
                                    $self->_find_element( "gwt-debug-"
                                          . $self->{$SYSTEM_NAME_KEY}
                                          . "iscsiPpAddrCol-input" )
                                      ->send_keys($currentAddress);
                                }
                                else {
                                    $Log->comment( "Entering new ipaddress: "
                                          . $args{'iscsiIPPositive'} );
                                    $self->_find_element( "gwt-debug-"
                                          . $self->{$SYSTEM_NAME_KEY}
                                          . "iscsiPpAddrCol-input" )->clear();
                                    $self->_find_element( "gwt-debug-"
                                          . $self->{$SYSTEM_NAME_KEY}
                                          . "iscsiPpAddrCol-input" )
                                      ->send_keys( $args{'iscsiIPPositive'} );
                                }
                            }
                        }
                        if (
                            $self->is_element_present(
                                "//button[text()='Save']")
                          )
                        {
                            $Log->comment("Clicking on Save button");
                            $self->_find_element("//button[text()='Save']")
                              ->click();
                            $self->_check_for_errordialog();
                        }
                    }
                }
            }
            if( grep( /fcp/i, @{ $args{'protocol'} } ) ) {
                $Log->comment("Clicking on fcp Link");
                $self->_find_element($fcpLink)->click();
                $self->wait_for_element_not_present($RETRIEVING);
                $Log->comment("Configuring FC Page Config CheckBox");
                $self->_find_element( "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "fcPageConfigCheckbox']/input" )->click();
                $Log->comment(
                    "Entering FC Lif Per Node: " . $args{'fcLifNode'} );
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "fcPageIntfPerNodeField-input" )->clear();
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "fcPageIntfPerNodeField-input" )
                  ->send_keys( $args{'fcLifNode'} );
                if ( exists( $args{'lunProvFC'} ) ) {
                    $Log->comment( "Entering lun prov: " . $args{'lunProvFC'} );
                    $self->_find_element(
                        "//td[2]/div/table/tbody/tr/td/div/input")
                      ->send_keys( $args{'lunProvFC'} );
                    $Log->comment(
                        "Selecting Lun size Unit: " . $args{'lunSizeUnitFC'} );
                    $self->_find_element(
"//td[3]/div/table/tbody/tr[2]/td[2]/div/table/tbody/tr/td[2]/div/img"
                    )->click();
                    $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'lunSizeUnitFC'}
                          . "']" )->click();
                    $Log->comment(
                        "Selecting Lun OS Type: " . $args{'lunOSFC'} );
                    $self->_find_element(
                        "//td[3]/div/table/tbody/tr[3]/td[2]/div/img")->click();
                    $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'lunOSFC'}
                          . "']" )->click();
                    $Log->comment(
                        "Entering initiator: " . $args{'lunInitiatorFC'} );
                    $self->_find_element(
                        "//td[3]/div/table/tbody/tr[4]/td[2]/div/input")
                      ->send_keys( $args{'lunInitiatorFC'} );
                }
                if ( exists( $args{'fcpAdvanced'} ) ) {
                    $Log->comment("Clicking on Advanced Setting CheckBox");
                    $self->_find_element( "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcPageAdvancedSettingsCheckbox']/input" )->click();
                    $Log->comment( "Entering number of portsets: "
                          . $args{'fcpportSets'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcPortsetSpinner-spinnerField-input" )->clear();
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcPortsetSpinner-spinnerField-input" )
                      ->send_keys( $args{'fcpportSets'} );
                    if ( exists( $args{'fcpInterfaceName'} ) ) {
                        $self->_find_element(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div"
                        )->click();
                        $Log->comment("Double Clicking the interface row");
                        $self->_double_click(
"//div[contains(\@class,'x-grid3-col-interface-name')]/div"
                        );
                        $self->wait_for_element_not_present($LOADING);
                        $Log->comment( "Entering interface name: "
                              . $args{'fcpInterfaceName'} );
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "fcInterfaceNameCol-input" )->clear();
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "fcInterfaceNameCol-input" )
                          ->send_keys( $args{'fcpInterfaceName'} );
                        if ( exists( $args{'fcpPort'} ) ) {
                            $Log->comment("Clicking on port selection");
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "fcHomeportCol-input" )->click();
                            $Log->comment(
                                "Selecting port: " . $args{'fcpPort'} );
                            $self->_find_element(
"//div[contains(\@class,'x-combo-list-item') and text()='"
                                  . $args{'fcpPort'}
                                  . "']" )->click();
                        }
                        $Log->comment("Clicking On Save Button");
                        $self->_find_element(
"//div/table/tbody/tr/td/table/tbody/tr[2]/td[2]/em/button"
                        )->click();
                    }
                }
            }
            if (  grep( /fcoe/i, @{ $args{'protocol'} } ) ) {
                $Log->comment("Clicking on FCoE Config CheckBox");
                $self->_find_element( "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "fcoePageConfigCheckbox']/input" )->click();
                $Log->comment(
                    "Entering fcoe lif per node: " . $args{'fcoeLifNode'} );
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "fcoePageIntfPerNodeField-input" )->clear();
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "fcoePageIntfPerNodeField-input" )
                  ->send_keys( $args{'fcoeLifNode'} );
                $Log->comment("Clicking on Text Box");
                $self->_find_element(
                  "//table/tbody/tr[2]/td[2]/div/table/tbody/tr/td/div/input"
                )->click();
                $self->wait_for_element_not_present($LOADING);

                if ( exists( $args{'lunProvFC'} ) ) {
                    $Log->comment( "Entering lun prov: " . $args{'lunProvFC'} );
                    $self->_find_element(
                      "//table/tbody/tr[2]/td[2]/div/table/tbody/tr/td/div/input"
                    )->send_keys( $args{'lunProvFC'} );
                    $Log->comment(
                        "Selecting Lun size Unit: " . $args{'lunSizeUnitFC'} );
                    $self->_find_element(
                        "//table/tbody/tr[2]/td[2]/div/table/tbody/tr/td[2]/div/img"
                    )->click();
                    $self->_find_element(
                      "//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'lunSizeUnitFC'}
                          . "']" )->click();
                    $Log->comment(
                        "Selecting Lun OS Type: " . $args{'lunOSFC'} );
                    $self->_find_element(
                      "//table/tbody/tr/td[3]/div/table/tbody/tr[3]/td[2]/div/img"
                    )->click();
                    $self->_find_element(
                      "//div[contains(\@class,'x-combo-list-item') and text()='"
                          . $args{'lunOSFC'}
                          . "']" )->click();
                    $Log->comment(
                        "Entering initiator: " . $args{'lunInitiatorFC'} );
                    $self->_find_element(
                        "//table/tbody/tr/td[3]/div/table/tbody/tr[4]/td[2]/div/input"
                    )->send_keys( $args{'lunInitiatorFC'} );
                }
                if ( exists( $args{'fcoeAdvanced'} ) ) {
                    $Log->comment("Clicking on Advanced Setting CheckBox");
                    $self->_find_element( "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcoePageAdvancedSettingsCheckbox']/input" )
                      ->click();
                    $Log->comment( "Entering number of portsets: "
                          . $args{'fcoeportSets'} );
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcoePortsetSpinner-spinnerField-input" )->clear();
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcPortsetSpinner-spinnerField-input" )
                      ->send_keys( $args{'fcoeportSets'} );
                    if ( exists( $args{'fcoeInterfaceName'} ) ) {
                        $self->_find_element(
                          "//div[contains(\@class,'x-grid3-col-interface-name')]/div"
                        )->click();
                        $Log->comment("Double Clicking the interface row");
                        $self->_double_click(
                          "//div[contains(\@class,'x-grid3-col-interface-name')]/div"
                        );
                        $self->wait_for_element_not_present($LOADING);
                        $Log->comment( "Entering interface name: "
                              . $args{'fcoeInterfaceName'} );
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "fcoeInterfaceNameCol-input" )->clear();
                        $self->_find_element( "gwt-debug-"
                              . $self->{$SYSTEM_NAME_KEY}
                              . "fcoeInterfaceNameCol-input" )
                          ->send_keys( $args{'fcoeInterfaceName'} );
                        if ( exists( $args{'fcoePort'} ) ) {
                            $Log->comment("Clicking on port selection");
                            $self->_find_element( "gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "fcoeHomeportCol-input" )->click();
                            $Log->comment(
                                "Selecting port: " . $args{'fcoePort'} );
                            $self->_find_element(
                          "//div[contains(\@class,'x-combo-list-item') and text()='"
                                  . $args{'fcoePort'}
                                  . "']" )->click();
                        }
                        $Log->comment("Clicking On Save Button");
                        $self->_find_element("//button[test()=\"Save\"")->click();
                    }
                }
            }
        }
        if ( exists($args{'vsAdmin'}) and
             $args{'vsAdmin'} =~ /yes|1/ ) {
            $Log->comment("Clicking On vsadmin link");
            $self->_find_element($vsadminLink)->click();
            $self->wait_for_element_not_present($LOADING);
            $Log->comment(
                "Entering vsAdmin Password: " . $args{'vsAdminPasswd'} );
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "VserverSetupAdminPageVserverSetupAdminPageNameAdminPasswordTextField-input"
            )->send_keys( $args{'vsAdminPasswd'} );
            $Log->comment( "Entering vsAdmin Confirm Password: "
                  . $args{'vsAdminPasswdConfirm'} );

            if ( exists( $args{'vsAdminPasswdConfirm'} ) ) {
                $Log->comment( "Entering vsAdmin Confirm Password: "
                     . $args{'vsAdminPasswdConfirm'} );

                 $self->_find_element( "gwt-debug-"
                 . $self->{$SYSTEM_NAME_KEY}
                 . "VserverSetupAdminPageVserverSetupAdminPage"
                 . "ConfirmAdminPasswordTextField-input")->send_keys( $args{'vsAdminPasswdConfirm'} );

            } else {
                 $Log->comment( "Entering vsAdmin Confirm Password: "
                  . $args{'vsAdminPasswd'} );
 
                 $self->_find_element( "gwt-debug-"
                 . $self->{$SYSTEM_NAME_KEY}
                 . "VserverSetupAdminPageVserverSetupAdminPage"
                 . "ConfirmAdminPasswordTextField-input")->send_keys( $args{'vsAdminPasswd'} );
            }

            if ( exists( $args{'newLifMgt'} ) ) {
                my $checkbox =
                    "//div[\@id='gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "VserverSetupAdminPageVserverSetupAdminPageNewDataLifCheckBox']/input";
                if ( $args{'newLifMgt'} =~ /no/ ) {
                    $Log->comment("Disabling vsmgmt lif creation checkbox");
                    $self->_find_element($checkbox)->click();
                }
                else {
                    $Log->comment("Clicking on Subnet text box");
                    $self->_find_element( "gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "adminsubnetPortInterfacePanelSubnetInfoCombo-input"
                    )->click();
                    $Log->comment( "Selecting Subnet: " . $args{'subnet'} );
                    $self->_find_element(
                        "//div[contains(\@class,'ellipsis') and text()='"
                          . $args{'subnet'}
                          . "']" )->click();
                    if ( exists( $args{'node'} ) ) {
                        $Log->comment("clicking on browse");
                        $self->_find_element(
                            "//button[contains(text(),'Browse')]")->click();
                        $self->wait_for_element_not_present($LOADING);
                        $Log->comment(
                            "clicking on node: " . $args{'node'} );
                        $self->_double_click(
                                    "//div[contains(\@id,'gwt-debug-"
                                  . $self->{$SYSTEM_NAME_KEY}
                                  . "NetworkPortInterfaceGrid')]/div/span[contains(\@class,'x-tree3-node-text') and text()='"
                                  . $args{'node'} . "']"
                        );
                        sleep(5);
                        $Log->comment(
                            "Clicking on the port " . $args{'port'} );
                        $self->_find_element(
                            "//div[contains(\@class,'x-tree3-el')]/span[contains"
                          . "(\@class,'x-tree3-node-text') and text()='"
                          . $args{'port'}
                          . "']" )->click();
                        $Log->comment("Clicking on ok");
                        $self->_find_element($GENERIC_DIALOG2_OK_BUTTON)->click();
                    }
                    my $manualIPAutoRadio =
                        "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "subnetPortInterfacePanelAutoSelectRadio']/input";
                    my $manualIPSpecificRadio =
                        "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "subnetPortInterfacePanelSpecificIPRadio']/input";
                    my $manualIPSpecificInput =
                        "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "subnetPortInterfacePanelIpAddressTextField-input";
                    if ( exists( $args{'manualIPCIFS'} ) ) {
                        if (
                            !$self->is_selected(
                                $self->_find_element($manualIPAutoRadio)
                            )
                          )
                        {
                            $Log->comment( "Auto Select IPAddress is not selected by default");
                            $self->closeVserver();

                            $Log->exit() if $may_exit;
                            return 0;
                        }
                        $Log->comment("Selecting specific radio button");
                        $self->_find_element($manualIPSpecificRadio)
                          ->click();
                        $Log->comment( "Entering specific IPAddress: "
                              . $args{'manualIPCIFS'} );
                        $self->_find_element($manualIPSpecificInput)
                          ->clear();
                        $self->_find_element($manualIPSpecificInput)
                          ->send_keys( $args{'manualIPCIFS'} );
                    }
                }
            }
        }

        if ( exists( $args{'vsmgmtLif'} ) and
             $args{'vsmgmtLif'} =~ /yes/ ) {
            $Log->comment("Clicking On vsmgmtLink link");
            $self->_find_element($vsmgmtLink)->click();
            $self->wait_for_element_not_present($LOADING);
            if ( exists( $args{'vsAdminPasswd'} ) ) {
                $Log->comment( "Entering vsAdmin Password: "
                      . $args{'vsAdminPasswd'} );
                $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "VserverSetupAdminPageVserverSetupAdminPageNameAdminPasswordTextField-input")
                      ->send_keys( $args{'vsAdminPasswd'} );
            
                if ( exists( $args{'vsAdminPasswdConfirm'} ) ) {
                    $Log->comment( "Entering vsAdmin Confirm Password: " . $args{'vsAdminPasswdConfirm'} );
                     $self->_find_element( "gwt-debug-"
                    . $self->{$SYSTEM_NAME_KEY}
                    . "VserverSetupAdminPageVserverSetupAdminPageConfirmAdminPasswordTextField-input")
                      ->send_keys( $args{'vsAdminPasswdConfirm'} );
  
                } else {
                    $Log->comment( "Entering vsAdmin Confirm Password: " . $args{'vsAdminPasswd'} );
                    $self->_find_element( "gwt-debug-"
                     . $self->{$SYSTEM_NAME_KEY}
                     . "VserverSetupAdminPageVserverSetupAdminPageConfirmAdminPasswordTextField-input")->send_keys( $args{'vsAdminPasswd'} );
                }
            }
            $Log->comment("Clicking on Subnet text box");
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "adminsubnetPortInterfacePanelSubnetInfoCombo-input" )
              ->click();
            $Log->comment( "Selecting Subnet: " . $args{'subnet'} );
            $self->_find_element(
                    "//div[contains(\@class,'ellipsis') and text()='"
                  . $args{'subnet'}
                  . "']" )->click();
            if ( exists( $args{'node'} ) ) {
                $Log->comment("clicking on browse");
                $self->_find_element("//button[contains(text(),'Browse')]")
                  ->click();
                $self->wait_for_element_not_present($LOADING);
                $Log->comment( "clicking on node: " . $args{'node'} );
                $self->_double_click(
                            "//div[contains(\@id,'gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "NetworkPortInterfaceGrid')]/div/span[contains(\@class,'x-tree3-node-text') and text()='"
                          . $args{'node'} . "']"
                );
                sleep(5);
                $Log->comment( "Clicking on the port " . $args{'port'} );
                $self->_find_element( "//div[contains(\@class,'x-tree3-el')]/"
                    . "span[contains(\@class,'x-tree3-node-text') and text()='"
                    . $args{'port'}
                    . "']" )->click();
                $Log->comment("Clicking on ok");
                $self->_find_element($GENERIC_DIALOG2_OK_BUTTON)->click();
            }
            my $manualIPAutoRadio =
                "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "subnetPortInterfacePanelAutoSelectRadio']/input";
            my $manualIPSpecificRadio =
                "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "subnetPortInterfacePanelSpecificIPRadio']/input";
            my $manualIPSpecificInput =
                "gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "subnetPortInterfacePanelIpAddressTextField-input";
            if ( exists( $args{'manualIPCIFS'} ) ) {
                if (
                    !$self->is_selected(
                        $self->_find_element($manualIPAutoRadio)
                    )
                  )
                {
                    $Log->comment(
                        "Auto Select IPAddress is not selected by default");
                    $self->closeVserver();

                    $Log->exit() if $may_exit;
                    return 0;
                }
                $Log->comment("Selecting specific radio button");
                $self->_find_element($manualIPSpecificRadio)->click();
                $Log->comment( "Entering specific IPAddress: "
                      . $args{'manualIPCIFS'} );
                $self->_find_element($manualIPSpecificInput)->clear();
                $self->_find_element($manualIPSpecificInput)
                  ->send_keys( $args{'manualIPCIFS'} );
            }
        }

        if ( $self->is_element_present(
             "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "VserverSetupDialogSubmitButton"))
        {
            $Log->comment("Clicking On Submit Button");
            $self->_find_element(
                "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "VserverSetupDialogSubmitButton" )
              ->click();
        }
        $self->wait_for_element_not_present($CREATING);
        $self->wait_for_element_not_present($RETRIEVING);
        $self->wait_for_element_not_present($LOADING);
        $self->_check_for_error();
    }
    catch NATE::BaseException with {
        my $e = shift;
        $Log->comment( "Unable navigate SetUp Protocol " . $e->text() );
        $self->closeVserver();
        $Log->exit() if $may_exit;
        $e->throw();
    };
    if ( $self->is_element_present($GENERIC_DIALOG2_OK_BUTTON) ) {
        $self->_find_element($GENERIC_DIALOG2_OK_BUTTON)->click();
    }
    $self->closeVserver();

    return {execution_time => time - $execution_time};

} ## end reEnrtyProtoclSetUp


=head2 refreshVserver

Returns boolean

=over

=item Options

=over


=back

=back

=over

=back

=cut

sub refreshVserver {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = @_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );
    my $execution_time = time;

    $self->setVserverTab( 'vserver' => $vserver );

    $Log->comment("Refreshing Vservers");

    $self->setVserverOperation( 'operation' => "Refresh", );
    $self->getVserverOperation()->click();
    $self->wait_for_element_not_present($LOADING);

    $Log->exit() if $may_exit;

    return {execution_time => time - $execution_time};

} ## end refreshVserver


=head2 setVserverOperation

Returns void

=over

=item Options

=over

=item C<< operation => SCALAR >>

 (Optional)

=back

=back

=over

=back
  
=cut

sub setVserverOperation {

    my $self = shift;

    $Log->enter() if $may_enter;
    my $execution_time = time;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'operation' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $vserverOperation =
      $self->_find_element( "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "VserverPage"
                            . $args{'operation'} . "ButtonVserverPageId" );

    $Log->exit() if $may_exit;
    return {execution_time => time - $execution_time};

} ## end setVserverOperation

=head2 setVserverTab

Returns boolean

=over

=item Options

=over

=item C<< vserver => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub setVserverTab {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'vserver' => { type => SCALAR|UNDEF }, },
        allow_extra => 1
    );
    my $execution_time = time;

    $Log->comment("Setting the vserver Tab");
    $vserver = $args{'vserver'};

    $self->cluster_tree_navigate( $vserver, $self->{$SYSTEM_NAME_KEY} );

    $VSERVER_CREATE_PROTOCOL_CHECKBOX_CIFS
        = "//div[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY}
        . "vserverSetupCreatePageCifsProtocolCheckBox']/input";
    $VSERVER_CREATE_PROTOCOL_CHECKBOX_NFS
        = "//div[\@id='gwt-debug-". $self->{$SYSTEM_NAME_KEY}
        . "vserverSetupCreatePageNfsProtocolCheckBox']/input";
    $VSERVER_CREATE_PROTOCOL_CHECKBOX_ISCSI
        = "//div[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY}
        . "vserverSetupCreatePageIscsiProtocolCheckBox']/input";
    $VSERVER_CREATE_PROTOCOL_CHECKBOX_FC
        = "//div[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY}
        . "vserverSetupCreatePageFcProtocolCheckBox']/input";
    $VSERVER_CREATE_DATA_INT_FIELD
        = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY}
        . "VserverSetupNasDataInterfacePanelDataIntfFieldSet";
    $VSERVER_CREATE_PORT_BROWSE_BTN
        = "//button[contains(text(),'Browse')]";
    $VSERVER_CREATE_NET_PORT_INT_GRID
        = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY}
        . "NetworkPortInterfaceGrid";

    $Log->exit() if $may_exit;
    return {execution_time => time - $execution_time};
} ## end setVserverTab


=head2 startVserver

Returns boolean

=over

=item Options

=over

=item C<< vserver => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub startVserver {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'vserver' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );
    my $execution_time = time;

    $Log->comment("Starting vserver");
    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;
    my $close = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ProgressBarIndicatorCloseButton";

    $self->refreshVserver();

    $self->clickVserver( 'vserver' => $args{'vserver'} );
    $Log->comment("Setting Vserver operation to start");
    $self->setVserverOperation( 'operation' => "Start", );
    $elementIdOrXpath = $self->getVserverOperation();
    $startTime        = $self->click_EventTime($elementIdOrXpath);
    $Log->comment("Wait for LOADING element not present");
    $self->eventWaitingTime( $LOADING, $startTime,
        $methodName . "_initial_loading" );
    my $i = 0;
    while ( $self->is_element_present($close) && $i < 12 ) {
        $Log->comment("Starting the Vserver");
        $i++;
        if ( $i == 12 ) {
            NATE::BaseException->throw(
                "Unable navigate start the vserver for 1 min");
        }
    }
    $self->check_for_error();

    $Log->exit() if $may_exit;
    return {execution_time => time - $execution_time};

} ## end startVserver

=head2 stopVserver

Returns boolean

=over

=item Options

=over

=item C<< vserver => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub stopVserver {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'vserver' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );
    $Log->comment("Stopping vserver");
    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;
    my $cancel = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ConfirmationDialogCancelButton";
    my $execution_time = time;
    $self->refreshVserver();

    $self->clickVserver( 'vserver'  => $args{'vserver'} );
    $Log->comment("Setting Vserver operation to stop");
    $self->setVserverOperation( 'operation' => "Stop", );
    $elementIdOrXpath = $self->getVserverOperation();
    $startTime        = $self->click_EventTime($elementIdOrXpath);
    $Log->comment("Wait for LOADING element not present");
    $self->eventWaitingTime( $LOADING, $startTime,
        $methodName . "_initial_loading" );

    if ( !$self->is_element_present($cancel) ) {
        $Log->exit() if $may_exit;
        NATE::BaseException->throw("Vserver Stop Dialog is not present");
    }
    $Log->comment("Clicking On Confirmation dialog checkbox");
    $self->_find_element( "//div[\@id='gwt-debug-"
          . $self->{$SYSTEM_NAME_KEY}
          . "ConfirmationDialogCheckBox1']/input" )->click();
    $Log->comment("Clicking On Confirmation dialog OK Button");
    $elementIdOrXpath = $self->_find_element(
        "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ConfirmationDialogOKButton" );
    $startTime = $self->click_EventTime($elementIdOrXpath);
    $self->_check_for_errordialog();
    $Log->comment("Wait for LOADING element not present");
    $self->eventWaitingTime( $LOADING, $startTime,
        $methodName . "_stopVserver" );

    return {execution_time => time - $execution_time};

} ## end stopVserver

1;
