#
# Copyright (c) 2017 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

import re

from NATE.Log import log_global
Log = log_global()

class Response:
    def __init__(self, **kwargs):
        self.output = kwargs.pop('output')
        self.CLI_separator = kwargs.pop('CLI_separator')
        p = re.compile('(.+)\?.+')
        self.processed_output = self.output
        #if (p.search(output)):
        #    self.processed_output = _.group(1)

        #self._parse_job_ids()
        self._parse_output()

    def get_raw_output(self):
        return self.output

    def get_parsed_output(self):
        return self.parsed_output

    def search(self):
        None

    # Method:  get_output_not_parsed
    # Purpose: Return all those lines which have not been parsed.
    def get_output_not_parsed(self):
        return self.not_parsed

    # Method:  get_job_ids
    # Purpose: Return Job IDs in the parsed output (if present)
    def get_job_ids(self):
        None

    # Method:  is_private_job
    # Purpose: Return 1 if the job is a private job
    def is_private_job(self):
        None
        #return $self->{parsed_output}->[0]->{is_private};

    # Returns the rows(as reference to array of hashes)containing specified
    # field and value
    def get_rows(self):
        #%args = NACL::APISet->validate_params(
        #params => \%args,
        #spec   => {
        #    field => { type => SCALAR, required => 1 },
        #    value => { type => SCALAR, required => 1 },
        #}
        #);
        #my $field  = $args{field};
        #my $value  = $args{value};
        #my @output = @{ $self->{parsed_output} };

        #my @result = ();
        #foreach my $hash (@output) {
            #foreach my $key ( keys( %{$hash} ) ) {
                #if ( $key eq $field ) {
                    #if ( $hash->{$key} eq $value ) {
                        #my %outhash = %{$hash};
                        #push( @result, \%outhash );
                    #}
                #}    # end of if key=field
            #} ## end foreach my $key ( keys( %{$hash...}))
        #} ## end foreach my $hash (@output)
        #return \@result;
        None

    def _parse_job_ids(self):
        #my %hash;
        #my $jobid;
        #$Log->debug("Trying to parse Job IDs in the output");
        jobid = ''
        output = self.processed_output
        lines  = output.splitlines()
        private = 0
        for l in lines:
            m = re.search('\[Job (\d+)\].*(?:\cH)*', l, flags=re.MULTILINE|re.DOTALL)
            if(m):
                jobid = _group(1)
                #if ($_ !~ /$self->{CLI_separator}/
                #&& (   $_ =~ /\[Job (\d+)\].*(?:\cH)*/
                #|| $_ =~ /[jJ]ob: (\d+).*(?:\cH)*/
                #|| $_ =~ /[jJ]ob: \"(\d+).*(?:\cH)*/ )
                #)
                #{
                #$jobid = $1;
                #$hash{$jobid} = $jobid;
                #$private = 1 if ($_ =~ /Queued private job/i);
                #push( @{ $self->{parsed_output} },
                #{ 'job_id' => $jobid, 'is_private' => $private } );

    def _parse_output(self):
        #if (self.processed_output):
        #    return

        output        = self.processed_output
        CLI_separator = self.CLI_separator

        output = re.sub(r'^W((?i)ARNING).*', '', output)
        #command = self.method_name

        # just skip blank lines. Note that \w does not match quotes, so include
        # that as well.
        lines = output.splitlines()
        lines = list(line for line in lines if line)
        #@lines = grep {/\w|"/} @lines;

        ## Removing '\\r\\n' from the output
        lines = [x.replace("\r\n","") for x in lines]

        # If the output has nothing than new lines (no output), we can return back
        # here itself
        if not lines:
            self.parsed_output = []
            return

        fields  = lines.pop(0)
        if not lines:
            self.parsed_output = []
            return

        heading = lines.pop(0)
        tmp_output = lines
        fields_list  = []
        heading_list = []
        if (fields):
            fields_list=fields.split(CLI_separator)

        if (heading):
            heading_list=heading.split(CLI_separator)

        not_parsed = []
        output = []
        partial_line = ''
        for line in tmp_output:
            # We're here to parse the output into key/value structures,
            # save skipped lines

            if (re.search('^I((?i)NFO)', line, flags=re.MULTILINE|re.DOTALL)):
                not_parsed.append(line)
                next
            elif (re.search('^W((?i)ARNING)', line, flags=re.MULTILINE|re.DOTALL)):
                not_parsed.append(line)
                next

            self.not_parsed = not_parsed

            values = line.split(CLI_separator)
            if (len(values) != len(heading_list)):
                if (len(partial_line)):
                    partial_line = partial_line+'\n'+line
                else:
                    partial_line += line

                # make sure we have seen the end of the row
                m = re.search(CLI_separator+'$', partial_line, flags=re.MULTILINE|re.DOTALL)
                if (not m):
                    next

                partial = partial_line.split(CLI_separator)
                if (len(partial) == len(heading)):
                    output.append(partial_line)
                    partial_line = ''
                elif (len(partial) > len(heading_list)):
                    print('Error')
            else:
                output.append(line)

        want_array = []
        for line in output:
            output_dict = {}
            index = 0
            for field in (line.split(CLI_separator)):
                field_name = fields_list[index]
                if not field_name:
                    # Shouldn't ever reach here
                    next

                if len(field.split(', *')) > 1:
                    output_dict[field_name] = field.split(', *')
                elif (len(field.split(',')) > 1):
                    # $array_ref->[0] =~ s/^"//;
                    # $array_ref->[-1] =~ s/"$//;
                    output_dict[field_name] = field.split(',')
                else:
                    output_dict[field_name] = field
                index += 1
            # Below line removes hash entry with key as "\r" that is left
            # after parsing all other lines for key value pairs.
            # delete $output{"\r"} if exists( $output{"\r"} );
            want_array.append(output_dict)

        # $Log->debug( sub {"Parsed output is:\n" . Dumper($want_array)} );
        self.parsed_output = want_array
