#$Id: //depot/prod/test/nacldev/lib/NACL/APISet/Switch/CLI/CiscoFC/default/reload.pm#1 $
#
#Copyright (c) 2012 Network Appliance, Inc.
#All rights reserved.
#
## @summary Routines to parse CiscoNetwork reload command
##
## @description
##    This is a library to parse the raw output of CiscoNetwork switch reload command.
##
## @synopsis
##  use NACL::APISet::Switch::CLI::CiscoFC::default::reload
##
##  reload(%args)
##
## @author skotagir@netapp.com ,dl-nacl-dev@netapp.com
##
## @status public
#
package NACL::APISet::Switch::CLI::CiscoFC::default::reload;

use strict;

#Include exceptions which will be thrown
use NACL::APISet::Exceptions::MissingRequiredParamException;
use NACL::APISet::Exceptions::InvalidParamValueException;
use NACL::APISet::Exceptions::InvalidParamException;
use NACL::APISet::Exceptions::CommandFailedException;

sub _check_error {
    my ( $error, $error_message );
    my %args       = @_;
    my $raw_output = $args{raw_output};
    my $resp       = $args{response_object};

    if ( $raw_output =~ /(Incomplete\s+command)/i ) {
        $error_message = $raw_output;
        $error         = "MissingRequiredParam";
    } elsif ( $raw_output =~ /(Invalid\s+number)/i ) {
        $error_message = $raw_output;
        $error         = "InvalidParamValue";
    } elsif ( $raw_output =~ /Invalid\s+parameter/ ) {
        $error_message = $raw_output;
        $error         = "InvalidParam";
    } elsif ( $raw_output =~ /reload command with force download cannot be issued for local supervisor module/ ) {
        $error_message = $raw_output;
        $error         = "CommandFailed";
    }
    if ($error) {
        $error = 'NACL::APISet::Exceptions::' . $error . 'Exception';
        $error->throw( text => $error_message, response_object => $resp );
    }
} ## end sub _check_error

sub reload {
    my %args   = @_;
    my $resp   = $args{response_object};
    my $output = $resp->get_processed_output();
    _check_error( raw_output => $output, response_object => $resp );

    return [];
} ## end sub reload
1;
