
#
# Copyright (c) 2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
## @summary Version class for finding Version attributes specific to BrocadeFC.
## @author rawat@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

package NACL::APISet::Version::Switch::BrocadeFC;

#
# Compiler Directives
#
use strict;
use warnings;

#
# Module imports
#
use NACL::APISet::Session::CLI::BrocadeFC;

#
# base class
#
use base qw(NACL::APISet::Version::Switch);

1;


=head1 NAME

NACL::APISet::Version::Switch::BrocadeFC - Version library for BrocadeFC

=head1 SYNOPSIS

 use NACL::APISet::Version::Switch::BrocadeFC;

=head1 DESCRIPTION

A C<NACL::APISet::Version::Switch::BrocadeFC> is used to connect to BrocadeFC Switch and 
collect version related attributes. All version related attributes exposed from
this libary can also be set or get by the user. 

=cut

=head1 CONSTRUCTORS

=head2 new

Returns a reference to a newly created C<NACL::APISet::Version::Switch::BrocadeFC>.

=over 

=item Synopsis

Since new is defined in base class. it will be called like this
$version = NACL::APISet::Version::Switch->new(%args)

=item Arguments

=over

=item category

(Mandatory)
The category to use.  Valid values include "Switch".

=item shell_type

(Mandatory)
The refers to the type of the shell host sent through 'hostobj'.
Valid values include "BrocadeFC".

=item hostobj

(Mandatory)
The hostrec object created for the resource.

=item conn_overrides

(Optional)
Hash reference to the list of connection overrides to be considered when
establishing the connection to the service.
Valid connection overrides are username, password, connid, conntype, ipaddress,
prompt_username and prompt_password.

=back

=item Returns

A reference to a new BrocadeFC Version object

=back

=cut
