
#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
## @summary Version class for finding Version attributes specific to Mellanox.
## @author  dl-nacl-dev@netapp.com


package NACL::APISet::Version::Switch::Mellanox;

#
# Compiler Directives
#
use strict;
use warnings;

#
# Module imports
#
use NACL::APISet::Session::CLI::Mellanox;

#
# base class
#
use base qw(NACL::APISet::Version::Switch);

1;

=head1 NAME

NACL::APISet::Version::Switch::Mellanox - Version library for Mellanox

=head1 SYNOPSIS

 use NACL::APISet::Version::Switch::Mellanox;

=head1 DESCRIPTION

A C<NACL::APISet::Version::Switch::Mellanox> is used to connect to Mellanox Switch and 
collect version related attributes. All version related attributes exposed from
this libary can also be set or get by the user. 

=cut

=head1 CONSTRUCTORS

=head2 new

Returns a reference to a newly created C<NACL::APISet::Version::Switch::Mellanox>.

=over 

=item Synopsis

Since new is defined in base class. it will be called like this
$version = NACL::APISet::Version::Switch->new(%args)

=item Arguments

=over

=item category

(Mandatory)
The category to use.  Valid values include "Switch".

=item shell_type

(Mandatory)
The refers to the type of the shell host sent through 'hostobj'.
Valid values include "Mellanox"

=item hostobj

(Mandatory)
The hostrec object created for the resource.

=item conn_overrides

(Optional)
Hash reference to the list of connection overrides to be considered when
establishing the connection to the service.
Valid connection overrides are username, password, connid, conntype, ipaddress,
prompt_username and prompt_password.

=back

=item Returns

A reference to a new Mellanox Version object

=back

=cut
