#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::AppBuilder::EnGenX::FlashRay;

use strict;
use warnings;

use ParamsMgr;
use NATE::BaseException qw(:try);

use parent qw(NACL::AppBuilder::EnGenX::FlashRay::Setup
              NACL::AppBuilder::EnGenX::FlashRay::Cleanup
              NACL::AppBuilder::EnGenX::Util);

sub new {
    my ($class, %opts) = @_;
    my $self = \%opts;
    bless($self, $class);
    return $self;
}

sub load_resource {
    my ($self) = @_;

    # load any resources if necessary (probably doesn't need to be implemented)
}

sub xml_to_list {
    my ($self) = @_;

    # translate ParamsMgr XML datastructures into EnGenX Resources
    # See EnGenX::Client::xml_to_list() for examples

    my $flashrays = &ParamsMgr::search(
        search_path => [],
        key => "FR_CLUSTERS",
        $self->NACL::AppBuilder::EnGenX::Util::get_paramset());
    if (&ParamsMgr::error()) {
        NATE::BaseException->throw("Failed");
    }

    # register as resources

}

1;
