use strict;
use warnings;

package NACL::AppBuilder::EnGenX::UnitTest::VolumeCloneConfig;

use parent 'NACL::AppBuilder::Xgen::Config::ONTAP';

use NATE::Log qw(log_global);
use NACL::AppBuilder::Xgen::Resource::Volume::Clone;

sub build {
    my ($self, %args) = @_;

    log_global()->log("Generating parent resources");
    $self->SUPER::build(%args);

    log_global()->log("Generating Volume clones");
    $self->generate_volume_clone(%args);

}

sub generate_volume_clone {
    my ($self, %args) = @_;
    
    # add parent
    # get_resources nodes
    my $nodes = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Node");
    my $clone = NACL::AppBuilder::Xgen::Resource::Volume::Clone->new(
                                                                    vserver         => "vs0",
                                                                    flexclone       => "clone",
                                                                    'parent-volume' => "parent",
                                                                 );
    $clone->add_parent_resources(resources => [$nodes->[0]]);
    $self->add_resources(resources => [$clone]);
}

1;
