#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

my $scaling_factor = 4;
my $node_count     = 4;

package NACL::AppBuilder::Xgen::Config::STE::EQ::Kmeans_config;

use parent qw(NACL::AppBuilder::Xgen::Config::STE::EQ::Base_STE);

my $scaling_factor = 4;
my $node_count     = 4;

use constant SCALING_FACTOR => 4;

use constant TOTAL_VS_COUNT => 5; #2 * $scaling_factor;

use constant VS_NODAL_LAYOUT => {
    4 => 5

};

use constant TOTAL_IPV4_LIFS_PER_VS_PER_NODE_PER_FABRIC => 1; #2 * $scaling_factor;
use constant TOTAL_IPV6_LIFS_PER_VS_PER_NODE_PER_FABRIC => 1; #2 * $scaling_factor;

use constant TOTAL_VOLUME_COUNT     => 92; #38 * $scaling_factor * $node_count;
use constant VOL_SIZE               => '200g';
use constant VOL_EFFICIENCY_PERCENT => 100;
use constant VOL_AUTOSIZE_MODE                   => "off";

use constant TOTAL_QTREE_COUNT         => 180; #45 * $scaling_factor * $node_count;
use constant TOTAL_QTREE_HOMEDIR_COUNT => 0;

use constant TOTAL_CIFS_SHARE_COUNT => 69; #17 * $scaling_factor * $node_count;
use constant CIFS_SHARE_LAYOUT      => {
    qtree  => 50,
    volume => 50
};

use constant TOTAL_SNAPMIRROR_COUNT => 8; #3 * $scaling_factor * $node_count;
use constant SNAPMIRROR_LAYOUT      => {
    "vault"           => 13, #1 * $scaling_factor * $node_count,
    "data_protection" => 87 #2 * $scaling_factor * $node_count
};

use constant TOTAL_SYMLINK_COUNT => 0;

use constant TOTAL_QOS_POLICY_COUNT => 0;

use constant VSERVER_ROOT_VOLUME_SECURITY_LAYOUT => {
    unix  => 100
};

use constant SAN_VSERVERS_COUNT => 1;
use constant PERCENTAGE_OF_VOLUMES_WITH_LUNS => 100;
use constant TOTAL_LUN_COUNT => 8; #2 * $scaling_factor * $node_count;
use constant LUN_SIZE => "10g";

1;

__END__

=head1 NAME

PTEFIT::Xgen::Config::ONTAP::Cifs::ResiliencyHigh

=head1 AUTHOR/MAINTAINER

=over

=item PTEFIT AUTOMATION (ng-ptefit-automation-core@netapp.com)

=back

   Last revised $Date: $ by $Author: $

=cut
