#
# Copyright (c) 2014 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::AppBuilder::Xgen::Resource::FailoverGroup;

use strict;
use warnings;

use parent qw( NACL::Service::Xgen::Resource );

# Cannot use this since the CS class requires command_interface for this specific object type.
# use constant nacl_cs_class => 'NACL::CS::NetworkInterfaceFailoverGroups';

use Params::Validate qw(validate_with SCALAR ARRAYREF);
use NACL::Service::Xgen::Exceptions::InvalidAttribute;

sub _validate_private_attrs {
    my ($self, $args) = @_;

    eval {
        $args = validate_with(
            params => [%{$args}],
            spec => {
                'targets'           => {type => ARRAYREF, optional => 1},
                'node'              => {type => SCALAR, optional => 1},
                'port'              => {type => SCALAR, optional => 1},
                'vserver'           => {type => SCALAR},
                'failover-group'    => {type => SCALAR},
            });
    };
    if (my $err = $@) {
        NACL::Service::Xgen::Exceptions::InvalidAttribute->throw($err);
    }

    return $args;
}
1;

__END__

=head1 NAME

NACL::AppBuilder::Xgen::Resource::FailoverGroup

=head1 AUTHOR/MAINTAINER

=over

=item PTEFIT AUTOMATION (ng-ptefit-automation-core@netapp.com)

=back

   Last revised $Date: $ by $Author: $

=cut
