#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::AppBuilder::Xgen::Resource::Switch;

use strict;
use warnings;

use parent qw( NACL::Service::Xgen::Resource );

use Params::Validate qw(validate_with SCALAR ARRAYREF);
use NACL::Service::Xgen::Exceptions::InvalidAttribute;

sub _validate_private_attrs {
    my ($self, $args) = @_;

    eval {
        $args = validate_with(
            params => [%{$args}],
            spec => {
                name             => {type => SCALAR},
                admin_domain     => {type => SCALAR, default => ""}, 
                virtual_fabric   => {type => SCALAR, default => ""}, 
                fabric_id        => {type => SCALAR, default => ""}, 
                fabric_names     => {type => ARRAYREF, default => []}
            });
    };
    if (my $err = $@) {
        NACL::Service::Xgen::Exceptions::InvalidAttribute->throw($err);
    }

    return $args;
}

1;

__END__

=head1 NAME

NACL::AppBuilder::Xgen::Resource::Switch

=head1 AUTHOR/MAINTAINER

=over

=item PTEFIT AUTOMATION (dl-ptefit-automation-core@netapp.com)

=back

   Last revised $Date: $ by $Author: $

=cut
