# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary CapacityBalanceVolumeRebalance Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::CapacityBalanceVolumeRebalance

=head1 DESCRIPTION

C<NACL::C::CapacityBalanceVolumeRebalance> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP CapacityBalanceVolumeRebalance.  A related class is
L<NACL::CS::CapacityBalanceVolumeRebalance|lib-NACL-CS-CapacityBalanceVolumeRebalance-pm>, which represents
the past state of an ONTAP CapacityBalanceVolumeRebalance.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 volume

=head2 storage_service

=head2 vserver

=cut

package NACL::C::CapacityBalanceVolumeRebalance;

use strict;
use warnings;

use NACL::CS::CapacityBalanceVolumeRebalance;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $CapacityBalanceVolumeRebalance = NACL::C::CapacityBalanceVolumeRebalance->new(
                                   command_interface => $ci,
                                   'volume' => $volume,
                                   'storage-service' => $storage_service,
                                   'vserver' => $vserver,
                                  );

Return a new CapacityBalanceVolumeRebalance component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'volume',
    scalar => 'storage_service',
    scalar => 'vserver',
];

# "-" is a valid value for storage-service.
sub init {
    $Log->enter() if $may_enter;
    my ($self, %opts) = @_;

    # Might be hyphenated or underscored
    $opts{storage_service} ||= delete $opts{'storage-service'};

    my $was_hyphen;
    if (defined $opts{storage_service} && $opts{storage_service} eq '-') {
        $was_hyphen = 1;

        # Work around the check in the base class by temporarily setting
        # a dummy value.
        $opts{storage_service} = 'dummy';
    }

    $self->SUPER::init(%opts);
    $self->storage_service('-') if $was_hyphen;

    $self->_vserver_context_init(%opts);
    $Log->exit() if $may_exit;
}

=head2 find

    my $CapacityBalanceVolumeRebalance_obj  = NACL::C::CapacityBalanceVolumeRebalance->find(command_interface => $ci, ...);
    my @CapacityBalanceVolumeRebalance_objs = NACL::C::CapacityBalanceVolumeRebalance->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my CapacityBalanceVolumeRebalance_state = $CapacityBalanceVolumeRebalance_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::CapacityBalanceVolumeRebalance would return
a NACL::CS::CapacityBalanceVolumeRebalance object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 start

    my $CapacityBalanceVolumeRebalance_obj    = NACL::C::CapacityBalanceVolumeRebalance->start(
                                command_interface => $ci,
                                'volume' => $volume,
                                'storage-service' => $storage_service,
                                'vserver' => $vserver,
                                ...);

(Class method)
This method is used to start the Automated Rebalancer for an Infinite Volume.
Uses CMode CLI/ZAPI .
Invokes  volume-capacity-balance-start for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'volume' => $volume >>

(Required)
Volume Name

Applicable for CMode CLI

=item C<< 'storage-service' => $storage_service >>

(Required)
Storage Service

Applicable for CMode CLI

=item C<< 'vserver' => $vserver >>

(Required)
Vserver

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "capacity balance volume rebalance start" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub start {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params => \@args,
        api    => 'capacity_balance_volume_rebalance_start',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_start_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_start_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::CapacityBalanceVolumeRebalance::start',
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        volume            => $opts{'volume'},
        storage_service   => $opts{'storage-service'},
        vserver           => $vserver,
    );
    $Log->exit() if $may_exit;
    return $obj;
}

sub _start_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'capacity_balance_volume_rebalance_start',);
    $Log->exit() if $may_exit;
}

sub _start_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(storage-service)];
    my $map = {'volume' => 'volume-name',};
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'volume-capacity-balance-start',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 stop

    NACL::C::CapacityBalanceVolumeRebalance->stop(
                                command_interface => $ci,
                                'volume' => $volume,
                                'storage-service' => $storage_service,
                                'vserver' => $vserver,
                                ...);

                                 or

    $CapacityBalanceVolumeRebalance_obj->stop(...);

(Class or instance method)
This method is used to stop the Automated Rebalancer for an Infinite Volume.
Uses CMode CLI/ZAPI .
Invokes  volume-capacity-balance-stop for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'volume' => $volume >>

(Required for class method, Not Applicable for instance method)
Volume Name

Applicable for CMode CLI

=item C<< 'storage-service' => $storage_service >>

(Required for class method, Not Applicable for instance method)
Storage Service

Applicable for CMode CLI

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "capacity balance volume rebalance stop" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub stop {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        api    => 'capacity_balance_volume_rebalance_stop',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_stop_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_stop_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::CapacityBalanceVolumeRebalance::stop',
    );

    $Log->exit() if $may_exit;
}

sub _stop_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'capacity_balance_volume_rebalance_stop',);
    $Log->exit() if $may_exit;
}

sub _stop_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(storage-service)];
    my $map = {'volume' => 'volume-name',};
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'volume-capacity-balance-stop',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'volume'          => {type => SCALAR},
        'storage-service' => {type => SCALAR},
        'vserver'         => {type => SCALAR},
    );
}

1;
