#
# Copyright (c) 2012-13 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
#
## @summary Iscsi Target Component Module
## @author Vishwanath.Rawat@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here
################################################################################

=head1 NAME

NACL::C::Client::IscsiTarget

=head1 DESCRIPTION

C<NACL::C::Client::IscsiTarget> Is a derived class of
L<NACL::C::Component::Client|lib-NACL-C-Component-pm>. It represents target object accepted by methods of the NACL::C::Client::Iscsi component.

=head1 ATTRIBUTES

=head2 target_name

Iqn of the target node

=head2 address

Ip address of the discovered target node

=head2 ip_port

ISCSI Port used for discovery

Valid values are: open-iscsi, linuxiscsi

=head2 tpgroup_tag

Target portal group tag value of the discovered target node

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=cut

###################
# Package
package NACL::C::Client::IscsiTarget;

###################
use strict;
use warnings;

use Class::MethodMaker [
    new     => ['-hash','new'],
    scalar  => 'target_name',
    scalar  => 'address',
    scalar  => 'ip_port',
    scalar  => 'tpgroup_tag',
];

1;
