# Copyright (c) 2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Abstract base class for SOAP components
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::Component::SOAP

=head1 SYNOPSIS

    use base 'NACL::C::Component::SOAP';

=head1 DESCRIPTION

C<NACL::C::Component::SOAP> is an abstract base class for all
SOAP Component libraries.
It is derived from L<NACL::C::Component|lib-NACL-C-Component-pm>
and it provides SOAP specific component base class methods.

=head1 ATTRIBUTES

Command interfaces are constrained to be sub-classes of C<NACL::C::SOAPCommandInterface>.)

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::SOAPCommandInterface|lib-NACL-C-SOAPCommandInterface-pm>

=cut

package NACL::C::Component::SOAP;

use strict;
use warnings;
use base 'NACL::C::Component';

use Class::MethodMaker [
    scalar => [
        {-type => 'NACL::C::SOAPCommandInterface'},
        'command_interface'
    ],
];

1;
