# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Abstract base class for Switch components
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::Component::Switch

=head1 SYNOPSIS

    use base 'NACL::C::Component::Switch';

=head1 DESCRIPTION

NACL::C::Component::Switch is an abstract base class for all
Switch Component libraries.
It is derived from L<NACL::C::Component|lib-NACL-C-Component-pm>
and it provides Switch specific component base class methods.

=head1 ATTRIBUTES

Same as those of L<NACL::C::Component|lib-NACL-C-Component-pm/ATTRIBUTES>.
(command interfaces are constrained to be sub-classes of
C<NACL::C::Switch>.)

=cut

package NACL::C::Component::Switch;

use strict;
use warnings;
use base 'NACL::C::Component';
use NACL::C::Switch::Utils qw (_exit_config_modes_cisconetwork);

use Class::MethodMaker [
    scalar => [
        {   -type => 'NACL::C::Switch' },
        'command_interface'
    ],
];

1;
