# Copyright (c) 2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Abstract base class for VPserver components
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::Component::VPserver

=head1 SYNOPSIS

    use base 'NACL::C::Component::VPserver';

=head1 DESCRIPTION

C<NACL::C::Component::VPserver> is an abstract base class for all
VPserver Component libraries.
It is derived from L<NACL::C::Component|lib-NACL-C-Component-pm>
and it provides VPserver specific component base class methods.

=head1 ATTRIBUTES

Command interfaces are constrained to be sub-classes of C<NACL::C::VPserver>.)

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::VPserver|lib-NACL-C-VPserver-pm>

=head2 credential

>>>> ORIGINAL //depot/prod/DOT/dev/test/lib/NACL/C/Component/VPserver.pm#1
A VPserver credential object of type L<NATE::SOAP::Data>

==== THEIRS //depot/prod/DOT/dev/test/lib/NACL/C/Component/VPserver.pm#2
A VPserver credential object of type L<NATE::SOAP::Data|lib-NATE-SOAP-Data-pm>
==== YOURS //manpreek:burt_722046_set8_files_070136/test/lib/NACL/C/Component/VPserver.pm
A VPserver credential object of type L<NATE::SOAP::Data|nate-lib-NATE-SOAP-Data-pm>
<<<<
=cut

package NACL::C::Component::VPserver;

use strict;
use warnings;

use base 'NACL::C::Component::SOAP';
use NATE::SOAP::Data;
use NACL::APISet::Exceptions::InvalidParamValueException;

use Class::MethodMaker [
     scalar => [ {-type => 'NACL::C::VPserver' },
                 'command_interface'
     ],
];

1;
