# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCpsStorageArea Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugCpsStorageArea

=head1 DESCRIPTION

C<NACL::C::DebugCpsStorageArea> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugCpsStorageArea.  A related class is
L<NACL::CS::DebugCpsStorageArea|lib-NACL-CS-DebugCpsStorageArea-pm>, which represents
the past state of an ONTAP DebugCpsStorageArea.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 area

=cut

package NACL::C::DebugCpsStorageArea;

use strict;
use warnings;

use NACL::CS::DebugCpsStorageArea;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugCpsStorageArea = NACL::C::DebugCpsStorageArea->new(
                                   command_interface => $ci,
                                   'area' => $area,
								  );

Return a new DebugCpsStorageArea component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'area',];

=head2 find

    my $DebugCpsStorageArea_obj  = NACL::C::DebugCpsStorageArea->find(command_interface => $ci, ...);
	my @DebugCpsStorageArea_objs = NACL::C::DebugCpsStorageArea->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DebugCpsStorageArea_state = $DebugCpsStorageArea_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugCpsStorageArea would return 
a NACL::CS::DebugCpsStorageArea object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 force_problem

    NACL::C::DebugCpsStorageArea->force_problem(
                                command_interface => $ci,
	                            'area' => $area,
                                ...);
	                             
								 or

    $DebugCpsStorageArea_obj->force_problem(...);

(Class or instance method)
This method is used to force storage area problem.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'area' => $area >>

(Required for class method, Not Applicable for instance method)

Storage Area possible value(s) are, crs-scratch,crs-sender-queues,crs-receiver-queues
Applicable for CMode CLI

=item C<< 'relocation-reason' => $string >>

Relocation Reason
Applicable for CMode CLI

=item C<< 'error-code' => $string >>

Error Code
Applicable for CMode CLI

=item C<< 'client-id' => $string >>

Client Identifier
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug cps storage area force problem" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub force_problem {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( relocation-reason error-code

                    client-id
                    )
            ),
        },
        cli_cmd => 'debug cps storage-area force-problem',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_force_problem_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCpsStorageArea::force_problem',
    );

}

sub _force_problem_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_cps_storage_area_force_problem',);
    $Log->exit() if $may_exit;
}

=head2 report_problem

    NACL::C::DebugCpsStorageArea->report_problem(
                                command_interface => $ci,
	                            'area' => $area,
                                ...);
	                             
								 or

    $DebugCpsStorageArea_obj->report_problem(...);

(Class or instance method)
This method is used to report storage area problem.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'area' => $area >>

(Required for class method, Not Applicable for instance method)

Storage Area possible value(s) are, crs-scratch,crs-sender-queues,crs-receiver-queues
Applicable for CMode CLI

=item C<< 'epoch' => $string >>

Area Epoch
Applicable for CMode CLI

=item C<< 'path' => $string >>

Storage Area Path
Applicable for CMode CLI

=item C<< 'relocation-reason' => $string >>

Relocation Reason
Applicable for CMode CLI

=item C<< 'error-code' => $string >>

Error Code
Applicable for CMode CLI

=item C<< 'client-id' => $string >>

Client Identifier
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug cps storage area report problem" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub report_problem {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( epoch path relocation-reason error-code

                    client-id
                    )
            ),
        },
        cli_cmd => 'debug cps storage-area report-problem',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_report_problem_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCpsStorageArea::report_problem',
    );

}

sub _report_problem_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_cps_storage_area_report_problem',);
    $Log->exit() if $may_exit;
}

=head2 subscribe

    NACL::C::DebugCpsStorageArea->subscribe(
                                command_interface => $ci,
	                            'area' => $area,
                                ...);
	                             
								 or

    $DebugCpsStorageArea_obj->subscribe(...);

(Class or instance method)
This method is used to subscribe to storage area.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'area' => $area >>

(Required for class method, Not Applicable for instance method)

Storage Area possible value(s) are, crs-scratch,crs-sender-queues,crs-receiver-queues
Applicable for CMode CLI

=item C<< 'client-id' => $string >>

Client Identifier
Applicable for CMode CLI

=item C<< 'desire-changes' => $string >>

Client Desires Change Notifications possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug cps storage area subscribe" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub subscribe {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( client-id desire-changes
                    )
            ),
        },
        cli_cmd => 'debug cps storage-area subscribe',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_subscribe_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCpsStorageArea::subscribe',
    );

}

sub _subscribe_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_cps_storage_area_subscribe',);
    $Log->exit() if $may_exit;
}

=head2 unsubscribe

    NACL::C::DebugCpsStorageArea->unsubscribe(
                                command_interface => $ci,
	                            'area' => $area,
                                ...);
	                             
								 or

    $DebugCpsStorageArea_obj->unsubscribe(...);

(Class or instance method)
This method is used to unsubscribe from storage area.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'area' => $area >>

(Required for class method, Not Applicable for instance method)

Storage Area possible value(s) are, crs-scratch,crs-sender-queues,crs-receiver-queues
Applicable for CMode CLI

=item C<< 'client-id' => $string >>

Client Identifier
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug cps storage area unsubscribe" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub unsubscribe {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( client-id
                    )
            ),
        },
        cli_cmd => 'debug cps storage-area unsubscribe',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_unsubscribe_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCpsStorageArea::unsubscribe',
    );

}

sub _unsubscribe_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_cps_storage_area_unsubscribe',);
    $Log->exit() if $may_exit;
}

=head2 simulate_nvfail

    NACL::C::DebugCpsStorageArea->simulate_nvfail(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to simulate NVFAIL on storage.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'volume' => $string >>

Volume
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug cps storage area simulate nvfail" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub simulate_nvfail {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( volume
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'debug cps storage-area simulate-nvfail',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_simulate_nvfail_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCpsStorageArea::simulate_nvfail',
    );

    $Log->exit() if $may_exit;
}

sub _simulate_nvfail_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_cps_storage_area_simulate_nvfail',);
    $Log->exit() if $may_exit;
}

=head2 cleanse_areas

    NACL::C::DebugCpsStorageArea->cleanse_areas(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to cleanse storage areas.
Uses CMode CLI.


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'cleanse-reason' => $string >>

Cleanse Reason

Applicable for CMode CLI

=item C<< 'client-id' => $string >>

Client Identifier

Applicable for CMode CLI

=item C<< 'areas' => [ $area1, $area2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)


Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug cps storage area cleanse areas" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub cleanse_areas {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'areas' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( cleanse-reason client-id
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'debug cps storage-area cleanse-areas',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_cleanse_areas_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCpsStorageArea::cleanse_areas',
    );

    $Log->exit() if $may_exit;
}

sub _cleanse_areas_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_cps_storage_area_cleanse_areas',);
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('area' => {type => SCALAR},);
}

1;
