# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsDomain Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugCrsDomain

=head1 DESCRIPTION

C<NACL::C::DebugCrsDomain> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. 
Unlike other components this package does not model any element/service 
but is present to provide component-level support for functionality. 
Since it does not model any element/service there is no ComponentState 
module for this component. For the same reason, 'find' and 'state' will
not work for this component.
Instead NACL::CS::DebugCrsDomain->fetch() should be used.
(See L<fetch|lib-NACL-CS-ComponentState-pm/fetch> for a full description)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::DebugCrsDomain;

use strict;
use warnings;

use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugCrsDomain = NACL::C::DebugCrsDomain->new(
                                   command_interface => $ci,
								  );

Return a new DebugCrsDomain component object with the given attributes.

=cut

use Class::MethodMaker [];

=head2 show_objects

    my $show_objects_obj = NACL::C::DebugCrsDomain->show_objects(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_objects_objs = NACL::C::DebugCrsDomain->show_objects(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_objects_obj = $DebugCrsDomain_obj->show_objects(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCrsDomainShowObjects-pm/ATTRIBUTES>
of NACL::CS::DebugCrsDomainShowObjects as input. 
This method returns objects of the type L<NACL::CS::DebugCrsDomainShowObjects|lib-NACL-CS-DebugCrsDomainShowObjects-pm>.

=cut

sub show_objects {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCrsDomainShowObjects;
    my @state_objs = NACL::CS::DebugCrsDomainShowObjects->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_baseline_object_size

    my $show_baseline_object_size_obj = NACL::C::DebugCrsDomain->show_baseline_object_size(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_baseline_object_size_objs = NACL::C::DebugCrsDomain->show_baseline_object_size(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_baseline_object_size_obj = $DebugCrsDomain_obj->show_baseline_object_size(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCrsDomainShowBaselineObjectSize-pm/ATTRIBUTES>
of NACL::CS::DebugCrsDomainShowBaselineObjectSize as input. 
This method returns objects of the type L<NACL::CS::DebugCrsDomainShowBaselineObjectSize|lib-NACL-CS-DebugCrsDomainShowBaselineObjectSize-pm>.

=cut

sub show_baseline_object_size {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCrsDomainShowBaselineObjectSize;
    my @state_objs
        = NACL::CS::DebugCrsDomainShowBaselineObjectSize->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}


__PACKAGE__->_load_event_class();

1;
