# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsDomainInstance Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugCrsDomainInstance

=head1 DESCRIPTION

C<NACL::C::DebugCrsDomainInstance> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. 
Unlike other components this package does not model any element/service 
but is present to provide component-level support for functionality. 
Since it does not model any element/service there is no ComponentState 
module for this component. For the same reason, 'find' and 'state' will
not work for this component.
Instead NACL::CS::DebugCrsDomainInstance->fetch() should be used.
(See L<fetch|lib-NACL-CS-ComponentState-pm/fetch> for a full description)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::DebugCrsDomainInstance;

use strict;
use warnings;

use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugCrsDomainInstance = NACL::C::DebugCrsDomainInstance->new(
                                   command_interface => $ci,
								  );

Return a new DebugCrsDomainInstance component object with the given attributes.

=cut

use Class::MethodMaker [];

=head2 show_baseline_meta_info

    NACL::C::DebugCrsDomainInstance->show_baseline_meta_info(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to display meta information about the baseline.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'baseline-seq-num' => $string >>

Cluster Wide Baseline Sequence Number
Applicable for CMode CLI

=item C<< 'domain-instance-uuid' => $string >>

Domain Instance UUID
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs domain instance show baseline meta info" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub show_baseline_meta_info {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( baseline-seq-num

                    domain-instance-uuid
                    )
            ),
        },
        ignore_primary_keys => 1,
        api => 'debug_crs_domain_instance_show_baseline_meta_info',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_show_baseline_meta_info_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugCrsDomainInstance::show_baseline_meta_info',
    );

}

sub _show_baseline_meta_info_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_domain_instance_show_baseline_meta_info',);
    $Log->exit() if $may_exit;
}

=head2 show_baseline_per_domain_instance

    my $show_baseline_per_domain_instance_obj = NACL::C::DebugCrsDomainInstance->show_baseline_per_domain_instance(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_baseline_per_domain_instance_objs = NACL::C::DebugCrsDomainInstance->show_baseline_per_domain_instance(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_baseline_per_domain_instance_obj = $DebugCrsDomainInstance_obj->show_baseline_per_domain_instance(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCrsDomainInstanceShowBaselinePerDomainInstance-pm/ATTRIBUTES>
of NACL::CS::DebugCrsDomainInstanceShowBaselinePerDomainInstance as input. 
This method returns objects of the type L<NACL::CS::DebugCrsDomainInstanceShowBaselinePerDomainInstance|lib-NACL-CS-DebugCrsDomainInstanceShowBaselinePerDomainInstance-pm>.

=cut

sub show_baseline_per_domain_instance {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCrsDomainInstanceShowBaselinePerDomainInstance;
    my @state_objs
        = NACL::CS::DebugCrsDomainInstanceShowBaselinePerDomainInstance
        ->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 delete_local_baseline

    NACL::C::DebugCrsDomainInstance->delete_local_baseline(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to delete a local baseline using the provided sequence number.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'baseline-seq-num' => $string >>

Baseline Sequence Number
Applicable for CMode CLI

=item C<< 'domain-instance-uuid' => $string >>

Domain Instance UUID
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs domain instance delete local baseline" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete_local_baseline {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( baseline-seq-num domain-instance-uuid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'debug crs domain-instance delete-local-baseline',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_local_baseline_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCrsDomainInstance::delete_local_baseline',
    );

}

sub _delete_local_baseline_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_domain_instance_delete_local_baseline',);
    $Log->exit() if $may_exit;
}

=head2 generate_baseline

    NACL::C::DebugCrsDomainInstance->generate_baseline(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to generate a baseline for a domain instance.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'domain-instance-uuid' => $string >>

Domain Instance UUID
Applicable for CMode CLI

=item C<< 'streams' => [ $stream1, $stream2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs domain instance generate baseline" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub generate_baseline {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'streams' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( domain-instance-uuid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'debug crs domain-instance generate-baseline',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_generate_baseline_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCrsDomainInstance::generate_baseline',
    );

}

sub _generate_baseline_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_domain_instance_generate_baseline',);
    $Log->exit() if $may_exit;
}

=head2 generate_local_baseline

    NACL::C::DebugCrsDomainInstance->generate_local_baseline(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to generate a local baseline for a domain instance.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'domain' => $string >>

Replication Domain possible value(s) are, cluster,test,vserver
Applicable for CMode CLI

=item C<< 'baseline-seq-num' => $string >>

Baseline Sequence Number
Applicable for CMode CLI

=item C<< 'domain-instance-uuid' => $string >>

Domain Instance UUID
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs domain instance generate local baseline" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub generate_local_baseline {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( domain baseline-seq-num domain-instance-uuid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'debug crs domain-instance generate-local-baseline',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_generate_local_baseline_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugCrsDomainInstance::generate_local_baseline',
    );

}

sub _generate_local_baseline_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_domain_instance_generate_local_baseline',);
    $Log->exit() if $may_exit;
}

=head2 generate_marker

    NACL::C::DebugCrsDomainInstance->generate_marker(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to queue a marker message for a domain instance.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'domain-instance-uuid' => $string >>

Domain Instance UUID
Applicable for CMode CLI

=item C<< 'streams' => [ $stream1, $stream2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs domain instance generate marker" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub generate_marker {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'streams' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( domain-instance-uuid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'debug crs domain-instance generate-marker',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_generate_marker_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCrsDomainInstance::generate_marker',
    );

}

sub _generate_marker_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_domain_instance_generate_marker',);
    $Log->exit() if $may_exit;
}

=head2 generate_partial_local_baseline

    NACL::C::DebugCrsDomainInstance->generate_partial_local_baseline(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to generate a partial local baseline for a domain instance.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'domain' => $string >>

Replication Domain possible value(s) are, cluster,test,vserver
Applicable for CMode CLI

=item C<< 'baseline-seq-num' => $string >>

Baseline Sequence Number
Applicable for CMode CLI

=item C<< 'domain-instance-uuid' => $string >>

Domain Instance UUID
Applicable for CMode CLI

=item C<< 'objects' => [ $object1, $object2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs domain instance generate partial local baseline" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub generate_partial_local_baseline {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'objects' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( domain baseline-seq-num domain-instance-uuid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'debug crs domain-instance generate-partial-local-baseline',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_generate_partial_local_baseline_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugCrsDomainInstance::generate_partial_local_baseline',
    );

}

sub _generate_partial_local_baseline_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_domain_instance_generate_partial_local_baseline',);
    $Log->exit() if $may_exit;
}

=head2 is_baseline_in_progress

    NACL::C::DebugCrsDomainInstance->is_baseline_in_progress(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to display if a baseline is in progress for a domain instance.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'domain-instance-uuid' => $string >>

Domain Instance UUID
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs domain instance is baseline in progress" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub is_baseline_in_progress {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( domain-instance-uuid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'debug crs domain-instance is-baseline-in-progress',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_is_baseline_in_progress_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugCrsDomainInstance::is_baseline_in_progress',
    );

}

sub _is_baseline_in_progress_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_domain_instance_is_baseline_in_progress',);
    $Log->exit() if $may_exit;
}

=head2 process_baseline

    NACL::C::DebugCrsDomainInstance->process_baseline(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to process a local baseline using the provided sequence number.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'baseline-seq-num' => $string >>

Baseline Sequence Number
Applicable for CMode CLI

=item C<< 'domain-instance-uuid' => $string >>

Domain Instance UUID
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs domain instance process baseline" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub process_baseline {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( baseline-seq-num domain-instance-uuid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'debug crs domain-instance process-baseline',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_process_baseline_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCrsDomainInstance::process_baseline',
    );

}

sub _process_baseline_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_domain_instance_process_baseline',);
    $Log->exit() if $may_exit;
}

=head2 process_manual_update

    NACL::C::DebugCrsDomainInstance->process_manual_update(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to process Manual Update for a domain instance.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'domain-instance-uuid' => $string >>

Domain Instance UUID
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs domain instance process manual update" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub process_manual_update {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( domain-instance-uuid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'debug crs domain-instance process-manual-update',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_process_manual_update_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCrsDomainInstance::process_manual_update',
    );

}

sub _process_manual_update_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_domain_instance_process_manual_update',);
    $Log->exit() if $may_exit;
}

=head2 start_manual_update_collection

    NACL::C::DebugCrsDomainInstance->start_manual_update_collection(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to start Manual Update Collection for a domain instance.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'domain-instance-uuid' => $string >>

Domain Instance UUID
Applicable for CMode CLI

=item C<< 'objects' => [ $object1, $object2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs domain instance start manual update collection" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub start_manual_update_collection {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'objects' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( domain-instance-uuid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'debug crs domain-instance start-manual-update-collection',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_start_manual_update_collection_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugCrsDomainInstance::start_manual_update_collection',
    );

}

sub _start_manual_update_collection_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_domain_instance_start_manual_update_collection',);
    $Log->exit() if $may_exit;
}

=head2 stop_manual_update_collection

    NACL::C::DebugCrsDomainInstance->stop_manual_update_collection(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to stop Manual Update Collection for a domain instance.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'domain-instance-uuid' => $string >>

Domain Instance UUID
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs domain instance stop manual update collection" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub stop_manual_update_collection {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( domain-instance-uuid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'debug crs domain-instance stop-manual-update-collection',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_stop_manual_update_collection_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugCrsDomainInstance::stop_manual_update_collection',
    );

}

sub _stop_manual_update_collection_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_domain_instance_stop_manual_update_collection',);
    $Log->exit() if $may_exit;
}

__PACKAGE__->_load_event_class();

1;
