# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugNetworkRecovery Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugNetworkRecovery

=head1 DESCRIPTION

C<NACL::C::DebugNetworkRecovery> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugNetworkRecovery.  A related class is
L<NACL::CS::DebugNetworkRecovery|lib-NACL-CS-DebugNetworkRecovery-pm>, which represents
the past state of an ONTAP DebugNetworkRecovery.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 object_name

=head2 object_id

=head2 instance_id

=head2 action

=cut

package NACL::C::DebugNetworkRecovery;

use strict;
use warnings;

use NACL::CS::DebugNetworkRecovery;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugNetworkRecovery = NACL::C::DebugNetworkRecovery->new(
                                   command_interface => $ci,
                                   'object-name' => $object_name,
                                   'object-id' => $object_id,
                                   'instance-id' => $instance_id,
                                   'action' => $action,
								  );

Return a new DebugNetworkRecovery component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'object_name',
    scalar => 'object_id',
    scalar => 'instance_id',
    scalar => 'action',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, %args) = @_;
    $args{enable_value_check}=0;
    $self->SUPER::init(%args);
    $Log->exit() if $may_exit;
}


=head2 find

    my $DebugNetworkRecovery_obj  = NACL::C::DebugNetworkRecovery->find(command_interface => $ci, ...);
	my @DebugNetworkRecovery_objs = NACL::C::DebugNetworkRecovery->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DebugNetworkRecovery_state = $DebugNetworkRecovery_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugNetworkRecovery would return 
a NACL::CS::DebugNetworkRecovery object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 execute

    NACL::C::DebugNetworkRecovery->execute(
                                command_interface => $ci,
	                            'object-name' => $object_name,
	                            'object-id' => $object_id,
	                            'instance-id' => $instance_id,
	                            'action' => $action,
                                ...);
	                             
								 or

    $DebugNetworkRecovery_obj->execute(...);

(Class or instance method)
This method is used to execute the recovery action for a previously recorded failure..
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'object-name' => $object_name >>

(Required for class method, Not Applicable for instance method)
Object Name
Applicable for CMode CLI

=item C<< 'object-id' => $object_id >>

(Required for class method, Not Applicable for instance method)
Object Identifier
Applicable for CMode CLI

=item C<< 'instance-id' => $instance_id >>

(Required for class method, Not Applicable for instance method)
Instance Counter
Applicable for CMode CLI

=item C<< 'action' => $action >>

(Required for class method, Not Applicable for instance method)
Recovery Action
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug network recovery execute" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub execute {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'debug network recovery execute',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_execute_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugNetworkRecovery::execute',
    );

}

sub _execute_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_network_recovery_execute',);
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'object-name' => {type => SCALAR},
        'object-id'   => {type => SCALAR},
        'instance-id' => {type => SCALAR},
        'action'      => {type => SCALAR},
    );
}

1;
