#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugSmdbTrace Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugSmdbTrace

=head1 DESCRIPTION

C<NACL::C::DebugSmdbTrace> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugSmdbTrace.  A related class is
L<NACL::CS::DebugSmdbTrace|lib-NACL-CS-DebugSmdbTrace-pm>, which represents
the past state of an ONTAP DebugSmdbTrace.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 table

=head2 node

=head2 process

=cut

package NACL::C::DebugSmdbTrace;

use strict;
use warnings;

use NACL::CS::DebugSmdbTrace;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $DebugSmdbTrace = NACL::C::DebugSmdbTrace->new(
                                   command_interface => $ci,
                                   'table' => $table,
                                   'node' => $node,
                                   'process' => $process,
								  );

Return a new DebugSmdbTrace component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'table',
    scalar => 'node',
    scalar => 'process',
];

=head2 find

    my $DebugSmdbTrace  = NACL::C::DebugSmdbTrace->find(command_interface => $ci, ...);
	my @DebugSmdbTraces = NACL::C::DebugSmdbTrace->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my DebugSmdbTrace_state = $NACL::C::DebugSmdbTrace->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugSmdbTrace would return 
a NACL::CS::DebugSmdbTrace object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 modify

    NACL::C::DebugSmdbTrace->modify(
                                command_interface => $ci,
	                            'table' => $table,
	                            'node' => $node,
	                            'process' => $process,
                                ...);
	                             
								 or

    $DebugSmdbTrace_object->modify(...);

(Class or instance method)
This method is used to set SMDB table tracing.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'table' => $table >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'process' => $process >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'next-error' => $string >>

Applicable for CMode CLI.

=item C<< 'tracing' => $string >>

Applicable for CMode CLI.

=item C<< 'modify-error' => $string >>

Applicable for CMode CLI.

=item C<< 'remove-error' => $string >>

Applicable for CMode CLI.

=item C<< 'create-error' => $string >>

Applicable for CMode CLI.

=item C<< 'postop-error' => $string >>

Applicable for CMode CLI.

=item C<< 'nextseq-error' => $string >>

Applicable for CMode CLI.

=item C<< 'action' => $string >>

Applicable for CMode CLI.

=item C<< 'get-error' => $string >>

Applicable for CMode CLI.

=item C<< 'other-error' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'send-to' => $string >>

Applicable for CMode CLI.

=item C<< 'testmode-copy' => $string >>

copy normal for testmode possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< 'testmode' => $string >>

table test mode possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< 'testmode-local' => $string >>

force local access possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'smf-trace' => $string >>

SMF Iterator Tracing possible value(s) are, yes,no,auto
Applicable for CMode CLI

=item C<< 'trace-threshold' => $string >>

Trace Threshold (secs) ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'dsmf-max-in-int-prio' => $string >>

DSMF Max in Intermediate Priority Queue ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'dsmf-max-in-high-prio' => $string >>

SMF Max in High Priority Queue ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'dsmf-max-active-thresh' => $string >>

DSMF Max Active Threshold ranges from 0 to 255
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"debug smdb trace modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( next-error tracing modify-error remove-error create-error postop-error
                    nextseq-error action get-error other-error

                    send-to

                    testmode-copy testmode testmode-local

                    smf-trace trace-threshold

                    dsmf-max-in-int-prio dsmf-max-in-high-prio dsmf-max-active-thresh
                    )
            ),
        },
        cli_cmd => 'debug smdb trace modify',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugSmdbTrace::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_smdb_trace_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

=head2 create

    my $DebugSmdbTrace_object	= NACL::C::DebugSmdbTrace->create(
                                command_interface => $ci,
	                            'table' => $table,
	                            'node' => $node,
	                            'process' => $process,
                                ...);

(Class method)
This method is used to enable SMDB table tracing.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'table' => $table >>

(Required)

Applicable for CMode CLI.

=item C<< 'node' => $node >>

(Required)

Applicable for CMode CLI.

=item C<< 'process' => $process >>

(Required)

Applicable for CMode CLI.

=item C<< 'next-error' => $string >>

Applicable for CMode CLI.

=item C<< 'tracing' => $string >>

Applicable for CMode CLI.

=item C<< 'modify-error' => $string >>

Applicable for CMode CLI.

=item C<< 'remove-error' => $string >>

Applicable for CMode CLI.

=item C<< 'create-error' => $string >>

Applicable for CMode CLI.

=item C<< 'postop-error' => $string >>

Applicable for CMode CLI.

=item C<< 'nextseq-error' => $string >>

Applicable for CMode CLI.

=item C<< 'action' => $string >>

Applicable for CMode CLI.

=item C<< 'get-error' => $string >>

Applicable for CMode CLI.

=item C<< 'other-error' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'send-to' => $string >>

Applicable for CMode CLI.

=item C<< 'testmode-copy' => $string >>

copy normal for testmode possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< 'testmode' => $string >>

table test mode possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< 'testmode-local' => $string >>

force local access possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'smf-trace' => $string >>

SMF Iterator Tracing possible value(s) are, yes,no,auto
Applicable for CMode CLI

=item C<< 'trace-threshold' => $string >>

Trace Threshold (secs) ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'dsmf-max-in-int-prio' => $string >>

DSMF Max in Intermediate Priority Queue ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'dsmf-max-in-high-prio' => $string >>

SMF Max in High Priority Queue ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'dsmf-max-active-thresh' => $string >>

DSMF Max Active Threshold ranges from 0 to 255
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"debug smdb trace create" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( next-error tracing modify-error remove-error create-error postop-error
                    nextseq-error action get-error other-error

                    send-to

                    testmode-copy testmode testmode-local

                    smf-trace trace-threshold

                    dsmf-max-in-int-prio dsmf-max-in-high-prio dsmf-max-active-thresh
                    )
            ),
        },
        cli_cmd => 'debug smdb trace create',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugSmdbTrace::create',
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        table             => $opts{'table'},
        node              => $opts{'node'},
        process           => $opts{'process'},
    );
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts, api => 'debug_smdb_trace_create',);
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_cli

=head2 delete

    NACL::C::DebugSmdbTrace->delete(
                                command_interface => $ci,
	                            'table' => $table,
	                            'node' => $node,
	                            'process' => $process,
                                ...);
	                             
								 or

    $DebugSmdbTrace_object->delete(...);

(Class or instance method)
This method is used to disable SMDB table tracing.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'table' => $table >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'process' => $process >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"debug smdb trace delete" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'debug smdb trace delete',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugSmdbTrace::delete',
    );

    $Log->exit() if $may_exit;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_smdb_trace_delete',);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'table'   => {type => SCALAR},
        'node'    => {type => SCALAR},
        'process' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
