#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DiagSecdNameMapping Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DiagSecdNameMapping

=head1 DESCRIPTION

C<NACL::C::DiagSecdNameMapping> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DiagSecdNameMapping.  A related class is
L<NACL::CS::DiagSecdNameMapping|lib-NACL-CS-DiagSecdNameMapping-pm>, which represents
the past state of an ONTAP DiagSecdNameMapping.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 direction

=head2 vserver

=head2 name

=head2 node

=cut

package NACL::C::DiagSecdNameMapping;

use strict;
use warnings;

use NACL::CS::DiagSecdNameMapping;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $DiagSecdNameMapping = NACL::C::DiagSecdNameMapping->new(command_interface=>$ci,
                                   direction =>$direction,
                                   vserver =>$vserver,
                                   name =>$name,
                                   node =>$node,
								  );

Return a new DiagSecdNameMapping component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'direction',
    scalar => 'vserver',
    scalar => 'name',
    scalar => 'node',
];

=head2 find

    my $DiagSecdNameMapping  = NACL::C::DiagSecdNameMapping->find(command_interface => $ci, ...);
	my @DiagSecdNameMappings = NACL::C::DiagSecdNameMapping->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $DiagSecdNameMapping_state = $NACL::C::DiagSecdNameMapping->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DiagSecdNameMapping would return 
a NACL::CS::DiagSecdNameMapping object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'direction' => {type => SCALAR},
        'vserver'   => {type => SCALAR},
        'name'      => {type => SCALAR},
        'node'      => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
