# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
# VMware® End User License Agreement

# VMware, Inc. (“VMware”) provides the vSphere Command-Line Interface (vSphere CLI) 
# and/or vSphere Software Development Kit for Perl (vSphere SDK for Perl) (collectively 
# the “Software”) to you subject to the following terms and conditions.  If you 
# disagree with any of the following terms, then do not use the Software.

# 1.  The Software contains a variety of materials, interface definitions, documentation, 
# sample utility applications and sample code regarding programming interfaces to one or 
# more VMware products as referenced in such materials (“VMware Products”).  This Software 
# is intended to be used to execute supplied commands and utility applications and to 
# create scripts that interact with the VMware Products. 

# 2.  Use Rights:  Subject to the restrictions below, you may download and make a 
# reasonable number of copies of the Software contents for your use solely for the purpose
# of creating software that communicates with VMware Products (“Developer Software”).  For
# vSphere SDK for Perl, some code may be designated as “distributable code” and/or
# “modifiable code” at http://www.vmware.com/go/vsdkperl-redistribution-info.  For vSphere
# CLI, some code may be designated as “distributable code” and/ or “modifiable code” at
# http://www.vmware.com/go/vcli-redistribution-info.  You may use and merge all or portions
# of the “distributable code” with your Developer Software.  Any merged portion of any 
# “distributable code” is subject to this Agreement.  Additionally, you may modify or create
# derivative works of all or portions of the “modifiable code.”  You are permitted to
# re-distribute the “distributable code” and the modified or derivative works of the 
# “modifiable code” only as part of your Developer Software for non-commercial or commercial 
# use. Open source software components provided with the Software are licensed to you under
# the terms of the applicable license agreements included with such open source software
# components.  The open source software licenses can be found in the open_source_licenses.txt
# file, other materials accompanying the Software, the documentation or corresponding source
# files available at http://www.vmware.com/download/vi/open_source.html.

# 3.  Restrictions:  You agree that you will not (1) use the Software to create, design or
# develop anything other than Developer Software; (2) make any more copies of the Software
# than are reasonably necessary for the authorized use and backup and archival purposes;
# (3) modify, create derivative works of, reverse engineer, reverse compile, or disassemble
# the Software, except as expressly permitted in Section 2; (4) distribute, sell, lease, rent,
# lend, or sublicense any part of the Software to any third party except as expressly permitted
# in Section 2 or; (5) use the Software to (a) create, design or develop software or service to
# circumvent, enable, modify or provide access, permissions or rights which would violate the
# technical restrictions of VMware Products, any additional licensing terms provided by VMware
# via product documentation, email notification and/or policy change on VMware website, and/or
# the terms of the End User License Agreements of VMware products; (b) disable, remove, over-ride
# or modify the display of any VMware product End User License Agreements to the end customers;
# and (c) upload or otherwise transmit any material containing software viruses or other computer
# code, files or programs designed to interrupt, destroy, or limit the functionality of any
# software or hardware.  

# The restrictions in this Section 3 shall not apply if and to the extent they contradict
# mandatory local law (including, but not limited to, law implementing the EC Software Directive)
# provided that, before you exercise any rights that you believe to be entitled to based on
# mandatory law, you provide VMware with 30 days prior written notice at SDK_Legal@vmware.com and
# provide all reasonably requested information to allow VMware to assess your claim and, at
# VMware’s sole discretion, to provide alternatives that reduce any adverse impact on VMware’s
# intellectual property or other rights.  

# 4.   VMware retains ownership of the Software, including without limitation all copyrights and
# other intellectual property rights therein. You may not remove, delete or modify any of VMware
# copyright statements in the Software.

# 5.  You may not use VMware’s name, trademarks or service marks in your Developer Software’s
# names or in a way that suggests your Developer Software is certified or endorsed by VMware. Your
# use of VMware product names and trademarks shall comply with the Branding Guidelines posted at
# www.vmware.com. 

# 6.  If you are currently entitled to support from VMware, you may submit a support request
# for installation assistance of this Software and assistance in executing unmodified utility
# applications or vSphere CLI commands provided with this Software.  Except as provided herein,
# you are not entitled to any VMware support for this Software or any other services from VMware
# in connection with this Software or your Developer Software.  

# 7.  Term, Termination and Changes: This Agreement shall continue as long as you are in compliance
# with the terms specified herein or until otherwise terminated.  You and or VMware each may
# terminate this Agreement for any reason at any time.  You agree, upon termination, to destroy
# all copies of the Software within your possession or control. The Confidential Information,
# Limitations of Warranties, Liability and Indemnification sections set out in this Agreement
# shall survive any termination or expiration of this Agreement. 

# 8.  Limitations of Warranties and Liability:  THE SOFTWARE IS PROVIDED “AS IS” WITHOUT ANY
# WARRANTIES OF ANY KIND.  TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, VMWARE DISCLAIMS
# ANY IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT OF INTELLECTUAL PROPERTY RIGHTS.

# TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT WILL VMWARE BE LIABLE FOR ANY
# LOST PROFITS OR BUSINESS OPPORTUNITIES, LOSS OF USE, BUSINESS INTERRUPTION, LOSS OF DATA, OR ANY
# OTHER INDIRECT, SPECIAL, INCIDENTAL, OR CONSE¬QUEN¬TIAL DAMAGES ARISING OUT OF THE SOFTWARE OR
# YOUR USE OF THE SOFTWARE, UNDER ANY THEORY OF LIABILITY, WHETHER BASED IN CONTRACT, TORT,
# NEGLIGENCE, PRODUCT LIABILITY, OR OTHERWISE.  BECAUSE SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION
# OR LIMITATION OF LIABILITY FOR CONSEQUENTIAL OR INCIDENTAL DAMAGES, THE PRECEDING LIMITATION MAY
# NOT APPLY TO YOU.

# VMWARE’S LIABILITY ARISING OUT OF THE SOFTWARE PROVIDED HEREUNDER WILL NOT, IN ANY EVENT,
# EXCEED US$5.00.

# THE FOREGOING LIMITATIONS SHALL APPLY TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, REGARDLESS
# OF WHETHER VMWARE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES AND REGARDLESS OF WHETHER
# ANY REMEDY FAILS OF ITS ESSENTIAL PURPOSE.

# 9.  Indemnification: You agree to defend, indemnify and hold harmless VMware, and any of its
# directors, officers, employees, affiliates or agents, from and against any and all claims, losses,
# damages, liabilities and other expenses (including reasonable attorneys’ fees), arising from your
# modification or derivative works of the “modifiable code”, distribution or use of your Developer
# Software or breach of this Agreement.

# 10.  These terms are governed by the laws of the State of California and the United States of
# America without regard to conflict of laws principles.  You may not assign any part of this Agreement
# without the prior written consent of VMware.  Any attempted assignment without consent shall be void.
# These terms constitute the entire agreement between you and VMware with respect to the Software, and
# supersede all prior written or oral communications, understandings and agreements. Any waiver of these
# terms must be in writing to be effective. If any provision of these terms is found to be invalid or
# unenforceable, the remaining terms will continue to be valid and enforceable to the fullest extent
# permitted by law.

## @summary ESX/VSwitch Component Module
## @author bkprasha@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::ESX::VSwitch

=head1 DESCRIPTION

C<NACL::C::ESX::VSwitch> is a derived class of
L<NACL::C::Component|lib-NACL-C-Component-pm>.  It represents access
to the Virtual Switch managed object reference of an ESX Server.  
A related class isL<NACL::CS::ESX::VSwitch|lib-NACL-CS-ESX-VSwitch-pm>, 
which represents the state of Virtual Switches on the given ESX Server.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vswitchName

The name of the virtual switch, used to identify it uniquely.  (Virtual Switch
names are assumed to be unique within a given ESX Server)

=cut

package NACL::C::ESX::VSwitch;

use strict;
use warnings;
use Params::Validate qw(validate_with validate SCALAR );
use NATE::BaseException qw(:try);

use NACL::CS::ESX::VSwitch;
use NACL::ComponentUtils qw(_optional_scalars Dumper);
use base 'NACL::C::Component';
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

require VMware::VICommon;
require VMware::VIMRuntime;
require VMware::VIM25Stub;

=head1 METHODS

=head2 new

  my $vswitch_obj = NACL::C::ESX::VSwitch->new(command_interface=>$ci,
                                          vswitchName => $vswitch_name,
                                          );

Return a new ESX::VSwitch component object with the given attributes.

=cut

use Class::MethodMaker [
    new    => [ '-hash', '-init', 'new' ],
    scalar => 'vswitchName',
    scalar => [ { -type => 'NACL::C::ESX::ESXHost' }, 'command_interface', ],
];

=head2 add

  my $vswitch  = NACL::C::ESX::VSwitch->add(command_interface=>$ci,vswitchName =>$vswitch_name,
                                      numPorts => $num_ports);
									  
  $vswitch_obj->add(numPorts => $num_ports);

(Class or Instance method) Request addition of a new VSwitch element, and  return a new
VSwitch component object that refers to it. 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< vswitchName=> $string >>

(Required) Name of virtual switch.

=item C<< numPorts=>$num >>

(Required) Number of ports to be included to the switch to be added

=back

=back

=cut

sub add {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with(
        params          => \@_,
        additional_spec => { numPorts => { type => SCALAR, optional => 1 }, },
    );

    my $ret =
      $pkg->call_on_apiset( %opts,
        choices => [ { method => '_add_virtual_switch', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 delete
	
  NACL::C::ESX::VSwitch->delete(command_interface=>$ci,vswitchName =>$vswitch_name);
  
  $vswitch_obj->delete();

(Class or Instance method) Request deletion of a new VSwitch element, and  return a new
VSwitch component object that refers to it. 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< vswitchName=> $string >>

(Required) Name of virtual switch.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_frontend_log_debug_opts(@_);
    my %opts = $pkg_or_obj->_common_validate_with( params => \@_, );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
        choices => [ { method => '_delete_virtual_switch', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 add_pnic
	
  NACL::C::ESX::VSwitch->add_pnic(
						command_interface => $ci,
						vswitchName 	  => $vswitch_name,
						pnic			  => $pnic,
					);
  
  $vswitch_obj->add_pnic(pnic => $pnic);

(Class or Instance method) Request addition of an existing pnic element 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< vswitchName=> $string >>

(Required) Name of virtual switch.

=item C<< pnic=> $string >>

(Required) Name of pnic.

=back

=back

=cut

sub add_pnic {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_frontend_log_debug_opts(@_);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@_,
        additional_spec => { pnic => { type => SCALAR }, },
    );

    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        add => 1,
        choices => [ { method => '_update_uplink', }, ],
    );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 delete_pnic
	
  NACL::C::ESX::VSwitch->delete_pnic(
						command_interface => $ci,
						vswitchName 	  => $vswitch_name,
						pnic			  => $pnic,
					);
  
  $vswitch_obj->delete_pnic(pnic => $pnic);

(Class or Instance method) Request deleting an existing pnic element. 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< vswitchName=> $string >>

(Required) Name of virtual switch.

=item C<< pnic=> $string >>

(Required) Name of pnic.

=back

=back

=cut

sub delete_pnic {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_frontend_log_debug_opts(@_);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@_,
        additional_spec => { pnic => { type => SCALAR }, },
    );

    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        add => 0,
        choices => [ { method => '_update_uplink', }, ],
    );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 add_port_group
	
  NACL::C::ESX::VSwitch->add_port_group(
						command_interface => $ci,
						vswitchName       => $vswitchName,
						portgroup_name	  => $portgroup_name,
						vlanId	          => $vlanId,
					);
  
  $vswitch_obj->add_port_group(
					portgroup_name	  => $portgroup_name,
					vlanId	          => $vlanId,
				);

(Class or Instance method) Request addition of a portgroup to a virtual switch 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< vswitchName=> $string >>

(Required) Name of virtual switch.

=item C<< portgroup_name=> $string >>

(Required) Name of the port group to be added.

=item C<< vlanId=> $num >>

(Optional) Vlan Id to associte the port group being added.  Valid Vlan Id range 
is 0-4095

=back

=back

=cut

sub add_port_group {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_frontend_log_debug_opts(@_);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@_,
        additional_spec => {
            portgroup_name => { type => SCALAR },
            vlanId         => { type => SCALAR, default => 0 },
        },
    );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
        choices => [ { method => '_add_pg_to_vswitch', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 remove_port_group
	
  NACL::C::ESX::VSwitch->remove_port_group(
						command_interface => $ci,
						vswitchName       => $vswitchName,
						portgroup_name	  => $portgroup_name,
					);
  
  $vswitch_obj->remove_port_group(
					portgroup_name	  => $portgroup_name,
				);

(Class or Instance method) Request removal of a portgroup from the virtual switch

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< vswitchName=> $string >>

(Required) Name of virtual switch.

=item C<< portgroup_name=> $string >>

(Required) Name of the port group to be added.

=back

=back

=cut

sub remove_port_group {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_frontend_log_debug_opts(@_);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@_,
        additional_spec => { portgroup_name => { type => SCALAR }, },
    );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
        choices => [ { method => '_remove_pg_from_vswitch', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 add_vlan
	
  NACL::C::ESX::VSwitch->add_vlan(
						command_interface => $ci,
						vswitchName       => $vswitchName,
						portgroup_name	  => $portgroup_name,
						vlanId			  => $vlanId
					);
  
  $vswitch_obj->add_vlan(
					portgroup_name	  => $portgroup_name,
					vlanId			  => $vlanId
				);

(Class or Instance method) Request adding a vlan id to a portgroup 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< vswitchName=> $string >>

(Required) Name of virtual switch.

=item C<< portgroup_name=> $string >>

(Required) Name of the port group to be added.

=item C<< vlanId=> $number >>

(Required) Vlan Id to associte the port group.  Valid Vlan Id range is 1-4095

=back

=back

=cut

sub add_vlan {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_frontend_log_debug_opts(@_);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@_,
        additional_spec => {
            portgroup_name => { type => SCALAR },
            vlanId         => { type => SCALAR },
        },
    );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
        choices => [ { method => '_update_port_group_vlan', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 delete_vlan
	
  NACL::C::ESX::VSwitch->delete_vlan(
						command_interface => $ci,
						vswitchName       => $vswitchName,
						portgroup_name	  => $portgroup_name,
					);
  
  $vswitch_obj->delete_vlan(
					portgroup_name	  => $portgroup_name,
				);

(Class or Instance method) Request deleting the vlan id from the portgroup 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< vswitchName=> $string >>

(Required) Name of virtual switch.

=item C<< portgroup_name=> $string >>

(Required) Name of the port group to be added.

=back

=back

=cut

sub delete_vlan {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_frontend_log_debug_opts(@_);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@_,
        additional_spec => { portgroup_name => { type => SCALAR }, },
    );

    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        vlanId  => 0,
        choices => [ { method => '_update_port_group_vlan', }, ],
    );

    $Log->exit() if $may_exit;
    return $ret;
}

sub _add_virtual_switch {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $networksystem     = $command_interface->networksystem();

    if ( defined( $opts{numPorts} ) ) {
        my $hostVirtualSwitchSpec =
          HostVirtualSwitchSpec->new( numPorts => $opts{numPorts} );

        $networksystem->AddVirtualSwitch(
            'vswitchName' => $opts{'vswitchName'},
            'spec'        => $hostVirtualSwitchSpec
        );
    }
    else {
        $networksystem->AddVirtualSwitch( 'vswitchName' => $opts{'vswitchName'},
        );
    }

    $Log->exit() if $may_exit;

    return $pkg->new(
        vswitchName       => $opts{'vswitchName'},
        command_interface => $command_interface
    );
}

sub _delete_virtual_switch {
    my $pkg_or_obj        = shift;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $networksystem     = $command_interface->networksystem();

    $networksystem->RemoveVirtualSwitch(
        'vswitchName' => $opts{'vswitchName'} );

    return;
}

sub _update_uplink {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $networksystem     = $command_interface->networksystem();
    my $vswitchName       = $opts{'vswitchName'};
    my $pnic              = $opts{'pnic'};
    my $add               = $opts{'add'};

    my $vs = _find_vswitch_by_name( $networksystem, $vswitchName );
    unless ( defined( $vs->spec->bridge ) ) {
        if ($add) {
            $vs->{spec}->{bridge} = HostVirtualSwitchBondBridge->new();
        }
    }

    my $bridge = $vs->spec->bridge;
    delete $vs->{spec}->{policy};
    if ( $bridge->isa('HostVirtualSwitchBondBridge') ) {
        if ($add) {
            push( @{ $bridge->{nicDevice} }, $pnic );
        }
        else {
            my $size = @{ $bridge->{nicDevice} };
            for ( my $i = 0 ; $i < $size ; $i++ ) {
                if ( $bridge->{nicDevice}->[$i] eq "$pnic" ) {
                    splice( @{ $bridge->{nicDevice} }, $i, 0 );
                    last;
                }
            }

            if (   ( @{ $bridge->{nicDevice} } == 1 )
                && ( $bridge->{nicDevice}->[0] eq $pnic ) )
            {
                delete $vs->{spec}->{bridge};
            }
        }
    }
    elsif ( $bridge->isa('HostVirtualSwitchSimpleBridge') ) {
        if ($add) {
            $bridge->{nicDevice} = $pnic;
        }
        else {
            $bridge->{nicDevice} = undef;
        }
    }

    $networksystem->UpdateVirtualSwitch(
        vswitchName => $vswitchName,
        spec        => $vs->spec
    );
}

sub _add_pg_to_vswitch {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $networksystem     = $command_interface->networksystem();
    my $vlanId            = $opts{vlanId};

    #vlan valid range is 0-4095
    my $hostNetPolicy = HostNetworkPolicy->new();
    my $hostPGSpec    = HostPortGroupSpec->new(
        name        => $opts{portgroup_name},
        policy      => $hostNetPolicy,
        vlanId      => $vlanId,
        vswitchName => $opts{vswitchName}
    );
    $networksystem->AddPortGroup(
        _this   => $networksystem,
        portgrp => $hostPGSpec
    );

    $Log->exit() if $may_exit;

}

sub _remove_pg_from_vswitch {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $networksystem     = $command_interface->networksystem();

    $networksystem->RemovePortGroup( pgName => $opts{portgroup_name} );

    $Log->exit() if $may_exit;
}

sub _update_port_group_vlan {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $networksystem     = $command_interface->networksystem();

    my $pg =
      _find_portgroup_by_name( $networksystem, $opts{vswitchName},
        $opts{portgroup_name} );

    my $hostPGSpec = HostPortGroupSpec->new(
        name        => $opts{portgroup_name},
        policy      => $pg->spec->policy,
        vlanId      => $opts{vlanId},
        vswitchName => $opts{vswitchName}
    );

    $networksystem->UpdatePortGroup(
        pgName  => $opts{portgroup_name},
        portgrp => $hostPGSpec
    );

    $Log->exit() if $may_exit;
}

sub _find_vswitch_by_name {
    $Log->enter() if $may_enter;
    my ( $networksystem, $name ) = @_;
    my $vSwitches = $networksystem->networkInfo->vswitch;
    foreach my $vSwitch (@$vSwitches) {
        if ( $name eq $vSwitch->name ) {
            $Log->exit() if $may_exit;
            return $vSwitch;
        }
    }
    $Log->exit() if $may_exit;
    NATE::BaseException->throw( "No such virtual switch: " . $name );

}

sub _find_portgroup_by_name {
    $Log->enter() if $may_enter;
    my ( $network, $vSwitch, $pgName ) = @_;
    my $name       = $vSwitch;
    my $portGroups = $network->networkInfo->portgroup;

    foreach my $pg (@$portGroups) {
        my $spec = $pg->spec;
        if (   ( $spec->vswitchName eq $vSwitch )
            && ( $spec->name eq $pgName ) )
        {
            $Log->exit() if $may_exit;
            return $pg;
        }
    }
    $Log->exit() if $may_exit;
    NATE::BaseException->throw(
        "Port Group $pgName}" . " on VSwitch $vSwitch is not found" );
}

sub _primary_keys_validate_spec {
    return (
        vswitchName => { type => SCALAR },

    );
} ## end sub _primary_keys_validate_spec
1;
