#
# Copyright (c) 2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Ehash Component Module
## @author jabhijit@netapp.com,dl-metawafl-qa@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::Ehash

=head1 DESCRIPTION

C<NACL::C::Ehash> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to metawafl nodescope 'mw teh stats' command. A related class is
L<NACL::CS::EhashStats|lib-NACL-CS-EhashStats-pm>, which
represents the current state of metawafl Ehash.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

=cut

package NACL::C::Ehash;

use strict;
use warnings;

use base 'NACL::C::Component::ONTAP';

use Params::Validate qw(validate);
use Tharn qw($Log);

__PACKAGE__->_nodescope_builder( command => 'mw_teh_init',   method => 'init' );
__PACKAGE__->_nodescope_builder( command => 'mw_teh_insert', method => 'insert' );
__PACKAGE__->_nodescope_builder( command => 'mw_teh_lookup', method => 'lookup' );
__PACKAGE__->_nodescope_builder( command => 'mw_teh_delete', method => 'delete' );

__PACKAGE__->_cs_call_method_builder(method => 'stats');

1;
