#
# Copyright (c) 2015 NetApp Inc.
# All rights reserved.
#
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::Client::UserGroup::UserGroupException

=head1 DESCRIPTION

This exception is thrown when we attempt to create an already
existing directory.

=head1 EXAMPLE

   use NACL::C::Exceptions::Client::UserGroup::UserGroupException qw(:try);

   try {
       my $dir_obj = NACL::C::Client::UserGroup->add(name => $Name);
   } catch NACL::C::Exceptions::Client::UserGroup::UserGroupException {
        # Duplicate entry exists
   };

=cut

package NACL::C::Exceptions::Client::UserGroup::UserGroupException;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::C::Exceptions::Component
    NATE::BaseException
);

sub detect {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(@args,
        regexes =>
            [qr/(not a valid group name|exists|not exist|not a unique name)/i]);
    $Log->exit() if $may_exit;
    return $detected;
} ## end sub detect

1;
