#
# Copyright (c) 2017 NetApp Inc.
# All rights reserved.
#
## @summary An exception can be thrown during software image upgrade.
##          relationship.
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::ClusterImage::VerifySignaturesImage;

=head1 DESCRIPTION

This exception is thrown when an attempt is made to upgrade software image.

=head1 EXAMPLE

   use NACL::C::Exceptions::ClusterImage::VerifySignaturesImage;;

   try {
       NACL::C::ClusterImage->update(%opts);
   } catch NACL::C::Exceptions::ClusterImage::VerifySignaturesImage;{};

=cut

package NACL::C::Exceptions::ClusterImage::VerifySignaturesImage;

use base qw(
    NACL::C::Exceptions::Component
    NACL::APISet::Exceptions::CommandFailedException
);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

sub detect {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [
            qr/Install Failed.*Failed to verify the signatures of the image/i
        ],
    );
    $Log->exit() if $may_exit;
    return $detected;
} ## end sub detect

1;
