# $Id: //depot/prod/test/main/lib/NACL/C/Exceptions/DFM/Alert/DoesNotExist.pm$
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception for when a Alert destroy operation is performed on an
##          alert that does not exist.
##
## @author revathi@netapp.com, dl-mpo-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::DFM::Alert::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when alert destroy operation is performed on a
alert that does not exist.

=head1 EXAMPLE

   use NACL::C::Exceptions::DFM::Alert::DoesNotExist qw(:try);

   try {
       $non_existing_alert_obj->destroy();
   } catch NACL::C::Exceptions::DFM::Alert::DoesNotExist with {
        # Alert does not exist
   };

=cut

package NACL::C::Exceptions::DFM::Alert::DoesNotExist;

use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::APISet::Exceptions::InvalidParamValueException
);

1;
