# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/DFM/Eventclass/AlreadyExists.pm$
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception for when a Eventclass add operation is performed on an
##          eventclass that already exists.
##
## @author ramyar@netapp.com, dl-mpo-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::DFM::Eventclass::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when eventclass add operation is performed on an
eventclass that already exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::DFM::Eventclass:: qw(:try);

   try {
       $already_existing_eventclass_obj->add_custom(event_class_name => $already_existing_eventclass, event_namespace_name =>$already_existing_event_namespace, %other_opts);
   } catch NACL::C::Exceptions::DFM::Eventclass::AlreadyExists with {
        # Eventclass already exists
   };

=cut

package NACL::C::Exceptions::DFM::Eventclass::AlreadyExists;

use base qw(
    NACL::APISet::Exceptions::ResponseException
    NACL::C::Exceptions::AlreadyExists
);

1;
