# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/DFM/Eventclass/DoesNotExist.pm$
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception for when a Eventclass delete operation is performed on an
##          eventclass that does not exist.
##
## @author ramyar@netapp.com, dl-mpo-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::DFM::Eventclass::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when eventclass delete operation is performed on an
eventclass that does not exist.

=head1 EXAMPLE

   use NACL::C::Exceptions::DFM::Eventclass:: qw(:try);

   try {
       $non_existing_eventclass_obj->delete_custom();
   } catch NACL::C::Exceptions::DFM::Eventclass::DoesNotExist with {
        # Eventclass does not exist
   };

=cut

package NACL::C::Exceptions::DFM::Eventclass::DoesNotExist;

use base qw(
    NACL::APISet::Exceptions::ResponseException
    NACL::C::Exceptions::DoesNotExist
);

1;
