# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/EventMailhistory/DoesNotExist.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when entry doesn't exist for EventMailhistory
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::EventMailhistory::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when we attempt to delete a mail history
when entry does not exist.

=head1 EXAMPLE

   use NACL::C::Exceptions::EventMailhistory::DoesNotExist qw(:try);

   try {
       NACL::C::EventMailhistory->delete(
           command_interface  => $Node,
	   node		      => $node_name,
	   seqnum	      => $seq_num
           %other_opts);
   } catch NACL::C::Exceptions::EventMailhistory::DoesNotExist with {
        # Entry Does not exist
   };

=cut

package NACL::C::Exceptions::EventMailhistory::DoesNotExist;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::APISet::Exceptions::InvalidParamValueException
    NACL::C::Exceptions::DoesNotExist
);

sub detect {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;

    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [ qr/doesn't\s+exist/, qr/invalid\s+value\s+for\s+field/,
	qr/There\s+are\sno\sentries\smatching\syour\squery/ ]
    );
    $Log->exit() if $may_exit;
    return $detected;
}
1;
