#
# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary An exception for, when an attempt is made to operate on event notification element
## which is non-existent.
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::EventNotification::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when a attempt is made to perform an operation on a event notification element
which does not exist .

=cut

package NACL::C::Exceptions::EventNotification::DoesNotExist;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::C::Exceptions::DoesNotExist
);
1;
