#
# Copyright (c) 2013 NetApp Inc.
# All rights reserved.
#
## @summary A base class for the VmIsNotASnapshot exceptions
##
## @author rawat@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VmIsNotASnapshot

=head1 DESCRIPTION

This is an abstract base class for the exceptions that get thrown
when we attempt to delete an VM that is not a snapshot.

=head1 EXAMPLE

   use NACL::C::Exceptions::HyperV::VmIsNotASnapshot qw(:try);

   # $vm is a object to a VM snapshot
   try {
       $vm->remove(%opts);
   } catch NACL::C::Exceptions::HyperV::VmIsNotASnapshot with {
        # VM passed is not a snapshot
   };

=cut


package NACL::C::Exceptions::HyperV::VmIsNotASnapshot;
use base 'NACL::C::Exceptions::Component';
1;
