#
# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary This exception is thrown, when we attempt for
##          Lun move operation and maximum simultaneous file operations reached.
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::LunMove::MaximumSimultaneousOperation


=head1 EXAMPLE

   use NACL::C::Exceptions::LunMove::MaximumSimultaneousOperation qw(:try);

   try {
       NACL::C::Exceptions::LunMove->atart(%opts);
   } catch NACL::C::Exceptions::LunMove::MaximumSimultaneousOperation with {
       # maximum simultaneous file operations
   };

=cut

package NACL::C::Exceptions::LunMove::MaximumSimultaneousOperation;

use base 'NACL::C::_Mixins::Exceptions::FileCopyMove::MaximumSimultaneousOperation';

1;
