# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/LunPortSet/AlreadyExists.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception for when a LunPortSet of the same name already exists
##
## @author kathar@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::LunPortset::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a igroup which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::LunPortset::AlreadyExists qw(:try);

   try {
       NACL::C::LunPortSet->create(igroup => $already_existing_igroup, %other_opts);
   } catch NACL::C::Exceptions::LunPortSet::AlreadyExists with {
        # LunPortSet already exists.
   };

=cut

package NACL::C::Exceptions::LunPortset::AlreadyExists;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base NACL::C::Exceptions::AlreadyExists;
sub detect {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;

    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [ qr/already exist/i,]
    );
    $Log->exit() if $may_exit;
    return $detected;
}

1;
