# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/Snapmirror/DataProtectionVolume.pm
#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception gets thrown when we attempt to break snapmirror when the volume
## is not a data protection volume. 
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::Snapmirror::DataProtectionVolume

=head1 DESCRIPTION

An exception gets thrown when we attempt to break snapmirror when the volume
is not a data protection volume.

=head1 EXAMPLE

   use NACL::C::Exceptions::Snapmirror::DataProtectionVolume qw(:try);

   try {
       NACL::C::Snapmirror->break(
           command_interface  => $Node,
           'destination-path'       => $Path,
           %other_opts);
   } catch NACL::C::Exceptions::Snapmirror::DataProtectionVolume with {
        # not a data protection volume
   };

=cut

package NACL::C::Exceptions::Snapmirror::DataProtectionVolume;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::Component
);

sub detect {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [qr/(is not|must be) a data\-protection\s+(.*\s+)?Volume/i]
    );
    $Log->exit() if $may_exit;
    return $detected;
}
1;
