# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/Snapmirror/SnapmirrorDpLicenseCheckFailed.pm
#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception is thrown if an attempt is made to create when
## snapmirror DP license check failed for the cluster.
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::Snapmirror::SnapmirrorDpLicenseCheckFailed

=head1 DESCRIPTION

This exception gets thrown if an attempt is made to create when
snapmirror DP license check failed for the cluster.

=head1 EXAMPLE

   use NACL::C::Exceptions::Snapmirror::SnapmirrorDpLicenseCheckFailed qw(:try);

   try {
       NACL::C::Snapmirror->create(
           command_interface  => $Node,
           'destination-path' => $Path,
           %other_opts);
   } catch NACL::C::Exceptions::Snapmirror::SnapmirrorDpLicenseCheckFailed with {
        # snapmirror DP license check failed for the cluster
   };

=cut

package NACL::C::Exceptions::Snapmirror::SnapmirrorDpLicenseCheckFailed;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::Component
);

sub detect {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [qr/SnapMirror_DP\s+license\s+check\s+failed\s+for\s+cluster/i]
    );
    $Log->exit() if $may_exit;
    return $detected;
}
1;
