# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/Snapmirror/SnapmirrorIsTurnedOff.pm
#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception is thrown if we attempt to initialize the snapmirror
## when it is turned off.
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::Snapmirror::SnapmirrorIsTurnedOff

=head1 DESCRIPTION

This exception is thrown if we attempt to initialize the snapmirror when it is turned off.

=head1 EXAMPLE

   use NACL::C::Exceptions::Snapmirror::SnapmirrorIsTurnedOff qw(:try);

   try {
        NACL::C::Snapmirror->create(
            command_interface  =>  $command_interface,
            'source-path'      =>  $source_specification,
            'destination-path' =>  $destination_specification,
            %other_options
        );
   } catch NACL::C::Exceptions::Snapmirror::SnapmirrorIsTurnedOff with {
        # snapmirror is turned off
   };

=cut

package NACL::C::Exceptions::Snapmirror::SnapmirrorIsTurnedOff;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::Component
);

sub detect {
    $Log->enter();
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [qr/is\s+turned\s+off/i, qr/SnapMirror is off/i]
    );
    $Log->exit();
    return $detected;
}
1;
