# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/StorageFailover/DiskInventoryNotReceived.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when giveback fails as disk inventory information is not received.
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::StorageFailover::DiskInventoryNotReceived

=head1 DESCRIPTION

This exception is thrown when giveback fails as disk inventory information is not received.

=head1 EXAMPLE

   use NACL::C::Exceptions::StorageFailover::DiskInventoryNotReceived qw(:try);

   try {
    NACL::C::StorageFailover->giveback(
                command_interface => $ci,
		node              => $Filer
    );
   } catch NACL::C::Exceptions::StorageFailover::DiskInventoryNotReceived with {
        # disk inventory information is not received
   };

=cut

package NACL::C::Exceptions::StorageFailover::DiskInventoryNotReceived;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::Component
);

sub detect {
    $Log->enter();
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [qr/Disk\s+Inventory\s+information\s+(?:is\s+not|not\s+yet)\s+received/]
    );
    $Log->exit();
    return $detected;
}
1;
