# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/StorageFailover/UnableToReadPartnerState.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when giveback fails as it is unable to read partner state.
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::StorageFailover::UnableToReadPartnerState

=head1 DESCRIPTION

This exception is thrown when giveback fails as it is unable to read partner state.

=head1 EXAMPLE

   use NACL::C::Exceptions::StorageFailover::UnableToReadPartnerState qw(:try);

   try {
    NACL::C::StorageFailover->giveback(
                command_interface => $ci,
		fromnode          => "$Filer2"
    );
   } catch NACL::C::Exceptions::StorageFailover::UnableToReadPartnerState with {
        # unable to read partner state
   };

=cut

package NACL::C::Exceptions::StorageFailover::UnableToReadPartnerState;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::Component
);

sub detect {
    $Log->enter();
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [qr/Unable\s+to\s+read\s+partner\s+state/i]
    );
    $Log->exit();
    return $detected;
}
1;
