# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/SystemLicense/NoLicenseCodeIsNecessary.pm#3 $
#
# Copyright (c) 2009-2012 NetApp Inc.
# All rights reserved.
#
## @summary This exception is thrown when we try to add license code
##          which is already included and no license code is necessary.
##
## @author sshaik@netapp.com,dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::SystemLicense::NoLicenseCodeIsNecessary

=head1 DESCRIPTION

This exception is thrown when we try to add license code
which is already included and no license code is necessary.

=head1 EXAMPLE

   use NACL::C::Exceptions::SystemLicense::NoLicenseCodeIsNecessary qw(:try);

   try {
       NACL::C::SystemLicense->add(%opts);
   } catch NACL::C::Exceptions::SystemLicense::NoLicenseCodeIsNecessary with {
       # already included no license code is necessary
   };

=cut

package NACL::C::Exceptions::SystemLicense::NoLicenseCodeIsNecessary;

use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::Component
);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
sub detect {
    $Log->enter();
    my ( $pkg, @args ) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [qr/no license code is necessary/]
    );
    $Log->exit();
    return $detected;
} ## end sub detect
1;
