# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/Volume/CannotDeleteRootVolume.pm
#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when when we attempt to delete Root volume of Vserver
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::Volume::CannotDeleteRootVolume

=head1 DESCRIPTION

This exception is thrown when we attempt to delete Root volume of vserver when it
contains other volumes.

=head1 EXAMPLE

   use NACL::C::Exceptions::Volume::CannotDeleteRootVolume qw(:try);

   try {
        NACL::C::Volume->delete(
            command_interface=>$ci,
            volume =>$aggr_name,
            vserver => $vserver_name);
   } catch NACL::C::Exceptions::Volume::CannotDeleteRootVolume with {
        # Cannot delete root volume
   };

=cut

package NACL::C::Exceptions::Volume::CannotDeleteRootVolume;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::Component
);

sub detect {
    $Log->enter();
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [qr/Cannot\s+delete\s+root\s+volume\s+because\s+the\s+Vserver\s+has\s+volumes/]
    );
    $Log->exit();
    return $detected;
}
1;
