# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/VolumeCloneSplit/CloneAttachedToParent.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception for when we attempt to find any ongoing split actions
## on a cloned volume which hasn't yet separated from its parent.
##
## @author isshwar@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VolumeCloneSplit::CloneAttachedToParent;

=head1 DESCRIPTION

This exception is thrown when we try to find any ongoing split actions on a 
cloned volume which hasn't yet separated from its parent.

=head1 EXAMPLE

   use NACL::C::Exceptions::VolumeCloneSplit::CloneAttachedToParent qw(:try);

   try {
       $object = NACL::C::VolumeCloneSplit->find(command_interface =>$ci,
            filter => {flexclone => 'clone_vol'}
       );
   } catch NACL::C::Exceptions::VolumeCloneSplit::CloneAttachedToParent with {
        # volume 'clone_vol' is not yet detached from its parent
   };

=cut

package NACL::C::Exceptions::VolumeCloneSplit::CloneAttachedToParent;

use base qw(
    NACL::APISet::Exceptions::ResponseException
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::Component
);

1;
