# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/VolumeCloneSplit/NonExistentVolume.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception for when we attempt to find any ongoing split actions
## on a volume which doesn't exist
##
## @author isshwar@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VolumeCloneSplit::NonExistentVolume;

=head1 DESCRIPTION

This exception is thrown when we try to find any ongoing split actions on a 
volume which doesn't exist.

=head1 EXAMPLE

   use NACL::C::Exceptions::VolumeCloneSplit::NonExistentVolume qw(:try);

   try {
       $object = NACL::C::VolumeCloneSplit->find(command_interface =>$ci,
            filter => {flexclone => 'xyz_i_dont_exist'}
       );
   } catch NACL::C::Exceptions::VolumeCloneSplit::NonExistentVolume with {
        # volume doesn't exist
   };

=cut

package NACL::C::Exceptions::VolumeCloneSplit::NonExistentVolume;

use base qw(
    NACL::APISet::Exceptions::ResponseException
    NACL::Exceptions::NoElementsFound
    NACL::C::Exceptions::Component
);

1;
