# $Id: //depot/prod/DOT/dev/test/lib/NACL/C/Exceptions/VolumeEfficiencyPolicy/DoesNotExist.pm#1 $
#
# Copyright (c) 2013 NetApp Inc.
# All rights reserved.
#
## @summary An exception for when volume efficiency policy modify is performed on a
##          policy that does not exist.
##
## @author anupamap@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VolumeEfficiencyPolicy::DoesNotExist

=head1 DESCRIPTION

This exception is thrown volume efficiency policy modify is performed on a
policy that does not exist.

=head1 EXAMPLE

   use NACL::C::Exceptions::VolumeEfficiencyPolicy::DoesNotExist qw(:try);

   try {
       NACL::C::VolumeEfficiencyPolicy->modify(vserver => $vserver , policy => $policy);
   } catch NACL::C::Exceptions::VolumeEfficiencyPolicy::DoesNotExist with {
        # VolumeEfficiencyPolicy does not exist any more
   };

=cut

package NACL::C::Exceptions::VolumeEfficiencyPolicy::DoesNotExist;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::APISet::Exceptions::NoMatchingEntriesException
    NACL::C::Exceptions::DoesNotExist
);
sub detect {
    $Log->enter();
    my ($pkg, @args) = @_;

    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [ qr/entry\s+doesn't\s+exist/ ]
    );
    $Log->exit();
    return $detected;
}
1;
