#
# Copyright (c) 2015 NetApp Inc.
# All rights reserved.
#
## @summary An exception when entry doesn't exists for VolumeQuotaPolicyRule
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VolumeQuotaPolicyRule::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when an attempt is made to delete a 
non-existent quota policy rule

=head1 EXAMPLE

   use NACL::C::Exceptions::VolumeQuotaPolicyRule::DoesNotExist qw(:try);

   try {
       NACL::C::VolumeQuotaPolicyRule->delete(
           command_interface => $Node,
           vserver           => $vserver,
           'policy-name'     => $policy,
           %other_opts);
   } catch NACL::C::Exceptions::VolumeQuotaPolicyRule::DoesNotExist with {
        # Entry Does not exists
   };

=cut

package NACL::C::Exceptions::VolumeQuotaPolicyRule::DoesNotExist;
use base qw(NACL::C::Exceptions::DoesNotExist);
1;
