# Copyright (c) 2015 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for Vserver Cifs Home Dir Search path
##
## @author ng-ptefit-automation-core
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverCifsHomeDirectorySearchPath::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a home dir search path which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverCifsHomeDirectorySearchPath::AlreadyExists qw(:try);

   try {
       NACL::C::VserverCifsHomeDirectorySearchPath->create(
           command_interface  => $Node,
           vserver            => $Vserver,
           path               => $path,
           %other_opts);
   } catch NACL::C::Exceptions::VserverCifsHomeDirectorySearchPath::AlreadyExists with {
        # Duplicate entry exists
   };

=cut

package NACL::C::Exceptions::VserverCifsHomeDirectorySearchPath::AlreadyExists;
use base 'NACL::C::Exceptions::AlreadyExists';
1;
