# Copyright (c) 2015 NetApp Inc.
# All rights reserved.
#
## @summary An exception when entry doesn't exists for VserverCifsHomeDirectorySearchPath
##
## @author ng-ptefit-automation-core
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverCifsHomeDirectorySearchPath::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when we attempt to create a search path
when entry does not exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverCifsHomeDirectorySearchPath::DoesNotExist qw(:try);

   try {
       NACL::C::VserverCifsHomeDirectorySearchPath->delete(
           command_interface  => $Node,
           vserver            => $Vserver,
           path               => $path,
           %other_opts);
   } catch NACL::C::Exceptions::VserverCifsHomeDirectorySearchPath::DoesNotExist with {
        # Entry Does not exists
   };

=cut

package NACL::C::Exceptions::VserverCifsHomeDirectorySearchPath::DoesNotExist;
use base 'NACL::C::Exceptions::DoesNotExist';
1;
