# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/VserverCifsShare/DoesNotExist.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when entry doesn't exists for VserverCifsShare
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverCifsShare::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when we attempt to delete a cifs share
when entry does not exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverCifsShare::DoesNotExist qw(:try);

   try {
       NACL::C::VserverCifsShare->delete(
           command_interface  => $Node,
           vserver            => $Vserver,
           'share-name'       => $Share_name,
           %other_opts);
   } catch NACL::C::Exceptions::VserverCifsShare::DoesNotExist with {
        # Entry Does not exists
   };

=cut

package NACL::C::Exceptions::VserverCifsShare::DoesNotExist;


use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::DoesNotExist
);

sub detect {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [ qr/entry\s+doesn't\s+exist/i]

    );
    $Log->exit() if $may_exit;
    return $detected;
}
1;
