# Copyright (c) 2015 NetApp Inc.
# All rights reserved.
#
## @summary An exception when VserverCifsShareAccessControl  operation is performed on a
##          ShareAccessControl that does not exist.
##
## @author ng-ptefit-automation-core
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverCifsShareAccessControl::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when a VserverCifsShareAccessControl operation is performed on a
entry that does not exist.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverCifsShareAccessControl::DoesNotExist qw(:try);

   try {
       $non_existing_share_access_control_obj->modify(level=>'emerg');
   } catch NACL::C::Exceptions::VserverCifsShareAccessControl::DoesNotExist with {
        # VserverCifsShareAccessControl does not exist any more
   };

=cut

package NACL::C::Exceptions::VserverCifsShareAccessControl::DoesNotExist;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base 'NACL::C::Exceptions::DoesNotExist';

1;
