# Copyright (c) 2012-2015 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for VserverExportPolicyRule
##
## @author ng-ptefit-automation-core
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverExportPolicyRule::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a export policy rule which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverExportPolicyRule::AlreadyExists qw(:try);

   try {
       NACL::C::VserverExportPolicyRule->create(
           command_interface  => $Node,
           vserver            => $Vserver,
           %other_opts);
   } catch NACL::C::Exceptions::VserverExportPolicyRule::AlreadyExists with {
        # Duplicate entry exists
   };

=cut

package NACL::C::Exceptions::VserverExportPolicyRule::AlreadyExists;
use base 'NACL::C::Exceptions::AlreadyExists';
1;
