# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/VserverFpolicyPolicy/AlreadyExists.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for VserverFpolicyPolicy
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverFpolicyPolicy::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a Vserver Fpolicy Policy which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverFpolicyPolicy::AlreadyExists qw(:try);

   try {
    NACL::C::VserverFpolicyPolicy->create(
                command_interface => $ci,
                vserver           => $vserver,
		policy            => $Policy,
    );
   } catch NACL::C::Exceptions::VserverFpolicyPolicy::AlreadyExists with {
        # Duplicate entry exists
   };

=cut

package NACL::C::Exceptions::VserverFpolicyPolicy::AlreadyExists;
use base 'NACL::C::_Mixins::Exceptions::VserverFpolicyPolicy::AlreadyExists';
1;
