# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/VserverFpolicyPolicyEvent/AlreadyExists.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for VserverFpolicyPolicyEvent
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverFpolicyPolicyEvent::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a Vserver Fpolicy Policy Event which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverFpolicyPolicyEvent::AlreadyExists qw(:try);

   try {
    NACL::C::VserverFpolicyPolicyEvent->create(
                command_interface => $ci,
                vserver           => $vserver,
	        events            => \@events,
    );
   } catch NACL::C::Exceptions::VserverFpolicyPolicyEvent::AlreadyExists with {
        # entry already exists
   };

=cut

package NACL::C::Exceptions::VserverFpolicyPolicyEvent::AlreadyExists;
use base 'NACL::C::_Mixins::Exceptions::VserverFpolicyPolicy::AlreadyExists';
1;
