# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/VserverFpolicyPolicyExternalEngine/AlreadyExists.pm#1 $
#
# Copyright (c) 2009-2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for VserverFpolicyPolicyExternalEngine
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverFpolicyPolicyExternalEngine::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a VserverFpolicyPolicyExternalEngine which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverFpolicyPolicyExternalEngine::AlreadyExists qw(:try);

   try {
       NACL::C::VserverFpolicyPolicyExternalEngine->create(vserver => $vserver,
					'engine-name'       => $Engine_Name, %other_opts);
   } catch NACL::C::Exceptions::VserverFpolicyPolicyExternalEngine::AlreadyExists with {
        # external-engine already exists.
   };

=cut

package NACL::C::Exceptions::VserverFpolicyPolicyExternalEngine::AlreadyExists;
use base 'NACL::C::_Mixins::Exceptions::VserverFpolicyPolicy::AlreadyExists';
1;
