
# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/VserverFpolicyPolicyExternalEngine/DoesNotExist.pm#1 $
#
# Copyright (c) 2009-2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a entry does not exist for VserverFpolicyPolicyExternalEngine.
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverFpolicyPolicyExternalEngine::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when we attempt to delete an VserverFpolicyPolicyExternalEngine
when entry does not exist.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverFpolicyPolicyExternalEngine::DoesNotExist qw(:try);

   try {
       $non_existing_engine_obj->delete();
   } catch NACL::C::Exceptions::VserverFpolicyPolicyExternalEngine::DoesNotExist with {
        # entry does not exists
   };

=cut

package NACL::C::Exceptions::VserverFpolicyPolicyExternalEngine::DoesNotExist;
use base 'NACL::C::_Mixins::Exceptions::VserverFpolicyPolicy::DoesNotExist';
1;
