# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/VserverFpolicyPolicyScope/AlreadyExists.pm#1 $
#
# Copyright (c) 2009-2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for VserverFpolicyPolicyScope
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverFpolicyPolicyScope::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a Vserver Fpolicy Policy Scope which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverFpolicyPolicyScope::AlreadyExists qw(:try);

   try {
       NACL::C::VserverFpolicyPolicyScope->create(vserver => $vserver,
					'policy-name' => 'test_policy',%other_opts);
   } catch NACL::C::Exceptions::VserverFpolicyPolicyScope::AlreadyExists with {
        # entry already exists.
   };

=cut

package NACL::C::Exceptions::VserverFpolicyPolicyScope::AlreadyExists;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base 'NACL::C::_Mixins::Exceptions::VserverFpolicyPolicy::AlreadyExists';
1;
