# Copyright (c) 2012-2015 NetApp Inc.
# All rights reserved.
#
## @summary An exception when entry doesn't exists for VserverNameMapping
##
## @author ng-ptefit-automation-core
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverNameMapping::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when we attempt to create a name mapping
when entry does not exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverNameMapping::DoesNotExist qw(:try);

   try {
       NACL::C::VserverNameMapping->delete(
           command_interface  => $Node,
           vserver            => $Vserver,
           %other_opts);
   } catch NACL::C::Exceptions::VserverNameMapping::DoesNotExist with {
        # Entry Does not exists
   };

=cut

package NACL::C::Exceptions::VserverNameMapping::DoesNotExist;
use base 'NACL::C::Exceptions::DoesNotExist';
1;
