#
# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary An exception for, when an attempt is made to operate on vserver services name service ldap client element
## which is non-existent.
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverServicesNameServiceLdapClient::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when a attempt is made to perform an operation on a vserver services name service ldap client element
which already exists .

=cut

package NACL::C::Exceptions::VserverServicesNameServiceLdapClient::AlreadyExists;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::AlreadyExists
);
sub detect {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
       @args,
       regexes => [ qr/duplicate\s+entry/]
    );
    $Log->exit() if $may_exit;
    return $detected;
}
1;
