# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/VserverVscanOnAccessPolicy/AlreadyExists.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception for when a VserverVscanOnAccessPolicy of the same name already exists
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverVscanOnAccessPolicy::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a igroup which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverVscanOnAccessPolicy::AlreadyExists qw(:try);

   try {
       NACL::C::VserverVscanOnAccessPolicy->create('policy-name' => $already_existing_policy, %other_opts);
   } catch NACL::C::Exceptions::VserverVscanOnAccessPolicy::AlreadyExists with {
        # VserverVscanOnAccessPolicy already exists.
   };

=cut

package NACL::C::Exceptions::VserverVscanOnAccessPolicy::AlreadyExists;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base NACL::C::Exceptions::AlreadyExists;
1;
