# Copyright (c) 2015 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for Symlink
##
## @author ng-ptefit-automation-core
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverVscanScannerPool::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a scanner pool which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverVscanScannerPool::AlreadyExists qw(:try);

   try {
       $sched = NACL::C::VserverVscanScannerPool->create(
                    command_interface => $Filer_Dst,
                    vserver => $vserver,
                    %other_opts);
   } catch NACL::C::Exceptions::VserverVscanScannerPool::AlreadyExists with {
        # Duplicate entry exists
   };

=cut

package NACL::C::Exceptions::VserverVscanScannerPool::AlreadyExists;

use base 'NACL::C::Exceptions::AlreadyExists';
1;
