
#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
# VMware End User License Agreement

# VMware, Inc. (VMware) provides the vSphere Command-Line Interface (vSphere CLI) 
# and/or vSphere Software Development Kit for Perl (vSphere SDK for Perl) (collectively 
# the Software) to you subject to the following terms and conditions.  If you 
# disagree with any of the following terms, then do not use the Software.

# 1.  The Software contains a variety of materials, interface definitions, documentation, 
# sample utility applications and sample code regarding programming interfaces to one or 
# more VMware products as referenced in such materials (VMware Products).  This Software 
# is intended to be used to execute supplied commands and utility applications and to 
# create scripts that interact with the VMware Products. 

# 2.  Use Rights:  Subject to the restrictions below, you may download and make a 
# reasonable number of copies of the Software contents for your use solely for the purpose
# of creating software that communicates with VMware Products (Developer Software).  For
# vSphere SDK for Perl, some code may be designated as distributable code and/or
# modifiable code at http://www.vmware.com/go/vsdkperl-redistribution-info.  For vSphere
# CLI, some code may be designated as distributable code and/ or modifiable code at
# http://www.vmware.com/go/vcli-redistribution-info.  You may use and merge all or portions
# of the distributable code with your Developer Software.  Any merged portion of any 
# distributable code is subject to this Agreement.  Additionally, you may modify or create
# derivative works of all or portions of the modifiable code.  You are permitted to
# re-distribute the distributable code and the modified or derivative works of the 
# modifiable code only as part of your Developer Software for non-commercial or commercial 
# use. Open source software components provided with the Software are licensed to you under
# the terms of the applicable license agreements included with such open source software
# components.  The open source software licenses can be found in the open_source_licenses.txt
# file, other materials accompanying the Software, the documentation or corresponding source
# files available at http://www.vmware.com/download/vi/open_source.html.

# 3.  Restrictions:  You agree that you will not (1) use the Software to create, design or
# develop anything other than Developer Software; (2) make any more copies of the Software
# than are reasonably necessary for the authorized use and backup and archival purposes;
# (3) modify, create derivative works of, reverse engineer, reverse compile, or disassemble
# the Software, except as expressly permitted in Section 2; (4) distribute, sell, lease, rent,
# lend, or sublicense any part of the Software to any third party except as expressly permitted
# in Section 2 or; (5) use the Software to (a) create, design or develop software or service to
# circumvent, enable, modify or provide access, permissions or rights which would violate the
# technical restrictions of VMware Products, any additional licensing terms provided by VMware
# via product documentation, email notification and/or policy change on VMware website, and/or
# the terms of the End User License Agreements of VMware products; (b) disable, remove, over-ride
# or modify the display of any VMware product End User License Agreements to the end customers;
# and (c) upload or otherwise transmit any material containing software viruses or other computer
# code, files or programs designed to interrupt, destroy, or limit the functionality of any
# software or hardware.  

# The restrictions in this Section 3 shall not apply if and to the extent they contradict
# mandatory local law (including, but not limited to, law implementing the EC Software Directive)
# provided that, before you exercise any rights that you believe to be entitled to based on
# mandatory law, you provide VMware with 30 days prior written notice at SDK_Legal@vmware.com and
# provide all reasonably requested information to allow VMware to assess your claim and, at
# VMwares sole discretion, to provide alternatives that reduce any adverse impact on VMwares
# intellectual property or other rights.  

# 4.   VMware retains ownership of the Software, including without limitation all copyrights and
# other intellectual property rights therein. You may not remove, delete or modify any of VMware
# copyright statements in the Software.

# 5.  You may not use VMwares name, trademarks or service marks in your Developer Softwares
# names or in a way that suggests your Developer Software is certified or endorsed by VMware. Your
# use of VMware product names and trademarks shall comply with the Branding Guidelines posted at
# www.vmware.com. 

# 6.  If you are currently entitled to support from VMware, you may submit a support request
# for installation assistance of this Software and assistance in executing unmodified utility
# applications or vSphere CLI commands provided with this Software.  Except as provided herein,
# you are not entitled to any VMware support for this Software or any other services from VMware
# in connection with this Software or your Developer Software.  

# 7.  Term, Termination and Changes: This Agreement shall continue as long as you are in compliance
# with the terms specified herein or until otherwise terminated.  You and or VMware each may
# terminate this Agreement for any reason at any time.  You agree, upon termination, to destroy
# all copies of the Software within your possession or control. The Confidential Information,
# Limitations of Warranties, Liability and Indemnification sections set out in this Agreement
# shall survive any termination or expiration of this Agreement. 

# 8.  Limitations of Warranties and Liability:  THE SOFTWARE IS PROVIDED AS IS WITHOUT ANY
# WARRANTIES OF ANY KIND.  TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, VMWARE DISCLAIMS
# ANY IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT OF INTELLECTUAL PROPERTY RIGHTS.

# TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT WILL VMWARE BE LIABLE FOR ANY
# LOST PROFITS OR BUSINESS OPPORTUNITIES, LOSS OF USE, BUSINESS INTERRUPTION, LOSS OF DATA, OR ANY
# OTHER INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE SOFTWARE OR
# YOUR USE OF THE SOFTWARE, UNDER ANY THEORY OF LIABILITY, WHETHER BASED IN CONTRACT, TORT,
# NEGLIGENCE, PRODUCT LIABILITY, OR OTHERWISE.  BECAUSE SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION
# OR LIMITATION OF LIABILITY FOR CONSEQUENTIAL OR INCIDENTAL DAMAGES, THE PRECEDING LIMITATION MAY
# NOT APPLY TO YOU.

# VMWARES LIABILITY ARISING OUT OF THE SOFTWARE PROVIDED HEREUNDER WILL NOT, IN ANY EVENT,
# EXCEED US$5.00.

# THE FOREGOING LIMITATIONS SHALL APPLY TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, REGARDLESS
# OF WHETHER VMWARE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES AND REGARDLESS OF WHETHER
# ANY REMEDY FAILS OF ITS ESSENTIAL PURPOSE.

# 9.  Indemnification: You agree to defend, indemnify and hold harmless VMware, and any of its
# directors, officers, employees, affiliates or agents, from and against any and all claims, losses,
# damages, liabilities and other expenses (including reasonable attorneys fees), arising from your
# modification or derivative works of the modifiable code, distribution or use of your Developer
# Software or breach of this Agreement.

# 10.  These terms are governed by the laws of the State of California and the United States of
# America without regard to conflict of laws principles.  You may not assign any part of this Agreement
# without the prior written consent of VMware.  Any attempted assignment without consent shall be void.
# These terms constitute the entire agreement between you and VMware with respect to the Software, and
# supersede all prior written or oral communications, understandings and agreements. Any waiver of these
# terms must be in writing to be effective. If any provision of these terms is found to be invalid or
# unenforceable, the remaining terms will continue to be valid and enforceable to the fullest extent
# permitted by law.

## @summary HyperV/VDisk Component Module
## @author rawat@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::HyperV::VDisk

=head1 DESCRIPTION

C<NACL::C::HyperV::VDisk> is a derived class of
L<NACL::C::Component|lib-NACL-C-Component-pm>.  It represents access
to the VirtualDiskManager object reference of an HyperV Server.  

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vmdk_path

Name of the vmdk file to be created along with the vmfs path in the form of datastore path. 
This also acts as the source vmdk path for clone
	e.g. /vmfs/volumes/SrcVol_1/xyz.vmdk

=cut

package NACL::C::HyperV::VDisk;

use strict;
use warnings;
use Params::Validate qw(validate_with validate SCALAR UNDEF);

use NACL::C::UnitNormalization;
use NACL::ComponentUtils qw(_optional_scalars Dumper);
use base 'NACL::C::Component::HyperV';
use Tharn;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
require VMware::VICommon;
require VMware::VIMRuntime;
require VMware::VIM25Stub;

=head1 METHODS

=head2 new

  my $vdisk_obj = NACL::C::HyperV::VDisk->new(
									command_interface   => $ci,
                                    vmdk_path           => $vmdk_path,
                                );
										  
Return a new HyperV::VDisk component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vmdk_path',
];

=head2 create

  my $vdisk  = NACL::C::HyperV::VDisk->create(
										command_interface   => $ci,
										vmdk_path           => $vmdk_path,
										disk_size           => $disk_size,
                                        disk_type           => $disk_type,
                                        device_type         => $device_type,
                                        adapter_type        => $adapter_type,
									);
  OR
  
  $vdisk->create(disk_size => $disk_size);


(Class or Instance method) Request addition of a new VDisk element, and  return a new
VDisk component object that refers to it. 
Applicable for VMAPI ESX.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< disk_size=>$string >>

(Required)The size of the virtual disk to be created.  The size 
to be of the form #gGmMkK.  e.g., 1G or 1g, 100M or 100m

=item C<< disk_type=$string >>

(Optional)The type of the virtual disk to be created.  Accepts
values such as zeroedthick|eagerzeroedthick|thin

=item C<< adapter_type=$string >>

(Optional) The adapter type of a disk to be created. Accepts 
buslogic, lsilogic or ide.

=item C<< device_type=$string >>

(Optional) Creates raw disk mapping, takes the disk device path.
Map a raw disk to a file on a VMFS file system. Once the mapping
is established, it can be used to access the raw disk like a
normal VMFS virtual disk. The 'file length' of the mapping is
the same as the size of the raw disk that it points to.
	
=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;

    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with( params => \@args, );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
                        choices => [
                            { 
                              method => '_create_virtual_disk_esx',
                              interface => 'VMAPI',
                              set   => 'ESX',
                            },
                        ], 
                   );

    $Log->exit() if $may_exit;
    return $ret;
}


sub _create_virtual_disk_esx {
    $Log->enter() if $may_enter;
    my $pkg_or_obj               = shift;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $vdisksystem       = $command_interface->vdisksystem();
    my $hostview          = $vdisksystem->hostview();
    my $vdiskmanager      = $vdisksystem->vdiskmanager();
    my $datastoreRefs     = $hostview->datastore;

    my $vmdk_path = _convert_path(
        apiset    => $apiset,
        vmdk_path => $opts{vmdk_path},
        datastore => $datastoreRefs,
    );

    my $adapter_type = $opts{adapter_type} || "busLogic";
    my $disk_type    = $opts{disk_type}    || "zeroedthick";
    my $device_type  = $opts{device_type};

    my $spec;
    if ( defined($device_type) ) {

        $spec = DeviceBackedVirtualDiskSpec->new();
        if ( $device_type !~ /^\/vmfs\/devices\/disks\// ) {
            $device_type = "/vmfs/devices/disks/" . $device_type;
        }
        $spec->{device} = $device_type;
    }
    else {
        my $size_kb = undef;
        if ( defined $opts{disk_size} ) {
            if ( $opts{disk_size} =~ /^(\d+)[gGmMkK]$/ ) {
                $size_kb =
                  NACL::C::UnitNormalization::to_kilobytes( $opts{disk_size} );
                $size_kb =
                  NACL::C::UnitNormalization::strip_unit_spec($size_kb);
            }
        }
        $spec = FileBackedVirtualDiskSpec->new();
        $spec->{capacityKb} = $size_kb;
    }

    $spec->{diskType}    = _convert_disk_format($disk_type);
    $spec->{adapterType} = $adapter_type;

    my $result =
      $vdiskmanager->CreateVirtualDisk( name => $vmdk_path, spec => $spec );

    $Log->exit() if $may_exit;

    return $pkg_or_obj->new(
        vmdk_path         => $opts{vmdk_path},
        command_interface => $command_interface
    );
}

=head2 clone

  my $vdisk  = NACL::C::HyperV::VDisk->clone(
										command_interface => $ci,
                                        vmdk_path         => $source_vmdk_path,
										target_vmdk_path  => $target_vmdk_path,
									);
  
  NACL::C::HyperV::VDisk->clone(
						command_interface   => $ci,
						vmdk_path           => $source_vmdk_path,
						target_vmdk_path    => $target_vmdk_path,
					);
                    
  OR
  my $clone_vdisk = $vdisk->clone(target_vmdk_path =>$target_vmdk_path);
									  


(Class method) Request clone of a source VDisk to a specified target Vdisk.
Applicable for VMAPI ESX.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< target_vmdk_path=> $string >>

(Required) target vmdk file name along with the vmfs path in the form of datastore path 
		e.g. /vmfs/volumes/SrcVol_1/xyz.vmdk

=item C<< disk_size=>$string >>

(Required)The size of the virtual disk to be created.  The size 
to be of the form #gGmMkK.  e.g., 1G or 1g, 100M or 100m

=item C<< disk_type=$string >>

(Optional)The type of the virtual disk to be created.  Accepts
values such as zeroedthick|eagerzeroedthick|thin

=item C<< adapter_type=$string >>

(Optional) The adapter type of a disk to be created. Accepts 
buslogic, lsilogic or ide.

=item C<< device_type=$string >>

(Optional) Creates raw disk mapping, takes the disk device path.
Map a raw disk to a file on a VMFS file system. Once the mapping
is established, it can be used to access the raw disk like a
normal VMFS virtual disk. The 'file length' of the mapping is
the same as the size of the raw disk that it points to.
	
=back

=back

=cut

sub clone {
    $Log->enter() if $may_enter;

    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);

    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => { target_vmdk_path => { type => SCALAR }, },
    );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
                        choices => [
                            { 
                              method => '_clone_virtual_disk_esx',
                              interface => 'VMAPI',
                              set   => 'ESX',
                            },
                        ], 
                   );

    $Log->exit() if $may_exit;
    return $ret;
}

sub _clone_virtual_disk_esx {
    $Log->enter() if $may_enter;

    my $pkg_or_obj        = shift;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $vdisksystem       = $command_interface->vdisksystem();
    my $hostview          = $vdisksystem->{hostview};
    my $vdiskmanager      = $vdisksystem->{vdiskmanager};
    my $datastoreRefs     = $hostview->datastore;

    my $source_vmdk_path = _convert_path(
        apiset    => $apiset,
        vmdk_path => $opts{vmdk_path},
        datastore => $datastoreRefs,
    );

    my $target_vmdk_path = _convert_path(
        apiset    => $apiset,
        vmdk_path => $opts{target_vmdk_path},
        datastore => $datastoreRefs,
    );

    my $device = undef;
    my ( $disk_type, $adapter_type );

    ( $disk_type, $device ) = _get_device_disk_type( $opts{disk_type} );
    $disk_type = "zeroedthick" unless defined($disk_type);
    $adapter_type = $opts{adapter_type} ? $opts{adapter_type} : "busLogic";

    my $spec = undef;
    if ( defined($device) ) {
        $spec = DeviceBackedVirtualDiskSpec->new();
        $spec->{device} = $device;
    }
    else {
        $spec = FileBackedVirtualDiskSpec->new();
        $spec->{capacityKb} = 10000;
    }

    $spec->{diskType}    = _convert_disk_format($disk_type);
    $spec->{adapterType} = $adapter_type;

    my $result = $vdiskmanager->CopyVirtualDisk(
        sourceName       => $source_vmdk_path,
        sourceDatacenter => undef,
        destName         => $target_vmdk_path,
        destDatacenter   => undef,
        destSpec         => $spec,
        force            => 1,
    );

    $Log->exit() if $may_exit;

    return $pkg_or_obj->new(
        vmdk_path         => $opts{vmdk_path},
        target_vmdk       => $opts{target_vmdk_path},
        command_interface => $command_interface
    );
}

sub _get_device_disk_type {
    $Log->enter() if $may_enter;
    my $type = shift;
    if ( $type && $type =~ /(rdm:|rdmp:|raw:)(.*)$/ ) {
        my $dtype = substr( $1, 0, length($1) - 1 );
        $Log->exit() if $may_exit;
        return ( $dtype, $2 );
    }
    else {
        $Log->exit() if $may_exit;
        return ( $type, undef );
    }
}

sub _convert_path {
    $Log->enter() if $may_enter;
    my %opts          = @_;
    my $vmdk_path     = $opts{vmdk_path};
    my $datastoreRefs = $opts{datastore};
    my $apiset        = $opts{apiset};

    if ( defined $vmdk_path && $vmdk_path =~ /^\/vmfs\/volumes\// ) {
        $vmdk_path =~ s/\/$//;
        my @arr = split( /\//, $vmdk_path, 5 );
        my $dsName = $arr[3];

        foreach my $dsref (@$datastoreRefs) {
            my $response_for_datastore = $apiset->get_view( mo_ref => $dsref );
            my $data_store = $response_for_datastore->get_raw_output();

            if ( $data_store->info->url =~ /$dsName/ ) {
                $dsName = $data_store->info->name;
                last;
            }
        }
        $vmdk_path = ( defined( $arr[4] ) ) ? "[$dsName] $arr[4]" : "[$dsName]";
    }
    $Log->exit() if $may_exit;
    return $vmdk_path;
}

sub _convert_disk_format {
    $Log->enter() if $may_enter;
    my $disk_format = shift;
    if ( defined($disk_format) ) {
        if ( $disk_format =~ /^2gbsparse$/i ) {
            $Log->exit() if $may_exit;
            return "sparse2Gb";
        }
        elsif ( $disk_format =~ /^zeroedthick$/i ) {
            $Log->exit() if $may_exit;
            return "preallocated";
        }
        elsif ( $disk_format =~ /^eagerzeroedthick$/i ) {
            $Log->exit() if $may_exit;
            return "eagerZeroedThick";
        }
        else {
            $Log->exit() if $may_exit;
            return $disk_format;
        }
    }
    else {
        $Log->exit() if $may_exit;
        return undef;
    }
}

sub _common_validate_with {
    $Log->enter() if $may_enter;
    my ( $pkg_or_obj, %opts ) = @_;
    validate_with(
        params => $opts{params},
        spec   => {
            disk_size    => { type => SCALAR },
            disk_type    => { type => SCALAR | UNDEF, optional => 1 },
            adapter_type => { type => SCALAR | UNDEF, optional => 1 },
            device_type  => { type => SCALAR | UNDEF, optional => 1 },
        },
        allow_extra => 1,
    );
    $Log->exit() if $may_exit;
    return $pkg_or_obj->SUPER::_common_validate_with( %opts, allow_extra => 1 );
}

sub _primary_keys_validate_spec {
    return ( vmdk_path => { type => SCALAR }, );
} ## end sub _primary_keys_validate_spec
1;
