# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary MetroclusterCheckConfigReplication Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::MetroclusterCheckConfigReplication

=head1 DESCRIPTION

C<NACL::C::MetroclusterCheckConfigReplication> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP MetroclusterCheckConfigReplication.  A related class is
L<NACL::CS::MetroclusterCheckConfigReplication|lib-NACL-CS-MetroclusterCheckConfigReplication-pm>, which represents
the past state of an ONTAP MetroclusterCheckConfigReplication.
However, since it does not have any primary keys, 'find' and 'state' do not
work for this component. (This component is considered a 'singleton',
i.e. there is only one row shown by the relevant 'show' command)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::MetroclusterCheckConfigReplication;

use strict;
use warnings;

use NACL::CS::MetroclusterCheckConfigReplication;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $MetroclusterCheckConfigReplication = NACL::C::MetroclusterCheckConfigReplication->new(
                                   command_interface => $ci,
								  );

Return a new MetroclusterCheckConfigReplication component object with the given attributes.

=cut

use Class::MethodMaker [];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $MetroclusterCheckConfigReplication_obj  = NACL::C::MetroclusterCheckConfigReplication->find(command_interface => $ci, ...);
	my @MetroclusterCheckConfigReplication_objs = NACL::C::MetroclusterCheckConfigReplication->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my MetroclusterCheckConfigReplication_state = $MetroclusterCheckConfigReplication_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::MetroclusterCheckConfigReplication would return 
a NACL::CS::MetroclusterCheckConfigReplication object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 show_aggregate_eligibility

    my $show_aggregate_eligibility_obj = NACL::C::MetroclusterCheckConfigReplication->show_aggregate_eligibility(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_aggregate_eligibility_objs = NACL::C::MetroclusterCheckConfigReplication->show_aggregate_eligibility(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_aggregate_eligibility_obj = $MetroclusterCheckConfigReplication_obj->show_aggregate_eligibility(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-MetroclusterCheckConfigReplicationShowAggregateEligibility-pm/ATTRIBUTES>
of NACL::CS::MetroclusterCheckConfigReplicationShowAggregateEligibility as input. 
This method returns objects of the type L<NACL::CS::MetroclusterCheckConfigReplicationShowAggregateEligibility|lib-NACL-CS-MetroclusterCheckConfigReplicationShowAggregateEligibility-pm>.

=cut

sub show_aggregate_eligibility {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require
        NACL::CS::MetroclusterCheckConfigReplicationShowAggregateEligibility;
    my @state_objs
        = NACL::CS::MetroclusterCheckConfigReplicationShowAggregateEligibility
        ->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}


__PACKAGE__->_load_event_class();

1;
