
#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary NetworkRoutingGroupsRouteCdb Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::NetworkRoutingGroupsRouteCdb

=head1 DESCRIPTION

C<NACL::C::NetworkRoutingGroupsRouteCdb> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP NetworkRoutingGroupsRouteCdb.  A related class is
L<NACL::CS::NetworkRoutingGroupsRouteCdb|lib-NACL-CS-NetworkRoutingGroupsRouteCdb-pm>, which represents
the past state of an ONTAP NetworkRoutingGroupsRouteCdb.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 destination

=head2 node

=head2 routing_group

=cut

package NACL::C::NetworkRoutingGroupsRouteCdb;

use strict;
use warnings;

use NACL::CS::NetworkRoutingGroupsRouteCdb;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $NetworkRoutingGroupsRouteCdb = NACL::C::NetworkRoutingGroupsRouteCdb->new(command_interface=>$ci,
                                   destination =>$destination,
                                   node =>$node,
                                   routing_group =>$routing_group,
								  );

Return a new NetworkRoutingGroupsRouteCdb component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'destination',
    scalar => 'node',
    scalar => 'routing_group',
];

=head2 find

    my $NetworkRoutingGroupsRouteCdb  = NACL::C::NetworkRoutingGroupsRouteCdb->find(command_interface => $ci, ...);
	my @NetworkRoutingGroupsRouteCdbs = NACL::C::NetworkRoutingGroupsRouteCdb->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $NetworkRoutingGroupsRouteCdb_state = $NACL::C::NetworkRoutingGroupsRouteCdb->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::NetworkRoutingGroupsRouteCdb would return 
a NACL::CS::NetworkRoutingGroupsRouteCdb object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 delete

   NACL::C::NetworkRoutingGroupsRouteCdb->delete(
                                command_interface => $ci,
	                             destination => $destination,
	                             node => $node,
	                             routing_group => $routing_group,
                                  ...);
	                             
								 or

    $NetworkRoutingGroupsRouteCdb_object->delete(...);

(Class or instance method)

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "destination" => $destination >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "node" => $node >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "routing-group" => $routing_group >>

(Required for class method, Not Applicable for instance method)

=item C<< '*' >>

This method takes all other options supported by
"network routing-groups route cdb delete" command in ONTAP.

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'network routing-groups route cdb delete',
    );
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_delete_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::NetworkRoutingGroupsRouteCdb::delete',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@args, api => 'network_routing_groups_route_cdb_delete');

    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

=head2 modify

   NACL::C::NetworkRoutingGroupsRouteCdb->modify(
                                command_interface => $ci,
	                             destination => $destination,
	                             node => $node,
	                             routing_group => $routing_group,
                                  ...);
	                             
								 or

    $NetworkRoutingGroupsRouteCdb_object->modify(...);

(Class or instance method)

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "destination" => $destination >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "node" => $node >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "routing-group" => $routing_group >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "gateway" => $string >>

Applicable for CMode CLI.

=item C<< "metric" => $string >>

=item C<< '*' >>

This method takes all other options supported by
"network routing-groups route cdb modify" command in ONTAP.

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( gateway metric
                    )
            ),
        },
        cli_cmd => 'network routing-groups route cdb modify',
    );
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_modify_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::NetworkRoutingGroupsRouteCdb::modify',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;

    $pkg_or_obj->_base_backend_cmode_cli(@args, api => 'network_routing_groups_route_cdb_modify');
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

=head2 create

    my $NetworkRoutingGroupsRouteCdb_object	= NACL::C::NetworkRoutingGroupsRouteCdb->create(
                                command_interface => $ci,
	                             destination => $destination,
	                             node => $node,
	                             routing_group => $routing_group,
                                  ...);

(Class method)

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "destination" => $destination >>

(Required)

Applicable for CMode CLI.

=item C<< "node" => $node >>

(Required)

Applicable for CMode CLI.

=item C<< "routing-group" => $routing_group >>

(Required)

Applicable for CMode CLI.

=item C<< "gateway" => $string >>

Applicable for CMode CLI.

=item C<< "metric" => $string >>

=item C<< '*' >>

This method takes all other options supported by
"network routing-groups route cdb create" command in ONTAP.

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( gateway metric
                    )
            ),
        },
        cli_cmd => 'network routing-groups route cdb create',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_create_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::NetworkRoutingGroupsRouteCdb::create',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;

    $pkg->_base_backend_cmode_cli(%opts, api => 'network_routing_groups_route_cdb_create');
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $opts{command_interface},
        destination       => $opts{'destination'},
        node              => $opts{'node'},
        routing_group     => $opts{'routing-group'},
    );
} ## end sub _create_cmode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'destination'   => {type => SCALAR},
        'node'          => {type => SCALAR},
        'routing-group' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
