
#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary RepositoryPlacementFileCreate Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::RepositoryPlacementFileCreate

=head1 DESCRIPTION

C<NACL::C::RepositoryPlacementFileCreate> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP RepositoryPlacementFileCreate.  A related class is
L<NACL::CS::RepositoryPlacementFileCreate|lib-NACL-CS-RepositoryPlacementFileCreate-pm>, which represents
the past state of an ONTAP RepositoryPlacementFileCreate.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 constituent_group_id 

=cut

package NACL::C::RepositoryPlacementFileCreate;

use strict;
use warnings;

use NACL::CS::RepositoryPlacementFileCreate;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with OBJECT SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $RepositoryPlacementFileCreate = NACL::C::RepositoryPlacementFileCreate->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                   'constituent-group-id'   => $constituent_group_id,  
								  );

Return a new RepositoryPlacementFileCreate component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'constituent_group_id',

    # supported for backwards compatibility
    scalar => [
        {   '-read_cb' => sub {
                return (defined $_[1])
                    ? $_[1]
                    : $_[0]->constituent_group_id;
                }
        },
        'data_constituent_group'
    ],
    scalar => [
        {   '-read_cb' => sub {
                return (defined $_[1])
                    ? $_[1]
                    : $_[0]->data_constituent_group;
                }
        },
        'object_volume_group'
    ],

];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 find

    my $RepositoryPlacementFileCreate  = NACL::C::RepositoryPlacementFileCreate->find(command_interface => $ci, ...);
	my @RepositoryPlacementFileCreates = NACL::C::RepositoryPlacementFileCreate->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my RepositoryPlacementFileCreate_state = $NACL::C::RepositoryPlacementFileCreate->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::RepositoryPlacementFileCreate would return 
a NACL::CS::RepositoryPlacementFileCreate object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 modify

    NACL::C::RepositoryPlacementFileCreate->modify(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'constituent-group-id'   => $constituent_group_id, 
                                ...);
	                             
								 or

    $RepositoryPlacementFileCreate_object->modify(...);

(Class or instance method)

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'create-regular-ratio' => $string >>

Applicable for CMode CLI.

=item C<< 'create-empty-ratio' => $string >>

Applicable for CMode CLI.

=item C<< 'create-force-volume' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'constituent-group-id' => $string >>

Applicable for CMode CLI.

=item C<< 'volume' => $string >>

*Volume Name

Applicable for CMode CLI

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"repository placement file-create modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( create-regular-ratio create-empty-ratio create-force-volume

                    object-volume-group

                    volume
                    )
            ),
        },
        cli_cmd => 'repository placement file-create modify',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::RepositoryPlacementFileCreate::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'repository_placement_file_create_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

=head2 recalc

    NACL::C::RepositoryPlacementFileCreate->recalc(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'constituent-group'      => $constituent_group_id,
                                ...);
	                             
								 or

    $RepositoryPlacementFileCreate_object->recalc(...);

(Class or instance method)
This method is used to recalcluate buckets used to determine object volume placement on create.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

=item C<< 'constituent-group-id' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"repository placement file create recalc" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub recalc {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        api    => 'repository_placement_file_create_recalc',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_recalc_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::RepositoryPlacementFileCreate::recalc',
    );

    $Log->exit() if $may_exit;
} ## end sub recalc

sub _recalc_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'repository_placement_file_create_recalc',);
    $Log->exit() if $may_exit;
} ## end sub _recalc_cmode_cli

=head2 recalculate

    NACL::C::RepositoryPlacementFileCreate->recalculate(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'constituent-group-id'   => $constituent_group_id,
                                ...);
	                             
								 or

    $RepositoryPlacementFileCreate_obj->recalculate(...);

(Class or instance method)
This method is used to recalculate buckets used to determine data constituent placement on create.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'constituent-group-id' => $constituent_group_id >>


(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.



=item C<< 'volume' => $string >>

*Volume Name

Applicable for CMode CLI

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"repository placement file-create recalculate" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub recalculate {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( volume
                    )
            )
        },
        cli_cmd => 'repository placement file-create recalculate',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_recalculate_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::RepositoryPlacementFileCreate::recalculate',
    );

    $Log->exit() if $may_exit;
} ## end sub recalculate

sub _recalculate_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'repository_placement_file_create_recalculate',);
    $Log->exit() if $may_exit;
} ## end sub _recalculate_cmode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    my $pkg_or_obj = shift;
    my %opts       = validate(
        @_,
        {   command_interface => {
                type     => OBJECT,
                isa      => 'NACL::C::CommandInterface::ONTAP',
                optional => 1
            }
        }
    );
    my $command_interface = $opts{command_interface};

    my %default_spec = (
        'vserver'                => {type => SCALAR},
        'object-volume-group'    => {type => SCALAR, optional => 1},
        'data-constituent-group' => {type => SCALAR, optional => 1},
        'constituent-group-id'   => {type => SCALAR, optional => 1},
    );

    if (defined $command_interface) {
        if ($command_interface->version_manager->has_uichange(
                uichange =>
                    'repository-placement-file-create-modify-data-constituent-group',
                throw_exception => 0
            )
            )
        {
            return (
                'vserver'              => {type => SCALAR},
                'constituent-group-id' => {type => SCALAR},
            );
        } elsif (
            $command_interface->version_manager->has_uichange(
                uichange        => 'object-volume-group',
                throw_exception => 0
            )
            )
        {
            return (
                'vserver'                => {type => SCALAR},
                'data-constituent-group' => {type => SCALAR},
            );
        } else {
            return (
                'vserver'             => {type => SCALAR},
                'object-volume-group' => {type => SCALAR},
            );
        }
    } else {
        return %default_spec;
    }
} ## end sub _primary_keys_validate_spec

1;
