#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SecurityLoginPublickey Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SecurityLoginPublickey

=head1 DESCRIPTION

C<NACL::C::SecurityLoginPublickey> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SecurityLoginPublickey.  A related class is
L<NACL::CS::SecurityLoginPublickey|lib-NACL-CS-SecurityLoginPublickey-pm>, which represents
the past state of an ONTAP SecurityLoginPublickey.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 index

=head2 vserver

=head2 username

=cut

package NACL::C::SecurityLoginPublickey;

use strict;
use warnings;

use NACL::CS::SecurityLoginPublickey;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;
use NATE::BaseException qw(:try);

=head1 METHODS

=head2 new

  my $SecurityLoginPublickey = NACL::C::SecurityLoginPublickey->new(command_interface=>$ci,
                                   index =>$index,
                                   vserver =>$vserver,
                                   username =>$username,
								  );

Return a new SecurityLoginPublickey component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'index',
    scalar => 'vserver',
    scalar => 'username',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
} ## end sub init

=head2 find

    my $SecurityLoginPublickey  = NACL::C::SecurityLoginPublickey->find(command_interface => $ci, ...);
	my @SecurityLoginPublickeys = NACL::C::SecurityLoginPublickey->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $SecurityLoginPublickey_state = $NACL::C::SecurityLoginPublickey->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SecurityLoginPublickey would return 
a NACL::CS::SecurityLoginPublickey object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 delete

   NACL::C::SecurityLoginPublickey->delete(
                                command_interface => $ci,
	                             index => $index,
	                             vserver => $vserver,
	                             username => $username,
                                  ...);
	                             
								 or

    $SecurityLoginPublickey_object->delete(...);

(Class or instance method)
This method is used to delete a public key.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "index" => $index >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "vserver" => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "username" => $username >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"security login publickey delete" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        api    => 'security_login_publickey_delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_delete_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::SecurityLoginPublickey::delete',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'security_login_publickey_delete',);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

=head2 modify

   NACL::C::SecurityLoginPublickey->modify(
                                command_interface => $ci,
	                             index => $index,
	                             vserver => $vserver,
	                             username => $username,
                                  ...);
	                             
								 or

    $SecurityLoginPublickey_object->modify(...);

(Class or instance method)
This method is used to modify a public key.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "index" => $index >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "vserver" => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "username" => $username >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "comment" => $string >>

Applicable for CMode CLI.

=item C<< "purpose" => $string >>

Applicable for CMode CLI.

=item C<< "publickey" => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"security login publickey modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( comment purpose publickey
                    )
            ),
        },
        api => 'security_login_publickey_modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_modify_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::SecurityLoginPublickey::modify',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'security_login_publickey_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

=head2 create

    my $SecurityLoginPublickey_object	= NACL::C::SecurityLoginPublickey->create(
                                command_interface => $ci,
	                             index => $index,
	                             vserver => $vserver,
	                             username => $username,
                                  ...);
   
(Class method)
This method is used to add a new public key.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "index" => $index >>

(Required)

Applicable for CMode CLI.

=item C<< "vserver" => $vserver >>

(Required)

Applicable for CMode CLI.

=item C<< "username" => $username >>

(Required)

Applicable for CMode CLI.

=item C<< "comment" => $string >>

Applicable for CMode CLI.

=item C<< "purpose" => $string >>

Applicable for CMode CLI.

=item C<< "publickey" => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"security login publickey create" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( comment purpose publickey
                    )
            ),
        },
        api => 'security_login_publickey_create',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_create_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::SecurityLoginPublickey::create',
    );
    my $ret = $pkg->new(
        command_interface => $opts{command_interface},
        index             => $opts{'index'},
        vserver           => $vserver,
        username          => $opts{'username'},
    );
    $Log->exit() if $may_exit;
    return $ret;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $apiset = $opts{apiset};
    try{
       $pkg->_base_backend_cmode_cli(%opts,
          api => 'security_login_publickey_create');
    }finally{
       $apiset->get_connection()->resync();
    };
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_cli

=head2 load_from_uri

   NACL::C::SecurityLoginPublickey->load_from_uri(
                                command_interface => $ci,
	                             index => $index,
	                             vserver => $vserver,
	                             username => $username,
                                  ...);
   
(Class method)
This method is used to load one or more public keys from a URI.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "index" => $index >>

(Required)

Applicable for CMode CLI.

=item C<< "vserver" => $vserver >>

(Required)

Applicable for CMode CLI.

=item C<< "username" => $username >>

(Required)

Applicable for CMode CLI.

=item C<< "uriusername" => $string >>

Applicable for CMode CLI.

=item C<< "overwrite" => $string >>

Applicable for CMode CLI.

=item C<< "uripassword" => $string >>

Applicable for CMode CLI.

=item C<< "uri" => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"security login publickey load-from-uri" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub load_from_uri {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( uriusername overwrite uripassword uri
                    vserver username
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'security_login_publickey_load_from_uri',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_load_from_uri_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::SecurityLoginPublickey::load_from_uri',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub load_from_uri

sub _load_from_uri_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'security_login_publickey_load_from_uri',);
    $Log->exit() if $may_exit;
} ## end sub _load_from_uri_cmode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'index'    => {type => SCALAR},
        'vserver'  => {type => SCALAR},
        'username' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
