# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SnaplockComplianceClock Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SnaplockComplianceClock

=head1 DESCRIPTION

C<NACL::C::SnaplockComplianceClock> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SnaplockComplianceClock.  A related class is
L<NACL::CS::SnaplockComplianceClock|lib-NACL-CS-SnaplockComplianceClock-pm>, which represents
the past state of an ONTAP SnaplockComplianceClock.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

=cut

package NACL::C::SnaplockComplianceClock;

use strict;
use warnings;
use feature 'state';

use NACL::CS::SnaplockComplianceClock;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use NACL::C::Exceptions::SnaplockComplianceClock::AlreadyInitialized qw(:try);

=head1 METHODS

=head2 new

  my $SnaplockComplianceClock = NACL::C::SnaplockComplianceClock->new(
                                   command_interface => $ci,
                                   'node' => $node,
								  );

Return a new SnaplockComplianceClock component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'node',];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $SnaplockComplianceClock_obj  = NACL::C::SnaplockComplianceClock->find(command_interface => $ci, ...);
	my @SnaplockComplianceClock_objs = NACL::C::SnaplockComplianceClock->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my SnaplockComplianceClock_state = $SnaplockComplianceClock_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SnaplockComplianceClock would return 
a NACL::CS::SnaplockComplianceClock object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 initialize

    NACL::C::SnaplockComplianceClock->initialize(
                                command_interface => $ci,
	                            'node' => $node,
                                ...);
	                             
								 or

    $SnaplockComplianceClock_obj->initialize(...);

(Class or instance method)
This method is used to initializes the node ComplianceClock.
Implemented for CMode CLI/ZAPI, 7Mode-CLI.
Invokes snaplock-set-node-compliance-clock  for CMode Zapi non-iter.
Invokes "snaplock clock initialize" for 7Mode-CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'node' => $node >>

(Optional for class method for CMode, Not Applicable for instance method and 7Mode)
Node possible value(s) are: <nodename>,local.
For 7Mode, this is not applicable. For CMode, if this is not specified, then
it is defaulted to the node the command_interface is associated with.

=item C<< 'force' => 'true' | 'false' >>

Forces Initialization
Applicable for CMode CLI/ZAPI (non-iter), 7Mode-CLI.

=item C<< '*' >>

This method takes all other options supported by "snaplock compliance clock initialize" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::SnaplockComplianceClock::AlreadyInitialized>

This exception is thrown when a Snaplock clock is already initialized.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub initialize {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( force
                    )
            ),
        },
        cli_cmd => 'snaplock compliance-clock initialize',
    );

    # If not specified, default to the node of the command_interface
    $opts{node} //= $opts{command_interface}->node();
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_initialize_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_initialize_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
            {   method    => '_initialize_7mode_cli',
                interface => 'CLI',
                set       => '7Mode',
                zapi_type => 'none',
            },
        ],
        frontend        => 'NACL::C::SnaplockComplianceClock::initialize',
        nacl_exceptions => [qw(AlreadyInitialized)],
    );

    $Log->exit() if $may_exit;
}

sub _initialize_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'snaplock_compliance_clock_initialize',);
    $Log->exit() if $may_exit;
}

sub _initialize_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(node)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'snaplock-set-node-compliance-clock',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

sub _initialize_7mode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = $pkg->_validate_backend_opts(@args);
    my %api_args;
    $api_args{force} = $opts{force} if (defined $opts{force});
    state $prompts_answers = [
        'Is the current local system time correct?' => 'y',
        'Are you REALLY sure you want initialize the Compliance Clock?' => 'y',
    ];
    $opts{apiset}->snaplock_clock_initialize(%api_args,
        'connectrec-match_table' => $prompts_answers);
    $Log->exit() if $may_exit;
}

sub _check_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_check_non_iter(@opts, _primary_keys => [qw(node)],);
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('node' => {type => SCALAR, optional => 1},);
}

1;
