# $Id$

#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SnapmirrorSnapshotOwner Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @changes : raghaveb@netapp.com Added CMode ZAPI support.
## @status shared
## @pod here

=head1 NAME

NACL::C::SnapmirrorSnapshotOwner

=head1 DESCRIPTION

C<NACL::C::SnapmirrorSnapshotOwner> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SnapmirrorSnapshotOwner.  A related class is
L<NACL::CS::SnapmirrorSnapshotOwner|lib-NACL-CS-SnapmirrorSnapshotOwner-pm>, which represents
the past state of an ONTAP SnapmirrorSnapshotOwner.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 snapshot

=head2 volume

=head2 vserver

=cut

package NACL::C::SnapmirrorSnapshotOwner;

use strict;
use warnings;

use NACL::CS::SnapmirrorSnapshotOwner;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $SnapmirrorSnapshotOwner = NACL::C::SnapmirrorSnapshotOwner->new(
                                   command_interface => $ci,
                                   'snapshot' => $snapshot,
                                   'volume' => $volume,
                                   'vserver' => $vserver,
								  );

Return a new SnapmirrorSnapshotOwner component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'snapshot',
    scalar => 'volume',
    scalar => 'vserver',
];

=head2 find

    my $SnapmirrorSnapshotOwner_obj  = NACL::C::SnapmirrorSnapshotOwner->find(command_interface => $ci, ...);
	my @SnapmirrorSnapshotOwner_objs = NACL::C::SnapmirrorSnapshotOwner->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my SnapmirrorSnapshotOwner_state = $SnapmirrorSnapshotOwner_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SnapmirrorSnapshotOwner would return 
a NACL::CS::SnapmirrorSnapshotOwner object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 create

    my $SnapmirrorSnapshotOwner_obj	= NACL::C::SnapmirrorSnapshotOwner->create(
                                command_interface => $ci,
	                            'snapshot' => $snapshot,
	                            'volume' => $volume,
	                            'vserver' => $vserver,
                                ...);
   
(Class method)
This method is used to add an owner to preserve a Snapshot copy for a SnapMirror Mirror to Vault cascade configuration.

Uses CMode CLI/ZAPI .

Invokes "snapmirror-snapshot-owner-create" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'snapshot' => $snapshot >>

(Required)
Snapshot Copy Name

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: snapshot

=item C<< 'volume' => $volume >>

(Required)
Volume Name

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: volume

=item C<< 'vserver' => $vserver >>

(Required)
Vserver Name

Applicable for CMode CLI/ZAPI

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'owner' => $string >>

Snapshot Copy Owner Name

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: snapshot-owner-name

=item C<< '*' >>

This method takes all other options supported by "snapmirror snapshot owner create" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( owner
                    )
            ),
        },
        cli_cmd => 'snapmirror snapshot-owner create',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_create_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SnapmirrorSnapshotOwner::create',
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        snapshot          => $opts{'snapshot'},
        volume            => $opts{'volume'},
        vserver           => $vserver,
    );
    $Log->exit() if $may_exit;
    return $obj;
}

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'snapmirror_snapshot_owner_create',);
    $Log->exit() if $may_exit;
}

sub _create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_zapi(@opts,
        api    => 'snapmirror_snapshot_owner_create',
        copy   => [qw(vserver volume snapshot)],
        map    => {owner => 'snapshot-owner-name'},
    );
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_zapi

=head2 delete

    NACL::C::SnapmirrorSnapshotOwner->delete(
                                command_interface => $ci,
	                            'snapshot' => $snapshot,
	                            'volume' => $volume,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $SnapmirrorSnapshotOwner_obj->delete(...);

(Class or instance method)
This method is used to delete an owner used to preserve a Snapshot copy for a SnapMirror Mirror to Vault cascade configuration.

Uses CMode CLI/ZAPI .

Invokes "snapmirror-snapshot-owner-destroy" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'snapshot' => $snapshot >>

(Required for class method, Not Applicable for instance method)
Snapshot Copy Name

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: snapshot

=item C<< 'volume' => $volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: volume

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver Name

Applicable for CMode CLI/ZAPI

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'owner' => $string >>

Snapshot Copy Owner Name

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: snapshot-owner-name

=item C<< '*' >>

This method takes all other options supported by "snapmirror snapshot owner delete" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( owner
                    )
            ),
        },
        cli_cmd => 'snapmirror snapshot-owner delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_delete_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SnapmirrorSnapshotOwner::delete',
    );

}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'snapmirror_snapshot_owner_delete',);
    $Log->exit() if $may_exit;
}

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_zapi(@opts,
        api    => 'snapmirror_snapshot_owner_destroy',
        copy   => [qw(vserver volume snapshot)],
        map    => {owner => 'snapshot-owner-name'},
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'snapshot' => {type => SCALAR},
        'volume'   => {type => SCALAR},
        'vserver'  => {type => SCALAR},
    );
}

1;
