# $Id: //depot/prod/test/nacldev/lib/NACL/C/StatisticsArchiveConfig.pm#9 $

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsArchiveConfig Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, pkj@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::StatisticsArchiveConfig

=head1 DESCRIPTION

C<NACL::C::StatisticsArchiveConfig> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP StatisticsArchiveConfig.  A related class is
L<NACL::CS::StatisticsArchiveConfig|lib-NACL-CS-StatisticsArchiveConfig-pm>, which represents
the past state of an ONTAP StatisticsArchiveConfig.
However, since it does not have any primary keys, 'find' and 'state' do not
work for this component. (This component is considered a 'singleton',
i.e. there is only one row shown by the relevant 'show' command)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::StatisticsArchiveConfig;

use strict;
use warnings;

use NACL::CS::StatisticsArchiveConfig;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $StatisticsArchiveConfig = NACL::C::StatisticsArchiveConfig->new(
                                   command_interface => $ci,
                                  );

Return a new StatisticsArchiveConfig component object with the given attributes.

=cut

=head2 find

    my $StatisticsArchiveConfig_obj  = NACL::C::StatisticsArchiveConfig->find(command_interface => $ci, ...);
    my @StatisticsArchiveConfig_objs = NACL::C::StatisticsArchiveConfig->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my StatisticsArchiveConfig_state = $StatisticsArchiveConfig_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::StatisticsArchiveConfig would return
a NACL::CS::StatisticsArchiveConfig object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 modify

    NACL::C::StatisticsArchiveConfig->modify(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to modify cluster-wide Performance Archive configuration.

Uses a CMode CLI/ZAPI APISet.
  Invokes 'perf-archive-config-modify' API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'datastore-file-rotation' => $string >>

  Applicable for CMode CLI/ZAPI
  Maps to:
    CM ZAPI: datastore-file-rotation

=item C<< 'datastore-max-size' => $string >>

  Applicable for CMode CLI/ZAPI
  Maps to:
    CM ZAPI: datastore-max-size

=item C<< 'max-counter-bw' => $string >>

  Applicable for CMode CLI/ZAPI
  Maps to:
    CM ZAPI: max-counter-bw

=item C<< 'cleaner-period' => $string >>

    Applicable for CMode CLI

=item C<< 'is-enabled' => $string >>

  Applicable for CMode CLI/ZAPI
  Maps to:
    CM ZAPI: is-enabled

=item C<< 'min-buffer-size' => $string >>

  Applicable for CMode CLI

=item C<< 'max-buffer-size' => $string >>

Applicable for CMode CLI/ZAPI

=item C<< 'buffer-size' => $string >>

  Applicable for CMode CLI

=item C<< 'max-cleaner-period' => $string >>

  Applicable for CMode CLI

=item C<< 'min-cleaner-period' => $string >>

  Applicable for CMode CLI

=item C<< 'datastore-max-retention' => $string >>

  Applicable for CMode CLI/ZAPI
  Maps to:
    CM ZAPI: datastore-max-retention

=item C<< 'collector-period' => $string >>

  Applicable only for CMode CLI

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'datastore-max-percent' => $string >>

*Maximum Percentage of Root Volume Used for Performance Archive Data
  Applicable for CMode CLI/ZAPI
  Maps to:
    CM ZAPI: datastore-max-percent

=item C<< 'extended_query' => $string >>

(Optional)
  Applicable only for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'perfstat-sampling-period' => $string >>

Minutes Between Perfstat Collection ranges from 0 to 60
Applicable for CMode CLI

=item C<< 'reset-ccma-rdb' => $string >>

Reset CM Archiver and CM Preset RDB Tables
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"statistics archive config modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( datastore-file-rotation datastore-max-size max-counter-bw cleaner-period
                    is-enabled min-buffer-size max-buffer-size buffer-size max-cleaner-period
                    min-cleaner-period datastore-max-retention collector-period

                    datastore-max-percent

                    perfstat-sampling-period

                    reset-ccma-rdb
                    )
            ),
        },
        cli_cmd => 'statistics archive config modify',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::StatisticsArchiveConfig::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'statistics_archive_config_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $allowed_cmode_options = [
        qw( datastore-file-rotation datastore-max-size max-counter-bw
            is-enabled datastore-max-retention datastore-max-percent
            )
    ];

    $pkg->_base_backend_cmode_zapi(@args,
        api    => 'perf_archive_config_modify',
        copy   => $allowed_cmode_options,
    );

    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

1;
