#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsCatalogInstance Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::StatisticsCatalogInstance

=head1 DESCRIPTION

C<NACL::C::StatisticsCatalogInstance> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP StatisticsCatalogInstance.  A related class is
L<NACL::CS::StatisticsCatalogInstance|lib-NACL-CS-StatisticsCatalogInstance-pm>, which represents
the past state of an ONTAP StatisticsCatalogInstance.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 object

=head2 filter

=head2 instance

=cut

package NACL::C::StatisticsCatalogInstance;

use strict;
use warnings;

use NACL::CS::StatisticsCatalogInstance;
use NACL::ComponentUtils
    qw (_optional_scalars Dumper _make_attribute_readonly);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $StatisticsCatalogInstance = NACL::C::StatisticsCatalogInstance->new(
                                   command_interface => $ci,
                                   'object' => $object,
                                   'filter' => $filter,
                                   'instance' => $instance,
								  );

Return a new StatisticsCatalogInstance component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => [
        {   _make_attribute_readonly($_[1], $_[2]),
            '-read_cb' => sub { $_[0]->object }
        },
        'objectName'
    ],
    scalar => [
        {   _make_attribute_readonly($_[1], $_[2]),
            '-read_cb' => sub {
                $_[0]->instance;
                }
        },
        'outputName'
    ],
    scalar => [
        {   _make_attribute_readonly($_[1], $_[2]),
            '-read_cb' => sub {
                $_[0]->filter;
                }
        },
        'filter_data'
    ],
    scalar => 'object',
    scalar => 'filter',
    scalar => 'instance',
];

=head2 find

    my $StatisticsCatalogInstance_obj  = NACL::C::StatisticsCatalogInstance->find(command_interface => $ci, ...);
	my @StatisticsCatalogInstance_objs = NACL::C::StatisticsCatalogInstance->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my StatisticsCatalogInstance_state = $StatisticsCatalogInstance_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::StatisticsCatalogInstance would return 
a NACL::CS::StatisticsCatalogInstance object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'object'   => {type => SCALAR},
        'instance' => {type => SCALAR},
    );
}

1;
