# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsPresetDetail Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::StatisticsPresetDetail

=head1 DESCRIPTION

C<NACL::C::StatisticsPresetDetail> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP StatisticsPresetDetail.  A related class is
L<NACL::CS::StatisticsPresetDetail|lib-NACL-CS-StatisticsPresetDetail-pm>, which represents
the past state of an ONTAP StatisticsPresetDetail.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 object

=head2 vserver

=head2 sample_period

=head2 preset

=cut

package NACL::C::StatisticsPresetDetail;

use strict;
use warnings;

use NACL::CS::StatisticsPresetDetail;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $StatisticsPresetDetail = NACL::C::StatisticsPresetDetail->new(
                                   command_interface => $ci,
                                   'object' => $object,
                                   'vserver' => $vserver,
                                   'sample-period' => $sample_period,
                                   'preset' => $preset,
								  );

Return a new StatisticsPresetDetail component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'object',
    scalar => 'vserver',
    scalar => 'sample_period',
    scalar => 'preset',
];

=head2 find

    my $StatisticsPresetDetail_obj  = NACL::C::StatisticsPresetDetail->find(command_interface => $ci, ...);
	my @StatisticsPresetDetail_objs = NACL::C::StatisticsPresetDetail->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my StatisticsPresetDetail_state = $StatisticsPresetDetail_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::StatisticsPresetDetail would return 
a NACL::CS::StatisticsPresetDetail object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'object'        => {type => SCALAR},
        'vserver'       => {type => SCALAR, optional => 1},
        'sample-period' => {type => SCALAR},
        'preset'        => {type => SCALAR},
    );
}

1;
