
#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsRdbTransactions Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::StatisticsRdbTransactions

=head1 DESCRIPTION

C<NACL::C::StatisticsRdbTransactions> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP StatisticsRdbTransactions.  A related class is
L<NACL::CS::StatisticsRdbTransactions|lib-NACL-CS-StatisticsRdbTransactions-pm>, which represents
the past state of an ONTAP StatisticsRdbTransactions.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 ring

=head2 period_begin

=head2 reporter

=cut

package NACL::C::StatisticsRdbTransactions;

use strict;
use warnings;

use NACL::CS::StatisticsRdbTransactions;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $StatisticsRdbTransactions = NACL::C::StatisticsRdbTransactions->new(
                                   command_interface => $ci,
                                   'ring' => $ring,
                                   'period-begin' => $period_begin,
                                   'reporter' => $reporter,
								  );

Return a new StatisticsRdbTransactions component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'ring',
    scalar => 'period_begin',
    scalar => 'reporter',
];

=head2 find

    my $StatisticsRdbTransactions_obj  = NACL::C::StatisticsRdbTransactions->find(command_interface => $ci, ...);
	my @StatisticsRdbTransactions_objs = NACL::C::StatisticsRdbTransactions->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my StatisticsRdbTransactions_state = $StatisticsRdbTransactions_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::StatisticsRdbTransactions would return 
a NACL::CS::StatisticsRdbTransactions object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 show_details

    my $show_details_obj = NACL::C::StatisticsRdbTransactions->show_details(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_details_objs = NACL::C::StatisticsRdbTransactions->show_details(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_details_obj = $StatisticsRdbTransactions_obj->show_details(); 

(Class or Instance method)
This method returns objects of the type L<NACL::CS::StatisticsRdbTransactionsShowDetails|lib-NACL-CS-StatisticsRdbTransactionsShowDetails-pm>.

This method accepts all the parameters accepted by L<fetch|lib-NACL-CS-ComponentState-pm/fetch> 
(requested_fields, filter, allow_empty) and has all of the other properties of 
fetch methods (callable in scalar or list context, throws a NoElementsFound 
exception if no matching elements are found)

=cut

sub show_details {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_handle_obj_cs_like_calls(@_);
    require NACL::CS::StatisticsRdbTransactionsShowDetails;
    my @state_objs
        = NACL::CS::StatisticsRdbTransactionsShowDetails->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub show_details

=head2 test

    NACL::C::StatisticsRdbTransactions->test(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to generates RDB transactions..

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'held-time' => $string >>

Applicable for CMode CLI.

=item C<< 'num-commit' => $string >>

Applicable for CMode CLI.

=item C<< 'rdb_process' => $string >>

Applicable for CMode CLI.

=item C<< 'num-abort' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub test {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with(
        params          => \@_,
        additional_spec => {
            _optional_scalars(
                qw( held-time num-commit rdb_process num-abort
                    )
            ),
        },
        ignore_primary_keys => 1,
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_test_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub test

sub _test_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg  = shift;
    my %opts = $pkg->_validate_backend_opts(@_);

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( held-time num-commit rdb_process num-abort
            extended_query )
    ];
    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $pkg->_api_call_log_debug_opts(
        api      => 'statistics_rdb_transactions_test',
        api_opts => \%cmode_args
    );

    $apiset->statistics_rdb_transactions_test(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _test_cmode_cli

=head2 show_summary_by_label

    my $show_summary_by_label_obj = NACL::C::StatisticsRdbTransactions->show_summary_by_label(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_summary_by_label_objs = NACL::C::StatisticsRdbTransactions->show_summary_by_label(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_summary_by_label_obj = $StatisticsRdbTransactions_obj->show_summary_by_label(); 

(Class or Instance method)
This method returns objects of the type L<NACL::CS::StatisticsRdbTransactionsShowSummaryByLabel|lib-NACL-CS-StatisticsRdbTransactionsShowSummaryByLabel-pm>.

This method accepts all the parameters accepted by L<fetch|lib-NACL-CS-ComponentState-pm/fetch> 
(requested_fields, filter, allow_empty) and has all of the other properties of 
fetch methods (callable in scalar or list context, throws a NoElementsFound 
exception if no matching elements are found)

=cut

sub show_summary_by_label {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_handle_obj_cs_like_calls(@_);
    require NACL::CS::StatisticsRdbTransactionsShowSummaryByLabel;
    my @state_objs
        = NACL::CS::StatisticsRdbTransactionsShowSummaryByLabel->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub show_summary_by_label


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'ring'         => {type => SCALAR},
        'period-begin' => {type => SCALAR},
        'reporter'     => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
