#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageAggregateRelocation Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::StorageAggregateRelocation

=head1 DESCRIPTION

C<NACL::C::StorageAggregateRelocation> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP StorageAggregateRelocation.  A related class is
L<NACL::CS::StorageAggregateRelocation|lib-NACL-CS-StorageAggregateRelocation-pm>, which represents
the past state of an ONTAP StorageAggregateRelocation.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

Name of the Node that currently owns the aggregate

=head2 aggregate

Aggregate Name

=cut

package NACL::C::StorageAggregateRelocation;

use strict;
use warnings;

use NACL::CS::StorageAggregateRelocation;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $StorageAggregateRelocation = NACL::C::StorageAggregateRelocation->new(
                                   command_interface => $ci,
                                   'node' => $node,
								  );

Return a new StorageAggregateRelocation component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'node',
    scalar => 'aggregate'
];

=head2 find

    my $StorageAggregateRelocation_obj  = NACL::C::StorageAggregateRelocation->find(command_interface => $ci, ...);
	my @StorageAggregateRelocation_objs = NACL::C::StorageAggregateRelocation->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my StorageAggregateRelocation_state = $StorageAggregateRelocation_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::StorageAggregateRelocation would return 
a NACL::CS::StorageAggregateRelocation object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 start

    my $StorageAggregateRelocation_obj	= NACL::C::StorageAggregateRelocation->start(
                                command_interface => $ci,
	                            'node' => $node,
                                ...);

(Class method)
This method is used to relocate aggregates to specified destination. In an array
context it returns the list of component objects. In a scalar context it returns
a component object for just one element.

Uses a CMode CLI/ZAPI.

Invokes "aggr-relocation" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required)

Maps to:

 CMode ZAPI:

    <aggr-relocation>
      <source-node-name>$value</source-node-name>
     <aggr-relocation>

Applicable for CMode CLI/ZAPI.

=item C<< 'override-vetoes' => $string >>

Maps to:

 CMode ZAPI:

    <aggr-relocation>
      <is-override-vetoes>$value</is-override-vetoes>
    <aggr-relocation>

Applicable for CMode CLI/ZAPI.

=item C<< 'relocate-to-higher-version' => $string >>

Maps to:

 CMode ZAPI:

    <aggr-relocation>
      <is-relocate-to-higher-version>$value</is-relocate-to-higher-version>
    <aggr-relocation>

Applicable for CMode CLI/ZAPI.

=item C<< 'destination' => $string >>

Maps to:

 CMode ZAPI:

    <aggr-relocation>
      <destination-node-name>$value</destination-node-name>
    <aggr-relocation>

Applicable for CMode CLI/ZAPI.

=item C<< 'ndo-controller-upgrade' => $string >>

Maps to:

 CMode ZAPI:

    <aggr-relocation>
      <is-ndo-controller-upgrade>$value</is-ndo-controller-upgrade>
    <aggr-relocation>

Applicable for CMode CLI/ZAPI.

=item C<< 'override-destination-checks' => $string >>

Maps to:

 CMode ZAPI:

    <aggr-relocation>
      <is-override-destination-checks>$value</is-override-destination-checks>
    <aggr-relocation>

Applicable for CMode CLI/ZAPI.

=item C<< 'aggregate-list' => [ $aggregate-1, $aggregate-2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"storage aggregate relocation start" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub start {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'node'           => {type => SCALAR},
            'aggregate-list' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( override-vetoes relocate-to-higher-version destination
                    ndo-controller-upgrade override-destination-checks
                    node
                    )
            ),
        },
        cli_cmd => 'storage aggregate relocation start',
    );
    my @components = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_start_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_start_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::StorageAggregateRelocation::start',
    );

    $Log->exit() if $may_exit;
    return wantarray ? @components : $components[0];
} ## end sub start

sub _start_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    $pkg->_base_backend_cmode_cli (
            %opts,
            api     => 'storage_aggregate_relocation_start',
        );
    Tharn::sleep 2;
    my @arl_c;
    foreach my $aggr (@{$opts{'aggregate-list'}}) {
        push @arl_c,
             $pkg->new(
                     command_interface => $opts{command_interface},
                     node              => $opts{'node'},
                     aggregate         => $aggr
                     );
    }
    $Log->exit() if $may_exit;
    return @arl_c;
} ## end sub _start_cmode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        node      => {type => SCALAR},
        aggregate => {type => SCALAR, optional => 1},
    );
}

sub _start_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;

    my %args              = @opts;
    my $command_interface = $args{command_interface};

    $pkg->_base_backend_cmode_zapi(
        @opts,
        api => 'aggr-relocation',
        map => {
            'node'                        => 'source-node-name',
            'destination'                 => 'destination-node-name',
            'ndo-controller-upgrade'      => 'is-ndo-controller-upgrade',
            'override-destination-checks' => 'is-override-destination-checks',
            'override-vetoes'             => 'is-override-vetoes',
            'relocate-to-higher-version'  => 'is-relocate-to-higher-version',
        },
        copy => [qw(aggregate-list)],
    );

    my @arl_c;
    my @var = @{$args{'aggregate-list'}};
    foreach my $aggr (@var) {
        push @arl_c,
            $pkg->new(
            command_interface => $command_interface,
            node              => $args{'node'},
            aggregate         => $aggr
            );
    }

    $Log->exit() if $may_exit;
    return @arl_c;

}

1;
