# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageFailoverHwassistStats Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::StorageFailoverHwassistStats

=head1 DESCRIPTION

C<NACL::C::StorageFailoverHwassistStats> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP StorageFailoverHwassistStats.  A related class is
L<NACL::CS::StorageFailoverHwassistStats|lib-NACL-CS-StorageFailoverHwassistStats-pm>, which represents
the past state of an ONTAP StorageFailoverHwassistStats.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

=cut

package NACL::C::StorageFailoverHwassistStats;

use strict;
use warnings;

use NACL::CS::StorageFailoverHwassistStats;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $StorageFailoverHwassistStats = NACL::C::StorageFailoverHwassistStats->new(
                                   command_interface => $ci,
                                   'node' => $node,
                                  );

Return a new StorageFailoverHwassistStats component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'node',];

=head2 find

    my $StorageFailoverHwassistStats_obj  = NACL::C::StorageFailoverHwassistStats->find(command_interface => $ci, ...);
    my @StorageFailoverHwassistStats_objs = NACL::C::StorageFailoverHwassistStats->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my StorageFailoverHwassistStats_state = $StorageFailoverHwassistStats_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::StorageFailoverHwassistStats would return
a NACL::CS::StorageFailoverHwassistStats object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 clear

    NACL::C::StorageFailoverHwassistStats->clear(
                                command_interface => $ci,
                                'node' => $node,
                                ...);

                                 or

    $StorageFailoverHwassistStats_obj->clear(...);

(Class or instance method)
This method is used to clear the hwassist statistics.

Uses a CMode CLI/ZAPI, 7Mode CLI APISet.
  Invokes 'cf-hwassist-stats-clear' API for CMode ZAPI.
  Invokes 'cf hw assist stats clear' command for 7Mode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)
  Applicable for CMode CLI/ZAPI.
  Maps to:
    CM ZAPI: node

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'extended_query' => $string >>

(Optional)
  Applicable only for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"storage failover hwassist stats clear" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub clear {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( node
                    )
            )
        },
        cli_cmd => 'storage failover hwassist stats clear',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_clear_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_clear_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
            {   method    => "_clear_7mode_cli",
                interface => "CLI",
                set       => "7Mode",
            },

        ],
        frontend => 'NACL::C::StorageFailoverHwassistStats::clear',
    );

    $Log->exit() if $may_exit;
} ## end sub clear

sub _clear_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'storage_failover_hwassist_stats_clear',);
    $Log->exit() if $may_exit;
} ## end sub _clear_cmode_cli

sub _clear_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_zapi(
        @opts,
        copy => [qw(node extended_query)],
        api  => 'cf_hwassist_stats_clear',
    );
    $Log->exit() if $may_exit;
} ## end sub _clear_cmode_zapi

sub _clear_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg  = shift;
    my %opts = validate_with(
        params      => \@_,
        spec        => $pkg->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    delete $opts{node};
    my $apiset = delete $opts{apiset};

    $apiset->cf_hw_assist_stats_clear(%opts);
    $Log->exit() if $may_exit;
} ## end sub _clear_7mode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('node' => {type => SCALAR, optional => 1},);
}

1;
