# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageShelfAcpModule Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::StorageShelfAcpModule

=head1 DESCRIPTION

C<NACL::C::StorageShelfAcpModule> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP StorageShelfAcpModule.  A related class is
L<NACL::CS::StorageShelfAcpModule|lib-NACL-CS-StorageShelfAcpModule-pm>, which represents
the past state of an ONTAP StorageShelfAcpModule.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

=head2 mac_enaddr

=cut

package NACL::C::StorageShelfAcpModule;

use strict;
use warnings;

use NACL::CS::StorageShelfAcpModule;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $StorageShelfAcpModule = NACL::C::StorageShelfAcpModule->new(
                                   command_interface => $ci,
                                   'node' => $node,
                                   'mac-address' => $mac_addr,
								  );

Return a new StorageShelfAcpModule component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'node',
    scalar => 'mac_address',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $StorageShelfAcpModule_obj  = NACL::C::StorageShelfAcpModule->find(command_interface => $ci, ...);
	my @StorageShelfAcpModule_objs = NACL::C::StorageShelfAcpModule->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my StorageShelfAcpModule_state = $StorageShelfAcpModule_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::StorageShelfAcpModule would return 
a NACL::CS::StorageShelfAcpModule object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'node'       => {type => SCALAR},
        'mac-address' => {type => SCALAR},
    );
}

1;
