# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageShelfError Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::StorageShelfError

=head1 DESCRIPTION

C<NACL::C::StorageShelfError> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP StorageShelfError.  A related class is
L<NACL::CS::StorageShelfError|lib-NACL-CS-StorageShelfError-pm>, which represents
the past state of an ONTAP StorageShelfError.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 shelf_uuid

=head2 node

=head2 shelf

=cut

package NACL::C::StorageShelfError;

use strict;
use warnings;

use NACL::CS::StorageShelfError;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $StorageShelfError = NACL::C::StorageShelfError->new(
                                   command_interface => $ci,
                                   'shelf-uid' => $shelf_uid,
                                   'node' => $node,
                                   'shelf' => $shelf,
								  );

Return a new StorageShelfError component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'shelf_uid',
    scalar => 'node',
    scalar => 'shelf',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $StorageShelfError_obj  = NACL::C::StorageShelfError->find(command_interface => $ci, ...);
	my @StorageShelfError_objs = NACL::C::StorageShelfError->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my StorageShelfError_state = $StorageShelfError_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::StorageShelfError would return 
a NACL::CS::StorageShelfError object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'shelf-uid' => {type => SCALAR},
        'node'       => {type => SCALAR},
        'shelf'      => {type => SCALAR},
    );
}

1;
