# $Id: //depot/prod/test/main/lib/NACL/C/Switch/Utils.pm#1 $

#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Switch Component Utility methods
## @author rawat@netapp.com
## @status shared
## @pod here

package NACL::C::Switch::Utils;

=head1 NAME

NACL::C::Switch::Utils

=head1 DESCRIPTION

C<NACL::C::Switch::Utils> is a collection of utility methods 
for switch components and component states

=cut

BEGIN {
    use Exporter qw(import);
    our @EXPORT_OK
        = qw(_exit_config_modes_cisconetwork);
}

use NACL::APISet::Exceptions::CommandFailedException qw(:try);
use Params::Validate qw(validate_with);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

sub _exit_config_modes_cisconetwork {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %args = validate_with(
        params => \@args,
        spec   => {
            apiset => { isa  => "NACL::APISet" },
        },
    );

    my $apiset = $args{apiset};
    try {
        $apiset->end();
    }
    catch NACL::APISet::Exceptions::CommandFailedException with {
        # Dont do anything if exception is thrown.
    };

    $Log->exit() if $may_exit;
}

1;
