# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemHealthAutosupportTriggerHistory Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemHealthAutosupportTriggerHistory

=head1 DESCRIPTION

C<NACL::C::SystemHealthAutosupportTriggerHistory> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemHealthAutosupportTriggerHistory.  A related class is
L<NACL::CS::SystemHealthAutosupportTriggerHistory|lib-NACL-CS-SystemHealthAutosupportTriggerHistory-pm>, which represents
the past state of an ONTAP SystemHealthAutosupportTriggerHistory.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

=head2 alert_id

=head2 alerting_resource

=head2 monitor

=cut

package NACL::C::SystemHealthAutosupportTriggerHistory;

use strict;
use warnings;

use NACL::CS::SystemHealthAutosupportTriggerHistory;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $SystemHealthAutosupportTriggerHistory = NACL::C::SystemHealthAutosupportTriggerHistory->new(
                                   command_interface => $ci,
                                   'node' => $node,
                                   'alert-id' => $alert_id,
                                   'alerting-resource' => $alerting_resource,
                                   'monitor' => $monitor,
								  );

Return a new SystemHealthAutosupportTriggerHistory component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'node',
    scalar => 'alert_id',
    scalar => 'alerting_resource',
    scalar => 'monitor',
];

=head2 find

    my $SystemHealthAutosupportTriggerHistory_obj  = NACL::C::SystemHealthAutosupportTriggerHistory->find(command_interface => $ci, ...);
	my @SystemHealthAutosupportTriggerHistory_objs = NACL::C::SystemHealthAutosupportTriggerHistory->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my SystemHealthAutosupportTriggerHistory_state = $SystemHealthAutosupportTriggerHistory_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemHealthAutosupportTriggerHistory would return 
a NACL::CS::SystemHealthAutosupportTriggerHistory object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 create

    my $SystemHealthAutosupportTriggerHistory_obj	= NACL::C::SystemHealthAutosupportTriggerHistory->create(
                                command_interface => $ci,
	                            'node' => $node,
	                            'alert-id' => $alert_id,
	                            'alerting-resource' => $alerting_resource,
	                            'monitor' => $monitor,
                                ...);
   
(Class method)
This method is used to create an entry in AutoSupport history table.
Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required)
Node possible value(s) are, <nodename>,local
Applicable for CMode CLI

=item C<< 'alert-id' => $alert_id >>

(Required)
Alert ID
Applicable for CMode CLI

=item C<< 'alerting-resource' => $alerting_resource >>

(Required)
Alerting Resource
Applicable for CMode CLI

=item C<< 'monitor' => $monitor >>

(Required)
Monitor
Applicable for CMode CLI

=item C<< 'autosupport-triggered' => $string >>

AutoSupport Triggered possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'alert-clear-time' => $string >>

Alert Clear Time
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "system health autosupport trigger history create" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'cmd_execution_time' => {type => SCALARREF, optional => 1},
            _optional_scalars(
                qw( autosupport-triggered

                    alert-clear-time
                    )
            ),
        },
        api => 'system_health_autosupport_trigger_history_create',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemHealthAutosupportTriggerHistory::create',
    );

    my $obj = $pkg->new(
        command_interface => $opts{'command_interface'},
        node              => $opts{'node'},
        alert_id          => $opts{'alert-id'},
        alerting_resource => $opts{'alerting-resource'},
        monitor           => $opts{'monitor'},
    );
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_health_autosupport_trigger_history_create',);
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_cli

=head2 delete

    NACL::C::SystemHealthAutosupportTriggerHistory->delete(
                                command_interface => $ci,
	                            'node' => $node,
	                            'alert-id' => $alert_id,
	                            'alerting-resource' => $alerting_resource,
	                            'monitor' => $monitor,
                                ...);
	                             
								 or

    $SystemHealthAutosupportTriggerHistory_obj->delete(...);

(Class or instance method)
This method is used to delete an entry in AutoSupport history table.
Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)
Node possible value(s) are, <nodename>,local
Applicable for CMode CLI

=item C<< 'alert-id' => $alert_id >>

(Required for class method, Not Applicable for instance method)
Alert ID
Applicable for CMode CLI

=item C<< 'alerting-resource' => $alerting_resource >>

(Required for class method, Not Applicable for instance method)
Alerting Resource
Applicable for CMode CLI

=item C<< 'monitor' => $monitor >>

(Required for class method, Not Applicable for instance method)
Monitor
Applicable for CMode CLI

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by "system health autosupport trigger history delete" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        additional_spec =>
            {'cmd_execution_time' => {type => SCALARREF, optional => 1},},
        api => 'system_health_autosupport_trigger_history_delete',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemHealthAutosupportTriggerHistory::delete',
    );

    $Log->exit() if $may_exit;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'system_health_autosupport_trigger_history_delete',);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

=head2 modify

    NACL::C::SystemHealthAutosupportTriggerHistory->modify(
                                command_interface => $ci,
	                            'node' => $node,
	                            'alert-id' => $alert_id,
	                            'alerting-resource' => $alerting_resource,
	                            'monitor' => $monitor,
                                ...);
	                             
								 or

    $SystemHealthAutosupportTriggerHistory_obj->modify(...);

(Class or instance method)
This method is used to modify an entry in AutoSupport history table.
Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)
Node possible value(s) are, <nodename>,local
Applicable for CMode CLI

=item C<< 'alert-id' => $alert_id >>

(Required for class method, Not Applicable for instance method)
Alert ID
Applicable for CMode CLI

=item C<< 'alerting-resource' => $alerting_resource >>

(Required for class method, Not Applicable for instance method)
Alerting Resource
Applicable for CMode CLI

=item C<< 'monitor' => $monitor >>

(Required for class method, Not Applicable for instance method)
Monitor
Applicable for CMode CLI

=item C<< 'autosupport-triggered' => $string >>

AutoSupport Triggered possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'alert-clear-time' => $string >>

Alert Clear Time
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "system health autosupport trigger history modify" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'cmd_execution_time' => {type => SCALARREF, optional => 1},
            _optional_scalars(
                qw( autosupport-triggered

                    alert-clear-time
                    )
            ),
        },
        api => 'system_health_autosupport_trigger_history_modify',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemHealthAutosupportTriggerHistory::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'system_health_autosupport_trigger_history_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

=head2 update

    NACL::C::SystemHealthAutosupportTriggerHistory->update(
                                command_interface => $ci,
                                ...);
   
(Class method)
Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'poll-interval' => $string >>

Polling interval
Applicable for CMode CLI

=item C<< 'history-interval' => $string >>

History interval
Applicable for CMode CLI

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by "system health autosupport trigger history update" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub update {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'cmd_execution_time' => {type => SCALARREF, optional => 1},
            _optional_scalars(
                qw( poll-interval history-interval
                    )
            ),
        },
        ignore_primary_keys => 1,
        api => 'system_health_autosupport_trigger_history_update',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_update_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemHealthAutosupportTriggerHistory::update',
    );

    $Log->exit() if $may_exit;
} ## end sub update

sub _update_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_health_autosupport_trigger_history_update',);
    $Log->exit() if $may_exit;
} ## end sub _update_cmode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'node'              => {type => SCALAR},
        'alert-id'          => {type => SCALAR},
        'alerting-resource' => {type => SCALAR},
        'monitor'           => {type => SCALAR},
    );
}

1;
