# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemHealthClusterSwitch Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemHealthClusterSwitch

=head1 DESCRIPTION

C<NACL::C::SystemHealthClusterSwitch> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemHealthClusterSwitch.  A related class is
L<NACL::CS::SystemHealthClusterSwitch|lib-NACL-CS-SystemHealthClusterSwitch-pm>, which represents
the past state of an ONTAP SystemHealthClusterSwitch.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 device

=cut

package NACL::C::SystemHealthClusterSwitch;

use strict;
use warnings;

use NACL::CS::SystemHealthClusterSwitch;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $SystemHealthClusterSwitch = NACL::C::SystemHealthClusterSwitch->new(
                                   command_interface => $ci,
                                   'device' => $device,
								  );

Return a new SystemHealthClusterSwitch component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'device',];

=head2 find

    my $SystemHealthClusterSwitch_obj  = NACL::C::SystemHealthClusterSwitch->find(command_interface => $ci, ...);
	my @SystemHealthClusterSwitch_objs = NACL::C::SystemHealthClusterSwitch->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my SystemHealthClusterSwitch_state = $SystemHealthClusterSwitch_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemHealthClusterSwitch would return 
a NACL::CS::SystemHealthClusterSwitch object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 delete

    NACL::C::SystemHealthClusterSwitch->delete(
                                command_interface => $ci,
	                            'device' => $device,
                                ...);
	                             
								 or

    $SystemHealthClusterSwitch_obj->delete(...);

(Class or instance method)
This method is used to delete information about a cluster switch or management switch.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'device' => $device >>

(Required for class method, Not Applicable for instance method)
Remote SNMP Agent

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'force' => $string >>

Force Delete
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"system health cluster-switch delete" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        api    => 'system_health_cluster_switch_delete',
        ,
        additional_spec => {
            _optional_scalars(
                qw( force
                    )
            )
        },
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemHealthClusterSwitch::delete',
    );

    $Log->exit() if $may_exit;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'system_health_cluster_switch_delete',);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

=head2 create

    my $SystemHealthClusterSwitch_obj	= NACL::C::SystemHealthClusterSwitch->create(
                                command_interface => $ci,
	                            'device' => $device,
                                ...);

(Class method)
This method is used to add information about a cluster switch or management switch.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'device' => $device >>

(Required)
Remote SNMP Agent

Applicable for CMode CLI.

=item C<< 'community' => $string >>

Community String

Applicable for CMode CLI.

=item C<< 'model' => $string >>

Model Number, possible value(s) are NX5010,NX5020,CAT2960

Applicable for CMode CLI.

=item C<< 'type' => $string >>

Switch Network, possible value(s) are cluster,management

Applicable for CMode CLI.

=item C<< 'ipaddress' => $string >>

IP Address

Applicable for CMode CLI.

=item C<< 'snmpversion' => $string >>

SNMP Version, possible value(s) are SNMPv1,SNMPv2c

Applicable for CMode CLI.

=item C<< 'discovered' => $string >>

Is Discovered, possible value(s) are true,false

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'snmp-version' => $string >>

SNMP Version possible value(s) are, SNMPv1,SNMPv2c
Applicable for CMode CLI

=item C<< 'address' => $string >>

IP Address
Applicable for CMode CLI

=item C<< 'disable-monitoring' => $string >>

Disable Switch Monitoring possible value(s) are, yes,no
Applicable for CMode CLI

=item C<< 'is-monitoring-enabled-admin' => $string >>

Enable Switch Monitoring possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"system health cluster-switch create" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( community model type ipaddress snmpversion discovered

                    snmp-version address

                    disable-monitoring

                    is-monitoring-enabled-admin
                    )
            ),
        },
        api => 'system_health_cluster_switch_create',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemHealthClusterSwitch::create',
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        device            => $opts{'device'},
    );
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_health_cluster_switch_create',);
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_cli

=head2 modify

    NACL::C::SystemHealthClusterSwitch->modify(
                                command_interface => $ci,
	                            'device' => $device,
                                ...);
	                             
								 or

    $SystemHealthClusterSwitch_obj->modify(...);

(Class or instance method)
This method is used to modify information about a switch's configuration.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'device' => $device >>

(Required for class method, Not Applicable for instance method)
Remote SNMP Agent

Applicable for CMode CLI.

=item C<< 'community' => $string >>

Community String

Applicable for CMode CLI.

=item C<< 'model' => $string >>

Model Number, possible value(s) are NX5010,NX5020,CAT2960

Applicable for CMode CLI.

=item C<< 'type' => $string >>

Switch Network, possible value(s) are cluster,management

Applicable for CMode CLI.

=item C<< 'ipaddress' => $string >>

IP Address

Applicable for CMode CLI.

=item C<< 'snmpversion' => $string >>

SNMP Version, possible value(s) are SNMPv1,SNMPv2c

Applicable for CMode CLI.

=item C<< 'discovered' => $string >>

Is Discovered, possible value(s) are true,false

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'snmp-version' => $string >>

SNMP Version possible value(s) are, SNMPv1,SNMPv2c
Applicable for CMode CLI

=item C<< 'address' => $string >>

IP Address
Applicable for CMode CLI

=item C<< 'disable-monitoring' => $string >>

Disable Switch Monitoring possible value(s) are, yes,no
Applicable for CMode CLI

=item C<< 'is-monitoring-enabled-admin' => $string >>

Enable Switch Monitoring possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"system health cluster-switch modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( community model type ipaddress snmpversion discovered

                    snmp-version address

                    disable-monitoring

                    is-monitoring-enabled-admin
                    )
            ),
        },
        api => 'system_health_cluster_switch_modify',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemHealthClusterSwitch::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'system_health_cluster_switch_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

=head2 show_all

    my $show_all_obj = NACL::C::SystemHealthClusterSwitch->show_all(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_all_objs = NACL::C::SystemHealthClusterSwitch->show_all(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_all_obj = $SystemHealthClusterSwitch_obj->show_all(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-SystemHealthClusterSwitchShowAll-pm/ATTRIBUTES>
of NACL::CS::SystemHealthClusterSwitchShowAll as input. 
This method returns objects of the type L<NACL::CS::SystemHealthClusterSwitchShowAll|lib-NACL-CS-SystemHealthClusterSwitchShowAll-pm>.

=cut

sub show_all {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::SystemHealthClusterSwitchShowAll;
    my @state_objs = NACL::CS::SystemHealthClusterSwitchShowAll->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 prepare_to_downgrade

    NACL::C::SystemHealthClusterSwitch->prepare_to_downgrade(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to changes the model number of manually created switches based on the switch support provided in the Data ONTAP releases earlier to 8.2.1.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< '*' >>

This method takes all other options supported by "system health cluster switch prepare to downgrade" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub prepare_to_downgrade {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params              => \@args,
        ignore_primary_keys => 1,
        api => 'system_health_cluster_switch_prepare_to_downgrade',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_prepare_to_downgrade_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::SystemHealthClusterSwitch::prepare_to_downgrade',
    );

    $Log->exit() if $may_exit;
}

sub _prepare_to_downgrade_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_health_cluster_switch_prepare_to_downgrade',);
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('device' => {type => SCALAR},);
}

1;
