# $Id$ //depot/prod/test/nacldev/lib/NACL/C/SystemLicenseCleanup.pm#7

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemLicenseCleanup Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemLicenseCleanup

=head1 DESCRIPTION

C<NACL::C::SystemLicenseCleanup> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemLicenseCleanup.  A related class is
L<NACL::CS::SystemLicenseCleanup|lib-NACL-CS-SystemLicenseCleanup-pm>, which represents
the past state of an ONTAP SystemLicenseCleanup.
However, since it does not have any primary keys, 'find' and 'state' do not
work for this component. (This component is considered a 'singleton',
i.e. there is only one row shown by the relevant 'show' command)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::SystemLicenseCleanup;

use strict;
use warnings;

use NACL::CS::SystemLicenseCleanup;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $SystemLicenseCleanup = NACL::C::SystemLicenseCleanup->new(
                                   command_interface => $ci,
								  );

Return a new SystemLicenseCleanup component object with the given attributes.

=cut

=head2 find

    my $SystemLicenseCleanup_obj  = NACL::C::SystemLicenseCleanup->find(command_interface => $ci, ...);
	my @SystemLicenseCleanup_objs = NACL::C::SystemLicenseCleanup->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my SystemLicenseCleanup_state = $SystemLicenseCleanup_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemLicenseCleanup would return
a NACL::CS::SystemLicenseCleanup object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 unused

    NACL::C::SystemLicenseCleanup->unused(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to remove all unused licenses.

Uses a CMode CLI/ZAPI APISet.

Invokes 'license-v2-delete-unused' API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<< "extended_query" => $string >>

(Optional)
Applicable only for CMode CLI

=back

=back

=cut

sub unused {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with( params => \@_,  cli_cmd => 'system_license_cleanup_unused');
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_unused_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_unused_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
}

sub _unused_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $allowed_cmode_options = [
        qw(
            extended_query )
    ];
    $pkg_or_obj->_base_backend_cmode_cli(%opts,
            api    => 'system_license_cleanup_unused',
            copy   => $allowed_cmode_options,
	);
    $Log->exit() if $may_exit;
}

sub _unused_cmode_zapi {
    $Log->enter() if $may_enter;
    my ( $pkg, @args ) = @_;
    $pkg->_base_backend_cmode_zapi(@args,  api => 'license_v2_delete_unused');
    $Log->exit() if $may_exit;
} #end of sub _unused_cmode_zapi

=head2 expired

    NACL::C::SystemLicenseCleanup->expired(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to remove all expired demo licenses.

Uses a CMode CLI/ZAPI APISet.

Invokes 'license-v2-delete-expired' API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<< "extended_query" => $string >>

(Optional)
Applicable only for CMode CLI

=back

=back

=cut

sub expired {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with( params => \@_,  cli_cmd => 'system_license_cleanup_expired');
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_expired_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_expired_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
}

sub _expired_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $allowed_cmode_options = [
        qw(
            )
    ];
    $pkg_or_obj->_base_backend_cmode_cli(%opts,
            api    => 'system_license_cleanup_expired',
            copy   => $allowed_cmode_options,
	);
    $Log->exit() if $may_exit;
}

sub _expired_cmode_zapi {
    $Log->enter() if $may_enter;
    my ( $pkg, @args ) = @_;
    $pkg->_base_backend_cmode_zapi(@args,   api => 'license_v2_delete_expired');
    $Log->exit() if $may_exit;
} #end of sub _expired_cmode_zapi

__PACKAGE__->_load_event_class();

1;
