# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemManagedFeature Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemManagedFeature

=head1 DESCRIPTION

C<NACL::C::SystemManagedFeature> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemManagedFeature.  A related class is
L<NACL::CS::SystemManagedFeature|lib-NACL-CS-SystemManagedFeature-pm>, which represents
the past state of an ONTAP SystemManagedFeature.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 feature_name

=cut

package NACL::C::SystemManagedFeature;

use strict;
use warnings;

use NACL::CS::SystemManagedFeature;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $SystemManagedFeature = NACL::C::SystemManagedFeature->new(
                                   command_interface => $ci,
                                   'feature-name' => $feature_name,
								  );

Return a new SystemManagedFeature component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'feature_name',];

=head2 find

    my $SystemManagedFeature_obj  = NACL::C::SystemManagedFeature->find(command_interface => $ci, ...);
	my @SystemManagedFeature_objs = NACL::C::SystemManagedFeature->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my SystemManagedFeature_state = $SystemManagedFeature_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemManagedFeature would return 
a NACL::CS::SystemManagedFeature object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('feature-name' => {type => SCALAR},);
}

1;
