# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemNodeAutosupportBudget Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemNodeAutosupportBudget

=head1 DESCRIPTION

C<NACL::C::SystemNodeAutosupportBudget> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemNodeAutosupportBudget.  A related class is
L<NACL::CS::SystemNodeAutosupportBudget|lib-NACL-CS-SystemNodeAutosupportBudget-pm>, which represents
the past state of an ONTAP SystemNodeAutosupportBudget.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

=head2 subsystem

=cut

package NACL::C::SystemNodeAutosupportBudget;

use strict;
use warnings;

use NACL::CS::SystemNodeAutosupportBudget;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF UNDEF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $SystemNodeAutosupportBudget = NACL::C::SystemNodeAutosupportBudget->new(command_interface=>$ci,
                                   node =>$node,
                                   subsystem =>$subsystem,
                                  );

Return a new SystemNodeAutosupportBudget component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'node',
    scalar => 'subsystem',
];

=head2 find

    my $SystemNodeAutosupportBudget  = NACL::C::SystemNodeAutosupportBudget->find(command_interface => $ci, ...);
    my @SystemNodeAutosupportBudgets = NACL::C::SystemNodeAutosupportBudget->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $SystemNodeAutosupportBudget_state = $NACL::C::SystemNodeAutosupportBudget->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemNodeAutosupportBudget would return
a NACL::CS::SystemNodeAutosupportBudget object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 modify

   NACL::C::SystemNodeAutosupportBudget->modify(
                                command_interface => $ci,
                                 node => $node,
                                 subsystem => $subsystem,
                                  ...);

                                 or

    $SystemNodeAutosupportBudget_object->modify(...);

(Class or instance method)
This method is used to modify AutoSupport time and size limits per subsystem.

Uses a CMode CLI/ZAPI, 7Mode CLI APISet.

Invokes 'autosupport-budget-modify' API for CMode ZAPI,7Mode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "node" => $node >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: node-name

=item C<< "subsystem" => $subsystem >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI,7Mode CLI.

Maps to:

CM ZAPI: subsystem

7M CLI : -subsystem <value> (Programmatic name: subsystem)

=item C<< "size-limit" => $string >>

Applicable for CMode CLI/ZAPI,7Mode CLI.

Maps to:

CM ZAPI: size-limit

7M CLI : -size limit <value> (Programmatic name: size limit)

=item C<< "time-limit" => $string >>

Applicable for CMode CLI/ZAPI,7Mode CLI.

Maps to:

CM ZAPI: time-limit

7M CLI : -time limit <value> (Programmatic name: time limit)

=item C<< 'extended_query' => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< 'diagnostic-size-limit' => $string >>

Diagnostic Content Size Limit
Applicable for CMode CLI

=item C<< 'diagnostic-time-limit' => $string >>

Diagnostic Content Time Limit
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"system node autosupport budget modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( size-limit time-limit

                    diagnostic-size-limit diagnostic-time-limit
                    )
            ),
        },
        cli_cmd => 'system node autosupport budget modify',
    );
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_7mode_cli',
                interface => 'CLI',
                set       => '7Mode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemNodeAutosupportBudget::modify',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@args, api  => 'system_node_autosupport_budget_modify');
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my $allowed_7mode_options = [
        qw( size-limit subsystem time-limit
            )
    ];
    my %mode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_7mode_options,
        target => \%mode_args,
    );
    %opts = %mode_args;

    $apiset->autosupport_budget_modify(%opts);
    $Log->exit() if $may_exit;

} ## end sub _modify_7mode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $allowed_cmode_options = [
        qw( size-limit subsystem time-limit
            )
    ];
    $pkg_or_obj->_base_backend_cmode_zapi(%opts,
            api    => 'autosupport_budget_modify',
            copy   => $allowed_cmode_options,
            map    => {"node" => "node-name"},
	);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_zapi


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'node'      => {type => SCALAR | UNDEF, optional => 1},
        'subsystem' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
