# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemNodeAutosupportTrigger Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
##   Added 7Mode cli support for modify
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemNodeAutosupportTrigger

=head1 DESCRIPTION

C<NACL::C::SystemNodeAutosupportTrigger> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemNodeAutosupportTrigger.  A related class is
L<NACL::CS::SystemNodeAutosupportTrigger|lib-NACL-CS-SystemNodeAutosupportTrigger-pm>, which represents
the past state of an ONTAP SystemNodeAutosupportTrigger.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 autosupport_message

=head2 node

=cut

package NACL::C::SystemNodeAutosupportTrigger;

use strict;
use warnings;

use NACL::CS::SystemNodeAutosupportTrigger;
use NACL::ComponentUtils qw (_optional_scalars);
use NACL::APISet::Exceptions::ResponseException qw(:try);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF UNDEF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $SystemNodeAutosupportTrigger = NACL::C::SystemNodeAutosupportTrigger->new(command_interface=>$ci,
                                   autosupport_message =>$autosupport_message,
                                   node =>$node,
                                  );

Return a new SystemNodeAutosupportTrigger component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'autosupport_message',
    scalar => 'node',
];

=head2 find

    my $SystemNodeAutosupportTrigger  = NACL::C::SystemNodeAutosupportTrigger->find(command_interface => $ci, ...);
    my @SystemNodeAutosupportTriggers = NACL::C::SystemNodeAutosupportTrigger->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $SystemNodeAutosupportTrigger_state = $NACL::C::SystemNodeAutosupportTrigger->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemNodeAutosupportTrigger would return
a NACL::CS::SystemNodeAutosupportTrigger object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 modify

   NACL::C::SystemNodeAutosupportTrigger->modify(
                                command_interface => $ci,
                                 autosupport_message => $autosupport_message,
                                 node => $node,
                                  ...);

                                 or

    $SystemNodeAutosupportTrigger_object->modify(...);

(Class or instance method)
This method is used to modify AutoSupport trigger configuration.

Uses a CMode CLI/ZAPI, 7Mode CLI APISet.

Invokes 'autosupport-trigger-modify' API for CMode ZAPI, 7Mode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "autosupport-message" => $autosupport_message >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: trigger

7M CLI : -autosupport message <value> (Programmatic name: autosupport message)

=item C<< "node" => $node >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: node-name

=item C<< "noteto" => $string >>


Applicable for CMode CLI/ZAPI,7Mode CLI.

Maps to:

CM ZAPI: noteto-enabled

7M CLI : -noteto <value> (Programmatic name: noteto)

=item C<< "to" => $string >>


Applicable for CMode CLI/ZAPI,7Mode CLI.

Maps to:

CM ZAPI: to-enabled

7M CLI : -to <value> (Programmatic name: to)

=item C<< "time-limit" => $string >>


Applicable for CMode CLI/ZAPI,7Mode CLI.

Maps to:

CM ZAPI: time-limit

7M CLI : -time limit <value> (Programmatic name: time limit)

=item C<< "troubleshooting-additional" => [ $troubleshooting-additional1, $troubleshooting-additional2, ... ] >>


Applicable for CMode CLI/ZAPI,7Mode CLI.

Maps to:

CM ZAPI: troubleshooting-additional

7M CLI : -troubleshooting additional <value> (Programmatic name: troubleshooting additional)

=item C<< "basic-additional" => [ $basic-additional1, $basic-additional2, ... ] >>


Applicable for CMode CLI/ZAPI,7Mode CLI.

Maps to:

CM ZAPI: basic-additional

7M CLI : -basic additional <value> (Programmatic name: basic additional)

=item C<< 'extended_query' => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< 'diagnostic-additional' => [ $diagnostic-additional1, $diagnostic-additional2, ... ] >>

Additional Subsystems Reporting Diagnostic Info
(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI

=item C<< 'suppress' => $string >>


Suppress all occurrences of this trigger possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"system node autosupport trigger modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            "diagnostic-additional"      => {type => ARRAYREF, optional => 1},
            "troubleshooting-additional" => {type => ARRAYREF, optional => 1},
            "basic-additional"           => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( noteto to time-limit

                    suppress
                    )
            ),
        },
        cli_cmd => 'system node autosupport trigger modify',
    );
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
            {   method    => '_modify_7mode_cli',
                interface => 'CLI',
                set       => '7Mode',
            },
        ],
        frontend => 'NACL::C::SystemNodeAutosupportTrigger::modify',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@args, api  => 'system_node_autosupport_trigger_modify');
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my $allowed_7mode_options = [
        qw( noteto to autosupport-message troubleshooting-additional
            basic-additional time-limit
            )
    ];
    my %mode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_7mode_options,
        target => \%mode_args,
    );
    %opts = %mode_args;

    foreach
        my $array_element (qw(troubleshooting-additional basic-additional))
    {
        if (defined $opts{$array_element}) {
            $opts{$array_element} = join ',', @{$opts{$array_element}};
        }
    } ## end foreach my $array_element ...

    $apiset->autosupport_trigger_modify(%opts);
    $Log->exit() if $may_exit;

} ## end sub _modify_7mode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( troubleshooting-additional
            basic-additional time-limit
            )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        map    => {
            "node"                => "node-name",
            "autosupport-message" => "trigger",
            "noteto"              => "noteto-enabled",
            "to"                  => "to-enabled",
        },
        target => \%cmode_args,
    );
    %opts = %cmode_args;

    my $original_to_enabled     = $opts{'to-enabled'};
    my $original_noteto_enabled = $opts{'noteto-enabled'};

    my %enabled_boolean_hash = ('enabled' => 'true', 'disabled' => 'false');
    foreach my $boolean_field (qw(to-enabled noteto-enabled)) {
        if (defined $opts{$boolean_field}
            && exists $enabled_boolean_hash{$opts{$boolean_field}})
        {
            $opts{$boolean_field}
                = $enabled_boolean_hash{$opts{$boolean_field}};
        }
    }

    try {
        $apiset->autosupport_trigger_modify(%opts);
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = shift;
        if ($exception->text()
            =~ /Invalid value specified for .*to\-enabled.*(true)|(false)/)
        {
            $Log->trace("Value of 'to-enabled' and 'noteto-enabled' should "
                    . 'be enabled/disabled, rather than true/false');
            if (defined $opts{'to-enabled'}) {
                $opts{'to-enabled'} = $original_to_enabled;
            }
            if (defined $opts{'noteto-enabled'}) {
                $opts{'noteto-enabled'} = $original_noteto_enabled;
            }
            $apiset->autosupport_trigger_modify(%opts);
        } else {
            $Log->exit() if $may_exit;
            $exception->throw();
        }
    };
    $Log->exit() if $may_exit;
}    #end _modify_cmode_zapi


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'autosupport-message' => {type => SCALAR, optional => 1},
        'node'                => {type => SCALAR, optional => 1},
    );
} ## end sub _primary_keys_validate_spec

1;
