#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemNodeCoredump Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com , benjaram@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemNodeCoredump

=head1 DESCRIPTION

C<NACL::C::SystemNodeCoredump> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemNodeCoredump.  A related class is
L<NACL::CS::SystemNodeCoredump|lib-NACL-CS-SystemNodeCoredump-pm>, which represents
the past state of an ONTAP SystemNodeCoredump.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 corename

=head2 node

=cut

package NACL::C::SystemNodeCoredump;

use strict;
use warnings;

use NACL::CS::SystemNodeCoredump;
use NACL::ComponentUtils qw (_optional_scalars Dumper);
use NACL::C::Exceptions::SystemNodeCoredump::DoesNotExist;
use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF UNDEF);
use NATE::Log qw(log_global);
use NACL::APISet::Exceptions::ResponseException qw(:try);

=head1 METHODS

=head2 new

  my $SystemNodeCoredump = NACL::C::SystemNodeCoredump->new(
                                   command_interface => $ci,
                                   'corename' => $corename,
                                   'coreid' => $coreid,
                                   'node' => $node,
                                   'type' => $type,
                                  );

Return a new SystemNodeCoredump component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'corename',
    scalar => 'coreid',
    scalar => 'node',
    scalar => 'type',
];

my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $SystemNodeCoredump_obj  = NACL::C::SystemNodeCoredump->find(command_interface => $ci, ...);
    my @SystemNodeCoredump_objs = NACL::C::SystemNodeCoredump->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.
This method executes coredump-get-iter for Cmode Zapi

=head2 state

    my SystemNodeCoredump_state = $SystemNodeCoredump_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemNodeCoredump would return
a NACL::CS::SystemNodeCoredump object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.


=cut

=head2 save

    NACL::C::SystemNodeCoredump->save(
                                command_interface => $ci,
                                'corename'        => $corename,
                                'coreid'          => $coreid,
                                'node'            => $node,
              ...)
                                or
    $SystemNodeCoredump_obj->save(...);

(Class or instance method)
This method is used to save an unsaved kernel coredump.

Uses a CMode CLI/ZAPI APISet.

Invokes "coredump-save-core-iter" API for CMode ZAPI

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'corename' => $corename >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

<coredump-save-core-iter>
<query>
<coredump-info>
<core-name>$value</core-name>
</coredump-info>
</query>
</coredump-save-core-iter>

=item C<< 'coreid' => $coreid >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

<coredump-save-core-iter>
<query>
<coredump-info>
<core-id>$value</core-id>
</coredump-info>
</query>
</coredump-save-core-iter>

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

<coredump-save-core-iter>
<query>
<coredump-info>
<node-name>$value</node-name>
</coredump-info>
</query>
</coredump-save-core-iter>

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'extended_query' => $string >>

(Optional) Applicable for CMode CLI/ZAPI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system node coredump save" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub save {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        api    => 'system_node_coredump_save',
    );
    try {
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_save_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_save_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::SystemNodeCoredump::save',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        my $doesnot_exist
            = 'NACL::C::Exceptions::SystemNodeCoredump::DoesNotExist';
        $doesnot_exist->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };
    $Log->exit() if $may_exit;
} ## end sub save

sub _save_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'system_node_coredump_save',);
    $Log->exit() if $may_exit;
} ## end sub _save_cmode_cli

sub _save_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;

    $pkg_or_obj->_iter_helper(
        @args,
        api      => 'coredump-save-core-iter',
        show_cmd => 'system node coredump show',
        map      => {
            'node'     => 'node-name',
            'coreid'   => 'core-id',
            'corename' => 'core-name',
        },
        does_not_exist_error => "entry doesn't exist",
        does_not_exist_exception =>
            'NACL::C::Exceptions::SystemNodeCoredump::DoesNotExist'
    );

    $Log->exit() if $may_exit;
} ## end sub _save_cmode_zapi

=head2 upload

    NACL::C::SystemNodeCoredump->upload(
                                command_interface => $ci,
                                'corename' => $corename,
                                'coreid' => $coreid,
                                'node' => $node,
                                'type' => $type,
                                ...);

                                 or

    $SystemNodeCoredump_obj->upload(...);

(Class or instance method)
This method is used to upload a coredump to a remote site.

Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'corename' => $corename >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'coreid' => $coreid >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "user-name" => $string >>

(Required) User name for ftp login.
  Applicable for CMode CLI.

=item C<< "password" => $string >>

(Required) password for ftp login.
  Applicable for CMode CLI.

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'location' => $string >>

Applicable for CMode CLI.

=item C<< 'sequence' => $string >>

Applicable for CMode CLI.

=item C<< 'casenum' => $string >>

Applicable for CMode CLI.

=item C<< 'type' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'extended_query' => $string >>

(Optional) Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system node coredump upload" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub upload {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( location sequence casenum type
                    user-name password
                    )
            ),
        },
        cli_cmd => 'system node coredump upload',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_upload_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemNodeCoredump::upload',
    );
    $Log->exit() if $may_exit;
} ## end sub upload

sub _upload_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    $opts{additional_args} = {
        'connectrec-match_table' => [
            qr/user:/i     => delete $opts{'user-name'},
            qr/password:/i => delete $opts{password}
        ]
    };
    $pkg_or_obj->_base_backend_cmode_cli(%opts,
        api => 'system_node_coredump_upload',);
    $Log->exit() if $may_exit;
} ## end sub _upload_cmode_cli

=head2 delete_all

    NACL::C::SystemNodeCoredump->delete_all(
                                command_interface => $ci,
                                'node' => $node,
                                'type' => $type,
                                ...);

(Class method)
This method is used to delete all coredumps owned by a node.

Uses a CMode CLI/ZAPI, 7Mode CLI APISet.

Invokes 'coredump-delete-all' API for CMode ZAPI.

Invokes 'rmcores' command for 7Mode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: node-name

=item C<< 'type' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: core-type

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'extended_query' => $string >>

(Optional) Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system node coredump delete-all" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete_all {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( type node
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'system node coredump delete-all',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_all_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_delete_all_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
            {   method    => '_delete_all_7mode_cli',
                interface => 'CLI',
                set       => '7Mode',
            },
        ],
        frontend => 'NACL::C::SystemNodeCoredump::delete_all',
    );
    $Log->exit() if $may_exit;
} ## end sub delete_all

sub _delete_all_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_node_coredump_delete_all',);
    $Log->exit() if $may_exit;
} ## end sub _delete_all_cmode_cli

sub _delete_all_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    $pkg_or_obj->_base_backend_cmode_zapi(%opts,
            api    => 'coredump_delete_all',
            map    => {'type' => 'core-type', 'node' => 'node-name'},
	);
    $Log->exit() if $may_exit;
} ## end sub _delete_all_cmode_zapi

sub _delete_all_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg  = shift;
    my %opts = validate_with(
        params      => \@_,
        spec        => $pkg->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my %mode_args;

    #my  $allowed_cmode_options;
    $apiset->rmcores();
    $Log->exit() if $may_exit;
} ## end sub _delete_all_7mode_cli

=head2 delete

    NACL::C::SystemNodeCoredump->delete(
                                command_interface => $ci,
                                'corename' => $corename,
                                'coreid' => $coreid,
                                'node' => $node,
                                'type' => $type,
                                ...);

                                 or

    $SystemNodeCoredump_obj->delete(...);

(Class or instance method)
This method is used to delete a coredump.

Uses a CMode CLI/ZAPI APISet.

Invokes "coredump-delete-core-iter" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'corename' => $corename >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

<coredump-delete-core-iter>
<query>
<coredump-info>
<core-name>$value</core-name>
</coredump-info>
</query>
</coredump-delete-core-iter>

=item C<< 'coreid' => $coreid >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

<coredump-delete-core-iter>
<query>
<coredump-info>
<core-id>$value</core-id>
</coredump-info>
</query>
</coredump-delete-core-iter>

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

<coredump-delete-core-iter>
<query>
<coredump-info>
<node-name>$value</node-name>
</coredump-info>
</query>
</coredump-delete-core-iter>

=item C<< 'type' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'extended_query' => $string >>

(Optional) Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $Log->debug("Opts to 'delete' front end are:\n" . Dumper({@_}));
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@_,
        additional_spec => {
            _optional_scalars(
                qw( type
                    )
            ),
        },
    );
    try {
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_delete_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_delete_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        my $doesnot_exist
            = 'NACL::C::Exceptions::SystemNodeCoredump::DoesNotExist';
        $doesnot_exist->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };
    $Log->exit() if $may_exit;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( corename type node coreid
            extended_query )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $Log->debug("Opts to API call 'system_node_coredump_delete' are: \n"
            . Dumper(\%cmode_args));

    $apiset->system_node_coredump_delete(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;

    $pkg_or_obj->_iter_helper(
        @args,
        api      => 'coredump-delete-core-iter',
        show_cmd => 'system node coredump show',
        map      => {
            'node'     => 'node-name',
            'corename' => 'core-name',
            'coreid'   => 'core-id',
        },
        does_not_exist_error => "entry doesn't exist",
        does_not_exist_exception =>
            'NACL::C::Exceptions::SystemNodeCoredump::DoesNotExist'
    );

    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_zapi

=head2 save_all

    NACL::C::SystemNodeCoredump->save_all(
                                command_interface => $ci,
                                'node' => $node,
                                ...);
(Class method)
This method is used to save all unsaved kernel coredumps owned by a node.

Uses a CMode CLI/ZAPI, 7Mode CLI APISet.

Invokes 'coredump-save-all' API for CMode ZAPI.

Invokes 'savecore' command for 7Mode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: node-name

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'display-info' => $display-info >>


Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : -i (Programmatic name: display info)

=item C<< 'list' => $list >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : -l (Programmatic name: list)

=item C<< 'display-progress' => $display-progress >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : -s (Programmatic name: display progress)

=item C<< 'synchronous' => $synchronous >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : -w (Programmatic name: synchronous)

=item C<< 'force' => $force >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : -f (Programmatic name: force)

=item C<< 'invalidate' => $invalidate >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : -k (Programmatic name: invalidate)

=item C<< 'core-id' => $core-id >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : core id

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system node coredump save-all" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub save_all {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( display-info list display-progress synchronous force
                    invalidate core-id corename coreid node
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'system node coredump save-all',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_save_all_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_save_all_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
            {   method    => '_save_all_7mode_cli',
                interface => 'CLI',
                set       => '7Mode',
            },
        ],
        frontend => 'NACL::C::SystemNodeCoredump::save_all',
    );
    $Log->exit() if $may_exit;
} ## end sub save_all

sub _save_all_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_node_coredump_save_all',);
    $Log->exit() if $may_exit;
} ## end sub _save_all_cmode_cli

sub _save_all_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    $pkg_or_obj->_base_backend_cmode_zapi(%opts,
            api    => 'coredump_save_all',
            map    => {'node' => 'node-name',},
	);
    $Log->exit() if $may_exit;
} ## end sub _save_all_cmode_zapi

sub _save_all_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    delete $opts{coreid};
    delete $opts{node};
    delete $opts{corename};
    my $apiset = delete $opts{apiset};

    my $allowed_mode_options = [
        qw( display-info list display-progress synchronous force
            invalidate core-id
            )
    ];
    my %mode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        map    => {
            "coreid" => "corename",

        },
        copy   => $allowed_mode_options,
        target => \%mode_args,
    );

    $apiset->savecore(%mode_args);
    $Log->exit() if $may_exit;

} ## end sub _save_all_7mode_cli

=head2 status

    my $status_obj = NACL::C::SystemNodeCoredump->status(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

    my @status_objs = NACL::C::SystemNodeCoredump->status(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

   my $status_obj = $SystemNodeCoredump_obj->status();

(Class or Instance method)
This method returns objects of the type L<NACL::CS::SystemNodeCoredumpStatus|lib-NACL-CS-SystemNodeCoredumpStatus-pm>.

This method accepts all the parameters accepted by L<fetch|lib-NACL-CS-ComponentState-pm/fetch>
(requested_fields, filter, allow_empty) and has all of the other properties of
fetch methods (callable in scalar or list context, throws a NoElementsFound
exception if no matching elements are found)

=cut

sub status {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_handle_obj_cs_like_calls(@_);
    require NACL::CS::SystemNodeCoredumpStatus;
    my @state_objs = NACL::CS::SystemNodeCoredumpStatus->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub status

=head2 trigger

    NACL::C::SystemNodeCoredump->trigger(
                                command_interface => $ci,
	                            'node' => $node,
                                ...);
   
(Class method)
This method is used to make the node dump system core and reset.
Uses CMode CLI/ZAPI .
Invokes  coredump-trigger for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required)
Node possible value(s) are, <nodename>,local

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "system node coredump trigger" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub trigger {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( node
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'system_node_coredump_trigger',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_trigger_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_trigger_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemNodeCoredump::trigger',
    );

    $Log->exit() if $may_exit;
}

sub _trigger_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $prompts_answers = ['.*Do you want to continue\? {y\|n}:' => "y",];
    $pkg->_base_backend_cmode_cli(
        @opts,
        additional_args => {'connectrec-match_table' => $prompts_answers},
        api => 'system_node_coredump_trigger',);
    $Log->exit() if $may_exit;
}

sub _trigger_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(node)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'coredump-trigger',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'corename' => {type => SCALAR,},
        'coreid'   => {type => SCALAR, optional => 1},
        'node'     => {type => SCALAR | UNDEF, optional => 1},
        'type'     => {type => SCALAR, optional => 1},
    );
} ## end sub _primary_keys_validate_spec

1;
