# $Id$

#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemNodeCoredumpSegmentConfig Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, pkj@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemNodeCoredumpSegmentConfig

=head1 DESCRIPTION

C<NACL::C::SystemNodeCoredumpSegmentConfig> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemNodeCoredumpSegmentConfig.  A related class is
L<NACL::CS::SystemNodeCoredumpSegmentConfig|lib-NACL-CS-SystemNodeCoredumpSegmentConfig-pm>, which represents
the past state of an ONTAP SystemNodeCoredumpSegmentConfig.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

=cut

package NACL::C::SystemNodeCoredumpSegmentConfig;

use strict;
use warnings;

use NACL::CS::SystemNodeCoredumpSegmentConfig;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $SystemNodeCoredumpSegmentConfig = NACL::C::SystemNodeCoredumpSegmentConfig->new(
                                   command_interface => $ci,
                                   'node' => $node,
                                  );

Return a new SystemNodeCoredumpSegmentConfig component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'node',];

=head2 find

    my $SystemNodeCoredumpSegmentConfig_obj  = NACL::C::SystemNodeCoredumpSegmentConfig->find(command_interface => $ci, ...);
    my @SystemNodeCoredumpSegmentConfig_objs = NACL::C::SystemNodeCoredumpSegmentConfig->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI, 7Mode CLI/ZAPI APISet.

=head2 state

    my SystemNodeCoredumpSegmentConfig_state = $SystemNodeCoredumpSegmentConfig_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemNodeCoredumpSegmentConfig would return
a NACL::CS::SystemNodeCoredumpSegmentConfig object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI, 7Mode CLI/ZAPI APISet.

=cut

=head2 modify

    NACL::C::SystemNodeCoredumpSegmentConfig->modify(
                                command_interface => $ci,
                                'node' => $node,
                                ...);

                                 or

    $SystemNodeCoredumpSegmentConfig_obj->modify(...);

(Class or instance method)
This method is used to modify the Core Segmentation Configuration.

Uses a CMode CLI, 7Mode CLI/ZAPI APISet.

Invokes "core-segment-config-modify" API for CMode ZAPI.

Invokes 'core-segment-config-modify' API for 7Mode ZAPI.

Invokes 'coredump segment config modify' command for 7Mode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI 7Mode CLI/ZAPI.

Maps to:

CM ZAPI: node

7M CLI : -node <value> (Programmatic name: node)

7M ZAPI: node

=item C<< 'auto-segment' => $string >>

Applicable for CMode CLI/ZAPI, 7Mode CLI/ZAPI.

Maps to:

CM ZAPI: is-auto-segment

7M CLI : -auto segment <value> (Programmatic name: auto segment)

7M ZAPI: is-auto-segment

=item C<< 'auto-delete' => $string >>

Applicable for CMode CLI/ZAPI, 7Mode CLI/ZAPI.

Maps to:

CM ZAPI: is-auto-delete

7M CLI : -auto delete <value> (Programmatic name: auto delete)

7M ZAPI: is-auto-delete

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system node coredump segment config modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( auto-segment auto-delete

                    node
                    )
            ),
        },
        cli_cmd => 'system node coredump segment config modify',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_7mode_cli',
                interface => 'CLI',
                set       => '7Mode',
            },
            {   method    => '_modify_7mode_zapi',
                interface => 'ZAPI',
                set       => '7Mode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },

        ],
        frontend => 'NACL::C::SystemNodeCoredumpSegmentConfig::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'system_node_coredump_segment_config_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_7mode_zapi {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_validate_backend_opts(@_);

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my $allowed_7mode_options = [qw( node )];
    my %_7mode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_7mode_options,
        map    => {
            'auto-segment' => 'is-auto-segment',
            'auto-delete'  => 'is-auto-delete',
        },
        target => \%_7mode_args,
    );
    $apiset->core_segment_config_modify(%_7mode_args);
    $Log->exit() if $may_exit;
} ## end sub _modify_7mode_zapi

sub _modify_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_validate_backend_opts(@_);

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( auto-segment auto-delete
            )
    ];
    my %allowed_7mode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%allowed_7mode_args,
    );
    $apiset->coredump_segment_config_modify(%allowed_7mode_args);
    $Log->exit() if $may_exit;
} ## end sub _modify_7mode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my $allowed_cmode_options = [qw(  node )];
    $pkg_or_obj->_base_backend_cmode_zapi(@args,
            api    => 'core_segment_config_modify',
            copy   => $allowed_cmode_options,
            map    => {
                'auto-segment' => 'is-auto-segment',
                'auto-delete'  => 'is-auto-delete',
        },
	);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_zapi


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('node' => {type => SCALAR},);
}
1;
