# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemNodeEnvironmentSensors Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemNodeEnvironmentSensors

=head1 DESCRIPTION

C<NACL::C::SystemNodeEnvironmentSensors> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemNodeEnvironmentSensors.  A related class is
L<NACL::CS::SystemNodeEnvironmentSensors|lib-NACL-CS-SystemNodeEnvironmentSensors-pm>, which represents
the past state of an ONTAP SystemNodeEnvironmentSensors.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 name

=head2 node

=cut

package NACL::C::SystemNodeEnvironmentSensors;

use strict;
use warnings;

use NACL::CS::SystemNodeEnvironmentSensors;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $SystemNodeEnvironmentSensors = NACL::C::SystemNodeEnvironmentSensors->new(command_interface=>$ci,
                                   node =>$node,
								  );

Return a new SystemNodeEnvironmentSensors component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'node',
    scalar => 'name',
    scalar => 'index',
];

=head2 find

    my $SystemNodeEnvironmentSensors  = NACL::C::SystemNodeEnvironmentSensors->find(command_interface => $ci, ...);
	my @SystemNodeEnvironmentSensorss = NACL::C::SystemNodeEnvironmentSensors->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $SystemNodeEnvironmentSensors_state = $NACL::C::SystemNodeEnvironmentSensors->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemNodeEnvironmentSensors would return 
a NACL::CS::SystemNodeEnvironmentSensors object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'node'  => {type => SCALAR, optional => 1},
        'index' => {type => SCALAR, optional => 1},
        'name'  => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
