# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemServicesNdmpNodeScopeMode Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemServicesNdmpNodeScopeMode

=head1 DESCRIPTION

C<NACL::C::SystemServicesNdmpNodeScopeMode> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. 
Unlike other components this package does not model any element/service 
but is present to provide component-level support for functionality. 
Since it does not model any element/service there is no ComponentState 
module for this component. For the same reason, 'find' and 'state' will
not work for this component.
Instead NACL::CS::SystemServicesNdmpNodeScopeMode->fetch() should be used.
(See L<fetch|lib-NACL-CS-ComponentState-pm/fetch> for a full description)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::SystemServicesNdmpNodeScopeMode;

use strict;
use warnings;

use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::CS::SystemServicesNdmpNodeScopeModeStatus;

=head1 METHODS

=head2 new

  my $SystemServicesNdmpNodeScopeMode = NACL::C::SystemServicesNdmpNodeScopeMode->new(
                                   command_interface => $ci,
								  );

Return a new SystemServicesNdmpNodeScopeMode component object with the given attributes.

=cut

use Class::MethodMaker [];

=head2 off

    NACL::C::SystemServicesNdmpNodeScopeMode->off(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to disable NDMP node-scope-mode.
Uses CMode CLI/ZAPI .
Invokes ndmp-vserver-aware-mode-enable for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< '*' >>

This method takes all other options supported by "system services ndmp node scope mode off" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub off {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params              => \@args,
        ignore_primary_keys => 1,
        api                 => 'system_services_ndmp_node_scope_mode_off',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_off_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_off_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::SystemServicesNdmpNodeScopeMode::off',
    );

}

sub _off_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_services_ndmp_node_scope_mode_off',);
    $Log->exit() if $may_exit;
}

sub _off_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_zapi(@opts,
        api => 'ndmp-vserver-aware-mode-enable',);
    $Log->exit() if $may_exit;
}

=head2 on

    NACL::C::SystemServicesNdmpNodeScopeMode->on(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to enable NDMP node-scope-mode.
Uses CMode CLI/ZAPI .
Invokes ndmp-node-scope-mode-enable for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< '*' >>

This method takes all other options supported by "system services ndmp node scope mode on" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub on {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params              => \@args,
        ignore_primary_keys => 1,
        api                 => 'system_services_ndmp_node_scope_mode_on',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_on_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_on_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::SystemServicesNdmpNodeScopeMode::on',
    );

}

sub _on_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_services_ndmp_node_scope_mode_on',);
    $Log->exit() if $may_exit;
}

sub _on_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_zapi(@opts,
        api => 'ndmp-node-scope-mode-enable',);
    $Log->exit() if $may_exit;
}

=head2 status

    NACL::C::SystemServicesNdmpNodeScopeMode->status(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to status of NDMP node-scope-mode.
Uses CMode CLI/ZAPI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< '*' >>

This method takes all other options supported by "system services ndmp node scope mode status" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub status {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params              => \@args,
        ignore_primary_keys => 1,
        additional_spec => {
              _optional_scalars( qw( want-vserver-api )) },
        cli_cmd                 => 'system services ndmp node-scope-mode status',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_status_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_status_cmode_zapi',
               interface => 'ZAPI',
               set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemServicesNdmpNodeScopeMode::status',
    );
    $Log->exit() if $may_exit;
    return $ret;

}

sub _status_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $response;

    $pkg->_base_backend_cmode_cli(
        %opts,
        api => 'system_services_ndmp_node_scope_mode_status',
        apiset_response_obj => \$response,
    );

    my $output = $response->get_parsed_output();
    my $obj    = NACL::CS::SystemServicesNdmpNodeScopeModeStatus->new(
        command_interface => $opts{command_interface}
    );
    $obj->status($output->[0]->{status});

    $Log->exit() if $may_exit;
    return $obj;
} ## end sub _status_cmode_cli

sub _status_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my ($response, $output);
    my $obj    = NACL::CS::SystemServicesNdmpNodeScopeModeStatus->new(
             command_interface => $opts{command_interface}
    );
    if ($opts{'want-vserver-api'}) {
    $pkg->_base_backend_cmode_zapi(%opts,
            api => 'ndmp-vserver-aware-mode-status',
            apiset_response_obj => \$response,);
     $output = $response->get_parsed_output();
     $obj->status($output->[0]->{'is-vserver-aware-mode-enabled'});
    } else {
        $pkg->_base_backend_cmode_zapi(%opts,
                api => 'ndmp-node-scope-mode-status',
                apiset_response_obj => \$response,);
        $output = $response->get_parsed_output();
        $obj->status($output->[0]->{'is-node-scope-mode-enabled'});
    }

    $Log->exit() if $may_exit;
    return $obj;

}

__PACKAGE__->_load_event_class();

1;
