# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VolumeFileMove Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VolumeFileMove

=head1 DESCRIPTION

C<NACL::C::VolumeFileMove> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VolumeFileMove.  A related class is
L<NACL::CS::VolumeFileMove|lib-NACL-CS-VolumeFileMove-pm>, which represents
the past state of an ONTAP VolumeFileMove.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 file_index

=head2 job_uuid

=cut

package NACL::C::VolumeFileMove;

use strict;
use warnings;

use NACL::CS::VolumeFileMove;
use NACL::ComponentUtils qw (_optional_scalars);

use NACL::APISet::Exceptions::NoMatchingEntriesException qw(:try);
use NATE::BaseException qw(:try);
use NATE::Exceptions::Argument ();

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::CS::VolumeSnapshot;
use NACL::C::_Mixins::VolumeFileCopyMove qw(:all);

=head1 METHODS

=head2 new

  my $VolumeFileMove = NACL::C::VolumeFileMove->new(
                                   command_interface => $ci,
                                   'job_uuid' => $job_uuid,
                                   'file_index' => $job_uuid,
                                  );

Return a new VolumeFileMove component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'job_uuid',
    scalar => 'file_index',
];

=head2 find

    my $VolumeFileMove_obj  = NACL::C::VolumeFileMove->find(command_interface => $ci, ...);
    my @VolumeFileMove_objs = NACL::C::VolumeFileMove->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VolumeFileMove_state = $VolumeFileMove_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VolumeFileMove would return
a NACL::CS::VolumeFileMove object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 start

    my @VolumeFileMove_objs    = NACL::C::VolumeFileMove->start(
        command_interface => $ci,
        'source-paths' => [ $source-path1, $source-path2, ... ],
        'destination-paths' => [ $destination-path1, $destination-path2, ... ],
        ...);

(Class method)
This method is used to moves a file or set of files from one flexible volume
to another. The destination volume can be located on the same node as the
original volume or on a different node..

Uses a CMode CLI/ZAPI APISet.

Invokes "file-move-start" API for CMode ZAPI.

B<NOTE>: This method defaults to going through the ZAPI. The reason for this
is that the CLI "start" command is not available in customer (i.e. promoted)
builds, while the ZAPI is available to customers. Note that it would still be
possible to run this through the CLI if C<< interface => 'CLI' >> is provided
through either apiset_should or apiset_must.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'max-cutover-time' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: cutover-time

=item C<< 'max-throughput' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'scanner-paused' => $string >>

Applicable for CMode CLI.

=item C<< 'scanner-limit' => $string >>

Applicable for CMode CLI.

=item C<< 'source-paths' => [ $source-path1, $source-path2, ... ] >>

Either a single vserver:volume/path or an array ref of paths.

Applicable for CMode CLI/ZAPI.

=item C<< 'destination-paths' => [ $destination-path1, $destination-path2, ... ] >>

Either a single vserver:volume/path or an array ref of paths. A Unique
destination can either be specified for each source path or a single destination
for all of the source paths.

Applicable for CMode CLI/ZAPI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'hold-quiescence' => $string >>

*Hold Quiescence, possible value(s) are true,false

Applicable for CMode CLI/ZAPI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'reference-max-cutover-time' => $string >>

Maximum Cut Over Time for Reference File (seconds)
Applicable for CMode CLI/ZAPI.

Maps to:

CMode ZAPI: reference-cutover-time

=item C<< 'reference-path' => $string >>

Source Reference File Path
Applicable for CMode CLI/ZAPI.

=item C<< 'report-completed' => $string >>

Report Completed Status (120 secs) possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'report-time' => $string >>

Completion Report Time (seconds)
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "volume file move start" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::VolumeFileMove::MaximumSimultaneousOperation>

This exception gets thrown, when we attempt for
File move operation and maximum simultaneous file operations reached.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub start {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'source-paths'      => {type => ARRAYREF | SCALAR},
            'destination-paths' => {type => ARRAYREF | SCALAR},
            _optional_scalars(
                qw( max-cutover-time max-throughput scanner-paused scanner-limit
                    hold-quiescence
                    reference-max-cutover-time reference-path

                    report-completed

                    report-time
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'volume file move start',
    );

    my @move_instances = $pkg->_create_common_code(%opts,
        frontend => 'NACL::C::VolumeFileMove::start');

    $Log->exit() if $may_exit;
    return wantarray ? @move_instances : $move_instances[0];
}

sub _start_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $response;
    $pkg->_base_backend_cmode_cli(
        %opts,
        api                 => 'volume_file_move_start',
        apiset_response_obj => \$response
    );

    ${$opts{_job_uuid}} = $response->get_parsed_output()->[0]{'job-uuid'};
    $Log->exit() if $may_exit;
}

sub _start_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_start_cmode_zapi_helper(@opts, api => 'file-move-start');
    $Log->exit() if $may_exit;
}

=head2 destroy

    NACL::C::VolumeFileMove->destroy(
                                command_interface => $ci,
	                            'job-uuid' => $job_uuid,
	                            'file-index' => $file_index,
                                ...);
	                             
								 or

    $VolumeFileMove_obj->destroy(...);

(Class or instance method)
This method is used to destructively aborts an incomplete file move operation. All pending data scans will be halted. The destination file will be deleted. The source file will be destroyed as well..
Uses CMode CLI/ZAPI .

Invokes "file-move-destory" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'job-uuid' => $job_uuid >>

(Required for class method, Not Applicable for instance method)
Job UUID
Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <file-move-destroy>
      <job-uuid>$value</job-uuid>
 </file-move-destroy>

=item C<< 'file-index' => $file_index >>

(Required for class method, Not Applicable for instance method)
File Index
Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <file-move-destroy>
      <file-index>$value</file-index>
 </file-move-destroy>

=item C<< 'allow-destroy-file' => 'true' | 'false' >>

(Optional)

Specifies whether the file being moved may be deleted in order to destroy the
file move operation.  Default is 'true' for compatibility with the CMode CLI.

Applicable for CMode ZAPI.

=item C<< '*' >>

This method takes all other options supported by "volume file move destroy" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub destroy {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( allow-destroy-file
                    )
            ),
        },
        cli_cmd => 'volume file move destroy',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_destroy_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                check     => '_destroy_cmode_cli_check',
            },
            {   method    => '_destroy_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VolumeFileMove::destroy',
    );

}

sub _destroy_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'volume_file_move_destroy',);
    $Log->exit() if $may_exit;
}

sub _destroy_cmode_cli_check {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    if (defined($opts{'allow-destroy-file'})
        && ($opts{'allow-destroy-file'} eq 'false'))
    {
        $Log->exit() if $may_exit;
        NACL::Exceptions::InvalidChoice->throw('Could not use the CLI '
                . "implementation of ${pkg}::destroy because the CLI destroy "
                . "comamnd does not support passing 'allow-destroy-file' => 'false'"
        );
    }
    $Log->exit() if $may_exit;
}

sub _destroy_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_destroy_cmode_zapi_helper(
        'allow-destroy-file' => 'true',
        @opts,
        api => 'file-move-destroy'
    );
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VolumeFileMove->modify(
                                command_interface => $ci,
	                            'job-uuid' => $job_uuid,
	                            'file-index' => $file_index,
                                ...);
	                             
								 or

    $VolumeFileMove_obj->modify(...);

(Class or instance method)
This method is used to modify an incomplete file move operation. May be used to pause or change the rate limit of the data scanner..
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'job-uuid' => $job_uuid >>

(Required for class method, Not Applicable for instance method)
Job UUID
Applicable for CMode CLI

=item C<< 'file-index' => $file_index >>

(Required for class method, Not Applicable for instance method)
File Index
Applicable for CMode CLI

=item C<< 'max-throughput' => $string >>

Maximum Scanner Speed
Applicable for CMode CLI

=item C<< 'scanner-paused' => $string >>

Scanner Paused possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "volume file move modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( max-throughput scanner-paused
                    )
            ),
        },
        cli_cmd => 'volume file move modify',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VolumeFileMove::modify',
    );

}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'volume_file_move_modify',);
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'job-uuid'   => {type => SCALAR},
        'file-index' => {type => SCALAR},
    );
}

1;
