#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VolumeMoveTargetAggr Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VolumeMoveTargetAggr

=head1 DESCRIPTION

C<NACL::C::VolumeMoveTargetAggr> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VolumeMoveTargetAggr.  A related class is
L<NACL::CS::VolumeMoveTargetAggr|lib-NACL-CS-VolumeMoveTargetAggr-pm>, which represents
the past state of an ONTAP VolumeMoveTargetAggr.
However, since it does not have any primary keys, 'find' and 'state' do not
work for this component. (This component is considered a 'singleton',
i.e. there is only one row shown by the relevant 'show' command)

=cut

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=cut

package NACL::C::VolumeMoveTargetAggr;

use strict;
use warnings;

use NACL::CS::VolumeMoveTargetAggr;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $VolumeMoveTargetAggr = NACL::C::VolumeMoveTargetAggr->new(command_interface=>$ci,
								  );

Return a new VolumeMoveTargetAggr component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'volume',
    scalar => 'vserver',
];


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        vserver => {type => SCALAR},
        volume  => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
