#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VolumeSnapshotAutodelete Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VolumeSnapshotAutodelete

=head1 DESCRIPTION

C<NACL::C::VolumeSnapshotAutodelete> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VolumeSnapshotAutodelete.  A related class is
L<NACL::CS::VolumeSnapshotAutodelete|lib-NACL-CS-VolumeSnapshotAutodelete-pm>, which represents
the past state of an ONTAP VolumeSnapshotAutodelete.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 volume

=head2 vserver

=cut

package NACL::C::VolumeSnapshotAutodelete;

use strict;
use warnings;

use NACL::CS::VolumeSnapshotAutodelete;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::C::_Mixins::VolumeSnapshotAutodelete qw(:all);

=head1 METHODS

=head2 new

  my $VolumeSnapshotAutodelete = NACL::C::VolumeSnapshotAutodelete->new(command_interface=>$ci,
                                   volume =>$volume,
                                   vserver =>$vserver,
                                  );

Return a new VolumeSnapshotAutodelete component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'volume',
    scalar => 'vserver',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 find

    my $VolumeSnapshotAutodelete  = NACL::C::VolumeSnapshotAutodelete->find(command_interface => $ci, ...);
    my @VolumeSnapshotAutodeletes = NACL::C::VolumeSnapshotAutodelete->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $VolumeSnapshotAutodelete_state = $NACL::C::VolumeSnapshotAutodelete->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VolumeSnapshotAutodelete would return
a NACL::CS::VolumeSnapshotAutodelete object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 modify

   NACL::C::VolumeSnapshotAutodelete->modify(
                                command_interface => $ci,
                                 volume => $volume,
                                 vserver => $vserver,
                                  ...);

                                 or

    $VolumeSnapshotAutodelete_object->modify(...);

(Class or instance method)
This method is used to modify autodelete settings.

Uses a CMode CLI, CMode-ZAPI or 7Mode CLI APISet.

Invokes snapshot-autodelete-set-options for CMode-ZAPI.

Invokes "snap autodelete" command for 7Mode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "volume" => $volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : volume name <value> (Programmatic name: "vol-name")

=item C<< "vserver" => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "delete-order" => $string >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : delete_order <value> (Programmatic name: "delete-order")

=item C<< "trigger" => $string >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : trigger <value> (Programmatic name: "trigger")

=item C<< "defer-delete-prefix" => $string >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : prefix <value> (Programmatic name: "prefix")

=item C<< "destroy-list" => $string >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : destroy_list <value> (Programmatic name: "destroy-list")

=item C<< "target-free-space" => $string >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : target_free_space <value> (Programmatic name: "target-free-space")

=item C<< "commitment" => $string >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : commitment <value> (Programmatic name: "commitment")

=item C<< "defer-delete" => $string >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : defer_delete <value> (Programmatic name: "defer-delete")

=item C<< "enabled" => $string >>

Applicable for CMode CLI/ZAPI, 7Mode CLI.

Maps to:

7M CLI : action name (Programmatic name: "action")

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< '*' >>

This method takes all other options supported by
"volume snapshot autodelete modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( delete-order trigger defer-delete-prefix destroy-list target-free-space
                    commitment defer-delete enabled
                    )
            ),
        },
        cli_cmd => 'volume snapshot autodelete modify',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_modify_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
            {   method    => "_modify_cmode_zapi",
                interface => "ZAPI",
                set       => "CMode",
            },
            {   method    => "_modify_7mode_cli",
                interface => "CLI",
                set       => "7Mode",
            },
        ],
        frontend => 'NACL::C::VolumeSnapshotAutodelete::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my %args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => [
            qw( commitment trigger target-free-space
                delete-order defer-delete destroy-list)
        ],
        target => \%args,
        map    => {
            "volume"              => "vol-name",
            "enabled"             => "action",
            "defer-delete-prefix" => "prefix",
        }
    );

    if (defined($args{action}) && $args{action} eq 'true') {
        $args{action} = 'on';
    } elsif (defined($args{action}) && $args{action} eq 'false') {
        $args{action} = 'off';
    }

    $apiset->snap_autodelete(%args);
    $Log->exit() if $may_exit;
} ## end sub _modify_7mode_cli

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(
        @opts,
        api     => 'volume_snapshot_autodelete_modify',
    );
    $Log->exit() if $may_exit;
 } ## end sub _modify_cmode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts          = $pkg_or_obj->_validate_backend_opts(@args);
    my $apiset        = $opts{apiset};
    my %zapi_call_opts;
    my %zapi_opts;

    # separate out volume
    $zapi_call_opts{volume}  = $opts{volume};
    
    my $enabled = $opts{enabled};
    if (defined $enabled) {
        my $state;
        if ($enabled eq 'true') {
            $state = 'on';
        } elsif ($enabled eq 'false') {
            $state = 'off';
        } else {
            $state = $enabled;
        }
        $opts{enabled} = $state;
    }

    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $pkg_or_obj->_common_zapi_copy(),
        map    => $pkg_or_obj->_common_zapi_map(),
        target => \%zapi_opts,
    );
    

    $pkg_or_obj->_handle_zapi_vserver_context(
        api_opts          => \%zapi_call_opts,
        vserver           => $opts{vserver},
        command_interface => $opts{command_interface},
    );

    # Not using the base back-end method since we need to make multiple
    # APISet calls and each call would result in the same code being redone
    # in the base back-end method.
    foreach my $option (keys %zapi_opts) {
        $apiset->snapshot_autodelete_set_option(%zapi_call_opts,
            'option-name' => $option, 'option-value' => $zapi_opts{$option},
        );
    }

    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_zapi


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'volume'  => {type => SCALAR},
        'vserver' => {type => SCALAR, optional => 1},
    );
} ## end sub _primary_keys_validate_spec

1;
