# Copyright (c) 2001-2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsBranchcache Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, pkj@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverCifsBranchcache

=head1 DESCRIPTION

C<NACL::C::VserverCifsBranchcache> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverCifsBranchcache.  A related class is
L<NACL::CS::VserverCifsBranchcache|lib-NACL-CS-VserverCifsBranchcache-pm>, which represents
the past state of an ONTAP VserverCifsBranchcache.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=cut

package NACL::C::VserverCifsBranchcache;

use strict;
use warnings;

use NACL::CS::VserverCifsBranchcache;
use NACL::ComponentUtils qw (_optional_scalars Dumper);
use NACL::C::UnitNormalization qw (convert_to_bytes_int);
use NACL::C::Exceptions::VserverCifsBranchcache::AlreadyExists;
use NACL::C::Exceptions::VserverCifsBranchcache::DoesNotExist ();
use NACL::APISet::Exceptions::ResponseException qw(:try);
use NACL::C::Exceptions::Component qw(:try);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $VserverCifsBranchcache = NACL::C::VserverCifsBranchcache->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                  );

Return a new VserverCifsBranchcache component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'vserver',];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 find

    my $VserverCifsBranchcache_obj  = NACL::C::VserverCifsBranchcache->find(command_interface => $ci, ...);
    my @VserverCifsBranchcache_objs = NACL::C::VserverCifsBranchcache->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.
This method executes cifs-branchcache-get-iter for CMode ZAPI.

=head2 state

    my VserverCifsBranchcache_state = $VserverCifsBranchcache_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverCifsBranchcache would return
a NACL::CS::VserverCifsBranchcache object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.
This method executes cifs-branchcache-get-iter for CMode ZAPI.

=cut

=head2 delete

    NACL::C::VserverCifsBranchcache->delete(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                ...);

                                 or

    $VserverCifsBranchcache_obj->delete(...);

(Class or instance method)
This method is used to stop and remove BranchCache service.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-branchcache-remove" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
         option.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< 'flush-hashes' => $string >>

Delete Existing Hashes possible value(s) are, true,false
Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs branchcache delete" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::VserverCifsBranchcache::DoesNotExist>

This type of exception gets thrown when an operation is performed on branchcache that doesn't exist.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( flush-hashes
                    )
            )
        },
        api => 'vserver_cifs_branchcache_delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $pkg_or_obj->call_on_apiset(
                %opts,
                choices => [
                    {   method    => '_delete_cmode_cli',
                        interface => 'CLI',
                        set       => 'CMode',
                    },
                    {   method    => '_delete_cmode_zapi',
                        interface => 'ZAPI',
                        set       => 'CMode',
                    },
                ],
                frontend => 'NACL::C::VserverCifsBranchcache::delete',
            );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverCifsBranchcache::DoesNotExist
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };

    $Log->exit() if $may_exit;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_branchcache_delete',);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_zapi(
        @opts,
        copy            => [qw(flush-hashes)],
        api             => 'cifs-branchcache-remove',
        frontend_method => 'delete',
    );
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VserverCifsBranchcache->modify(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                ...);

                                 or

    $VserverCifsBranchcache_obj->modify(...);

(Class or instance method)
This method is used to modify BranchCache service settings.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-branchcache-modify" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
         option.

=item C<< 'hash-store-max-size' => $string >>

Maximum Size of the Hash Store, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Applicable for CMode CLI/ZAPI

Maps to:

CM ZAPI: hash-store-max-size

=item C<< 'server-key' => $string >>

Encryption Key Used to Secure the Hashes

Applicable for CMode CLI/ZAPI

Maps to:

CM ZAPI: server-key

=item C<< 'hash-store-path' => $string >>

Path to Hash Store

Applicable for CMode CLI/ZAPI

Maps to:

CM ZAPI: hash-store-path

=item C<< 'operating-mode' => $string >>

CIFS BranchCache Operating Modes, possible value(s) are
disable,all-shares,per-share

Applicable for CMode CLI/ZAPI

Maps to:

CM ZAPI: operating-mode

=item C<< 'versions' => [ $version1, $version2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI

Maps to:

CM ZAPI: versions

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< 'hash-store-max-size-bytes' => $string >>

Maximum Size of the Hash Store
Applicable for CMode CLI

=item C<< 'server-secret' => $string >>

Encryption Key Used to Secure the Hashes
Applicable for CMode CLI

=item C<< 'flush-hashes' => $string >>

Delete Existing Hashes possible value(s) are, true,false
Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs branchcache modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'versions' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( hash-store-max-size server-key hash-store-path operating-mode

                    hash-store-max-size-bytes server-secret flush-hashes
                    )
            ),
        },
        cli_cmd => 'vserver cifs branchcache modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsBranchcache::modify',
    );
    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@args,
        api => 'vserver_cifs_branchcache_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my $allowed_cmode_options = [
        qw( versions hash-store-max-size server-key
            operating-mode hash-store-path flush-hashes
            )
    ];

    $pkg_or_obj->_base_backend_cmode_zapi(@args,
        api => 'cifs_branchcache_modify',
        copy   => $allowed_cmode_options,
    );
    $Log->exit() if $may_exit;
}

=head2 create

    my $VserverCifsBranchcache_obj    = NACL::C::VserverCifsBranchcache->create(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                ...);

(Class method)
This method is used to create the BranchCache service.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-branchcache-create" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required)
Vserver

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
         option.

=item C<< 'hash-store-max-size' => $string >>

Maximum Size of the Hash Store, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: hash-store-max-size

=item C<< 'server-key' => $string >>

Encryption Key Used to Secure the Hashes

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: server-key

=item C<< 'hash-store-path' => $string >>

Path to Hash Store

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: hash-store-path

=item C<< 'operating-mode' => $string >>

CIFS BranchCache Operating Modes, possible value(s) are
disable,all-shares,per-share

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: operating-mode

=item C<< 'versions' => [ $version1, $version2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: versions

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs branchcache create" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::VserverCifsBranchcache::AlreadyExists>

This type of exception gets thrown if an attempt is made to create a brachcache which already exists.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'versions' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( hash-store-max-size server-key hash-store-path operating-mode
                    )
            ),
        },
        cli_cmd => 'vserver cifs branchcache create',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $pkg->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_create_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_create_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::VserverCifsBranchcache::create',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverCifsBranchcache::AlreadyExists
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        vserver           => $opts{vserver},
    );
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_base_backend_cmode_cli(@args,
        api     => 'vserver_cifs_branchcache_create',
    );
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_cli

sub _create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;

    # 663505 BURT fix - allow 1 GB,MB,KB ... in hash-store-max-size
    if (defined $opts{'hash-store-max-size'}) {
        my $value_in_bytes
            = convert_to_bytes_int($opts{'hash-store-max-size'});
        $opts{'hash-store-max-size'} = $value_in_bytes;
    }

    my $allowed_cmode_options = [
        qw( versions hash-store-max-size server-key
            operating-mode hash-store-path
            )
    ];

    $pkg->_base_backend_cmode_zapi(%opts,
        api    => 'cifs_branchcache_create',
        copy   => $allowed_cmode_options,
    );

    $Log->exit() if $may_exit;
}

=head2 hash_flush

    NACL::C::VserverCifsBranchcache->hash_flush(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                ...);

                                 or

    $VserverCifsBranchcache_obj->hash_flush(...);

(Class or instance method)
This method is used to flush all generated hashes.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-branchcache-flush" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
         option.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs branchcache hash-flush" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub hash_flush {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        cli_cmd => 'vserver cifs branchcache hash-flush',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_hash_flush_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_hash_flush_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsBranchcache::hash_flush',
    );

    $Log->exit() if $may_exit;
} ## end sub hash_flush

sub _hash_flush_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@args,
        api     => 'vserver_cifs_branchcache_hash_flush',
    );
    $Log->exit() if $may_exit;
} ## end sub _hash_flush_cmode_cli

sub _hash_flush_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_base_backend_cmode_zapi(@args,
        api     => 'cifs_branchcache_flush',
    );
    $Log->exit() if $may_exit;
}

=head2 hash_create

    NACL::C::VserverCifsBranchcache->hash_create(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                ...);

(Class method)
This method is used to force hash generation for specified path or file.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-branchcache-hash" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required)
Vserver

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
         option.

=item C<< 'recurse' => $string >>

Process All Files in the Directory Recursively, possible value(s) are true,false

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: recurse

=item C<< 'path' => $string >>

Path of File or Directory to Hash

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: path

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs branchcache hash-create" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub hash_create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( recurse path
                    )
            ),
        },
        cli_cmd => 'vserver cifs branchcache hash-create',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_hash_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_hash_create_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsBranchcache::hash_create',
    );

    $Log->exit() if $may_exit;
} ## end sub hash_create

sub _hash_create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_base_backend_cmode_cli(@args,
        api     => 'vserver_cifs_branchcache_hash_create',
    );
    $Log->exit() if $may_exit;
} ## end sub _hash_create_cmode_cli

sub _hash_create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $allowed_cmode_options = [qw( recurse path )];

    $pkg->_base_backend_cmode_zapi(@args,
        api    => 'cifs_branchcache_hash',
        copy   => $allowed_cmode_options,
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('vserver' => {type => SCALAR},);
}

1;
