# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsUsersAndGroups Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverCifsUsersAndGroups

=head1 DESCRIPTION

C<NACL::C::VserverCifsUsersAndGroups> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. 
Unlike other components this package does not model any element/service 
but is present to provide component-level support for functionality. 
Since it does not model any element/service there is no ComponentState 
module for this component. For the same reason, 'find' and 'state' will
not work for this component.
Instead NACL::CS::VserverCifsUsersAndGroups->fetch() should be used.
(See L<fetch|lib-NACL-CS-ComponentState-pm/fetch> for a full description)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::VserverCifsUsersAndGroups;

use strict;
use warnings;

use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $VserverCifsUsersAndGroups = NACL::C::VserverCifsUsersAndGroups->new(
                                   command_interface => $ci,
								  );

Return a new VserverCifsUsersAndGroups component object with the given attributes.

=cut

use Class::MethodMaker [];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 show_domain_sid

    my $show_domain_sid_obj = NACL::C::VserverCifsUsersAndGroups->show_domain_sid(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_domain_sid_objs = NACL::C::VserverCifsUsersAndGroups->show_domain_sid(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_domain_sid_obj = $VserverCifsUsersAndGroups_obj->show_domain_sid(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverCifsUsersAndGroupsShowDomainSid-pm/ATTRIBUTES>
of NACL::CS::VserverCifsUsersAndGroupsShowDomainSid as input. 
This method returns objects of the type L<NACL::CS::VserverCifsUsersAndGroupsShowDomainSid|lib-NACL-CS-VserverCifsUsersAndGroupsShowDomainSid-pm>.

=cut

sub show_domain_sid {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::VserverCifsUsersAndGroupsShowDomainSid;
    my @state_objs
        = NACL::CS::VserverCifsUsersAndGroupsShowDomainSid->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 update_names

    NACL::C::VserverCifsUsersAndGroups->update_names(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to update the names of Active Directory users and groups.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'suppress-all-output' => $string >>

Suppress All Output possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'vserver' => $string >>

Vserver
Applicable for CMode CLI

=item C<< 'display-failed-only' => $string >>

Display Only Failures possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver cifs users and groups update names" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub update_names {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( suppress-all-output vserver display-failed-only
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'vserver_cifs_users_and_groups_update_names',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_update_names_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsUsersAndGroups::update_names',
    );

}

sub _update_names_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_users_and_groups_update_names',);
    $Log->exit() if $may_exit;
}

__PACKAGE__->_load_event_class();

1;
