# $Id: //depot/prod/test/nacldev/lib/NACL/C/VserverCifsUsersAndGroupsLocalUser.pm#2 $

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsUsersAndGroupsLocalUser Component Module (auto-generated by CGT)
## @author pbala@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverCifsUsersAndGroupsLocalUser

=head1 DESCRIPTION

C<NACL::C::VserverCifsUsersAndGroupsLocalUser> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverCifsUsersAndGroupsLocalUser.  A related class is
L<NACL::CS::VserverCifsUsersAndGroupsLocalUser|lib-NACL-CS-VserverCifsUsersAndGroupsLocalUser-pm>, which represents
the past state of an ONTAP VserverCifsUsersAndGroupsLocalUser.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 user_name

=cut

package NACL::C::VserverCifsUsersAndGroupsLocalUser;

use strict;
use warnings;

use NACL::CS::VserverCifsUsersAndGroupsLocalUser;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR SCALARREF ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $VserverCifsUsersAndGroupsLocalUser = NACL::C::VserverCifsUsersAndGroupsLocalUser->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                   'user-name' => $user_name,
                                  );

Return a new VserverCifsUsersAndGroupsLocalUser component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'user_name',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 find

    my $VserverCifsUsersAndGroupsLocalUser_obj  = NACL::C::VserverCifsUsersAndGroupsLocalUser->find(command_interface => $ci, ...);
    my @VserverCifsUsersAndGroupsLocalUser_objs = NACL::C::VserverCifsUsersAndGroupsLocalUser->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverCifsUsersAndGroupsLocalUser_state = $VserverCifsUsersAndGroupsLocalUser_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverCifsUsersAndGroupsLocalUser would return
a NACL::CS::VserverCifsUsersAndGroupsLocalUser object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 delete

    NACL::C::VserverCifsUsersAndGroupsLocalUser->delete(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'user-name' => $user_name,
                                ...);

                                 or

    $VserverCifsUsersAndGroupsLocalUser_obj->delete(...);

(Class or instance method)
This method is used to delete a local user.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-local-user-delete" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'user-name' => $user_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: user-name

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-user delete" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver cifs users-and-groups local-user delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_delete_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsUsersAndGroupsLocalUser::delete',
        nacl_exceptions => [qw(DoesNotExist)],
    );

    $Log->exit() if $may_exit;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_users_and_groups_local_user_delete',);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(user-name)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'cifs-local-user-delete',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_zapi

=head2 create

    my $VserverCifsUsersAndGroupsLocalUser_obj    = NACL::C::VserverCifsUsersAndGroupsLocalUser->create(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'user-name' => $user_name,
                                ...);

(Class method)
This method is used to create a local user.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-local-user-create" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'user-name' => $user_name >>

(Required)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: user-name

=item C<< 'user-cannot-change-password' => $string >>

Applicable for CMode CLI.

=item C<< 'sid-aliases' => $string >>

Applicable for CMode CLI.

=item C<< 'password-must-change-time' => $string >>

Applicable for CMode CLI.

=item C<< 'primary-group-id' => $string >>

Applicable for CMode CLI.

=item C<< 'password' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: user-password

=item C<< 'must-change-password' => $string >>

Applicable for CMode CLI.

=item C<< 'is-account-disabled' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: is-account-disabled

=item C<< 'password-can-change-time' => $string >>

Applicable for CMode CLI.

=item C<< 'full-name' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: full-name

=item C<< 'description' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: description

=item C<< 'account-expiry-time' => $string >>

Applicable for CMode CLI.

=item C<< 'is-account-locked' => $string >>

Applicable for CMode CLI.

=item C<< 'password-never-expires' => $string >>

Applicable for CMode CLI.

=item C<< 'password-last-set' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'password-prevent-tc124' => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-user create" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( user-cannot-change-password sid-aliases password-must-change-time
                    primary-group-id password must-change-password is-account-disabled
                    password-can-change-time full-name description account-expiry-time
                    is-account-locked password-never-expires password-last-set

                    password-prevent-tc124
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups local-user create',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_create_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsUsersAndGroupsLocalUser::create',
        nacl_exceptions => [qw(AlreadyExists)],
    );
    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        vserver           => $vserver,
        user_name         => $opts{'user-name'},
    );

    $Log->exit() if $may_exit;
    return $obj;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $password          = delete $opts{'password'};
    my %additional_args;
    my $prompt_answers = [
        'Enter the password:'   => sub {$password},
        'Confirm the password:' => sub {$password},
    ];
    $additional_args{'connectrec-match_table'} = $prompt_answers;
    $pkg->_base_backend_cmode_cli(
        %opts,
        api             => 'vserver_cifs_users_and_groups_local_user_create',
        additional_args => \%additional_args
    );
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_cli

sub _create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [
        qw(user-name 
            full-name description is-account-disabled)
    ];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        copy => $copy,
	map  => {'password' => 'user-password'},
        api  => 'cifs-local-user-create',
    );
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_zapi

=head2 rename

    NACL::C::VserverCifsUsersAndGroupsLocalUser->rename(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'user-name' => $user_name,
                                ...);

                                 or

    $VserverCifsUsersAndGroupsLocalUser_obj->rename(...);

(Class or instance method)
This method is used to rename a local user.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-local-user-rename" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'user-name' => $user_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: user-name

=item C<< 'new-user-name' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: new-user-name

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-user rename" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub rename {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( new-user-name
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups local-user rename',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_rename_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_rename_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsUsersAndGroupsLocalUser::rename',
    );

    $Log->exit() if $may_exit;
} ## end sub rename

sub _rename_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    $pkg->_base_backend_cmode_cli(%opts,
        api => 'vserver_cifs_users_and_groups_local_user_rename',);
    $pkg->user_name($opts{'new-user-name'})
        if (ref $pkg);
    $Log->exit() if $may_exit;

} ## end sub _rename_cmode_cli

sub _rename_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $copy = [qw(user-name new-user-name)];
    $pkg->_base_backend_cmode_zapi(
        %opts,
        api  => 'cifs-local-user-rename',
        copy => $copy,
    );
    $pkg->user_name($opts{'new-user-name'})
        if (ref $pkg);
    $Log->exit() if $may_exit;

} ## end sub _rename_cmode_zapi

=head2 show_sid

    my $show_sid_obj = NACL::C::VserverCifsUsersAndGroupsLocalUser->show_sid(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

    my @show_sid_objs = NACL::C::VserverCifsUsersAndGroupsLocalUser->show_sid(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

   my $show_sid_obj = $VserverCifsUsersAndGroupsLocalUser_obj->show_sid();

(Class or Instance method)
This method returns objects of the type L<NACL::CS::VserverCifsUsersAndGroupsLocalUserShowSid|lib-NACL-CS-VserverCifsUsersAndGroupsLocalUserShowSid-pm>.

This method accepts all the parameters accepted by L<fetch|lib-NACL-CS-ComponentState-pm/fetch>
(requested_fields, filter, allow_empty) and has all of the other properties of
fetch methods (callable in scalar or list context, throws a NoElementsFound
exception if no matching elements are found)

Uses a CMode CLI/ZAPI APISet.

=cut

sub show_sid {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_handle_obj_cs_like_calls(@_);
    require NACL::CS::VserverCifsUsersAndGroupsLocalUserShowSid;
    my @state_objs
        = NACL::CS::VserverCifsUsersAndGroupsLocalUserShowSid->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub show_sid

=head2 set_password

    NACL::C::VserverCifsUsersAndGroupsLocalUser->set_password(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'user-name' => $user_name,
                                ...);

                                 or

    $VserverCifsUsersAndGroupsLocalUser_obj->set_password(...);

(Class or instance method)
This method is used to set a password for a local user.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-local-user-set-password" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'user-name' => $user_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: user-name

=item C<< 'user-password' => $password >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: user-password

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-user set-password" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub set_password {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( user-password
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups local-user set-password',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_set_password_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_set_password_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverCifsUsersAndGroupsLocalUser::set_password',
    );

    $Log->exit() if $may_exit;
} ## end sub set_password

sub _set_password_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my %additional_args;
    my $password          = delete $opts{'user-password'};
    my $prompt_answers = [
        'Enter the new password:'   => sub {$password},
        'Confirm the new password:' => sub {$password},
    ];
    $additional_args{'connectrec-match_table'} = $prompt_answers;
    $pkg->_base_backend_cmode_cli(
        %opts,
        api             => 'vserver_cifs_users_and_groups_local_user_set_password',
        additional_args => \%additional_args
    );
    $Log->exit() if $may_exit;

} ## end sub _set_password_cmode_cli

sub _set_password_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_zapi(
        @opts,
        copy => [qw(user-name user-password)],
        api  => 'cifs-local-user-set-password',
    );
    $Log->exit() if $may_exit;
} ## end sub _set_password_cmode_zapi

=head2 modify

    NACL::C::VserverCifsUsersAndGroupsLocalUser->modify(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'user-name' => $user_name,
                                ...);

                                 or

    $VserverCifsUsersAndGroupsLocalUser_obj->modify(...);

(Class or instance method)
This method is used to modify a local user.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-local-user-modify" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'user-name' => $user_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: user-name

=item C<< 'user-cannot-change-password' => $string >>

Applicable for CMode CLI.

=item C<< 'sid-aliases' => $string >>

Applicable for CMode CLI.

=item C<< 'password-must-change-time' => $string >>

Applicable for CMode CLI.

=item C<< 'primary-group-id' => $string >>

Applicable for CMode CLI.

=item C<< 'password' => $string >>

Applicable for CMode CLI.

=item C<< 'must-change-password' => $string >>

Applicable for CMode CLI.

=item C<< 'is-account-disabled' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: is-account-disabled

=item C<< 'password-can-change-time' => $string >>

Applicable for CMode CLI.

=item C<< 'full-name' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: full-name

=item C<< 'description' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: description

=item C<< 'account-expiry-time' => $string >>

Applicable for CMode CLI.

=item C<< 'is-account-locked' => $string >>

Applicable for CMode CLI.

=item C<< 'password-never-expires' => $string >>

Applicable for CMode CLI.

=item C<< 'password-last-set' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'password-prevent-tc124' => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-user modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( user-cannot-change-password sid-aliases password-must-change-time
                    primary-group-id password must-change-password is-account-disabled
                    password-can-change-time full-name description account-expiry-time
                    is-account-locked password-never-expires password-last-set

                    password-prevent-tc124
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups local-user modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsUsersAndGroupsLocalUser::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_users_and_groups_local_user_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(user-name is-account-disabled full-name description)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'cifs-local-user-modify',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_zapi

=head2 show_membership

    my $show_membership_obj = NACL::C::VserverCifsUsersAndGroupsLocalUser->show_membership(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

    my @show_membership_objs = NACL::C::VserverCifsUsersAndGroupsLocalUser->show_membership(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

   my $show_membership_obj = $VserverCifsUsersAndGroupsLocalUser_obj->show_membership();

(Class or Instance method)
This method returns objects of the type L<NACL::CS::VserverCifsUsersAndGroupsLocalUserShowMembership|lib-NACL-CS-VserverCifsUsersAndGroupsLocalUserShowMembership-pm>.

This method accepts all the parameters accepted by L<fetch|lib-NACL-CS-ComponentState-pm/fetch>
(requested_fields, filter, allow_empty) and has all of the other properties of
fetch methods (callable in scalar or list context, throws a NoElementsFound
exception if no matching elements are found)

Uses a CMode CLI/ZAPI APISet.

=cut

sub show_membership {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_handle_obj_cs_like_calls(@_);
    require NACL::CS::VserverCifsUsersAndGroupsLocalUserShowMembership;
    my @state_objs
        = NACL::CS::VserverCifsUsersAndGroupsLocalUserShowMembership->fetch(
        %opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub show_membership

=head2 mycreate

    NACL::C::VserverCifsUsersAndGroupsLocalUser->mycreate(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'user-name' => $user_name,
                                ...);
   
(Class method)
Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required)
Vserver possible value(s) are, vserver name
Applicable for CMode CLI

=item C<< 'user-name' => $user_name >>

(Required)
User Name possible value(s) are, CIFS name
Applicable for CMode CLI

=item C<< 'user-password' => $string >>

The password for the local user possible value(s) are, text
Applicable for CMode CLI

=item C<< 'full-name' => $string >>

The full name of the local user possible value(s) are, TextNoCase
Applicable for CMode CLI

=item C<< 'is-account-disabled' => $string >>

The local user account is disabled possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'description' => $string >>

The description of the local user possible value(s) are, TextNoCase
Applicable for CMode CLI

=item C<< 'cmd_execution_time' => \$scalar >>

(Optional) Scalar reference , it will be updated with the command execution
time returned by the apiset response object

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-user mycreate" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub mycreate {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'cmd_execution_time' => {type => SCALARREF, optional => 1},
            _optional_scalars(
                qw( user-password full-name is-account-disabled description
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups local-user mycreate',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_mycreate_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsUsersAndGroupsLocalUser::mycreate',
    );

    $Log->exit() if $may_exit;
} ## end sub mycreate

sub _mycreate_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;

    $pkg->_base_backend_cmode_cli(
        @opts,
        api => 'vserver_cifs_users_and_groups_local_user_mycreate',
    );

    $Log->exit() if $may_exit;
} ## end sub _mycreate_cmode_cli

=head2 myset_password

    NACL::C::VserverCifsUsersAndGroupsLocalUser->myset_password(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'user-name' => $user_name,
                                ...);
	                             
								 or

    $VserverCifsUsersAndGroupsLocalUser_obj->myset_password(...);

(Class or instance method)
Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver possible value(s) are, vserver name
Applicable for CMode CLI

=item C<< 'user-name' => $user_name >>

(Required for class method, Not Applicable for instance method)
User Name possible value(s) are, CIFS name
Applicable for CMode CLI

=item C<< 'user-password' => $string >>

The Password for a Local User possible value(s) are, text
Applicable for CMode CLI

=item C<< 'cmd_execution_time' => \$scalar >>

(Optional) Scalar reference , it will be updated with the command execution
time returned by the apiset response object

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-user myset-password" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub myset_password {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'cmd_execution_time' => {type => SCALARREF, optional => 1},
            _optional_scalars(
                qw( user-password
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups local-user myset-password',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_myset_password_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverCifsUsersAndGroupsLocalUser::myset_password',
    );

    $Log->exit() if $may_exit;
} ## end sub myset_password

sub _myset_password_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;

    $pkg_or_obj->_base_backend_cmode_cli(
        @opts,
        api => 'vserver_cifs_users_and_groups_local_user_myset_password',
    );

    $Log->exit() if $may_exit;
} ## end sub _myset_password_cmode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver'   => {type => SCALAR},
        'user-name' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
