# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsUsersAndGroupsPrivilege Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com,raghaveb@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverCifsUsersAndGroupsPrivilege

=head1 DESCRIPTION

C<NACL::C::VserverCifsUsersAndGroupsPrivilege> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverCifsUsersAndGroupsPrivilege.  A related class is
L<NACL::CS::VserverCifsUsersAndGroupsPrivilege|lib-NACL-CS-VserverCifsUsersAndGroupsPrivilege-pm>, which represents
the past state of an ONTAP VserverCifsUsersAndGroupsPrivilege.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 user_or_group_name

=cut

package NACL::C::VserverCifsUsersAndGroupsPrivilege;

use strict;
use warnings;

use NACL::CS::VserverCifsUsersAndGroupsPrivilege;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF );
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $VserverCifsUsersAndGroupsPrivilege = NACL::C::VserverCifsUsersAndGroupsPrivilege->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                   'domain-name' => $domain_name,
                                   'entry-rid' => $entry_rid,
                                  );

Return a new VserverCifsUsersAndGroupsPrivilege component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'user_or_group_name',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 find

    my $VserverCifsUsersAndGroupsPrivilege_obj  = NACL::C::VserverCifsUsersAndGroupsPrivilege->find(command_interface => $ci, ...);
    my @VserverCifsUsersAndGroupsPrivilege_objs = NACL::C::VserverCifsUsersAndGroupsPrivilege->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my VserverCifsUsersAndGroupsPrivilege_state = $VserverCifsUsersAndGroupsPrivilege_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverCifsUsersAndGroupsPrivilege would return
a NACL::CS::VserverCifsUsersAndGroupsPrivilege object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 remove_privilege

    NACL::C::VserverCifsUsersAndGroupsPrivilege->remove_privilege(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'domain-name' => $domain_name,
                                'entry-rid' => $entry_rid,
                                ...);

                                 or

    $VserverCifsUsersAndGroupsPrivilege_obj->remove_privilege(...);

(Class or instance method)
This method is used to remove privileges from a user or group.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-privilege-remove-privilege" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'domain-name' => $domain_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'entry-rid' => $entry_rid >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'user-or-group-name' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: user-or-group-name

=item C<< 'privileges' => [ $privilege1, $privilege2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: privileges

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups privilege remove-privilege" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub remove_privilege {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'privileges' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( user-or-group-name entry-rid
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups privilege remove-privilege',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_remove_privilege_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_remove_privilege_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverCifsUsersAndGroupsPrivilege::remove_privilege',
    );

    $Log->exit() if $may_exit;
} ## end sub remove_privilege

sub _remove_privilege_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_users_and_groups_privilege_remove_privilege',);
    $Log->exit() if $may_exit;
} ## end sub _remove_privilege_cmode_cli

sub _remove_privilege_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(privileges user-or-group-name)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        copy => $copy,
        api  => 'cifs_privilege_remove_privilege',
    );
    $Log->exit() if $may_exit;
} ## end sub _remove_privilege_cmode_zapi

=head2 add_privilege

    my $VserverCifsUsersAndGroupsPrivilege_obj =
        NACL::C::VserverCifsUsersAndGroupsPrivilege->add_privilege(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'domain-name' => $domain_name,
                                'entry-rid' => $entry_rid,
                                ...);

                                 or

    $VserverCifsUsersAndGroupsPrivilege_obj->add_privilege(...);

(Class or instance method)
This method is used to add local privileges to a user or group.

Uses a CMode CLI and ZAPI APISet.

Invokes "cifs-privilege-add-privilege" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.


=item C<< 'domain-name' => $domain_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'entry-rid' => $entry_rid >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'user-or-group-name' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: user-or-group-name

=item C<< 'privileges' => [ $privilege1, $privilege2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: privileges


=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups privilege add-privilege" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub add_privilege {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'privileges' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( user-or-group-name entry-rid
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups privilege add-privilege',
    );
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_add_privilege_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_add_privilege_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverCifsUsersAndGroupsPrivilege::add_privilege',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub add_privilege

sub _add_privilege_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->_base_backend_cmode_cli(%opts,
        api => 'vserver_cifs_users_and_groups_privilege_add_privilege',);
    $Log->exit() if $may_exit;

    if (ref $pkg_or_obj) {
        return $pkg_or_obj;
    } else {
        return $pkg_or_obj->new(
            command_interface    => $opts{command_interface},
            'vserver'            => $vserver,
            'user-or-group-name' => $opts{'user-or-group-name'}
        );
    } ## end else [ if ( ref $pkg_or_obj )]

} ## end sub _add_privilege_cmode_cli

sub _add_privilege_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    my $copy = [qw(privileges user-or-group-name)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        %opts,
        copy => $copy,
        api  => 'cifs_privilege_add_privilege',
    );
    $Log->exit() if $may_exit;
    if (ref $pkg_or_obj) {
        return $pkg_or_obj;
    } else {
        return $pkg_or_obj->new(
            command_interface    => $opts{command_interface},
            'vserver'            => $vserver,
            'user-or-group-name' => $opts{'user-or-group-name'}
        );
    } ## end else [ if ( ref $pkg_or_obj )]
} ## end sub _add_privilege_cmode_zapi

=head2 reset_privilege

    NACL::C::VserverCifsUsersAndGroupsPrivilege->reset_privilege(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'domain-name' => $domain_name,
                                'entry-rid' => $entry_rid,
                                ...);

                                 or

    $VserverCifsUsersAndGroupsPrivilege_obj->reset_privilege(...);

(Class or instance method)
This method is used to reset local privileges for a user or group.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-privilege-reset-privilege" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'domain-name' => $domain_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'entry-rid' => $entry_rid >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'user-or-group-name' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: user-or-group-name

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups privilege reset-privilege" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub reset_privilege {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( user-or-group-name entry-rid
                    )
            )
        },
        cli_cmd => 'vserver cifs users-and-groups privilege reset-privilege',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_reset_privilege_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_reset_privilege_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverCifsUsersAndGroupsPrivilege::reset_privilege',
    );

    $Log->exit() if $may_exit;
} ## end sub reset_privilege

sub _reset_privilege_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_users_and_groups_privilege_reset_privilege',);
    $Log->exit() if $may_exit;
} ## end sub _reset_privilege_cmode_cli

sub _reset_privilege_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_zapi(
        @opts,
        copy => [qw( user-or-group-name )],
        api  => 'cifs_privilege_reset_privilege',
    );
    $Log->exit() if $may_exit;
} ## end sub _reset_privilege_cmode_zapi


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver'            => {type => SCALAR},
        'user-or-group-name' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
