#$Id: //depot/prod/test/nacldev/lib/NACL/C/VserverCifsUtilitiesFile.pm#5 $
#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsUtilitiesFile Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverCifsUtilitiesFile

=head1 DESCRIPTION

C<NACL::C::VserverCifsUtilitiesFile> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverCifsUtilitiesFile.  A related class is
L<NACL::CS::VserverCifsUtilitiesFile|lib-NACL-CS-VserverCifsUtilitiesFile-pm>, which represents
the past state of an ONTAP VserverCifsUtilitiesFile.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 file_id

=head2 vserver

=head2 node

=cut

package NACL::C::VserverCifsUtilitiesFile;

use strict;
use warnings;

use NACL::CS::VserverCifsUtilitiesFile;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $VserverCifsUtilitiesFile = NACL::C::VserverCifsUtilitiesFile->new(
                                   command_interface => $ci,
                                   'file-id' => $file_id,
                                   'vserver' => $vserver,
                                   'node' => $node,
								  );

Return a new VserverCifsUtilitiesFile component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'file_id',
    scalar => 'vserver',
    scalar => 'node',
];

=head2 find

    my $VserverCifsUtilitiesFile_obj  = NACL::C::VserverCifsUtilitiesFile->find(command_interface => $ci, ...);
	my @VserverCifsUtilitiesFile_objs = NACL::C::VserverCifsUtilitiesFile->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my VserverCifsUtilitiesFile_state = $VserverCifsUtilitiesFile_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverCifsUtilitiesFile would return 
a NACL::CS::VserverCifsUtilitiesFile object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'file-id' => { type => SCALAR },
        'vserver' => { type => SCALAR },
        'node'    => { type => SCALAR },
    );
}

1;
