# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverFpolicyPolicyEvent Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, benjaram@netapp.com
## @status public
## @pod here

=head1 NAME

NACL::C::VserverFpolicyPolicyEvent

=head1 DESCRIPTION

C<NACL::C::VserverFpolicyPolicyEvent> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverFpolicyPolicyEvent.  A related class is
L<NACL::CS::VserverFpolicyPolicyEvent|lib-NACL-CS-VserverFpolicyPolicyEvent-pm>, which represents
the past state of an ONTAP VserverFpolicyPolicyEvent.
However, since it does not have any primary keys, 'find' and 'state' do not
work for this component. (This component is considered a 'singleton',
i.e. there is only one row shown by the relevant 'show' command)

=cut

=head1 ATTRIBUTES

=head2 vserver

=head2 event_name

=cut

package NACL::C::VserverFpolicyPolicyEvent;

use strict;
use warnings;

use NACL::CS::VserverFpolicyPolicyEvent;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::C::Exceptions::VserverFpolicyPolicyEvent::AlreadyExists ();
use NACL::C::Exceptions::VserverFpolicyPolicyEvent::DoesNotExist  ();
use NATE::BaseException qw(:try);

=head1 METHODS

=head2 new

  my $VserverFpolicyPolicyEvent = NACL::C::VserverFpolicyPolicyEvent->new(
                                   command_interface => $ci,
                                  );

Return a new VserverFpolicyPolicyEvent component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'event_name',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 find

    my $VserverFpolicyPolicyEvent_obj  = NACL::C::VserverFpolicyPolicyEvent->find(command_interface => $ci, ...);
    my @VserverFpolicyPolicyEvent_objs = NACL::C::VserverFpolicyPolicyEvent->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverFpolicyPolicyEvent_state = $VserverFpolicyPolicyEvent_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverFpolicyPolicyEvent would return
a NACL::CS::VserverFpolicyPolicyEvent object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 delete

    NACL::C::VserverFpolicyPolicyEvent->delete(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to delete Event.

Uses a CMode CLI/ZAPI APISet.

Invokes "fpolicy-policy-event-delete" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'event-name' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: event-name

=item C<< 'vserver' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver fpolicy policy event delete" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<NACL::C::Exceptions::VserverFpolicyPolicyEvent::DoesNotExist>
This exception is thrown when we attempt to delete an Vserver Fpolicy Policy Event
when entry does not exists.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver fpolicy policy event delete',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_delete_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                check     => '_delete_zapi_check',
            },
        ],
        frontend => 'NACL::C::VserverFpolicyPolicyEvent::delete',
        nacl_exceptions => [qw(DoesNotExist)]
    );
    $Log->exit() if $may_exit;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_fpolicy_policy_event_delete',);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_zapi(@opts,
        api    => 'fpolicy_policy_event_delete',
        copy   => [qw ( event-name )],
    );
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_zapi

sub _delete_zapi_check {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my @fields_to_check = ('event-name');
    $pkg_or_obj->_fallback_for_relational_regex(%opts, fields_to_check => \@fields_to_check);

    $Log->exit() if $may_exit;
} ## end sub _delete_zapi_check    

=head2 modify

    NACL::C::VserverFpolicyPolicyEvent->modify(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to modify Event.

Uses a CMode CLI/ZAPI APISet.

Invokes "fpolicy-policy-event-modify" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'event-name' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: event-name

=item C<< 'vserver' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'protocol' => [ $protocol1, $protocol2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: protocol

=item C<< 'volume-operations' => [ $volume-operation1, $volume-operation2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: volume-operations


=item C<< 'file-operations' => [ $file-operation1, $file-operation2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: file-opetations

=item C<< 'filters' => [ $filter1, $filter2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: filter-string

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'volume-operation' => $string >>

Volume Operation, possible value(s) are true,false

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver fpolicy policy event modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( volume-operation
                    )
            ),
            'protocol'          => {type => ARRAYREF | SCALAR, optional => 1},
            'volume-operations' => {type => ARRAYREF,          optional => 1},
            'file-operations'   => {type => ARRAYREF,          optional => 1},
            'filters'           => {type => ARRAYREF,          optional => 1},
        },
        cli_cmd => 'vserver fpolicy policy event modify',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverFpolicyPolicyEvent::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_fpolicy_policy_event_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;

    if ($opts{'protocol'}) {
        $opts{'protocol'} = $opts{'protocol'}->[0];
    }

    $pkg->_base_backend_cmode_zapi(%opts,
        api    => 'fpolicy_policy_event_modify',
        copy   =>
            [qw ( event-name protocol volume-operations file-operations )],
        map    => {'filters' => 'filter-string',},
    );

    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_zapi

=head2 create

    my $VserverFpolicyPolicyEvent_obj    = NACL::C::VserverFpolicyPolicyEvent->create(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to create Event.

Uses a CMode CLI/ZAPI APISet.

Invokes "fpolicy-policy-event-create" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'event-name' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: event-name

=item C<< 'vserver' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'protocol' => [ $protocol1, $protocol2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: protocol

=item C<< 'volume-operations' => [ $volume-operation1, $volume-operation2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: volume-operations

=item C<< 'file-operations' => [ $file-operation1, $file-operation2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: file-opetations

=item C<< 'filters' => [ $filter1, $filter2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: filter-string

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'volume-operation' => $string >>

Volume Operation, possible value(s) are true,false

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver fpolicy policy event create" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<NACL::C::Exceptions::VserverFpolicyPolicyEvent::AlreadyExists>
This exception is thrown when we attempt to create a Vserver Fpolicy Policy
Event which already exists.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( volume-operation
                    )
            ),
            'protocol'          => {type => ARRAYREF | SCALAR, optional => 1},
            'volume-operations' => {type => ARRAYREF,          optional => 1},
            'volume-operation'  => {type => SCALAR,            optional => 1},
            'file-operations'   => {type => ARRAYREF,          optional => 1},
            'filters'           => {type => ARRAYREF,          optional => 1},
        },
        cli_cmd => 'vserver fpolicy policy event create',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_create_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverFpolicyPolicyEvent::create',
        nacl_exceptions => [qw(AlreadyExists)]
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        'event-name'      => $opts{'event-name'},
        vserver           => $vserver
    );
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_fpolicy_policy_event_create',);
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_cli

sub _create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $allowed_cmode_options
        = [qw( event-name protocol volume-operations file-operations)];

    if ($opts{'protocol'}) {
        $opts{'protocol'} = $opts{'protocol'}->[0];
    }

    $pkg->_base_backend_cmode_zapi(%opts,
        api    => 'fpolicy_policy_event_create',
        copy   => $allowed_cmode_options,
        map    => {'filters' => 'filter-string',},
    );

    $Log->exit() if $may_exit;
} ## end sub _create_cmode_zapi


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        vserver      => {type => SCALAR, optional => 1},
        'event-name' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
