# Copyright (c) 2001-2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverFpolicyPolicyExternalEngine Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, benjaram@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverFpolicyPolicyExternalEngine

=head1 DESCRIPTION

C<NACL::C::VserverFpolicyPolicyExternalEngine> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverFpolicyPolicyExternalEngine.  A related class is
L<NACL::CS::VserverFpolicyPolicyExternalEngine|lib-NACL-CS-VserverFpolicyPolicyExternalEngine-pm>, which represents
the past state of an ONTAP VserverFpolicyPolicyExternalEngine.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 engine_name
None.

=cut

package NACL::C::VserverFpolicyPolicyExternalEngine;

use strict;
use warnings;

use NACL::CS::VserverFpolicyPolicyExternalEngine;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::C::Exceptions::VserverFpolicyPolicyExternalEngine::AlreadyExists ();
use NACL::C::Exceptions::VserverFpolicyPolicyExternalEngine::DoesNotExist  ();
use NACL::C::_Mixins::VserverFpolicyPolicyExternalEngine qw(:all);
use NATE::BaseException qw(:try);

=head1 METHODS

=head2 new

  my $VserverFpolicyPolicyExternalEngine = NACL::C::VserverFpolicyPolicyExternalEngine->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                   'engine-name' => $engine_name,
                                  );

Return a new VserverFpolicyPolicyExternalEngine component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'engine_name',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
} ## end sub init

=head2 find

    my $VserverFpolicyPolicyExternalEngine_obj  = NACL::C::VserverFpolicyPolicyExternalEngine->find(command_interface => $ci, ...);
    my @VserverFpolicyPolicyExternalEngine_objs = NACL::C::VserverFpolicyPolicyExternalEngine->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.
Uses fpolicy_policy_external_engine_get_iter for CMode ZAPI.

=head2 state

    my VserverFpolicyPolicyExternalEngine_state = $VserverFpolicyPolicyExternalEngine_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverFpolicyPolicyExternalEngine would return
a NACL::CS::VserverFpolicyPolicyExternalEngine object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 delete

    NACL::C::VserverFpolicyPolicyExternalEngine->delete(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'engine-name' => $engine_name,
                                ...);

                                 or

    $VserverFpolicyPolicyExternalEngine_obj->delete(...);

(Class or instance method)
This method is used to delete an External Engine.

Uses a CMode CLI/ZAPI APISet.

Invokes "fpolicy-policy-external-engine-delete" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'engine-name' => $engine_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: engine-name

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver fpolicy policy external-engine delete" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<NACL::C::Exceptions::VserverFpolicyPolicyExternalEngine::DoesNotExist>
This exception is thrown when we attempt to delete an Vserver Fpolicy Policy
External Engine when entry does not exist.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver fpolicy policy external-engine delete',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_delete_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverFpolicyPolicyExternalEngine::delete',
        nacl_exceptions => [qw(DoesNotExist)]
    );

    $Log->exit() if $may_exit;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_fpolicy_policy_external_engine_delete',);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_zapi(@opts,
        api    => 'fpolicy_policy_external_engine_delete',
        copy   => [qw( engine-name )],
    );
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_zapi

=head2 create

    my $VserverFpolicyPolicyExternalEngine_obj    = NACL::C::VserverFpolicyPolicyExternalEngine->create(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to create an External Engine.

Uses a CMode CLI/ZAPI APISet.

Invokes "fpolicy-policy-external-engine-create" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'extern-engine-type' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: extern-engine-type

=item C<< 'status-req-interval' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: status-request-interval

=item C<< 'port' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: port-number

=item C<< 'reqs-cancel-timeout' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: request-cancel-timeout

=item C<< 'max-server-reqs' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: max-server-requests

=item C<< 'reqs-abort-timeout' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: request-abort-timeout

=item C<< 'server-progress-timeout' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: server-progress-timeout

=item C<< 'credential-lifetime' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: credential-lifetime

=item C<< 'max-connection-retries' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: max-connection-retries

=item C<< 'ssl-common-name' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ssl-common-name

=item C<< 'max-policy-reqs' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: max-policy-requests

=item C<< 'secondary-servers' => [ $secondary-server1, $secondary-server2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: secondary-servers

=item C<< 'primary-servers' => [ $primary-server1, $primary-server2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: primary-servers

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'certificate-common-name' => $string >>

FQDN or Custom Common Name
Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: certificate-common-name

=item C<< 'certificate-ca' => $string >>

Certificate Authority
Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: certificate-ca

=item C<< 'ssl-option' => $string >>


SSL Option for External Communication possible value(s) are, no-auth,server-auth,mutual-auth
Applicable for CMode CLI/ZAPI

Maps to:

CM ZAPI: ssl-option

=item C<< 'certificate-serial' => $string >>

Serial Number of Certificate
Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: certificate-serial

=item C<< 'keep-alive-interval' => $string >>

Interval for Sending Keep-Alive Messages
Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: keep-alive-interval

=item C<< 'session-timeout' => $string >>

Session ID Purge Timeout During Reconnection
Applicable for CMode CLI

=item C<< 'recv-buffer-size' => $string >>

Receive Buffer Size
Applicable for CMode CLI

=item C<< 'send-buffer-size' => $string >>

Send Buffer Size
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver fpolicy policy external-engine create" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<NACL::C::Exceptions::VserverFpolicyPolicyExternalEngine::AlreadyExists>
This exception is thrown when we attempt to create a Vserver Fpolicy Policy
External Engine which already exists.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'secondary-servers' => {type => ARRAYREF, optional => 1},
            'primary-servers'   => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( extern-engine-type status-req-interval port reqs-cancel-timeout
                    max-server-reqs reqs-abort-timeout server-progress-timeout
                    credential-lifetime max-connection-retries ssl-common-name
                    max-policy-reqs

                    certificate-common-name certificate-ca ssl-option certificate-serial
                    keep-alive-interval

                    session-timeout recv-buffer-size send-buffer-size
                    )
            ),
        },
        cli_cmd => 'vserver fpolicy policy external-engine create',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_create_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverFpolicyPolicyExternalEngine::create',
        nacl_exceptions => [qw(AlreadyExists)]
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        vserver           => $vserver,
        engine_name       => $opts{'engine-name'},
    );
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_fpolicy_policy_external_engine_create',);
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_cli

sub _create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $common_copy = $pkg->_common_zapi_copy();
    my $common_map  = $pkg->_common_zapi_map();
    my $map         = {};
    $pkg->_hash_copy(
        source => $common_map,
        target => $map,
        copy   => [
            qw ( max-policy-reqs  max-server-reqs status-req-interval port reqs-cancel-timeout reqs-abort-timeout)
        ]
    );
    $map->{'secondary-servers'} = 'secondary-servers';
    $map->{'primary-servers'}   = 'primary-servers';

    $pkg->_base_backend_cmode_zapi(
        %opts,
        api             => 'fpolicy-policy-external-engine-create',
        copy            => $common_copy,
        map             => $map,
        frontend_method => 'create',
    );
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_zapi

=head2 modify

    NACL::C::VserverFpolicyPolicyExternalEngine->modify(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'engine-name' => $engine_name,
                                ...);

                                 or

    $VserverFpolicyPolicyExternalEngine_obj->modify(...);

(Class or instance method)
This method is used to modify an External Engine.

Uses a CMode CLI/ZAPI APISet.

Invokes "vserver-fpolicy-policy-external-engine-modify" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'engine-name' => $engine_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: engine-name

=item C<< 'extern-engine-type' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: extern-engine-type

=item C<< 'status-req-interval' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: status-request-interval

=item C<< 'port' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: port-number

=item C<< 'reqs-cancel-timeout' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: request-cancel-timeout

=item C<< 'max-server-reqs' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: max-server-requests

=item C<< 'reqs-abort-timeout' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: request-abort-timeout

=item C<< 'server-progress-timeout' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: server-progress-timeout

=item C<< 'credential-lifetime' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: credential-lifetime

=item C<< 'max-connection-retries' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: max-connection-retries

=item C<< 'ssl-common-name' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ssl-common-name

=item C<< 'max-policy-reqs' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: max-policy-requests

=item C<< 'secondary-servers' => [ $secondary-server1, $secondary-server2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: secondary-servers

=item C<< 'primary-servers' => [ $primary-server1, $primary-server2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: primary-servers

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'certificate-common-name' => $string >>

FQDN or Custom Common Name
Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: certificate-common-name

=item C<< 'certificate-ca' => $string >>

Certificate Authority
Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI:certificate-ca

=item C<< 'ssl-option' => $string >>


SSL Option for External Communication possible value(s) are, no-auth,server-auth,mutual-auth
Applicable for CMode CLI/ZAPI

Maps to:

CM ZAPI: ssl-option

=item C<< 'certificate-serial' => $string >>

Serial Number of Certificate
Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: certificate-serial

=item C<< 'keep-alive-interval' => $string >>

Interval for Sending Keep-Alive Messages
Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: keep-alive-interval

=item C<< 'session-timeout' => $string >>

Session ID Purge Timeout During Reconnection
Applicable for CMode CLI

=item C<< 'recv-buffer-size' => $string >>

Receive Buffer Size
Applicable for CMode CLI

=item C<< 'send-buffer-size' => $string >>

Send Buffer Size
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver fpolicy policy external-engine modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'secondary-servers' => {type => ARRAYREF, optional => 1},
            'primary-servers'   => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( extern-engine-type status-req-interval port reqs-cancel-timeout
                    max-server-reqs reqs-abort-timeout server-progress-timeout
                    credential-lifetime max-connection-retries ssl-common-name
                    max-policy-reqs

                    certificate-common-name certificate-ca ssl-option certificate-serial
                    keep-alive-interval

                    session-timeout recv-buffer-size send-buffer-size
                    )
            ),
        },
        cli_cmd => 'vserver fpolicy policy external-engine modify',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverFpolicyPolicyExternalEngine::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_fpolicy_policy_external_engine_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $common_copy = $pkg->_common_zapi_copy();
    my $common_map  = $pkg->_common_zapi_map();
    my $map         = {};
    $pkg->_hash_copy(
        source => $common_map,
        target => $map,
        copy   => [
            qw ( max-policy-reqs  max-server-reqs status-req-interval port reqs-cancel-timeout reqs-abort-timeout)
        ]
    );

    $map->{'secondary-servers'} = 'secondary-servers';
    $map->{'primary-servers'}   = 'primary-servers';

    $pkg->_base_backend_cmode_zapi(
        %opts,
        api             => 'fpolicy-policy-external-engine-modify',
        copy            => $common_copy,
        map             => $map,
        frontend_method => 'modify',
        zapi_field_translations => { 
            hrminsec_to_sec => [qw( status-req-interval session-timeout server-progress-timeout 
            reqs-abort-timeout reqs-cancel-timeout keep-alive-interval ) ]
        }
    );
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_zapi

#
#The get_api_options method is overridden, because ssl-option
# is not listed in the cdef file.
# We can remove this method when product burt#657254 is
# resolved
#
sub get_api_options {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %args) = @_;
    my %target_hash = $pkg_or_obj->SUPER::get_api_options(%args);
    if (exists $args{options}{'ssl-option'}) {
        $target_hash{'ssl-option'} = $args{options}{'ssl-option'};
    }
    $Log->exit() if $may_exit;
    return %target_hash;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver'     => {type => SCALAR, 'optional' => '1'},
        'engine-name' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
