#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverIscsiInterfaceAccesslist Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, benjaram@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverIscsiInterfaceAccesslist

=head1 DESCRIPTION

C<NACL::C::VserverIscsiInterfaceAccesslist> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverIscsiInterfaceAccesslist.  A related class is
L<NACL::CS::VserverIscsiInterfaceAccesslist|lib-NACL-CS-VserverIscsiInterfaceAccesslist-pm>, which represents
the past state of an ONTAP VserverIscsiInterfaceAccesslist.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 initiator

=head2 initiator_name

=head2 vserver

=cut

package NACL::C::VserverIscsiInterfaceAccesslist;

use strict;
use warnings;

use NACL::CS::VserverIscsiInterfaceAccesslist;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF UNDEF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;
use NATE::Exceptions::Argument qw(:try);
use NACL::C::_Mixins::VserverIscsi qw(:all);

=head1 METHODS

=head2 new

  my $VserverIscsiInterfaceAccesslist = NACL::C::VserverIscsiInterfaceAccesslist->new(command_interface=>$ci,
                                   initiator_name =>$initiator_name,
                                   vserver =>$vserver,
                                  );

Return a new VserverIscsiInterfaceAccesslist component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'initiator',
    scalar => 'initiator_name',
    scalar => 'vserver',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
} ## end sub init

=head2 find

    my $VserverIscsiInterfaceAccesslist  = NACL::C::VserverIscsiInterfaceAccesslist->find(command_interface => $ci, ...);
    my @VserverIscsiInterfaceAccesslists = NACL::C::VserverIscsiInterfaceAccesslist->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses CMode CLI/ZAPI, 7Mode CLI APISet.

Invokes 'iscsi-interface-accesslist-get-iter' api for CMode ZAPI.

Invokes 'iscsi interface accesslist show' command for 7Mode CLI.

=head2 state

    my $VserverIscsiInterfaceAccesslist_state = $NACL::C::VserverIscsiInterfaceAccesslist->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverIscsiInterfaceAccesslist would return
a NACL::CS::VserverIscsiInterfaceAccesslist object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses CMode CLI/ZAPI, 7Mode CLI APISet.

=cut

=head2 add

   NACL::C::VserverIscsiInterfaceAccesslist->add(
                                command_interface => $ci,
                                 initiator_name => $initiator_name,
                                 vserver => $vserver,
                                  ...);

                                 or

    $VserverIscsiInterfaceAccesslist_object->add(...);

(Class or instance method)
This method is used to add the iSCSI LIFs to the accesslist of the specified initiator.

Uses a CMode CLI/ZAPI APISet and 7Mode CLI Apiset.

Invokes 'iscsi-interface-accesslist-add' api for CMode ZAPI.

Invokes 'iscsi interface accesslist add' command for 7Mode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "initiator" => $initiator >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: initiator

=item C<< "initiator-name" => $initiator_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI, 7Mode CLI.

Maps to:

CM ZAPI: initiator

7M CLI : initiator name (Programmatic name: initiator-name)

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : initiator name (Programmatic name: "initiator-name")

=item C<< "vserver" => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
         option.

=item C<< "all" => $string >>

(Boolean takes "true" or "false")

Applicable for CMode CLI, 7Mode CLI.

7M CLI:
    If this opion is true then backend method executes the api call
    without interface option.
Maps to:

7M CLI : -a (Programmatic name: "all")

=item C<< "force" => $string >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : -f (Programmatic name: "force")

=item C<< "lifs" => [ $lif1, $lif2, ... ] >>

Applicable for CMode CLI.

=item C<< "lif" => [ $lif1, $lif2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : interface name (Programmatic name: "interface")

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< 'lifs' => $string >>

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver iscsi interface accesslist add" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub add {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            "lif" => {type => SCALAR | ARRAYREF, optional => 1},
            _optional_scalars(
                qw( all force

                    lifs
                    )
            ),
        },
        cli_cmd => 'vserver iscsi interface accesslist add',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->_scalar_to_array_deprication_warning(
        params  => ['lif'],
        options => \%opts
    );
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_add_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
            {   method    => "_add_7mode_cli",
                interface => "CLI",
                set       => "7Mode",
            },
            {   method    => "_add_cmode_zapi",
                interface => "ZAPI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::VserverIscsiInterfaceAccesslist::add',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub add

sub _add_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@args,
        api     => 'vserver_iscsi_interface_accesslist_add',
    );
    $Log->exit() if $may_exit;
} ## end sub _add_cmode_cli

sub _add_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my $allowed_mode_options = [
        qw( all force initiator-name
            )
    ];
    my %iscsi_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_mode_options,
        target => \%iscsi_args,
    );

    if (exists $iscsi_args{all} && $iscsi_args{all} eq "true") {
        $apiset->iscsi_interface_accesslist_add(%iscsi_args);
    } else {
        delete $opts{all};
        if (defined $opts{'lif'}) {
            foreach my $interface (@{$opts{'lif'}}) {
                $apiset->iscsi_interface_accesslist_add(%iscsi_args,
                    'interface' => $interface);
            }
        } else {
            $apiset->iscsi_interface_accesslist_add(%iscsi_args);
        }
    }

    $Log->exit() if $may_exit;
} ## end sub _add_7mode_cli

sub _add_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = validate_with(
        params      => \@args,
        spec        => $pkg->_backend_validate_spec(),
        allow_extra => 1
    );
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vserver           = $opts{vserver};

    my $allowed_cmode_options = [qw( initiator )];
    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        map    => {'initiator-name' => 'initiator'},
        target => \%cmode_args,
    );

    $vserver = $pkg->_handle_zapi_vserver_context(
        api_opts          => \%cmode_args,
        vserver           => $vserver,
        command_interface => $command_interface
    );

    $opts{'lif'} = $pkg->_handle_lif_all_options(%opts);

    my $exception;
    if (defined $opts{'lif'}) {
        foreach my $interface (@{$opts{'lif'}}) {
            try{
                $apiset->iscsi_interface_accesslist_add(%cmode_args,
                    'interface-name' => $interface);
            } otherwise {
                #Burt952247 Don't fail immediately, but execute all ZAPIs first
                $exception = $_[0];
            };
        }
    } else {
        $apiset->iscsi_interface_accesslist_add(%cmode_args);
    }
    if ($exception){
        $Log->exit() if $may_exit;
        $exception->throw();
    }
    $Log->exit() if $may_exit;
} ## end sub _add_cmode_zapi

=head2 remove

   NACL::C::VserverIscsiInterfaceAccesslist->remove(
                                command_interface => $ci,
                                 initiator => $initiator,
                                 vserver => $vserver,
                                  ...);

                                 or

    $VserverIscsiInterfaceAccesslist_object->remove(...);

(Class or instance method)
This method is used to remove the iSCSI LIFs from the accesslist of the specified initiator.

Uses a CMode CLI/ZAPI APISet and 7Mode CLI Apiset.

Invokes 'iscsi-interface-accesslist-remove' api for CMode ZAPI and 7Mode CLI.

Invokes 'iscsi interface accesslist remove' command for 7Mode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "initiator" => $initiator >>

(Required for class method, Not Applicable for instance method)

Applicanle for CMode CLI/ZAPI.

Maps to:

CM ZAPI: initiator

=item C<< "initiator-name" => $initiator_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI, 7Mode CLI.

Maps to:

7M CLI : initiator name (Programmatic name: initiator-name)

CM ZAPI: initiator

Applicable for CMode CLI.

=item C<< "initiator-name" => $initiator_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : initiator name (Programmatic name: "initiator-name")

=item C<< "vserver" => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicanle for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
         option.
Applicable for CMode CLI.

=item C<< "all" => $string >>

(Boolean takes "true" or "false")

Applicable for CMode CLI and 7Mode CLI.

7M CLI:
If this opion is true then backend method executes the api call
without interface option.

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : -a (Programmatic name: "all")

=item C<< "force" => $string >>

Applicanle for CMode CLI and 7Mode CLI.

Maps to:

=item C<< "lifs" => [ $lif1, $lif2, ... ] >>
7M CLI : -f (Programmatic name: "force")

=item C<< "lifs" => [ $lif1, $lif2, ... ] >>

Applicable for CMode CLI.

=item C<< 'lif' => [ $lif1, $lif2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI, 7Mode CLI.

Maps to:

7M CLI: interface name ( Programmatic name: interface )

CM ZAPI: interface-name

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : interface name (Programmatic name: "interface")

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< 'lifs' => $string >>

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver iscsi interface accesslist remove" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub remove {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            "lif" => {type => SCALAR | ARRAYREF, optional => 1},
            _optional_scalars(
                qw( all force

                    lifs
                    )
            ),
        },
        cli_cmd => 'vserver iscsi interface accesslist remove',
    );
    $pkg_or_obj->_scalar_to_array_deprication_warning(
        params  => ['lif'],
        options => \%opts
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_remove_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
            {   method    => "_remove_7mode_cli",
                interface => "CLI",
                set       => "7Mode",
            },
            {   method    => "_remove_cmode_zapi",
                interface => "ZAPI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::VserverIscsiInterfaceAccesslist::remove',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub remove

sub _remove_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@args,
        api     => 'vserver_iscsi_interface_accesslist_remove',
    );
    $Log->exit() if $may_exit;
} ## end sub _remove_cmode_cli

sub _remove_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my $allowed_mode_options = [
        qw( all force initiator-name
            )
    ];
    my %iscsi_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_mode_options,
        target => \%iscsi_args,
    );

    if (exists $iscsi_args{all} && $iscsi_args{all} eq "true") {
        $apiset->iscsi_interface_accesslist_remove(%iscsi_args);
    } else {
        delete $opts{all};
        if (defined $opts{'lif'}) {
            foreach my $interface (@{$opts{'lif'}}) {
                $apiset->iscsi_interface_accesslist_remove(%iscsi_args,
                    'interface' => $interface);
            }
        } else {
            $apiset->iscsi_interface_accesslist_remove(%iscsi_args);
        }
    }

    $Log->exit() if $may_exit;
} ## end sub _remove_7mode_cli

sub _remove_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = validate_with(
        params      => \@args,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vserver           = $opts{vserver};

    my $allowed_cmode_options = [qw( initiator )];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        map    => {'initiator-name' => 'initiator'},
        target => \%cmode_args,
    );

    $pkg_or_obj->_handle_zapi_vserver_context(
        api_opts          => \%cmode_args,
        vserver           => $vserver,
        command_interface => $command_interface
    );

    $opts{'lif'} = $pkg_or_obj->_handle_lif_all_options(%opts);

    my $exception;
     if (defined $opts{'lif'}) {
         foreach my $interface (@{$opts{'lif'}}) {
             try{
                 $apiset->iscsi_interface_accesslist_remove(%cmode_args,
                     'interface-name' => $interface);
             }otherwise {
                 #Burt952247 Don't fail immediately, but execute all ZAPIs first
                 $exception = $_[0];
             };
         }
     } else {
         $apiset->iscsi_interface_accesslist_remove(%cmode_args);
     }
     if ($exception){
         $Log->exit() if $may_exit;
         $exception->throw();
     }

     $Log->exit() if $may_exit;
} ## end sub _remove_cmode_zapi


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'initiator'      => {type => SCALAR | UNDEF, optional => 1},
        'initiator-name' => {type => SCALAR | UNDEF, optional => 1},
        'vserver'        => {type => SCALAR | UNDEF, optional => 1},
    );
} ## end sub _primary_keys_validate_spec

1;
