# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverNfsKerberosConfig Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com benjaram@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverNfsKerberosConfig

=head1 DESCRIPTION

C<NACL::C::VserverNfsKerberosConfig> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverNfsKerberosConfig.  A related class is
L<NACL::CS::VserverNfsKerberosConfig|lib-NACL-CS-VserverNfsKerberosConfig-pm>, which represents
the past state of an ONTAP VserverNfsKerberosConfig.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 lif

=cut

package NACL::C::VserverNfsKerberosConfig;

use strict;
use warnings;

use NACL::CS::VserverNfsKerberosConfig;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $VserverNfsKerberosConfig = NACL::C::VserverNfsKerberosConfig->new(command_interface=>$ci,
                                   vserver =>$vserver,
                                   lif =>$lif,
                                                  );

Return a new VserverNfsKerberosConfig component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'lif',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 find

    my $VserverNfsKerberosConfig  = NACL::C::VserverNfsKerberosConfig->find(command_interface => $ci, ...);
      my @VserverNfsKerberosConfigs = NACL::C::VserverNfsKerberosConfig->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $VserverNfsKerberosConfig_state = $NACL::C::VserverNfsKerberosConfig->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverNfsKerberosConfig would return
a NACL::CS::VserverNfsKerberosConfig object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 modify

   NACL::C::VserverNfsKerberosConfig->modify(
                                command_interface => $ci,
                                   vserver => $vserver,
                                   lif => $lif,
                                  ...);

                                                 or

    $VserverNfsKerberosConfig_object->modify(...);

(Class or instance method)
This method is used to modify the Kerberos configuration of an NFS server.
Uses a CMode CLI/ZAPI APISet.
Invokes "kerberos-config-modify" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< reuse_account => $string >>

(Optional) (Applicable for CMode CLI default: 'y')
This attribute defines the answer for the prompt "Do you want to re-use this account? {y|n}:".
Valid values are 'y' and 'n' meaning 'yes' and 'no' respectively.

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "vserver" => $vserver >>

(Required for class method, Not Applicable for instance method)
Applicable for CMode CLI/ZAPI
Maps to the same option name for CMode ZAPI

=item C<< "lif" => $lif >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI
This maps to interface-name in CMode ZAPI

=item C<< "spn" => $string >>

Applicable for CMode CLI/ZAPI
This maps to service-principal-name in CMode ZAPI

=item C<< "kerberos" => $string >>

Applicable for CMode CLI/ZAPI
This maps to is-kerberos-enabled in CMode ZAPI

=item C<< "keytab-uri" => $string >>

Applicable for CMode CLI/ZAPI
Maps to the same option name for CMode ZAPI

=item C<< "admin-password" => $string >>

Applicable for CMode CLI/ZAPI
Maps to the same option name for CMode ZAPI

=item C<< "admin-username" => $string >>

Applicable for CMode CLI/ZAPI
This maps to admin-user-name in CMode ZAPI

=item C<< 'ou' => $string >>

Organizational Unit
Applicable for CMode CLI/ZAPI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( spn kerberos keytab-uri admin-password admin-username
                    ou reuse_account
                    )
            ),
        },
    );
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_modify_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
            {   method    => "_modify_cmode_zapi",
                interface => "ZAPI",
                set       => "CMode",
                check     => '_check_cmode_zapi_modify'
            },
        ],
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ( $pkg_or_obj, %opts ) = @_;
    my $password           = delete $opts{'admin-password'};
    my $reuse_account = delete $opts{'reuse_account'} || 'y';
    my $prompts_answers    = [ 'Password:' => sub {$password}, qr/want\s+to\s+re-use\s+this\s+account/ => sub {$reuse_account} ];

    $pkg_or_obj->_base_backend_cmode_cli(
        %opts,
        api             => 'vserver_nfs_kerberos_config_modify',
        additional_args => { 'connectrec-match_table' => $prompts_answers, },
    );
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ( $pkg_or_obj, %opts ) = @_;
    my $vserver;

    $pkg_or_obj->_base_backend_cmode_zapi(
        %opts,
        api  => 'kerberos-config-modify',
        copy => [qw(keytab-uri admin-password extended_query ou)],
        map  => {
            'admin-username' => 'admin-user-name',
            'kerberos'       => 'is-kerberos-enabled',
            'spn'            => 'service-principal-name',
            'lif'            => 'interface-name',
        },
        zapi_field_translations => {
            enable_disable    => [qw(kerberos)],
        },
        vserver_operated_on => \$vserver
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver' => {type => SCALAR},
        'lif'     => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

sub _check_cmode_zapi_modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $reuse_account = delete $opts{'reuse_account'};
    if ($reuse_account eq 'n') {
        $Log->exit() if $may_exit;
        NACL::Exceptions::InvalidChoice->throw(
                  "The value of 'reuse_account' was provided as 'n', but ZAPI does not allow this."
                . "For this reason, the ZAPI back-end could not be used for modify"
        );
    }
    $Log->exit() if $may_exit;
}

1;
