# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverNfsKerberosInterface Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverNfsKerberosInterface

=head1 DESCRIPTION

C<NACL::C::VserverNfsKerberosInterface> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverNfsKerberosInterface.  A related class is
L<NACL::CS::VserverNfsKerberosInterface|lib-NACL-CS-VserverNfsKerberosInterface-pm>, which represents
the past state of an ONTAP VserverNfsKerberosInterface.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 lif

=cut

package NACL::C::VserverNfsKerberosInterface;

use strict;
use warnings;

use NACL::CS::VserverNfsKerberosInterface;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(:all);
use NATE::Log qw(log_global);

# Exceptions
use NACL::C::Exceptions::VserverNfsKerberosInterface::AlreadyDisabled;
use NACL::C::Exceptions::VserverNfsKerberosInterface::AlreadyEnabled qw(:try);

=head1 METHODS

=head2 new

  my $VserverNfsKerberosInterface = NACL::C::VserverNfsKerberosInterface->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                   'lif' => $lif,
                                  );

Return a new VserverNfsKerberosInterface component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'lif',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $VserverNfsKerberosInterface_obj  = NACL::C::VserverNfsKerberosInterface->find(command_interface => $ci, ...);
    my @VserverNfsKerberosInterface_objs = NACL::C::VserverNfsKerberosInterface->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverNfsKerberosInterface_state = $VserverNfsKerberosInterface_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverNfsKerberosInterface would return
a NACL::CS::VserverNfsKerberosInterface object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 disable

    NACL::C::VserverNfsKerberosInterface->disable(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'lif' => $lif,
                                ...);

                                 or

    $VserverNfsKerberosInterface_obj->disable(...);

(Class or instance method)
This method is used to disable NFS Kerberos on a LIF.
Uses CMode CLI.


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI

=item C<< 'lif' => $lif >>

(Required for class method, Not Applicable for instance method)
Logical Interface
Applicable for CMode CLI

=item C<< 'admin-password' => $string >>

Account Creation Password
Applicable for CMode CLI

=item C<< 'admin-username' => $string >>

Account Creation Username
Applicable for CMode CLI

=item C<< 'force' => $string >>

Force Disable possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver nfs kerberos interface disable" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http:/thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http:/thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub disable {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( admin-password admin-username force
                    )
            ),
        },
        cli_cmd => 'vserver nfs kerberos interface disable',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_disable_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode'
                },
                {   method    => '_disable_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode'
                },
            ],
            frontend => 'NACL::C::VserverNfsKerberosInterface::disable',
        );
    } catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverNfsKerberosInterface::AlreadyDisabled
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };
    $Log->exit() if $may_exit;
}

sub _disable_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $password           = delete $opts{'admin-password'};
    my $prompts_answers    = [ 'Password:' => sub {$password},];

    $pkg_or_obj->_base_backend_cmode_cli(%opts,
        api => 'vserver_nfs_kerberos_interface_disable',
        additional_args => { 'connectrec-match_table' => $prompts_answers, },);
    $Log->exit() if $may_exit;
}

sub _disable_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    # Add kerberos disabled so that we mimic interface disable command
    $opts{'kerberos'} = 'disabled';
    my $copy = [qw(keytab-uri force admin-password)];
    my $map  = {
        'spn'            => 'service-principal-name',
        'kerberos'       => 'is-kerberos-enabled',
        'ou'             => 'organizational-unit',
        'lif'            => 'interface-name',
        'admin-username' => 'admin-user-name',
    };
    $pkg_or_obj->_base_backend_cmode_zapi(
        %opts,
        api                     => 'kerberos-config-modify',
        copy                    => $copy,
        map                     => $map,
        zapi_field_translations => {enable_disable => [qw(kerberos)],},
    );
    $Log->exit() if $may_exit;
}
=head2 enable

    NACL::C::VserverNfsKerberosInterface->enable(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'lif' => $lif,
                                ...);

                                 or

    $VserverNfsKerberosInterface_obj->enable(...);

(Class or instance method)
This method is used to enable NFS Kerberos on a LIF.
Uses CMode CLI.


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI

=item C<< 'lif' => $lif >>

(Required for class method, Not Applicable for instance method)
Logical Interface
Applicable for CMode CLI

=item C<< 'spn' => $string >>

Service Principal Name
Applicable for CMode CLI

=item C<< 'ou' => $string >>

Organizational Unit
Applicable for CMode CLI

=item C<< 'keytab-uri' => $string >>


Load Keytab from URI possible value(s) are, (ftp,http)://(hostname,IPv4 Address,'['IPv6 Address']')...
Applicable for CMode CLI

=item C<< 'admin-password' => $string >>

Account Creation Password
Applicable for CMode CLI

=item C<< 'admin-username' => $string >>

Account Creation Username
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver nfs kerberos interface enable" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http:/thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http:/thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub enable {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( spn ou keytab-uri admin-password admin-username
                    )
            ),
        },
        cli_cmd => 'vserver nfs kerberos interface enable',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_enable_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode'
                },
                {   method    => '_enable_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::VserverNfsKerberosInterface::enable',
        );
    } catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverNfsKerberosInterface::AlreadyEnabled
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };
    $Log->exit() if $may_exit;
}

sub _enable_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $password           = delete $opts{'admin-password'};
    my $prompts_answers    = [ 'Password:' => sub {$password},
                              qr/want\s+to\s+re-use\s+this\s+account/ => sub {'y'} ];

    $pkg_or_obj->_base_backend_cmode_cli(%opts,
        api => 'vserver_nfs_kerberos_interface_enable',
        additional_args => { 'connectrec-match_table' => $prompts_answers, },
    );
    $Log->exit() if $may_exit;
}

sub _enable_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    # Add kerberos enabled so that we mimic interface enables command
    $opts{'kerberos'} = 'enabled';
    my $copy = [qw(keytab-uri force admin-password)];
    my $map  = {
        'spn'            => 'service-principal-name',
        'kerberos'       => 'is-kerberos-enabled',
        'ou'             => 'organizational-unit',
        'lif'            => 'interface-name',
        'admin-username' => 'admin-user-name',
    };
    $pkg_or_obj->_base_backend_cmode_zapi(
        %opts,
        api                     => 'kerberos-config-modify',
        copy                    => $copy,
        map                     => $map,
        zapi_field_translations => {enable_disable => [qw(kerberos)],},
    );
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VserverNfsKerberosInterface->modify(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'lif' => $lif,
                                ...);

                                 or

    $VserverNfsKerberosInterface_obj->modify(...);

(Class or instance method)
This method is used to modify the Kerberos configuration of an NFS server.
Uses CMode CLI/ZAPI .
Invokes  kerberos-config-modify  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'lif' => $lif >>

(Required for class method, Not Applicable for instance method)
Logical Interface
Applicable for CMode CLI/ZAPI, non-iter.

Mapping for non-iter: interface-name

=item C<< 'kerberos' => $string >>

Kerberos Enabled possible value(s) are, enabled,disabled
Applicable for CMode CLI/ZAPI, non-iter.

Mapping for non-iter: is-kerberos-enabled

=item C<< 'ou' => $string >>

Organizational Unit
Applicable for CMode CLI/ZAPI, non-iter.

Mapping for non-iter: organizational-unit

=item C<< 'keytab-uri' => $string >>


Load Keytab from URI possible value(s) are, (ftp,http)://(hostname,IPv4 Address,'['IPv6 Address']')...
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'admin-username' => $string >>

Account Creation Username
Applicable for CMode CLI/ZAPI, non-iter.

Mapping for non-iter: admin-user-name

=item C<< 'force' => $string >>

Force Disable possible value(s) are, true,false
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'spn' => $string >>

Service Principal Name
Applicable for CMode CLI/ZAPI, non-iter.

Mapping for non-iter: service-principal-name

=item C<< 'admin-password' => $string >>

Account Creation Password
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver nfs kerberos interface modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http:/thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http:/thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( kerberos ou keytab-uri admin-username force spn admin-password )
            ),
        },
        cli_cmd => 'vserver nfs kerberos interface modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_modify_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_modify_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::VserverNfsKerberosInterface::modify',
        );
    } catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverNfsKerberosInterface::AlreadyEnabled
            ->detect_convert_and_throw(exception => $exception);
        NACL::C::Exceptions::VserverNfsKerberosInterface::AlreadyDisabled
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };
    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $password           = delete $opts{'admin-password'};
    my $prompts_answers    = [ 'Password:' => sub {$password},
                              qr/want\s+to\s+re-use\s+this\s+account/ => sub {'y'} ];

    $pkg_or_obj->_base_backend_cmode_cli(
        %opts,
        api => 'vserver_nfs_kerberos_interface_modify',
        additional_args => { 'connectrec-match_table' => $prompts_answers, },
    );
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(keytab-uri force admin-password)];
    my $map  = {
        'spn'            => 'service-principal-name',
        'kerberos'       => 'is-kerberos-enabled',
        'ou'             => 'organizational-unit',
        'lif'            => 'interface-name',
        'admin-username' => 'admin-user-name',
    };
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api                     => 'kerberos-config-modify',
        copy                    => $copy,
        map                     => $map,
        zapi_field_translations => {enable_disable => [qw(kerberos)],},
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver' => {type => SCALAR},
        'lif'     => {type => SCALAR},
    );
}

1;
