#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverSecurityFileDirectoryPolicyTask Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, pkj@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverSecurityFileDirectoryPolicyTask

=head1 DESCRIPTION

C<NACL::C::VserverSecurityFileDirectoryPolicyTask> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverSecurityFileDirectoryPolicyTask.  A related class is
L<NACL::CS::VserverSecurityFileDirectoryPolicyTask|lib-NACL-CS-VserverSecurityFileDirectoryPolicyTask-pm>, which represents
the past state of an ONTAP VserverSecurityFileDirectoryPolicyTask.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 path

=head2 policy_name

=cut

package NACL::C::VserverSecurityFileDirectoryPolicyTask;

use strict;
use warnings;

use NACL::CS::VserverSecurityFileDirectoryPolicyTask;
use NACL::ComponentUtils qw (_optional_scalars Dumper);
use
    NACL::C::Exceptions::VserverSecurityFileDirectoryPolicyTask::AlreadyExists (
    );
use
    NACL::C::Exceptions::VserverSecurityFileDirectoryPolicyTask::DoesNotExist (
    );
use NATE::BaseException qw(:try);
use NATE::Exceptions::Argument qw(:try);
use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use feature qw(state);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::CS::VserverSecurityFileDirectoryPolicyTask;
use NACL::C::_Mixins::VserverSecurityFileDirectoryPolicyTask qw(_handle_ntfs_sd);

=head1 METHODS

=head2 new

  my $VserverSecurityFileDirectoryPolicyTask = NACL::C::VserverSecurityFileDirectoryPolicyTask->new(
                                   command_interface => $ci,
                                   'index' => $index,
                                   'vserver' => $vserver,
                                   'path' => $path,
                                   'policy-name' => $policy_name,
                                  );

Return a new VserverSecurityFileDirectoryPolicyTask component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'index',
    scalar => 'vserver',
    scalar => 'path',
    scalar => 'policy_name',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 find

    my $VserverSecurityFileDirectoryPolicyTask_obj  = NACL::C::VserverSecurityFileDirectoryPolicyTask->find(command_interface => $ci, ...);
    my @VserverSecurityFileDirectoryPolicyTask_objs = NACL::C::VserverSecurityFileDirectoryPolicyTask->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverSecurityFileDirectoryPolicyTask_state = $VserverSecurityFileDirectoryPolicyTask_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverSecurityFileDirectoryPolicyTask would return
a NACL::CS::VserverSecurityFileDirectoryPolicyTask object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 add

    my $PolicyTask_obj = NACL::C::VserverSecurityFileDirectoryPolicyTask->add(
                                command_interface => $ci,
                                'index' => $index,
                                'vserver' => $vserver,
                                'path' => $path,
                                'policy-name' => $policy_name,
                                ...);

                                 or

    $VserverSecurityFileDirectoryPolicyTask_obj->add(...);

(Class or instance method)
This method is used to add a policy task.
This method returns the object for the added policy task.

Uses a CMode CLI/ZAPI APISet.
  Invokes 'file-directory-security-policy-task-add' API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'index' => $index >>

(Required for class method, Not Applicable for instance method)
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : task-index-number

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
  Applicable for CMode CLI/ZAPI.
  Maps to:
    CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
             option.

=item C<< 'path' => $path >>

(Required for class method, Not Applicable for instance method)
Path
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : path

=item C<< 'policy-name' => $policy_name >>

(Required for class method, Not Applicable for instance method)
Policy Name
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : policy-name

=item C<< 'index-num' => $string >>

Position
  Applicable only for CMode CLI

=item C<< 'ntfs-mode' => $string >>

Propagation Mode
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : ntfs-mode

=item C<< 'ntfs-sd' => $string >>

NTFS Security Descriptor Name
  Applicable for CMode CLI/ZAPI
  should be an ARRAYREF for FS onwards
  Maps to :
    CM ZAPI : ntfs-sd

=item C<< 'security-type' => $string >>

Security Type of the File
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : security-type

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< extended_query => $string >>

(Optional)
  Applicable only for CMode CLI

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::VserverSecurityFileDirectoryPolicyTask::AlreadyExists>

This type of exception gets thrown if an attempt is made to add a
Policy that already exists.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<< 'access-control' => $string >>

Access Control Level possible value(s) are, file-directory,slag
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver security file-directory policy task add" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=back

=back

=cut

sub add {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my $obj;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'ntfs-sd' => {type => ARRAYREF | SCALAR, optional => 1},
            _optional_scalars(
                qw( index-num ntfs-mode security-type

                    access-control
                    )
            ),
        },
        cli_cmd  => 'vserver security file-directory policy task add',
    );
    $pkg_or_obj->_handle_ntfs_sd(options => \%opts);
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $obj = $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_add_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_add_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend =>
                'NACL::C::VserverSecurityFileDirectoryPolicyTask::add',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverSecurityFileDirectoryPolicyTask::AlreadyExists
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub add

sub _add_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(%opts,
        api => 'vserver_security_file_directory_policy_task_add',);
    $Log->exit() if $may_exit;
    return $pkg_or_obj->new(
        'command_interface' => $opts{command_interface},
        'vserver'           => ${$opts{vserver_operated_on}}, 
        'index'             => $opts{'index'},
        'policy-name'       => $opts{'policy-name'},
        'path'              => $opts{'path'},
    );
} ## end sub _add_cmode_cli

sub _add_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    $pkg->_base_backend_cmode_zapi(
        %opts,
        copy => [qw(ntfs-mode path policy-name ntfs-sd security-type)],
        map    => {'index' => 'task-index-number'},
        api  => 'file-directory-security-policy-task-add',
    );
    $Log->exit() if $may_exit;
    return $pkg->new(
        'command_interface' => $opts{command_interface},
        'vserver'           => ${$opts{vserver_operated_on}},
        'policy-name'       => $opts{'policy-name'},
        'path'              => $opts{'path'},
    );

} ## end sub _add_cmode_zapi

=head2 reorder

    NACL::C::VserverSecurityFileDirectoryPolicyTask->reorder(
                                command_interface => $ci,
                                'index' => $index,
                                'vserver' => $vserver,
                                'path' => $path,
                                'policy-name' => $policy_name,
                                ...);

                                 or

    $VserverSecurityFileDirectoryPolicyTask_obj->reorder(...);

(Class or instance method)
This method is used to reorder a policy task..

Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'index' => $index >>

(Required for class method, Not Applicable for instance method)
  Applicable only for CMode CLI

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
  Applicable only for CMode CLI

=item C<< 'path' => $path >>

(Required for class method, Not Applicable for instance method)
Path
  Applicable only for CMode CLI

=item C<< 'policy-name' => $policy_name >>

(Required for class method, Not Applicable for instance method)
Policy Name
  Applicable only for CMode CLI

=item C<< 'index-num' => $string >>

Target Position
  Applicable only for CMode CLI

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< extended_query => $string >>

(Optional)
  Applicable only for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver security file-directory policy task reorder" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub reorder {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( index-num
                    )
            ),
        },
        api => 'vserver_security_file_directory_policy_task_reorder',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_reorder_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverSecurityFileDirectoryPolicyTask::reorder',
    );

    $Log->exit() if $may_exit;
} ## end sub reorder

sub _reorder_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $vserver = $opts{vserver};

    $pkg_or_obj->_base_backend_cmode_cli(
        %opts,
        api => 'vserver_security_file_directory_policy_task_reorder',
        vserver_operated_on => \$vserver,
    );

    $Log->exit() if $may_exit;
} ## end _reorder_cmode_cli

=head2 remove

    NACL::C::VserverSecurityFileDirectoryPolicyTask->remove(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'path' => $path,
                                'policy-name' => $policy_name,
                                ...);

(Class method)
This method is used to remove a policy task.

Uses a CMode CLI/ZAPI APISet.
  Invokes 'file-directory-security-policy-task-remove' API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

Applicable for CMode CLI

=item C<< 'vserver' => $vserver >>

(Required)
  Applicable for CMode CLI/ZAPI.
  Maps to:
    CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
             option.

=item C<< 'path' => $path >>

(Required)
Path
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : path

=item C<< 'policy-name' => $policy_name >>

(Required)
Policy Name
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : policy-name

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< extended_query => $string >>

(Optional)
  Applicable only for CMode CLI

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::VserverSecurityFileDirectoryPolicyTask::DoesNotExist>

This type of exception gets thrown if an attempt is made to remove a
Policy which does not exists.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<< '*' >>

This method takes all other options supported by
"vserver security file-directory policy task remove" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=back

=back

=cut

sub remove {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( vserver path policy-name index
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'vserver security file-directory policy task remove',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver; 
    try {
        $pkg->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_remove_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_remove_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend =>
                'NACL::C::VserverSecurityFileDirectoryPolicyTask::remove',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverSecurityFileDirectoryPolicyTask::DoesNotExist
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };
    $Log->exit() if $may_exit;
} ## end sub remove

sub _remove_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_security_file_directory_policy_task_remove',);
    $Log->exit() if $may_exit;
} ## end sub _remove_cmode_cli

sub _remove_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_zapi(
        @opts,
        copy => [qw(path policy-name)],
        api  => 'file_directory_security_policy_task_remove',
    ); 
    $Log->exit() if $may_exit;
} ## end sub _remove_cmode_zapi

=head2 modify

    NACL::C::VserverSecurityFileDirectoryPolicyTask->modify(
                                command_interface => $ci,
                                'index' => $index,
                                'vserver' => $vserver,
                                'path' => $path,
                                'policy-name' => $policy_name,
                                ...);

                                 or

    $VserverSecurityFileDirectoryPolicyTask_obj->modify(...);

(Class or instance method)
This method is used to modify a policy task.

Uses a CMode CLI/ZAPI APISet.
  Invokes 'file-directory-security-policy-task-modify' API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'index' => $index >>

(Required for class method, Not Applicable for instance method)
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : task-index-number

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
  Applicable for CMode CLI/ZAPI.
  Maps to:
    CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
             option.

=item C<< 'path' => $path >>

(Required for class method, Not Applicable for instance method)
Path
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : path

=item C<< 'policy-name' => $policy_name >>

(Required for class method, Not Applicable for instance method)
Policy Name
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : policy-name

=item C<< 'index-num' => $string >>

Position
  Applicable only for CMode CLI

=item C<< 'ntfs-mode' => $string >>

NTFS Propagation Mode
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : ntfs-mode

=item C<< 'ntfs-sd' => $string >>

NTFS Security Descriptor Name
  Applicable for CMode CLI/ZAPI
  should be an ARRAYREF for FS onwards
  Maps to :
    CM ZAPI : ntfs-sd

=item C<< 'security-type' => $string >>

Security Type
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : security-type

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< extended_query => $string >>

(Optional)
  Applicable only for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver security file-directory policy task modify" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'ntfs-sd' => {type => ARRAYREF | SCALAR, optional => 1},
            _optional_scalars(
                qw( index-num ntfs-mode security-type
                    )
            ),
        },
        cli_cmd => 'vserver security file-directory policy task modify',
    );
    if (!ref $opts{'ntfs-sd'}) {
        $pkg_or_obj->_handle_ntfs_sd(options => \%opts);
    }
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverSecurityFileDirectoryPolicyTask::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_security_file_directory_policy_task_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy
        = [qw( ntfs-mode path policy-name ntfs-sd security-type )];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        copy => $copy,
        map    => {'index' => 'task-index-number'},
        api  => 'file_directory_security_policy_task_modify',
    );
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_zapi


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'index'       => {type => SCALAR, optional => 1},
        'vserver'     => {type => SCALAR},
        'path'        => {type => SCALAR},
        'policy-name' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec
1;
