# Copyright (c) 2001-2017 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesNameServiceDns Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverServicesNameServiceDns

=head1 DESCRIPTION

C<NACL::C::VserverServicesNameServiceDns> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverServicesNameServiceDns.  A related class is
L<NACL::CS::VserverServicesNameServiceDns|lib-NACL-CS-VserverServicesNameServiceDns-pm>, which represents
the past state of an ONTAP VserverServicesNameServiceDns.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=cut

package NACL::C::VserverServicesNameServiceDns;

use strict;
use warnings;

use NACL::CS::VserverServicesNameServiceDns;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use NATE::BaseException qw(:try);
use NATE::Exceptions::Argument qw(:try);

use NACL::C::Exceptions::VserverServicesDns::DnsServerException ();

=head1 METHODS

=head2 new

  my $VserverServicesNameServiceDns = NACL::C::VserverServicesNameServiceDns->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                  );

Return a new VserverServicesNameServiceDns component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'vserver',];

my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $VserverServicesNameServiceDns_obj  = NACL::C::VserverServicesNameServiceDns->find(command_interface => $ci, ...);
    my @VserverServicesNameServiceDns_objs = NACL::C::VserverServicesNameServiceDns->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverServicesNameServiceDns_state = $VserverServicesNameServiceDns_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverServicesNameServiceDns would return
a NACL::CS::VserverServicesNameServiceDns object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 create

    my $VserverServicesNameServiceDns_obj    = NACL::C::VserverServicesNameServiceDns->create(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                ...);

(Class method)
This method is used to create a new DNS table entry.
Uses CMode CLI/ZAPI .
Invokes  net-dns-create for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required)
Vserver

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : vserver-name

=item C<< 'timeout' => $string >>

Timeout (secs) ranges from 1 to 5

Applicable for CMode CLI/ZAPI

=item C<< 'attempts' => $string >>

Maximum Attempts ranges from 1 to 4

Applicable for CMode CLI/ZAPI

=item C<< 'state' => $string >>

Enable/Disable DNS possible value(s) are, enabled,disabled

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : dns-state

=item C<< 'domains' => [ $domain1, $domain2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)


Applicable for CMode CLI/ZAPI

=item C<< 'name-servers' => [ $name-server1, $name-server2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)


Applicable for CMode CLI/ZAPI

=item C<< 'user-modified' => $string >>

User Modified This Row possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'skip-config-validation' => $string >>

Skip Configuration Validation,possible value(s) are true,false
Applicable for CMode CLI/ZAPI.

=item C<< '*' >>

This method takes all other options supported by "vserver services name service dns create" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'domains'      => {type => ARRAYREF, optional => 1},
            'name-servers' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( timeout attempts state

                    user-modified skip-config-validation
                    )
            ),
        },
        api => 'vserver_services_name_service_dns_create',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $pkg->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_create_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_create_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::VserverServicesNameServiceDns::create',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
	foreach my $type ( qw( DnsServerException) ) {
            my $fulltype = "NACL::C::Exceptions::VserverServicesDns::$type";
            $fulltype->detect_convert_and_throw(exception => $exception);
	}
        $Log->exit() if $may_exit;
        $exception->throw();
    };

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        vserver           => $vserver,
    );
    $Log->exit() if $may_exit;
    return $obj;
}

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_dns_create',);
    $Log->exit() if $may_exit;
}

sub _create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(timeout name-servers attempts domains skip-config-validation)];
    my $map = {'state' => 'dns-state',};
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'net-dns-create',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 delete

    NACL::C::VserverServicesNameServiceDns->delete(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                ...);

                                 or

    $VserverServicesNameServiceDns_obj->delete(...);

(Class or instance method)
This method is used to remove a DNS table entry.
Uses CMode CLI/ZAPI .
Invokes  net-dns-destroy for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service dns delete" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        api    => 'vserver_services_name_service_dns_delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_delete_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverServicesNameServiceDns::delete',
    );

    $Log->exit() if $may_exit;
}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_dns_delete',);
    $Log->exit() if $may_exit;
}

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_zapi(@opts, api => 'net-dns-destroy',);
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VserverServicesNameServiceDns->modify(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                ...);

                                 or

    $VserverServicesNameServiceDns_obj->modify(...);

(Class or instance method)
This method is used to change a DNS table entry.
Uses CMode CLI/ZAPI .
Invokes  net-dns-modify for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : vserver-name

=item C<< 'timeout' => $string >>

Timeout (secs) ranges from 1 to 5

Applicable for CMode CLI/ZAPI

=item C<< 'attempts' => $string >>

Maximum Attempts ranges from 1 to 4

Applicable for CMode CLI/ZAPI

=item C<< 'state' => $string >>

Enable/Disable DNS possible value(s) are, enabled,disabled

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : dns-state

=item C<< 'domains' => [ $domain1, $domain2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)


Applicable for CMode CLI/ZAPI

=item C<< 'name-servers' => [ $name-server1, $name-server2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)


Applicable for CMode CLI/ZAPI

=item C<< 'user-modified' => $string >>

User Modified This Row possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'skip-config-validation' => $string >>

Skip Configuration Validation,possible value(s) are true,false
Applicable for CMode CLI/ZAPI.

=item C<< '*' >>

This method takes all other options supported by "vserver services name service dns modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'domains'      => {type => ARRAYREF, optional => 1},
            'name-servers' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( timeout attempts state

                    user-modified skip-config-validation
                    )
            ),
        },
        api => 'vserver_services_name_service_dns_modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverServicesNameServiceDns::modify',
    );

    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_dns_modify',);
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(timeout name-servers attempts domains skip-config-validation)];
    my $map = {'state' => 'dns-state',};
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'net-dns-modify',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 show_statistics

    my $show_statistics_obj = NACL::C::VserverServicesNameServiceDns->show_statistics(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

    my @show_statistics_objs = NACL::C::VserverServicesNameServiceDns->show_statistics(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

   my $show_statistics_obj = $VserverServicesNameServiceDns_obj->show_statistics();

(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty)
and has all of the other properties of fetch methods (callable in scalar or list
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverServicesNameServiceDnsShowStatistics-pm/ATTRIBUTES>
of NACL::CS::VserverServicesNameServiceDnsShowStatistics as input.
This method returns objects of the type L<NACL::CS::VserverServicesNameServiceDnsShowStatistics|lib-NACL-CS-VserverServicesNameServiceDnsShowStatistics-pm>.

=cut

sub show_statistics {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::VserverServicesNameServiceDnsShowStatistics;
    my @state_objs
        = NACL::CS::VserverServicesNameServiceDnsShowStatistics->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 clear_statistics

    NACL::C::VserverServicesNameServiceDns->clear_statistics(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                ...);

                                 or

    $VserverServicesNameServiceDns_obj->clear_statistics(...);

(Class or instance method)
This method is used to clear DNS statistics information.
Uses CMode CLI/ZAPI .
Invokes  nameservice-dns-statistics-clear for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI/ZAPI

=item C<< 'node' => $string >>

Node possible value(s) are, <nodename>,local

Applicable for CMode CLI/ZAPI

=item C<< 'name-server' => $string >>

Name Server

Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service dns clear statistics" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub clear_statistics {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( node name-server
                    )
            ),
        },
        api => 'vserver_services_name_service_dns_clear_statistics',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_clear_statistics_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_clear_statistics_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverServicesNameServiceDns::clear_statistics',
    );

    $Log->exit() if $may_exit;
}

sub _clear_statistics_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_dns_clear_statistics',);
    $Log->exit() if $may_exit;
}

sub _clear_statistics_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(name-server node vserver)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'nameservice-dns-statistics-clear',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('vserver' => {type => SCALAR},);
}

1;
