#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesNameServiceGetxxbyyy Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverServicesNameServiceGetxxbyyy

=head1 DESCRIPTION

C<NACL::C::VserverServicesNameServiceGetxxbyyy> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. 
Unlike other components this package does not model any element/service 
but is present to provide component-level support for functionality. 
Since it does not model any element/service there is no ComponentState 
module for this component. For the same reason, 'find' and 'state' will
not work for this component.
Instead NACL::CS::VserverServicesNameServiceGetxxbyyy->fetch() should be used.
(See L<fetch|lib-NACL-CS-ComponentState-pm/fetch> for a full description)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::VserverServicesNameServiceGetxxbyyy;

use strict;
use warnings;

use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::ComponentUtils qw(Dumper);
use Net::IP qw(ip_is_ipv4 ip_is_ipv6);
=head1 METHODS

=head2 new

  my $VserverServicesNameServiceGetxxbyyy = NACL::C::VserverServicesNameServiceGetxxbyyy->new(
                                   command_interface => $ci,
								  );

Return a new VserverServicesNameServiceGetxxbyyy component object with the given attributes.

=cut

use Class::MethodMaker [];

=head2 getaddrinfo

    my $getaddrinfo_obj = NACL::C::VserverServicesNameServiceGetxxbyyy->getaddrinfo(
                                command_interface => $ci,
                                ...);

    Returns an object of type
    L<NACL::CS::VserverServicesNameServiceGetxxbyyyGetaddrinfo|lib-NACL-CS-VserverServicesNameServiceGetxxbyyyGetaddrinfo-pm>.

(Class method)
This method is used to gets the IP address information by using the host name..
Uses CMode CLI/ZAPI .

Invokes API 'nameservice-get-ip-from-hostname' for Cmode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $string >>

Vserver Name
Applicable for CMode CLI/ZAPI

=item C<< 'hostname' => $string >>

Host Name
Applicable for CMode CLI/ZAPI

=item C<< 'node' => $string >>

Node Name possible value(s) are, <nodename>,local
Applicable for CMode CLI/ZAPI

=item C<< 'show-source' => $string >>

Show Source used for Lookup possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'address-family' => $string >>

Return Addresses for Family possible value(s) are, ipv4,ipv6,all
Applicable for CMode CLI

=item C<< 'ipaddress' => [ $ipaddres1, $ipaddres2, ... ] >>

IP Address
(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI

=item C<< 'cmdpid' => $string >>

Command Pid
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service getxxbyyy getaddrinfo" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub getaddrinfo {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            "ipaddress" => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( vserver hostname node

                    show-source address-family

                    cmdpid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'vserver services name-service getxxbyyy getaddrinfo',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_getaddrinfo_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_getaddrinfo_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverServicesNameServiceGetxxbyyy::getaddrinfo',
    );
    $Log->exit() if $may_exit;
    return $ret;
}

sub _getaddrinfo_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $response;
    my %opts = $pkg->_validate_backend_opts(@opts);
    $pkg->_base_backend_cmode_cli(
        @opts,
        api => 'vserver_services_name_service_getxxbyyy_getaddrinfo',
        apiset_response_obj => \$response
    );
    require NACL::CS::VserverServicesNameServiceGetxxbyyyGetaddrinfo;
    my $obj = NACL::CS::VserverServicesNameServiceGetxxbyyyGetaddrinfo->new(
        command_interface => $opts{command_interface});
    my $row = $response->get_parsed_output()->[0];
    $row->{ipv4_address} = delete $row->{ipv4};
    $row->{ipv6_address} = delete $row->{ipv6};
    $obj->_set_fields(row => $row);
    $Log->exit() if $may_exit;
    return $obj;
}

sub _getaddrinfo_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $response;
    $pkg_or_obj->_base_backend_cmode_zapi(
        %opts,
        api                 => 'nameservice-get-ip-from-hostname',
        copy                => [qw( hostname node vserver )],
        apiset_response_obj => \$response,
        frontend_method     => 'getaddrinfo',
    );
    require NACL::CS::VserverServicesNameServiceGetxxbyyyGetaddrinfo;
    my $obj = NACL::CS::VserverServicesNameServiceGetxxbyyyGetaddrinfo->new(
        command_interface => $opts{command_interface});
    my $ip_addrs_struct
        = $response->get_parsed_output()->[0]{'ipaddress'}->[0]->{'ip-address'};
    my @ip_address;
    if (ref $ip_addrs_struct eq 'ARRAY') {
        @ip_address = @{$ip_addrs_struct};
    } else {
        @ip_address = $ip_addrs_struct;
    }
    my (@ipv4, @ipv6);
    foreach my $ip (@ip_address) {
        if (Net::IP::ip_is_ipv4($ip)) {
            push (@ipv4,$ip);
        } else {
            push (@ipv6,$ip);
        }
    }
    $obj->ipv4_address(@ipv4);
    $obj->ipv6_address(@ipv6);
    $Log->exit;
    return $obj;
}

=head2 getgrbygid

    my $getgrbygid_obj = NACL::C::VserverServicesNameServiceGetxxbyyy->getgrbygid(
                                command_interface => $ci,
                                ...);
   Returns an object of type
   L<NACL::CS::VserverServicesNameServiceGetxxbyyyGetgrbyid|lib-NACL-CS-VserverServicesNameServiceGetxxbyyyGetgrbyid-pm>.

(Class method)
This method is used to gets the group members by using the group identifier or GID..
Uses CMode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'groupID' => $string >>

Group ID
Applicable for CMode CLI

=item C<< 'vserver' => $string >>

Vserver Name
Applicable for CMode CLI

=item C<< 'node' => $string >>

Node Name possible value(s) are, <nodename>,local
Applicable for CMode CLI

=item C<< 'show-source' => $string >>

Show Source used for Lookup possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'cmdpid' => $string >>

Command Pid
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service getxxbyyy getgrbygid" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub getgrbygid {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( groupID vserver node

                    show-source

                    cmdpid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'vserver services name-service getxxbyyy getgrbygid',
    );
    my @ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_getgrbygid_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverServicesNameServiceGetxxbyyy::getgrbygid',
    );

    $Log->exit() if $may_exit;
    return wantarray ? @ret : $ret[0];
}

sub _getgrbygid_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my ($response ,$obj, @state_objs);
    $pkg->_base_backend_cmode_cli(%opts,
        api => 'vserver_services_name_service_getxxbyyy_getgrbygid',
        apiset_response_obj => \$response,
    );

    require NACL::CS::VserverServicesNameServiceGetxxbyyyGetgrbyid;
    foreach my $row (@{$response->get_parsed_output()}) {
        $obj = NACL::CS::VserverServicesNameServiceGetxxbyyyGetgrbyid->new(
             command_interface => $opts{command_interface}
        );
        $row->{group_name} = delete $row->{name};
        $row->{group_id} = delete $row->{gid};
        $row->{group_member} = delete $row->{gr_mem};
        $obj->_set_fields(row => $row);
        push @state_objs,$obj;
    }
    $Log->exit() if $may_exit;
    return @state_objs;
}

=head2 getgrbyname

    my $getgrbyname_obj = NACL::C::VserverServicesNameServiceGetxxbyyy->getgrbyname(
                                command_interface => $ci,
                                ...);
    Returns an object of type
    L<NACL::CS::VserverServicesNameServiceGetxxbyyyGetgrbyname|lib-NACL-CS-VserverServicesNameServiceGetxxbyyyGetgrbyname-pm>.

(Class method)
This method is used to gets the group members by using the group name..
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'groupname' => $string >>

Group Name
Applicable for CMode CLI

=item C<< 'vserver' => $string >>

Vserver Name
Applicable for CMode CLI

=item C<< 'node' => $string >>

Node Name possible value(s) are, <nodename>,local
Applicable for CMode CLI

=item C<< 'show-source' => $string >>

Show Source used for Lookup possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'cmdpid' => $string >>

Command Pid
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service getxxbyyy getgrbyname" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub getgrbyname {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( groupname vserver node

                    show-source

                    cmdpid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'vserver services name-service getxxbyyy getgrbyname',
    );
    my @ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_getgrbyname_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverServicesNameServiceGetxxbyyy::getgrbyname',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @ret : $ret[0];
}

sub _getgrbyname_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;

    my ($response ,$obj, @state_objs);
    $pkg->_base_backend_cmode_cli(%opts,
        api => 'vserver_services_name_service_getxxbyyy_getgrbyname',
        apiset_response_obj => \$response,
    );

    require NACL::CS::VserverServicesNameServiceGetxxbyyyGetgrbyname;
    foreach my $row (@{$response->get_parsed_output()}) {
        $obj = NACL::CS::VserverServicesNameServiceGetxxbyyyGetgrbyname->new(
             command_interface => $opts{command_interface}
        );
        $row->{group_name} = delete $row->{name};
        $row->{group_id} = delete $row->{gid};
        $row->{group_member} = delete $row->{gr_mem};
        $obj->_set_fields(row => $row);
        push @state_objs,$obj;
    }
    $Log->exit() if $may_exit;
    return @state_objs;
}

=head2 getgrlist

    NACL::C::VserverServicesNameServiceGetxxbyyy->getgrlist(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to gets the group list by using the user name..
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $string >>

Vserver Name
Applicable for CMode CLI

=item C<< 'node' => $string >>

Node Name possible value(s) are, <nodename>,local
Applicable for CMode CLI

=item C<< 'username' => $string >>

User Name
Applicable for CMode CLI

=item C<< 'show-source' => $string >>

Show Source used for Lookup possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'cmdpid' => $string >>

Command Pid
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service getxxbyyy getgrlist" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub getgrlist {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( vserver node username

                    show-source

                    cmdpid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'vserver services name-service getxxbyyy getgrlist',
    );
    my @ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_getgrlist_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverServicesNameServiceGetxxbyyy::getgrlist',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @ret : $ret[0];
}

sub _getgrlist_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my ($response ,$obj, @state_objs);
    $pkg->_base_backend_cmode_cli(%opts,
        api => 'vserver_services_name_service_getxxbyyy_getgrlist',
        apiset_response_obj => \$response);
    require NACL::CS::VserverServicesNameServiceGetxxbyyyGetgrlist;

    foreach my $row (@{$response->get_parsed_output()}) {
        $obj = NACL::CS::VserverServicesNameServiceGetxxbyyyGetgrlist->new(
                         command_interface => $opts{command_interface});
        $obj->_set_fields(row => $row);
        push @state_objs,$obj;
    }
    $Log->exit() if $may_exit;
    return @state_objs;
}

=head2 gethostbyaddr

    my $gethostbyaddr_obj = NACL::C::VserverServicesNameServiceGetxxbyyy->gethostbyaddr(
                                command_interface => $ci,
                                ...);

    Returns an object of type
    L<NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyaddr|lib-NACL-CS-VserverServicesNameServiceGetxxbyyyGethostbyaddr-pm>.

(Class method)
This method is used to gets the host information from the IP address..
Uses CMode CLI/ZAPI .

Invokes API 'nameservice-get-hostname-from-ipv4' for Cmode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $string >>

Vserver Name
Applicable for CMode CLI/ZAPI

=item C<< 'node' => $string >>

Node Name possible value(s) are, <nodename>,local
Applicable for CMode CLI/ZAPI

=item C<< 'ipaddress' => $string >>

IP Address
Applicable for CMode CLI/ZAPI
Maps to:
    CM ZAPI : ip-address

=item C<< 'show-source' => $string >>

Show Source used for Lookup possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'cmdpid' => $string >>

Command Pid
Applicable for CMode CLI

=item C<< 'cname' => $string >>

Canonical Host Name
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service getxxbyyy gethostbyaddr" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub gethostbyaddr {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( vserver node ipaddress

                    show-source

                    cmdpid cname
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'vserver services name-service getxxbyyy gethostbyaddr',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_gethostbyaddr_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_gethostbyaddr_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverServicesNameServiceGetxxbyyy::gethostbyaddr',
    );
    $Log->exit;
    return $ret;
}

sub _gethostbyaddr_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $response;
    my %opts = $pkg->_validate_backend_opts(@opts);
    $pkg->_base_backend_cmode_cli(
        @opts,
        api => 'vserver_services_name_service_getxxbyyy_gethostbyaddr',
        apiset_response_obj => \$response
    );
    require NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyaddr;
    my $obj = NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyaddr->new(
        command_interface => $opts{command_interface});
    my $row = $response->get_parsed_output()->[0];
    $obj->_set_fields(row => $row);
    $Log->exit() if $may_exit;
    return $obj;
}

sub _gethostbyaddr_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $response;
    $pkg_or_obj->_base_backend_cmode_zapi(
        %opts,
        api                 => 'nameservice-get-hostname-from-ipv4',
        copy                => [qw( node vserver )],
        map                 => {'ipaddress' => 'ip-address'},
        apiset_response_obj => \$response,
        frontend_method     => 'gethostbyaddr',
    );
    require NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyaddr;
    my $obj = NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyaddr->new(
        command_interface => $opts{command_interface});
    my @host_names_struct = $response->get_parsed_output()->[0];
    my @host_names = map { $_->{'canonical-name'} } @host_names_struct;
    $obj->host_name(@host_names);
    $Log->exit;
    return $obj;
}

=head2 gethostbyname

    my $gethostbyname_obj = NACL::C::VserverServicesNameServiceGetxxbyyy->gethostbyname(
                                command_interface => $ci,
                                ...);

    Returns an object of type
    L<NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyname|lib-NACL-CS-VserverServicesNameServiceGetxxbyyyGethostbyname-pm>.

(Class method)
This method is used to gets the IP address information from host name..
Uses CMode CLI/ZAPI .

Invokes API 'nameservice-get-ipv4-from-hostname' for Cmode ZAPI.
=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $string >>

Vserver Name
Applicable for CMode CLI/ZAPI

=item C<< 'hostname' => $string >>

Host Name
Applicable for CMode CLI/ZAPI

=item C<< 'node' => $string >>

Node Name possible value(s) are, <nodename>,local
Applicable for CMode CLI/ZAPI

=item C<< 'show-source' => $string >>

Show Source used for Lookup possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'ipaddress' => [ $ipaddres1, $ipaddres2, ... ] >>

IP Address
(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI

=item C<< 'cmdpid' => $string >>

Command Pid
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service getxxbyyy gethostbyname" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub gethostbyname {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            "ipaddress" => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( vserver hostname node

                    show-source

                    cmdpid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'vserver services name-service getxxbyyy gethostbyname',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_gethostbyname_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_gethostbyname_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverServicesNameServiceGetxxbyyy::gethostbyname',
    );
    $Log->exit;
    return $ret;
}

sub _gethostbyname_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $response;
    my %opts = $pkg->_validate_backend_opts(@opts);
    $pkg->_base_backend_cmode_cli(
        @opts,
        api => 'vserver_services_name_service_getxxbyyy_gethostbyname',
        apiset_response_obj => \$response
    );
    require NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyname;
    my $obj = NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyname->new(
        command_interface => $opts{command_interface});
    my $row = $response->get_parsed_output()->[0];
    $row->{ip_address} = delete $row->{ipv4};
    $obj->_set_fields(row => $row);
    $Log->exit() if $may_exit;
    return $obj;
}

sub _gethostbyname_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $response;
    $pkg_or_obj->_base_backend_cmode_zapi(
        %opts,
        api                 => 'nameservice-get-ipv4-from-hostname',
        copy                => [qw( hostname node vserver )],
        apiset_response_obj => \$response,
        frontend_method     => 'gethostbyname',
    );
    require NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyname;
    my $obj = NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyname->new(
        command_interface => $opts{command_interface});
    my @ip_addrs_struct
        = $response->get_parsed_output()->[0]{'ipaddress'}->[0];
    my @ip_addrs = map { $_->{'ip-address'} } @ip_addrs_struct;
    $obj->ip_address(@ip_addrs);
    $Log->exit;
    return $obj;
}

=head2 getnameinfo

    NACL::C::VserverServicesNameServiceGetxxbyyy->getnameinfo(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to gets the name information by using the IP address..
Uses CMode CLI .

This method returns objects of the type
L<NACL::CS::VserverServicesNameServiceGetxxbyyyGetnameinfo|lib-NACL-CS-VserverServicesNameServiceGetxxbyyyGetnameinfo-pm>.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $string >>

Vserver Name
Applicable for CMode CLI

=item C<< 'node' => $string >>

Node Name possible value(s) are, <nodename>,local
Applicable for CMode CLI

=item C<< 'ipaddress' => $string >>

IP Address
Applicable for CMode CLI

=item C<< 'show-source' => $string >>

Show Source used for Lookup possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'cmdpid' => $string >>

Command Pid
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service getxxbyyy getnameinfo" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub getnameinfo {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( vserver node ipaddress

                    show-source

                    cmdpid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'vserver services name-service getxxbyyy getnameinfo',
    );
    my @ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_getnameinfo_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverServicesNameServiceGetxxbyyy::getnameinfo',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @ret : $ret[0];
}

sub _getnameinfo_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
	my ($response, @state_objs, $obj);
    $pkg->_base_backend_cmode_cli(%opts,
        api => 'vserver_services_name_service_getxxbyyy_getnameinfo',
		apiset_response_obj => \$response
    );
    require NACL::CS::VserverServicesNameServiceGetxxbyyyGetnameinfo;
    foreach my $row (@{$response->get_parsed_output()}) {
        $obj = NACL::CS::VserverServicesNameServiceGetxxbyyyGetnameinfo->new(
             command_interface => $opts{command_interface}
        );
        $obj->_set_fields(row => $row);
        push @state_objs,$obj;
   }
   $Log->exit() if $may_exit;
   return @state_objs;
}

=head2 getpwbyname

    NACL::C::VserverServicesNameServiceGetxxbyyy->getpwbyname(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to get the password entry  by using the user name..
Uses CMode CLI .
This method returns objects of the type
L<NACL::CS::VserverServicesNameServiceGetxxbyyyGetpwbyname|lib-NACL-CS-VserverServicesNameServiceGetxxbyyyGetpwbyname-pm>.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'rbacpath' => $string >>

RBAC Path Indicator possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'vserver' => $string >>

Vserver Name
Applicable for CMode CLI

=item C<< 'node' => $string >>

Node Name possible value(s) are, <nodename>,local
Applicable for CMode CLI

=item C<< 'username' => $string >>

User Name
Applicable for CMode CLI

=item C<< 'show-source' => $string >>

Show Source used for Lookup possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'use-rbac' => $string >>

Use RBAC Resolution possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'cmdpid' => $string >>

Command Pid
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service getxxbyyy getpwbyname" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub getpwbyname {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( rbacpath vserver node username

                    show-source use-rbac

                    cmdpid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'vserver services name-service getxxbyyy getpwbyname',
    );
    my @ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_getpwbyname_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverServicesNameServiceGetxxbyyy::getpwbyname',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @ret : $ret[0];
}

sub _getpwbyname_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
	my ($response ,$obj, @state_objs);
   $pkg->_base_backend_cmode_cli(%opts,
        api => 'vserver_services_name_service_getxxbyyy_getpwbyname',
		apiset_response_obj => \$response);
    require NACL::CS::VserverServicesNameServiceGetxxbyyyGetpwbyname;
    foreach my $row (@{$response->get_parsed_output()}) {
        $obj = NACL::CS::VserverServicesNameServiceGetxxbyyyGetpwbyname->new(
             command_interface => $opts{command_interface}
        );
        $row->{username} = delete $row->{pw_name};
        $obj->_set_fields(row => $row);
        push @state_objs,$obj;
    }
    $Log->exit() if $may_exit;
    return @state_objs;
}

=head2 getpwbyuid

    NACL::C::VserverServicesNameServiceGetxxbyyy->getpwbyuid(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to gets the password entry by using the user identifier or UID..
Uses CMode CLI .
This method returns objects of the type
L<NACL::CS::VserverServicesNameServiceGetxxbyyyGetpwbyuid|lib-NACL-CS-VserverServicesNameServiceGetxxbyyyGetpwbyuid-pm>.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'rbacpath' => $string >>

RBAC Path Indicator possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'vserver' => $string >>

Vserver Name
Applicable for CMode CLI

=item C<< 'node' => $string >>

Node Name possible value(s) are, <nodename>,local
Applicable for CMode CLI

=item C<< 'userID' => $string >>

User ID
Applicable for CMode CLI

=item C<< 'show-source' => $string >>

Show Source used for Lookup possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'use-rbac' => $string >>

Use RBAC Resolution possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'cmdpid' => $string >>

Command Pid
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service getxxbyyy getpwbyuid" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub getpwbyuid {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( rbacpath vserver node userID

                    show-source use-rbac

                    cmdpid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'vserver services name-service getxxbyyy getpwbyuid',
    );
    my @ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_getpwbyuid_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverServicesNameServiceGetxxbyyy::getpwbyuid',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @ret : $ret[0];

}

sub _getpwbyuid_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my ($response ,$obj, @state_objs);
    $pkg->_base_backend_cmode_cli(%opts,
        api => 'vserver_services_name_service_getxxbyyy_getpwbyuid',
        apiset_response_obj => \$response );
    require NACL::CS::VserverServicesNameServiceGetxxbyyyGetpwbyuid;
    foreach my $row (@{$response->get_parsed_output()}) {
        $obj = NACL::CS::VserverServicesNameServiceGetxxbyyyGetpwbyuid->new(
             command_interface => $opts{command_interface}
        );
        $row->{userID} = delete $row->{pw_uid};
        $obj->_set_fields(row => $row);
        push @state_objs,$obj;
    }
    $Log->exit() if $may_exit;
    return @state_objs;
}

=head2 netgrp

    my $bool = NACL::C::VserverServicesNameServiceGetxxbyyy->netgrp(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to checks if a client is part of a netgroup..
Uses CMode CLI .
This method returns 0 or 1 indication whether a client belongs to a netgrp or
not.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'client' => $string >>

Client Name
Applicable for CMode CLI

=item C<< 'netgroup' => $string >>

Netgroup Name
Applicable for CMode CLI

=item C<< 'vserver' => $string >>

Vserver Name
Applicable for CMode CLI

=item C<< 'node' => $string >>

Node Name possible value(s) are, <nodename>,local
Applicable for CMode CLI

=item C<< 'show-source' => $string >>

Show Source used for Lookup possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'cmdpid' => $string >>

Command Pid
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service getxxbyyy netgrp" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub netgrp {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( client netgroup vserver node

                    show-source

                    cmdpid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'vserver services name-service getxxbyyy netgrp',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_netgrp_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverServicesNameServiceGetxxbyyy::netgrp',
    );
    $Log->exit() if $may_exit;
    return $ret;
}

sub _netgrp_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $response;
    $pkg->_base_backend_cmode_cli(%opts,
        api => 'vserver_services_name_service_getxxbyyy_netgrp',
        apiset_response_obj => \$response );
    my $output   = $response->get_raw_output();
    $Log->exit;
    return ($output =~ /^\S+\s*is\s*a\s*member\s*of\s*\S+/i) ? 1 : 0;
}

__PACKAGE__->_load_event_class();

1;
