# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesNdmp Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverServicesNdmp

=head1 DESCRIPTION

C<NACL::C::VserverServicesNdmp> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverServicesNdmp.  A related class is
L<NACL::CS::VserverServicesNdmp|lib-NACL-CS-VserverServicesNdmp-pm>, which represents
the past state of an ONTAP VserverServicesNdmp.
However, since it does not have any primary keys, 'find' and 'state' do not
work for this component. (This component is considered a 'singleton',
i.e. there is only one row shown by the relevant 'show' command)

=cut

=head1 ATTRIBUTES

=head2 vserver

=cut

package NACL::C::VserverServicesNdmp;

use strict;
use warnings;

use NACL::CS::VserverServicesNdmp;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR SCALARREF ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use NACL::Exceptions::InvalidChoice;

=head1 METHODS

=head2 new

  my $VserverServicesNdmp = NACL::C::VserverServicesNdmp->new(
                                   command_interface => $ci,
                                   vserver => $vserver,
								  );

Return a new VserverServicesNdmp component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'vserver',];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 find

    my $VserverServicesNdmp_obj  = NACL::C::VserverServicesNdmp->find(command_interface => $ci, ...);
	my @VserverServicesNdmp_objs = NACL::C::VserverServicesNdmp->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my VserverServicesNdmp_state = $VserverServicesNdmp_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverServicesNdmp would return 
a NACL::CS::VserverServicesNdmp object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 killall

    NACL::C::VserverServicesNdmp->killall(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to kill all NDMP sessions.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver services ndmp killall" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub killall {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( vserver
                    )
            )
        },
        api => 'vserver_services_ndmp_killall',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_killall_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverServicesNdmp::killall',
    );

    $Log->exit() if $may_exit;
} ## end sub killall

sub _killall_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $vserver = $opts{vserver};

    $pkg->_base_backend_cmode_cli(
        %opts,
        api                 => 'vserver_services_ndmp_killall',
        vserver_operated_on => \$vserver,
    );

    $Log->exit() if $may_exit;
} ## end sub _killall_cmode_cli

=head2 status

    my $status_obj = NACL::C::VserverServicesNdmp->status(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @status_objs = NACL::C::VserverServicesNdmp->status(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $status_obj = $VserverServicesNdmp_obj->status(); 

(Class or Instance method)
This method returns objects of the type L<NACL::CS::VserverServicesNdmpStatus|lib-NACL-CS-VserverServicesNdmpStatus-pm>.

This method accepts all the parameters accepted by L<fetch|lib-NACL-CS-ComponentState-pm/fetch> 
(requested_fields, filter, allow_empty) and has all of the other properties of 
fetch methods (callable in scalar or list context, throws a NoElementsFound 
exception if no matching elements are found)

=cut

sub status {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_handle_obj_cs_like_calls(@_);
    require NACL::CS::VserverServicesNdmpStatus;
    my @state_objs = NACL::CS::VserverServicesNdmpStatus->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub status

=head2 on

    NACL::C::VserverServicesNdmp->on(
                                command_interface => $ci,
                                    'vserver' => $vserver,
                                ...);

                                                                 or

    $VserverServicesNdmp_obj->on(...);

(Class or instance method)
This method is used to enable NDMP service.
Uses CMode CLI/ZAPI .
Invokes  ndmp-vserver-service-enable  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver services ndmp on" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub on {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver services ndmp on',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_on_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_on_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::VserverServicesNdmp::on',
    );

    $Log->exit() if $may_exit;
}

sub _on_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_ndmp_on',);
    $Log->exit() if $may_exit;
}

sub _on_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api => 'ndmp-vserver-service-enable',
    );
    $Log->exit() if $may_exit;
}

=head2 off

    NACL::C::VserverServicesNdmp->off(
                                command_interface => $ci,
                                    'vserver' => $vserver,
                                ...);

                                                                 or

    $VserverServicesNdmp_obj->off(...);

(Class or instance method)
This method is used to disable NDMP service.
Uses CMode CLI/ZAPI .
Invokes  ndmp-vserver-service-disable  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver services ndmp off" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub off {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver services ndmp off',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_off_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_off_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::VserverServicesNdmp::off',
    );

    $Log->exit() if $may_exit;
}

sub _off_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_ndmp_off',);
    $Log->exit() if $may_exit;
}

sub _off_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api => 'ndmp-vserver-service-disable',
    );
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VserverServicesNdmp->modify(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to modify  NDMP Properties.

Uses a CMode CLI/ZAPI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'data-port-range' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'per-qtree-exclude-enable' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'abort-on-disk-error' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'fh-dir-retry-interval' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'fh-node-retry-interval' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'debug-filter' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'authtype' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'tcpwinsize' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'dump-detailed-stats' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'restore-vm-cache-size' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'ignore-ctime-enabled' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'tcpnodelay' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'enable' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'maxversion' => $string >>

Applicable for CMode CLI.

=item C<< 'access' => $string >>

Applicable for CMode CLI.

=item C<< 'vserver' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'backup-log-enable' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'offset-map-enable' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'dump-logical-find' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'debug-enable' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'vserver' => $string >>

Applicable for CMode CLI/ZAPI.

=item C<< 'preferred-interface-role' => [ $preferred-interface-role1, $preferred-interface-role2, ... ] >>

Preferred interface role, possible value(s) are
cluster,data,node-mgmt,intercluster,cluster-mgmt
(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

=item C<< 'secondary-debug-filter' => $string >>

*Secondary debug filter

Applicable for CMode CLI/ZAPI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< 'is-secure-control-connection-enabled' => $string >>

Is Secure Control Connection Enabled possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver services ndmp modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            "preferred-interface-role" => {type => ARRAYREF, optional => 1},
            'authtype' => {type => SCALAR | ARRAYREF, optional => 1},
            _optional_scalars(
                qw( data-port-range per-qtree-exclude-enable abort-on-disk-error
                    fh-dir-retry-interval fh-node-retry-interval debug-filter
                    tcpwinsize dump-detailed-stats restore-vm-cache-size ignore-ctime-enabled
                    tcpnodelay enable maxversion access backup-log-enable
                    offset-map-enable dump-logical-find debug-enable
                    vserver
                    secondary-debug-filter

                    is-secure-control-connection-enabled
                    )
            ),
        },
        cli_cmd => 'vserver services ndmp modify',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
                check     => '_common_zapi_check',
            },
        ],
        frontend => 'NACL::C::VserverServicesNdmp::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $vserver = $opts{vserver};

    $pkg->_base_backend_cmode_cli(
        %opts,
        api                 => 'vserver_services_ndmp_modify',
        vserver_operated_on => \$vserver,
    );

    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $copy = [
        qw(per-qtree-exclude-enable data-port-range abort-on-disk-error
            fh-dir-retry-interval fh-node-retry-interval debug-filter
            tcpwinsize dump-detailed-stats ignore-ctime-enabled restore-vm-cache-size
            secondary-debug-filter enable tcpnodelay backup-log-enable
            offset-map-enable preferred-interface-role dump-logical-find
            is-secure-control-connection-enabled debug-enable authtype)
    ];
    my @auth_arr = split(/,/, $opts{authtype});

    if (!ref $opts{authtype}) {
        $opts{authtype} = \@auth_arr;
    }
    my @vservers = split(/,/, $opts{vserver});
    foreach my $vserver (@vservers) {
        $opts{vserver} = $vserver;
        $pkg_or_obj->_base_backend_cmode_zapi(
            %opts,
            api                 => 'ndmp-vserver-attributes-modify',
            vserver_operated_on => \$vserver,
            copy                => $copy,
        );
    }
    $Log->exit() if $may_exit;
}

sub _common_zapi_check {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;

    if ($opts{vserver} eq '*') {
        my $msg = 'If value for vserver is *, fall back to CLI';
        $Log->comment($msg);
        $Log->exit() if $may_exit;
        NACL::Exceptions::InvalidChoice->throw($msg);
    }
    $Log->exit() if $may_exit;
}

=head2 generate_password

    my $generate_password_obj = NACL::C::VserverServicesNdmp->generate_password(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @generate_password_objs = NACL::C::VserverServicesNdmp->generate_password(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $generate_password_obj = $VserverServicesNdmp_obj->generate_password(); 

(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverServicesNdmpGeneratePassword-pm/ATTRIBUTES>
of NACL::CS::VserverServicesNdmpGeneratePassword as input. 
This method returns objects of the type L<NACL::CS::VserverServicesNdmpGeneratePassword|lib-NACL-CS-VserverServicesNdmpGeneratePassword-pm>.

=cut

sub generate_password {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_handle_obj_cs_like_calls(@_);
    require NACL::CS::VserverServicesNdmpGeneratePassword;
    my @state_objs
        = NACL::CS::VserverServicesNdmpGeneratePassword->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 kill_all

    NACL::C::VserverServicesNdmp->kill_all(
                                command_interface => $ci,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $VserverServicesNdmp_obj->kill_all(...);

(Class or instance method)
This method is used to kill all NDMP sessions.

Uses a CMode CLI/ZAPI APIset.
Invokes ndmp-vserver-session-kill-all for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver services ndmp kill-all" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub kill_all {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver services ndmp kill-all',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_kill_all_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_kill_all_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::VserverServicesNdmp::kill_all',
    );

    $Log->exit() if $may_exit;
} ## end sub kill_all

sub _kill_all_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $vserver = $opts{vserver};

    $pkg_or_obj->_base_backend_cmode_cli(
        %opts,
        api                 => 'vserver_services_ndmp_kill_all',
        vserver_operated_on => \$vserver,
    );

    $Log->exit() if $may_exit;
} ## end  sub _kill_all_cmode_cli

sub _kill_all_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $vserver = $opts{vserver};
    $pkg_or_obj->_base_backend_cmode_zapi(
        %opts,
        api                 => 'ndmp-vserver-session-kill-all',
        vserver_operated_on => \$vserver,
    );
    $Log->exit() if $may_exit;
}

=head2 killsession

    NACL::C::VserverServicesNdmp->killsession(
                                command_interface => $ci,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $VserverServicesNdmp_obj->killsession(...);

(Class or instance method)
This method is used to kill the specified NDMP session.

Uses a CMode CLI/ZAPI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver possible value(s) are, vserver name

Applicable for CMode CLI/ZAPI.

=item C<< 'session-id' => $string >>

Session Identifier possible value(s) are, text

Applicable for CMode CLI/ZAPI.

=item C<< 'cmd_execution_time' => \$scalar >>

(Optional) Scalar reference , it will be updated with the command execution
time returned by the apiset response object

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver services ndmp killsession" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub killsession {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'cmd_execution_time' => {type => SCALARREF, optional => 1},
            _optional_scalars(
                qw( session-id
                    )
            ),
        },
        cli_cmd => 'vserver services ndmp killsession',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_killsession_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_killsession_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::VserverServicesNdmp::killsession',
    );

    $Log->exit() if $may_exit;
} ## end sub killsession

sub _killsession_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;

    $pkg_or_obj->_base_backend_cmode_cli(@args,
        api => 'vserver_services_ndmp_killsession',);

    $Log->exit() if $may_exit;
} ## end sub _killsession_cmode_cli

sub _killsession_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $vserver = $opts{vserver};
    my $copy    = [qw(session-id)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        %opts,
        api                 => 'ndmp-vserver-session-kill',
        copy                => $copy,
        vserver_operated_on => \$vserver,
    );
    $Log->exit() if $may_exit;
}

=head2 maxversion

    my $maxversion_obj = NACL::C::VserverServicesNdmp->maxversion(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @maxversion_objs = NACL::C::VserverServicesNdmp->maxversion(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $maxversion_obj = $VserverServicesNdmp_obj->maxversion(); 

(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverServicesNdmpMaxversion-pm/ATTRIBUTES>
of NACL::CS::VserverServicesNdmpMaxversion as input. 
This method returns objects of the type L<NACL::CS::VserverServicesNdmpMaxversion|lib-NACL-CS-VserverServicesNdmpMaxversion-pm>.

=cut

sub maxversion {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::VserverServicesNdmpMaxversion;
    my @state_objs = NACL::CS::VserverServicesNdmpMaxversion->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('vserver' => {type => SCALAR, optional => 1});
}
1;
