# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverVscanConnectionStatus Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverVscanConnectionStatus

=head1 DESCRIPTION

C<NACL::C::VserverVscanConnectionStatus> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverVscanConnectionStatus.  A related class is
L<NACL::CS::VserverVscanConnectionStatus|lib-NACL-CS-VserverVscanConnectionStatus-pm>, which represents
the past state of an ONTAP VserverVscanConnectionStatus.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 node

=cut

package NACL::C::VserverVscanConnectionStatus;

use strict;
use warnings;

use NACL::CS::VserverVscanConnectionStatus;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $VserverVscanConnectionStatus = NACL::C::VserverVscanConnectionStatus->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                   'node' => $node,
								  );

Return a new VserverVscanConnectionStatus component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'node',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $VserverVscanConnectionStatus_obj  = NACL::C::VserverVscanConnectionStatus->find(command_interface => $ci, ...);
	my @VserverVscanConnectionStatus_objs = NACL::C::VserverVscanConnectionStatus->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my VserverVscanConnectionStatus_state = $VserverVscanConnectionStatus_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverVscanConnectionStatus would return 
a NACL::CS::VserverVscanConnectionStatus object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 show_all

    my $show_all_obj = NACL::C::VserverVscanConnectionStatus->show_all(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_all_objs = NACL::C::VserverVscanConnectionStatus->show_all(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_all_obj = $VserverVscanConnectionStatus_obj->show_all(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverVscanConnectionStatusShowAll-pm/ATTRIBUTES>
of NACL::CS::VserverVscanConnectionStatusShowAll as input. 
This method returns objects of the type L<NACL::CS::VserverVscanConnectionStatusShowAll|lib-NACL-CS-VserverVscanConnectionStatusShowAll-pm>.

=cut

sub show_all {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::VserverVscanConnectionStatusShowAll;
    my @state_objs
        = NACL::CS::VserverVscanConnectionStatusShowAll->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_connected

    my $show_connected_obj = NACL::C::VserverVscanConnectionStatus->show_connected(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_connected_objs = NACL::C::VserverVscanConnectionStatus->show_connected(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_connected_obj = $VserverVscanConnectionStatus_obj->show_connected(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverVscanConnectionStatusShowConnected-pm/ATTRIBUTES>
of NACL::CS::VserverVscanConnectionStatusShowConnected as input. 
This method returns objects of the type L<NACL::CS::VserverVscanConnectionStatusShowConnected|lib-NACL-CS-VserverVscanConnectionStatusShowConnected-pm>.

=cut

sub show_connected {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::VserverVscanConnectionStatusShowConnected;
    my @state_objs
        = NACL::CS::VserverVscanConnectionStatusShowConnected->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_not_connected

    my $show_not_connected_obj = NACL::C::VserverVscanConnectionStatus->show_not_connected(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_not_connected_objs = NACL::C::VserverVscanConnectionStatus->show_not_connected(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_not_connected_obj = $VserverVscanConnectionStatus_obj->show_not_connected(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverVscanConnectionStatusShowNotConnected-pm/ATTRIBUTES>
of NACL::CS::VserverVscanConnectionStatusShowNotConnected as input. 
This method returns objects of the type L<NACL::CS::VserverVscanConnectionStatusShowNotConnected|lib-NACL-CS-VserverVscanConnectionStatusShowNotConnected-pm>.

=cut

sub show_not_connected {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::VserverVscanConnectionStatusShowNotConnected;
    my @state_objs
        = NACL::CS::VserverVscanConnectionStatusShowNotConnected->fetch(
        %opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_extended_stats

    my $show_extended_stats_obj = NACL::C::VserverVscanConnectionStatus->show_extended_stats(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_extended_stats_objs = NACL::C::VserverVscanConnectionStatus->show_extended_stats(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_extended_stats_obj = $VserverVscanConnectionStatus_obj->show_extended_stats(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverVscanConnectionStatusShowExtendedStats-pm/ATTRIBUTES>
of NACL::CS::VserverVscanConnectionStatusShowExtendedStats as input. 
This method returns objects of the type L<NACL::CS::VserverVscanConnectionStatusShowExtendedStats|lib-NACL-CS-VserverVscanConnectionStatusShowExtendedStats-pm>.

=cut

sub show_extended_stats {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::VserverVscanConnectionStatusShowExtendedStats;
    my @state_objs
        = NACL::CS::VserverVscanConnectionStatusShowExtendedStats->fetch(
        %opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver' => {type => SCALAR},
        'node'    => {type => SCALAR},
    );
}

1;
