# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverVscanOnDemandTask Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverVscanOnDemandTask

=head1 DESCRIPTION

C<NACL::C::VserverVscanOnDemandTask> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverVscanOnDemandTask.  A related class is
L<NACL::CS::VserverVscanOnDemandTask|lib-NACL-CS-VserverVscanOnDemandTask-pm>, which represents
the past state of an ONTAP VserverVscanOnDemandTask.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 task_name

=cut

package NACL::C::VserverVscanOnDemandTask;

use strict;
use warnings;

use NACL::CS::VserverVscanOnDemandTask;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $VserverVscanOnDemandTask = NACL::C::VserverVscanOnDemandTask->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                   'task-name' => $task_name,
								  );

Return a new VserverVscanOnDemandTask component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'task_name',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $VserverVscanOnDemandTask_obj  = NACL::C::VserverVscanOnDemandTask->find(command_interface => $ci, ...);
	my @VserverVscanOnDemandTask_objs = NACL::C::VserverVscanOnDemandTask->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverVscanOnDemandTask_state = $VserverVscanOnDemandTask_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverVscanOnDemandTask would return 
a NACL::CS::VserverVscanOnDemandTask object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 create

    my $VserverVscanOnDemandTask_obj	= NACL::C::VserverVscanOnDemandTask->create(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'task-name' => $task_name,
                                ...);
   
(Class method)
This method is used to create an On-Demand task.
Uses CMode CLI/ZAPI .
Invokes  vscan-on-demand-task-create  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'task-name' => $task_name >>

(Required)
Task Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'cross-junction' => $string >>

Cross Junction possible value(s) are, true,false
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'scan-files-with-no-ext' => $string >>

Scan Files with No Extension possible value(s) are, true,false
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'report-directory' => $string >>

Report Directory 
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'schedule' => $string >>

Job Schedule
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'request-timeout' => $string >>

Request Service Timeout
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'directory-recursion' => $string >>

Directory Recursion possible value(s) are, true,false
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'scan-priority' => $string >>

Scan Priority possible value(s) are, low,normal
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'max-file-size' => $string >>

Max File Size Allowed for Scanning
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'scan-paths' => [ $scan-path1, $scan-path2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'paths-to-exclude' => [ $paths-to-exclude1, $paths-to-exclude2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'file-ext-to-include' => [ $file-ext-to-include1, $file-ext-to-include2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'file-ext-to-exclude' => [ $file-ext-to-exclude1, $file-ext-to-exclude2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver vscan on demand task create" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'scan-paths'           => {type => ARRAYREF, optional => 1},
            'paths-to-exclude'    => {type => ARRAYREF, optional => 1},
            'file-ext-to-include' => {type => ARRAYREF, optional => 1},
            'file-ext-to-exclude' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( cross-junction scan-files-with-no-ext report-directory schedule request-timeout
                    directory-recursion scan-priority max-file-size
                    )
            ),
        },
        cli_cmd => 'vserver vscan on-demand-task create',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_create_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        nacl_exceptions => [qw(AlreadyExists)],
        frontend        => 'NACL::C::VserverVscanOnDemandTask::create',
    );

    my %obj_opts = (
        command_interface => $opts{command_interface},
        vserver           => $vserver,
        task_name         => $opts{'task-name'},
    );
    my $obj = $pkg->new(%obj_opts);
    $Log->exit() if $may_exit;
    return $obj;
}

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_vscan_on_demand_task_create',);
    $Log->exit() if $may_exit;
}

sub _create_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [
        qw(paths-to-exclude scan-paths cross-junction scan-files-with-no-ext
            request-timeout schedule report-directory directory-recursion
            file-ext-to-include scan-priority task-name file-ext-to-exclude
            max-file-size)
    ];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api                     => 'vscan-on-demand-task-create',
        copy                    => $copy,
        zapi_field_translations => {
            convert_to_bytes => [qw(max-file-size)],
            hrminsec_to_sec  => [qw(request-timeout)],
        },
    );
    $Log->exit() if $may_exit;
}

sub _check_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_check_non_iter(
        @opts,
        _primary_keys => [qw(vserver task-name)],
        _vs_context   => 1
    );
    $Log->exit() if $may_exit;
}

=head2 delete

    NACL::C::VserverVscanOnDemandTask->delete(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'task-name' => $task_name,
                                ...);
	                             
								 or

    $VserverVscanOnDemandTask_obj->delete(...);

(Class or instance method)
This method is used to delete an On-Demand task.
Uses CMode CLI/ZAPI .
Invokes  vscan-on-demand-task-delete  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'task-name' => $task_name >>

(Required for class method, Not Applicable for instance method)
Task Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver vscan on demand task delete" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver vscan on-demand-task delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_delete_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        nacl_exceptions => [qw(DoesNotExist)],
        frontend        => 'NACL::C::VserverVscanOnDemandTask::delete',
    );

    $Log->exit() if $may_exit;
}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_vscan_on_demand_task_delete',);
    $Log->exit() if $may_exit;
}

sub _delete_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(task-name)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'vscan-on-demand-task-delete',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VserverVscanOnDemandTask->modify(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'task-name' => $task_name,
                                ...);
	                             
								 or

    $VserverVscanOnDemandTask_obj->modify(...);

(Class or instance method)
This method is used to modify an On-Demand task.
Uses CMode CLI/ZAPI .
Invokes  vscan-on-demand-task-modify  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'task-name' => $task_name >>

(Required for class method, Not Applicable for instance method)
Task Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'cross-junction' => $string >>

Cross Junction possible value(s) are, true,false
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'scan-files-with-no-ext' => $string >>

Scan Files with No Extension possible value(s) are, true,false
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'report-directory' => $string >>

Report Path
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'schedule' => $string >>

Job Schedule
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'request-timeout' => $string >>

Request Service Timeout
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'directory-recursion' => $string >>

Directory Recursion possible value(s) are, true,false
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'scan-priority' => $string >>

Scan Priority possible value(s) are, low,normal
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'max-file-size' => $string >>

Max File Size Allowed for Scanning
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'scan-paths' => [ $scan-path1, $scan-path2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'paths-to-exclude' => [ $paths-to-exclude1, $paths-to-exclude2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'file-ext-to-include' => [ $file-ext-to-include1, $file-ext-to-include2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'file-ext-to-exclude' => [ $file-ext-to-exclude1, $file-ext-to-exclude2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver vscan on demand task modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'scan-paths'           => {type => ARRAYREF, optional => 1},
            'paths-to-exclude'    => {type => ARRAYREF, optional => 1},
            'file-ext-to-include' => {type => ARRAYREF, optional => 1},
            'file-ext-to-exclude' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( cross-junction scan-files-with-no-ext report-directory schedule request-timeout
                    directory-recursion scan-priority max-file-size
                    )
            ),
        },
        cli_cmd => 'vserver vscan on-demand-task modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_modify_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::VserverVscanOnDemandTask::modify',
    );

    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_vscan_on_demand_task_modify',);
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [
        qw(paths-to-exclude scan-paths cross-junction scan-files-with-no-ext
            request-timeout schedule report-directory directory-recursion
            file-ext-to-include scan-priority task-name file-ext-to-exclude
            max-file-size)
    ];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api                     => 'vscan-on-demand-task-modify',
        copy                    => $copy,
        zapi_field_translations => {
            convert_to_bytes => [qw(max-file-size)],
            hrminsec_to_sec  => [qw(request-timeout)],
        },
    );
    $Log->exit() if $may_exit;
}

=head2 run

    NACL::C::VserverVscanOnDemandTask->run(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'task-name' => $task_name,
                                ...);
	                             
								 or

    $VserverVscanOnDemandTask_obj->run(...);

(Class or instance method)
This method is used to run an On-Demand task.
Uses CMode CLI/ZAPI .
Invokes  vscan-on-demand-task-run  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'task-name' => $task_name >>

(Required for class method, Not Applicable for instance method)
Task Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver vscan on demand task run" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub run {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver vscan on-demand-task run',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_run_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_run_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::VserverVscanOnDemandTask::run',
    );

    $Log->exit() if $may_exit;
}

sub _run_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_vscan_on_demand_task_run',);
    $Log->exit() if $may_exit;
}

sub _run_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(task-name)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'vscan-on-demand-task-run',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 schedule

    NACL::C::VserverVscanOnDemandTask->schedule(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'task-name' => $task_name,
                                ...);
	                             
								 or

    $VserverVscanOnDemandTask_obj->schedule(...);

(Class or instance method)
This method is used to schedule an On-Demand task.
Uses CMode CLI.


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI

=item C<< 'task-name' => $task_name >>

(Required for class method, Not Applicable for instance method)
Task Name
Applicable for CMode CLI

=item C<< 'schedule' => $string >>

Schedule Name
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver vscan on demand task schedule" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub schedule {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( schedule
                    )
            ),
        },
        cli_cmd => 'vserver vscan on-demand-task schedule',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_schedule_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },

        ],
        frontend => 'NACL::C::VserverVscanOnDemandTask::schedule',
    );

    $Log->exit() if $may_exit;
}

sub _schedule_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_vscan_on_demand_task_schedule',);
    $Log->exit() if $may_exit;
}

=head2 unschedule

    NACL::C::VserverVscanOnDemandTask->unschedule(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'task-name' => $task_name,
                                ...);
	                             
								 or

    $VserverVscanOnDemandTask_obj->unschedule(...);

(Class or instance method)
This method is used to unschedule an On-Demand task.
Uses CMode CLI.


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI

=item C<< 'task-name' => $task_name >>

(Required for class method, Not Applicable for instance method)
Task Name
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver vscan on demand task unschedule" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub unschedule {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver vscan on-demand-task unschedule',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_unschedule_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },

        ],
        frontend => 'NACL::C::VserverVscanOnDemandTask::unschedule',
    );

    $Log->exit() if $may_exit;
}

sub _unschedule_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_vscan_on_demand_task_unschedule',);
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver'   => {type => SCALAR},
        'task-name' => {type => SCALAR},
    );
}

1;
