#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Wafl Snap Diff Component Module
## @author onkarb@netapp.com,asmitak@netapp.com,kvishal@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::WaflSnapDiff

=head1 DESCRIPTION

C<NACL::C::WaflSnapDiff> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>.
It represents access to wafl nodescope 'wafl get*' commands.
A related class is <NACL::CS::WaflSnapDiffGetChild|lib-NACL-CS-WaflSnapDiffGetChild-pm>,
A related class is <NACL::CS::WaflSnapDiffGetSubtreeLevel|lib-NACL-CS-WaflSnapDiffGetSubtreeLevel-pm>,
which represents the child id, next fbn and is_eob(it is the end of the buffer)

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

=cut


package NACL::C::WaflSnapDiff;

use strict;
use warnings;

use Params::Validate
    qw(validate_with SCALAR BOOLEAN ARRAYREF HASHREF UNDEF SCALARREF OBJECT);

use base 'NACL::C::Component::ONTAP';

1;
