#
# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary An exception when executing Lun or VolumeFile copy/move start
## operation.
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::_Mixins::Exceptions::FileCopyMove::MaximumSimultaneousOperation

=head1 DESCRIPTION

This exception is thrown when we try to execute VolumeFile copy/move start
operation.

=cut

package NACL::C::_Mixins::Exceptions::FileCopyMove::MaximumSimultaneousOperation;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::C::Exceptions::Component
    NACL::APISet::Exceptions::CommandFailedException
);

sub detect {
    $Log->enter();
    my ( $pkg, @args ) = @_;

    my $detected =
      $pkg->_detect_helper( @args,
              regexes => [qr/Maximum\s+simultaneous\s/i,
                          qr/Maximum combined total of file and LUN copy and move operations reached/i]);

    $Log->exit();
    return $detected;
}

1;
