# $Id: //depot/prod/test/nacldev/lib/NACL/C/_Mixins/Exceptions/VserverFpolicyPolicy/DoesNotExist.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when we attempt to delete a non-existing VserverFpolicyPolicy or PolicyEvent
## or PolicyScope or PolicyExternalEngine.
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::_Mixins::Exceptions::VserverFpolicyPolicy::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when we attempt to delete an existing Vserver Fpolicy Policy or event
or external-engine or policy-scope.

=cut

package NACL::C::_Mixins::Exceptions::VserverFpolicyPolicy::DoesNotExist;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::DoesNotExist
);
sub detect {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [qr/entry\s+doesn\'t\s+exist/,]
    );
    $Log->exit() if $may_exit;
    return $detected;
}
1;
