#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Common methods for the SecurityAudit Component and ComponentState
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

package NACL::C::_Mixins::SecurityAudit;

use strict;
use warnings;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

BEGIN {
    use Exporter qw(import);
    our @EXPORT_OK = qw(_cli_to_zapi_map);
    our %EXPORT_TAGS = ( 'all' => \@EXPORT_OK );
}

sub _cli_to_zapi_map {
    $Log->enter() if $may_enter;
    $Log->exit() if $may_exit;
    return {
        'httpset'   => 'http-set',
        'httpget'   => 'http-get',
        'snmpset'   => 'snmp-set',
        'snmpget'   => 'snmp-get',
        'cliset'    => 'cli-set',
        'cliget'    => 'cli-get',
        'ontapiset' => 'ontapi-set',
        'ontapiget' => 'ontapi-get',
    };
}

1;
