#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Common methods for the NetworkPort Component and ComponentState
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

package NACL::C::_Mixins::VolumeFlexcacheCachePolicy;

use strict;
use warnings;

BEGIN {
    use Exporter qw(import);
    our @EXPORT_OK = qw(_common_zapi_map _common_zapi_copy );
    our %EXPORT_TAGS = ( 'all' => \@EXPORT_OK );
}

sub _common_zapi_map {
    my %map = (
        "policy"    => "cache-policy-name",
        "reg-ttl"   => "time-to-live-files",
        "dir-ttl"   => "time-to-live-directories",
        "meta-ttl"  => "time-to-live-metafiles",
        "sym-ttl"   => "time-to-live-symbolic",
        "other-ttl" => "time-to-live-other",
    );
    return wantarray ? %map : \%map;
}

sub _common_zapi_copy {
    my @copy = (qw( deleg-lru-timeout prefer-local-cache vserver ));
    return wantarray ? @copy : \@copy;
}

1;
