#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Common methods for the VserverFpolicyPolicyExternalEngine Component and ComponentState
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

package NACL::C::_Mixins::VserverFpolicyPolicyExternalEngine;

use strict;
use warnings;

BEGIN {
    use Exporter qw(import);
    our @EXPORT_OK = qw(_common_zapi_map  _common_zapi_copy );
    our %EXPORT_TAGS = ( 'all' => \@EXPORT_OK );
}

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);


sub _common_zapi_map {
    my %map = (
       'max-policy-reqs'     => 'max-policy-requests',
       'max-server-reqs'     => 'max-server-requests',
       'status-req-interval' => 'status-request-interval',
       'port'                => 'port-number',
       'reqs-cancel-timeout' => 'request-cancel-timeout',
       'reqs-abort-timeout'  => 'request-abort-timeout',
       'secondary-servers'   => [
           make_zapi_array('secondary-servers'),
           make_zapi_skip('ip-address')
       ],
       'primary-servers' => [
          make_zapi_array('primary-servers'),
          make_zapi_skip('ip-address')
       ]
    );
    return wantarray ? %map : \%map;
}


sub _common_zapi_copy {
    my @copy = (qw(credential-lifetime  engine-name  extern-engine-type
        max-connection-retries ssl-common-name ssl-option
        keep-alive-interval certificate-common-name server-progress-timeout
        certificate-serial certificate-ca session-timeout));
    return wantarray ? @copy : \@copy;
}

1;
