#
# Copyright (c) 2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
#
## @summary EcacheFlushq Component Module
## @author Paul Chen chenp@netapp.com,dl-metawafl-qa@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::AggregateEcacheFlushq

=head1 DESCRIPTION

C<NACL::CS::AggregateEcacheFlushq> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>.
It represents the state of metawafl Eicach. A related class is
L<NACL::C::AggregateEcache|lib-NACL-C-AggregateEcache-pm>, which represents
access to metawafl nodescope 'mw tec'.

=head1 ATTRIBUTES

=over

=item C<< equeue_free_queue_0_ndx >>

Filled in for 7Mode Nodescope.

=item C<< equeue_free_queue_1_ndx >>

Filled in for 7Mode Nodescope.

=item C<< equeue_unused_queue >>

Filled in for 7Mode Nodescope.

=item C<< equeue_recycle_queue >>

Filled in for 7Mode Nodescope.

=item C<< equeue_dirty_queue_0_ndx >>

Filled in for 7Mode Nodescope.

=item C<< equeue_dirty_queue_1_ndx >>

Filled in for 7Mode Nodescope.

=cut

package NACL::CS::AggregateEcacheFlushq;

use strict;
use warnings;

use Tharn qw($Log);
use Params::Validate qw(validate);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'equeue_free_queue_0_ndx',
    scalar => 'equeue_free_queue_1_ndx',
    scalar => 'equeue_unused_queue',
    scalar => 'equeue_recycle_queue',
    scalar => 'equeue_dirty_queue_0_ndx',
    scalar => 'equeue_dirty_queue_1_ndx',
    scalar => 'aggregate',
];

=head1 METHODS

=head2 fetch

    my $state = NACL::CS::AggregateEcacheFlushq->fetch(
        command_interface => $ci,
        filter => { 'aggregate' => aggr_name,},
    );

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Supports 7Mode CLI

=over

=cut

__PACKAGE__->_fetch_7mode_cli_method_builder(
    apiset_method => 'mw_tec_flushq',
    filter_keys_to_be_passed_to_apiset => ['aggregate']
);

1;

