# $Id$
#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AggregateSnapshotReserveGet ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::AggregateSnapshotReserveGet

=head1 DESCRIPTION

C<NACL::CS::AggregateSnapshotReserveGet> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this
type are returned when NACL::CS::AggregateSnapshotReserveGet->get_version() is invoked.

(This module does not represent the state of any element, but is an object
representation of the output obtained when an aggregate snapshot is queried for
reserved status.

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< aggregate >>

=item C<< reserve >>

=item C<< size >>

=back

=cut

package NACL::CS::AggregateSnapshotReserveGet;

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'aggregate',
    scalar => 'reserve',
    scalar => 'size',
];

1;
