# $Id$
#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AggregateSnapshotSchedGet ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::AggregateSnapshotSchedGet

=head1 DESCRIPTION

C<NACL::CS::AggregateSnapshotSchedGet> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this
type are returned when NACL::C::AggregateSnapshot->sched_get() is invoked.

(This module does not represent the state of any element, but is an object
representation of the output obtained when an aggregate is queried for
snapshot schedule.

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< aggregate >>

=item C<< weeks >>

=item C<< days >>

=item C<< hours >>

=item C<< hour_list >>

=back

=cut

package NACL::CS::AggregateSnapshotSchedGet;

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'aggregate',
    scalar => 'weeks',
    scalar => 'days',
    scalar => 'hours',
    array => 'hour_list',
];

1;
