#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AntivirusOnAccess ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::AntivirusOnAccess

=head1 DESCRIPTION

C<NACL::CS::AntivirusOnAccess> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP AntivirusOnAccess.  A related class is
L<NACL::C::AntivirusOnAccess|lib-NACL-C-AntivirusOnAccess-pm>, which represents access
to an ONTAP AntivirusOnAccess.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the AntivirusOnAccess
element are the attributes of the AntivirusOnAccess ComponentState.

=over

=item C<< "volume_policy" >>

Filled in for CMode CLI

=item C<< "vserver_policy" >>

Filled in for CMode CLI

=item C<< "volume" >>

Filled in for CMode CLI

=item C<< "vserver" >>

Filled in for CMode CLI

=item C<< volume_type >>

Filled in for CMode CLI

=item C<< is_repository >>

Filled in for CMode CLI.

=item C<< is_constituent >>

Is Constituent Volume, possible value(s) are true,false

Filled in for CMode CLI.

=back

=cut

package NACL::CS::AntivirusOnAccess;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'volume_policy',
    scalar => 'vserver_policy',
    scalar => 'volume',
    scalar => 'vserver',
    scalar => 'volume_type',
    scalar => 'is_repository',
    scalar => 'is_constituent',
];

=head1 METHODS

=head2 fetch

    my $AntivirusOnAccess_state   = NACL::CS::AntivirusOnAccess->fetch(command_interface => $ci, ...);
	my @AntivirusOnAccess_states = NACL::CS::AntivirusOnAccess->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching antivirus on access(s) found',
        show_cmd       => 'antivirus on-access show',
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'antivirus_on_access_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
