# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AntivirusOnDemandCommandScanFile ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, benjaram@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::AntivirusOnDemandCommandScanFile

=head1 DESCRIPTION

C<NACL::CS::AntivirusOnDemandCommandScanFile> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP AntivirusOnDemandCommandScanFile.  A related class is
L<NACL::C::AntivirusOnDemandCommandScanFile|lib-NACL-C-AntivirusOnDemandCommandScanFile-pm>, which represents access
to an ONTAP AntivirusOnDemandCommandScanFile.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the AntivirusOnDemandCommandScanFile
element are the attributes of the AntivirusOnDemandCommandScanFile ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< scan_path >>

Path Name

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-file-info>
    <scan-path>$value</scan-path>
 </av-on-demand-command-scan-file-info>


=item C<< policy_owner >>

Creator of On-demand Command

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-file-info>
    <policy-owner>$value</policy-owner>
 </av-on-demand-command-scan-file-info>

=item C<< vserver >>

Vserver

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-file-info>
    <vserver>$value</vserver>
 </av-on-demand-command-scan-file-info>

=item C<< scan_type >>

Object to be Scanned, possible value(s) are file,dir,vserver,cluster

Filled in for CMode CLI

=item C<< name >>

Command Name

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-file-info>
    <command-name>$value</command-name>
 </av-on-demand-command-scan-file-info>

=item C<< force >>

Force Creation

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-file-info>
    <force>$value</force>
 </av-on-demand-command-scan-file-info>

=back

=cut

package NACL::CS::AntivirusOnDemandCommandScanFile;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'scan_path',
    scalar => 'policy_owner',
    scalar => 'vserver',
    scalar => 'scan_type',
    scalar => 'name',
    scalar => 'force',
];

=head1 METHODS

=head2 fetch

    my $AntivirusOnDemandCommandScanFile_state  = NACL::CS::AntivirusOnDemandCommandScanFile->fetch(command_interface => $ci, ...);
    my @AntivirusOnDemandCommandScanFile_states = NACL::CS::AntivirusOnDemandCommandScanFile->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI.

Invokes "av-on-demand-command-scan-file-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching antivirus on-demand command scan-file(s) found',
        show_cmd       => 'antivirus on-demand command scan-file show',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'antivirus_on_demand_command_scan_file_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;

    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        api  => 'av_on_demand_command_scan_file_get_iter',
        copy => [qw( force policy-owner scan-path vserver )],
        map  => {'name' => 'command-name',},
    );

    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

1;
