# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ClusterImageShowUpdateLogDetail ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::ClusterImageShowUpdateLogDetail

=head1 DESCRIPTION

C<NACL::CS::ClusterImageShowUpdateLogDetail> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP ClusterImageShowUpdateLogDetail.  A related class is
L<NACL::C::ClusterImageShowUpdateLogDetail|lib-NACL-C-ClusterImageShowUpdateLogDetail-pm>, which represents access
to an ONTAP ClusterImageShowUpdateLogDetail.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the ClusterImageShowUpdateLogDetail
element are the attributes of the ClusterImageShowUpdateLogDetail ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< destination >>

task target node
Filled in for CMode CLI

=item C<< status >>


Status Of Task possible value(s) are, created,ready-to-run,running,completed,failed,pause_req,paused,paused-error,cancel_req,canceled,resume_req,default_status
Filled in for CMode CLI

=item C<< src_info >>

Source Information
Filled in for CMode CLI

=item C<< msg_type >>

Type of Message
Filled in for CMode CLI

=item C<< node >>

Node possible value(s) are, <nodename>,local
Filled in for CMode CLI

=item C<< message >>

Update Log Message
Filled in for CMode CLI

=item C<< ndu_phase >>

Update phase
Filled in for CMode CLI

=item C<< posted_time >>

Posted Time
Filled in for CMode CLI

=item C<< msg_seq_no >>

Message Sequence
Filled in for CMode CLI

=item C<< task_name >>


Task Name possible value(s) are, initialize,mount-image,restart-hm,get-health,run-scripts,unmount-image,clear-alert,post-restart-hm,cleanup-rd,synch-image,do-download-job,do-failover-job,check-progress,complete-validation,invalid-task,default-task 
Filled in for CMode CLI

=item C<< current_pid >>

process ID
Filled in for CMode CLI

=item C<< task_id >>

Task Id
Filled in for CMode CLI

=back

=cut

package NACL::CS::ClusterImageShowUpdateLogDetail;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'destination',
    scalar => 'status',
    scalar => 'src_info',
    scalar => 'msg_type',
    scalar => 'node',
    scalar => 'message',
    scalar => 'ndu_phase',
    scalar => 'posted_time',
    scalar => 'msg_seq_no',
    scalar => 'task_name',
    scalar => 'current_pid',
    scalar => 'task_id',
];

=head1 METHODS

=head2 fetch

    my $ClusterImageShowUpdateLogDetail_state  = NACL::CS::ClusterImageShowUpdateLogDetail->fetch(command_interface => $ci, ...);
	my @ClusterImageShowUpdateLogDetail_states = NACL::CS::ClusterImageShowUpdateLogDetail->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'cluster image show-update-log-detail show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching cluster image show-update-log-detail(s) found',
        frontend => 'NACL::CS::ClusterImageShowUpdateLogDetail::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'cluster_image_show_update_log_detail_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
