
#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ClusterImageUpdate ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::ClusterImageUpdate

=head1 DESCRIPTION

This module does not represent the state of any element, but is an object
representation of the output of cluster image update command

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the ClusterImageUpdate
element are the attributes of the ClusterImageUpdate ComponentState.

=over

=item C<< status >>

Filled in for CMode CLI.

=item C<< non_disruptive_check >>

Filled in for CMode CLI.

=item C<< error_action >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::ClusterImageUpdate;

use strict;
use warnings;
use base qw(NACL::CS::ComponentState::ONTAP);

use Class::MethodMaker [
    scalar => 'status',
    scalar => 'non_disruptive_check',
    scalar => 'error_action',
];

1;
