# $Id: $

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ClusterPingCluster ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::ClusterPingCluster

=head1 DESCRIPTION

This module does not represent the state of any element, but is an object
representation of the output of cluster ping cluster 

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the ClusterPingCluster 
element are the attributes of the ClusterPingCluster ComponentState.

=over

=item C<< rpc_status >>

=item C<< no_of_up_paths >>

=item C<< protocol_check >>

=item C<< protocol_check >>

=item C<< no_of_down_paths >>

=item C<< host_name >>

=item C<< ping_status >>

=item C<< no_of_paths >>

=item C<< connectivity >>

=item C<< status >>

=item C<< local_ip >>

Filled in for CMode CLI.

=item C<< mtu_info>

Filled in for CMode CLI.

=item C<< remote_ip >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::ClusterPingCluster;

use strict;
use warnings;
use base qw(NACL::CS::ComponentState::ONTAP);
use Class::MethodMaker [
    array  => 'rpc_status',
    scalar => 'no_of_up_paths',
    scalar => 'protocol_check',
    scalar => 'no_of_down_paths',
    scalar => 'host_name',
    array  => 'ping_status',
    scalar => 'no_of_paths',
    scalar => 'connectivity',
    scalar => 'status',
    array  => 'local_ip',
    array  => 'mtu_info',
    array  => 'remote_ip',
];

1;
