# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Abstract base class for Client CS modules
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::ComponentState::Client

=head1 SYNOPSIS

    use base 'NACL::CS::ComponentState::Client';

=head1 DESCRIPTION

NACL::CS::ComponentState::Client is an abstract base class for all Client
Component state libraries. It is derived
from L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm> and it 
provides Client specific component base class methods. The implementation 
and documentation of provided functionality is present in 
L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm>.

=head1 ATTRIBUTES

Same as those of L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/ATTRIBUTES>
(command interfaces are constrained to be sub-classes of
C<NACL::C::Client>.)

=cut

package NACL::CS::ComponentState::Client;

use strict;
use warnings;
use base 'NACL::CS::ComponentState';

use Class::MethodMaker [
    scalar => [
        { -type => 'NACL::C::Client' }, 
        'command_interface', 
    ],
];

1;
