# $Id: //depot/prod/test/UM6.0_integ/lib/NACL/CS/DFM/DiskPhysicalSummary.pm#1 $

#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Disk ComponentState Module (auto-generated by CGT)
## @author dl-mei-nacl-dev@netapp.com
## @change 2012-01-04 deepthis Created the file
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::DiskPhysicalSummary

=head1 DESCRIPTION

C<NACL::CS::DFM::DiskPhysicalSummary> is a derived class of
L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm>. It represents the
state of an ONTAP Disk.  A related class is
L<NACL::C::DFM::Disk|lib-NACL-C-DFM-Disk-pm>, which represents access
to an ONTAP Disk.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the Disk
element are the attributes of the Disk ComponentState.

=over

=item C<< disk_info  >> 
(Type L<NACL::CS::DFM::DiskPhysicalSummaryDiskInfo|lib-NACL-CS-DFM-DiskPhysicalSummaryDiskInfo-pm>) )

=item C<< lun_info >>
(Type L<NACL::CS::DFM::DiskPhysicalSummaryLunInfo|lib-NACL-CS-DFM-DiskPhysicalSummaryLunInfo-pm>) )
    
=back

=cut

package NACL::CS::DFM::DiskPhysicalSummary;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::CS::DFM::DiskPhysicalSummaryDiskInfo;
use NACL::CS::DFM::DiskPhysicalSummaryLunInfo;

use base 'NACL::CS::ComponentState::DFM';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => [
        { -type => 'NACL::CS::DFM::DiskPhysicalSummaryDiskInfo' }, 'disk_info'
    ],
    scalar =>
      [ { -type => 'NACL::CS::DFM::DiskPhysicalSummaryLunInfo' }, 'lun_info' ],
];

sub _nested_objects {
    return {
        'disk_info' => 'NACL::CS::DFM::DiskPhysicalSummaryDiskInfo',
        'lun_info'  => 'NACL::CS::DFM::DiskPhysicalSummaryLunInfo',
    };
}

1;
