# $Id$
#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary EventNameInfo ComponentState Module (auto-generated by OCUM CGT)
## @author dl-mpo-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::EventNameInfo

=head1 DESCRIPTION

C<NACL::CS::DFM::EventNameInfo> is a derived class of
L<NACL::CS::ComponentState::DFM|lib-NACL-CS-ComponentState-DFM-pm>. It represents the
state of a EventNameInfo. 

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the EventNameInfo
element are the attributes of the EventNameInfo ComponentState.

=over


=item C<< impact_level >>

=item C<< event_name_short >>

=item C<< severity >>

=item C<< event_name_pretty >>

=back

=cut 

package NACL::CS::DFM::EventNameInfo;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use base 'NACL::CS::ComponentState::DFM';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'impact_level',
    scalar => 'event_name_short',
    scalar => 'severity',
    scalar => 'event_name_pretty',
];

1;
