# $Id: //depot/prod/test/main/lib/NACL/CS/Eventclass.pm $
#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Eventclass ComponentState Module (auto-generated by OCUM CGT)
## @author dl-mpo-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::Eventclass

=head1 DESCRIPTION

C<NACL::CS::DFM::Eventclass> is a derived class of
L<NACL::CS::ComponentState::DFM|lib-NACL-CS-ComponentState-DFM-pm>. It represents the
state of a Eventclass.  A related class is
L<NACL::C::DFM::Eventclass|lib-NACL-C-DFM-Eventclass-pm>, which represents access
to OCUM Eventclass.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the Eventclass
element are the attributes of the Eventclass ComponentState.

=over


=item C<< event_class_id >>

=item C<< is_multi_current >>

=item C<< event_class_name >>

=item C<< event_names >>
( Array, Type L<NACL::CS::DFM::EventNameInfo|lib-NACL-CS-DFM-EventNameInfo-pm> )

=item C<< event_class_type >>

=item C<< category >>

=item C<< about_message >>

=item C<< is_allow_duplicates >>

=item C<< impact_area >>

=back

=head2 ADDITIONAL FILTER FIELDS

The fetch method also allows the following options to be passed in the
filter even though they are not MethodMaker fields.

=over

=item C<< event-class-name-or-ids >>
( Array )
=back

=cut 

package NACL::CS::DFM::Eventclass;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use base 'NACL::CS::ComponentState::DFM';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'event_class_id',
    scalar => 'is_multi_current',
    scalar => 'event_class_name',
    array => [ { -type => 'NACL::CS::DFM::EventNameInfo' }, 'event_names' ],
    scalar => 'event_class_type',
    scalar => 'category',
    scalar => 'about_message',
    scalar => 'is_allow_duplicates',
    scalar => 'impact_area',
];

=head1 METHODS


=head2 fetch

    my $state = NACL::CS::DFM::Eventclass->fetch(command_interface => $ci, ...);
    my @states = NACL::CS::DFM::Eventclass->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

=cut

sub fetch {

    $Log->enter() if $may_enter;
    my $pkg = shift;

    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {
                method    => '_fetch_zapi',
                interface => 'ZAPI',
                set       => 'DFM',
            },
        ],
        exception_text => 'No matching Eventclass(s) found.',
    );

    $Log->exit() if $may_exit;

    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_zapi {

    $Log->enter() if $may_enter;
    my $pkg = shift;

    my @state_objs = $pkg->SUPER::_fetch_dfm_zapi(
        @_,
        api => 'eventclass-list-iter',
    );

    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _extra_filter_fields {

    $Log->enter() if $may_enter;
    $Log->exit() if $may_exit;
    return [
      qw( event-class-name-or-ids event-class-type 
      ) ]; 
}

sub _nested_objects {
    return {
        'event_names' => 'NACL::CS::DFM::EventNameInfo',
    };
}

1;
