# $Id: //depot/prod/test/main/lib/NACL/CS/RelationshipTaskInfo.pm $
#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary RelationshipTaskInfo ComponentState Module (auto-generated by OCUM CGT)
## @author dl-mpo-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::RelationshipTaskInfo

=head1 DESCRIPTION

C<NACL::CS::DFM::RelationshipTaskInfo> is a derived class of
L<NACL::CS::ComponentState::DFM|lib-NACL-CS-ComponentState-DFM-pm>. It represents the
state of a RelationshipTaskInfo.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the RelationshipTaskInfo
element are the attributes of the RelationshipTaskInfo ComponentState.

=over


=item C<< source_member_resource_key >>

=item C<< source_node_resource_key >>

=item C<< connection_resource_key >>

=item C<< relationship_resource_key >>

=item C<< destination_member_name >>

=item C<< destination_member_resource_key >>

=item C<< source_node_name >>

=item C<< source_member_name >>

=item C<< destination_node_resource_key >>

=item C<< destination_node_name >>

=item C<< last_progress_info >>
( Type L<NACL::CS::DFM::TransferProgressTaskInfo|lib-NACL-CS-DFM-TransferProgressTaskInfo-pm> )

=back

=cut 

package NACL::CS::DFM::RelationshipTaskInfo;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use base 'NACL::CS::ComponentState::DFM';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'source_member_resource_key',
    scalar => 'source_node_resource_key',
    scalar => 'connection_resource_key',
    scalar => 'relationship_resource_key',
    scalar => 'destination_member_name',
    scalar => 'destination_member_resource_key',
    scalar => 'source_node_name',
    scalar => 'source_member_name',
    scalar => 'destination_node_resource_key',
    scalar => 'destination_node_name',
    scalar => [ { -type => 'NACL::CS::DFM::TransferProgressTaskInfo' }, 'last_progress_info' ],
];

sub _nested_objects {
    return {
        'last_progress_info' => 'NACL::CS::DFM::TransferProgressTaskInfo',
    };
}

1;
