# $Id$ //depot/prod/test/UM6.0_integ/lib/NACL/CS/DFM/Snapshot.pm#1 $

#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Snapshot ComponentState Module (auto-generated by CGT)
## @author vinothg,dl-mpo-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::Snapshot

=head1 DESCRIPTION

C<NACL::CS::DFM::Snapshot> is a derived class of
L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm>. It represents the
state of an ONTAP Snapshot.  A related class is
L<NACL::C::DFM::Snapshot|lib-NACL-C-DFM-Snapshot-pm>, which represents access
to an ONTAP Snapshot.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the Snapshot
element are the attributes of the Snapshot ComponentState.

=over

=item C<< creation_timestamp >>

=item C<< cumulative_percentage_of_total_blocks >>

=item C<< dependencies >>

=item C<< is_busy >>

=item C<< percentage_of_total_blocks >>

=item C<< snapshot_instance_uuid >>

=item C<< snapshot_name >>

=item C<< snapshot_version_uuid >>

=item C<< volume_name >>

=item C<< volume_resource_key >>

=back

=head2 ADDITIONAL FILTER FIELDS

The fetch method also allows the following options to be passed in the
filter even though they are not MethodMaker fields.

=over

=item C<< resource-filter >>

=back 

=cut

package NACL::CS::DFM::Snapshot;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use base 'NACL::CS::ComponentState::DFM';
use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'creation_timestamp',
    scalar => 'cumulative_percentage_of_total_blocks',
    scalar => 'dependencies',
    scalar => 'is_busy',
    scalar => 'percentage_of_total_blocks',
    scalar => 'snapshot_instance_uuid',
    scalar => 'snapshot_name',
    scalar => 'snapshot_version_uuid',
    scalar => 'volume_name',
    scalar => 'volume_resource_key',
];


=head2 fetch

    my $Snapshot_state   = NACL::CS::DFM::Snapshot->fetch(command_interface => $ci, ...);
    my @Snapshot_states = NACL::CS::DFM::Snapshot->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg = shift;

    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {
                method    => '_fetch_zapi',
                interface => 'ZAPI',
                set       => 'DFM',
            },
        ],
        exception_text => 'No matching Snapshot(s) found.',
    );

    $Log->exit() if $may_exit;

    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_zapi {

    $Log->enter() if $may_enter;

    my $pkg = shift;

    my @state_objs =
      $pkg->SUPER::_fetch_dfm_zapi( @_, api => 'snapshot-list-info-iter', );
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _extra_filter_fields {
    $Log->enter() if $may_enter;
    $Log->exit() if $may_exit;
    return [qw( resource-filter )];
}

1;
