# $Id: //depot/prod/test/main/lib/NACL/CS/VolumeCloneInfo.pm $
#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VolumeCloneInfo ComponentState Module (auto-generated by OCUM CGT)
## @author dl-mpo-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::VolumeCloneInfo

=head1 DESCRIPTION

C<NACL::CS::DFM::VolumeCloneInfo> is a derived class of
L<NACL::CS::ComponentState::DFM|lib-NACL-CS-ComponentState-DFM-pm>. It represents the
state of a VolumeCloneInfo.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VolumeCloneInfo
element are the attributes of the VolumeCloneInfo ComponentState.

=over


=item C<< parent_volume_name >>

=item C<< is_clone_present >>

=item C<< clone_child_count >>

=item C<< clone_space_savings_percentage >>

=item C<< is_clone >>

=item C<< clone_space_savings >>

=item C<< parent_volume_resource_key >>

=back

=cut 

package NACL::CS::DFM::VolumeCloneInfo;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use base 'NACL::CS::ComponentState::DFM';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'parent_volume_name',
    scalar => 'is_clone_present',
    scalar => 'clone_child_count',
    scalar => 'clone_space_savings_percentage',
    scalar => 'is_clone',
    scalar => 'clone_space_savings',
    scalar => 'parent_volume_resource_key',
];

1;
