# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::DashboardHealthVserver->show_combined() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DashboardHealthVserverShowCombined

=head1 DESCRIPTION

C<NACL::CS::DashboardHealthVserverShowCombined> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::DashboardHealthVserver->show_combined() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::DashboardHealthVserver->show_combined() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< vserver >>

Vserver

Filled in for CMode CLI.

=item C<< time >>

Time

Filled in for CMode CLI.

=item C<< event >>

Event name

Filled in for CMode CLI.

=item C<< description >>

Description

Filled in for CMode CLI.

=item C<< node >>

Issuing Node

Filled in for CMode CLI.

=item C<< objectname >>

Object Name

Filled in for CMode CLI.

=item C<< category >>

Health Issue Type

Filled in for CMode CLI.

=item C<< severity >>

Severity, possible value(s) are ok,info,warning,critical

Filled in for CMode CLI.

=back

=cut

package NACL::CS::DashboardHealthVserverShowCombined;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'time',
    scalar => 'event',
    scalar => 'description',
    scalar => 'node',
    scalar => 'objectname',
    scalar => 'category',
    scalar => 'severity',
];

=head1 METHODS

=head2 fetch

    my $DashboardHealthVserverShowCombined_state  = NACL::CS::DashboardHealthVserverShowCombined->fetch(command_interface => $ci, ...);
	my @DashboardHealthVserverShowCombined_states = NACL::CS::DashboardHealthVserverShowCombined->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'dashboard health vserver show-combined',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching dashboard health vserver(s) found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'dashboard_health_vserver_show_combined',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
