#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugClusterSetup ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugClusterSetup

=head1 DESCRIPTION

C<NACL::CS::DebugClusterSetup> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugClusterSetup.  A related class is
L<NACL::C::DebugClusterSetup|lib-NACL-C-DebugClusterSetup-pm>, which represents access
to an ONTAP DebugClusterSetup.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugClusterSetup
element are the attributes of the DebugClusterSetup ComponentState.

=over

=item C<< status >>

Filled in for CMode CLI.

=item C<< work_status >>

(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $work_status = $obj->work_status();
# $work_status contains a reference to the array of values
my @work_status = $obj->work_status();
# @work_status contains the array of values

Filled in for CMode CLI.

=item C<< status_message >>

Filled in for CMode CLI.

=item C<< num_failures >>

Filled in for CMode CLI.

=item C<< num_tries >>

Filled in for CMode CLI.

=item C<< sub_task_id >>

Filled in for CMode CLI.

=item C<< notes >>

(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $notes = $obj->notes();
# $notes contains a reference to the array of values
my @notes = $obj->notes();
# @notes contains the array of values

Filled in for CMode CLI.

=item C<< total_time >>

Filled in for CMode CLI.

=item C<< task_id >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::DebugClusterSetup;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'status',
    array  => 'work_status',
    scalar => 'status_message',
    scalar => 'num_failures',
    scalar => 'num_tries',
    scalar => 'sub_task_id',
    array  => 'notes',
    scalar => 'total_time',
    scalar => 'task_id',
];

=head1 METHODS

=head2 fetch

    my $DebugClusterSetup_state   = NACL::CS::DebugClusterSetup->fetch(command_interface => $ci, ...);
	my @DebugClusterSetup_states = NACL::CS::DebugClusterSetup->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'debug cluster-setup show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching debug cluster setup(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'debug_cluster_setup_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
