# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCpsStorageArea ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCpsStorageArea

=head1 DESCRIPTION

C<NACL::CS::DebugCpsStorageArea> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugCpsStorageArea.  A related class is
L<NACL::C::DebugCpsStorageArea|lib-NACL-C-DebugCpsStorageArea-pm>, which represents access
to an ONTAP DebugCpsStorageArea.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugCpsStorageArea
element are the attributes of the DebugCpsStorageArea ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< pending_status_clients >>

Clients Awaiting Area Status
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $pending_status_clients = $obj->pending_status_clients();
 
# $pending_status_clients contains a reference to the array of values
 
my @pending_status_clients = $obj->pending_status_clients();
 
# @pending_status_clients contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { pending_status_clients = [ value1, value2...] }

Filled in for CMode CLI

=item C<< epoch >>

Epoch

Filled in for CMode CLI

=item C<< area >>


Storage Area possible value(s) are, crs-scratch,crs-sender-queues,crs-receiver-queues

Filled in for CMode CLI

=item C<< clients >>

Clients
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $clients = $obj->clients();
 
# $clients contains a reference to the array of values
 
my @clients = $obj->clients();
 
# @clients contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { clients = [ value1, value2...] }

Filled in for CMode CLI

=item C<< delta_clients >>

Clients Handling Area Deltas
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $delta_clients = $obj->delta_clients();
 
# $delta_clients contains a reference to the array of values
 
my @delta_clients = $obj->delta_clients();
 
# @delta_clients contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { delta_clients = [ value1, value2...] }

Filled in for CMode CLI

=item C<< path >>

Storage Area Path

Filled in for CMode CLI

=item C<< under_repair >>

Under Repair possible value(s) are, true,false

Filled in for CMode CLI

=back

=cut

package NACL::CS::DebugCpsStorageArea;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'pending_status_clients',
    scalar => 'epoch',
    scalar => 'area',
    array  => 'clients',
    array  => 'delta_clients',
    scalar => 'path',
    scalar => 'under_repair',
];

=head1 METHODS

=head2 fetch

    my $DebugCpsStorageArea_state  = NACL::CS::DebugCpsStorageArea->fetch(command_interface => $ci, ...);
	my @DebugCpsStorageArea_states = NACL::CS::DebugCpsStorageArea->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug cps storage-area show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug cps storage-area(s) found',
        frontend       => 'NACL::CS::DebugCpsStorageArea::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_cps_storage_area_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
