# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsStorageArea ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCrsStorageArea

=head1 DESCRIPTION

C<NACL::CS::DebugCrsStorageArea> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugCrsStorageArea.  A related class is
L<NACL::C::DebugCrsStorageArea|lib-NACL-C-DebugCrsStorageArea-pm>, which represents access
to an ONTAP DebugCrsStorageArea.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugCrsStorageArea
element are the attributes of the DebugCrsStorageArea ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< pending_error_operation >>


Pending Error Operation possible value(s) are, none,open,read,write,tell,seek,close,move,copy,remove

Filled in for CMode CLI

=item C<< epoch >>

Epoch

Filled in for CMode CLI

=item C<< area >>


Storage Area possible value(s) are, crs-scratch,crs-sender-queues,crs-receiver-queues

Filled in for CMode CLI

=item C<< error_operation >>


Error Operation possible value(s) are, none,open,read,write,tell,seek,close,move,copy,remove

Filled in for CMode CLI

=item C<< path >>

Storage Area Path

Filled in for CMode CLI

=item C<< pending_error_code >>

Pending Error Code

Filled in for CMode CLI

=item C<< error_code >>

Error Code

Filled in for CMode CLI

=item C<< error_confirmed >>

Error Confirmed possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< reported_error_count >>

Count of Observed Errors

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DebugCrsStorageArea;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'pending_error_operation',
    scalar => 'epoch',
    scalar => 'area',
    scalar => 'error_operation',
    scalar => 'path',
    scalar => 'pending_error_code',
    scalar => 'error_code',
    scalar => 'error_confirmed',
    scalar => 'reported_error_count',
];

=head1 METHODS

=head2 fetch

    my $DebugCrsStorageArea_state  = NACL::CS::DebugCrsStorageArea->fetch(command_interface => $ci, ...);
	my @DebugCrsStorageArea_states = NACL::CS::DebugCrsStorageArea->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug crs storage-area show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug crs storage-area(s) found',
        frontend       => 'NACL::CS::DebugCrsStorageArea::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_crs_storage_area_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
