# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsStreamOperational ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCrsStreamOperational

=head1 DESCRIPTION

C<NACL::CS::DebugCrsStreamOperational> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugCrsStreamOperational.  A related class is
L<NACL::C::DebugCrsStreamOperational|lib-NACL-C-DebugCrsStreamOperational-pm>, which represents access
to an ONTAP DebugCrsStreamOperational.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugCrsStreamOperational
element are the attributes of the DebugCrsStreamOperational ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< last_error_count_reciprocal >>

Last Error Count of Reciprocal

Filled in for CMode CLI

=item C<< stream_uuid >>

Stream UUID

Filled in for CMode CLI

=item C<< last_seq_num_dequeued >>

Last Sequence Number Dequeued

Filled in for CMode CLI

=item C<< oper_state_reciprocal >>


Operational State of Reciprocal possible value(s) are, up,down,paused,in-error,not-created,unknown,misconfigured

Filled in for CMode CLI

=item C<< last_error_count >>

Last Error Count

Filled in for CMode CLI

=item C<< last_seq_num_queued_reciprocal >>

Last Sequence Number Queued on Reciprocal

Filled in for CMode CLI

=item C<< last_seq_num_dequeued_reciprocal >>

Last Sequence Number Dequeued on Reciprocal

Filled in for CMode CLI

=item C<< incarnation_uuid >>

Incarnation UUID

Filled in for CMode CLI

=item C<< oper_state >>


Operational State possible value(s) are, up,down,paused,in-error,not-created,unknown,misconfigured

Filled in for CMode CLI

=item C<< is_recovering >>

Recovering After Reset on Receiver possible value(s) are, true,false

Filled in for CMode CLI

=item C<< last_heartbeat_timestamp >>

Time Stamp of Last Heartbeat

Filled in for CMode CLI

=item C<< ecv_reciprocal >>

Effective Cluster Version of Reciprocal

Filled in for CMode CLI

=item C<< ecv >>

Effective Cluster Version

Filled in for CMode CLI

=item C<< out_of_sequence_deletions >>

Out of Sequence Queue Deletions
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $out_of_sequence_deletions = $obj->out_of_sequence_deletions();
 
# $out_of_sequence_deletions contains a reference to the array of values
 
my @out_of_sequence_deletions = $obj->out_of_sequence_deletions();
 
# @out_of_sequence_deletions contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { out_of_sequence_deletions = [ value1, value2...] }

Filled in for CMode CLI

=item C<< incarnation_uuid_reciprocal >>

Incarnation UUID of Reciprocal

Filled in for CMode CLI

=item C<< last_seq_num_queued >>

Last Sequence Number Queued

Filled in for CMode CLI

=item C<< percent_full_reciprocal >>

Percent Full on Reciprocal

Filled in for CMode CLI

=item C<< last_dequeued_time_reciprocal >>

Time when Last Message was Dequeued on Reciprocal

Filled in for CMode CLI

=back

=cut

package NACL::CS::DebugCrsStreamOperational;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'last_error_count_reciprocal',
    scalar => 'stream_uuid',
    scalar => 'last_seq_num_dequeued',
    scalar => 'oper_state_reciprocal',
    scalar => 'last_error_count',
    scalar => 'last_seq_num_queued_reciprocal',
    scalar => 'last_seq_num_dequeued_reciprocal',
    scalar => 'incarnation_uuid',
    scalar => 'oper_state',
    scalar => 'is_recovering',
    scalar => 'last_heartbeat_timestamp',
    scalar => 'ecv_reciprocal',
    scalar => 'ecv',
    array  => 'out_of_sequence_deletions',
    scalar => 'incarnation_uuid_reciprocal',
    scalar => 'last_seq_num_queued',
    scalar => 'percent_full_reciprocal',
    scalar => 'last_dequeued_time_reciprocal',
];

=head1 METHODS

=head2 fetch

    my $DebugCrsStreamOperational_state  = NACL::CS::DebugCrsStreamOperational->fetch(command_interface => $ci, ...);
	my @DebugCrsStreamOperational_states = NACL::CS::DebugCrsStreamOperational->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug crs stream operational show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug crs stream operational(s) found',
        frontend       => 'NACL::CS::DebugCrsStreamOperational::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_crs_stream_operational_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
