# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::DebugCrsStreamOperational->show_summary_stats() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCrsStreamOperationalShowSummaryStats

=head1 DESCRIPTION

C<NACL::CS::DebugCrsStreamOperationalShowSummaryStats> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::DebugCrsStreamOperational->show_summary_stats() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::DebugCrsStreamOperational->show_summary_stats() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< ecv >>

Effective Cluster Version

Filled in for CMode CLI

=item C<< stream_uuid >>

Stream UUID

Filled in for CMode CLI

=item C<< oper_state_reciprocal >>


Operational State of Reciprocal possible value(s) are, up,down,paused,in-error,not-created,unknown,misconfigured

Filled in for CMode CLI

=item C<< last_message_timestamp >>

Time Stamp of Last Message

Filled in for CMode CLI

=item C<< oper_state >>


Operational State possible value(s) are, up,down,paused,in-error,not-created,unknown,misconfigured

Filled in for CMode CLI

=item C<< direction >>

Direction possible value(s) are, sender,receiver

Filled in for CMode CLI

=item C<< last_message_type >>

Last Message Type possible value(s) are, baseline,marker,update

Filled in for CMode CLI

=item C<< synopsis >>

Synopsis

Filled in for CMode CLI

=item C<< last_heartbeat_timestamp >>

Time Stamp of Last Heartbeat

Filled in for CMode CLI

=item C<< ecv_reciprocal >>

Effective Cluster Version of Reciprocal

Filled in for CMode CLI

=back

=cut

package NACL::CS::DebugCrsStreamOperationalShowSummaryStats;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'ecv',
    scalar => 'stream_uuid',
    scalar => 'oper_state_reciprocal',
    scalar => 'last_message_timestamp',
    scalar => 'oper_state',
    scalar => 'direction',
    scalar => 'last_message_type',
    scalar => 'synopsis',
    scalar => 'last_heartbeat_timestamp',
    scalar => 'ecv_reciprocal',
];

=head1 METHODS

=head2 fetch

    my $DebugCrsStreamOperationalShowSummaryStats_state  = NACL::CS::DebugCrsStreamOperationalShowSummaryStats->fetch(command_interface => $ci, ...);
	my @DebugCrsStreamOperationalShowSummaryStats_states = NACL::CS::DebugCrsStreamOperationalShowSummaryStats->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug crs stream operational show-summary-stats',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug crs stream operational(s) found',
        frontend =>
            'NACL::CS::DebugCrsStreamOperationalShowSummaryStats::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_crs_stream_operational_show_summary_stats',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
