# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsStreamSummary ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCrsStreamSummary

=head1 DESCRIPTION

C<NACL::CS::DebugCrsStreamSummary> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugCrsStreamSummary.  A related class is
L<NACL::C::DebugCrsStreamSummary|lib-NACL-C-DebugCrsStreamSummary-pm>, which represents access
to an ONTAP DebugCrsStreamSummary.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugCrsStreamSummary
element are the attributes of the DebugCrsStreamSummary ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< last_error_count_reciprocal >>

Reciprocal Last Error Count

Filled in for CMode CLI

=item C<< stream_uuid >>

Stream Uuid

Filled in for CMode CLI

=item C<< last_seq_num_dequeued >>

Last Sequence Number Dequeued

Filled in for CMode CLI

=item C<< oper_state_reciprocal >>


Reciprocal Operational State possible value(s) are, up,down,paused,in-error,not-created,unknown,misconfigured

Filled in for CMode CLI

=item C<< last_error_count >>

Last Error Count

Filled in for CMode CLI

=item C<< last_seq_num_queued_reciprocal >>

Reciprocal Last Sequence Number Queued

Filled in for CMode CLI

=item C<< last_seq_num_dequeued_reciprocal >>

Reciprocal Last Sequence Number Dequeued

Filled in for CMode CLI

=item C<< last_seq_num_queued >>

Last Sequence Number Queued

Filled in for CMode CLI

=item C<< oper_state >>


Operational State possible value(s) are, up,down,paused,in-error,not-created,unknown,misconfigured

Filled in for CMode CLI

=item C<< percent_full >>

Queue Percent Full

Filled in for CMode CLI

=item C<< direction >>

Direction possible value(s) are, sender,receiver

Filled in for CMode CLI

=item C<< percent_full_reciprocal >>

Reciprocal Queue Percent Full

Filled in for CMode CLI

=item C<< direction_reciprocal >>

Reciprocal Direction possible value(s) are, sender,receiver

Filled in for CMode CLI

=back

=cut

package NACL::CS::DebugCrsStreamSummary;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'last_error_count_reciprocal',
    scalar => 'stream_uuid',
    scalar => 'last_seq_num_dequeued',
    scalar => 'oper_state_reciprocal',
    scalar => 'last_error_count',
    scalar => 'last_seq_num_queued_reciprocal',
    scalar => 'last_seq_num_dequeued_reciprocal',
    scalar => 'last_seq_num_queued',
    scalar => 'oper_state',
    scalar => 'percent_full',
    scalar => 'direction',
    scalar => 'percent_full_reciprocal',
    scalar => 'direction_reciprocal',
];

=head1 METHODS

=head2 fetch

    my $DebugCrsStreamSummary_state  = NACL::CS::DebugCrsStreamSummary->fetch(command_interface => $ci, ...);
	my @DebugCrsStreamSummary_states = NACL::CS::DebugCrsStreamSummary->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug crs stream-summary show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug crs stream-summary(s) found',
        frontend       => 'NACL::CS::DebugCrsStreamSummary::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_crs_stream_summary_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
