# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsTestView ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCrsTestView

=head1 DESCRIPTION

C<NACL::CS::DebugCrsTestView> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugCrsTestView.  A related class is
L<NACL::C::DebugCrsTestView|lib-NACL-C-DebugCrsTestView-pm>, which represents access
to an ONTAP DebugCrsTestView.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugCrsTestView
element are the attributes of the DebugCrsTestView ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< owner >>

The table that owns it

Filled in for CMode CLI

=item C<< value_2 >>

Value 2

Filled in for CMode CLI

=item C<< vserver >>

Vserver

Filled in for CMode CLI

=item C<< name >>

Test Name

Filled in for CMode CLI

=item C<< value_1 >>

Value 1

Filled in for CMode CLI

=item C<< node >>

Node possible value(s) are, <nodename>,local

Filled in for CMode CLI

=item C<< value_4 >>

Value 4

Filled in for CMode CLI

=item C<< value_3 >>

Value 3

Filled in for CMode CLI

=back

=cut

package NACL::CS::DebugCrsTestView;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'owner',
    scalar => 'value_2',
    scalar => 'vserver',
    scalar => 'name',
    scalar => 'value_1',
    scalar => 'node',
    scalar => 'value_4',
    scalar => 'value_3',
];

=head1 METHODS

=head2 fetch

    my $DebugCrsTestView_state  = NACL::CS::DebugCrsTestView->fetch(command_interface => $ci, ...);
	my @DebugCrsTestView_states = NACL::CS::DebugCrsTestView->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug crs test-view show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug crs test-view(s) found',
        frontend       => 'NACL::CS::DebugCrsTestView::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_crs_test_view_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
