# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::DebugCsmCache->blade_ip_map_v4() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCsmCacheBladeIpMapV4

=head1 DESCRIPTION

C<NACL::CS::DebugCsmCacheBladeIpMapV4> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::DebugCsmCache->blade_ip_map_v4() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::DebugCsmCache->blade_ip_map_v4() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< blade_type >>

Blade Type

Filled in for CMode CLI

=item C<< lif_role >>

LIF Role

Filled in for CMode CLI

=item C<< cluster_id >>

Cluster ID

Filled in for CMode CLI

=item C<< hostname >>

Blade Host Name

Filled in for CMode CLI

=item C<< blade_id >>

Blade ID

Filled in for CMode CLI

=item C<< node >>

Node Name possible value(s) are, <nodename>,local

Filled in for CMode CLI

=item C<< ipaddress >>

IP Addresses

Filled in for CMode CLI

=back

=cut

package NACL::CS::DebugCsmCacheBladeIpMapV4;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'blade_type',
    scalar => 'lif_role',
    scalar => 'cluster_id',
    scalar => 'hostname',
    scalar => 'blade_id',
    scalar => 'node',
    scalar => 'ipaddress',
];

=head1 METHODS

=head2 fetch

    my $DebugCsmCacheBladeIpMapV4_state  = NACL::CS::DebugCsmCacheBladeIpMapV4->fetch(command_interface => $ci, ...);
	my @DebugCsmCacheBladeIpMapV4_states = NACL::CS::DebugCsmCacheBladeIpMapV4->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug csm cache blade-ip-map-v4',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug csm cache(s) found',
        frontend       => 'NACL::CS::DebugCsmCacheBladeIpMapV4::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_csm_cache_blade_ip_map_v4',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
