#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCsmCt ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCsmCt

=head1 DESCRIPTION

C<NACL::CS::DebugCsmCt> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugCsmCt.  A related class is
L<NACL::C::DebugCsmCt|lib-NACL-C-DebugCsmCt-pm>, which represents access
to an ONTAP DebugCsmCt.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugCsmCt
element are the attributes of the DebugCsmCt ComponentState.

=over

=item C<< priority >>

Filled in for CMode CLI.

=item C<< connection >>

Filled in for CMode CLI.

=item C<< uniquifier >>

Filled in for CMode CLI.

=item C<< node >>

Filled in for CMode CLI.

=item C<< messages_received >>

Filled in for CMode CLI.

=item C<< state >>

Filled in for CMode CLI.

=item C<< force_remote_closed >>

Filled in for CMode CLI.

=item C<< loremote_closed >>

Filled in for CMode CLI.

=item C<< local_closed >>

Filled in for CMode CLI.

=item C<< closed >>

Filled in for CMode CLI.

=item C<< messages_upcalled >>

Filled in for CMode CLI.

=item C<< messages_sent >>

Filled in for CMode CLI.

=item C<< error_code >>

Filled in for CMode CLI.

=item C<< remote_closed >>

Filled in for CMode CLI.

=item C<< opened >>

Filled in for CMode CLI.

=item C<< loerror_code >>

Filled in for CMode CLI.

=item C<< type >>

Filled in for CMode CLI.

=item C<< cid >>

Filled in for CMode CLI.

=item C<< lolocal_closed >>

Filled in for CMode CLI.

=item C<< next_sequence_number >>

Next Sequence Number

Filled in for CMode CLI.

=item C<< deferred_queue_drain >>

Number of Deferred Queue Drain

Filled in for CMode CLI.

=item C<< rcv_cons_called_after_rcv >>

Was RcvConsume Called After Rcv possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< deferred_queue_insert >>

Number of Deferred Queue Insert

Filled in for CMode CLI.

=item C<< send_active >>

Send Active possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< retry_send >>

Retry Send possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< num_deferred_queue_discard >>

Number of Deferred Queue Discard

Filled in for CMode CLI.

=item C<< vifid >>

Vif ID

Filled in for CMode CLI.

=item C<< msg_type_tag >>

Message Type Tag possible value(s) are, request,response,null

Filled in for CMode CLI.

=item C<< last_snd_time_ms >>

Last Send Time in Milliseconds

Filled in for CMode CLI.

=item C<< channel_number >>

Channel Number

Filled in for CMode CLI.

=item C<< last_rcv_consume_time_ms >>

Last Recieve Time in Milliseconds

Filled in for CMode CLI.


=item C<< authenticated >>


Whether the Connection is Authenticated possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< local_port >>

Local Port Number

Filled in for CMode CLI.

=item C<< netaddress >>

IPv4 Address

Filled in for CMode CLI.

=item C<< cluster >>

Remote Cluster ID

Filled in for CMode CLI.


=item C<< position >>

Pointer Position

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DebugCsmCt;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'priority',
    scalar => 'connection',
    scalar => 'uniquifier',
    scalar => 'node',
    scalar => 'messages_received',
    scalar => 'state',
    scalar => 'force_remote_closed',
    scalar => 'loremote_closed',
    scalar => 'local_closed',
    scalar => 'closed',
    scalar => 'messages_upcalled',
    scalar => 'messages_sent',
    scalar => 'error_code',
    scalar => 'remote_closed',
    scalar => 'opened',
    scalar => 'loerror_code',
    scalar => 'type',
    scalar => 'cid',
    scalar => 'lolocal_closed',
    scalar => 'next_sequence_number',
    scalar => 'deferred_queue_drain',
    scalar => 'rcv_cons_called_after_rcv',
    scalar => 'deferred_queue_insert',
    scalar => 'send_active',
    scalar => 'retry_send',
    scalar => 'num_deferred_queue_discard',
    scalar => 'vifid',
    scalar => 'msg_type_tag',
    scalar => 'last_snd_time_ms',
    scalar => 'channel_number',
    scalar => 'last_rcv_consume_time_ms',
    scalar => 'authenticated',
    scalar => 'local_port',
    scalar => 'netaddress',
    scalar => 'cluster',
    scalar => 'position',
];

=head1 METHODS

=head2 fetch

    my $DebugCsmCt_state   = NACL::CS::DebugCsmCt->fetch(command_interface => $ci, ...);
	my @DebugCsmCt_states = NACL::CS::DebugCsmCt->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'debug csm ct show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching debug csm ct(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@_, api => 'debug_csm_ct_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
