#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCsmNulltx ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCsmNulltx

=head1 DESCRIPTION

C<NACL::CS::DebugCsmNulltx> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugCsmNulltx.  A related class is
L<NACL::C::DebugCsmNulltx|lib-NACL-C-DebugCsmNulltx-pm>, which represents access
to an ONTAP DebugCsmNulltx.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugCsmNulltx
element are the attributes of the DebugCsmNulltx ComponentState.

=over

=item C<< priority >>

Filled in for CMode CLI.

=item C<< backpressure_count >>

Filled in for CMode CLI.

=item C<< connection >>

Filled in for CMode CLI.

=item C<< uniquifier >>

Filled in for CMode CLI.

=item C<< deferred_queue_drain >>

Filled in for CMode CLI.

=item C<< node >>

Filled in for CMode CLI.

=item C<< queue_length >>

Filled in for CMode CLI.

=item C<< deferred_queue_insert >>

Filled in for CMode CLI.

=item C<< outbound_pkts >>

Filled in for CMode CLI.

=item C<< allow_callthru >>

Filled in for CMode CLI.

=item C<< callthru_send_ops >>

Filled in for CMode CLI.

=item C<< snd_ops >>

Filled in for CMode CLI.

=item C<< sender_blocked >>

Filled in for CMode CLI.

=item C<< local_closed >>

Filled in for CMode CLI.

=item C<< rcv_ops >>

Filled in for CMode CLI.

=item C<< max_queue_len >>

Filled in for CMode CLI.

=item C<< callthru_rcv_ops >>

Filled in for CMode CLI.

=item C<< pkts_in_flight >>

Filled in for CMode CLI.

=item C<< window_size >>

Filled in for CMode CLI.

=item C<< type >>

Filled in for CMode CLI.

=item C<< next_sequence_number >>

Next Sequence Number

Filled in for CMode CLI.

=item C<< rcv_cons_called_after_rcv >>

Was RcvConsume Called After Rcv possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< send_active >>

Send Active possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< retry_send >>

Retry Send possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< num_deferred_queue_discard >>

Number of Deferred Queue Discard

Filled in for CMode CLI.

=item C<< msg_type_tag >>

Message Type Tag possible value(s) are, request,response,null

Filled in for CMode CLI.

=item C<< last_snd_time_ms >>

Last Send Time in Milliseconds

Filled in for CMode CLI.

=item C<< channel_number >>

Channel Number

Filled in for CMode CLI.

=item C<< last_rcv_consume_time_ms >>

Last Recieve Time in Milliseconds

Filled in for CMode CLI.


=item C<< position >>

Pointer Position

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DebugCsmNulltx;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'priority',
    scalar => 'backpressure_count',
    scalar => 'connection',
    scalar => 'uniquifier',
    scalar => 'deferred_queue_drain',
    scalar => 'node',
    scalar => 'queue_length',
    scalar => 'deferred_queue_insert',
    scalar => 'outbound_pkts',
    scalar => 'allow_callthru',
    scalar => 'callthru_send_ops',
    scalar => 'snd_ops',
    scalar => 'sender_blocked',
    scalar => 'local_closed',
    scalar => 'rcv_ops',
    scalar => 'max_queue_len',
    scalar => 'callthru_rcv_ops',
    scalar => 'pkts_in_flight',
    scalar => 'window_size',
    scalar => 'type',
    scalar => 'next_sequence_number',
    scalar => 'rcv_cons_called_after_rcv',
    scalar => 'send_active',
    scalar => 'retry_send',
    scalar => 'num_deferred_queue_discard',
    scalar => 'msg_type_tag',
    scalar => 'last_snd_time_ms',
    scalar => 'channel_number',
    scalar => 'last_rcv_consume_time_ms',
    scalar => 'position',
];

=head1 METHODS

=head2 fetch

    my $DebugCsmNulltx_state   = NACL::CS::DebugCsmNulltx->fetch(command_interface => $ci, ...);
	my @DebugCsmNulltx_states = NACL::CS::DebugCsmNulltx->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'debug csm nulltx show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching debug csm nulltx(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@_, api => 'debug_csm_nulltx_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
