# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::DebugCsmSession->status() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCsmSessionStatus

=head1 DESCRIPTION

C<NACL::CS::DebugCsmSessionStatus> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::DebugCsmSession->status() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::DebugCsmSession->status() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< ui_req_id >>

Filled in for CMode CLI.

=item C<< sub_req_id >>

Filled in for CMode CLI.

=item C<< uniquifier >>

Filled in for CMode CLI.

=item C<< clear_completed >>

Filled in for CMode CLI.

=item C<< end_time >>

Filled in for CMode CLI.

=item C<< node >>

Filled in for CMode CLI.

=item C<< end_cycle >>

Filled in for CMode CLI.

=item C<< delta_time_micros >>

Filled in for CMode CLI.

=item C<< start_cycle >>

Filled in for CMode CLI.

=item C<< start_time >>

Filled in for CMode CLI.

=item C<< action >>

Filled in for CMode CLI.

=item C<< req_status >>

Filled in for CMode CLI.

=item C<< result >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::DebugCsmSessionStatus;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'ui_req_id',
    scalar => 'sub_req_id',
    scalar => 'uniquifier',
    scalar => 'clear_completed',
    scalar => 'end_time',
    scalar => 'node',
    scalar => 'end_cycle',
    scalar => 'delta_time_micros',
    scalar => 'start_cycle',
    scalar => 'start_time',
    scalar => 'action',
    scalar => 'req_status',
    scalar => 'result',
];

=head1 METHODS

=head2 fetch

    my $DebugCsmSessionStatus_state  = NACL::CS::DebugCsmSessionStatus->fetch(command_interface => $ci, ...);
	my @DebugCsmSessionStatus_states = NACL::CS::DebugCsmSessionStatus->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut


sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'debug csm session status',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug csm session(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(
        @_,
        api => 'debug_csm_session_status',

    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
