# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugDmVserverQueue ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugDmVserverQueue

=head1 DESCRIPTION

C<NACL::CS::DebugDmVserverQueue> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugDmVserverQueue.  A related class is
L<NACL::C::DebugDmVserverQueue|lib-NACL-C-DebugDmVserverQueue-pm>, which represents access
to an ONTAP DebugDmVserverQueue.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugDmVserverQueue
element are the attributes of the DebugDmVserverQueue ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< request >>


Request possible value(s) are, abort , apply-baseline-till-baseline-marker , apply-baseline-till-sync-marker , apply-manual-baseline , apply-manual-rebaseline , apply-manual-update , apply-till-seq-id , apply-till-sync-marker , apply-update-till-seq-id , apply-update-till-sync-marker , generate-baseline , generate-local-baseline , generate-flip-rebaseline , generate-rebaseline , insert-marker , peek-and-apply , process-backlog

Filled in for CMode CLI

=item C<< stream_uuid >>

Stream UUID

Filled in for CMode CLI

=item C<< object_op_list >>

Object Operation List
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $object_op_list = $obj->object_op_list();
 
# $object_op_list contains a reference to the array of values
 
my @object_op_list = $obj->object_op_list();
 
# @object_op_list contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { object_op_list = [ value1, value2...] }

Filled in for CMode CLI

=item C<< index_in_queue >>

Index In Queue

Filled in for CMode CLI

=item C<< in_run_queue >>

In Run Queue possible value(s) are, true,false

Filled in for CMode CLI

=item C<< msg_seq_id >>

Message Sequence Id

Filled in for CMode CLI

=item C<< marker_tag >>

Marker Tag

Filled in for CMode CLI

=item C<< direction >>

Direction possible value(s) are, sender,receiver

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DebugDmVserverQueue;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'request',
    scalar => 'stream_uuid',
    array  => 'object_op_list',
    scalar => 'index_in_queue',
    scalar => 'in_run_queue',
    scalar => 'msg_seq_id',
    scalar => 'marker_tag',
    scalar => 'direction',
];

=head1 METHODS

=head2 fetch

    my $DebugDmVserverQueue_state  = NACL::CS::DebugDmVserverQueue->fetch(command_interface => $ci, ...);
	my @DebugDmVserverQueue_states = NACL::CS::DebugDmVserverQueue->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug dm vserver queue show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug dm vserver queue(s) found',
        frontend       => 'NACL::CS::DebugDmVserverQueue::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_dm_vserver_queue_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
