# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugLocksMirrored ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugLocksMirrored

=head1 DESCRIPTION

C<NACL::CS::DebugLocksMirrored> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugLocksMirrored.  A related class is
L<NACL::C::DebugLocksMirrored|lib-NACL-C-DebugLocksMirrored-pm>, which represents access
to an ONTAP DebugLocksMirrored.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugLocksMirrored
element are the attributes of the DebugLocksMirrored ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< protocol >>

*Lock Protocol, possible value(s) are cifs,nfsv4,nlm,fcache,nfsv4.1

Filled in for CMode CLI.

=item C<< smb2_expiration_time >>

*SMB2 Expiration Time (Secs)

Filled in for CMode CLI.

=item C<< smb2_open_type >>

*SMB2 Open Type, possible value(s) are none,durable

Filled in for CMode CLI.

=item C<< file_id >>

*File Identifier

Filled in for CMode CLI.

=item C<< node >>

*Node Holding Lock State

Filled in for CMode CLI.

=item C<< sharelock_mode >>

*Shared Lock Access Mode

Filled in for CMode CLI.

=item C<< bytelock_offset >>

*Bytelock Starting Offset

Filled in for CMode CLI.

=item C<< smb2_connect_state >>

*SMB2 Connect State

Filled in for CMode CLI.

=item C<< bytelock_length >>

*Number of Bytes Locked

Filled in for CMode CLI.

=item C<< sharelock_soft >>

*Shared Lock is Soft, possible value(s) are true,false

Filled in for CMode CLI.

=item C<< oplock_level >>

*Oplock Level, possible value(s) are exclusive,level2,batch,null,read-batch

Filled in for CMode CLI.

=item C<< bytelock_exclusive >>

*Bytelock is Exclusive, possible value(s) are true,false

Filled in for CMode CLI.

=item C<< lif_name >>

*Interface Name

Filled in for CMode CLI.

=item C<< sharelock_super >>

*Shared Lock is Superlock, possible value(s) are true,false

Filled in for CMode CLI.

=item C<< bytelock_soft >>

*Bytelock is Soft, possible value(s) are true,false

Filled in for CMode CLI.

=item C<< volume >>

*Volume Name

Filled in for CMode CLI.

=item C<< vserver >>

*Vserver

Filled in for CMode CLI.

=item C<< client_id >>

*Client ID

Filled in for CMode CLI.

=item C<< vif_name >>


Filled in for CMode CLI.

=item C<< lock_state >>

*Lock State

Filled in for CMode CLI.

=item C<< smb2_open_group_id >>

*SMB2 Open Group ID

Filled in for CMode CLI.

=item C<< bytelock_super >>

*Bytelock is Superlock, possible value(s) are true,false

Filled in for CMode CLI.

=item C<< lockid >>

*Lock UUID

Filled in for CMode CLI.

=item C<< owner_id >>

*Owner ID

Filled in for CMode CLI.

=item C<< vif >>

Filled in for CMode CLI.

=item C<< type >>

*Lock Type, possible value(s) are byte-range,share-level,op-lock,delegation

Filled in for CMode CLI.

=item C<< lif >>

Filled in for CMode CLI.

=item C<< bytelock_mandatory >>

*Bytelock is Mandatory, possible value(s) are true,false

Filled in for CMode CLI.

=item C<< client_address >>

*Client Address

Filled in for CMode CLI.

=item C<< smb_connect_state >>

SMB Connect State possible value(s) are, Lock Connect State

Filled in for CMode CLI.

=item C<< smb_open_type >>

SMB Open Type possible value(s) are, none,durable,persistent

Filled in for CMode CLI.

=item C<< smb_open_group_id >>

SMB Open Group ID possible value(s) are, text

Filled in for CMode CLI.

=item C<< nodename >>

Node Holding Lock State possible value(s) are, nodename

Filled in for CMode CLI.

=item C<< smb_expiration_time >>

SMB Expiration Time (Secs) possible value(s) are, integer

Filled in for CMode CLI.

=item C<< generation >>

File Generation possible value(s) are, integer

Filled in for CMode CLI.

=item C<< lock_index >>

Lock Index Number

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DebugLocksMirrored;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'protocol',
    scalar => 'smb2_expiration_time',
    scalar => 'smb2_open_type',
    scalar => 'file_id',
    scalar => 'node',
    scalar => 'sharelock_mode',
    scalar => 'bytelock_offset',
    scalar => 'smb2_connect_state',
    scalar => 'bytelock_length',
    scalar => 'sharelock_soft',
    scalar => 'oplock_level',
    scalar => 'bytelock_exclusive',
    scalar => 'lif_name',
    scalar => 'sharelock_super',
    scalar => 'bytelock_soft',
    scalar => 'volume',
    scalar => 'vserver',
    scalar => 'client_id',
    scalar => 'vif_name',
    scalar => 'lock_state',
    scalar => 'smb2_open_group_id',
    scalar => 'bytelock_super',
    scalar => 'lockid',
    scalar => 'owner_id',
    scalar => 'vif',
    scalar => 'type',
    scalar => 'lif',
    scalar => 'bytelock_mandatory',
    scalar => 'client_address',
    scalar => 'smb_connect_state',
    scalar => 'smb_open_type',
    scalar => 'smb_open_group_id',
    scalar => 'nodename',
    scalar => 'smb_expiration_time',
    scalar => 'generation',
    scalar => 'lock_index',
];

=head1 METHODS

=head2 fetch

    my $DebugLocksMirrored_state  = NACL::CS::DebugLocksMirrored->fetch(command_interface => $ci, ...);
	my @DebugLocksMirrored_states = NACL::CS::DebugLocksMirrored->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'debug locks mirrored show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug locks mirrored(s) found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'debug_locks_mirrored_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
