# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugSmdb ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugSmdb

=head1 DESCRIPTION

C<NACL::CS::DebugSmdb> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugSmdb.  A related class is
L<NACL::C::DebugSmdb|lib-NACL-C-DebugSmdb-pm>, which represents access
to an ONTAP DebugSmdb.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugSmdb
element are the attributes of the DebugSmdb ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< next_error >>

next() error possible value(s) are, integer

Filled in for CMode CLI.

=item C<< tracing >>

smf iterator tracing possible value(s) are, yes,no

Filled in for CMode CLI.

=item C<< testmode >>

table test mode possible value(s) are, yes,no

Filled in for CMode CLI.

=item C<< table >>

Table Name possible value(s) are, text

Filled in for CMode CLI.

=item C<< modify_error >>

modify() error possible value(s) are, integer

Filled in for CMode CLI.

=item C<< remove_error >>

remove() error possible value(s) are, integer

Filled in for CMode CLI.

=item C<< send_to >>

Logging Destination possible value(s) are, file,user,both

Filled in for CMode CLI.

=item C<< create_error >>

create() error possible value(s) are, integer

Filled in for CMode CLI.

=item C<< postop_error >>

postop() error possible value(s) are, integer

Filled in for CMode CLI.

=item C<< testmode_copy >>

copy normal for testmode possible value(s) are, yes,no

Filled in for CMode CLI.

=item C<< nextseq_error >>

nextseq() error possible value(s) are, integer

Filled in for CMode CLI.

=item C<< action >>

Debugging Options possible value(s) are, none,app,imp,both

Filled in for CMode CLI.

=item C<< testmode_local >>

force local access possible value(s) are, yes,no

Filled in for CMode CLI.

=item C<< get_error >>

get() error possible value(s) are, integer

Filled in for CMode CLI.

=item C<< other_error >>

app-specific error possible value(s) are, integer

Filled in for CMode CLI.

=item C<< smf_trace >>

SMF Iterator Tracing possible value(s) are, yes,no,auto

Filled in for CMode CLI.

=item C<< trace_threshold >>

Trace Threshold (secs) ranges from 0 to 255

Filled in for CMode CLI.


=item C<< dsmf_max_in_int_prio >>

DSMF Max in Intermediate Priority Queue ranges from 0 to 255

Filled in for CMode CLI.

=item C<< dsmf_max_in_high_prio >>

SMF Max in High Priority Queue ranges from 0 to 255

Filled in for CMode CLI.

=item C<< dsmf_max_active_thresh >>

DSMF Max Active Threshold ranges from 0 to 255

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DebugSmdb;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'next_error',
    scalar => 'tracing',
    scalar => 'testmode',
    scalar => 'table',
    scalar => 'modify_error',
    scalar => 'remove_error',
    scalar => 'send_to',
    scalar => 'create_error',
    scalar => 'postop_error',
    scalar => 'testmode_copy',
    scalar => 'nextseq_error',
    scalar => 'action',
    scalar => 'testmode_local',
    scalar => 'get_error',
    scalar => 'other_error',
    scalar => 'smf_trace',
    scalar => 'trace_threshold',
    scalar => 'dsmf_max_in_int_prio',
    scalar => 'dsmf_max_in_high_prio',
    scalar => 'dsmf_max_active_thresh',
];

=head1 METHODS

=head2 fetch

    my $DebugSmdb_state  = NACL::CS::DebugSmdb->fetch(command_interface => $ci, ...);
	my @DebugSmdb_states = NACL::CS::DebugSmdb->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug smdb show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug smdb(s) found',
        frontend       => 'NACL::CS::DebugSmdb::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@args, api => 'debug_smdb_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
