# $Id: //depot/prod/test/nacldev/lib/NACL/CS/DiagSecdAuthenticationTranslate.pm#1 $

#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DiagSecdAuthenticationTranslate ComponentState Module
## @author jais@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DiagSecdAuthenticationTranslate

=head1 DESCRIPTION

This module does not represent the state of any element, but is an object
representation of the output of Diag Secd Authentication

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the DiagSecdAuthenticationTranslate
element are the attributes of the DiagSecdAuthenticationTranslate ComponentState.

=over

=item C<< vserver >>

Filled in for CMode CLI.

=item C<< node >>

Filled in for CMode CLI.

=item C<< sid >>

Filled in for CMode CLI.

=item C<< gid >>

Filled in for CMode CLI.

=item C<< uid >>

Filled in for CMode CLI.

=item C<< unix_user_name >>

Filled in for CMode CLI.

=item C<< unix_group_name >>

Filled in for CMode CLI.

=item C<< win_name >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::DiagSecdAuthenticationTranslate;

use strict;
use warnings;
use base qw(NACL::CS::ComponentState::ONTAP);
use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'node',
    scalar => 'sid',
    scalar => 'gid',
    scalar => 'uid',
    scalar => 'unix_user_name',
    scalar => 'unix_group_name',
    scalar => 'win_name',
];

1;
