#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DiagSecdLog ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DiagSecdLog

=head1 DESCRIPTION

C<NACL::CS::DiagSecdLog> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DiagSecdLog.  A related class is
L<NACL::C::DiagSecdLog|lib-NACL-C-DiagSecdLog-pm>, which represents access
to an ONTAP DiagSecdLog.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the DiagSecdLog
element are the attributes of the DiagSecdLog ComponentState.

=over

=item C<< node >>

Filled in for CMode CLI.

=item C<< log_level >>

Filled in for CMode CLI.

=item C<< function_enter_exit_logging >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::DiagSecdLog;

use strict;
use warnings;
use Params::Validate qw(validate_with HASHREF);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'node',
    scalar => 'log_level',
    scalar => 'function_enter_exit_logging',
];

=head1 METHODS

=head2 fetch

    my $DiagSecdLog_state   = NACL::CS::DiagSecdLog->fetch(command_interface => $ci, ...);
	my @DiagSecdLog_states = NACL::CS::DiagSecdLog->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs   = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'diag secd log show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching diag secd log(s) found',
        is_singleton   => 1
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'diag_secd_log_show', is_singleton => 1);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

# Even though it's a singleton table, filter->{node} should be sent down to the
# command.
sub _compute_cmode_cli_options {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = validate_with(
        params      => \@args,
        spec        => {filter => {type => HASHREF}},
        allow_extra => 1
    );

    my $api_opts = $pkg->SUPER::_compute_cmode_cli_options(%opts);
    if (exists $opts{filter}->{node}) {
        $api_opts->{node} = $opts{filter}->{node};
    }
    $Log->exit() if $may_exit;
    return $api_opts;
}

1;
