# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::LunMove->show_by_job_info() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::LunMoveShowByJobInfo

=head1 DESCRIPTION

C<NACL::CS::LunMoveShowByJobInfo> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::LunMove->show_by_job_info() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::LunMove->show_by_job_info() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over


=item C<< scanner_total >>

LUN Move Total
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info scanner-total="$value" />


=item C<< job_status >>


LUN Move Status possible value(s) are, Preparing,Allocation-Map,Data,Destroying,Paused-Admin,Paused-Error,Complete,Destroyed
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info job-status="$value" />


=item C<< source_vserver >>

Source Vserver
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-copy-info source-vserver="$value" />


=item C<< source_snapshot_instance_uuid >>

Source Snapshot Instance UUID
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-copy-info source-snapshot-instance-uuid="$value" />


=item C<< lun_index >>

LUN Index
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info lun-index="$value" />


=item C<< source_snapshot >>

Source Snapshot Name
Filled in for CMode CLI/ZAPI iter

=item C<< last_failure_reason >>

Last Failure Reason
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info last-failure-reason="$value" />


=item C<< destination_path >>

Destination Path
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info destination-path="$value" />


=item C<< job_uuid >>

LUN Move Job UUID
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info job-uuid="$value" />


=item C<< is_snapshot_fenced >>

Is Snapshot Fenced possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info is-snapshot-fenced="$value" />


=item C<< cutover_time >>

Cutover Time
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info cutover-time="$value" />


=item C<< max_throughput >>

Maximum Transfer Rate (per sec)
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info max-throughput="$value" />


=item C<< progress_percent >>

LUN Move Progress (%)
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info progress-percent="$value" />


=item C<< vserver >>

Vserver Name
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info vserver="$value" />


=item C<< source_snapshot_id >>

Source Snapshot ID
Filled in for CMode CLI/ZAPI iter

=item C<< elapsed_time >>

Elapsed Time
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info elapsed-time="$value" />


=item C<< is_destination_ready >>

Is Destination Ready possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info is-destination-ready="$value" />

=item C<< node >>

Destination Node possible value(s) are, <nodename>,local
Filled in for CMode CLI.

=item C<< dest_node >>

Destination Node
Filled in for CMode CLI/ZAPI iter

=item C<< is_promoted_late >>

Is Destination Promoted Late possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info is-promoted-late="$value" />


=item C<< scanner_progress >>

LUN Move Progress
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info scanner-progress="$value" />


=item C<< source_path >>

Source Path
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <lun-move-info source-path="$value" />

=back

=cut

package NACL::CS::LunMoveShowByJobInfo;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'scanner_total',
    scalar => 'job_status',
    scalar => 'source_vserver',
    scalar => 'source_snapshot_instance_uuid',
    scalar => 'lun_index',
    scalar => 'source_snapshot',
    scalar => 'last_failure_reason',
    scalar => 'destination_path',
    scalar => 'job_uuid',
    scalar => 'is_snapshot_fenced',
    scalar => 'cutover_time',
    scalar => 'max_throughput',
    scalar => 'progress_percent',
    scalar => 'vserver',
    scalar => 'source_snapshot_id',
    scalar => 'elapsed_time',
    scalar => 'is_destination_ready',
    scalar => 'dest_node',
    scalar => 'is_promoted_late',
    scalar => 'scanner_progress',
    scalar => 'source_path',
    scalar => 'node',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 fetch

    my $LunMoveShowByJobInfo_state  = NACL::CS::LunMoveShowByJobInfo->fetch(command_interface => $ci, ...);
	my @LunMoveShowByJobInfo_states = NACL::CS::LunMoveShowByJobInfo->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes lun-move-get-iter API for CMode ZAPI iter.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        show_cmd => 'lun move show-by-job-info',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'iter'
            },

        ],
        exception_text => 'No matching LunMoveShowByJobInfo(s) found',
        frontend       => 'NACL::CS::LunMoveShowByJobInfo::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'lun_move_show_by_job_info',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(scanner-total source-vserver job-uuid scanner-progress lun-index
                is-snapshot-fenced max-throughput is-destination-ready source-path
                source-snapshot-instance-uuid last-failure-reason destination-path
                cutover-time progress-percent job-status vserver elapsed-time
                is-promoted-late
                )
        ],
        api => "lun-move-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
