# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary LunTransition7Mode ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::LunTransition7Mode

=head1 DESCRIPTION

C<NACL::CS::LunTransition7Mode> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP LunTransition7Mode.  A related class is
L<NACL::C::LunTransition7Mode|lib-NACL-C-LunTransition7Mode-pm>, which represents access
to an ONTAP LunTransition7Mode.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the LunTransition7Mode
element are the attributes of the LunTransition7Mode ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< volume >>

Volume Name

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info volume="$value" />



=item C<< serial >>

Serial Number

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info serial="$value" />



=item C<< suffix_size >>

Suffix Stream Size

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info suffix-size="$value" />



=item C<< vserver >>

Vserver Name

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info vserver="$value" />



=item C<< path >>

LUN Path

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info path="$value" />



=item C<< serial_7_mode >>

7-mode Serial Number

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info serial-7-mode="$value" />



=item C<< uuid >>

UUID

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info uuid="$value" />



=item C<< node >>

Node

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info node="$value" />



=item C<< volume_dsid >>

Volume DSID

Filled in for CMode CLI.

=item C<< prefix_size >>

Prefix Stream Size

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info prefix-size="$value" />



=item C<< size >>

LUN Size

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info size="$value" />



=item C<< base_size >>

Base Stream Size

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info base-size="$value" />



=item C<< ostype >>

OS Type

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info ostype="$value" />



=item C<< vserver_uuid >>

Vserver UUID

Filled in for CMode CLI.

=item C<< is_transitioned >>

Transition Complete possible value(s) are, true,false

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lun-transition-7mode-info is-transitioned="$value" />



=item C<< volume_msid >>

Volume MSID

Filled in for CMode CLI.

=back

=cut

package NACL::CS::LunTransition7Mode;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'volume',
    scalar => 'serial',
    scalar => 'suffix_size',
    scalar => 'vserver',
    scalar => 'path',
    scalar => 'serial_7_mode',
    scalar => 'uuid',
    scalar => 'node',
    scalar => 'volume_dsid',
    scalar => 'prefix_size',
    scalar => 'size',
    scalar => 'base_size',
    scalar => 'ostype',
    scalar => 'vserver_uuid',
    scalar => 'is_transitioned',
    scalar => 'volume_msid',
];

=head1 METHODS

=head2 fetch

    my $LunTransition7Mode_state  = NACL::CS::LunTransition7Mode->fetch(command_interface => $ci, ...);
	my @LunTransition7Mode_states = NACL::CS::LunTransition7Mode->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes lun-transition-7mode-get-iter API for CMode ZAPI.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
        ],
        show_cmd => 'lun transition 7-mode show',
	exception_text => 'No matching lun transition 7-mode(s) found',
        frontend       => 'NACL::CS::LunTransition7Mode::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'lun_transition_7_mode_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(volume vserver suffix-size serial serial-7-mode path node uuid size prefix-size
                ostype base-size is-transitioned
                )
        ],
        api => "lun-transition-7mode-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
