# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::MetroclusterVserverSwitchoverLatency->show_details_per_vserver() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::MetroclusterVserverSwitchoverLatencyShowDetailsPerVserver

=head1 DESCRIPTION

C<NACL::CS::MetroclusterVserverSwitchoverLatencyShowDetailsPerVserver> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::MetroclusterVserverSwitchoverLatency->show_details_per_vserver() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::MetroclusterVserverSwitchoverLatency->show_details_per_vserver() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< protocol_times >>

Protocol start times
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $protocol_times = $obj->protocol_times();
 
# $protocol_times contains a reference to the array of values
 
my @protocol_times = $obj->protocol_times();
 
# @protocol_times contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { protocol_times = [ value1, value2...] }

Filled in for CMode CLI

=item C<< state_change >>

Time to change vserver state

Filled in for CMode CLI

=item C<< vserver >>

Vserver

Filled in for CMode CLI

=item C<< protocols >>

Protocols
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $protocols = $obj->protocols();
 
# $protocols contains a reference to the array of values
 
my @protocols = $obj->protocols();
 
# @protocols contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { protocols = [ value1, value2...] }

Filled in for CMode CLI

=item C<< lif_times >>

Time to online LIFs
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $lif_times = $obj->lif_times();
 
# $lif_times contains a reference to the array of values
 
my @lif_times = $obj->lif_times();
 
# @lif_times contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { lif_times = [ value1, value2...] }

Filled in for CMode CLI

=item C<< switchover_time >>

Time to Switchover

Filled in for CMode CLI

=item C<< lifs >>

LIFs
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $lifs = $obj->lifs();
 
# $lifs contains a reference to the array of values
 
my @lifs = $obj->lifs();
 
# @lifs contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { lifs = [ value1, value2...] }

Filled in for CMode CLI

=back

=cut

package NACL::CS::MetroclusterVserverSwitchoverLatencyShowDetailsPerVserver;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'protocol_times',
    scalar => 'state_change',
    scalar => 'vserver',
    array  => 'protocols',
    array  => 'lif_times',
    scalar => 'switchover_time',
    array  => 'lifs',
];

=head1 METHODS

=head2 fetch

    my $MetroclusterVserverSwitchoverLatencyShowDetailsPerVserver_state  = NACL::CS::MetroclusterVserverSwitchoverLatencyShowDetailsPerVserver->fetch(command_interface => $ci, ...);
	my @MetroclusterVserverSwitchoverLatencyShowDetailsPerVserver_states = NACL::CS::MetroclusterVserverSwitchoverLatencyShowDetailsPerVserver->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching metrocluster vserver switchover latency(s) found',
        frontend =>
            'NACL::CS::MetroclusterVserverSwitchoverLatencyShowDetailsPerVserver::fetch',
        show_cmd =>
            'metrocluster vserver switchover latency show-details-per-vserver',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api =>
            'metrocluster_vserver_switchover_latency_show_details_per_vserver',
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
