#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary NetworkBladeInformation ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::NetworkBladeInformation

=head1 DESCRIPTION

C<NACL::CS::NetworkBladeInformation> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP NetworkBladeInformation.  A related class is
L<NACL::C::NetworkBladeInformation|lib-NACL-C-NetworkBladeInformation-pm>, which represents access
to an ONTAP NetworkBladeInformation.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the NetworkBladeInformation
element are the attributes of the NetworkBladeInformation ComponentState.

=over

=item C<< "hostName" >>

Filled in for CMode CLI.

=item C<< "vifRole" >>

Filled in for CMode CLI.

=item C<< "lifRole" >>

Filled in for CMode CLI.

=item C<< "bladeType" >>

Filled in for CMode CLI.

=item C<< "ipCnt" >>

Filled in for CMode CLI.

=item C<< "bladeID" >>

Filled in for CMode CLI.

=item C<< "ipAddrs" >>

Filled in for CMode CLI.

=item C<< lif_role >>

Filled in for CMode CLI.

=item C<< ip_count >>

Filled in for CMode CLI.

=item C<< ip_addrs >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $ip_addrs = $obj->ip_addrs();
# $ip_addrs contains a reference to the array of values
my @ip_addrs = $obj->ip_addrs();
# @ip_addrs contains the array of values

Filled in for CMode CLI.

=item C<< blade_type >>

Filled in for CMode CLI.

=item C<< blade_uuid >>

Filled in for CMode CLI.

=item C<< host_name >>

Filled in for CMode CLI.

=item C<< lif_role_out >>

Lif Role possible value(s) are, cluster,data,node-mgmt,intercluster,cluster-mgmt

Filled in for CMode CLI.

=back

=cut

package NACL::CS::NetworkBladeInformation;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'hostName',
    scalar => 'vifRole',
    scalar => 'lifRole',
    scalar => 'bladeType',
    scalar => 'ipCnt',
    scalar => 'bladeID',
    scalar => 'ipAddrs',
    scalar => 'lif_role',
    scalar => 'ip_count',
    array  => 'ip_addrs',
    scalar => 'blade_type',
    scalar => 'blade_uuid',
    scalar => 'host_name',
    scalar => 'lif_role_out',
];

=head1 METHODS

=head2 fetch

    my $NetworkBladeInformation_state   = NACL::CS::NetworkBladeInformation->fetch(command_interface => $ci, ...);
	my @NetworkBladeInformation_states = NACL::CS::NetworkBladeInformation->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'network blade-information show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching network blade information(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'network_blade_information_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
