# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::NetworkFcpAdapter->stats() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::NetworkFcpAdapterStats

=head1 DESCRIPTION

C<NACL::CS::NetworkFcpAdapterStats> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::NetworkFcpAdapter->stats() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::NetworkFcpAdapter->stats() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< spurious_interrupts >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <spurious-interrupts>$value</spurious-interrupts>
 </fcp-adapter-stats-info>

=item C<< sfp_formfactor >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-formfactor>$value</sfp-formfactor>
 </fcp-adapter-stats-info>

=item C<< protocol_errors >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <protocol-errors>$value</protocol-errors>
 </fcp-adapter-stats-info>

=item C<< crc_errors >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <crc-errors>$value</crc-errors>
 </fcp-adapter-stats-info>

=item C<< sfp_wavelength >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-wavelength>$value</sfp-wavelength>
 </fcp-adapter-stats-info>

=item C<< scsi_requests_dropped >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <scsi-requests-dropped>$value</scsi-requests-dropped>
 </fcp-adapter-stats-info>

=item C<< sfp_date_code >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-date-code>$value</sfp-date-code>
 </fcp-adapter-stats-info>

=item C<< initiators_connected >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <initiators-connected>$value</initiators-connected>
 </fcp-adapter-stats-info>

=item C<< sfp_connector >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-connector>$value</sfp-connector>
 </fcp-adapter-stats-info>

=item C<< sfp_rev >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-rev>$value</sfp-rev>
 </fcp-adapter-stats-info>

=item C<< sfp_part_number >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-part-number>$value</sfp-part-number>
 </fcp-adapter-stats-info>

=item C<< frames_underrun >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <frame-underruns>$value</frame-underruns>
 </fcp-adapter-stats-info>

=item C<< nos_received >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <nos-received>$value</nos-received>
 </fcp-adapter-stats-info>

=item C<< ols_received >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <ols-received>$value</ols-received>
 </fcp-adapter-stats-info>

=item C<< is_sfp_rx_power_in_range >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <is-sfp-rx-power-in-range>$value</is-sfp-rx-power-in-range>
 </fcp-adapter-stats-info>

=item C<< sfp_serial_number >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-serial-number>$value</sfp-serial-number>
 </fcp-adapter-stats-info>

=item C<< is_sfp_optical_transceiver_valid >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <is-sfp-optical-transceiver-valid>$value</is-sfp-optical-transceiver-valid>
 </fcp-adapter-stats-info>

=item C<< sfp_fc_speed_capabilities >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-fc-speedcapabilities>$value</sfp-fc-speedcapabilities>
 </fcp-adapter-stats-info>

=item C<< adapter >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <adapter>$value</adapter>
 </fcp-adapter-stats-info>

=item C<< is_sfp_tx_power_in_range >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <is-sfp-rx-power-in-range>$value</is-sfp-rx-power-in-range>
 </fcp-adapter-stats-info>

=item C<< lr_received >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <lr-received>$value</lr-received>
 </fcp-adapter-stats-info>

=item C<< link_breaks >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <link-breaks>$value</link-breaks>
 </fcp-adapter-stats-info>

=item C<< sfp_vendor_oui >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-vendor-oui>$value</sfp-vendor-oui>
 </fcp-adapter-stats-info>

=item C<< frames_overrun >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <frame-overruns>$value</frame-overruns>
 </fcp-adapter-stats-info>

=item C<< total_logins >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <total-logins>$value</total-logins>
 </fcp-adapter-stats-info>

=item C<< node >>

Filled in for CMode CLI.

=item C<< lr_sent >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <lr-sent>$value</lr-sent>
 </fcp-adapter-stats-info>

=item C<< sfp_encoding >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-encoding>$value</sfp-encoding>
 </fcp-adapter-stats-info>

=item C<< sfp_tx_power >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-tx-power>$value</sfp-tx-power>
 </fcp-adapter-stats-info>

=item C<< invalid_xmit_words >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <invalid-xmit-words>$value</invalid-xmit-words>
 </fcp-adapter-stats-info>

=item C<< discarded_frames >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <discarded-frames>$value</discarded-frames>
 </fcp-adapter-stats-info>

=item C<< queue_depth >>

Filled in for CMode CLI.

=item C<< adapter_resets >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <adapter-resets>$value</adapter-resets>
 </fcp-adapter-stats-info>

=item C<< sfp_vendor_name >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-vendor-name>$value</sfp-vendor-name>
 </fcp-adapter-stats-info>

=item C<< total_logouts >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <total-logouts>$value</total-logouts>
 </fcp-adapter-stats-info>

=item C<< sfp_rx_power >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <sfp-rx-power>$value</sfp-rx-power>
 </fcp-adapter-stats-info>

=item C<< lip_resets >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <lip-resets>$value</lip-resets>
 </fcp-adapter-stats-info>

=item C<< is_sfp_diagnostics_internally_calibrated >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <fcp-adapter-stats-info>
     <is-sfp-diagnostics-internally-calibrated>$value</is-sfp-diagnostics-internally-calibrated>
 </fcp-adapter-stats-info>

=back

=cut

package NACL::CS::NetworkFcpAdapterStats;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'spurious_interrupts',
    scalar => 'sfp_formfactor',
    scalar => 'protocol_errors',
    scalar => 'crc_errors',
    scalar => 'sfp_wavelength',
    scalar => 'scsi_requests_dropped',
    scalar => 'sfp_date_code',
    scalar => 'initiators_connected',
    scalar => 'sfp_connector',
    scalar => 'sfp_rev',
    scalar => 'sfp_part_number',
    scalar => 'frames_underrun',
    scalar => 'nos_received',
    scalar => 'ols_received',
    scalar => 'is_sfp_rx_power_in_range',
    scalar => 'sfp_serial_number',
    scalar => 'is_sfp_optical_transceiver_valid',
    scalar => 'sfp_fc_speed_capabilities',
    scalar => 'adapter',
    scalar => 'is_sfp_tx_power_in_range',
    scalar => 'lr_received',
    scalar => 'link_breaks',
    scalar => 'sfp_vendor_oui',
    scalar => 'frames_overrun',
    scalar => 'total_logins',
    scalar => 'node',
    scalar => 'lr_sent',
    scalar => 'sfp_encoding',
    scalar => 'sfp_tx_power',
    scalar => 'invalid_xmit_words',
    scalar => 'discarded_frames',
    scalar => 'queue_depth',
    scalar => 'adapter_resets',
    scalar => 'sfp_vendor_name',
    scalar => 'total_logouts',
    scalar => 'sfp_rx_power',
    scalar => 'lip_resets',
    scalar => 'is_sfp_diagnostics_internally_calibrated',
];

=head1 METHODS

=head2 fetch

    my $NetworkFcpAdapterStats_state  = NACL::CS::NetworkFcpAdapterStats->fetch(command_interface => $ci, ...);
    my @NetworkFcpAdapterStats_states = NACL::CS::NetworkFcpAdapterStats->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI.

Invokes "fcp-adapter-stats-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        show_cmd =>'network fcp adapter stats',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
        ],
        exception_text => 'No matching network fcp adapter(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'network_fcp_adapter_stats',);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'fcp_adapter_stats_get_iter',
        copy => [
            qw (
                adapter is-sfp-optical-transceiver-valid lip-resets
                sfp-vendor-name is-sfp-tx-power-in-range
                sfp-tx-power spurious-interrupts sfp-rev
                protocol-errors
                discarded-frames sfp-serial-number
                sfp-part-number adapter-resets nos-received
                scsi-requests-dropped link-breaks lr-sent
                sfp-wavelength invalid-xmit-words crc-errors sfp-connector
                is-sfp-rx-power-in-range
                sfp-encoding sfp-date-code sfp-vendor-oui
                is-sfp-diagnostics-internally-calibrated
                lr-received sfp-formfactor ols-received total-logins
                total-logouts initiators-connected sfp-rx-power
                )
        ],
        map => {
            'frames-underrun'           => ['frame-underruns'],
            'frames-overrun'            => ['frame-overruns'],
            'sfp-fc-speed-capabilities' => ['sfp-fc-speedcapabilities'],
        }
    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

1;
