
#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary NetworkSubnet ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::NetworkSubnet

=head1 DESCRIPTION

C<NACL::CS::NetworkSubnet> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP NetworkSubnet.  A related class is
L<NACL::C::NetworkSubnet|lib-NACL-C-NetworkSubnet-pm>, which represents access
to an ONTAP NetworkSubnet.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the NetworkSubnet
element are the attributes of the NetworkSubnet ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< ipv4_prefix >>

IPv4 Prefix

Filled in for CMode CLI

=item C<< vservers >>

Vservers
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $vservers = $obj->vservers();
 
# $vservers contains a reference to the array of values
 
my @vservers = $obj->vservers();
 
# @vservers contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { vservers = [ value1, value2...] }

Filled in for CMode CLI

=item C<< ipv6_gateway >>

IPv6 Gateway

Filled in for CMode CLI

=item C<< ip_pools >>

IP Pool Name
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $ip_pools = $obj->ip_pools();
 
# $ip_pools contains a reference to the array of values
 
my @ip_pools = $obj->ip_pools();
 
# @ip_pools contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { ip_pools = [ value1, value2...] }

Filled in for CMode CLI

=item C<< failover_groups >>

Failover Groups
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $failover_groups = $obj->failover_groups();
 
# $failover_groups contains a reference to the array of values
 
my @failover_groups = $obj->failover_groups();
 
# @failover_groups contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { failover_groups = [ value1, value2...] }

Filled in for CMode CLI

=item C<< ipv6_total_count >>

Total IPv6 Address Count

Filled in for CMode CLI

=item C<< ipspace >>

IPspace Name

Filled in for CMode CLI/ZAPI

=item C<< subnet >>

Subnet Name

Filled in for CMode CLI/ZAPI

=item C<< mtu >>

MTU

Filled in for CMode CLI

=item C<< ipv4_available_count >>

Available IPv4 Address Count

Filled in for CMode CLI

=item C<< ipv6_used_count >>

Used IPv6 Address Count

Filled in for CMode CLI

=item C<< ipv4_used_count >>

Used IPv4 Address Count

Filled in for CMode CLI

=item C<< ipv4_total_count >>

Total IPv4 Address Count

Filled in for CMode CLI

=item C<< ipv4_gateway >>

IPv4 Gateway

Filled in for CMode CLI/ZAPI

=item C<< ipv6_prefix >>

IPv6 Prefix

Filled in for CMode CLI

=item C<< ports >>

Ports
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $ports = $obj->ports();
 
# $ports contains a reference to the array of values
 
my @ports = $obj->ports();
 
# @ports contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { ports = [ value1, value2...] }

Filled in for CMode CLI

=item C<< discovered_ipv6_prefixes >>

Discovered IPv6 Prefixes
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $discovered_ipv6_prefixes = $obj->discovered_ipv6_prefixes();
 
# $discovered_ipv6_prefixes contains a reference to the array of values
 
my @discovered_ipv6_prefixes = $obj->discovered_ipv6_prefixes();
 
# @discovered_ipv6_prefixes contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { discovered_ipv6_prefixes = [ value1, value2...] }

Filled in for CMode CLI

=item C<< subnet_id >>

Subnet ID

Filled in for CMode CLI

=item C<< ipv6_available_count >>

Available IPv6 Address count

Filled in for CMode CLI

=item C<< ip_ranges >>

IP Ranges
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $ip_ranges = $obj->ip_ranges();
 
# $ip_ranges contains a reference to the array of values
 
my @ip_ranges = $obj->ip_ranges();
 
# @ip_ranges contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { ip_ranges = [ value1, value2...] }

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

    <net-subnet-info>
        <ip-ranges>
            <ip-range>@ip_ranges</ip-range>
        </ip-ranges>
    </net-subnet-info>

=item C<< gateway >>

Gateway

Filled in for CMode CLI/ZAPI.

=item C<< total_count >>

Total Address Count

Filled in for CMode CLI/ZAPI.

=item C<< force_update_lif_associations >>

Change the subnet association

Filled in for CMode CLI/ZAPI.

=item C<< used_count >>

Used Address Count

Filled in for CMode CLI/ZAPI.

=item C<< available_count >>

Available Address Count

Filled in for CMode CLI/ZAPI.

=item C<< ipspace_id >>

IPspace ID

Filled in for CMode CLI.

=item C<< subnet_name >>

Subnet Name

Filled in for CMode CLI/ZAPI.

=item C<< broadcast_domain_id >>

Broadcast Domain ID

Filled in for CMode CLI.

=item C<< broadcast_domain >>

Broadcast Domain

Filled in for CMode CLI/ZAPI.


=item C<< subnet_string >>

Layer 3 Subnet String

Filled in for CMode CLI.


=item C<< gateway_string >>

Gateway String

Filled in for CMode CLI.


=back

=cut

package NACL::CS::NetworkSubnet;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'ipv4_prefix',
    array  => 'vservers',
    scalar => 'ipv6_gateway',
    array  => 'ip_pools',
    array  => 'failover_groups',
    scalar => 'ipv6_total_count',
    scalar => 'ipspace',
    scalar => 'subnet',
    scalar => 'mtu',
    scalar => 'ipv4_available_count',
    scalar => 'ipv6_used_count',
    scalar => 'ipv4_used_count',
    scalar => 'ipv4_total_count',
    scalar => 'ipv4_gateway',
    scalar => 'ipv6_prefix',
    array  => 'ports',
    array  => 'discovered_ipv6_prefixes',
    scalar => 'subnet_id',
    scalar => 'ipv6_available_count',
    array  => 'ip_ranges',
    scalar => 'gateway',
    scalar => 'total_count',
    scalar => 'force_update_lif_associations',
    scalar => 'used_count',
    scalar => 'available_count',
    scalar => 'ipspace_id',
    scalar => 'subnet_name',
    scalar => 'broadcast_domain_id',
    scalar => 'broadcast_domain',
    scalar => 'subnet_string',
    scalar => 'gateway_string',
];

=head1 METHODS

=head2 fetch

    my $NetworkSubnet_state  = NACL::CS::NetworkSubnet->fetch(command_interface => $ci, ...);
	my @NetworkSubnet_states = NACL::CS::NetworkSubnet->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes API 'net-subnet-get-iter' for Cmode ZAPI

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            }
        ],
	show_cmd       => 'network subnet show',
        exception_text => 'No matching network subnet(s) found',
        frontend       => 'NACL::CS::NetworkSubnet::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@args, api => 'network_subnet_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'net-subnet-get-iter',
        copy => [
            qw( available-count broadcast-domain gateway ipspace subnet
                subnet-name total-count used-count )
        ],
        map => {
            'ip-ranges' =>
                [make_zapi_array('ip-ranges'), make_zapi_skip('ip-range'),],
        },
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
