# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::RepositoryVolumeSnapmirror->list_destinations() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::RepositoryVolumeSnapmirrorListDestinations

=head1 DESCRIPTION

C<NACL::CS::RepositoryVolumeSnapmirrorListDestinations> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::RepositoryVolumeSnapmirror->list_destinations() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::RepositoryVolumeSnapmirror->list_destinations() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< destination_volume >>

Destination Volume

Filled in for CMode CLI.

=item C<< source_volume >>

Source Volume

Filled in for CMode CLI.

=item C<< destination_vserver >>

Destination Vserver

Filled in for CMode CLI.

=item C<< rel_status >>

Filled in for CMode CLI.

=item C<< status >>

Relationship Status

Filled in for CMode CLI.

=item C<< source_vserver >>

Source Vserver

Filled in for CMode CLI.

=item C<< transfer_progress >>

Transfer Progress, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< relationship_id >>

Relationship ID

Filled in for CMode CLI.

=item C<< destination_path >>

Destination Path

Filled in for CMode CLI.

=item C<< progress_last_updated >>

Timestamp of Last Progress Update

Filled in for CMode CLI.

=item C<< type >>

Relationship Type, possible value(s) are DP,LS,XDP,RST,TDP

Filled in for CMode CLI.

=item C<< source_path >>

Source Path

Filled in for CMode CLI.

=item C<< rel_type >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::RepositoryVolumeSnapmirrorListDestinations;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'destination_volume',
    scalar => 'source_volume',
    scalar => 'destination_vserver',
    scalar => 'rel_status',
    scalar => 'status',
    scalar => 'source_vserver',
    scalar => 'transfer_progress',
    scalar => 'relationship_id',
    scalar => 'destination_path',
    scalar => 'progress_last_updated',
    scalar => 'type',
    scalar => 'source_path',
    scalar => 'rel_type',
];

=head1 METHODS

=head2 fetch

    my $RepositoryVolumeSnapmirrorListDestinations_state  = NACL::CS::RepositoryVolumeSnapmirrorListDestinations->fetch(command_interface => $ci, ...);
	my @RepositoryVolumeSnapmirrorListDestinations_states = NACL::CS::RepositoryVolumeSnapmirrorListDestinations->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'repository volume snapmirror list-destinations',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching repository volume snapmirror(s) found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'repository_volume_snapmirror_list_destinations',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
