#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary RepositoryVolumeSnapshot ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::RepositoryVolumeSnapshot

=head1 DESCRIPTION

C<NACL::CS::RepositoryVolumeSnapshot> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP RepositoryVolumeSnapshot.  A related class is
L<NACL::C::RepositoryVolumeSnapshot|lib-NACL-C-RepositoryVolumeSnapshot-pm>, which represents access
to an ONTAP RepositoryVolumeSnapshot.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the RepositoryVolumeSnapshot
element are the attributes of the RepositoryVolumeSnapshot ComponentState.

=over

=item C<< volume >>

Filled in for CMode CLI.

=item C<< record_owner >>

Filled in for CMode CLI.

=item C<< blocks >>

Filled in for CMode CLI.

=item C<< vserver >>

Filled in for CMode CLI.

=item C<< instance_uuid >>

Filled in for CMode CLI.

=item C<< state >>

Filled in for CMode CLI.

=item C<< size >>

Filled in for CMode CLI.

=item C<< comment >>

Filled in for CMode CLI.

=item C<< owners >>

(Array)

Filled in for CMode CLI.

=item C<< create_time >>

Filled in for CMode CLI.

=item C<< usedblocks >>

Filled in for CMode CLI.

=item C<< snapshot >>

Filled in for CMode CLI.

=item C<< foreground >>

Filled in for CMode CLI.

=item C<< busy >>

Filled in for CMode CLI.

=item C<< dependency >>

Filled in for CMode CLI.

=item C<< cumulative_total >>

Filled in for CMode CLI.

=item C<< timestamp_sort >>

Filled in for CMode CLI.

=item C<< size_kb >>

Filled in for CMode CLI.

=item C<< timestamp >>

Filled in for CMode CLI.

=item C<< snapState >>

Filled in for CMode CLI.

=item C<< fs_version >>

File System Version
Filled in for CMode CLI.


=back

=cut

package NACL::CS::RepositoryVolumeSnapshot;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'volume',
    scalar => 'record_owner',
    scalar => 'blocks',
    scalar => 'vserver',
    scalar => 'instance_uuid',
    scalar => 'state',
    scalar => 'size',
    scalar => 'comment',
    array  => 'owners',
    scalar => 'create_time',
    scalar => 'usedblocks',
    scalar => 'snapshot',
    scalar => 'foreground',
    scalar => 'busy',
    scalar => 'dependency',
    scalar => 'cumulative_total',
    scalar => 'timestamp_sort',
    scalar => 'size_kb',
    scalar => 'timestamp',
    scalar => 'snapState',
    scalar => 'fs_version',
];

=head1 METHODS

=head2 fetch

    my $RepositoryVolumeSnapshot_state   = NACL::CS::RepositoryVolumeSnapshot->fetch(command_interface => $ci, ...);
	my @RepositoryVolumeSnapshot_states = NACL::CS::RepositoryVolumeSnapshot->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $Log->debug("Opts to 'fetch' frontend are:\n" . Dumper(\@_));
    my %opts        = validate @_, $pkg->_fetch_validate_spec();
    my $allow_empty = delete $opts{allow_empty};
    my @state_objs  = $pkg->call_on_apiset(
        %opts,
	show_cmd => 'repository volume snapshot show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );
    $pkg->_check_for_invalid_requested_fields(
        state_objs       => \@state_objs,
        requested_fields => $opts{requested_fields},
    );
    $pkg->_apply_filter(
        state_objs => \@state_objs,
        filter     => $opts{filter},
    );
    $Log->exit() if $may_exit;

    if (!@state_objs && !$allow_empty) {
        NACL::Exceptions::NoElementsFound->throw(
                  "No matching repository volume snapshot(s) found\n"
                . "Filter: "
                . _dump_one($opts{filter})
                . "\n");
    } ## end if ( !@state_objs && !...
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(
        @_,
        api => 'repository_volume_snapshot_show',

    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
