# $Id: //depot/prod/test/main/lib/NACL/CS/SmtapeRestoreGetVolumeGeometry.pm#1 $

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState module for the method
##   NACL::C::Smtape->restore_get_volume_geometry()
## @author dl-dpg-nb-automation; dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SmtapeRestoreGetVolumeGeometry

=head1 DESCRIPTION

C<NACL::CS::SmtapeRestoreGetVolumeGeometry> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this
type are returned when NACL::C::Smtape->restore_get_volume_geometry() is invoked.

(This module does not represent the state of any element, but is an object
repesentation of the output obtained when the Smtape Restore is queried
for volume geometry.)

=head1 ATTRIBUTES

The individual pieces of data that are part of the parsed output of
'smtape restore -g' are the attributes of the SmtapeRestoreGetVolumeGeometry
ComponentState object.

=over

=item C<< volume_geometry >>

Path for which volume geometry will be retrieved.

=back

=cut

package NACL::CS::SmtapeRestoreGetVolumeGeometry;

use strict;
use warnings;

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'volume_geometry',
];

1;
