# $Id: //depot/prod/test/nacldev/lib/NACL/CS/StatisticsPresetDetail.pm#5 $

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsPresetDetail ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StatisticsPresetDetail

=head1 DESCRIPTION

C<NACL::CS::StatisticsPresetDetail> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP StatisticsPresetDetail.  A related class is
L<NACL::C::StatisticsPresetDetail|lib-NACL-C-StatisticsPresetDetail-pm>, which represents access
to an ONTAP StatisticsPresetDetail.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the StatisticsPresetDetail
element are the attributes of the StatisticsPresetDetail ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< counter_set >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <perf-preset-detail-get>
    <counter-set>$value</counter-set>
 </perf-preset-detail-get>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $counter_set = $obj->counter_set();
# $counter_set contains a reference to the array of values
my @counter_set = $obj->counter_set();
# @counter_set contains the array of values

Filled in for CMode CLI.

=item C<< object >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <perf-preset-detail-get>
    <object>$value</object>
 </perf-preset-detail-get>

=item C<< vserver >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <perf-preset-detail-get>
    <vserver>$value</vserver>
 </perf-preset-detail-get>

=item C<< sample_period >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <perf-preset-detail-get>
    <sample-period>$value</sample-period>
 </perf-preset-detail-get>

item C<< instance_filters >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $instance_filters = $obj->instance_filters();
# $instance_filters contains a reference to the array of values
my @instance_filters = $obj->instance_filters();
# @instance_filters contains the array of values

Filled in for CMode CLI.

=item C<< generation_id >>

Filled in for CMode CLI.

=item C<< preset >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <perf-preset-detail-get>
    <preset>$value</preset>
 </perf-preset-detail-get>

=back

=cut

package NACL::CS::StatisticsPresetDetail;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'counter_set',
    scalar => 'object',
    scalar => 'vserver',
    scalar => 'sample_period',
    array  => 'instance_filters',
    scalar => 'generation_id',
    scalar => 'preset',
];

=head1 METHODS

=head2 fetch

    my $StatisticsPresetDetail_state  = NACL::CS::StatisticsPresetDetail->fetch(command_interface => $ci, ...);
	my @StatisticsPresetDetail_states = NACL::CS::StatisticsPresetDetail->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI APISet.

Invokes 'perf-preset-detail-get' API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching statistics preset detail(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'statistics_preset_detail_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;

    my %opts = validate @args, $pkg->_fetch_backend_validate_spec();
    my @state_objs;
    my $command_interface = $opts{command_interface};
    my $filter            = $opts{filter};
    my $apiset            = $opts{apiset};
    my $vserver           = $opts{vserver};

    my $response
        = $apiset->perf_preset_detail_get(preset => $filter->{'preset'},);
    my $output = $response->get_parsed_output();

    foreach my $list_output (
        @{$output->[0]{'preset-detail-infos'}->[0]{'preset-detail-info'}})
    {
        my $target = $pkg->_hash_copy(
            source => $list_output,
            copy   => [qw( sample-period object counter-set)],
        );
        my $obj = $pkg->new(command_interface => $opts{command_interface});
        $obj->_set_fields(row => $target);
        push @state_objs, $obj;
    } ## end foreach

    my $target = $pkg->_hash_copy(
        source => $output->[0],
        copy   => [qw( preset vserver )],
    );
    foreach my $obj (@state_objs) {
        $obj->vserver($target->{vserver});
        $obj->preset($target->{preset});
    }

    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

1;
