#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsRdbQuorumEvents ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StatisticsRdbQuorumEvents

=head1 DESCRIPTION

C<NACL::CS::StatisticsRdbQuorumEvents> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP StatisticsRdbQuorumEvents.  A related class is
L<NACL::C::StatisticsRdbQuorumEvents|lib-NACL-C-StatisticsRdbQuorumEvents-pm>, which represents access
to an ONTAP StatisticsRdbQuorumEvents.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the StatisticsRdbQuorumEvents
element are the attributes of the StatisticsRdbQuorumEvents ComponentState.

=over

Supports CMode CLI.

=item C<< "epoch" >>

Filled in for CMode CLI.

=item C<< "seqnum" >>

Filled in for CMode CLI.

=item C<< "subject" >>

Filled in for CMode CLI.

=item C<< "ring" >>

Filled in for CMode CLI.

=item C<< "reporter" >>

Filled in for CMode CLI.

=item C<< "event" >>

Filled in for CMode CLI.

=item C<< "timestamp" >>

Filled in for CMode CLI.

=item C<< "notes" >>

Filled in for CMode CLI.

=item C<< eventtime >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::StatisticsRdbQuorumEvents;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'epoch',
    scalar => 'seqnum',
    scalar => 'subject',
    scalar => 'ring',
    scalar => 'reporter',
    scalar => 'event',
    scalar => 'timestamp',
    scalar => 'notes',
    scalar => 'eventtime',
];

=head1 METHODS

=head2 fetch

    my $StatisticsRdbQuorumEvents_state   = NACL::CS::StatisticsRdbQuorumEvents->fetch(command_interface => $ci, ...);
	my @StatisticsRdbQuorumEvents_states = NACL::CS::StatisticsRdbQuorumEvents->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'statistics rdb quorum events show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching statistics rdb quorum events(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'statistics_rdb_quorum_events_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
