# $Id: //depot/prod/test/nacldev/lib/NACL/CS/StatisticsShowPeriodic.pm#23 $

#
# Copyright (c) 2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsShowPeriodic ComponentState Module
## @author Vaibhav.Mittal@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StatisticsShowPeriodic

=head1 DESCRIPTION

C<NACL::CS::StatisticsShowPeriodic> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>.  It represents the
state of ONTAP StatisticsShowPeriodic.  A related class is
L<NACL::C::Statistics|lib-NACL-C-Statistics-pm>, which represents access
to ONTAP statistics.

=head1 ATTRIBUTES

The individual pieces of data that are present in the output of
NACL::C::Statistics->show_periodic().
StatisticsShowPeriodic has attributes minimum, maximum, average, statistics, starttime, endtime.
Attributes minimum , maximum, average,  holds a singular object of
type NACL::CS::StatisticsShowPeriodicEntry and the attribute statistics attribute
holds array of such objects.

=over

=item C<< minimums >>

=item C<< averages >>

=item C<< statistics >>

=item C<< maximums >>

=item C<< starttime >>

=item C<< endtime >>

=back

=cut

package NACL::CS::StatisticsShowPeriodic;

use strict;
use warnings;
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'minimums',
    scalar => 'averages',
    scalar => 'maximums',
    array  => 'statistics',
    scalar => 'starttime',
    scalar => 'endtime',
];

1;
