# $Id$ 
#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageAggregateAddDisks64bitupgradeCheck ComponentState Module
## @author anbumozh@netapp.com dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageAggregateAddDisks64bitupgradeCheck

=head1 DESCRIPTION

C<NACL::CS::StorageAggregateAddDisks64bitupgradeCheck> is a derived class of
L<NACL::CS::Volume64bitUpgradeStartCheck|lib-NACL-CS-Volume64bitUpgradeStartCheck-pm>. Object(s) of this
type are returned when NACL::C::StorageAggregate->add_disks_64bitupgrade_check() is invoked.

This module does not represent the state of any element, but is an object
representation of the output obtained when a aggregate is queried for 
upgradability from 32-bit to 64-bits.

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< volume >>

=item C<< vserver >>

=item C<< used >>

=item C<< total >>

=item C<< capacity >>

=item C<< additional_space_required_for_upgrade => $string >>

=item C<< filesys_size_fixed => $string >>

=item C<< space_reserved_files => $string >>

=item C<< upgrade_64bit_added_space >>

CMode/7Mode ZAPI specific

=item C<< upgrade_64bit_check_last_errno >>

CMode/7Mode ZAPI specific

=item C<< upgrade_64bit_cookie >>

CMode/7Mode ZAPI specific

=item C<< upgrade_64bit_is_space_estimate_complete >>

CMode/7Mode ZAPI specific

=back

=cut

package NACL::CS::StorageAggregateAddDisks64bitupgradeCheck;

use base NACL::CS::Volume64bitUpgradeStartCheck;

use Class::MethodMaker [
    scalar => 'upgrade_64bit_added_space',
    scalar => 'upgrade_64bit_check_last_errno',
    scalar => 'upgrade_64bit_cookie',
    scalar => 'upgrade_64bit_is_space_estimate_complete',
];

1;
