#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState module for the method NACL::C::AggregateEmap->lookup()
## @author chenp@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::AggregateEmap

=head1 DESCRIPTION

C<NACL::CS::AggregateEmap> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>.
Object(s) of this type are returned when NACL::C::AggregateEmap->lookup()
is invoked.

This module does not represent the state of any element, but is an object
repesentation of the output of 'wafl showvbns' DBlade command.

=head1 ATTRIBUTES

The attribute names are selected to be the same as what ONTAP returns
in the output of 'wafl showvbns' DBlade command.

=over

=back

=cut

package NACL::CS::StorageAggregateEmapLookup;

use strict;
use warnings;


use Tharn qw($Log);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'aggregate',
    scalar => 'eid',
    array  => 'pvbns',
    scalar => 'region',
    scalar => 'random',
    scalar => 'count',
];


=head1 METHODS

=head2 fetch

    my $state = NACL::CS::AggregateEmapLookup->fetch(command_interface => $ci,);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Supports 7Mode CLI

=over

=cut

__PACKAGE__->_fetch_7mode_cli_method_builder(
        apiset_method => 'mw_emap_lookup',
        element_not_found_regex => 'PVBNs:$',
        filter_keys_to_be_passed_to_apiset => ['aggregate', 'eid', 'random', 'region', 'count'],
);

1;
