#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState module for the method NACL::C::StorageAggregate->stage_stat()
## @author chenp@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageAggregateStageStat.pm

=head1 DESCRIPTION

C<NACL::CS::StorageAggregateMwStageStat.pm> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>.
Object(s) of this type are returned when NACL::C::iStorageAggregateEmap->stage_stat()
is invoked.

This module does not represent the state of any element, but is an object
repesentation of the output of 'mw stage stat' DBlade command.

=head1 ATTRIBUTES

The attribute names are selected to be the same as what ONTAP returns
in the output of 'mw stage stat' DBlade command.

=over

=back

=cut

package NACL::CS::StorageAggregateMwStageStat;

use strict;
use warnings;

use Tharn qw($Log);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'aggregate',
    scalar => 'stages_committed_in_bckend',
    scalar => 'total_stages_acquired',
    scalar => 'eids_added_in_frntend',
    scalar => 'level',
    scalar => 'empty_stages_frd_on_susp',
    scalar => 'stages_added_in_frntend',
    scalar => 'op',
    scalar => 'eids_committed_in_bckend',
];


=head1 METHODS

=head2 fetch

    my $stat = NACL::CS::AggregateMwStageStat->fetch(command_interface => $ci,);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Supports 7Mode CLI

=over

=cut

__PACKAGE__->_fetch_7mode_cli_method_builder(
    apiset_method                      => 'mw_stage_stat',
    filter_keys_to_be_passed_to_apiset => ['aggregate'],
);

1;
