# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::StorageAggregate->plex_show() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageAggregatePlexShow

=head1 DESCRIPTION

C<NACL::CS::StorageAggregatePlexShow> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::StorageAggregate->plex_show() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::StorageAggregate->plex_show() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< plex >>

Plex Name
Filled in for CMode CLI

=item C<< plex_path >>

Plex path
Filled in for CMode CLI

=item C<< is_online >>

Is Online possible value(s) are, true,false
Filled in for CMode CLI

=item C<< pool >>

Pool ranges from 0 to 1
Filled in for CMode CLI

=item C<< status >>

Status
Filled in for CMode CLI

=item C<< in_progress >>

Resync is in Progress possible value(s) are, true,false
Filled in for CMode CLI

=item C<< resync_level >>

Resync Level ranges from 0 to 1
Filled in for CMode CLI

=item C<< aggregate >>

Aggregate
Filled in for CMode CLI

=item C<< resyncing_percent >>

Resyncing Percentage
Filled in for CMode CLI

=back

=cut

package NACL::CS::StorageAggregatePlexShow;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'plex',
    scalar => 'plex_path',
    scalar => 'is_online',
    scalar => 'pool',
    scalar => 'status',
    scalar => 'in_progress',
    scalar => 'resync_level',
    scalar => 'aggregate',
    scalar => 'resyncing_percent',
];

=head1 METHODS

=head2 fetch

    my $StorageAggregatePlexShow_state  = NACL::CS::StorageAggregatePlexShow->fetch(command_interface => $ci, ...);
	my @StorageAggregatePlexShow_states = NACL::CS::StorageAggregatePlexShow->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'storage aggregate plex show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching storage aggregate(s) found',
        frontend       => 'NACL::CS::StorageAggregatePlexShow::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'storage_aggregate_plex_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
