# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::StorageAggregate->show_df() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageAggregateShowDf

=head1 DESCRIPTION

C<NACL::CS::StorageAggregateShowDf> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::StorageAggregate->show_df() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::StorageAggregate->show_df() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< percent_inodes_used >>

Percentage of Inodes Used possible value(s) are, percent_no_limit.

Filled in for CMode CLI.

=item C<< dedupe_saved >>

Space Saved by Deduplication possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< percent_total_saved >>

Percentage Total Space Saved possible value(s) are, percent_no_limit.

Filled in for CMode CLI.

=item C<< filesys_name >>

Volume File System Name possible value(s) are, text.

Filled in for CMode CLI.

=item C<< uuid >>

Aggregate UUID possible value(s) are, UUID.

Filled in for CMode CLI.

=item C<< inodes_used >>

Inodes Used possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< inodes_free >>

Inodes Available possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< total_hybrid_cache_size >>

Total Size of SSD tier of a Flash Pool possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< percent_vbn_zero_saved >>

Percentage Saved by VBN ZERO possible value(s) are, percent_no_limit.

Filled in for CMode CLI.

=item C<< total_space >>

Total Space possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< total_saved >>

Total Space Saved possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< used_space >>

Used Space possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< aggregate >>

Aggregate Name possible value(s) are, aggregate name.

Filled in for CMode CLI.

=item C<< percent_compression_saved >>

Percentage Saved by Compression possible value(s) are, percent_no_limit.

Filled in for CMode CLI.

=item C<< percent_used_space >>

Percentage of Used Space possible value(s) are, percent_no_limit.

Filled in for CMode CLI.

=item C<< vbn_zero_saved >>

Space Saved by VBN ZERO possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< reserved_space >>

Reserved Space possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< fs_type >>

Snapshot or Active File System possible value(s) are, active,snapshot.

Filled in for CMode CLI.

=item C<< percent_dedupe_saved >>

Percentage Saved by Deduplication possible value(s) are, percent_no_limit.

Filled in for CMode CLI.

=item C<< available_space >>

Available Space possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< type >>

Aggregate Type possible value(s) are, flex,striped.

Filled in for CMode CLI.

=item C<< compression_saved >>

Space Saved by Compression possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=back

=cut

package NACL::CS::StorageAggregateShowDf;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'percent_inodes_used',
    scalar => 'dedupe_saved',
    scalar => 'percent_total_saved',
    scalar => 'filesys_name',
    scalar => 'uuid',
    scalar => 'inodes_used',
    scalar => 'inodes_free',
    scalar => 'total_hybrid_cache_size',
    scalar => 'percent_vbn_zero_saved',
    scalar => 'total_space',
    scalar => 'total_saved',
    scalar => 'used_space',
    scalar => 'aggregate',
    scalar => 'percent_compression_saved',
    scalar => 'percent_used_space',
    scalar => 'vbn_zero_saved',
    scalar => 'reserved_space',
    scalar => 'fs_type',
    scalar => 'percent_dedupe_saved',
    scalar => 'available_space',
    scalar => 'type',
    scalar => 'compression_saved',
];

=head1 METHODS

=head2 fetch

    my $StorageAggregateShowDf_state  = NACL::CS::StorageAggregateShowDf->fetch(command_interface => $ci, ...);
	my @StorageAggregateShowDf_states = NACL::CS::StorageAggregateShowDf->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'storage aggregate show-df',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching storage aggregate(s) found',
        frontend       => 'NACL::CS::StorageAggregateShowDf::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'storage_aggregate_show_df',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
