#$Id: //depot/prod/test/nacldev/lib/NACL/CS/StorageAggregateShowRaidgroup.pm#1 $

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::StorageAggregate->show_raidgroup() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, benjaram@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageAggregateShowRaidgroup

=head1 DESCRIPTION

C<NACL::CS::StorageAggregateShowRaidgroup> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::StorageAggregate->show_raidgroup() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::StorageAggregate->show_raidgroup() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< checksum_style >>

Raidgroup Checksum style possible value(s) are, text

Filled in for CMode CLI/ZAPI

Maps to:

CM ZAPI:

<raidgroup-info>
<checksum-style>$value</checksum-style>$
</raidgroup-info>

=item C<< recomputing_parity_percentage >>

Reparity Percentage possible value(s) are, percent

Filled in for CMode CLI/ZAPI

CM ZAPI:

<raidgroup-info>
<recomputing-parity-percentage>$value</<recomputing-parity-percentage>
</raidgroup-info>

=item C<< plex_path >>

Plex path possible value(s) are, text

Filled in for CMode CLI/ZAPI.

CM ZAPI:

<raidgroup-info>
<plex-path>$value</plex-path>
</raidgroup-info>

=item C<< plex >>

Plex Name possible value(s) are, text

Filled in for CMode CLI/ZAPI.

CM ZAPI:

<raidgroup-info>
<plex>$value</plex>
</raidgroup-info>

=item C<< raidgroup >>

Raidgroup Name possible value(s) are, text

Filled in for CMode CLI/ZAPI.

CM ZAPI:

<raidgroup-info>
<raidgroup>$value</raidgroup>
</raidgroup-info>

=item C<< is_recomputing_parity >>

Is reparity active ? possible value(s) are, true,false

Filled in for CMode CLI/ZAPI.

CM ZAPI:

<raidgroup-info>
<is-recomputing-parity>$value</is-recomputing-parity>
</raidgroup-info>

=item C<< aggregate >>

Aggregate possible value(s) are, aggregate name

Filled in for CMode CLI/ZAPI.

CM ZAPI:

<raidgroup-info>
<aggregate>$value</aggregate>
</raidgroup-info>

=item C<< is_cache_tier >>

Is cache tier ? possible value(s) are, true,false

Filled in for CMode CLI/ZAPI.

CM ZAPI:

<raidgroup-info>
<is-cache-tier>$value</is-cache-tier>
</raidgroup-info>

=item C<< reconstruction_percent >>

Reconstruction Percentage possible value(s) are, percent

Filled in for CMode CLI/ZAPI.

CM ZAPI:

<raidgroup-info>
<reconstruction-percent>$value</reconstruction-percent>
</raidgroup-info>

=item C<< is_reconstructing >>

Is Reconstructing possible value(s) are, true,false

Filled in for CMode CLI/ZAPI.

CM ZAPI:

<raidgroup-info>
<is-reconstructing>$value</is-reconstructing>
</raidgroup-info>

=back

=cut

package NACL::CS::StorageAggregateShowRaidgroup;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'checksum_style',
    scalar => 'recomputing_parity_percentage',
    scalar => 'plex_path',
    scalar => 'plex',
    scalar => 'raidgroup',
    scalar => 'is_recomputing_parity',
    scalar => 'aggregate',
    scalar => 'is_cache_tier',
    scalar => 'reconstruction_percent',
    scalar => 'is_reconstructing',
];

=head1 METHODS

=head2 fetch

    my $StorageAggregateShowRaidgroup_state  = NACL::CS::StorageAggregateShowRaidgroup->fetch(command_interface => $ci, ...);
	my @StorageAggregateShowRaidgroup_states = NACL::CS::StorageAggregateShowRaidgroup->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI/ZAPI APISet.

Invokes "raidgroup-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
        ],
        exception_text => 'No matching storage aggregate(s) found',
        frontend       => 'NACL::CS::StorageAggregateShowRaidgroup::fetch',
        show_cmd       => 'storage aggregate show-raidgroup'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'storage_aggregate_show_raidgroup',);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_obj = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        api  => "raidgroup-get-iter",
        copy => [
            qw(
                checksum-style recomputing-parity-percentage plex-path plex
                raidgroup aggregate is-recomputing-parity is-cache-tier
                reconstruction-percent is-reconstructing
                )
        ],
    );

    $Log->exit() if $may_exit;
    return @state_obj;
} ## end sub _fetch_cmode_zapi

1;
