# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::StorageAggregate->show_view() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageAggregateShowView

=head1 DESCRIPTION

C<NACL::CS::StorageAggregateShowView> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::StorageAggregate->show_view() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::StorageAggregate->show_view() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< checksum_style >>

Raidgroup Checksum style possible value(s) are, text.

Filled in for CMode CLI.

=item C<< volume_footprints_percent >>

Volume Data and Metadata Footprint Percent possible value(s) are, percent.

Filled in for CMode CLI.

=item C<< ha_policy >>

HA Policy possible value(s) are, sfo,cfo.

Filled in for CMode CLI.

=item C<< volume_footprints >>

Volume Data and Metadata Footprint possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< snap_maxfiles_possible >>

Maximum Files allowed for Snapshot Copies possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< home_name >>

Home Name possible value(s) are, text.

Filled in for CMode CLI.

=item C<< fs_maxfiles_used >>

Files Used (for user-visible data) possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< diskcount >>

Number Of Disks possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< home_id >>

Home ID possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< recomputing_parity_percentage >>

Reparity Percentage possible value(s) are, percent.

Filled in for CMode CLI.

=item C<< free_space_realloc >>

Free Space Reallocation possible value(s) are, on,off,no_redirect.

Filled in for CMode CLI.

=item C<< snap_maxfiles_used >>

Files in Use Snapshot copies possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< files_used >>

Files used possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< usedsize >>

Used Size possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< block_type >>

Block Type possible value(s) are, 32-bit,64-bit.

Filled in for CMode CLI.

=item C<< snap_maxfiles_available >>

Maximum Files available for Snapshot Copies possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< files_total >>

Total file count possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< maxraidsize >>

Max RAID Size possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< has_partner_mroot >>

Has Partner Node Mroot Volume possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< is_reconstructing >>

Is Reconstructing possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< snap_size_total >>

Total space for Snapshot Copies in bytes possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< aggregate_metadata_percent >>

Aggregate Metadata Percent possible value(s) are, percent.

Filled in for CMode CLI.

=item C<< upgrade_64bit_is_in_progress >>

Check if the 64-bit upgrade is in progress possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< upgrade_64bit_cookie >>

Unique identifier for a 64-bit transaction possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< max_write_alloc_blocks >>

Maximum Write Alloc Blocks possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< striping >>

Striping Type possible value(s) are, text.

Filled in for CMode CLI.

=item C<< chksumenabled >>

Checksum Enabled possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< upgrade_64bit_is_estimate_complete >>

Is the check for space usage complete? possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< iron_summary_scan_percentage >>

Percent Summary Blocks Scanned possible value(s) are, percent.

Filled in for CMode CLI.

=item C<< size >>

Size possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< volcount_not_online >>

Number of Volumes not Online possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< aggregate_metadata >>

Aggregate Metadata possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< owner_name >>

Owner Name possible value(s) are, text.

Filled in for CMode CLI.

=item C<< pool >>

Pool possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< chksumstyle >>

Checksum Style possible value(s) are, checksum style.

Filled in for CMode CLI.

=item C<< snaplock_type >>

The type of the snaplock possible value(s) are, text.

Filled in for CMode CLI.

=item C<< iron_last_start_errno >>

Last Start Error Number possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< resyncing_percent >>

Resyncing Percentage possible value(s) are, percent.

Filled in for CMode CLI.

=item C<< fsid >>

FSID possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< fs_inodefile_private_capacity >>

Inode File Capacity (for private system metadata) possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< iron_status >>

Wafliron Status possible value(s) are, text.

Filled in for CMode CLI.

=item C<< hybrid >>

Hybrid possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< raid_lost_write_state >>

RAID Lost Write State possible value(s) are, text.

Filled in for CMode CLI.

=item C<< snap_percent_inode_used_capacity >>

Percentage of disk space used by files in Snapshot Copies possible value(s) are, percent.

Filled in for CMode CLI.

=item C<< upgrade_64bit_added_space >>

Total effective space that would be added possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< mirror_status >>

Mirror status possible value(s) are, text.

Filled in for CMode CLI.

=item C<< snap_size_available >>

Available space for Snapshot Copies in bytes possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< is_recomputing_parity >>

Is reparity active ? possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< upgrade_64bit_min_space_for_upgrade >>

The minimum additional disk space required for 64-bit upgrade possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< dr_home_id >>

DR Home ID possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< snap_files_used >>

Total Files created in Snapshot Copies possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< uuid >>

UUID possible value(s) are, text.

Filled in for CMode CLI.

=item C<< state >>

State possible value(s) are, aggregate state.

Filled in for CMode CLI.

=item C<< raidgroup >>

Raidgroup Name possible value(s) are, text.

Filled in for CMode CLI.

=item C<< striped_volcount >>

Number of striped volumes possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< hybrid_cache_size_total >>

Total Hybrid Cache Size possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< is_snaplock >>

Is Snaplock possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< dr_home_name >>

DR Home Name possible value(s) are, text.

Filled in for CMode CLI.

=item C<< mirror_count_move_destinations >>

Number of Move Mirror Destination Volumes possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< upgrade_64bit_check_last_errno >>

Error code of last attempt to check for space usage possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< snap_files_total >>

Total Files allowed in Snapshot Copies possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< member_count >>

Member Count possible value(s) are, text.

Filled in for CMode CLI.

=item C<< availsize >>

Available Size possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< fs_total_reserved_space >>

Total Reserved Space possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< fs_inodefile_public_capacity >>

Inode File Capacity (for user-visible data) possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< inconsistent >>

Inconsistent possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< owner_id >>

Owner ID possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< upgrade_64bit_start_last_errno >>

Error code of last attempt to start 64-bit upgrade possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< type >>

Aggregate Type possible value(s) are, text.

Filled in for CMode CLI.

=item C<< nodes >>

Nodes possible value(s) are, <nodename>,local
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $nodes = $obj->nodes();
# $nodes contains a reference to the array of values
my @nodes = $obj->nodes();
# @nodes contains the array of values
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref
# filter => { nodes = [ value1, value2...] }

Filled in for CMode CLI.

=item C<< has_mroot >>

Has Mroot Volume possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< is_cache_tier >>

Is cache tier ? possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< mirror_count_ls_destinations >>

Number of LS Mirror Destination Volumes possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< reconstruction_percent >>

Reconstruction Percentage possible value(s) are, percent.

Filled in for CMode CLI.

=item C<< snap_size_used >>

Space used by Snapshot Copies in bytes possible value(s) are, <integer>[KB,MB,GB,TB,PB].

Filled in for CMode CLI.

=item C<< plex_path >>

Plex path possible value(s) are, text.

Filled in for CMode CLI.

=item C<< plex_count >>

Number of plexes possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< iron_last_start_error_info >>

Last Start Error Info possible value(s) are, text.

Filled in for CMode CLI.

=item C<< is_online >>

Is Online possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< percent_used >>

Used Percentage possible value(s) are, percent.

Filled in for CMode CLI.

=item C<< iron_scan_percentage >>

Percent Blocks Scanned possible value(s) are, percent.

Filled in for CMode CLI.

=item C<< status >>

Status possible value(s) are, text.

Filled in for CMode CLI.

=item C<< hybrid_enabled >>

Hybrid Enabled possible value(s) are, true,false.

Filled in for CMode CLI.

=item C<< resync_level >>

Resync Level possible value(s) are, integer.

Filled in for CMode CLI.

=item C<< disklist >>

Disks possible value(s) are, disk path name.
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $disklist = $obj->disklist();
# $disklist contains a reference to the array of values
my @disklist = $obj->disklist();
# @disklist contains the array of values
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref
# filter => { disklist = [ value1, value2...] }

Filled in for CMode CLI

=item C<< mirror_count_dp_destinations >>

Number of DP Mirror Destination Volumes possible value(s) are, integer

Filled in for CMode CLI

=item C<< plex >>

Plex Name possible value(s) are, text

Filled in for CMode CLI

=item C<< mirror_disklist >>

Disks for Mirrored Plex possible value(s) are, disk path name
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $mirror_disklist = $obj->mirror_disklist();
# $mirror_disklist contains a reference to the array of values
my @mirror_disklist = $obj->mirror_disklist();
# @mirror_disklist contains the array of values
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref
# filter => { mirror_disklist = [ value1, value2...] }

Filled in for CMode CLI

=item C<< snap_percent_used_capacity >>

Percentage of disk space used by Snapshot Copies possible value(s) are, percent_no_limit

Filled in for CMode CLI

=item C<< volcount >>

Number Of Volumes possible value(s) are, integer

Filled in for CMode CLI

=item C<< aggregate >>

Aggregate possible value(s) are, aggregate name

Filled in for CMode CLI

=item C<< mount_state >>

mount state possible value(s) are, text

Filled in for CMode CLI

=item C<< fs_percent_inode_used_capacity >>

Percent Total Files in Use (for user-visible data) possible value(s) are, percent

Filled in for CMode CLI

=item C<< raidstatus >>

RAID Status possible value(s) are, text

Filled in for CMode CLI

=item C<< fs_files_private_used >>

Files Used (for private system metadata) possible value(s) are, integer

Filled in for CMode CLI

=item C<< is_resyncing >>

Resync is in Progress possible value(s) are, true,false

Filled in for CMode CLI

=item C<< chksumstatus >>

Checksum Status possible value(s) are, text

Filled in for CMode CLI

=item C<< volcount_quiesced >>

Number of Quiesced Volumes possible value(s) are, integer

Filled in for CMode CLI

=item C<< fs_maxfiles_possible >>

Largest Possible Value of fs-maxfiles-available possible value(s) are, integer

Filled in for CMode CLI

=item C<< fs_maxfiles_available >>

Total Files (for user-visible data) possible value(s) are, integer

Filled in for CMode CLI

=item C<< collective_volcount >>

Collective volume count possible value(s) are, integer

Filled in for CMode CLI

=back

=cut

package NACL::CS::StorageAggregateShowView;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'checksum_style',
    scalar => 'volume_footprints_percent',
    scalar => 'ha_policy',
    scalar => 'volume_footprints',
    scalar => 'snap_maxfiles_possible',
    scalar => 'home_name',
    scalar => 'fs_maxfiles_used',
    scalar => 'diskcount',
    scalar => 'home_id',
    scalar => 'recomputing_parity_percentage',
    scalar => 'free_space_realloc',
    scalar => 'snap_maxfiles_used',
    scalar => 'files_used',
    scalar => 'usedsize',
    scalar => 'block_type',
    scalar => 'snap_maxfiles_available',
    scalar => 'files_total',
    scalar => 'maxraidsize',
    scalar => 'has_partner_mroot',
    scalar => 'is_reconstructing',
    scalar => 'snap_size_total',
    scalar => 'aggregate_metadata_percent',
    scalar => 'upgrade_64bit_is_in_progress',
    scalar => 'upgrade_64bit_cookie',
    scalar => 'max_write_alloc_blocks',
    scalar => 'striping',
    scalar => 'chksumenabled',
    scalar => 'upgrade_64bit_is_estimate_complete',
    scalar => 'iron_summary_scan_percentage',
    scalar => 'size',
    scalar => 'volcount_not_online',
    scalar => 'aggregate_metadata',
    scalar => 'owner_name',
    scalar => 'pool',
    scalar => 'chksumstyle',
    scalar => 'snaplock_type',
    scalar => 'iron_last_start_errno',
    scalar => 'resyncing_percent',
    scalar => 'fsid',
    scalar => 'fs_inodefile_private_capacity',
    scalar => 'iron_status',
    scalar => 'hybrid',
    scalar => 'raid_lost_write_state',
    scalar => 'snap_percent_inode_used_capacity',
    scalar => 'upgrade_64bit_added_space',
    scalar => 'mirror_status',
    scalar => 'snap_size_available',
    scalar => 'is_recomputing_parity',
    scalar => 'upgrade_64bit_min_space_for_upgrade',
    scalar => 'dr_home_id',
    scalar => 'snap_files_used',
    scalar => 'uuid',
    scalar => 'state',
    scalar => 'raidgroup',
    scalar => 'striped_volcount',
    scalar => 'hybrid_cache_size_total',
    scalar => 'is_snaplock',
    scalar => 'dr_home_name',
    scalar => 'mirror_count_move_destinations',
    scalar => 'upgrade_64bit_check_last_errno',
    scalar => 'snap_files_total',
    scalar => 'member_count',
    scalar => 'availsize',
    scalar => 'fs_total_reserved_space',
    scalar => 'fs_inodefile_public_capacity',
    scalar => 'inconsistent',
    scalar => 'owner_id',
    scalar => 'upgrade_64bit_start_last_errno',
    scalar => 'type',
    array  => 'nodes',
    scalar => 'has_mroot',
    scalar => 'is_cache_tier',
    scalar => 'mirror_count_ls_destinations',
    scalar => 'reconstruction_percent',
    scalar => 'snap_size_used',
    scalar => 'plex_path',
    scalar => 'plex_count',
    scalar => 'iron_last_start_error_info',
    scalar => 'is_online',
    scalar => 'percent_used',
    scalar => 'iron_scan_percentage',
    scalar => 'status',
    scalar => 'hybrid_enabled',
    scalar => 'resync_level',
    array  => 'disklist',
    scalar => 'mirror_count_dp_destinations',
    scalar => 'plex',
    array  => 'mirror_disklist',
    scalar => 'snap_percent_used_capacity',
    scalar => 'volcount',
    scalar => 'aggregate',
    scalar => 'mount_state',
    scalar => 'fs_percent_inode_used_capacity',
    scalar => 'raidstatus',
    scalar => 'fs_files_private_used',
    scalar => 'is_resyncing',
    scalar => 'chksumstatus',
    scalar => 'volcount_quiesced',
    scalar => 'fs_maxfiles_possible',
    scalar => 'fs_maxfiles_available',
    scalar => 'collective_volcount',
];

=head1 METHODS

=head2 fetch

    my $StorageAggregateShowView_state  = NACL::CS::StorageAggregateShowView->fetch(command_interface => $ci, ...);
	my @StorageAggregateShowView_states = NACL::CS::StorageAggregateShowView->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;

    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'storage aggregate show-view',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching storage aggregate(s) found',
        frontend       => 'NACL::CS::StorageAggregateShowView::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %args) = @_;
    my $is_promoted = $args{'command_interface'}->get_version_manager()->is_promoted();
    if( $is_promoted ) {
        if ( $args{filter}
            && $args{filter}->{'block-type'} ) {
            $Log->warn("\n The block-type field is not valid with diag priv, thus removing this field " .
                   " from filter hash in the call to NACL::CS::StorageAggregateShowView->fetch" .
                   " Please update your scripts");
        delete $args{filter}->{'block-type'};
        }

        my $requested_fields = delete $args{'requested_fields'};

        if ( $requested_fields ) {
            my %hash;
            map { $hash{$_} = 1 } @{ $requested_fields };
            if ( $hash{'block-type'} ) {
               $Log->warn("\n The block-type field is not valid with diag priv, thus removing this field " .
                   " from requested_fields in the call to NACL::CS::StorageAggregateShowView->fetch." .
                   " Please update your scripts");
               delete $hash{'block-type'};
               my @keys = keys %hash;
               $args{'requested_fields'} = \@keys;
            }
        }
    }
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(%args,
        api => 'storage_aggregate_show_view',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
