# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageAggregateVote ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageAggregateVote

=head1 DESCRIPTION

C<NACL::CS::StorageAggregateVote> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP StorageAggregateVote.  A related class is
L<NACL::C::StorageAggregateVote|lib-NACL-C-StorageAggregateVote-pm>, which represents access
to an ONTAP StorageAggregateVote.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the StorageAggregateVote
element are the attributes of the StorageAggregateVote ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< nplexes >>

Number of Plexes

Filled in for CMode CLI

=item C<< aggrID >>

Aggregate UUID

Filled in for CMode CLI

=item C<< plex1_ctime >>

Plex1 Creation Time

Filled in for CMode CLI

=item C<< cluster_uuid >>

Cluster UUID

Filled in for CMode CLI

=item C<< trans_time >>

Transaction Time

Filled in for CMode CLI

=item C<< trans_gen >>

Generation ID of Transaction

Filled in for CMode CLI

=item C<< plex0_id >>

Plex0 ID ranges from -3 to 1

Filled in for CMode CLI

=item C<< aggr_ctime >>

Aggregate Creation Time

Filled in for CMode CLI

=item C<< creator_bladeID >>

Creator Dblade ID

Filled in for CMode CLI

=item C<< aggregate >>

Aggregate

Filled in for CMode CLI

=item C<< plex0_ctime >>

Plex0 Creation Time

Filled in for CMode CLI

=item C<< plex1_id >>

Plex1 ID ranges from -3 to 1

Filled in for CMode CLI

=item C<< update_context >>

Update Context from DBlade

Filled in for CMode CLI.


=back

=cut

package NACL::CS::StorageAggregateVote;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'nplexes',
    scalar => 'aggrID',
    scalar => 'plex1_ctime',
    scalar => 'cluster_uuid',
    scalar => 'trans_time',
    scalar => 'trans_gen',
    scalar => 'plex0_id',
    scalar => 'aggr_ctime',
    scalar => 'creator_bladeID',
    scalar => 'aggregate',
    scalar => 'plex0_ctime',
    scalar => 'plex1_id',
    scalar => 'update_context',
];

=head1 METHODS

=head2 fetch

    my $StorageAggregateVote_state  = NACL::CS::StorageAggregateVote->fetch(command_interface => $ci, ...);
	my @StorageAggregateVote_states = NACL::CS::StorageAggregateVote->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'storage aggregate vote show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching storage aggregate vote(s) found',
        frontend       => 'NACL::CS::StorageAggregateVote::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'storage_aggregate_vote_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
