# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageAggregateWaflironBackup ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageAggregateWaflironBackup

=head1 DESCRIPTION

C<NACL::CS::StorageAggregateWaflironBackup> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP StorageAggregateWaflironBackup.  A related class is
L<NACL::C::StorageAggregateWaflironBackup|lib-NACL-C-StorageAggregateWaflironBackup-pm>, which represents access
to an ONTAP StorageAggregateWaflironBackup.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the StorageAggregateWaflironBackup
element are the attributes of the StorageAggregateWaflironBackup ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< fs_version >>

*ONTAP file system version.

Filled in for CMode CLI

=item C<< ctime >>

*Image Creation Time

Filled in for CMode CLI

=item C<< reserve_delta >>

*Aggregate Reserve Delta

Filled in for CMode CLI

=item C<< status >>

*Image Status

Filled in for CMode CLI

=item C<< restore_delta_flag >>

*Aggregate Reserve Restore Flag, possible value(s) are true,false

Filled in for CMode CLI

=item C<< name >>

*Image Name

Filled in for CMode CLI

=item C<< blocks_used >>

*Blocks Used by Image

Filled in for CMode CLI

=item C<< voltype >>

Filled in for CMode CLI

=item C<< cp_count >>

*WAFL CP Count of The Image

Filled in for CMode CLI

=item C<< filerid >>

Filled in for CMode CLI

=item C<< expiration >>

*Expiration Time of The Image

Filled in for CMode CLI

=item C<< reserve_inctried >>

*Attempted to Increase Snap Reserve, possible value(s) are true,false

Filled in for CMode CLI

=item C<< id >>

*Image ID

Filled in for CMode CLI

=item C<< aggregate >>

*Aggregate

Filled in for CMode CLI

=back

=cut

package NACL::CS::StorageAggregateWaflironBackup;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'fs_version',
    scalar => 'ctime',
    scalar => 'reserve_delta',
    scalar => 'status',
    scalar => 'restore_delta_flag',
    scalar => 'name',
    scalar => 'blocks_used',
    scalar => 'voltype',
    scalar => 'cp_count',
    scalar => 'filerid',
    scalar => 'expiration',
    scalar => 'reserve_inctried',
    scalar => 'id',
    scalar => 'aggregate',
];

=head1 METHODS

=head2 fetch

    my $StorageAggregateWaflironBackup_state  = NACL::CS::StorageAggregateWaflironBackup->fetch(command_interface => $ci, ...);
	my @StorageAggregateWaflironBackup_states = NACL::CS::StorageAggregateWaflironBackup->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'storage aggregate wafliron backup show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching storage aggregate wafliron backup(s) found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'storage_aggregate_wafliron_backup_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
