# $Id: //depot/prod/test/nacldev/lib/NACL/CS/StorageDownload.pm#1 $
#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState module for the method NACL::C::StorageFirmware->download()
## @author sangavai@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageDownload

=head1 DESCRIPTION

C<NACL::CS::StorageDownload> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this
type are returned when NACL::C::StorageDownload->verify_status() is invoked.

(This module does not represent the state of any element, but is an object
repesentation of the output obtained when the aggregate verify command
is invoked with the action being status.

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< status >>

Status of the download.

=back

=cut

package NACL::CS::StorageDownload;

use strict;
use warnings;

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'status',
];

1;

