#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageFailoverHwassist ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageFailoverHwassist

=head1 DESCRIPTION

C<NACL::CS::StorageFailoverHwassist> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP StorageFailoverHwassist.  A related class is
L<NACL::C::StorageFailoverHwassist|lib-NACL-C-StorageFailoverHwassist-pm>, which represents access
to an ONTAP StorageFailoverHwassist.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the StorageFailoverHwassist
element are the attributes of the StorageFailoverHwassist ComponentState.

=over

=item C<< "test" >>

=item C<< "loss_of_heartbeat" >>

=item C<< "partner_name" >>

=item C<< "reset_via_rlm" >>

=item C<< "local_port" >>
This maps to local-hwassist-port for zapi

=item C<< "bad_nvram_id" >>

=item C<< "local_inactive" >>

=item C<< "abnormal_reboot" >>

=item C<< "post_error" >>

=item C<< "partner_inactive" >>

=item C<< "enabled" >>

=item C<< "local_action" >>

=item C<< "local_status" >>
This maps to local-hwassist-status for zapi

=item C<< "power_off_via_sp" >>

=item C<< "no_status" >>

=item C<< "watchdog_reset" >>

=item C<< "status" >>

=item C<< "partner_ip" >>
This maps to partner-hwassist-ipaddr for zapi

=item C<< "partner_status" >>
This maps to partner-hwassist-status for zapi

=item C<< "reset_via_sp" >>

=item C<< "node" >>

=item C<< "power_cycle_via_sp" >>

=item C<< "partner_port" >>
This maps to partner-hwassist-port for zapi

=item C<< "power_off_via_rlm" >>

=item C<< "ss_mismatch" >>

=item C<< "no_stats" >>

=item C<< "local_ip" >>
This maps to local-hwassist-ipaddr for zapi

=item C<< "times_throttled" >>

=item C<< "partner_action" >>

=item C<< "power_loss" >>

=item C<< "keep_alive" >>

=item C<< "power_cycle_via_rlm" >>

=item C<< "unknown_alerts" >>

=item C<< stats_header >>

Filled in for CMode CLI/ZAPI.


=item C<< keep_alive_status >>

Filled in for CMode CLI.


=back

=cut

package NACL::CS::StorageFailoverHwassist;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'test',
    scalar => 'loss_of_heartbeat',
    scalar => 'partner_name',
    scalar => 'reset_via_rlm',
    scalar => 'local_port',
    scalar => 'bad_nvram_id',
    scalar => 'local_inactive',
    scalar => 'abnormal_reboot',
    scalar => 'post_error',
    scalar => 'partner_inactive',
    scalar => 'enabled',
    scalar => 'local_action',
    scalar => 'local_status',
    scalar => 'power_off_via_sp',
    scalar => 'no_status',
    scalar => 'watchdog_reset',
    scalar => 'status',
    scalar => 'partner_ip',
    scalar => 'partner_status',
    scalar => 'reset_via_sp',
    scalar => 'node',
    scalar => 'power_cycle_via_sp',
    scalar => 'partner_port',
    scalar => 'power_off_via_rlm',
    scalar => 'ss_mismatch',
    scalar => 'no_stats',
    scalar => 'local_ip',
    scalar => 'times_throttled',
    scalar => 'partner_action',
    scalar => 'power_loss',
    scalar => 'keep_alive',
    scalar => 'power_cycle_via_rlm',
    scalar => 'unknown_alerts',
    scalar => 'stats_header',
    scalar => 'keep_alive_status',
];

=head1 METHODS

=head2 fetch

    my $StorageFailoverHwassist_state   = NACL::CS::StorageFailoverHwassist->fetch(command_interface => $ci, ...);
    my @StorageFailoverHwassist_states = NACL::CS::StorageFailoverHwassist->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
            {   method    => '_fetch_7mode_cli',
                interface => 'CLI',
                set       => '7Mode',
            },
        ],
        exception_text => 'No matching storage failover hwassist(s) found',
        show_cmd       => 'storage failover hwassist show',
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'storage_failover_hwassist_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg    = shift;
    my %opts   = validate @_, $pkg->_fetch_backend_validate_spec();
    my $apiset = $opts{apiset};
    my $filter = $opts{filter};
    my $hwassist_response;
    my @state_objs;

    my %hw_args;
    $hw_args{'node'} = $filter->{'node'};
    $hwassist_response = $apiset->cf_hwassist_status(%hw_args);
    my $hwassist_output = $hwassist_response->get_parsed_output();

    foreach my $row (@{$hwassist_output}) {
        my $state_fields = $pkg->_zapi_hash_copy(
            source => $row,
            copy   => [qw( node partner-name)],
            map    => [
                'partner-hwassist-ipaddr' => 'partner-ip',
                'partner-hwassist-port'   => 'partner-port',
                'local-hwassist-ipaddr'   => 'local-ip',
                'local-hwassist-status'   => 'local-status',
                'partner-hwassist-status' => 'partner-status',
                'local-hwassist-port'     => 'local-port',
            ],
        );
        $state_fields->{'node'} = $hw_args{'node'};
        my $obj = $pkg->new(command_interface => $opts{command_interface});
        $obj->_set_fields(row => $state_fields);
        push @state_objs, $obj;
    }

    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

sub _fetch_7mode_cli {
    $Log->enter() if $may_enter;

    my $pkg               = shift;
    my %opts              = validate @_, $pkg->_fetch_backend_validate_spec();
    my $apiset            = delete $opts{apiset};
    my $command_interface = delete $opts{command_interface};
    my @state_objs;
    my $response = $apiset->cf_hw_assist_status();
    my $output   = $response->get_parsed_output();
    my $final_attributes;
    my $local;
    my $partner;
    my $arr;
    my $obj = $pkg->new();
    my %result;

    foreach my $row (@$output) {
        foreach my $key (keys %$row) {
            if ($key eq "local_node") {
                $local = $row->{$key};
            } elsif ($key eq "partner_node") {
                $partner = $row->{$key};
            } elsif ($key eq "local_node_info") {
                $arr = $row->{$key};
                foreach my $val (@$arr) {
                    if (defined($val)) {
                        $final_attributes = $pkg->_hash_copy(
                            source => $val,
                            map    => {
                                'alerts_from' => 'partner_name',
                                'ip_address'  => 'local_ip',
                                'port'        => 'local_port',
                                'status'      => 'local-status',
                            },
                        );

                        $$final_attributes{"node"} = $local;
                    }
                }
            } elsif ($key eq "partner_node_info") {
                $arr = $row->{$key};
                foreach my $val (@$arr) {
                    if (defined($val)) {
                        $final_attributes = $pkg->_hash_copy(
                            source => $val,
                            map    => {
                                'ip_address' => 'partner-ip',
                                'port'       => 'partner-port',
                                'status'     => 'partner-status',
                            },
                        );

                    }
                }
            }

            for my $key1 (keys %$final_attributes) {
                $result{"$key1"} = $$final_attributes{"$key1"};
            }
        }
    }
    $obj->_set_fields(row => \%result);
    push @state_objs, $obj;
    $Log->exit() if $may_exit;
    return @state_objs;

} ## end sub _fetch_7mode_cli
1;
