# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageFailoverInterconnectResetStatus ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageFailoverInterconnectResetStatus

=head1 DESCRIPTION

C<NACL::CS::StorageFailoverInterconnectResetStatus> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP StorageFailoverInterconnectResetStatus.  A related class is
L<NACL::C::StorageFailoverInterconnectResetStatus|lib-NACL-C-StorageFailoverInterconnectResetStatus-pm>, which represents access
to an ONTAP StorageFailoverInterconnectResetStatus.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the StorageFailoverInterconnectResetStatus
element are the attributes of the StorageFailoverInterconnectResetStatus ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< is_auto_reset_enabled >>

Auto-Reset Status: possible value(s) are, true,false

Filled in for CMode CLI

=item C<< timeout >>

Reset Timeout (ms)

Filled in for CMode CLI

=item C<< node >>

Node possible value(s) are, <nodename>,local

Filled in for CMode CLI

=back

=cut

package NACL::CS::StorageFailoverInterconnectResetStatus;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'is_auto_reset_enabled',
    scalar => 'timeout',
    scalar => 'node',
];

=head1 METHODS

=head2 fetch

    my $StorageFailoverInterconnectResetStatus_state  = NACL::CS::StorageFailoverInterconnectResetStatus->fetch(command_interface => $ci, ...);
	my @StorageFailoverInterconnectResetStatus_states = NACL::CS::StorageFailoverInterconnectResetStatus->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'storage failover interconnect reset status show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching storage failover interconnect reset status(s) found',
        frontend => 'NACL::CS::StorageFailoverInterconnectResetStatus::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'storage_failover_interconnect_reset_status_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
