# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageShelfError ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageShelfError

=head1 DESCRIPTION

C<NACL::CS::StorageShelfError> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP StorageShelfError.  A related class is
L<NACL::C::StorageShelfError|lib-NACL-C-StorageShelfError-pm>, which represents access
to an ONTAP StorageShelfError.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the StorageShelfError
element are the attributes of the StorageShelfError ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)


=item C<< error_type >>


Error Type possible value(s) are, unknown,acpp,bay,configuration,current,disk,internal,fan,module,port,power,temperature,voltage
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $error_type = $obj->error_type();
 
# $error_type contains a reference to the array of values
 
my @error_type = $obj->error_type();
 
# @error_type contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { error_type = [ value1, value2...] }

Filled in for CMode CLI

=item C<< shelf_component >>

Shelf component with error
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $shelf_component = $obj->shelf_component();
 
# $shelf_component contains a reference to the array of values
 
my @shelf_component = $obj->shelf_component();
 
# @shelf_component contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { shelf_component = [ value1, value2...] }

Filled in for CMode CLI

=item C<< op_status >>


Shelf Operational Status possible value(s) are, unknown,normal,warning,error,critical
Filled in for CMode CLI

=item C<< node >>

Node possible value(s) are, <nodename>,local
Filled in for CMode CLI

=item C<< error_count >>

Number of errors for this shelf possible value(s) are, <integer>,-
Filled in for CMode CLI

=item C<< state >>


Shelf State possible value(s) are, unknown,no-status,init-required,online,offline,missing
Filled in for CMode CLI

=item C<< error_text >>

Error Text
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $error_text = $obj->error_text();
 
# $error_text contains a reference to the array of values
 
my @error_text = $obj->error_text();
 
# @error_text contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { error_text = [ value1, value2...] }

Filled in for CMode CLI

=item C<< corrective_action >>

Corrective Action
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $corrective_action = $obj->corrective_action();
 
# $corrective_action contains a reference to the array of values
 
my @corrective_action = $obj->corrective_action();
 
# @corrective_action contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { corrective_action = [ value1, value2...] }

Filled in for CMode CLI

=item C<< disk_count >>

Disk Count possible value(s) are, <integer>,-
Filled in for CMode CLI

=item C<< shelf_uid >>

Shelf UID
Filled in for CMode CLI

=item C<< error_severity >>


Error Severity possible value(s) are, unknown,notice,warning,error,critical
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $error_severity = $obj->error_severity();
 
# $error_severity contains a reference to the array of values
 
my @error_severity = $obj->error_severity();
 
# @error_severity contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { error_severity = [ value1, value2...] }

Filled in for CMode CLI

=item C<< shelf_uuid >>

Shelf UID
Filled in for CMode CLI

=item C<< serial_number >>

Shelf Serial Number
Filled in for CMode CLI

=item C<< stack_id >>

Stack ID possible value(s) are, <integer>,-
Filled in for CMode CLI

=item C<< error_id >>

Error Identifier possible value(s) are, <integer>,-
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $error_id = $obj->error_id();
 
# $error_id contains a reference to the array of values
 
my @error_id = $obj->error_id();
 
# @error_id contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { error_id = [ value1, value2...] }

Filled in for CMode CLI

=item C<< is_local_attach >>

Is the Shelf Local to This Cluster? possible value(s) are, true,false
Filled in for CMode CLI

=item C<< module_type >>


Shelf Module Type possible value(s) are, unknown,atfcx,esh4,iom3,iom6,iom6e
Filled in for CMode CLI

=item C<< shelf >>

Shelf Name
Filled in for CMode CLI

=item C<< connection_type >>

Shelf Connection Type possible value(s) are, unknown,fc,sas
Filled in for CMode CLI

=item C<< component_location >>

Location of component with error
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $component_location = $obj->component_location();
 
# $component_location contains a reference to the array of values
 
my @component_location = $obj->component_location();
 
# @component_location contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { component_location = [ value1, value2...] }

Filled in for CMode CLI

=item C<< error_type_zapi >>


Error Type possible value(s) are, unknown,acpp,bay,configuration,current,disk,internal,fan,module,port,power,temperature,voltage
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $error_type_zapi = $obj->error_type_zapi();
 
# $error_type_zapi contains a reference to the array of values
 
my @error_type_zapi = $obj->error_type_zapi();
 
# @error_type_zapi contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { error_type_zapi = [ value1, value2...] }

Filled in for CMode CLI

=item C<< product_id >>

Shelf Product Identification
Filled in for CMode CLI

=item C<< shelf_id >>

Shelf ID
Filled in for CMode CLI

=item C<< vendor >>

Shelf Vendor
Filled in for CMode CLI
=back

=cut

package NACL::CS::StorageShelfError;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'error_type',
    array  => 'shelf_component',
    scalar => 'op_status',
    scalar => 'node',
    scalar => 'error_count',
    scalar => 'state',
    array  => 'error_text',
    array  => 'corrective_action',
    scalar => 'disk_count',
    scalar => 'shelf_uid',
    array  => 'error_severity',
    scalar => 'shelf_uuid',
    scalar => 'serial_number',
    scalar => 'stack_id',
    array  => 'error_id',
    scalar => 'is_local_attach',
    scalar => 'module_type',
    scalar => 'shelf',
    scalar => 'connection_type',
    array  => 'component_location',
    array  => 'error_type_zapi',
    scalar => 'product_id',
    scalar => 'shelf_id',
    scalar => 'vendor',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 fetch

    my $StorageShelfError_state  = NACL::CS::StorageShelfError->fetch(command_interface => $ci, ...);
	my @StorageShelfError_states = NACL::CS::StorageShelfError->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        show_cmd => 'storage shelf error show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },

        ],
        exception_text => 'No matching StorageShelfError(s) found',
        frontend       => 'NACL::CS::StorageShelfError::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _update_state_objs_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->SUPER::_update_state_objs_cmode_zapi(
        @args,
        zapi_field_translations => {
            hyphenate_value => [
                qw(op-status error-severity connection-type error-type-zapi state error-type)
            ],
        },
    );
    $Log->exit() if $may_exit;
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'storage_shelf_error_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
