#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemHealthAlert ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemHealthAlert

=head1 DESCRIPTION

C<NACL::CS::SystemHealthAlert> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SystemHealthAlert.  A related class is
L<NACL::C::SystemHealthAlert|lib-NACL-C-SystemHealthAlert-pm>, which represents access
to an ONTAP SystemHealthAlert.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the SystemHealthAlert
element are the attributes of the SystemHealthAlert ComponentState.

=over

=item C<< "alert_id" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <alert-id>$value</alert-id>
</diagnosis-alert-info>

=item C<< "perceived_severity" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <perceived-severity>$value</perceived-severity>
</diagnosis-alert-info>

=item C<< "additional_info" >>
(Array)

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <additional-info>
        <string>$value</string>
    </additional-info>
</diagnosis-alert-info>

=item C<< "monitor" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <monitor>$value</monitor>
</diagnosis-alert-info>

=item C<< "node" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <node>$value</node>
</diagnosis-alert-info>

=item C<< "possible_effect" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <possible-effect>$value</possible-effect>
</diagnosis-alert-info>

=item C<< "acknowledge" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <acknowledge>$value</acknowledge>
</diagnosis-alert-info>

=item C<< "indication_time" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <indication_time>$value</indication-time>
</diagnosis-alert-info>

=item C<< "probable_cause_description" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <probable-cause-description>$value</probable-cause-description>
</diagnosis-alert-info>

=item C<< "suppressor" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <suppressor>$value</suppressor>
</diagnosis-alert-info>

=item C<< "probable_cause" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <probable-cause>$value</probable-cause>
</diagnosis-alert-info>

=item C<< "recommended_actions" >>

=item C<< "suppress" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <suppress>$value</suppress>
</diagnosis-alert-info>

=item C<< "pol_id" >>

=item C<< "alerting_managed_element" >>

=item C<< "subsystem" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <subsystem>$value</subsystem>
</diagnosis-alert-info>

=item C<< "acknowledger" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <acknowledger>$value</acknowledger>
</diagnosis-alert-info>

=item C<< corrective_actions >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <corrective-actions>$value</corrective-actions>
</diagnosis-alert-info>

=item C<< policy >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <policy>$value</policy>
</diagnosis-alert-info>

=item C<< alerting_resource_name >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <alerting-resource-name>$value</alerting-resource-name>
</diagnosis-alert-info>

=item C<< alerting_resource >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

<diagnosis-alert-info>
    <alerting-resource>$value</alerting-resource>
</diagnosis-alert-info>

=item C<< process >>

Filled in for CMode CLI.

=item C<< tags >>

Filled in for CMode CLI.

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $tags = $obj->tags();
# $tags contains a reference to the array of values
my @tags = $obj->tags();
# @tags contains the array of values

Filled in for CMode CLI/ZAPI.
Filled in for CMode CLI.


=item C<< asup_enable >>

Filled in for CMode CLI.


=item C<< resource_id >>

ID Of the Resource

Filled in for CMode CLI.


=back

=cut

package NACL::CS::SystemHealthAlert;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'alert_id',
    scalar => 'perceived_severity',
    array  => 'additional_info',
    scalar => 'monitor',
    scalar => 'node',
    scalar => 'possible_effect',
    scalar => 'acknowledge',
    scalar => 'indication_time',
    scalar => 'probable_cause_description',
    scalar => 'suppressor',
    scalar => 'probable_cause',
    scalar => 'recommended_actions',
    scalar => 'suppress',
    scalar => 'pol_id',
    scalar => 'alerting_managed_element',
    scalar => 'subsystem',
    scalar => 'acknowledger',
    scalar => 'corrective_actions',
    scalar => 'policy',
    scalar => 'alerting_resource_name',
    scalar => 'alerting_resource',
    scalar => 'process',
    array  => 'tags',
    scalar => 'asup_enable',
    scalar => 'resource_id',
];

=head1 METHODS

=head2 fetch

    my $SystemHealthAlert_state   = NACL::CS::SystemHealthAlert->fetch(command_interface => $ci, ...);
	my @SystemHealthAlert_states = NACL::CS::SystemHealthAlert->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI/ZAPI APISet.
This methos uses diagnosis-alert-get-iter for CMode zapi.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        show_cmd       => 'system health alert show',
        exception_text => 'No matching system health alert(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(%opts,
        api => 'system_health_alert_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        %opts,
        api  => 'diagnosis_alert_get_iter',
        copy => [
            qw(
                acknowledger alert-id alerting-managed-element alerting-resource
                alerting-resource-name corrective-actions indication-time monitor
                node perceived-severity pol-id policy possible-effect
                probable-cause probable-cause-description recommended-actions subsystem
                suppress suppressor acknowledge
                )
        ],
        map => {
            'additional-info' => [
                make_zapi_array('additional-info'),
                make_zapi_skip('string'),
            ],
        }
    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

1;
