# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemHealthClusterSwitchPollingInterval ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemHealthClusterSwitchPollingInterval

=head1 DESCRIPTION

C<NACL::CS::SystemHealthClusterSwitchPollingInterval> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SystemHealthClusterSwitchPollingInterval.  A related class is
L<NACL::C::SystemHealthClusterSwitchPollingInterval|lib::NACL-C-SystemHealthClusterSwitchPollingInterval-pm>, which represents access
to an ONTAP SystemHealthClusterSwitchPollingInterval.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the SystemHealthClusterSwitchPollingInterval
element are the attributes of the SystemHealthClusterSwitchPollingInterval ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< polling_interval >>

Polling Interval ranges from 2 to 120

Filled in for CMode CLI

=back

=cut

package NACL::CS::SystemHealthClusterSwitchPollingInterval;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [scalar => 'polling_interval',];

=head1 METHODS

=head2 fetch

    my $SystemHealthClusterSwitchPollingInterval_state  = NACL::CS::SystemHealthClusterSwitchPollingInterval->fetch(command_interface => $ci, ...);
(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. This being a "singleton" table (i.e. one which can only have one
row) is callable only in scalar context.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'system health cluster-switch polling-interval show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching system health cluster-switch polling-interval(s) found',
        frontend =>
            'NACL::CS::SystemHealthClusterSwitchPollingInterval::fetch',
        is_singleton => 1
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(
        @args,
        api          => 'system_health_cluster_switch_polling_interval_show',
        is_singleton => 1,
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
