# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemHealthControllerMemoryDimm ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemHealthControllerMemoryDimm

=head1 DESCRIPTION

C<NACL::CS::SystemHealthControllerMemoryDimm> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SystemHealthControllerMemoryDimm.  A related class is
L<NACL::C::SystemHealthControllerMemoryDimm|lib-NACL-C-SystemHealthControllerMemoryDimm-pm>, which represents access
to an ONTAP SystemHealthControllerMemoryDimm.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the SystemHealthControllerMemoryDimm
element are the attributes of the SystemHealthControllerMemoryDimm ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< part_no >>

*Model Number

Filled in for CMode CLI

=item C<< cecc_count >>

*Correctable ECC error count

Filled in for CMode CLI

=item C<< serial >>

*Serial Number

Filled in for CMode CLI

=item C<< status >>

*Status, possible value(s) are Ok,Ok_with_suppressed,degraded,unreachable

Filled in for CMode CLI

=item C<< name >>

*Unique name of DIMM

Filled in for CMode CLI

=item C<< monitor >>

*Monitor Name, possible value(s) are
node-connect,system-connect,system,controller,chassis,cluster-switch,example

Filled in for CMode CLI

=item C<< channel >>

*Channel

Filled in for CMode CLI

=item C<< node >>

*Node

Filled in for CMode CLI

=item C<< display_name >>

*Display name for the DIMM

Filled in for CMode CLI

=item C<< socket >>

*CPU Socket

Filled in for CMode CLI

=item C<< pds_id >>

*DIMM ID

Filled in for CMode CLI

=item C<< uecc_count >>

*Uncorrectable ECC error count

Filled in for CMode CLI

=item C<< slotname >>

*Slot Name

Filled in for CMode CLI

=item C<< slot_no >>

*Slot number on a channel

Filled in for CMode CLI

=back

=cut

package NACL::CS::SystemHealthControllerMemoryDimm;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'part_no',
    scalar => 'cecc_count',
    scalar => 'serial',
    scalar => 'status',
    scalar => 'name',
    scalar => 'monitor',
    scalar => 'channel',
    scalar => 'node',
    scalar => 'display_name',
    scalar => 'socket',
    scalar => 'pds_id',
    scalar => 'uecc_count',
    scalar => 'slotname',
    scalar => 'slot_no',
];

=head1 METHODS

=head2 fetch

    my $SystemHealthControllerMemoryDimm_state  = NACL::CS::SystemHealthControllerMemoryDimm->fetch(command_interface => $ci, ...);
	my @SystemHealthControllerMemoryDimm_states = NACL::CS::SystemHealthControllerMemoryDimm->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'system controller memory dimm show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching system controller memory dimm(s) found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'system_controller_memory_dimm_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
