#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemNodeHardwareTapeDrive ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemNodeHardwareTapeDrive

=head1 DESCRIPTION

C<NACL::CS::SystemNodeHardwareTapeDrive> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SystemNodeHardwareTapeDrive.  A related class is
L<NACL::C::SystemNodeHardwareTapeDrive|lib-NACL-C-SystemNodeHardwareTapeDrive-pm>, which represents access
to an ONTAP SystemNodeHardwareTapeDrive.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the SystemNodeHardwareTapeDrive
element are the attributes of the SystemNodeHardwareTapeDrive ComponentState.

=over

=item C<< "ndmp_path" >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $ndmp_path = $obj->ndmp_path();
# $ndmp_path contains a reference to the array of values
my @ndmp_path = $obj->ndmp_path();
# @ndmp_path contains the array of values

Filled in for CMode CLI.

=item C<< "serial_number" >>

Filled in for CMode CLI.

=item C<< "node" >>

Filled in for CMode CLI.

=item C<< "description" >>

Filled in for CMode CLI.

=item C<< "wwn" >>

Filled in for CMode CLI.

=item C<< "device_id" >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::SystemNodeHardwareTapeDrive;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'ndmp_path',
    scalar => 'serial_number',
    scalar => 'node',
    scalar => 'description',
    scalar => 'wwn',
    scalar => 'device_id',
];

=head1 METHODS

=head2 fetch

    my $SystemNodeHardwareTapeDrive_state   = NACL::CS::SystemNodeHardwareTapeDrive->fetch(command_interface => $ci, ...);
	my @SystemNodeHardwareTapeDrive_states = NACL::CS::SystemNodeHardwareTapeDrive->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'system node hardware tape drive show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text =>
            'No matching system node hardware tape drive(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'system_node_hardware_tape_drive_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
