# $Id$ //depot/prod/test/nacldev/lib/NACL/CS/SystemNodeServiceProcessorImageUpdateProgress.pm#6

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemNodeServiceProcessorImageUpdateProgress ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com,skotagir@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemNodeServiceProcessorImageUpdateProgress

=head1 DESCRIPTION

C<NACL::CS::SystemNodeServiceProcessorImageUpdateProgress> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SystemNodeServiceProcessorImageUpdateProgress.  A related class is
L<NACL::C::SystemNodeServiceProcessorImageUpdateProgress|lib-NACL-C-SystemNodeServiceProcessorImageUpdateProgress-pm>, which represents access
to an ONTAP SystemNodeServiceProcessorImageUpdateProgress.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the SystemNodeServiceProcessorImageUpdateProgress
element are the attributes of the SystemNodeServiceProcessorImageUpdateProgress ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< start_time >>

Latest SP Firmware Update Start Timestamp
Filled in for CMode CLI, CMode ZAPI,7Mode CLI.

Maps to:

7M CLI : start-time

CM ZAPI :
    <service-processor-image-update-progress-info>
        <start-time>$value</start-time>
    </service-processor-image-update-progress-info>

=item C<< in_progress >>

Is Update in Progress, possible value(s) are yes,no
Filled in for CMode CLI, CMode ZAPI,7Mode CLI.

Maps to:

7M CLI : in-progress

CM ZAPI :
    <service-processor-image-update-progress-info>
        <is-in-progress>$value</is-in-progress>
    </service-processor-image-update-progress-info>

=item C<< end_time >>

Latest SP Firmware Update End Timestamp
Filled in for CMode CLI, CMode ZAPI,7Mode CLI.

Maps to:

7M CLI : end-time

CM ZAPI :
    <service-processor-image-update-progress-info>
        <end-time>$value</end-time>
    </service-processor-image-update-progress-info>

=item C<< percent_done >>

Latest SP Firmware Update Percentage Done
Filled in for CMode CLI, CMode ZAPI,7Mode CLI.

Maps to:

7M CLI : percent-done

CM ZAPI :
    <service-processor-image-update-progress-info>
        <percent-done>$value</percent-done>
    </service-processor-image-update-progress-info>

=item C<< node >>

Node
Filled in for CMode CLI, CMode ZAPI,7Mode CLI.

Maps to:

7M CLI : nodename

CM ZAPI :
    <service-processor-image-update-progress-info>
        <node>$value</node>
    </service-processor-image-update-progress-info>

=back

=cut

package NACL::CS::SystemNodeServiceProcessorImageUpdateProgress;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::CS::_Mixins::SystemNodeServiceProcessor qw(:all);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'start_time',
    scalar => 'in_progress',
    scalar => 'end_time',
    scalar => 'percent_done',
    scalar => 'node',
];

=head1 METHODS

=head2 fetch

    my $SystemNodeServiceProcessorImageUpdateProgress_state  = NACL::CS::SystemNodeServiceProcessorImageUpdateProgress->fetch(command_interface => $ci, ...);
	my @SystemNodeServiceProcessorImageUpdateProgress_states = NACL::CS::SystemNodeServiceProcessorImageUpdateProgress->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI or 7Mode CLI APISet.

Invokes "system node service-processor image update-progress show" command for 7Mode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=item C<NACL::Exceptions::InvalidChoice>

When apiset_must choice for interface is provided as 'ZAPI' and if the method
is invoked without specifying 'node' in the 'filter' or if the method is
invoked with special query characters in the filter, then this exception
will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_7mode_cli',
                interface => 'CLI',
                set       => '7Mode',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                check     => '_fetch_zapi_check',
            }
        ],
        exception_text => 'No matching $not_matching_element found',
        show_cmd       => 'system node service-processor image update-progress show',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'system_node_service_processor_image_update_progress_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_7mode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;

    my %opts = validate @args, $pkg->_fetch_backend_validate_spec();
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my %copy_filter       = %{$opts{filter}};

    my @copy_requested_fields = @{$opts{requested_fields}};

    $pkg->_remove_relational_regex_filters(
        filter           => \%copy_filter,
        requested_fields => \@copy_requested_fields
    );

    my %apiset_opts = ();
    if (scalar(keys %copy_filter)) {
        %apiset_opts = %copy_filter;
    }
    if (scalar(@copy_requested_fields)) {
        $apiset_opts{fields} = join(',', @copy_requested_fields);
    }

    if (exists $apiset_opts{'node'}) {
        $apiset_opts{'nodename'} = delete $apiset_opts{'node'};
    }

    my @state_objs;
    my $response
        = $apiset->system_node_service_processor_image_update_progress_show(
        %apiset_opts);
    my $list_output = $response->get_parsed_output();

    foreach my $output (@{$list_output}) {
        my $target = $pkg->_hash_copy(
            source => $output,
            copy => [qw(node start_time end_time percent_done in_progress )],
            map  => {
                'latest_sp_firmware_update_percentage_done' => 'percent_done',
                'is_update_in_progress'                     => 'in_progress',
                'latest_sp_firmware_update_end_timestamp'   => 'end-time',
                'latest_sp_firmware_update_start_timestamp' => 'start-time',
            },
        );
        my $obj = $pkg->new(command_interface => $command_interface,);
        $obj->_set_fields(row => $target);
        push @state_objs, $obj;
    } ## end foreach my $output (@$list_output)

    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;

    my %opts = validate @args, $pkg->_fetch_backend_validate_spec();
    my (@state_objs, $source);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $node              = $opts{filter}->{node};
    my $args              = $pkg->_hash_copy(
        source => $opts{filter},
        copy   => [qw(node)],
    );
    my $response
        = $apiset->service_processor_image_update_progress_get(node => $node);
    my $output = $response->get_parsed_output();

    foreach my $list_output (@$output) {
        if ($list_output->{'attributes'}->[0]
            ->{'service-processor-image-update-progress'}->[0])
        {
            $source = $list_output->{'attributes'}->[0]
                ->{'service-processor-image-update-progress'}->[0];
        } else {
            $source = $list_output->{'attributes'}->[0]
                ->{'service-processor-image-update-progress-info'}->[0];
        }
        my $target = $pkg->_hash_copy(
            source => $source,
            copy => [qw( start-time in-progress end-time percent-done node )],
            map  => {'is-in-progress' => 'in-progress'}
        );
        my $obj = $pkg->new(command_interface => $opts{command_interface});
        $obj->_set_fields(row => $target);
        push @state_objs, $obj;
    } ## end
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

1;
