#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState module for the method NACL::C::SystemServicesNdmp->get_password()
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemServicesNdmpGetPassword

=head1 DESCRIPTION

C<NACL::CS::SystemServicesNdmpGetPassword> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this
type are returned when NACL::C::SystemServicesNdmp->get_password() is invoked.

(This module does not represent the state of any element, but is an object
repesentation of the output obtained when the NDMP password is queried.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< password >>

The password for the user account specified.

=back

=cut

package NACL::CS::SystemServicesNdmpGetPassword;

use strict;
use warnings;

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'password',
];

1;
