#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VfilerLimit ComponentState Module
## @author madhav.shekar@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VfilerLimit

=head1 DESCRIPTION

C<NACL::CS::Vfiler> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the 
details returned by the "vfiler limit" 7Mode-CLI command. This object is
returned when NACL::C::Vfiler->limit is invoked.

=head1 ATTRIBUTES

=over

=item C<< platform_hard_limit >>

The maximum number of vfilers allowed on the hosting filer.

=item C<< current_limit >>

The current vfiler limit of the hosting filer.

=item C<< current_in_use >>

The number of vfilers currently on the hosting filer.

=back

=cut

package NACL::CS::VfilerLimit;

use strict;
use warnings;
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'platform_hard_limit',
    scalar => 'current_limit',
    scalar => 'current_in_use',
];

1;
