# $Id$ 
#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Volume64bitUpgradeStartCheck ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::Volume64bitUpgradeStartCheck

=head1 DESCRIPTION

C<NACL::CS::Volume64bitUpgradeStartCheck> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this
type are returned when NACL::CS::Volume64bitUpgradeStartCheck->get_version() is invoked.

(This module does not represent the state of any element, but is an object
representation of the output obtained when a volume is queried for 
upgradability from 32-bit to 64-bits.

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< volume >>

=item C<< vserver >>

=item C<< used >>

=item C<< total >>

=item C<< capacity >>

=item C<< additional_space_required_for_upgrade => $string >>

=item C<< filesys_size_fixed => $string >>

=item C<< space_reserved_files => $string >>

=back

=cut

package NACL::CS::Volume64bitUpgradeStartCheck;

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'volume',
    scalar => 'vserver',
    scalar => 'used',
    scalar => 'total',
    scalar => 'capacity',
    scalar => 'additional_space_required_for_upgrade',
    scalar => 'filesys_size_fixed',
    scalar => 'space_reserved_files'
];

1;
