# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::VolumeEfficiency->node_statistics() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VolumeEfficiencyNodeStatistics

=head1 DESCRIPTION

C<NACL::CS::VolumeEfficiencyNodeStatistics> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::VolumeEfficiency->node_statistics() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::VolumeEfficiency->node_statistics() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< running_efficiency_ops >>

Running Efficiency Ops possible value(s) are, integer

Filled in for CMode CLI.

=item C<< generated_clogs >>

Generated Change Logs possible value(s) are, integer

Filled in for CMode CLI.

=item C<< num_succeeded_ops >>

Number of Succeeded Ops possible value(s) are, integer

Filled in for CMode CLI.

=item C<< dropped_vol_deleted >>

Dropped Volume Deleted possible value(s) are, integer

Filled in for CMode CLI.

=item C<< node >>

Node possible value(s) are, text

Filled in for CMode CLI.

=item C<< dropped_bkdoor_failed >>

Dropped Backdoor Failed possible value(s) are, integer

Filled in for CMode CLI.

=item C<< dropped_non_dense >>

Dropped Non-dense logs possible value(s) are, integer

Filled in for CMode CLI.

=item C<< dropped_vol_offline >>

Dropped Volume Offline possible value(s) are, integer

Filled in for CMode CLI.

=item C<< flushed_clogs >>

Flushed Change Logs possible value(s) are, integer

Filled in for CMode CLI.

=item C<< pending_clogs >>

Pending Change Logs possible value(s) are, integer

Filled in for CMode CLI.

=item C<< dropped_wafl_write_fail >>

Dropped Wafl Write Fail possible value(s) are, integer

Filled in for CMode CLI.

=item C<< total_config_volumes >>

Total Dedupe Volumes possible value(s) are, integer

Filled in for CMode CLI.

=item C<< dropped_clogs >>

Dropped Change Logs possible value(s) are, integer

Filled in for CMode CLI.

=item C<< num_started_ops >>

Number of Started Ops possible value(s) are, integer

Filled in for CMode CLI.

=item C<< max_efficiency_ops >>

Maximum Efficiency Ops possible value(s) are, integer

Filled in for CMode CLI.

=item C<< dropped_alloc_failed >>

Dropped Alloc Failed possible value(s) are, integer

Filled in for CMode CLI.

=item C<< dropped_bufs_allocated >>

Dropped Bufs Allocated possible value(s) are, integer

Filled in for CMode CLI.

=item C<< dropped_alloc_rejected >>

Dropped Alloc Rejected possible value(s) are, integer

Filled in for CMode CLI.

=item C<< stolen_buffer_lookups >>

Stolen Buffer Lookups possible value(s) are, integer

Filled in for CMode CLI.

=item C<< filer_id >>

Filer ID possible value(s) are, nodename

Filled in for CMode CLI.

=item C<< num_deferred_ops >>

Number of Deferred Ops possible value(s) are, integer

Filled in for CMode CLI.

=item C<< dropped_aggr_full >>

Dropped Aggr Full possible value(s) are, integer

Filled in for CMode CLI.

=item C<< dropped_invalid_uuid >>

Dropped Invalid UUID possible value(s) are, integer

Filled in for CMode CLI.

=item C<< stolen_buffer_reads >>

Stolen Buffer Reads possible value(s) are, integer

Filled in for CMode CLI.

=item C<< num_failed_ops >>

Number of Failed Ops possible value(s) are, integer

Filled in for CMode CLI.

=item C<< stolen_buffers_used >>

Stolen Buffers Used possible value(s) are, integer

Filled in for CMode CLI.

=item C<< num_stopped_ops >>

Number of Stopped Ops possible value(s) are, integer

Filled in for CMode CLI.

=item C<< pending_efficiency_ops >>

Pending Efficiency Ops possible value(s) are, integer

Filled in for CMode CLI.

=item C<< max_share_blocks >>

Maximum Shared Blocks possible value(s) are, integer

Filled in for CMode CLI.

=item C<< dropped_steal_failed >>

Dropped Steal Failed possible value(s) are, integer

Filled in for CMode CLI.

=item C<< dropped_wafl_write_fail_unaligned >>

Dropped Wafl Write Fail Unaligned possible value(s) are, integer

Filled in for CMode CLI.

=item C<< replayed_sharing_messages >>

Replayed LRSE Share Messages

Filled in for CMode CLI.

=item C<< freed_sharing_messages >>

Freed LRSE Share Messages

Filled in for CMode CLI.

=back

=cut

package NACL::CS::VolumeEfficiencyNodeStatistics;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'running_efficiency_ops',
    scalar => 'generated_clogs',
    scalar => 'num_succeeded_ops',
    scalar => 'dropped_vol_deleted',
    scalar => 'node',
    scalar => 'dropped_bkdoor_failed',
    scalar => 'dropped_non_dense',
    scalar => 'dropped_vol_offline',
    scalar => 'flushed_clogs',
    scalar => 'pending_clogs',
    scalar => 'dropped_wafl_write_fail',
    scalar => 'total_config_volumes',
    scalar => 'dropped_clogs',
    scalar => 'num_started_ops',
    scalar => 'max_efficiency_ops',
    scalar => 'dropped_alloc_failed',
    scalar => 'dropped_bufs_allocated',
    scalar => 'dropped_alloc_rejected',
    scalar => 'stolen_buffer_lookups',
    scalar => 'filer_id',
    scalar => 'num_deferred_ops',
    scalar => 'dropped_aggr_full',
    scalar => 'dropped_invalid_uuid',
    scalar => 'stolen_buffer_reads',
    scalar => 'num_failed_ops',
    scalar => 'stolen_buffers_used',
    scalar => 'num_stopped_ops',
    scalar => 'pending_efficiency_ops',
    scalar => 'max_share_blocks',
    scalar => 'dropped_steal_failed',
    scalar => 'dropped_wafl_write_fail_unaligned',
    scalar => 'replayed_sharing_messages',
    scalar => 'freed_sharing_messages',
];

=head1 METHODS

=head2 fetch

    my $VolumeEfficiencyNodeStatistics_state  = NACL::CS::VolumeEfficiencyNodeStatistics->fetch(command_interface => $ci, ...);
	my @VolumeEfficiencyNodeStatistics_states = NACL::CS::VolumeEfficiencyNodeStatistics->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'volume efficiency node-statistics',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching volume efficiency(s) found',
        frontend       => 'NACL::CS::VolumeEfficiencyNodeStatistics::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'volume_efficiency_node_statistics',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
