#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VolumeLostFound ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VolumeLostFound

=head1 DESCRIPTION

C<NACL::CS::VolumeLostFound> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VolumeLostFound.  A related class is
L<NACL::C::VolumeLostFound|lib-NACL-C-VolumeLostFound-pm>, which represents access
to an ONTAP VolumeLostFound.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the VolumeLostFound
element are the attributes of the VolumeLostFound ComponentState.

=over

=item C<< "files" >>

Filled in for CMode CLI.

=item C<< "dsid" >>

Filled in for CMode CLI.

=item C<< "state" >>

Filled in for CMode CLI.

=item C<< "maxdir_size" >>

Filled in for CMode CLI.

=item C<< "autosize" >>

Filled in for CMode CLI.

=item C<< "percent_snapshot_space" >>

Filled in for CMode CLI.

=item C<< "user" >>

Filled in for CMode CLI.

=item C<< "files_used" >>

Filled in for CMode CLI.

=item C<< "max_autosize" >>

Filled in for CMode CLI.

=item C<< "total" >>

Filled in for CMode CLI.

=item C<< "space_guarantee" >>

Filled in for CMode CLI.

=item C<< "used" >>

Filled in for CMode CLI.

=item C<< "min_readahead" >>

Filled in for CMode CLI.

=item C<< "fractional_reserve" >>

Filled in for CMode CLI.

=item C<< "snapdir_access" >>

Filled in for CMode CLI.

=item C<< "max_write_alloc_blocks" >>

Filled in for CMode CLI.

=item C<< "msid" >>

Filled in for CMode CLI.

=item C<< "percent_used" >>

Filled in for CMode CLI.

=item C<< "node" >>

Filled in for CMode CLI.

=item C<< "size" >>

Filled in for CMode CLI.

=item C<< "group" >>

Filled in for CMode CLI.

=item C<< "vserver_uuid" >>

Filled in for CMode CLI.

=item C<< "aggregate" >>

Filled in for CMode CLI.

=item C<< "available" >>

Filled in for CMode CLI.

=item C<< "space_guarantee_enabled" >>

Filled in for CMode CLI.

=item C<< "volume" >>

Filled in for CMode CLI.

=item C<< "vserver" >>

Filled in for CMode CLI.

=item C<< "autosize_increment" >>

Filled in for CMode CLI.

=item C<< "atime_update" >>

Filled in for CMode CLI.

=item C<< "security_style" >>

Filled in for CMode CLI.

=item C<< "aggregate_uuid" >>

Filled in for CMode CLI.

=item C<< "overwrite_reserve" >>

Filled in for CMode CLI.

=item C<< autosize_mode >>

Filled in for CMode CLI.

=item C<< min_autosize >>

Filled in for CMode CLI.

=item C<< autosize_grow_threshold_percent >>

Filled in for CMode CLI.

=item C<< autosize_shrink_threshold_percent >>

Filled in for CMode CLI.

=item C<< space_nearly_full_threshold_percent >>

*Nearly Full Threshold Percentage

Filled in for CMode CLI.

=item C<< space_full_threshold_percent >>

*Full Threshold Percentage

Filled in for CMode CLI.

=back

=cut

package NACL::CS::VolumeLostFound;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'files',
    scalar => 'dsid',
    scalar => 'state',
    scalar => 'maxdir_size',
    scalar => 'autosize',
    scalar => 'percent_snapshot_space',
    scalar => 'user',
    scalar => 'files_used',
    scalar => 'max_autosize',
    scalar => 'total',
    scalar => 'space_guarantee',
    scalar => 'used',
    scalar => 'min_readahead',
    scalar => 'fractional_reserve',
    scalar => 'snapdir_access',
    scalar => 'max_write_alloc_blocks',
    scalar => 'msid',
    scalar => 'percent_used',
    scalar => 'node',
    scalar => 'size',
    scalar => 'group',
    scalar => 'vserver_uuid',
    scalar => 'aggregate',
    scalar => 'available',
    scalar => 'space_guarantee_enabled',
    scalar => 'volume',
    scalar => 'vserver',
    scalar => 'autosize_increment',
    scalar => 'atime_update',
    scalar => 'security_style',
    scalar => 'aggregate_uuid',
    scalar => 'overwrite_reserve',
    scalar => 'autosize_mode',
    scalar => 'min_autosize',
    scalar => 'autosize_grow_threshold_percent',
    scalar => 'autosize_shrink_threshold_percent',
    scalar => 'space_nearly_full_threshold_percent',
    scalar => 'space_full_threshold_percent',
];

=head1 METHODS

=head2 fetch

    my $VolumeLostFound_state   = NACL::CS::VolumeLostFound->fetch(command_interface => $ci, ...);
	my @VolumeLostFound_states = NACL::CS::VolumeLostFound->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'volume lost-found show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching volume lost found(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@_, api => 'volume_lost_found_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
