# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::Volume->show_space_old() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VolumeShowSpaceOld

=head1 DESCRIPTION

C<NACL::CS::VolumeShowSpaceOld> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::Volume->show_space_old() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::Volume->show_space_old() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< snapmirror_metadata_percent >>

SnapMirror Metadata Percent

Filled in for CMode CLI.

=item C<< snapshot_space_used >>

Snapshot Reserve Used

Filled in for CMode CLI.

=item C<< user_data_percent >>

User Data Percent

Filled in for CMode CLI.

=item C<< quota_metafiles >>

Quota Metadata, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< volume_size >>

Total User-Visible Size, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< snapshot_spill >>

Snapshot Spill, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< dedupe_metafiles_tmp >>

Temporary Deduplication Metadata, possible value(s) are
<integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< used_percent >>

Used Including Snaphot Reserve Percent

Filled in for CMode CLI.

=item C<< aggregate >>

Aggregate Name

Filled in for CMode CLI.

=item C<< filesystem_metadata_percent >>

Filesystem Metadata Percent

Filled in for CMode CLI.

=item C<< snapshot_spill_percent >>

Snapshot Spill Percent

Filled in for CMode CLI.

=item C<< dedupe_metafiles_tmp_percent >>

Temporary Deduplication Metadata Percent

Filled in for CMode CLI.

=item C<< volume >>

Volume Name

Filled in for CMode CLI.

=item C<< snapshot_reserve >>

Snapshot Reserve Size, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< vserver >>

Vserver Name

Filled in for CMode CLI.

=item C<< inodes >>

Inode Metadata, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< dedupe_metafiles >>

Deduplication Metadata, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< user_data >>

User Data, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< inodes_percent >>

Inode Metadata Percent

Filled in for CMode CLI.

=item C<< filesystem_metadata >>

Filesystem Metadata, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< snapmirror_metadata >>

SnapMirror Metadata, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< dedupe_metafiles_percent >>

Deduplication Metadata Percent

Filled in for CMode CLI.

=item C<< used >>

Used Including Snapshot Reserve, possible value(s) are
<integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< snapshot_reserve_percent >>

Space Reserved for Snapshots

Filled in for CMode CLI.

=item C<< quota_metafiles_percent >>

Quota Metadata Percent

Filled in for CMode CLI.

=back

=cut

package NACL::CS::VolumeShowSpaceOld;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'snapmirror_metadata_percent',
    scalar => 'snapshot_space_used',
    scalar => 'user_data_percent',
    scalar => 'quota_metafiles',
    scalar => 'volume_size',
    scalar => 'snapshot_spill',
    scalar => 'dedupe_metafiles_tmp',
    scalar => 'used_percent',
    scalar => 'aggregate',
    scalar => 'filesystem_metadata_percent',
    scalar => 'snapshot_spill_percent',
    scalar => 'dedupe_metafiles_tmp_percent',
    scalar => 'volume',
    scalar => 'snapshot_reserve',
    scalar => 'vserver',
    scalar => 'inodes',
    scalar => 'dedupe_metafiles',
    scalar => 'user_data',
    scalar => 'inodes_percent',
    scalar => 'filesystem_metadata',
    scalar => 'snapmirror_metadata',
    scalar => 'dedupe_metafiles_percent',
    scalar => 'used',
    scalar => 'snapshot_reserve_percent',
    scalar => 'quota_metafiles_percent',
];

=head1 METHODS

=head2 fetch

    my $VolumeShowSpaceOld_state  = NACL::CS::VolumeShowSpaceOld->fetch(command_interface => $ci, ...);
	my @VolumeShowSpaceOld_states = NACL::CS::VolumeShowSpaceOld->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ( $pkg, @args ) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'volume show-space-old',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching volume(s) found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ( $pkg, @args ) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli( @args,
        api => 'volume_show_space_old', );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
