# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::VserverCifsGroupPolicyRestrictedGroup->show_applied() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverCifsGroupPolicyRestrictedGroupShowApplied

=head1 DESCRIPTION

C<NACL::CS::VserverCifsGroupPolicyRestrictedGroupShowApplied> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::VserverCifsGroupPolicyRestrictedGroup->show_applied() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::VserverCifsGroupPolicyRestrictedGroup->show_applied() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over


=item C<< members >>

Members, List of Users/groups
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $members = $obj->members();
 
# $members contains a reference to the array of values
 
my @members = $obj->members();
 
# @members contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { members = [ value1, value2...] }

Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <gpo-restricted-group-applied-info>
  <members gpo-user-group="@values" />
</gpo-restricted-group-applied-info>


=item C<< link >>


Link Type possible value(s) are, Local,Site,Domain,OrganizationalUnit,RSOP
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <gpo-restricted-group-applied-info link-type="$value" />


=item C<< index >>

Index
Filled in for CMode CLI/ZAPI iter

=item C<< vserver >>

Vserver
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <gpo-restricted-group-applied-info vserver="$value" />


=item C<< version >>

Version
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <gpo-restricted-group-applied-info version="$value" />


=item C<< group_name >>

Group Name
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <gpo-restricted-group-applied-info group-name="$value" />


=item C<< uuid >>

UUID
Filled in for CMode CLI/ZAPI iter

=item C<< member_of >>

MemberOf, List of Groups
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $member_of = $obj->member_of();
 
# $member_of contains a reference to the array of values
 
my @member_of = $obj->member_of();
 
# @member_of contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { member_of = [ value1, value2...] }

Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <gpo-restricted-group-applied-info>
  <member-of gpo-user-group="@values" />
</gpo-restricted-group-applied-info>


=item C<< group_policy_name >>

Group Policy Name
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <gpo-restricted-group-applied-info group-policy-name="$value" />

=back

=cut

package NACL::CS::VserverCifsGroupPolicyRestrictedGroupShowApplied;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'members',
    scalar => 'link',
    scalar => 'index',
    scalar => 'vserver',
    scalar => 'version',
    scalar => 'group_name',
    scalar => 'uuid',
    array  => 'member_of',
    scalar => 'group_policy_name',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 fetch

    my $VserverCifsGroupPolicyRestrictedGroupShowApplied_state  = NACL::CS::VserverCifsGroupPolicyRestrictedGroupShowApplied->fetch(command_interface => $ci, ...);
	my @VserverCifsGroupPolicyRestrictedGroupShowApplied_states = NACL::CS::VserverCifsGroupPolicyRestrictedGroupShowApplied->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes gpo-restricted-group-applied-info-get-iter API for CMode ZAPI iter.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        show_cmd => 'vserver cifs group-policy restricted-group show-applied',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'iter'
            },

        ],
        exception_text =>
            'No matching vserver cifs group-policy restricted-group(s) found',
        frontend =>
            'NACL::CS::VserverCifsGroupPolicyRestrictedGroupShowApplied::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'vserver_cifs_group_policy_restricted_group_show_applied',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(version vserver group-policy-name group-name
                )
        ],
        map => {
            'link'      => 'link-type',
            'member-of' => [
                make_zapi_array('member-of'),
                make_zapi_skip('gpo-user-group'),
            ],
            'members' => [
                make_zapi_array('members'),
                make_zapi_skip('gpo-user-group'),
            ],
        },
        api => "gpo-restricted-group-applied-info-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
