#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsHomeDirectory ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverCifsHomeDirectory

=head1 DESCRIPTION

C<NACL::CS::VserverCifsHomeDirectory> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverCifsHomeDirectory.  A related class is
L<NACL::C::VserverCifsHomeDirectory|lib-NACL-C-VserverCifsHomeDirectory-pm>, which represents access
to an ONTAP VserverCifsHomeDirectory.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the VserverCifsHomeDirectory
element are the attributes of the VserverCifsHomeDirectory ComponentState.

=over

=item C<< "vserver" >>

=item C<< "enabled" >>

=item C<< is_home_dirs_access_for_public_enabled >>


Is Home Directory Access for Public Enabled possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< is_home_dirs_access_for_admin_enabled >>


Is Home Directory Access for Admin Enabled possible value(s) are, true,false

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverCifsHomeDirectory;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'enabled',
    scalar => 'is_home_dirs_access_for_public_enabled',
    scalar => 'is_home_dirs_access_for_admin_enabled',
];

=head1 METHODS

=head2 fetch

    my $VserverCifsHomeDirectory_state   = NACL::CS::VserverCifsHomeDirectory->fetch(command_interface => $ci, ...);
	my @VserverCifsHomeDirectory_states = NACL::CS::VserverCifsHomeDirectory->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'vserver cifs home-directory show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching vserver cifs home directory(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_cifs_home_directory_show');
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
