# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsShadowcopy ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverCifsShadowcopy

=head1 DESCRIPTION

C<NACL::CS::VserverCifsShadowcopy> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverCifsShadowcopy.  A related class is
L<NACL::C::VserverCifsShadowcopy|lib-NACL-C-VserverCifsShadowcopy-pm>, which represents access
to an ONTAP VserverCifsShadowcopy.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverCifsShadowcopy
element are the attributes of the VserverCifsShadowcopy ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< scsetid >>

Filled in for CMode CLI.

=item C<< volume >>

Filled in for CMode CLI.

=item C<< timestamp >>

Filled in for CMode CLI.

=item C<< share >>

Filled in for CMode CLI.

=item C<< vserver >>

Filled in for CMode CLI.

=item C<< state >>

Filled in for CMode CLI.

=item C<< scid >>

Filled in for CMode CLI.

=item C<< share_name >>

Filled in for CMode CLI.

=item C<< start_time >>

Filled in for CMode CLI.

=item C<< shadowcopy_id >>

Filled in for CMode CLI.

=item C<< shadowcopy_setid >>

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverCifsShadowcopy;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'scsetid',
    scalar => 'volume',
    scalar => 'timestamp',
    scalar => 'share',
    scalar => 'vserver',
    scalar => 'state',
    scalar => 'scid',
    scalar => 'share_name',
    scalar => 'start_time',
    scalar => 'shadowcopy_id',
    scalar => 'shadowcopy_setid',
];

=head1 METHODS

=head2 fetch

    my $VserverCifsShadowcopy_state  = NACL::CS::VserverCifsShadowcopy->fetch(command_interface => $ci, ...);
	my @VserverCifsShadowcopy_states = NACL::CS::VserverCifsShadowcopy->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'vserver cifs shadowcopy show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching vserver cifs shadowcopy(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_cifs_shadowcopy_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
