# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsShadowcopyOptions ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverCifsShadowcopyOptions

=head1 DESCRIPTION

C<NACL::CS::VserverCifsShadowcopyOptions> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverCifsShadowcopyOptions.  A related class is
L<NACL::C::VserverCifsShadowcopyOptions|lib-NACL-C-VserverCifsShadowcopyOptions-pm>, which represents access
to an ONTAP VserverCifsShadowcopyOptions.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverCifsShadowcopyOptions
element are the attributes of the VserverCifsShadowcopyOptions ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< max_waittime_to_abort >>

Filled in for CMode CLI.

=item C<< max_threads_to_delete_clones >>

Filled in for CMode CLI.

=item C<< max_shares_per_scs >>

Filled in for CMode CLI.

=item C<< max_scs_operations_per_vserver >>

Filled in for CMode CLI.

=item C<< max_threads_to_delete_snapshots >>

Filled in for CMode CLI.

=item C<< max_threads_to_clone_shares >>

Filled in for CMode CLI.

=item C<< max_threads_to_create_snapshots >>

Filled in for CMode CLI.

=item C<< mst_enabled >>

Filled in for CMode CLI.

=item C<< mst_interval >>

Filled in for CMode CLI.

=item C<< mst_expose_timeout >>

Filled in for CMode CLI.

=item C<< mst_recover_timeout >>

Filled in for CMode CLI.

=item C<< mst_prepare_timeout >>

Filled in for CMode CLI.


=item C<< mst_stuck_timeout >>

Filled in for CMode CLI.


=item C<< mst_medium_timeout >>

Message sequence medium timeout (in minutes)

Filled in for CMode CLI.

=item C<< mst_short_timeout >>

Message sequence short timeout (in minutes)

Filled in for CMode CLI.

=item C<< mst_long_timeout >>

Message sequence long timeout (in hours)

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverCifsShadowcopyOptions;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'max_waittime_to_abort',
    scalar => 'max_threads_to_delete_clones',
    scalar => 'max_shares_per_scs',
    scalar => 'max_scs_operations_per_vserver',
    scalar => 'max_threads_to_delete_snapshots',
    scalar => 'max_threads_to_clone_shares',
    scalar => 'max_threads_to_create_snapshots',
    scalar => 'mst_enabled',
    scalar => 'mst_interval',
    scalar => 'mst_expose_timeout',
    scalar => 'mst_recover_timeout',
    scalar => 'mst_prepare_timeout',
    scalar => 'mst_stuck_timeout',
    scalar => 'mst_medium_timeout',
    scalar => 'mst_short_timeout',
    scalar => 'mst_long_timeout',
];

=head1 METHODS

=head2 fetch

    my $VserverCifsShadowcopyOptions_state  = NACL::CS::VserverCifsShadowcopyOptions->fetch(command_interface => $ci, ...);
(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. This being a "singleton" table (i.e. one which can only have one
row) is callable only in scalar context.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'vserver cifs shadowcopy options show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching vserver cifs shadowcopy options(s) found',
        is_singleton => 1
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(
        @_,
        api          => 'vserver_cifs_shadowcopy_options_show',
        is_singleton => 1,

    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
