# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverConfigDiff ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverConfigDiff

=head1 DESCRIPTION

C<NACL::CS::VserverConfigDiff> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverConfigDiff.  A related class is
L<NACL::C::VserverConfigDiff|lib-NACL-C-VserverConfigDiff-pm>, which represents access
to an ONTAP VserverConfigDiff.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverConfigDiff
element are the attributes of the VserverConfigDiff ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)


=item C<< object >>

Configuration Object
Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <config-diff-info object="$value" />


=item C<< source_vserver_name >>

Source Vserver Name
Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <config-diff-info source-vserver-name="$value" />


=item C<< instance >>

Object Instance Count
Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <config-diff-info instance="$value" />


=item C<< source_vserver_value >>

Value of Attribute at Source
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $source_vserver_value = $obj->source_vserver_value();
 
# $source_vserver_value contains a reference to the array of values
 
my @source_vserver_value = $obj->source_vserver_value();
 
# @source_vserver_value contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { source_vserver_value = [ value1, value2...] }

Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <config-diff-info>
  <attribute-diff-list name="attribute-info" source-vserver-value="@values" />
</config-diff-info>

Mapping for CMode ZAPI non-iter: <attribute-diff-list>
  <attribute-info source-vserver-value="@values" />
</attribute-diff-list>


=item C<< destination_vserver_value >>

Value of Attribute at Destination
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $destination_vserver_value = $obj->destination_vserver_value();
 
# $destination_vserver_value contains a reference to the array of values
 
my @destination_vserver_value = $obj->destination_vserver_value();
 
# @destination_vserver_value contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { destination_vserver_value = [ value1, value2...] }

Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <config-diff-info>
  <attribute-diff-list name="attribute-info" destination-vserver-value="@values" />
</config-diff-info>

Mapping for CMode ZAPI non-iter: <attribute-diff-list>
  <attribute-info destination-vserver-value="@values" />
</attribute-diff-list>


=item C<< keys >>

Keys of Configuration Object
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $keys = $obj->keys();
 
# $keys contains a reference to the array of values
 
my @keys = $obj->keys();
 
# @keys contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { keys = [ value1, value2...] }

Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <config-diff-info>
  <keys key-value-pair="@values" />
</config-diff-info>

Mapping for CMode ZAPI non-iter: <keys key-value-pair="@values" />


=item C<< attribute >>

Attribute of Configuration Object
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $attribute = $obj->attribute();
 
# $attribute contains a reference to the array of values
 
my @attribute = $obj->attribute();
 
# @attribute contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { attribute = [ value1, value2...] }

Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <config-diff-info>
  <attribute-diff-list name="attribute-info" attribute="@values" />
</config-diff-info>

Mapping for CMode ZAPI non-iter: <attribute-diff-list>
  <attribute-info attribute="@values" />
</attribute-diff-list>


=item C<< instance_missing_on_vserver >>

Instance Missing on Vserver
Filled in for CMode CLI/ZAPI iter, non-iter.

=item C<< destination_vserver_name >>

Destination Vserver Name
Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <config-diff-info destination-vserver-name="$value" />


=item C<< destination_vserver_uuid >>

Destination Vserver External UUID
Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <config-diff-info destination-vserver-uuid="$value" />


=item C<< source_vserver_uuid >>

Source Vserver External UUID
Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <config-diff-info source-vserver-uuid="$value" />


=item C<< header_line >>

Header line
Filled in for CMode CLI/ZAPI iter, non-iter.
=back

=cut

package NACL::CS::VserverConfigDiff;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';
use NACL::Exceptions::InvalidChoice qw(:try);

use Class::MethodMaker [
    scalar => 'object',
    scalar => 'source_vserver_name',
    scalar => 'instance',
    array  => 'source_vserver_value',
    array  => 'destination_vserver_value',
    array  => 'keys',
    array  => 'attribute',
    scalar => 'instance_missing_on_vserver',
    scalar => 'destination_vserver_name',
    scalar => 'destination_vserver_uuid',
    scalar => 'source_vserver_uuid',
    scalar => 'header_line',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

sub _check_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_check_non_iter(
        @opts,
        _primary_keys => [
            qw(object keys destination-vserver-name)
        ],
        _vs_context => 0
    );
    $Log->exit() if $may_exit;
}

=head1 METHODS

=head2 fetch

    my $VserverConfigDiff_state  = NACL::CS::VserverConfigDiff->fetch(command_interface => $ci, ...);
	my @VserverConfigDiff_states = NACL::CS::VserverConfigDiff->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

For CMode-CLI, it automatically adds "no-progress" to the command and this
option does not need to be provided in the filter.

Uses CMode CLI/ZAPI.

Invokes vserver-config-diff-get-iter API for CMode ZAPI iter.

Invokes vserver-config-diff-get API for CMode ZAPI non-iter.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'iter',
            },
            {   method    => '_fetch_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
                check     => '_check_non_iter'
            },
        ],
        show_cmd       => 'vserver config diff show',
        exception_text => 'No matching vserver config diff(s) found',
        frontend       => 'NACL::CS::VserverConfigDiff::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    # Can take very long for this to complete for a large config, during which
    # time there might not be any output, so bump up the max_idle time.
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'vserver_config_diff_show', 'connectrec-max_idle' => 1800);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _compute_cmode_cli_options {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $api_opts = $pkg->SUPER::_compute_cmode_cli_options(@args);
    $api_opts->{'no-progress'} //= '';
    $Log->exit() if $may_exit;
    return $api_opts;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => _common_zapi_copy(),
        map  => _common_zapi_map(),
        api  => "vserver-config-diff-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi_non_iter(
        @args,
        copy => _common_zapi_copy(),
        map  => _common_zapi_map(),
        api => "vserver-config-diff-get",
        primary_keys => [
            qw( object instance keys destination-vserver-name )
        ],
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _extra_filter_fields {
    $Log->enter() if $may_enter;
    $Log->exit() if $may_exit;
    return [qw(no-progress)];
}

sub _common_zapi_copy {
    return [
        qw(object source-vserver-name instance destination-vserver-uuid
            destination-vserver-name source-vserver-uuid)
    ];
}

sub _common_zapi_map {
    return {
        'destination-vserver-value' => [
            make_zapi_array('attribute-diff-list'),
            make_zapi_skip('attribute-info'),
            'destination-vserver-value',
        ],
        'source-vserver-value' => [
            make_zapi_array('attribute-diff-list'),
            make_zapi_skip('attribute-info'),
            'source-vserver-value'
        ],
        'keys' =>
            [make_zapi_array('keys'), make_zapi_skip('key-value-pair'),],
        'attribute' => [
            make_zapi_array('attribute-diff-list'),
            make_zapi_skip('attribute-info'),
            'attribute',
        ],
    };
}

1;
