# Id: //depot/prod/test/nacldev/lib/NACL/CS/VserverIscsiInitiator.pm#8$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverIscsiInitiator ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, raghaveb@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverIscsiInitiator

=head1 DESCRIPTION

C<NACL::CS::VserverIscsiInitiator> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverIscsiInitiator.  A related class is
L<NACL::C::VserverIscsiInitiator|lib-NACL-C-VserverIscsiInitiator-pm>, which represents access
to an ONTAP VserverIscsiInitiator.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the VserverIscsiInitiator
element are the attributes of the VserverIscsiInitiator ComponentState.

=over

=item C<< "tpgt" >>

Filled in for CMode CLI.

=item C<< "vserver" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <iscsi-initiator-list-entry-info>
    <vserver>$value</vserver>
 </iscsi-initiator-list-entry-info>


=item C<< "node" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <iscsi-initiator-list-entry-info>
    <node>$value</node>
 </iscsi-initiator-list-entry-info>
 
=item C<< "isid" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <iscsi-initiator-list-entry-info>
    <isid>$value</isid>
 </iscsi-initiator-list-entry-info>

=item C<< "initiator" >>

=item C<< "igroup" >>
(Array)

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <iscsi-initiator-list-entry-info>
    <initiator-group-list>@value</initiator-group-list>
 </iscsi-initiator-list-entry-info>
 
=item C<< "tsih" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <iscsi-initiator-list-entry-info>
    <target-session-id>$value</target-session-id>
 </iscsi-initiator-list-entry-info>
 
=item C<< "tpgroup" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <iscsi-initiator-list-entry-info>
    <tpgroup-name>$value</tpgroup-name>
 </iscsi-initiator-list-entry-info>

=item C<< "alias" >>

Filled in for CMode CLI.

=item C<< initiator_alias >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <iscsi-initiator-list-entry-info>
    <initiator-aliasname>$value</initiator-aliasname>
 </iscsi-initiator-list-entry-info>
 
=item C<< initiator_name >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <iscsi-initiator-list-entry-info>
    <initiator-nodename>$value</initiator-nodename>
 </iscsi-initiator-list-entry-info>
 
=item C<< tpgroup_tag >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <iscsi-initiator-list-entry-info>
    <tpgroup-tag>$value</tpgroup-tag>
 </iscsi-initiator-list-entry-info>

=back

=cut

package NACL::CS::VserverIscsiInitiator;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'tpgt',
    scalar => 'vserver',
    scalar => 'node',
    scalar => 'isid',
    scalar => 'initiator',
    array  => 'igroup',
    scalar => 'tsih',
    scalar => 'tpgroup',
    scalar => 'alias',
    scalar => 'initiator_alias',
    scalar => 'initiator_name',
    scalar => 'tpgroup_tag',
];

=head1 METHODS

=head2 fetch

    my $VserverIscsiInitiator_state   = NACL::CS::VserverIscsiInitiator->fetch(command_interface => $ci, ...);
    my @VserverIscsiInitiator_states = NACL::CS::VserverIscsiInitiator->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI APISet.

Invokes "iscsi-initiator-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        show_cmd => 'vserver iscsi initiator show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching vserver iscsi initiator(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_iscsi_initiator_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'iscsi_initiator_get_iter',
        copy => [qw ( isid node tpgroup_tag vserver )],
        map  => {
            'initiator_alias' => 'initiator-aliasname',
            'igroup'          => [
                                   make_zapi_array('initiator-group-list'),
                                   make_zapi_skip('initiator-group-list-info'),
                                   make_zapi_skip('initiator-group-name'),
                                 ],
            'tpgroup'         => 'tpgroup-name',
            'tsih'            => 'target-session-id',
            'initiator_name'  => 'initiator-nodename',
        }
    );
    
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

1;
