# $Id: //depot/prod/test/nacldev/lib/NACL/CS/VserverIscsiStats.pm#$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::VserverIscsi->stats() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com,benjaram@netapp.com
## @status public
## @pod here

=head1 NAME

NACL::CS::VserverIscsiStats

=head1 DESCRIPTION

C<NACL::CS::VserverIscsiStats> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::VserverIscsi->stats() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::VserverIscsi->stats() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< login_redirects >>

Filled in for CMode CLI.

=item C<< protocol >>

Filled in for CMode CLI/ZAPI.

=item C<< hdr_digest >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-error-stats' -> 'hdr-digest' for CMode ZAPI.

=item C<< invalid_header >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-error-stats' -> 'invalid-header' for CMode ZAPI.

=item C<< text_req >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-received-stats' -> 'text-req' for CMode ZAPI.

=item C<< login_rsp >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-transmitted-stats' -> 'login-rsp' for CMode ZAPI.

=item C<< error_status >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-cdb-stats' -> 'error-status' for CMode ZAPI.

=item C<< total_pdus_transmitted >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-transmitted-stats' -> 'total-pdus-transmitted' for CMode ZAPI.

=item C<< scsi_task_mgt_cmd >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-received-stats' -> 'scsi-task-mgt-cmd' for CMode ZAPI.

=item C<< failed_logouts >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-error-stats' -> failed-logouts for Cmode ZAPI

=item C<< ready_to_transmit >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-transmitted-stats' -> ready-to-transmit for Cmode ZAPI

=item C<< login_accepts >>

Filled in for CMode CLI.

=item C<< snack >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-received-stats' -> snack for Cmode ZAPI

=item C<< last_failure_time >>

Filled in for CMode CLI.

=item C<< text_rsp >>

Filled in for CMode CLI.

=item C<< login_other_errors >>

Filled in for CMode CLI.

=item C<< nop_out >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-received-stats' -> nop-out for Cmode ZAPI

=item C<< data_in >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-transmitted-stats' -> data-in for Cmode ZAPI

=item C<< logout_normals >>

Filled in for CMode CLI.

=item C<< data_digest >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-error-stats' -> data-digest for Cmode ZAPI

=item C<< lastss_init_failure_name >>

Filled in for CMode CLI.

=item C<< logout_req >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-received-stats' -> logout-req for Cmode ZAPI

=item C<< last_init_failure_addr >>

Filled in for CMode CLI.

=item C<< scsi_task_mgt_rsp >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-transmitted-stats' -> scsi-task-mgt-rsp for Cmode ZAPI

=item C<< logout_others >>

Filled in for CMode CLI.

=item C<< last_failure_var >>

Filled in for CMode CLI.

=item C<< logout_rsp >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-transmitted-stats' -> logout-rsp for Cmode ZAPI

=item C<< login_authorize_errors >>

Filled in for CMode CLI.

=item C<< lastss_remote_name >>

Filled in for CMode CLI.

=item C<< failed_logins >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-error-stats' -> failed-logins for Cmode ZAPI

=item C<< unknown >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-received-stats' -> unknown for Cmode ZAPI

=item C<< failed_task_mgt >>

Filled in for CMode CLI/ZAPI.
Maps to '' -> failed-task-mgt for Cmode ZAPI

=item C<< nop_in >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-transmitted-stats' -> nop-in for Cmode ZAPI

=item C<< total_cdbs_processed >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-cdb-stats' -> 'total' for CMode ZAPI.

=item C<< total_errors >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-error-stats' -> 'total' for CMode ZAPI.

=item C<< outside_cmd_sn_window >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-error-stats' -> outside-cmd-sn-window for Cmode ZAPI

=item C<< success_status >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-cdb-stats' -> success-status for Cmode ZAPI

=item C<< login_req >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-received-stats' -> login-req for Cmode ZAPI

=item C<< data_in_blocks >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-cdb-stats' -> data-in-blocks for Cmode ZAPI

=item C<< vserver >>

Filled in for CMode CLI/ZAPI.

=item C<< scsi_cmd >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-received-stats' -> scsi-cmd for Cmode ZAPI

=item C<< data_out >>

Filled in for CMode CLI/ZAPI.

=item C<< lastssn_failure_var >>

Filled in for CMode CLI.

=item C<< total_pdus_received >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-received-stats' -> 'total' for CMode ZAPI.

=item C<< login_negotiate_errors >>

Filled in for CMode CLI.

=item C<< failed_text_cmd >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-error-stats' -> failed-text-cmd for Cmode ZAPI

=item C<< async_msg >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-transmitted-stats' -> async-msg for Cmode ZAPI

=item C<< data_out_blocks >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-cdb-stats' -> data-out-blocks for Cmode ZAPI

=item C<< reject >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-transmitted-stats' -> reject for Cmode ZAPI

=item C<< scsi_rsp >>

Filled in for CMode CLI/ZAPI.
Maps to 'iscsi-transmitted-stats' -> scsi-rsp for Cmode ZAPI

=item C<< login_authenticate_errors >>

Filled in for CMode CLI.

=item C<< totalErrors >>

Filled in for CMode CLI.

=item C<< totalCDBsProcessed >>

Filled in for CMode CLI.

=item C<< totalPDUsReceived >>

Filled in for CMode CLI.

=item C<< totalPDUsTransmitted >>

Filled in for CMode CLI.

=item C<< last_failure_time_snmp >>

*Last Failure Time for SNMP
Filled in for CMode CLI.

=item C<< last_failure_time_usec >>

*Last Failure Time uSeconds
Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverIscsiStats;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'login_redirects',
    scalar => 'protocol',
    scalar => 'hdr_digest',
    scalar => 'invalid_header',
    scalar => 'text_req',
    scalar => 'login_rsp',
    scalar => 'error_status',
    scalar => 'total_pdus_transmitted',
    scalar => 'scsi_task_mgt_cmd',
    scalar => 'failed_logouts',
    scalar => 'ready_to_transmit',
    scalar => 'login_accepts',
    scalar => 'snack',
    scalar => 'last_failure_time',
    scalar => 'text_rsp',
    scalar => 'login_other_errors',
    scalar => 'nop_out',
    scalar => 'data_in',
    scalar => 'logout_normals',
    scalar => 'data_digest',
    scalar => 'lastss_init_failure_name',
    scalar => 'logout_req',
    scalar => 'last_init_failure_addr',
    scalar => 'scsi_task_mgt_rsp',
    scalar => 'logout_others',
    scalar => 'last_failure_var',
    scalar => 'logout_rsp',
    scalar => 'login_authorize_errors',
    scalar => 'lastss_remote_name',
    scalar => 'failed_logins',
    scalar => 'unknown',
    scalar => 'failed_task_mgt',
    scalar => 'nop_in',
    scalar => 'total_cdbs_processed',
    scalar => 'total_errors',
    scalar => 'outside_cmd_sn_window',
    scalar => 'success_status',
    scalar => 'login_req',
    scalar => 'data_in_blocks',
    scalar => 'vserver',
    scalar => 'scsi_cmd',
    scalar => 'data_out',
    scalar => 'lastssn_failure_var',
    scalar => 'total_pdus_received',
    scalar => 'login_negotiate_errors',
    scalar => 'failed_text_cmd',
    scalar => 'async_msg',
    scalar => 'data_out_blocks',
    scalar => 'reject',
    scalar => 'scsi_rsp',
    scalar => 'login_authenticate_errors',
    scalar => 'totalErrors',
    scalar => 'totalCDBsProcessed',
    scalar => 'totalPDUsReceived',
    scalar => 'totalPDUsTransmitted',
    scalar => 'last_failure_time_snmp',
    scalar => 'last_failure_time_usec',
];

=head1 METHODS

=head2 fetch

    my $VserverIscsiStats_state  = NACL::CS::VserverIscsiStats->fetch(command_interface => $ci, ...);
    my @VserverIscsiStats_states = NACL::CS::VserverIscsiStats->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI/ZAPI, 7Mode CLI APISet.
Invokes 'iscsi-stats-get-iter' api for CMode ZAPI.
Invokes 'iscsi-stats' api for 7Mode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        show_cmd => 'vserver iscsi stats',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
            {   method    => '_fetch_7mode_cli',
                interface => 'CLI',
                set       => '7Mode',
            },
        ],
        exception_text => 'No matching vserver iscsi(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@_, api => 'vserver_iscsi_stats',);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg = shift;

    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'iscsi_stats_get_iter',
        copy => [qw( vserver )],
        map  => {
            'total_cdbs_processed' => [
                'iscsi-cdb-stats', make_zapi_skip('iscsi-cdb-stats-info'),
                'total'
            ],
            'data-in-blocks' => [
                'iscsi-cdb-stats', make_zapi_skip('iscsi-cdb-stats-info'),
                'data-in-blocks'
            ],
            'data-out-blocks' => [
                'iscsi-cdb-stats', make_zapi_skip('iscsi-cdb-stats-info'),
                'data-out-blocks'
            ],
            'error-status' => [
                'iscsi-cdb-stats', make_zapi_skip('iscsi-cdb-stats-info'),
                'error-status'
            ],
            'success-status' => [
                'iscsi-cdb-stats', make_zapi_skip('iscsi-cdb-stats-info'),
                'success-status'
            ],
            'total-errors' => [
                'iscsi-error-stats', make_zapi_skip('iscsi-error-stats-info'),
                'total'
            ],
            'data-digest' => [
                'iscsi-error-stats',
                make_zapi_skip('iscsi-error-stats-info'),
                'data-digest'
            ],
            'failed-text-cmd' => [
                'iscsi-error-stats',
                make_zapi_skip('iscsi-error-stats-info'),
                'failed-text-cmd'
            ],
            'failed-logins' => [
                'iscsi-error-stats',
                make_zapi_skip('iscsi-error-stats-info'),
                'failed-logins'
            ],
            'failed-logouts' => [
                'iscsi-error-stats',
                make_zapi_skip('iscsi-error-stats-info'),
                'failed-logouts'
            ],
            'nop-out' => [
                'iscsi-received-stats',
                make_zapi_skip('iscsi-received-stats-info'), 'nop-out'
            ],
            'protocol'       => ['protocol'],
            'failed-logouts' => ['failed-logouts'],
            'data-out'       => ['data-out'],
            'login-req'      => [
                'iscsi-received-stats',
                make_zapi_skip('iscsi-received-stats-info'),
                'login-req'
            ],
            'failed-task-mgt' => [
                'iscsi-error-stats',
                make_zapi_skip('iscsi-error-stats-info'),
                'failed-task-mgt'
            ],
            'hdr-digest' => [
                'iscsi-error-stats',
                make_zapi_skip('iscsi-error-stats-info'),
                'hdr-digest'
            ],
            'invalid-header' => [
                'iscsi-error-stats',
                make_zapi_skip('iscsi-error-stats-info'),
                'invalid-header'
            ],
            'outside-cmd-sn-window' => [
                'iscsi-error-stats',
                make_zapi_skip('iscsi-error-stats-info'),
                'outside-cmd-sn-window'
            ],
            'total-pdus-received' => [
                'iscsi-received-stats',
                make_zapi_skip('iscsi-received-stats-info'), 'total'
            ],
            'scsi-cmd' => [
                'iscsi-received-stats',
                make_zapi_skip('iscsi-received-stats-info'),
                'scsi-cmd'
            ],
            'logout-req' => [
                'iscsi-received-stats',
                make_zapi_skip('iscsi-received-stats-info'),
                'logout-req'
            ],
            'snack' => [
                'iscsi-received-stats',
                make_zapi_skip('iscsi-received-stats-info'), 'snack'
            ],
            'text-req' => [
                'iscsi-received-stats',
                make_zapi_skip('iscsi-received-stats-info'),
                'text-req'
            ],
            'unknown' => [
                'iscsi-received-stats',
                make_zapi_skip('iscsi-received-stats-info'), 'unknown'
            ],
            'scsi-task-mgt-cmd' => [
                'iscsi-received-stats',
                make_zapi_skip('iscsi-received-stats-info'),
                'scsi-task-mgt-cmd'
            ],

            'total-pdus-transmitted' => [
                'iscsi-transmitted-stats',
                make_zapi_skip('iscsi-transmitted-stats-info'),
                'total-pdus-transmitted'
            ],
            'async-msg' => [
                'iscsi-transmitted-stats',
                make_zapi_skip('iscsi-transmitted-stats-info'),
                'async-msg'
            ],
            'data-in' => [
                'iscsi-transmitted-stats',
                make_zapi_skip('iscsi-transmitted-stats-info'), 'data-in'
            ],
            'login-rsp' => [
                'iscsi-transmitted-stats',
                make_zapi_skip('iscsi-transmitted-stats-info'),
                'login-rsp'
            ],
            'logout-rsp' => [
                'iscsi-transmitted-stats',
                make_zapi_skip('iscsi-transmitted-stats-info'),
                'logout-rsp'
            ],
            'nop-in' => [
                'iscsi-transmitted-stats',
                make_zapi_skip('iscsi-transmitted-stats-info'), 'nop-in'
            ],
            'reject' => [
                'iscsi-transmitted-stats',
                make_zapi_skip('iscsi-transmitted-stats-info'), 'reject'
            ],
            'ready-to-transmit' => [
                'iscsi-transmitted-stats',
                make_zapi_skip('iscsi-transmitted-stats-info'),
                'ready-to-transmit'
            ],
            'scsi-task-mgt-rsp' => [
                'iscsi-transmitted-stats',
                make_zapi_skip('iscsi-transmitted-stats-info'),
                'scsi-task-mgt-rsp'
            ],
            'scsi-rsp' => [
                'iscsi-transmitted-stats',
                make_zapi_skip('iscsi-transmitted-stats-info'),
                'scsi-rsp'
            ],
        },
    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

sub _fetch_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg    = shift;
    my %opts   = validate @_, $pkg->_fetch_backend_validate_spec();
    my $apiset = delete $opts{apiset};
    my $filter = delete $opts{filter};
    my @state_objs;
    my $response = $apiset->iscsi_stats();
    my $output   = $response->get_parsed_output();
    my $i        = 0;
    my $obj      = $pkg->new();
    my %result;

    foreach my $row (@$output) {
        my $row_modified;
        if ($i == 0) {
            $row_modified = $pkg->_hash_copy(
                source => $row,
                copy   => [
                    qw( nop-out     text_req    scsi-cmd
                        unknown     snack       logout-req
                        data-out )
                ],
                map => {
                    'total'           => 'total_pdus_received',
                    'scsi_taskmgtcmd' => 'scsi_task_mgt_cmd',
                    'loginreq'        => 'login_req',
                    'logoutreq'       => 'logout_req',
                    'dataout'         => 'data_out',
                },
            );
        } elsif ($i == 1) {
            $row_modified = $pkg->_hash_copy(
                source => $row,
                copy   => [qw( nop-in     text_req    scsi-rsp data_in)],
                map    => {
                    'loginrsp'        => 'login_rsp',
                    'total'           => 'total_pdus_transmitted',
                    'scsi_taskmgtrsp' => 'scsi_task_mgt_rsp',
                    'logoutrsp'       => 'logout_rsp',
                    'textrsp'         => 'text_rsp',
                    'asyncmsg'        => 'async_msg',
                    'r2t'             => 'ready_to_transmit',
                    'scsi_taskmgtrsp' => 'scsi_task_mgt_rsp',
                    'logoutrsp'       => 'logout_rsp',
                },
            );
        } elsif ($i == 2) {
            $row_modified = $pkg->_hash_copy(
                source => $row,
                copy   => [qw( success_status error_status )],
                map    => {
                    'datain_blocks'  => 'data_in_blocks',
                    'total_cdbs'     => 'total_cdbs_processed',
                    'logoutrsp'      => 'logout_rsp',
                    'textrsp'        => 'text_rsp',
                    'dataout_blocks' => 'data_out_blocks',
                },
            );
        } elsif ($i == 3) {
            $row_modified = $pkg->_hash_copy(
                source => $row,
                copy   => [
                    qw( protocol     text_req    scsi-rsp
                        failed_logouts failed_logins )
                ],
                map => {
                    'pdu_discards_outside_cmdsn_window' =>
                        'outside_cmd_sn_window',
                    'total'                       => 'total_errors',
                    'failed_taskmgt'              => 'failed_task_mgt',
                    'failed_textcmd'              => 'failed_text_cmd',
                    'pdu_discards_invalid_header' => 'invalid_header',
                    'digest'                      => 'data_digest'
                },
            );
        }
        $i++;
        for my $key (keys %$row_modified) {
            $result{"$key"} = $$row_modified{"$key"};
        }
    }
    $obj->_set_fields(row => \%result);
    push @state_objs, $obj;
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_7mode_cli

1;
