# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverNfsKerberosConfig ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, benjaram@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverNfsKerberosConfig

=head1 DESCRIPTION

C<NACL::CS::VserverNfsKerberosConfig> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverNfsKerberosConfig.  A related class is
L<NACL::C::VserverNfsKerberosConfig|lib-NACL-C-VserverNfsKerberosConfig-pm>, which represents access
to an ONTAP VserverNfsKerberosConfig.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the VserverNfsKerberosConfig
element are the attributes of the VserverNfsKerberosConfig ComponentState.

=over

=item C<< "kerberos" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <kerberos-config-info>
     <is-kerberos-enabled>$value</is-kerberos-enabled>
 </kerberos-config-info>

=item C<< "keytab_uri" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <kerberos-config-info>
     <keytab-uri>$value</keytab-uri>
 </kerberos-config-info>

=item C<< "vserver" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <kerberos-config-info>
     <vserver>$value</vserver>
 </kerberos-config-info>

=item C<< "admin_username" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <kerberos-config-info>
     <admin-user-name>$value</admin-user-name>
 </kerberos-config-info>

=item C<< "spn" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <kerberos-config-info>
     <service-principal-name>$value</service-principal-name>
 </kerberos-config-info>

=item C<< "admin_password" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <kerberos-config-info>
     <admin-password>$value</admin-password>
 </kerberos-config-info>

=item C<< "address" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <kerberos-config-info>
     <ip-address>$value</ip-address>
 </kerberos-config-info>

=item C<< "lif" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <kerberos-config-info>
     <interface-name>$value</interface-name>
 </kerberos-config-info>

=item C<< numeric_id >>

Numeric Id

Filled in for CMode CLI.

=item C<< kerberos_keyblock_row >>

Kerberos Keyblock rdb row
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $kerberos_keyblock_row = $obj->kerberos_keyblock_row();
 
# $kerberos_keyblock_row contains a reference to the array of values
 
my @kerberos_keyblock_row = $obj->kerberos_keyblock_row();
 
# @kerberos_keyblock_row contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { kerberos_keyblock_row = [ value1, value2...] }

Filled in for CMode CLI.


=item C<< ou >>

Organizational Unit

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverNfsKerberosConfig;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'kerberos',
    scalar => 'keytab_uri',
    scalar => 'vserver',
    scalar => 'admin_username',
    scalar => 'spn',
    scalar => 'admin_password',
    scalar => 'address',
    scalar => 'lif',
    scalar => 'numeric_id',
    array  => 'kerberos_keyblock_row',
    scalar => 'ou',
];

=head1 METHODS

=head2 fetch

    my $VserverNfsKerberosConfig_state   = NACL::CS::VserverNfsKerberosConfig->fetch(command_interface => $ci, ...);
	my @VserverNfsKerberosConfig_states = NACL::CS::VserverNfsKerberosConfig->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI.

Invokes "kerberos-config-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        show_cmd => 'vserver nfs kerberos-config show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching vserver nfs kerberos config(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_nfs_kerberos_config_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'kerberos_config_get_iter',
        copy => [qw(admin-password keytab-uri vserver ou)],
        map  => {
            'admin-username' => 'admin-user-name',
            'spn'            => 'service-principal-name',
            'lif'            => 'interface-name',
            'address'        => 'ip-address',
            'kerberos'       => 'is-kerberos-enabled',
        }
    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

1;
