# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverNfsKerberosInterfaceAttrs ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverNfsKerberosInterfaceAttrs

=head1 DESCRIPTION

C<NACL::CS::VserverNfsKerberosInterfaceAttrs> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverNfsKerberosInterfaceAttrs.  A related class is
L<NACL::C::VserverNfsKerberosInterfaceAttrs|lib-NACL-C-VserverNfsKerberosInterfaceAttrs-pm>, which represents access
to an ONTAP VserverNfsKerberosInterfaceAttrs.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverNfsKerberosInterfaceAttrs
element are the attributes of the VserverNfsKerberosInterfaceAttrs ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)


=item C<< spn >>

Service Principal Name
Filled in for CMode CLI

=item C<< vserver >>

Vserver
Filled in for CMode CLI

=item C<< lif_id >>

Logical Interface
Filled in for CMode CLI
=back

=cut

package NACL::CS::VserverNfsKerberosInterfaceAttrs;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'spn',
    scalar => 'vserver',
    scalar => 'lif_id',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 fetch

    my $VserverNfsKerberosInterfaceAttrs_state  = NACL::CS::VserverNfsKerberosInterfaceAttrs->fetch(command_interface => $ci, ...);
    my @VserverNfsKerberosInterfaceAttrs_states = NACL::CS::VserverNfsKerberosInterfaceAttrs->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.


=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },

        ],
        exception_text =>
            'No matching VserverNfsKerberosInterfaceAttrs(s) found',
        frontend => 'NACL::CS::VserverNfsKerberosInterfaceAttrs::fetch',
        show_cmd => 'vserver nfs kerberos interface attrs show',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'vserver_nfs_kerberos_interface_attrs_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
