# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverSecurityFileDirectoryPolicyTask ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com,pkj@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverSecurityFileDirectoryPolicyTask

=head1 DESCRIPTION

C<NACL::CS::VserverSecurityFileDirectoryPolicyTask> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverSecurityFileDirectoryPolicyTask.  A related class is
L<NACL::C::VserverSecurityFileDirectoryPolicyTask|lib-NACL-C-VserverSecurityFileDirectoryPolicyTask-pm>, which represents access
to an ONTAP VserverSecurityFileDirectoryPolicyTask.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverSecurityFileDirectoryPolicyTask
element are the attributes of the VserverSecurityFileDirectoryPolicyTask ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< index_num >>

Position

Filled in for CMode CLI.

=item C<< index >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <file-directory-security-policy-task>
     <task-index-number>$value</task-index-number>
 </file-directory-security-policy-task>

=item C<< vserver >>

Vserver

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <file-directory-security-policy-task>
     <vserver>$value</vserver>
 </file-directory-security-policy-task>

=item C<< ntfs_mode >>

NTFS Propagation Mode

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <file-directory-security-policy-task>
     <ntfs-mode>$value</ntfs-mode>
 </file-directory-security-policy-task>

=item C<< path >>

Path

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <file-directory-security-policy-task>
     <path>$value</path>
 </file-directory-security-policy-task>

=item C<< policy_name >>

Policy Name

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <file-directory-security-policy-task>
     <policy-name>$value</policy-name>
 </file-directory-security-policy-task>

=item C<< ntfs_sd >>

NTFS Security Descriptor Name

This field is an array for FS and beyond and it is a scalar below FS releases
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $ntfs_sd = $obj->ntfs_sd();

# $ntfs_sd contains a reference to the array of values

my @ntfs_sd = $obj->ntfs_sd();

# @ntfs_sd contains the array of values

If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { ntfs-sd => [ value1, value2...] }

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <file-directory-security-policy-task>
     <ntfs-sd>$value</ntfs-sd>
 </file-directory-security-policy-task>

=item C<< security_type >>

Security Type

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <file-directory-security-policy-task>
     <security-type>$value</security-type>
 </file-directory-security-policy-task>

=item C<< policy_name_string >>

Policy Name String

Filled in for CMode CLI.

=item C<< ntfs_sd_string >>

Security Descriptor String

Filled in for CMode CLI.


=item C<< admin_account >>

BUILTIN Administrators

Filled in for CMode CLI.

=item C<< owner_account >>

CREATOR OWNER

Filled in for CMode CLI.

=item C<< users_account >>

BUILTIN Users

Filled in for CMode CLI.

=item C<< system_account >>

NT AUTHORITY SYSTEM

Filled in for CMode CLI.


=item C<< access_control >>

Access Control Level possible value(s) are, file-directory,slag

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverSecurityFileDirectoryPolicyTask;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR HASHREF);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use feature qw(state);

use NACL::Exceptions::NoElementsFound qw(:try);
use NACL::C::_Mixins::VserverSecurityFileDirectoryPolicyTask qw(_handle_ntfs_sd);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'index_num',
    scalar => 'index',
    scalar => 'vserver',
    scalar => 'ntfs_mode',
    scalar => 'path',
    scalar => 'policy_name',
    scalar => 'security_type',
    scalar => 'policy_name_string',
    scalar => 'ntfs_sd_string',
    scalar => 'admin_account',
    scalar => 'owner_account',
    scalar => 'users_account',
    scalar => 'system_account',
    scalar => 'access_control',
    array  => 'ntfs_sd',
];

=head1 METHODS

=head2 fetch

    my $VserverSecurityFileDirectoryPolicyTask_state  = NACL::CS::VserverSecurityFileDirectoryPolicyTask->fetch(command_interface => $ci, ...);
    my @VserverSecurityFileDirectoryPolicyTask_states = NACL::CS::VserverSecurityFileDirectoryPolicyTask->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI.

Invokes "file-directory-security-policy-task-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    state $spec = {filter => {type => HASHREF}};
    my %opts = validate_with(
        params      => \@args,
        spec        => $spec,
        allow_extra => 1,
    );

    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            }
        ],
        show_cmd       => 'vserver security file-directory policy task show',
        exception_text =>
            'No matching vserver security file-directory policy task(s) found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_security_file_directory_policy_task_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = validate @args, $pkg->_fetch_backend_validate_spec();
    my $command_interface = $opts{'command_interface'};
    my %additional_map;
    my %additional_opts;
    if ($opts{command_interface}->version_manager()
        ->is_version_ge(release => '8.3.1'))
    {
        $additional_map{'ntfs-sd'} = [make_zapi_array('ntfs-sd'),
            make_zapi_skip('file-security-ntfs-sd'),];
    } else {
        $additional_map{'ntfs-sd'} = [make_zapi_array('ntfs-sd'),
            make_zapi_skip('fsecurity-ntfs-sd'),];
    }
	my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        %opts,
        %additional_opts,
        api  => 'file_directory_security_policy_task_get_iter',
        copy => [qw(ntfs-mode policy-name path security-type vserver)],
        map  => {'index-num' => 'task-index-number', %additional_map,},
    );

    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _apply_filter {
    $Log->enter() if $may_enter;
    my ( $pkg, %opts ) = @_;
    my @cs = @{ $opts{state_objs} };
    if ( @cs ) {
        my $ci = $cs[0]->command_interface();
        my $filter = $opts{filter};
        $filter->{command_interface} = $ci;    
        $pkg->_handle_ntfs_sd(options => $filter);
        delete $filter->{command_interface};
        $pkg->SUPER::_apply_filter(%opts, filter => $filter);
    }
    $Log->exit() if $may_exit;
}
1;
