# $Id$

#
# Copyright (c) 2001-2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesNameServiceLdapClient ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverServicesNameServiceLdapClient

=head1 DESCRIPTION

C<NACL::CS::VserverServicesNameServiceLdapClient> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverServicesNameServiceLdapClient.  A related class is
L<NACL::C::VserverServicesNameServiceLdapClient|lib-NACL-C-VserverServicesNameServiceLdapClient-pm>, which represents access
to an ONTAP VserverServicesNameServiceLdapClient.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverServicesNameServiceLdapClient
element are the attributes of the VserverServicesNameServiceLdapClient ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)


=item C<< user_scope >>

User Search Scope possible value(s) are, base,onelevel,subtree
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client user-scope="$value" />


=item C<< netgroup_byhost_scope >>

Netgroup-By-Host Scope possible value(s) are, base,onelevel,subtree
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client netgroup-byhost-scope="$value" />


=item C<< base_dn >>

Base DN
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client base-dn="$value" />


=item C<< preferred_ad_servers >>

Preferred Active Directory Servers
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $preferred_ad_servers = $obj->preferred_ad_servers();
 
# $preferred_ad_servers contains a reference to the array of values
 
my @preferred_ad_servers = $obj->preferred_ad_servers();
 
# @preferred_ad_servers contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { preferred_ad_servers = [ value1, value2...] }

Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client>
  <preferred-ad-servers ip-address="@values" />
</ldap-client>


=item C<< schema >>

Schema Template
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client schema="$value" />


=item C<< user_dn >>

User DN
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client user-dn="$value" />


=item C<< asymmetric_name_mapping >>


Use different servers in each direction possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

=item C<< bind_as_cifs_server >>


Bind Using the Vserver's CIFS Credentials possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client bind-as-cifs-server="$value" />


=item C<< base_scope >>

Base Search Scope possible value(s) are, base,onelevel,subtree
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client base-scope="$value" />


=item C<< bind_dn >>

Bind DN (User)
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client bind-dn="$value" />


=item C<< group_dn >>

Group DN
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client group-dn="$value" />


=item C<< is_owner >>

Vserver Owns Configuration possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client is-owner="$value" />


=item C<< allow_ssl >>


Allow SSL for the TLS Handshake Protocol possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client allow-ssl="$value" />


=item C<< session_security >>

Client Session Security possible value(s) are, none,sign,seal
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client session-security="$value" />


=item C<< vserver >>

Vserver
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client vserver="$value" />


=item C<< min_bind_level >>


Minimum Bind Authentication Level possible value(s) are, anonymous,simple,sasl
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client min-bind-level="$value" />


=item C<< ad_domain >>

Active Directory Domain
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client ad-domain="$value" />


=item C<< netgroup_dn >>

Netgroup DN
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client netgroup-dn="$value" />


=item C<< port >>

LDAP Server Port ranges from 1 to 65535
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client tcp-port="$value" />


=item C<< group_scope >>

Group Search Scope possible value(s) are, base,onelevel,subtree
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client group-scope="$value" />


=item C<< netgroup_byhost_dn >>

Netgroup-By-Host DN
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client netgroup-byhost-dn="$value" />


=item C<< use_start_tls >>

Use start-tls Over LDAP Connections possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client use-start-tls="$value" />


=item C<< client_config >>

Client Configuration Name
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client ldap-client-config="$value" />


=item C<< servers >>

LDAP Server List
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $servers = $obj->servers();
 
# $servers contains a reference to the array of values
 
my @servers = $obj->servers();
 
# @servers contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { servers = [ value1, value2...] }

Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client>
  <servers ip-address="@values" />
</ldap-client>


=item C<< netgroup_scope >>

Netgroup Search Scope possible value(s) are, base,onelevel,subtree
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client netgroup-scope="$value" />


=item C<< query_timeout >>

Query Timeout (sec) ranges from 0 to 10
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client query-timeout="$value" />


=item C<< is_netgroup_byhost_enabled >>

Enable Netgroup-By-Host Lookup possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <ldap-client is-netgroup-byhost-enabled="$value" />

=back

=cut

package NACL::CS::VserverServicesNameServiceLdapClient;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'user_scope',
    scalar => 'netgroup_byhost_scope',
    scalar => 'base_dn',
    array  => 'preferred_ad_servers',
    scalar => 'schema',
    scalar => 'user_dn',
    scalar => 'asymmetric_name_mapping',
    scalar => 'bind_as_cifs_server',
    scalar => 'base_scope',
    scalar => 'bind_dn',
    scalar => 'group_dn',
    scalar => 'is_owner',
    scalar => 'allow_ssl',
    scalar => 'session_security',
    scalar => 'vserver',
    scalar => 'min_bind_level',
    scalar => 'ad_domain',
    scalar => 'netgroup_dn',
    scalar => 'port',
    scalar => 'group_scope',
    scalar => 'netgroup_byhost_dn',
    scalar => 'use_start_tls',
    scalar => 'client_config',
    array  => 'servers',
    scalar => 'netgroup_scope',
    scalar => 'query_timeout',
    scalar => 'is_netgroup_byhost_enabled',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 fetch

    my $VserverServicesNameServiceLdapClient_state  = NACL::CS::VserverServicesNameServiceLdapClient->fetch(command_interface => $ci, ...);
	my @VserverServicesNameServiceLdapClient_states = NACL::CS::VserverServicesNameServiceLdapClient->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes ldap-client-get-iter API for CMode ZAPI iter.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        show_cmd => 'vserver services name-service ldap client show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'iter'
            },

        ],
        exception_text =>
            'No matching VserverServicesNameServiceLdapClient(s) found',
        frontend => 'NACL::CS::VserverServicesNameServiceLdapClient::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _update_state_objs_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->SUPER::_update_state_objs_cmode_zapi(
        @args,
        zapi_field_translations => {
            hyphenate_value => [
                qw(user-scope netgroup-byhost-scope base-scope session-security
                    min-bind-level group-scope netgroup-scope)
            ],
        },
    );
    $Log->exit() if $may_exit;
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'vserver_services_name_service_ldap_client_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(netgroup-byhost-scope user-scope base-dn user-dn schema bind-as-cifs-server
                base-scope bind-dn is-owner group-dn allow-ssl session-security vserver
                min-bind-level netgroup-dn ad-domain netgroup-byhost-dn group-scope
                use-start-tls netgroup-scope query-timeout is-netgroup-byhost-enabled
                )
        ],
        map => {
            'preferred-ad-servers' => [
                make_zapi_array('preferred-ad-servers'),
                make_zapi_skip('ip-address'),
            ],
            'port' => 'tcp-port',
            'servers' =>
                [make_zapi_array('servers'), make_zapi_skip('ip-address'),],
            'client-config' => 'ldap-client-config',
        },
        api => "ldap-client-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
