# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesNdmp ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverServicesNdmp

=head1 DESCRIPTION

C<NACL::CS::VserverServicesNdmp> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverServicesNdmp.  A related class is
L<NACL::C::VserverServicesNdmp|lib-NACL-C-VserverServicesNdmp-pm>, which represents access
to an ONTAP VserverServicesNdmp.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverServicesNdmp
element are the attributes of the VserverServicesNdmp ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< data_port_range >>

Filled in for CMode CLI.

=item C<< per_qtree_exclude_enable >>

Filled in for CMode CLI.

=item C<< abort_on_disk_error >>

Filled in for CMode CLI.

=item C<< fh_dir_retry_interval >>

Filled in for CMode CLI.

=item C<< fh_node_retry_interval >>

Filled in for CMode CLI.

=item C<< debug_filter >>

Filled in for CMode CLI.

=item C<< authtype >>

Filled in for CMode CLI.
(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $authtype = $obj->authtype();
# $authtype contains a reference to the array of values
my @authtype = $obj->authtype();
# @authtype contains the array of values

=item C<< tcpwinsize >>

Filled in for CMode CLI.

=item C<< dump_detailed_stats >>

Filled in for CMode CLI.

=item C<< restore_vm_cache_size >>

Filled in for CMode CLI.

=item C<< ignore_ctime_enabled >>

Filled in for CMode CLI.

=item C<< tcpnodelay >>

Filled in for CMode CLI.

=item C<< enable >>

Filled in for CMode CLI.

=item C<< maxversion >>

Filled in for CMode CLI.

=item C<< access >>

Filled in for CMode CLI.

=item C<< vserver >>

Filled in for CMode CLI.

=item C<< backup_log_enable >>

Filled in for CMode CLI.

=item C<< offset_map_enable >>

Filled in for CMode CLI.

=item C<< dump_logical_find >>

Filled in for CMode CLI.

=item C<< debug_enable >>

Filled in for CMode CLI.

=item C<< secondary_debug_filter >>

*Secondary debug filter
Filled in for CMode CLI.

=item C<< preferred_interface_role >>

Preferred interface role, possible value(s) are
cluster,data,node-mgmt,intercluster,cluster-mgmt
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $preferred_interface_role = $obj->preferred_interface_role();
# $preferred_interface_role contains a reference to the array of values
my @preferred_interface_role = $obj->preferred_interface_role();
# @preferred_interface_role contains the array of values
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref
# filter => { preferred_interface_role = [ value1, value2...] }
Filled in for CMode CLI.


=item C<< is_secure_control_connection_enabled >>

Is Secure Control Connection Enabled possible value(s) are, true,false

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverServicesNdmp;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);

use Class::MethodMaker [
    scalar => 'data_port_range',
    scalar => 'per_qtree_exclude_enable',
    scalar => 'abort_on_disk_error',
    scalar => 'fh_dir_retry_interval',
    scalar => 'fh_node_retry_interval',
    scalar => 'debug_filter',
    array  => 'authtype',
    scalar => 'tcpwinsize',
    scalar => 'dump_detailed_stats',
    scalar => 'restore_vm_cache_size',
    scalar => 'ignore_ctime_enabled',
    scalar => 'tcpnodelay',
    scalar => 'enable',
    scalar => 'maxversion',
    scalar => 'access',
    scalar => 'vserver',
    scalar => 'backup_log_enable',
    scalar => 'offset_map_enable',
    scalar => 'dump_logical_find',
    scalar => 'debug_enable',
    scalar => 'secondary_debug_filter',
    array  => 'preferred_interface_role',
    scalar => 'is_secure_control_connection_enabled',
];

=head1 METHODS

=head2 fetch

    my $VserverServicesNdmp_state  = NACL::CS::VserverServicesNdmp->fetch(command_interface => $ci, ...);
	my @VserverServicesNdmp_states = NACL::CS::VserverServicesNdmp->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'vserver services ndmp show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'iter'
            },
        ],
        exception_text => 'No matching vserver services ndmp(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_services_ndmp_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(per-qtree-exclude-enable data-port-range abort-on-disk-error
                fh-dir-retry-interval debug-filter fh-node-retry-interval tcpwinsize
                dump-detailed-stats ignore-ctime-enabled restore-vm-cache-size tcpnodelay
                maxversion enable secondary-debug-filter offset-map-enable
                backup-log-enable dump-logical-find is-secure-control-connection-enabled
                debug-enable
                )
        ],
        map => {
            'authtype' => [
                make_zapi_array('authtype'),
                make_zapi_skip('ndmpd-authtypes'),
            ],
            'vserver'                  => 'vserver-name',
            'preferred-interface-role' => [
                make_zapi_array('preferred-interface-role'),
                make_zapi_skip('netport-role'),
            ],
        },
        api => "ndmp-vserver-attributes-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
