# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverVscanOnDemandTaskReport ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverVscanOnDemandTaskReport

=head1 DESCRIPTION

C<NACL::CS::VserverVscanOnDemandTaskReport> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverVscanOnDemandTaskReport.  A related class is
L<NACL::C::VserverVscanOnDemandTaskReport|lib-NACL-C-VserverVscanOnDemandTaskReport-pm>, which represents access
to an ONTAP VserverVscanOnDemandTaskReport.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverVscanOnDemandTaskReport
element are the attributes of the VserverVscanOnDemandTaskReport ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)


=item C<< files_infected >>

Number of Infected Files
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info files-infected="$value" />


=item C<< job_end_time >>

Job End Time
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info job-end-time="$value" />


=item C<< job_duration >>

Job Duration
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info job-duration="$value" />


=item C<< timedout_scans >>

Number of Timedout Scans
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info timedout-scans="$value" />


=item C<< internal_error >>

Number of Internal Error
Filled in for CMode CLI/ZAPI iter

=item C<< job_start_time >>

Job Start Time
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info job-start-time="$value" />


=item C<< files_cleaned >>

Number of Clean Files
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info files-cleaned="$value" />


=item C<< already_scanned_files >>

Number of Already Scanned Files
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info already-scanned-files="$value" />


=item C<< task_name >>

Task Name
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info task-name="$value" />


=item C<< vserver >>

Vserver
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info vserver="$value" />


=item C<< failed_scans >>

Number of Failed Scans
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info failed-scans="$value" />


=item C<< attempted_scans >>

Number of Attempted Scans
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info attempted-scans="$value" />


=item C<< report_directory >>

Report Directory 
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info report-directory="$value" />


=item C<< scan_retries >>

Number of scan retries
Filled in for CMode CLI/ZAPI iter

=item C<< successful_scans >>

Number of Successful Scans
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info successful-scans="$value" />


=item C<< skipped_scans >>

Number of Files Skipped from Scanning
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info skipped-scans="$value" />


=item C<< job_id >>

Job ID
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-report-info job-id="$value" />

=back

=cut

package NACL::CS::VserverVscanOnDemandTaskReport;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'files_infected',
    scalar => 'job_end_time',
    scalar => 'job_duration',
    scalar => 'timedout_scans',
    scalar => 'internal_error',
    scalar => 'job_start_time',
    scalar => 'files_cleaned',
    scalar => 'already_scanned_files',
    scalar => 'task_name',
    scalar => 'vserver',
    scalar => 'failed_scans',
    scalar => 'attempted_scans',
    scalar => 'report_directory',
    scalar => 'scan_retries',
    scalar => 'successful_scans',
    scalar => 'skipped_scans',
    scalar => 'job_id',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 fetch

    my $VserverVscanOnDemandTaskReport_state  = NACL::CS::VserverVscanOnDemandTaskReport->fetch(command_interface => $ci, ...);
	my @VserverVscanOnDemandTaskReport_states = NACL::CS::VserverVscanOnDemandTaskReport->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes vscan-on-demand-report-get-iter API for CMode ZAPI iter.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        show_cmd => 'vserver vscan on-demand-task report show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'iter'
            },

        ],
        exception_text =>
            'No matching VserverVscanOnDemandTaskReport(s) found',
        frontend => 'NACL::CS::VserverVscanOnDemandTaskReport::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _update_state_objs_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->SUPER::_update_state_objs_cmode_zapi(
        @args,
        zapi_field_translations => {
            sec_to_hrminsec       => [qw(job-duration)],
            timestamp_to_mmddyyyy => [qw(job-end-time job-start-time)],
        },
    );
    $Log->exit() if $may_exit;
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'vserver_vscan_on_demand_task_report_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(files-infected job-end-time job-duration job-start-time timedout-scans
                files-cleaned already-scanned-files task-name vserver failed-scans
                attempted-scans report-directory job-id successful-scans skipped-scans
                )
        ],
        api => "vscan-on-demand-report-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
