#
#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when the unit
##          normalization helper library for components 
##          (NACL::C::UnitNormalization) is passed invalid units
##
## @author madhavs@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NATE::Exceptions::BadUnit

=head1 Author/Maintainer

Madhav Shekar, dl-nacl-dev

=head1 Description

An exception for when the unit normalization helper library for components 
(NACL::C::UnitNormalization) is passed invalid units

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::Exceptions::BadUnit

=head2 Expected use

Use when the unit normalization helper library for components 
(NACL::C::UnitNormalization) is passed invalid units

=head2 Base Class

NATE::BaseException

=cut

package NACL::Exceptions::BadUnit;
use base qw(NATE::BaseException);
1;
