=head1 NAME

NACL::Exceptions::ClusterHealthCheckError

=head1 DESCRIPTION

The cluster is in an unhealthy state.

It may be because of health attribute is not true OR
Any of the node in cluster may be unreachable OR
Any of the process managed by SPM is not in running state OR 
Event Log may show any critrical or emergency level events.

=head1 EXAMPLE

   use NACL::Exceptions::ClusterHealthCheckError qw(:try);

   try {
       NACL::STask::Cluster->cluster_health_check(...);
   } catch NACL::Exceptions::ClusterHealthCheckError with {
       $Log->comment("Errors encountered: " $_[0]->text());
   };

=cut

package NACL::Exceptions::ClusterHealthCheckError;
use base qw(NATE::BaseException);

sub new {
    my ($pkg, @opts) = @_;
    my $text = "Errors are:\n" . join ("\n", @opts);
    my $self = $pkg->SUPER::new($text, errors => \@opts);
    return $self;
}

1;
