#
#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when an option
##          cannot be processed because of missing dependencies
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NACL::Exceptions::Constraint

=head1 Author/Maintainer

dl-nacl-dev

=head1 Description

An exception for when an option cannot be processed because of missing 
dependencies.

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::Exceptions::Constraint

=head2 Expected use

Use when an option cannot be processed because of missing dependencies.

=head2 Base Class

NATE::BaseException

=cut

package NACL::Exceptions::Constraint;
use base qw(NATE::BaseException);
1;
