#
# $Id$
#
# Copyright (c) 2009-2011 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when the 
##          destination Host is unreachable.
##
## @author dheeraj@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NACL::Exceptions::HostUnreachable

=head1 Author/Maintainer

Dheeraj Purushotham, dl-nacl-dev

=head1 Description

An exception for when the destination host is unreachable 

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::Exceptions::HostUnreachable

=head2 Expected use

Use when the destination host on pinging returns unreachable
error.

=head2 Base Class

NATE::BaseException

=cut

package NACL::Exceptions::HostUnreachable;
use base qw(NATE::BaseException);
1;
