#
#
# Copyright (c) 2001-2011 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is thrown when an invalid
##          method is called on a C/CS package.
##
## @author madhavs@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NACL::Exceptions::InvalidMethod

=head1 Author/Maintainer

Madhav Shekar, dl-nacl-dev

=head1 Description

This exception is thrown when an invalid method is called on a C/CS
package. This gets thrown when the method cannot be resolved in any of
the linked components and also cannot be resolved by the base AUTOLOAD
(which translates field names to accessor method names).

=head1 See Also

Package inherits from the BaseException module in NATE.

=cut

package NACL::Exceptions::InvalidMethod;
use base qw(NATE::BaseException);
use Class::MethodMaker [scalar => 'method'];
1;
