# Copyright (c) 2013 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of NATE::BaseException
##          that will be thrown when invalid parameters are encountered.
##
## @author rahula@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::Exceptions::InvalidParam

=head1 DESCRIPTION

An exception is raised when parameters / options are invalid. This can include
not providing the required parameters and/or providing invalid values to the
parameters.

=head1 SEE ALSO

Package inherits from the BaseException module in NATE.

=head1 EXPECTED USE

Use when caller did not provide the required parameters or invalid values
were provided.

=head1 BASE CLASS

NATE::BaseException

=cut

package NACL::Exceptions::InvalidParam;
use base qw(NATE::BaseException);
1;
