#
#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a component method
##          attempts to invoke an API in test privilege but cannot do so
##          because a promoted build is being used.
##
## @author madhavs@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NATE::Exceptions::InvalidPrivilege

=head1 Author/Maintainer

Madhav Shekar, dl-nacl-dev

=head1 Description

An exception for when a component method attempts to invoke an API in test 
privilege but cannot do so because a promoted build is being used.

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::Exceptions::InvalidPrivilege

=head2 Expected use

Use when a component method attempts to invoke an API in test 
privilege but cannot do so because a promoted build is being used.

=head2 Base Class

NATE::BaseException

=cut

package NACL::Exceptions::InvalidPrivilege;
use base qw(NATE::BaseException);
1;
