#
# $Id$
#
# Copyright (c) 2011-2012 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when the 
##          CPU load tuning phase fails in initial tuning phase
##
## @author isshwar@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NACL::Exceptions::LoadCPUFailed

=head1 Author/Maintainer

dl-nacl-dev

=head1 Description

An exception thrown from NACL::MTask::Load::BlockingLoad if the CPU load
tuning fails. For callers of NACL::MTask::Load, this exception will
be thrown if any failure occurs in the initial tuning phase.

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::Exceptions::LoadCPUFailed

=head2 Expected use

This exception should only be thrown from NACL::MTask::Load::BlockingLoad and
NACL::MTask::Load

=head2 Base Class

NATE::BaseException

=cut

package NACL::Exceptions::LoadCPUFailed;
use base qw(NATE::BaseException);
1;
