#
# Copyright (c) 2009-2011 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when diag nblade replay does not finish within the require timeout
##
## @author anerudh@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::Exceptions::ReplayNotComplete

=head1 DESCRIPTION

This exception is thrown when diag nblade replay does not finish within the required timeout


=head1 EXAMPLE

   use NACL::Exceptions::ReplayNotComplete qw(:try);

   try {
       NACL::STask::VserverCifsShare->create( command_interface => $c, nacltask_%other_opts);
   } catch NACL::Exceptions::ReplayNotComplete with {
        my $exception = shift;
        $Log->comment("Replay not completed for cifs share creation: ");
   };

=cut

package NACL::Exceptions::ReplayNotComplete;
use base qw(NATE::BaseException);

1;
