#$Id:$
#
# Copyright (c) 2009-2011 NetApp Inc.
# All rights reserved.
#
##
## @author sushantg@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::Exceptions::RevertFailure

=head1 DESCRIPTION
This exception is thrown when system node revert failed and 
we have to return the object.

In addition to the attributes that exception objects generally contain,
this exception also contains C<NACL::MTask::Revert> attribute.
This is a object of  NACL::MTask::Revert Task.

=head1 ATTRIBUTES

=head2 revert_object

In addition to the attributes that exception objects generally contain,
this exception also contains C<NACL::MTask::Revert> attribute.
This is a object of  NACL::MTask::Revert Task.

=head1 EXAMPLE

   use NACL::Exceptions::RevertFailure qw(:try);
   use NACL::MTask::Revert;

   try {
       $revert_obj=NACL::MTask::Revert->revert(
	    command_interface => $Node,
            revert_to         => '8.0',
	);
   } catch NACL::Exceptions::RevertFailure with {
        my $exception = shift;
        $Log->comment("Revert operation failed " 
           . $exception->text());
        my $failed_revert_obj = $exception->revert_object();
   };

=cut

package NACL::Exceptions::RevertFailure;
use base qw(NATE::BaseException);

use Class::MethodMaker [ scalar => 'revert_object' ];

1;
