# $Id: //depot/prod/test/nacldev/lib/NACL/Exceptions/SetFailure.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown whenever
##          Comparision of luns in the snapmirror relation got failed.
##
## @author sshaik@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::Exceptions::SetFailure

=head1 DESCRIPTION

This exception is thrown when comparison of multiple pairs of objects fail.
This is a abstract base class and this exception shouldn't be directly be
thrown by libraries. It is expected that the calling libraries to inherit
this exception (similar to LunSetFailure) and throw exceptions of subclasses.

In addition to the attributes that exception objects generally contain,
this exception also contains C<text> and C<exception_objects> attribute.
This is a scalar, which will hold the error text and the array of exception objects.

=head1 ATTRIBUTES

=head2 text

This attribute is a scalar, which will hold the error text.

=head2 exception_objects

This attribute is a array

This attribute is an array and the structure of array element
would be described in the subclasses

Being an array-field, this can be accessed in either scalar or list context.

    my $array_reference = $exception_obj->exception_objects();

                        or

    my @array = $exception_obj->exception_objects();

=cut

package NACL::Exceptions::SetFailure;
use base qw(NATE::BaseException);
use Class::MethodMaker [ array => 'exception_objects' ];
1;
