#
# $Id$
#
# Copyright (c) 2009-2011 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when the
##          invocation of traffic utilities by Traffic MTask fails
##
## @author isshwar@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NACL::Exceptions::TrafficFailed

=head1 Author/Maintainer

dl-nacl-dev

=head1 Description

An exception thrown from NACL::MTask::Traffic if the invocation
of traffic utility has failed. 

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::Exceptions::TrafficFailed

=head2 Expected use

This exception should only be thrown from NACL::MTask::Traffic

=head2 Base Class

NATE::BaseException

=cut

package NACL::Exceptions::TrafficFailed;
use base qw(NATE::BaseException);

use Class::MethodMaker [
    scalar => [ { '-type' => 'NACL::APISet::Response', }, '_response' ], ];
1;
