=head1 NAME

NACL::Exceptions::UnexpectedAVState

=head1 DESCRIPTION

An Aggregate or Volume has a different 'state' column value than expected.

=head1 EXAMPLE

   use NACL::Exceptions::UnexpectedAVState qw(:try);

   try {
       NACL::STask::Aggregate->create(%args);
   } catch NACL::Exceptions::UnexpectedAVState with {
       $Log->comment("Unexpected state was: " $_[0]->state);
   };

=cut

package NACL::Exceptions::UnexpectedAVState;
use base qw(NACL::Exceptions::UnexpectedState);

sub new {
    my ($self, $text, %args) = @_;
    $self->SUPER::new($text, %args, monitoring_fields => 'state');
}
1;
