# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a
##          method is not supported in the current ONTAP.
##
## @author bramya@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NACL::Exceptions::UnsupportedMethod

=head1 Description

The Exception gets thrown when a method is not supported by the current ONTAP version.

=head1 EXAMPLE

   use NACL::Exceptions::UnsupportedMethod;

    if ($nacl_node_obj->version_manager()->is_version_le(release =>'8.2')) {
        NACL::Exceptions::UnsupportedMethod->throw("ONTAPs 8.2.1 and later");
    }

=head1 See Also

Package inherits from the BaseException module in NATE.

=cut

package NACL::Exceptions::UnsupportedMethod;

use base qw(NATE::BaseException);
1;
