#
#   Copyright (c) 2017 NetApp, Inc., All Rights Reserved.
#   Any use, modification, or distribution is prohibited
#    without prior written consent from NetApp, Inc.
#

package NACL::Init::Config::ONTAP::SingleClusterVsimNHA;

use strict;
use warnings;

use NATE::ParamSet qw(param_global);;
use NATE::BaseException;

use Moo;
extends qw( NACL::Init::Config::ONTAP::SingleClusterVsim );

sub generate_resources {
    my ($self) = shift;

    # Get the value of the Resources.
    my $resources_param = param_global()->get('NODES') // NATE::BaseException->throw("Missing Mandatory NODES");
    my @resources = split(',', $resources_param);
    $self->resources(\@resources);
}

sub generate_setup_tasks {
    my ($self, %args) = @_;

    my $resources = $self->resources;

    $self->SUPER::generate_setup_tasks(%args);

    # remove HA create Vsims
    $self->remove_task(
        task_name => "NACL::Init::Tasks::Vsim::HACreate",
        alias     => "ha_create",
    );
}

1;

