#   Copyright (c) 2017 NetApp, Inc., All Rights Reserved.
#   Any use, modification, or distribution is prohibited
#    without prior written consent from NetApp, Inc.

# General VM operations for ESX

package NACL::Init::Config::ONTAPSelect::ESX::VMs;

use strict;
use warnings;

use NATE::ParamSet qw(param_global);

use NACL::Init::Utils qw(process_init_args);

use Moo;
extends qw(NATE::Init::Config);

sub generate_resources
{
    my ($self) = shift;

    # Get the value of the Resources.
    my $resources_param = param_global->get('OTHER_RESOURCES') //
        NATE::BaseException->throw('Missing Mandatory OTHER_RESOURCES');
    my @resources = split(/,|:/, $resources_param);
    $self->resources(\@resources);
}

sub generate_setup_tasks
{
    my $self = shift;

    # No setup tasks
}

sub generate_cleanup_tasks
{
    my $self = shift;

    $self->add_task(
        'task_name'  => 'NACL::Init::Tasks::ONTAPSelect::ESX::Host::Reconnect',
        'alias'      => 'reconnect_host',
    );

    $self->add_task(
        'task_name' => 'NACL::Init::Tasks::ONTAPSelect::ESX::Host::DestroyVMs',
        'alias'     => 'destroy_vms',
    );

}

1;
