#
#   Copyright (c) 2017 NetApp, Inc., All Rights Reserved.
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::Init::Tasks::ONTAP::ConfigureStorageFailover;

use strict;
use warnings;

use NATE::Log qw(log_global);
use NACL::C::Node;
use NACL::C::StorageFailover;
use Carp qw(confess);
use Moo;

extends qw(NATE::Init::Task);

# need to do this to prevent Moo from clashing with NATE::BaseException
BEGIN {undef *with;}

use NATE::BaseException qw(:try);

sub execute {
    my ($self, %args) = @_;

    my $resource = $args{resource};

    my $nodes;
    if (ref($resource) eq 'ARRAY') {
        $nodes = @{$resource};
    } else {
        $nodes = [$resource];
    }

    foreach my $node (@{$nodes}) {
        my $node_c = NACL::C::Node->new(name => $node);

        NACL::C::StorageFailover->modify(command_interface => $node_c,
                                         enabled => "true",
                                         node => $node);
    }
}

1;
