#   Copyright (c) 2016 NetApp, Inc., All Rights Reserved.
#   Any use, modification, or distribution is prohibited
#    without prior written consent from NetApp, Inc.

package NACL::Init::Topology::ONTAP::DeuxInit;

use strict;
use warnings;
use Data::Dumper;
use NATE::ParamSet qw(param_global);;
use NATE::Log qw(log_global);
use Carp qw(confess);
use NATE::BaseException;
use Moo;
extends qw( NATE::Init::Config );

sub generate_resources {
    my ($self) = shift;

    # Get the value of the Resources.
    my $resources_param = param_global()->get('NODES') // NATE::BaseException->throw("Missing Mandatory NODES value");
    my @resources = split(',', $resources_param);
    $self->resources(\@resources);
}

sub generate_setup_tasks {
    
    my ($self, %args) = @_;

    my $resources = $self->resources;

    # Deux Init
    my $task_obj  = $self->add_task (
                        task_name   => "NACL::Init::Tasks::deux_init",
                        alias       => "deux_init",
                        resources   => $resources,
                    );
}

sub generate_cleanup_tasks {

    my ($self, %args) = @_;

}

1;

