#   Copyright (c) 2017 NetApp, Inc., All Rights Reserved.
#   Any use, modification, or distribution is prohibited
#    without prior written consent from NetApp, Inc.

package NACL::Init::Utils::ONTAPSelect::Deploy;

use strict;
use warnings;
use IO::File;

use JSON::XS qw(decode_json);

use NATE::ParamSet           qw(param_global);
use NATE::ServiceAPI::KeyVal qw(keyval_global);

use NACL::Init::Utils::ONTAPSelect::Deploy::APIClient;

BEGIN {
    require Exporter;
    our @ISA = qw(Exporter);
    our @EXPORT_OK = qw(
        get_deploy_apiclient
    );
}

sub get_deploy_apiclient
{
    my $deploy_appliance = shift;

    my $hostrec_da = Hostrec->new('id' => $deploy_appliance);

    return NACL::Init::Utils::ONTAPSelect::Deploy::APIClient->new(
        'baseuri'  => 'https://' . $hostrec_da->hostname . '/api/v2',
        'username' => $hostrec_da->default_username,
        'password' => $hostrec_da->default_password,
    );
}

1;
