# # Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
package NACL::MTask::CLC::SmfXmlParser;

use Moose;
use Moose::Util::TypeConstraints;
use XML::Simple;
use NATE::Inc qw(find_file);
use File::Find::Rule;

my $LIB_PREFIX = find_file("P4ENV");
$LIB_PREFIX =~ s/P4ENV//;  
my $XML_DIR = "ng_docs/bedrock/export/common/gendocs/";

# find all the subdirectories of a given directory
my @subdirs = File::Find::Rule->directory->in( $directory );
 
# find all the .pm files in @INC
my @files = File::Find::Rule->file()
                            ->name( '*.pm' )
                            ->in( @INC );
 
# as above, but without method chaining
my $rule =  File::Find::Rule->new;
$rule->file;
$rule->name( '*.pm' );
my @files = $rule->in( @INC );

#
# the component
#
has 'component' => (
    is => 'ro',
    isa => 'Str',
    required => 1,
    default => '',
);

sub _get_data {
    # Instantiate the XML parser
    my $self = shift;
    my $xml = new XML::Simple;
 
    foreach my $file (@files) {
        # Read the configuration file
        
        my $data = $xml->XMLin($LIB_PREFIX.$XML_DIR.$self->component);
        
        # Store the data structure
        $conf_data{$file} = $data;
    }
    
    return \%conf_data;
}

sub get_component_methods {
    # Parse for component methods

