# $Id$
#
# Copyright (c) 2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
# VMware End User License Agreement

# VMware, Inc. (VMware) provides the vSphere Command-Line Interface (vSphere CLI)
# and/or vSphere Software Development Kit for Perl (vSphere SDK for Perl) (collectively
# the Software) to you subject to the following terms and conditions.  If you
# disagree with any of the following terms, then do not use the Software.

# 1.  The Software contains a variety of materials, interface definitions, documentation,
# sample utility applications and sample code regarding programming interfaces to one or
# more VMware products as referenced in such materials (VMware Products).  This Software
# is intended to be used to execute supplied commands and utility applications and to
# create scripts that interact with the VMware Products.

# 2.  Use Rights:  Subject to the restrictions below, you may download and make a
# reasonable number of copies of the Software contents for your use solely for the purpose
# of creating software that communicates with VMware Products (Developer Software).  For
# vSphere SDK for Perl, some code may be designated as distributable code and/or
# modifiable code at http://www.vmware.com/go/vsdkperl-redistribution-info.  For vSphere
# CLI, some code may be designated as distributable code and/ or modifiable code at
# http://www.vmware.com/go/vcli-redistribution-info.  You may use and merge all or portions
# of the distributable code with your Developer Software.  Any merged portion of any
# distributable code is subject to this Agreement.  Additionally, you may modify or create
# derivative works of all or portions of the modifiable code.  You are permitted to
# re-distribute the distributable code and the modified or derivative works of the
# modifiable code only as part of your Developer Software for non-commercial or commercial
# use. Open source software components provided with the Software are licensed to you under
# the terms of the applicable license agreements included with such open source software
# components.  The open source software licenses can be found in the open_source_licenses.txt
# file, other materials accompanying the Software, the documentation or corresponding source
# files available at http://www.vmware.com/download/vi/open_source.html.

# 3.  Restrictions:  You agree that you will not (1) use the Software to create, design or
# develop anything other than Developer Software; (2) make any more copies of the Software
# than are reasonably necessary for the authorized use and backup and archival purposes;
# (3) modify, create derivative works of, reverse engineer, reverse compile, or disassemble
# the Software, except as expressly permitted in Section 2; (4) distribute, sell, lease, rent,
# lend, or sublicense any part of the Software to any third party except as expressly permitted
# in Section 2 or; (5) use the Software to (a) create, design or develop software or service to
# circumvent, enable, modify or provide access, permissions or rights which would violate the
# technical restrictions of VMware Products, any additional licensing terms provided by VMware
# via product documentation, email notification and/or policy change on VMware website, and/or
# the terms of the End User License Agreements of VMware products; (b) disable, remove, over-ride
# or modify the display of any VMware product End User License Agreements to the end customers;
# and (c) upload or otherwise transmit any material containing software viruses or other computer
# code, files or programs designed to interrupt, destroy, or limit the functionality of any
# software or hardware.

# The restrictions in this Section 3 shall not apply if and to the extent they contradict
# mandatory local law (including, but not limited to, law implementing the EC Software Directive)
# provided that, before you exercise any rights that you believe to be entitled to based on
# mandatory law, you provide VMware with 30 days prior written notice at SDK_Legal@vmware.com and
# provide all reasonably requested information to allow VMware to assess your claim and, at
# VMwares sole discretion, to provide alternatives that reduce any adverse impact on VMwares
# intellectual property or other rights.

# 4.   VMware retains ownership of the Software, including without limitation all copyrights and
# other intellectual property rights therein. You may not remove, delete or modify any of VMware
# copyright statements in the Software.

# 5.  You may not use VMwares name, trademarks or service marks in your Developer Softwares
# names or in a way that suggests your Developer Software is certified or endorsed by VMware. Your
# use of VMware product names and trademarks shall comply with the Branding Guidelines posted at
# www.vmware.com.

# 6.  If you are currently entitled to support from VMware, you may submit a support request
# for installation assistance of this Software and assistance in executing unmodified utility
# applications or vSphere CLI commands provided with this Software.  Except as provided herein,
# you are not entitled to any VMware support for this Software or any other services from VMware
# in connection with this Software or your Developer Software.

# 7.  Term, Termination and Changes: This Agreement shall continue as long as you are in compliance
# with the terms specified herein or until otherwise terminated.  You and or VMware each may
# terminate this Agreement for any reason at any time.  You agree, upon termination, to destroy
# all copies of the Software within your possession or control. The Confidential Information,
# Limitations of Warranties, Liability and Indemnification sections set out in this Agreement
# shall survive any termination or expiration of this Agreement.

# 8.  Limitations of Warranties and Liability:  THE SOFTWARE IS PROVIDED AS IS WITHOUT ANY
# WARRANTIES OF ANY KIND.  TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, VMWARE DISCLAIMS
# ANY IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT OF INTELLECTUAL PROPERTY RIGHTS.

# TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT WILL VMWARE BE LIABLE FOR ANY
# LOST PROFITS OR BUSINESS OPPORTUNITIES, LOSS OF USE, BUSINESS INTERRUPTION, LOSS OF DATA, OR ANY
# OTHER INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE SOFTWARE OR
# YOUR USE OF THE SOFTWARE, UNDER ANY THEORY OF LIABILITY, WHETHER BASED IN CONTRACT, TORT,
# NEGLIGENCE, PRODUCT LIABILITY, OR OTHERWISE.  BECAUSE SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION
# OR LIMITATION OF LIABILITY FOR CONSEQUENTIAL OR INCIDENTAL DAMAGES, THE PRECEDING LIMITATION MAY
# NOT APPLY TO YOU.

# VMWARES LIABILITY ARISING OUT OF THE SOFTWARE PROVIDED HEREUNDER WILL NOT, IN ANY EVENT,
# EXCEED US$5.00.

# THE FOREGOING LIMITATIONS SHALL APPLY TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, REGARDLESS
# OF WHETHER VMWARE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES AND REGARDLESS OF WHETHER
# ANY REMEDY FAILS OF ITS ESSENTIAL PURPOSE.

# 9.  Indemnification: You agree to defend, indemnify and hold harmless VMware, and any of its
# directors, officers, employees, affiliates or agents, from and against any and all claims, losses,
# damages, liabilities and other expenses (including reasonable attorneys fees), arising from your
# modification or derivative works of the modifiable code, distribution or use of your Developer
# Software or breach of this Agreement.

# 10.  These terms are governed by the laws of the State of California and the United States of
# America without regard to conflict of laws principles.  You may not assign any part of this Agreement
# without the prior written consent of VMware.  Any attempted assignment without consent shall be void.
# These terms constitute the entire agreement between you and VMware with respect to the Software, and
# supersede all prior written or oral communications, understandings and agreements. Any waiver of these
# terms must be in writing to be effective. If any provision of these terms is found to be invalid or
# unenforceable, the remaining terms will continue to be valid and enforceable to the fullest extent
# permitted by law.

## @summary ESX/VirtualMachine Component Module
## @author kathar.hidayath@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::MTask::ESX::VMMigrate;

=head1 DESCRIPTION

C<NACL::MTask::ESX::VMMigrate;> ides a number of well-defined but
potentially complex or multi-step methods related to VirtualMachine
Migrate or Relocate

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 source_host_ci

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

Command Interface of the Source ESX Host

=head2 target_host_ci

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

Command Interface of the Target ESX Host

=head2 vm_name

The name of the virtual machine , used to identify it uniquely to be Migrated or Relocated.

=cut

package NACL::MTask::ESX::VMMigrate;

use strict;
use warnings;

#CPAN Imports
use Params::Validate
  qw(validate_pos validate_with validate SCALAR BOOLEAN OBJECT ARRAYREF);
use Data::Dumper;

#NATE Imports
use NATE::BaseException qw(:try);
use Tharn;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

#NACL Imports
use base qw(NACL::MTask::MTask);
use NACL::C::Component;
use NACL::C::ESX::Task;

#Third Party Imports
require VMware::VICommon;
require VMware::VIMRuntime;
require VMware::VIM25Stub;

=head1 METHODS

=head2 new

  my $vm_obj = NACL::MTask::ESX::VMMigrate->new(command_interface=>$ci,
                                          source_host_ci=>$src_ci,
					  target_host_ci=>$target_ci,
					  vm_name => $vm_name,
					  target_pool => $tgt_pool,
					  target_datastore => $tgt_ds
					  priority => $priority
                                    );

Return a new MTask::ESX::VMMigrate; Task object with the given attributes.

=cut

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'vm_name',
    scalar => [ { -type => 'NACL::C::ESX::ESXHost' }, 'command_interface', ],
    scalar => [ { -type => 'NACL::C::ESX::ESXHost' }, 'source_host_ci', ],
    scalar => [ { -type => 'NACL::C::ESX::ESXHost' }, 'target_host_ci', ],
    scalar => [ { -type => 'NACL::C::ESX::Task' },    'task_obj' ],
];

=head2 vmotion

  my $control  = NACL::MTask::ESX::VMMigrate->vmotion(
                                        command_interface => $ci,
					source_host_ci => $src_ci,
					target_host_ci => tgt_ci,
					priority => $priority,
					vm_state => $state,
					target_pool => $tgt_pool,
					target_datastore => $tgt_ds,
				);

(Class method) This method will migrate the given Virtual machine to a 
datastore associated to both source and destination ESX hosts.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

Command Interface of the VCenter Server

=item C<< source_host_ci=>$src_ci >>

(Required) See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

Command Interface of the Source ESX Host

=item C<< target_host_ci >>

(Required) See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

Command Interface of the Target ESX Host

=item C<< vm_name=>$vm_name >>

The name of the virtual machine , used to identify it uniquely to be Migrated or Relocated.

=item C<< vm_name=>$vm_state >>

The powered state of the virtual machine. Accepted values poweredOn, poweredOff, suspended.

=item C<< target_pool=>$tgt_pool >>

(Required) Name of the target pool to which the Virtual Machine should be migrated to.

=item C<< target_datastore=>$tgt_ds >>

(Required) Name of the target datastore to which both source and destination ESX hosts
are associated with

=item C<< priority=>$priority >>

(Required) Priority with which the migration should be considered to be performed. 
Accepts values defaultPriority, highPriority, lowPriority

=back

=back

=cut

sub vmotion {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_common_validate_with(
        params          => \@_,
        additional_spec => {
            vm_state         => { type => SCALAR },
            target_datastore => { type => SCALAR },
            target_pool      => { type => SCALAR },
            priority         => { type => SCALAR },
        },
    );

    my $vcenter_host_ci     = $opts{command_interface};
    my $vcenter_host_apiset = $vcenter_host_ci->apiset();

    my $begin_response        = $vcenter_host_apiset->get_service_content();
    my $begin_response_output = $begin_response->get_raw_output();
    my $begin                 = $begin_response_output->rootFolder;

    my $vms = $vcenter_host_ci->virtualmachines();
    my $vm = _find_target_vm( vm_name => $opts{vm_name}, vm_list => $vms );

    NATE::BaseException->throw( "Migrate could not be initiated as "
          . "the given Virtual Machine "
          . $opts{vm_name}
          . " was not found." )
      unless ($vm);

    my $target_datastore        = $opts{target_datastore};
    my $resource_pools          = $vcenter_host_ci->resourcepools();
    my $target_resourcepool_mor = _get_target_resourcepool_mor(
        resourcepool_list => $resource_pools,
        resourcepool_name => $opts{target_pool}
    );

    NATE::BaseException->throw( "Migrate could not be initiated as "
          . "the resource pool "
          . $opts{target_pool}
          . " could not be located." )
      unless ($target_resourcepool_mor);

    my $source_host_ci     = $opts{source_host_ci};
    my $source_host_apiset = $source_host_ci->apiset();

    my $target_host_ci     = $opts{target_host_ci};
    my $target_host_apiset = $target_host_ci->apiset();

    my $eligible_for_migrate = _check_eligibility_for_migrate(
        target_datastore => $target_datastore,
        source_host_ci   => $source_host_ci,
        target_host_ci   => $target_host_ci,
    );

    if ($eligible_for_migrate) {
        my $result = $vm->MigrateVM_Task(
            pool     => $target_resourcepool_mor,
            priority => VirtualMachineMovePriority->new( $opts{priority} ),
            state    => VirtualMachinePowerState->new( $opts{vm_state} )
        );

        my $task_obj = _get_task_object(
            apiset => $vcenter_host_apiset,
            vc_ci  => $vcenter_host_ci,
            result => $result
        );
        $Log->exit() if $may_exit;
        return $pkg_or_obj->new(
            command_interface => $vcenter_host_ci,
            source_host_ci    => $source_host_ci,
            target_host_ci    => $target_host_ci,
            vm_name           => $opts{vm_name},
            task_obj          => $task_obj,
        );
    }
    $Log->exit() if $may_exit;
    NATE::BaseException->throw(
"Target DataStore not found associated with both source and destination,"
          . "hence task not eligible for VM Migration. If destination DataStore is "
          . "different consider VM Relocation.\n" );
} ## end sub vmotion

=head2 storage_vmotion

  my $control  = NACL::MTask::ESX::VMMigrate->storage_vmotion(
                    			command_interface => $ci,
					source_host_ci => $src_ci,
					target_host_ci => tgt_ci,
					priority => $priority,
					vm_name => $vm_name,
					target_datastore => $tgt_ds,
				);

(Class method) This method relocates a virtual machine's virtual disks to a specific 
datastore. 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

Command Interface of the VCenter Server

=item C<< source_host_ci=>$src_ci >>

(Required) See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

Command Interface of the Source ESX Host

=item C<< target_host_ci >>

(Required) See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

Command Interface of the Target ESX Host

=item C<< vm_name=>$vm_name >>

The name of the virtual machine , used to identify it uniquely to be Migrated or Relocated.

=item C<< target_datastore=>$tgt_ds >>

(Required) Name of the target datastore to which both source and destination ESX hosts
are associated with

=back

=back

=cut

sub storage_vmotion {
    $Log->enter() if $may_enter;
    my ( $pkg_or_obj, @args ) = @_;
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => { target_datastore => { type => SCALAR }, },
    );

    my $vcenter_host_ci     = $opts{command_interface};
    my $vcenter_host_apiset = $vcenter_host_ci->apiset();

    my $vms = $vcenter_host_ci->virtualmachines();
    my $vm  = _find_target_vm(
        vm_name => $opts{vm_name},
        vm_list => $vms
    );

    unless ($vm) {
        $Log->exit() if $may_exit;
        NATE::BaseException->throw( "Migrate could not be initiated as "
              . "the given Virtual Machine "
              . $opts{vm_name}
              . " was not found." );
    }

    my $target_datastore           = $opts{target_datastore};
    my $target_datastore_view_resp = $vcenter_host_apiset->find_entity_view(
        view_type => 'Datastore',
        filter    => { 'name' => $target_datastore }
    );
    my $target_datastore_view = $target_datastore_view_resp->get_raw_output();

    my $relocate_spec =
      VirtualMachineRelocateSpec->new( datastore => $target_datastore_view );

    my $result = $vm->RelocateVM_Task( spec => $relocate_spec );

    my $task_obj = _get_task_object(
        apiset => $vcenter_host_apiset,
        vc_ci  => $vcenter_host_ci,
        result => $result
    );

    $Log->exit() if $may_exit;
    return $pkg_or_obj->new(
        command_interface => $vcenter_host_ci,
        source_host_ci    => $opts{source_host_ci},
        target_host_ci    => $opts{target_host_ci},
        vm_name           => $opts{vm_name},
        task_obj          => $task_obj,
    );
} ## end sub storage_vmotion

sub _object_attributes_validate_spec {
    $Log->enter() if $may_enter;
    $Log->exit() if $may_exit;
    return {
        source_host_ci => { type => OBJECT, isa => 'NACL::C::ESX::ESXHost' },
        target_host_ci => { type => OBJECT, isa => 'NACL::C::ESX::ESXHost' },
        vm_name        => { type => SCALAR },
    };
} ## end sub _object_attributes_validate_spec

sub _find_target_vm {
    $Log->enter() if $may_enter;
    my %opts = validate_with(
        params => \@_,
        spec   => {
            vm_list => { type => ARRAYREF, optional => 0 },
            vm_name => { type => SCALAR,   optional => 0 },
        }
    );

    my $name = $opts{vm_name};
    my $vms  = $opts{vm_list};

    foreach my $vm ( @{$vms} ) {
        if ( $vm->config->name eq $name ) {
            $Log->exit() if $may_exit;
            return $vm;
        }
    }
    $Log->exit() if $may_exit;
} ## end sub _find_target_vm

sub _get_target_resourcepool_mor {
    $Log->enter() if $may_enter;
    my %opts = validate_with(
        params => \@_,
        spec   => {
            resourcepool_list => { type => ARRAYREF, optional => 0 },
            resourcepool_name => { type => SCALAR,   optional => 0 },
        }
    );
    my $resourcepools = $opts{resourcepool_list};
    foreach my $resourcepool (@$resourcepools) {
        if ( $resourcepool->summary->name eq $opts{resourcepool_name} ) {
            $Log->exit() if $may_exit;
            return $resourcepool->{mo_ref};
        }
    }
    $Log->exit() if $may_exit;
} ## end sub _get_target_resourcepool_mor

sub _check_eligibility_for_migrate {
    $Log->enter() if $may_enter;
    my %opts = validate_with(
        params => \@_,
        spec   => {
            target_datastore => { type => SCALAR, optional => 0 },
            source_host_ci =>
              { type => OBJECT, isa => 'NACL::C::ESX::ESXHost' },
            target_host_ci =>
              { type => OBJECT, isa => 'NACL::C::ESX::ESXHost' },
        }
    );

    my $source_datastore_found = _is_datastore_found(
        target_datastore => $opts{target_datastore},
        host_ci          => $opts{source_host_ci}
    );
    my $target_datastore_found = _is_datastore_found(
        target_datastore => $opts{target_datastore},
        host_ci          => $opts{target_host_ci}
    );

    if ( $source_datastore_found and $target_datastore_found ) {
        $Log->exit() if $may_exit;
        return 1;
    }
    else {
        $Log->exit() if $may_exit;
        return 0;
    }
} ## end sub _check_eligibility_for_migrate

sub _is_datastore_found {
    $Log->enter() if $may_enter;
    my %opts = validate_with(
        params => \@_,
        spec   => {
            target_datastore => { type => SCALAR, optional => 0 },
            host_ci          => {
                type => OBJECT,
                isa  => 'NACL::C::ESX::ESXHost'
            },
        }
    );

    my $target_datastore = $opts{target_datastore};
    my $host_ci          = $opts{host_ci};

    my $host_view = $host_ci->hostsystem();

    if ( defined $host_view->datastore ) {
        my $host_apiset = $host_ci->apiset();
        my $host_mor    = $host_view->datastore;
        my $datastores_response =
          $host_apiset->get_views( mo_ref_array => $host_mor );
        my $datastores = $datastores_response->get_raw_output();
        foreach (@$datastores) {
            my $name = $_->summary->name;
            if ( $name eq $target_datastore ) {
                $Log->exit() if $may_exit;
                return 1;
            }
        }
        $Log->exit() if $may_exit;
        return 0;
    }

} ## end sub _is_datastore_found

sub _get_task_object {
    $Log->enter() if $may_enter;
    my %opts = validate_with(
        params => \@_,
        spec   => {
            apiset =>
              { isa => 'NACL::APISet::Host::VMAPI::ESX', optional => 0 },
            result => { isa => 'ManagedObjectReference' },
            vc_ci  => { isa => 'NACL::C::ESX::ESXHost' },
        },
        allow_extra => 1,
    );

    my $apiset            = $opts{apiset};
    my $command_interface = $opts{vc_ci};
    my $result            = $opts{result};

    my $response_for_task = $apiset->get_view( mo_ref => $result );
    my $task              = $response_for_task->get_raw_output();
    my $task_obj          = NACL::C::ESX::Task->new(
        'command_interface' => $command_interface,
        'key'               => $task->info()->key()
    );
    $task_obj->info( $task->info() );
    $Log->exit() if $may_exit;
    return $task_obj;
} ## end sub _get_task_object

1;
