#
#
# Copyright (c) 2016 NetApp Inc.
# All rights reserved.
#
## @summary Provide a generic exception class (a subclass of
##          NATE::BaseException) that will be thrown for
##          incorrect method parameters usage.
##          Callers should catch this specific exception
##          for handling invalid values to method parameters
##          or combinations of conflicting parameters.
##
## @author nimishp@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NACL::MTask::Exceptions::IncorrectParameterUsage

=head1 Author/Maintainer

dl-kernel-qa

=head1 Description

A generic NACL MTask exception for invalid values to method parameters
or combinations of conflicting parameters.

=head1 See Also

Package inherits from NATE::BaseException

=head1 NACL::MTask::Exceptions::IncorrectParameterUsage

=head2 Expected use

Throw this exception for incorrect method parameters usage.

=head2 Base Class

NATE::BaseException

=cut

package NACL::MTask::Exceptions::IncorrectParameterUsage;
use base qw(NATE::BaseException);

1;
