#
#
# Copyright (c) 2016 NetApp Inc.
# All rights reserved.
#
## @summary Provide a generic exception class (a subclass of
##          NATE::BaseException) that will be thrown for
##          when a new SRAM dump is detected during the check method
##          of NACL::MTask::SRAMDetector
##
## @author abowden@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NACL::MTask::Exceptions::SRAMDumpDetected

=head1 Author/Maintainer

ng-san-qa-rtp

=head1 Description

A generic NACL exception for when a new SRAM dump is detected during the check
method of NACL::MTask::SRAMDetector

=head1 See Also

Package inherits from NATE::BaseException

=head1 NACL::MTask::Exceptions::SRAMDumpDetected

=head2 Expected use

Throw this exception for file operation failures.

=head2 Base Class

NATE::BaseException

=cut

package NACL::MTask::Exceptions::SRAMDumpDetected;
use base qw(NATE::BaseException);

1;
