#
# Copyright (c) 2014-20* NetApp Inc.
# All rights reserved.
#
## @summary Simple class that can be used to test
##  HealthChecker functionality.
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

package NACL::MTask::HealthChecker::UnitTest;
sub start {
    my ($self) = @_;
    $self->SUPER::start(execute_in_parallel => 0);
}

use base qw(NACL::MTask::HealthChecker);

package NACL::MTask::HealthChecker::UnitTest::UnitTestA;
use base 'NACL::MTask::HealthChecker::UnitTest';
use Tharn qw($Log);

sub check_health_A1 {
    my ($self) = @_;
    $Log->comment("hc ran successfully for method A1");
}

sub check_health_A2 {
    my ($self) = @_;
    $Log->comment("hc ran successfully for method A2");
}

package NACL::MTask::HealthChecker::UnitTest::UnitTestB;
use base 'NACL::MTask::HealthChecker::UnitTest';
use Tharn qw($Log);

sub check_health_B1 {
    my ($self) = @_;
    $Log->comment("hc ran successfully for method B1");
}

sub check_health_B2 {
    my ($self) = @_;
    NATE::BaseException->throw("hc reported error for method B2");
}


package NACL::MTask::HealthChecker::UnitTest::UnitTestC;
use base 'NACL::MTask::HealthChecker::UnitTest';
use Tharn qw($Log);

sub check_health_C1 {
    my ($self) = @_;
    NATE::BaseException->throw("hc reported error for method C1");
}

sub check_health_C2 {
    my ($self) = @_;
    NATE::BaseException->throw("hc reported error for method C2");
}

package NACL::MTask::HealthChecker::UnitTest::UnitTestD;
use base 'NACL::MTask::HealthChecker::UnitTest';
use Tharn qw($Log);

sub check_health_D1 {
    my ($self) = @_;
    $Log->comment("hc ran successfully for method D1");
}

sub check_health_D2 {
    my ($self) = @_;
    NATE::BaseException->throw("hc reported error for method D2");
}

1;
