#
#
# Copyright (c) 2009-2014 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::MTask::MCC::Exceptions::DiskState that will be
##          thrown when an MCC disk state indicates that this machine
##          was initialized using fake_init, and hence cannot be
##          validated.
##
## @author dl-mcc-dpg-qa@netapp.com
## @status Shared
## @pod here

package NACL::MTask::MCC::Exceptions::DiskState::FakeInitState;

use strict;
use warnings;
use Carp;

use base qw(NACL::MTask::MCC::Exceptions::DiskState);

=pod

=head1 Package Name

NACL::MTask::MCC::Exceptions::DiskState::FakeInitState

=head1 Author/Maintainer

dl-mcc-dpg-qa@netapp.com

=head1 Description

NACL::MTask::MCC::Exceptions::DiskState::FakeInitState is a subclass of
NATE::Mtask::MCC:Exceptions::DiskState that will be thrown when an MCC
disk state indicates that it was initialized with fake init.

    NACL::MTask::MCC::Exceptions::DiskState::FakeInitState->
                                                     throw('my error message');


=head1 See Also

Package inherits from the DiskState module in NACL::MTask::MCC::Exceptions.

=head2 Base Class

NACL::MTask::MCC::Exceptions::DiskState

=cut

# No functionality changes compared to NATE::BaseException, just more specific
# object identity wrt MCC systems.

1;

