#
#
# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a general State
##          exception occurs.  It can also be used to
##          catch any of the different State exceptions.
##
## @author dl-mcc-dpg-qa@netapp.com
## @status Shared
## @pod here

package NACL::MTask::MCC::Exceptions::State;

use strict;
use warnings;
use Carp;

use parent qw(NACL::MTask::MCC::Exceptions::BaseException);

=pod

=head1 Package Name

NACL::MTask::MCC::Exceptions::State

=head1 Author/Maintainer

dl-mcc-dpg-qa@netapp.com

=head1 Description

NACL::MTask::MCC::Exceptions::State is a subclass of
NATE::BaseException that will be thrown when a general State exception
occurs.  It can also be used to catch any of the different
State exceptions.

    NACL::MTask::MCC::Exceptions::State->throw('my error message');


=head1 See Also

Package inherits from the BaseException module in NACL::MTask::MCC::Exceptions.

=head2 Base Class

NACL::MTask::MCC::Exceptions::BaseException

=cut

# No functionality changes compared to NATE::BaseException, just more specific
# object identity wrt MCC systems.

1;

