#
#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when Switch
##          exceptions occur.
##
## @author dl-mcc-dpg-qa@netapp.com
## @status Shared
## @pod here

package NACL::MTask::MCC::Exceptions::Switch;

use strict;
use warnings;
use Carp;

use base qw(NACL::MTask::MCC::Exceptions::BaseException);

=pod

=head1 Package Name

NACL::MTask::MCC::Exceptions::Switch

=head1 Author/Maintainer

dl-mcc-dpg-qa@netapp.com

=head1 Description

NACL::MTask::MCC::Exceptions::Switch is a subclass of NATE::BaseException that
will be thrown when any Switch operation exceptions occur.

    NACL::MTask::MCC::Exceptions::Switch->throw('my error message');

See the NACL::MTask::MCC::Network::Switch_Impl::BrocadeFC_Impl lib for example
usage.

=head1 See Also

Package inherits from the BaseException module in NACL::MTask::MCC::Exceptions

=head2 Base Class

NACL::MTask::MCC::Exceptions::BaseException

=cut

# No functionality changes compared to NATE::BaseException, just more specific
# object identity wrt MCC systems

1;

