package NACL::MTask::MCC::Menu;

use strict;
use warnings;
use Carp;


use base qw (NACL::MTask::MTask);

#use NACL::MTask::MCC::Metrocluster;
use Tharn qw( subtest);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Net::DNS::Resolver;

#double check these qw are used TODO
use Params::Validate
    qw(validate validate_with BOOLEAN HASHREF OBJECT ARRAYREF SCALAR UNDEF);

use Data::Dumper;

=head1 NAME

NACL::MTask::MCC::MetroCluster::Menu
??::Menu

=head1 DESCRIPTION

Displays an interactive cli utility menu to call common library functionality.

=cut

=head2 menu()

B<EXPERIMENTAL!>

This will be removed at some point to be replaced with a different structure
(put the same/similar functionality).

Displays an interactive cli utility menu to call common library functionality.


=cut

# Automatically generate the constructor (includes a call to
# 'init') and also creates non-public members and non-public accesors for
# them.
#
use Class::MethodMaker [
    new    => [ '-init', 'new' ],
    #scalar => [
    #{ -type => 'NACL::MTask::MCC::Metrocluster' },
    #'_metrocluster',
    #],
    #scalar => [
    #{ -type => 'NACL::MTask::MCC::DR_Coordinator' },
    #'_DR_coordinator',
    #],
    scalar => [
        qw/
            current_menu
            _exit
            _history
            history_file
            macro
            macro_filename
            macro_play_filename
            _macro_recording
            _macro_running
            _macro_commands
            menu
            name
            order
            path
            prompt
            prompt_post
            _setting
            _variables
            visible
            wait_on_comment
          /,
              ],
                       ];

# validate the parameters passed in and what else?
sub init {
    $Log->enter() if $may_enter;
    my $self = shift;
    my %opts = validate_with(
        params => \@_,
        spec   => {
            #metrocluster => { isa   => 'NACL::MTask::MCC::Metrocluster' },
            #site         => { regex => qr/^(A|B)$/ },
            _exit           => { default => 0 },
            macro           => { type => ARRAYREF, default => [] },
            _macro_commands => { type => ARRAYREF, default => [] },
            menu            => { type => HASHREF, default => {} },
            name            => { type => SCALAR },
            order           => { optional => 1 },
            prompt          => { type => SCALAR, default => 'menu' },
            prompt_post     => { type => SCALAR, default => '>' },
            _variables      => { type => HASHREF, default => {} },
            visible         => { type => BOOLEAN, default => 1 },


        },
        allow_extra => 1, #may not keep this TODO
                            );
        $self->path(());
    # set members per the passed constructor arguments.
    $self->_exit($opts{_exit});
    $self->name($opts{name});
    $self->order($opts{order});
    $self->prompt($opts{prompt});
    $self->prompt_post($opts{prompt_post});
    $self->_variables($opts{_variables});
    $self->visible($opts{visible});
    $self->macro($opts{macro});
    $self->_macro_commands($opts{_macro_commands});
    $self->menu($opts{menu});

    my $mymenu = core_menu();
    #my $id = $self->add_menu(menu => core_menu(), add_to_menu => $mymenu);
    my $id = $self->add_menu(menu => $mymenu);

    #$self->current_menu($id); # TODO think current menu should be removed

print Dumper $self->{menu} if $self->debug();
print Dumper $self if $self->debug();
#mprint (Dumper $self->menu);


    $Log->exit() if $may_exit;
    return;
}

sub debug {
    my $self = shift;
    #TODO ref check here as some call appeared to be a static one (?).  init?
    #should this check be in get_variable?
    return (ref $self) && $self->get_variable(name => 'debug');
}

sub start {
    $Log->enter() if $may_enter;
    my $self = shift;


    print Dumper $self if $self->debug();
    #mprint(Dumper $self);

    while (!$self->{_exit}) {
        #mprint($self->menu_layout());
        my ($menu_output, $menu, $order, $id_lookup, $key_lookup,$info) =
            $self->menu_layout(info => 1);
print Dumper $order if $self->debug();
print "MENU:" . Dumper $menu if $self->debug();
        mprint(join "\n",@{$info});
        mprint("\n");
        mprint($menu_output);
        #my $in = <STDIN>;
        #chomp $in;
        my $in = $self->get_input();
        my $out = $self->process_input(input => $in);
        #print "key: $order->[$in] $menu->{$order->[$in]}->{name}\n";
        #push @{$self->{path}},$order->[$in];
        #
        #print "key: $id_lookup->{$in} $menu->{items}->{$id_lookup->{$in}}->{name}\n";
        #push @{$self->{path}},$id_lookup->{$in};


    }
    $Log->exit() if $may_exit;
}

sub exit {
    my $self = shift;

    $self->{_exit} = 1;
}

sub add_menu {
    my $self = shift;

    my %opts = validate_with(
        params => \@_,
        spec   => {
            menu => { type => HASHREF },
            add_to_menu => { type => HASHREF, optional => 1, },
        },
    );

    #TODO maybe by passing a path, can add menu to a deeper sub menu
    my $menu = $opts{menu};
    my $add_to_menu = $opts{add_to_menu};
    my $id = $menu->{id};
    print Dumper $menu if $self->debug();
    print Dumper $self if $self->debug();
    #$self->menu->{$id} = $menu;

    if ($add_to_menu) {
        #this will overwrite anything there TODO warn/disallow?
        $add_to_menu->{menu}->{items}->{$id} = $menu;
    } else {
        $self->menu->{items}->{$id} = $menu;
    }

    return $id;

}

sub get_input {
    my $self = shift;

    my %opts = validate_with(
        params => \@_,
        spec   => {
            save_raw => { type => SCALAR, default => 0 },
            #id_hash => { type => HASHREF, optional => 1, },#id_lookup
        },
    );

    #deal w/macros here?? read/save... TODO
    #if $self->macro_running, etc...
    my $in;
    my ($menu_output, $menu, $order, $id_lookup, $key_lookup,$info) =
        $self->menu_layout();

    if ($self->{_macro_running} && (! scalar @{$self->{macro}})) {
        mprint("macro completed\n");
        $self->{_macro_running} = 0;
    }

    if ($self->{_macro_running}) {
        my $id = shift @{$self->{macro}};
        chomp $id;
        #TODO want to return $id?  yes, if it's not defined then it's a #
        $in = defined $key_lookup->{$id} ? $key_lookup->{$id} : $id;
        print("execute macro command:$id [$in]\n");
        mprint("macro command:$id [$in]\n");

    } else {
        ## no critic (InputOutput::ProhibitExplicitStdin)
        $in = <STDIN>;
        chomp $in;
        #just take a parameter to save the # instead of id (token)
        my $id = $id_lookup->{$in} || $in;
        $id = $in if $opts{save_raw};
print "INPUT:$in [$id]\n" if $self->debug();
        push @{$self->{history}},$id;
        push @{$self->{_macro_commands}},$id;
    }

print Dumper $self->{history} if $self->debug();
    return $in;

}

sub process_input {
    my $self = shift;

    my %opts = validate_with(
        params => \@_,
        spec   => {
            input => { type => SCALAR, optional => 1 },
        },
    );

    my $in = $opts{input};

    #figure out what menu id (MENU), command id ($in), path, etc...
    #execute code or  move to submenu, etc

    #TODO better way?  store these? no, dynamic better, but...pass in?? eh...
    my ($menu_output, $menu, $order, $id_lookup, $key_lookup,$info) =
        $self->menu_layout();

    my $up_command = '..'; #may allow defining later, eg, blank (<return>)


    if (exists $id_lookup->{$in}) {
        #TODO next
        if ($self->is_menu(menu => $menu, name => $id_lookup->{$in})) {
        print "key: $id_lookup->{$in} $menu->{items}->{$id_lookup->{$in}}->{name}\n" if $self->debug();
            print "yep it's a menu...\n" if $self->debug();
            #TODO put this into method probably
            my $reqerr;
            if (defined $menu->{items}->{$id_lookup->{$in}}->{menu}->{prerequisites} &&
            defined $menu->{items}->{$id_lookup->{$in}}->{menu}->{prerequisites}->{variables}) {
                print("prerequisites!\n") if $self->debug();
                #TODO we are going with an arrayref of these I think...do we need more info than just a list??
                #foreach my $var (keys %{$menu->{items}->{$id_lookup->{$in}}->{menu}->{prerequisites}->{variables}}) {
                foreach my $var ( @{$menu->{items}->{$id_lookup->{$in}}->{menu}->{prerequisites}->{variables}}) {
                    if (! defined $self->get_variable(name => $var)) {
                        #TODO assumption here about 'location' of var ... maybe global var should hold name + value
                        my $varname = $menu->{variables}->{$var}->{name} || $var;
                        mprint("*** $varname required for menu $id_lookup->{$in} ***\n");
                        $reqerr++;
                    }
                }

            }
            push @{$self->{path}},$id_lookup->{$in} unless $reqerr;
        } elsif ($self->is_code(menu => $menu, name => $id_lookup->{$in})) {
        print "key: $id_lookup->{$in} $menu->{items}->{$id_lookup->{$in}}->{name}\n" if $self->debug();
            print "it's code...\n" if $self->debug();
            $self->execute_code(menu => $menu, name => $id_lookup->{$in});

        } elsif ($self->is_variable(menu => $menu, name => $id_lookup->{$in})) {
            print "it's a variable...\n" if $self->debug();
            $self->variable_input(menu => $menu, name => $id_lookup->{$in});
        } else {
            print "no code or menu defined for $menu $id_lookup->{$in}!\n" if $self->debug();

        }

    } elsif ($in eq $up_command) { # up a menu (..)
        print "(up a level)\n" if $self->debug();
        pop @{$self->{path}};
    } elsif ($in =~ /^#/) { #comment
        print "COMMENT: $in\n" if $self->debug();

    } elsif (my($var,$value) = $in =~ /([^=]+)\s*=\s*([^=]+)/) {
        print "VAR:$var VAL:$value\n" if $self->debug();
        $self->set_variable(name => $var, value => $value);
    } else {
        print "unknown input: $in\n" if $self->debug();


    }



}

sub execute_code {
    my $self = shift;

    my %opts = validate_with(
        params => \@_,
        spec   => {
            menu => { type => HASHREF },
            name => { type => SCALAR | UNDEF, optional => 1 },
        },
    );
    my $code =  $opts{menu}->{items}->{$opts{name}}->{code};

    #print ntest::NTEST_STDOUT "execute code: $selected\n";
    eval {
        mprint("running code...\n");
        #$code->($setting);
        &$code($self);
        #TODO NEXT... clean up code execution, add variable and pass to code here...so it can get the parameters we care about
    };
    if ($@) { mprint( $@ ); }
    #return $opts{name} &&
    #exists $opts{menu}->{items}->{$opts{name}}->{code} &&
    #defined $opts{menu}->{items}->{$opts{name}}->{code};

}

sub variable_input {
    my $self = shift;

    my %opts = validate_with(
        params => \@_,
        spec   => {
            name => { type => SCALAR },
            menu => { type => HASHREF, optional => 1 },
        },
    );

    my $name = $opts{name};
    my $menu = $opts{menu};



    #OK, experimental ... a {list} is a coderef that will return a list of
    #choices to select from.  This value is then set.
    #TODO  revisit maybe...
    if (defined $menu->{variables}->{$name}->{list} &&
        ref $menu->{variables}->{$name}->{list} eq 'CODE' ) {
        print "running list code...\n" if $self->debug();
        my @list;
        eval {
            @list = &{$menu->{variables}->{$name}->{list}}($self);
            print Dumper \@list if $self->debug();
        };
        if ($@) { mprint($@); }
        my $menu = list_to_menu(list => \@list);
        my ($menu_output, $menu_obj, $order, $id_lookup, $key_lookup,$info) =
            $self->menu_layout( path => [], root => $menu);
        mprint($menu_output);
print Dumper $id_lookup if $self->debug();
        my $in = $self->get_input(save_raw => 1);
        #TODO verify valid, etc, first
        if (defined $id_lookup->{$in}) {
            print "key $in OK\n" if $self->debug();
            $self->set_variable(name => $name, value => $id_lookup->{$in});
        } else {
            print "key $in undefined\n" if $self->debug();
        }

    } else {
        print "hmmm, no variable {list}, prompt user for input...\n" if $self->debug();
        mprint("$name=");
        my $in = $self->get_input(save_raw => 1);
        $self->set_variable(name => $name, value => $in);

    }



    return ($opts{menu} && exists $opts{menu}->{variables}->{$opts{name}})
           ||
           ($opts{name} && exists $self->{_variables}->{$opts{name}});
        #return $opts{variable} &&
        #exists $self->{_variables}->{$opts{variable}};
}

sub list_to_menu {
    #my $self = shift;

    my %opts = validate_with(
        params => \@_,
        spec   => {
            list => { type => ARRAYREF },
            id   => { type => SCALAR, default => 'id' },
            #menu => { type => HASHREF, optional => 1 },
        },
    );

    my @list = @{ $opts{list} };
    #TODO allow inputs here
    my $id = 'id';
    my $name = 'name';

    my $items;

    foreach my $item (@list) {
#print "list item:$item\n";
        $items->{$item} = {};   #TODO need more def?
    }

    my $menu = {
        id => $id,
        name => $name,
        menu => { items => $items },
    };
    #TODO
    $menu = {
        id => $id,
        name => $name,
        items => $items ,
    };

#print Dumper $menu;
    return $menu;


}

sub is_variable {
    my $self = shift;

    my %opts = validate_with(
        params => \@_,
        spec   => {
            name => { type => SCALAR },
            menu => { type => HASHREF, optional => 1 },
        },
    );


    return ($opts{menu} && exists $opts{menu}->{variables}->{$opts{name}})
           ||
           ($opts{name} && exists $self->{_variables}->{$opts{name}});
        #return $opts{variable} &&
        #exists $self->{_variables}->{$opts{variable}};
}

sub get_variable {
    my $self = shift;

    my %opts = validate_with(
        params => \@_,
        spec   => {
            name => { type => SCALAR },
        },
    );

    return $self->{_variables}->{$opts{name}};

}

sub set_variable {
    my $self = shift;

    my %opts = validate_with(
        params => \@_,
        spec   => {
            name     => { type => SCALAR },
            value    => {  }, #TODO types?
            #value    => { type => SCALAR }, #TODO types?
        },
    );

    $self->{_variables}->{$opts{name}} = $opts{value};
print Dumper $self->{_variables} if $self->debug();
    return;

}

#instance?
sub is_menu {
    my $self = shift;

    my %opts = validate_with(
        params => \@_,
        spec   => {
            menu => { type => HASHREF },
            name => { type => SCALAR | UNDEF, optional => 1 },
        },
    );
print "MENU MENU MENU" . Dumper  $opts{menu} if $self->debug();
    return $opts{name} &&
        exists $opts{menu}->{items}->{$opts{name}} &&
        exists $opts{menu}->{items}->{$opts{name}}->{menu} &&
        defined $opts{menu}->{items}->{$opts{name}}->{menu};
}

sub is_code {
    my $self = shift;

    my %opts = validate_with(
        params => \@_,
        spec   => {
            menu => { type => HASHREF },
            name => { type => SCALAR | UNDEF, optional => 1 },
        },
    );

    return $opts{name} &&
        exists $opts{menu}->{items}->{$opts{name}} &&
        exists $opts{menu}->{items}->{$opts{name}}->{code} &&
        defined $opts{menu}->{items}->{$opts{name}}->{code};
}

#return menu of given name
sub get_menu {
    my $self = shift;

    my %opts = validate_with(
        params => \@_,
        spec   => {
            name => { type => SCALAR, optional => 1 },
        },
    );

    my $name = $opts{name} || $self->current_menu;

    return $self->menu->{items}->{$name};

}



sub mprint {
    while ($_ = shift) {
        print ntest::NTEST_STDOUT $_;
    }
}

sub menu_layout {
    my $self = shift;
    my %args = @_;

    #my @path = @{$self->{path} || $args{path} || []};
    my @path = @{$args{path} || $self->{path} || []};
    #my $menu = $self->{menu} || $args{root};
    my $menu = $args{root} || $self->{menu} ;
    my $info = $args{info};

    $menu = $menu->{$self->current_menu} if $self->current_menu;
    my @info;

    foreach my $next (@path) {
        if ($info &&
            defined $menu->{info} &&
            defined $menu->{info}->{code} &&
            $menu->{info}->{hierarchy}
        ) {
            #execute any info code
            eval {
                print("running hierarchy info code...\n") if $self->debug();
                push @info,&{$menu->{info}->{code}}($self);
            };
            if ($@) { mprint ($@); }
        }

        print "next menu:$next\n" if $self->debug();
        $menu = $menu->{items}->{$next}->{menu};
    }

    if ($info &&
        defined $menu->{info} &&
        defined $menu->{info}->{code}
    ) {
        #execute any info code
        eval {
            print("running info code...\n") if $self->debug();
            #$code->($setting);
            push @info,&{$menu->{info}->{code}}($self);
        };
        if ($@) { mprint ($@); }
    }


    #print ntest::NTEST_STDOUT Dumper $menu; #TODO debug

    my $output;

    my @order;        #order of menu items
    my @numorder;     #order of numbered menu items
    my @keyorder;     #order of keyed menu items
    my @preorder;     #order of predefined order => [] menu items
    my @varorder;     #order of variables

    my %key_item; #lookup, key -> menu id (hash key)         {'a'} -> apple
    my %item_key; #reverse lookup,menu id (hash key) -> key  {'apple'} -> a
    my $count = 1;
    my %preorder;     #order lookup

#print Dumper $menu;


    @preorder = @{ $menu->{order} } if defined $menu->{order};

    foreach my $item (@preorder) {
        $preorder{$item}   = $count;
        $item_key{$item}   = $count;
        $key_item{$count}  = $item;
        $count++;
    }
    #$count = 1; #no, we want to have these included in the same sequence

    foreach my $item (sort keys %{ $menu->{items} } ) {
        #next if $item =~ /^_/; #TODO we want this?
        #$name =~ s/(^.)/\[$1\]/;
       print "ITEM:$item ($count)\n" if $self->debug();



        if (exists $preorder{$item}) {
            #item already listed in custom order
           print "PREORDER EXISTS: $item ($preorder{$item})\n" if $self->debug();
        } elsif (my $key =  $menu->{items}->{$item}->{key}) {
            push @keyorder,$item;
            print "WARNING! duplicate key $item\n" if exists $item_key{$item};
            $item_key{$item} = $key;
            $key_item{$key}  = $item;
        } else { #no predefined key, use #
            push @numorder,$item;
            print "WARNING! duplicate key $item\n" if exists $item_key{$item};
            $item_key{$item} = $count;
            $key_item{$count}  = $item;
            $count++;
        }


    }

    foreach my $item (sort keys %{ $menu->{variables} } ) {
        print "VAR:$item ($count)\n" if $self->debug();
        push @numorder,$item;
        print "WARNING! duplicate key $item\n" if exists $item_key{$item};
        $item_key{$item} = $count;
        $key_item{$count}  = $item;
        $count++;
    }


    @order = (@preorder,@numorder,@keyorder);
    foreach my $item (@order) {
        my $key = $item_key{$item};
        #my $name = $menu->{items}->{$item}->{name} || $item;
        my $name;
        #if (exists $menu->{variables}->{$item}) {
        if ($self->is_variable(menu => $menu, name => $item)) {
            print " is VAR $item\n" if $self->debug();
            $name = $menu->{variables}->{$item}->{name} ?
                    "$menu->{variables}->{$item}->{name} [$item]" :#TODO[hilight]?
                    "[$item]";
            $name .= ' = ' . ($self->get_variable(name => $item) || '');
        } else {
            print " NOT VAR $item\n" if $self->debug();
            $name = $menu->{items}->{$item}->{name} || "[$item]"; #TODO [hilight]?
        }
        $output .= "$key: $name"  . (exists $menu->{items}->{$item} && exists $menu->{items}->{$item}->{menu} ? ' ->' : '') . "\n"; #customize later TODO
    }


    $output .= "(.. to go up a level) \n";
    my $prompt_text = $menu->{_prompt} || join '/',@path;
    #$output .= "$menu->{_prompt}>";
    $output .= "$prompt_text>";




    #use wantarray here
    if (wantarray) {
        return ($output, $menu, \@order, \%key_item, \%item_key,\@info);
    } else {
        return $output;
    }
}

sub menu_old {
    $Log->enter() if $may_enter;
    my $self = shift;
    my $exit = 0;

    my @macro;
    my $running_macro = 0;
    my $recording_macro = 0;
    my $macro_running = 0;
    my $macro_recording = 0;
    my $macro_filename = '';
    my $macro_play_filename = '';
    my @macro_commands;
    my $wait_on_comment = 1;

    my $prompt      = '>';
    my $prompt_info = 'mcc';
    my $file        = 'mccmenu.macro';

#TBD: throughout, dr_state needs to be determined dynamically
    my $dr_state='normal'; #should query this I guess...

    my $setting;

    my $command = {

        'dr_1normal'     => { name => 'cycle to dr state: normal',
                              code => sub {
my $local_setting = shift;
$self->get_cluster(site=> $local_setting->{'survivor-site'})->cycle_to_DR_state(
                      state  => 'normal',
                      verify => { disks => $local_setting->{'verify-disks'} });
$dr_state = 'normal';
                                      },
                            },

        'dr_2switchover' => { name => 'cycle to dr state: switchover_completed',
                              code => sub {
my $local_setting = shift;
$self->get_cluster(site=> $local_setting->{'survivor-site'})->cycle_to_DR_state(
                      state  => 'switchover_completed',
                      verify => { disks => $local_setting->{'verify-disks'} });
$dr_state = 'switchover_completed';
                                          },
                            },

        'dr_3heal_aggrs' => { name => 'cycle to dr state: heal_aggrs_completed',
                              code => sub {
my $local_setting = shift;
$self->get_cluster(site=> $local_setting->{'survivor-site'})->cycle_to_DR_state(
                      state  => 'heal_aggrs_completed',
                      verify => { disks => $local_setting->{'verify-disks'} });
$dr_state = 'heal_aggrs_completed';
                                          },
                            },

        'dr_4heal_roots' => { name => 'cycle to dr state: heal_roots_completed',
                              code => sub {
my $local_setting = shift;
$self->get_cluster(site=> $local_setting->{'survivor-site'})->cycle_to_DR_state(
                      state  => 'heal_roots_completed',
                      verify => { disks => $local_setting->{'verify-disks'} });
$dr_state = 'heal_roots_completed';
                                          },
                            },

        'dump_mcc'       => { name => 'dump metrocluster object',
                              code => sub {
my $local_setting = shift;
$Log->comment(NACL::MTask::MCC::Utils->dump(
                     target              => $self,
                     show_shared_storage => $local_setting->{'verify-disks'}));
                                          }
                            },

        'disk_verify'    => { name => 'do disk verification',
                              code => sub {
foreach my $dr (sort keys %{$self->get_DR_groups()}) {
    my $message = "validate shared storage in dr group $dr";
    $Log->comment($message);
    print ntest::NTEST_STDOUT "$message\n";

    $self->get_DR_groups()->{$dr}->get_shared_storage()->validate_disk_states();
}
                                          },
                            },

        'show_disasters' => { name => 'show DR and HA states',
                              code => sub {
try {
    my $disaster_status = $self->get_disaster_status(include_HA => 1);
    my $status_message = "overall disaster status:\n" .
                         NACL::MTask::MCC::Utils->dump($disaster_status);
    $Log->comment($status_message);
}
catch NACL::MTask::MCC::Exceptions::BaseException with {
    my $exception = shift;
    my $text = $exception->text();

    my $message = sprintf("%s", <<"END_PRINT");

Exception occurred during disaster status queries:

$text

This may be due to the DR or HA state currently transitioning, or it may be due
to an invalid DR or HA state.  You may safely repeat this query.  If this
query continues to fail in this manner for several minutes, it is likely that
the latter case is the reason for this failure, and you will need to triage
the MCC system manually.

END_PRINT

    $Log->comment($message);
};
                                          },
                            },
    '_prompt' => 'mcc',
                  };

    my $setting_spec = {
                   'survivor-site' => { default => 'A', regex => qr/^[AB]$/},
                   'verify-disks'  => { default => 1, regex => qr/^[01]$/ },
                       };

    $setting = validate_with(
        params => $setting || {},
        spec   => $setting_spec,
    );

    my @history;

    my $fiji;
    my $fijifile = 'mcc.fiji';
    if (-e $fijifile) {

        if (open (FIJI,'<',$fijifile)) {
          while (my $line = <FIJI>) {
              my ($name,$filter) = split (/=/,$line,2);
              chomp $filter;
              $fiji->{$name}->{fiji} = $filter;
          }
          close FIJI;
          print ntest::NTEST_STDOUT "read fiji file:" . Dumper $fiji;
        }

    }
    while (!$exit) {

        print ntest::NTEST_STDOUT Dumper $setting;
        #do this better, this is a quick test here
        my @order;
        my %itemorder;
        my $count = 1;
        foreach my $item (sort keys %$command) {
            next if $item =~ /^_/;  #_ prepend invisible. TODO validate this
            $order[$count] = $item;
            $itemorder{$item} = $count;
            print ntest::NTEST_STDOUT "$count: $command->{$item}->{name}\n";
            $count++;
        }

        print ntest::NTEST_STDOUT "f: fiji\n";
        print ntest::NTEST_STDOUT "l: get mcc filer logs\n";
        print ntest::NTEST_STDOUT
                                "m: " . ($recording_macro ? "stop" : "start") .
                                " recording macro" .
             ($recording_macro ? " [$macro_filename]\n" : "\n");
        print ntest::NTEST_STDOUT "p: play macro" .
                         ($running_macro ? " [$macro_play_filename]\n" : "\n");
        print ntest::NTEST_STDOUT "r: refresh command interfaces\n";
        print ntest::NTEST_STDOUT "t: network topology\n";
        print ntest::NTEST_STDOUT "q: quit\n";
        print ntest::NTEST_STDOUT "#: add comment to log\n";
        print ntest::NTEST_STDOUT "$prompt_info$prompt";

        #print ntest::NTEST_STDOUT menu_layout($self, path => undef, root => $command);

        my $in;
        if ($running_macro) {
            if (my $next = shift @macro) {
                chomp $next;
                if (defined $itemorder{$next}) {
                    $in = $itemorder{$next};
                } else {
                    if ($next =~ /^#/) {
                        print ntest::NTEST_STDOUT "$next\n";
                        if ($wait_on_comment) {
                          print ntest::NTEST_STDOUT "hit return to continue\n";
                          my $wait_in = <STDIN>;
                        }
                    }
                    elsif ($next eq 'm') {
                        #we aren't currently supporting recording macros during a macro play!
                        print ntest::NTEST_STDOUT "Did not execute record (m)acro command in macro\n";
                    }
                    elsif ($next eq 'q') {
                        $in = ''; #we don't want to quit do we?  or do we...
                        print ntest::NTEST_STDOUT "Did not execute (q)uit command in macro\n";

                    } else {
                        $in = $next;
                    }
                }

                print ntest::NTEST_STDOUT "macro command:$in\n";
            } else {
                print ntest::NTEST_STDOUT "macro completed\n";
                $running_macro = 0;
            }

        } else {
            $in = <STDIN>;
            chop $in;
            push @history,($in !~ /\D/ ? $order[$in] || $in : $in);
            push @macro_commands,$history[-1];
        }

        my @set = split /=/,$in,2; #if it's a set...

        if (lc $in eq 'q') {
            if ($dr_state eq 'normal') { #should query this...
                $exit = 1;
            } else {
                print ntest::NTEST_STDOUT "WARNING! Metrocluster NOT in normal state.  Switch to normal before quitting.\n";
            }
        } elsif ($in =~ /^#/) {
            $Log->comment("comment:$in");
        } elsif ($in eq 'c') {
            eval {$fiji->clear() if $fiji;};
        }
        elsif ($in eq 'f') {
            #fiji
            my $ci;
            if ($setting->{'survivor-site'} eq 'A') {
                $ci = $self->_site_A_metrocluster_component()->command_interface();
            } else {
                $ci = $self->_site_B_metrocluster_component()->command_interface();
            }

            my $fcount=1;
            my @forder;
            my %fitemorder;

            foreach my $item (sort keys %{$fiji}) {
                my $status = $fiji->{$item}->{status} || '-';
                print ntest::NTEST_STDOUT "$fcount: [$status] $item" .
                  ($item eq $fiji->{$item}->{fiji} ?
                                         "\n" : " [$fiji->{$item}->{fiji}]\n");
                  #($item eq $fiji->{$item}->{object}->{program} ?
                  #         "\n" : " [$fiji->{$item}->{object}->{program}]\n");
                $forder[$fcount] = $item;
                $fitemorder{$item} = $fcount;
                $fcount++;
            }



            print ntest::NTEST_STDOUT "c: clear fiji\n";
            #print ntest::NTEST_STDOUT "d: delete fiji\n"; #TODO
            print ntest::NTEST_STDOUT "n: new fiji\n";
            print ntest::NTEST_STDOUT "s: set fiji\n";
            print ntest::NTEST_STDOUT "<hit return to exit to main menu>\n";
            print ntest::NTEST_STDOUT "fiji$prompt";

            my $fin;

            if ($running_macro) {
                if (my $next = shift @macro) {
                    chomp $next;
                    if (defined $fitemorder{$next}) {
                        $fin = $fitemorder{$next};
                    } else {
                        if ($next =~ /^#/) {
                            print ntest::NTEST_STDOUT "$next\n";
                            if ($wait_on_comment) {
                              print ntest::NTEST_STDOUT "hit return to continue\n";
                              my $wait_in = <STDIN>;
                            }
                        } else {
                            $fin = $next;
                        }
                    }
                    print ntest::NTEST_STDOUT "macro command:$fin\n";
                }
            } else {
                $fin = <STDIN>;

                chop $fin;
                $fin = lc $fin;

                push @history,($fin !~ /\D/ ? $forder[$fin] || $fin : $fin);
                push @macro_commands,$history[-1];
            }

            if ($fin eq 'c') {
                print ntest::NTEST_STDOUT "fiji # to clear$prompt";
                my $number;
                if ($running_macro) {
                    if (my $next = shift @macro) {
                        chomp $next;
                        if (defined $fitemorder{$next}) {
                            $number = $fitemorder{$next};
                        } else {
                            if ($next =~ /^#/) {
                                print ntest::NTEST_STDOUT "$next\n";
                                if ($wait_on_comment) {
                                  print ntest::NTEST_STDOUT "hit return to continue\n";
                                  my $wait_in = <STDIN>;
                                }
                            } else {
                                $number = $next;
                            }
                        }
                        print ntest::NTEST_STDOUT "macro command:$number\n";
                    }
                } else {
                    $number = <STDIN>;

                    chop $number;
                    $number = lc $number;

                    push @history,($number !~ /\D/ ? $forder[$number] || $number : $number);
                    push @macro_commands,$history[-1];
                }
                #my $number = <STDIN>;
                #chop $number;
                my $item = $forder[$number] || next;
                eval {
                    print ntest::NTEST_STDOUT "fiji state?\n";
                    my $fs = $fiji->{$item}->{object}->state();
                    print ntest::NTEST_STDOUT "fiji state:" . Dumper $fs;
                };
                if ($fiji->{$item}->{status} eq 's') {
                    eval {
                        $fiji->{$item}->{object}->clear();
                        $fiji->{$item}->{status} = '';
                    };
                } else {
                    print ntest::NTEST_STDOUT "fiji $item not set, can't clear\n";
                }

            } elsif ($fin eq 'n') {
                print ntest::NTEST_STDOUT "fiji filter$prompt";
                my $fiji_program = <STDIN>;
                chop $fiji_program;
                print ntest::NTEST_STDOUT "fiji name/tag$prompt";
                my $fiji_tag = <STDIN>;
                chop $fiji_tag;
                $fiji_tag ||= $fiji_program;


                my $fijiobj = NACL::STask::Fiji->new(
                             command_interface => $ci,
                             tag               => $fiji_tag,
                             program           => $fiji_program,
                           );
                $fiji->{$fiji_tag}->{fiji} = $fiji_program;
                $fiji->{$fiji_tag}->{object} = $fijiobj;

                if (1) { #write fijis to file

                    if (open (FIJI,'>>',$fijifile)) {
                        my $filetag = $fiji_tag;
                        $filetag =~ s/=/_/g; #?? not sure if = is valid token
                        print FIJI "$filetag=$fiji_program\n";
                        close FIJI;
                    }
                }


                #print ntest::NTEST_STDOUT Dumper $fiji;
            } elsif ($fin eq 's') {
                print ntest::NTEST_STDOUT "fiji # to set$prompt";
                my $number;
                if ($running_macro) {
                    if (my $next = shift @macro) {
                        chomp $next;
                        if (defined $fitemorder{$next}) {
                            $number = $fitemorder{$next};
                        } else {
                            if ($next =~ /^#/) {
                                print ntest::NTEST_STDOUT "$next\n";
                                if ($wait_on_comment) {
                                  print ntest::NTEST_STDOUT "hit return to continue\n";
                                  my $wait_in = <STDIN>;
                                }
                            } else {
                                $number = $next;
                            }
                        }
                        print ntest::NTEST_STDOUT "macro command:$number\n";
                    }
                } else {
                    $number = <STDIN>;

                    chop $number;
                    $number = lc $number;

                    push @history,($number !~ /\D/ ? $forder[$number] || $number : $number);
                    push @macro_commands,$history[-1];
                }
                #my $number = <STDIN>;
                #chop $number;
                my $item = $forder[$number] || next;
                unless ($fiji->{$item}->{object}) {
                    $fiji->{$item}->{object} = NACL::STask::Fiji->new(
                                 command_interface => $ci,
                                 tag               => $item,
                                 program           => $fiji->{$item}->{fiji},
                               );

                }
                if ($fiji->{$item}->{status} ne 's') {
                    eval {
                        $fiji->{$item}->{object}->set();
                        $fiji->{$item}->{status} = 's';

                    };
                } else {
                    print ntest::NTEST_STDOUT "fiji $item not set, can't clear\n";
                }


            } else {
                #exit
            }


        } elsif ($in eq 'm') {
            if ($recording_macro) {

                print ntest::NTEST_STDOUT "\nAre you sure you want to stop recording macro $macro_filename? (y/[n]) ";

                my $verify = <STDIN>;
                if ($verify =~ /y/) {
                    print ntest::NTEST_STDOUT "macro filename (return to cancel)? ";

                    if (open (MACROFILE,'>>',$macro_filename.'.macro')) {
                        print MACROFILE join "\n",@macro_commands;
                        close MACROFILE;
                        $recording_macro = 0;
                        $macro_filename = '';
                    } else {
                        print ntest::NTEST_STDOUT "warning, could not open macro $file\n";
                    }
                }
            } else {
                print ntest::NTEST_STDOUT "macro filename (return to cancel)? ";
                $macro_filename = <STDIN>;
                chop $macro_filename;
                next if $macro_filename eq '';
                print ntest::NTEST_STDOUT "Recording macro $macro_filename\n";

                if (open (MACROFILE,'>',$macro_filename.'.macro')) {
                    print MACROFILE "version=1\n";

                    close MACROFILE;
                    $recording_macro = 1;
                    @macro_commands=(); #start over
                } else {
                    print ntest::NTEST_STDOUT "warning, could not open macro $macro_filename\n";
                }
            }

        } elsif ($in eq 'p') {
            print ntest::NTEST_STDOUT "macro filename (return to cancel)? ";
            my $macro_filename = <STDIN>;
            chop $macro_filename;
            next if $macro_filename eq '';
            $macro_filename .= '.macro' unless $macro_filename =~ /\.macro$/;
            if (open (FILE,'<',$macro_filename)) {
                my @macro = <FILE>;
                close FILE;
                print ntest::NTEST_STDOUT @macro;
            }
            print ntest::NTEST_STDOUT "Are you sure you want to play macro $macro_filename? (y/n) ";
            my $verify = <STDIN>;
            if ($verify =~ /y/) {
                $Log->comment("Replaying macro $file");
                print ntest::NTEST_STDOUT "Replaying macro $macro_filename\n";

                if (open (FILE,'<',$macro_filename)) {
                    @macro = <FILE>;
                    close FILE;
                    $running_macro = 1;
                    ($macro_play_filename = $macro_filename) =~ s/\.macro//;
                } else {
                    print ntest::NTEST_STDOUT "warning, could not open macro $macro_filename\n";
                }

            }
        } elsif ($in eq 't') {
            #network topology
            my $in_topo = 1;
            my @path = ();
            my $tin;
            while ($in_topo) {
                #print ntest::NTEST_STDOUT join ',',@path,"\n";
                my ($menu_output, $submenu, $order, $key_lookup) =
                    menu_layout($self,path => \@path, root => topology_menu() );
                print ntest::NTEST_STDOUT $menu_output;
                my $tin = <STDIN>;
                chomp $tin;
                print ntest::NTEST_STDOUT "$tin:@$order[$tin]\n\n";
                if ($tin eq '..') {
                    print ntest::NTEST_STDOUT "up a level\n";
                    pop @path;
                    $in_topo = @path;
                } else {
                    #if (defined
                    push @path, @{$order}[$tin] if $submenu->{@{$order}[$tin]}->{menu};
                }




            }

        } elsif ($in eq 'r') {
            $self->refresh_command_interfaces();
        } elsif ($in eq 'l') {
            ## no critic (InputOutput::ProhibitExplicitStdin)
            print ntest::NTEST_STDOUT
                "enter burt # <or leave blank to write logs to logdir>\n";
            my $submenu = 'log';
            print ntest::NTEST_STDOUT "$submenu$prompt";

            my ($burt) = <STDIN> =~ /(\d*)/;
            my $path = q{};

            if ($burt) {
                print ntest::NTEST_STDOUT "BURT: $burt\n";
                my $ci;
                if ($setting->{'survivor-site'} eq 'A') {
                    $ci = $self->_site_A_metrocluster_component()->
                                 command_interface();
                } else {
                    $ci = $self->_site_B_metrocluster_component()->
                                 command_interface();
                }

                #figure out the logs path
                my $show = NACL::CS::SystemNode->fetch(
                    command_interface => $ci,
                    requested_fields  => [ 'location' ] );
                my $location = $show->{location} || 'rtp';
                print ntest::NTEST_STDOUT "filer location:$location\n";

                $path = "/x/eng/$location-cores/burt.$burt";
            } else {
                $path = Tharn::param('LOGDIR') . '/logs';
            }
            print ntest::NTEST_STDOUT "log destination path:$path\n";

            print ntest::NTEST_STDOUT "p: paloma info\n";
            print ntest::NTEST_STDOUT
                's: controller scraper (adds san logs, core files, more -' .
                " can be SLOW -- 30 min)\n";
            print ntest::NTEST_STDOUT "<hit return to exit to main menu>\n";
            print ntest::NTEST_STDOUT "$submenu$prompt";
            my ($script) =  <STDIN> =~ /([p|s])/i;

            if ($script) {
                my $eval_return = eval {
                    $self->_get_logs( nodes     => $self->get_all_mcc_nodes(),
                                      log_path  => $path,
                                      use_tool  => lc $script  );
                    1;
                };
                unless ($eval_return) { print ntest::NTEST_STDOUT $@; };
            }
        } elsif ($in eq '') {
            #empty
        } elsif (defined $command->{$order[$in]}) {
            my $selected = $order[$in];
            if (defined $command->{$selected}) { # TODO REMOVE LINE
                my $commandref = $command->{$selected};
                print ntest::NTEST_STDOUT
                    "execute command: $commandref->{name} [$selected]\n";
                $Log->comment("execute command: $selected");
                if (defined $commandref->{code}) {

                    print ntest::NTEST_STDOUT "execute code: $selected\n";
                    eval {
                        $commandref->{code}->($setting);
                    };
                    if ($@) { print ntest::NTEST_STDOUT $@; }
                }
            }

        } elsif (defined $setting->{$set[0]}) {
            print ntest::NTEST_STDOUT "set value: $in\n";
            if ($set[1] =~ /$setting_spec->{$set[0]}->{regex}/) {
                $setting->{$set[0]} = $set[1];
            } else {
                print ntest::NTEST_STDOUT "$set[1] not a valid value for $set[0]\n";
            }


        } else { #???
            print ntest::NTEST_STDOUT "unknown command: $in\n";
        }



    }

    #move this to a _method
    $Log->comment("command history: " . join ',',@history);
    if (open (FILE,'>',$file)) {
        print FILE "version=1\n";
        print FILE join "\n", @history;
        close FILE;
    } else {
        $Log->comment(
                "warning, could not open $file to save command history macro");
    }


    $Log->exit() if $may_exit;
    return;
}

sub core_menu {


    my $switch_site_a = {
        'enable_switch'    => { name => 'enable switch',
                                key => 'e',
                         },
        'disable_switch'    => { name => 'disable switch',
                                 key => 'd',
                         },
        'enable_fcvi'    => { name => 'enable fcvi ports',
                         },
        'disable_fcvi'    => { name => 'disable fcvi ports',
                         },

    };

    my $fab_switch = {

        'switch_site_a' => { name => 'switch site A',
                             menu => {items => $switch_site_a},
                         },
        'enable_fab'    => { name => 'enable fabric',
            code => sub {print (`ls`)},
                         },
        'disable_fab'    => { name => 'disable fabric',
                         },

    };

    my $fabric = {
        'fabric_x' => { name => 'fabric X',
                        menu => {items => $fab_switch},
                    },
    };

    my $menu = {
        'fiji' => { name => 'fiji',
                    key  => 'f',
                    #menu => {code => \&fiji},
                    code => \&fiji,
                    #TODO fiji isn't really functional right now
                  },
        'logs' => { name => 'get filer logs',
                    key  => 'l',
                    code => \&save_logs,
                    #menu => {items => $fabric},
                  },
        'macro_record' => { name => 'record macro', #TODO dynamic name here, code,
                    key  => 'm',
                    code => \&macro_record,
                  },
        'macro_play' => { name => 'play macro', #TODO dynamic name here, code,
                    key  => 'p',
                    code => \&macro_play,
                  },
        'refresh' => { name => 'refresh command interfaces',
                    key  => 'r',
                    code => sub { shift->refresh_command_interfaces() },
                  },
        'quit' => { name => 'quit', #this should be global...
                    key  => 'q',
                    code => sub {my $menu = shift; $menu->exit();},
                  },

    };

    my $structure = {
        menu  => {
            items => $menu,
            variables => { log_nodes => {name => 'set get filer logs nodes'}, },
        },
        name  => 'core',
        id    => 'core',
        #prompt => '',
        #order => [],
    };



    #return $menu;
    return $structure;
}

sub macro_play {
    my $self = shift;

    mprint("macro filename (return to cancel)? ");
    my $macro_filename = $self->get_input();
    next if $macro_filename eq '';
    $macro_filename .= '.macro' unless $macro_filename =~ /\.macro$/;
    if (open (FILE,'<',$macro_filename)) {
        my @macro = <FILE>;
        close FILE;
        mprint(@macro);
    }
    mprint("\nAre you sure you want to play macro $macro_filename? (y/n) ");
    my $verify = $self->get_input();
    if ($verify =~ /y/) {
        $Log->comment("Replaying macro $macro_filename");
        mprint("Replaying macro $macro_filename\n");

        if (open (FILE,'<',$macro_filename)) {
            @{$self->{macro}} = <FILE>;
            close FILE;
            #TODO this stuff is brittle but it's simple now, so...
            my ($version) = (shift @{$self->{macro}}) =~ /version=(.*)/;
            print "macro version: $version\n";
            if (@{$self->{macro}}[0] =~ /path=/) {
                my ($path) = (shift @{$self->{macro}}) =~ /path=(.*)/;
                print "macro path: $path\n";
                my @path = split q{/},$path;
                #TODO give option to 'cd' to path 1st
            }
            $self->{_macro_running} = 1;
            ($self->{macro_play_filename} = $macro_filename) =~ s/\.macro//;
        } else {
            mprint( "warning, could not open macro $macro_filename\n");
        }

    }
}

sub macro_record {
    my $self = shift;

    if ($self->{_macro_recording}) {
        my $macro_filename = $self->{macro_filename};
        mprint("\nAre you sure you want to stop recording macro $macro_filename? (y/[n]) ");

        my $verify = $self->get_input();
        if ($verify =~ /y/) {
            #mprint ("macro filename (return to cancel)? ");

            if (open (MACROFILE,'>>',$macro_filename.'.macro')) {
                print MACROFILE join "\n",@{$self->{_macro_commands}};
                close MACROFILE;
                $self->{_macro_recording} = 0;
                $self->{macro_filename} = '';
            } else {
                mprint("warning, could not open macro $macro_filename\n");
            }
        }
    } else {
        mprint ("macro filename (return to cancel)? ");
        my $macro_filename = $self->get_input();
        next if $macro_filename eq '';
        mprint ("Recording macro $macro_filename\n");

        if (open (MACROFILE,'>',$macro_filename.'.macro')) {
            print MACROFILE "version=1\n";
            print MACROFILE sprintf("path=%s\n",join '/',@{$self->{path}});
            close MACROFILE;
            $self->{macro_filename} = $macro_filename;
            $self->{_macro_recording} = 1;
            @{$self->{_macro_commands}}=(); #start over
        } else {
            mprint ("warning, could not open macro $macro_filename\n");
        }

    }

    print "MACRO RECORD!@!" if $self->debug();


}

sub save_logs {
    my $self = shift;

    mprint("enter burt # <or leave blank to write logs to logdir>");

    my ($burt) = $self->get_input() =~ /(\d*)/;
    my $path = q{};

    my $nodes = $self->get_variable( name => 'log_nodes' );
    if ( ref $nodes ne 'ARRAY' ) {
        $nodes = [ split /,/, $nodes ];
    }

    my $resolver = Net::DNS::Resolver->new();
    $resolver->searchlist( '',
                           $resolver->searchlist(),
                           'gdl.englab.netapp.com'
                       );

    my $res_nodes = [];
    foreach my $node ( @{ $nodes } ) {
        my ($rnode) = $resolver->search($node);
        if ( defined $rnode ) {
            my ($answer) = $rnode->answer();
            push(@{ $res_nodes }, $answer->name());
        }
        else {
            warn("No resolution for name '$node'");
            next;
        }
    }

    if ($burt) {
        mprint("BURT: $burt\n");

        #this all seems incredibly convoluted, there must be a
        #simpler way...

        my $host = Tharn::host( $res_nodes->[0] );
        my $sn = NACL::C::SystemNode->new( hostrec => $host, );
        my $ci = $sn->command_interface();

        #figure out the logs path
        my $csstate = $sn->state();
        my $show    = NACL::CS::SystemNode->fetch(
            command_interface => $ci,
            requested_fields  => ['location']
        );
        my $location = $show->{location} || 'rtp';
        mprint("ci filer location:$show->{location}\n");
        mprint("filer location:$location\n");

        $path = "/x/eng/${location}-cores/burt.$burt";
    } else {
        $path = Tharn::param('LOGDIR') . '/logs';
    }
    mprint("log destination path: '$path'\n");

    mprint("p: paloma info\n");
    mprint('s: controller scraper (adds san logs, core files, more -'
          . " can be SLOW -- 30+ min)\n" );
    mprint("<hit return to abort log download>");

    my ($script) = $self->get_input() =~ /([p|s])/i;

    if ($script) {
        my $eval_return = eval {
            $self->_get_logs(
                nodes    => $res_nodes,
                log_path => $path,
                use_tool => lc $script
            );
            1;
        };
        unless ($eval_return) { mprint($@); }
    }
}

sub fiji {
    my $self = shift;
    #fiji
    my $ci;
    #TODO this is all temp until it's rewritten (ie the my vars here)
    my $fiji;
    my $setting;
    my @macro;
    my @history;
    my $prompt;
    my $fijifile;
    my $running_macro;
    my $wait_on_comment;
    my @macro_commands;


    if ($setting->{'survivor-site'} eq 'A') {
        $ci = $self->_site_A_metrocluster_component()->command_interface();
    } else {
        $ci = $self->_site_B_metrocluster_component()->command_interface();
    }

    my $fcount=1;
    my @forder;
    my %fitemorder;

    foreach my $item (sort keys %{$fiji}) {
        my $status = $fiji->{$item}->{status} || '-';
        print ntest::NTEST_STDOUT "$fcount: [$status] $item" .
          ($item eq $fiji->{$item}->{fiji} ?
                                 "\n" : " [$fiji->{$item}->{fiji}]\n");
          #($item eq $fiji->{$item}->{object}->{program} ?
          #         "\n" : " [$fiji->{$item}->{object}->{program}]\n");
        $forder[$fcount] = $item;
        $fitemorder{$item} = $fcount;
        $fcount++;
    }



    print ntest::NTEST_STDOUT "c: clear fiji\n";
    #print ntest::NTEST_STDOUT "d: delete fiji\n"; #TODO
    print ntest::NTEST_STDOUT "n: new fiji\n";
    print ntest::NTEST_STDOUT "s: set fiji\n";
    print ntest::NTEST_STDOUT "<hit return to exit to main menu>\n";
    print ntest::NTEST_STDOUT "fiji$prompt";

    my $fin;

    if ($running_macro) {
        if (my $next = shift @macro) {
            chomp $next;
            if (defined $fitemorder{$next}) {
                $fin = $fitemorder{$next};
            } else {
                if ($next =~ /^#/) {
                    mprint ("$next\n");
                    if ($wait_on_comment) {
                      mprint ("hit return to continue\n");
                      my $wait_in = <STDIN>;
                    }
                } else {
                    $fin = $next;
                }
            }
            mprint ("macro command:$fin\n");
        }
    } else {
        $fin = <STDIN>;

        chop $fin;
        $fin = lc $fin;

        push @history,($fin !~ /\D/ ? $forder[$fin] || $fin : $fin);
        push @macro_commands,$history[-1];
    }

    if ($fin eq 'c') {
        print ntest::NTEST_STDOUT "fiji # to clear$prompt";
        my $number;
        if ($running_macro) {
            if (my $next = shift @macro) {
                chomp $next;
                if (defined $fitemorder{$next}) {
                    $number = $fitemorder{$next};
                } else {
                    if ($next =~ /^#/) {
                        print ntest::NTEST_STDOUT "$next\n";
                        if ($wait_on_comment) {
                          print ntest::NTEST_STDOUT "hit return to continue\n";
                          my $wait_in = <STDIN>;
                        }
                    } else {
                        $number = $next;
                    }
                }
                print ntest::NTEST_STDOUT "macro command:$number\n";
            }
        } else {
            $number = <STDIN>;

            chop $number;
            $number = lc $number;

            push @history,($number !~ /\D/ ? $forder[$number] || $number : $number);
            push @macro_commands,$history[-1];
        }
        #my $number = <STDIN>;
        #chop $number;
        my $item = $forder[$number] || next;
        eval {
            print ntest::NTEST_STDOUT "fiji state?\n";
            my $fs = $fiji->{$item}->{object}->state();
            print ntest::NTEST_STDOUT "fiji state:" . Dumper $fs;
        };
        if ($fiji->{$item}->{status} eq 's') {
            eval {
                $fiji->{$item}->{object}->clear();
                $fiji->{$item}->{status} = '';
            };
        } else {
            print ntest::NTEST_STDOUT "fiji $item not set, can't clear\n";
        }

    } elsif ($fin eq 'n') {
        print ntest::NTEST_STDOUT "fiji filter$prompt";
        my $fiji_program = <STDIN>;
        chop $fiji_program;
        print ntest::NTEST_STDOUT "fiji name/tag$prompt";
        my $fiji_tag = <STDIN>;
        chop $fiji_tag;
        $fiji_tag ||= $fiji_program;


        my $fijiobj = NACL::STask::Fiji->new(
                     command_interface => $ci,
                     tag               => $fiji_tag,
                     program           => $fiji_program,
                   );
        $fiji->{$fiji_tag}->{fiji} = $fiji_program;
        $fiji->{$fiji_tag}->{object} = $fijiobj;

        if (1) { #write fijis to file

            if (open (FIJI,'>>',$fijifile)) {
                my $filetag = $fiji_tag;
                $filetag =~ s/=/_/g; #?? not sure if = is valid token
                print FIJI "$filetag=$fiji_program\n";
                close FIJI;
            }
        }


        #print ntest::NTEST_STDOUT Dumper $fiji;
    } elsif ($fin eq 's') {
        print ntest::NTEST_STDOUT "fiji # to set$prompt";
        my $number;
        if ($running_macro) {
            if (my $next = shift @macro) {
                chomp $next;
                if (defined $fitemorder{$next}) {
                    $number = $fitemorder{$next};
                } else {
                    if ($next =~ /^#/) {
                        print ntest::NTEST_STDOUT "$next\n";
                        if ($self->get_variable(name => 'wait_on_comment')) {
                          print ntest::NTEST_STDOUT "hit return to continue\n";
                          my $wait_in = <STDIN>;
                        }
                    } else {
                        $number = $next;
                    }
                }
                print ntest::NTEST_STDOUT "macro command:$number\n";
            }
        } else {
            #TODO move this to built in input stuff
            #$number = <STDIN>;
            #
            #chop $number;
            #$number = lc $number;
            #
            #push @history,($number !~ /\D/ ? $forder[$number] || $number : $number);
            #push @macro_commands,$history[-1];
        }
        #my $number = <STDIN>;
        #chop $number;
        my $item = $forder[$number] || next;
        unless ($fiji->{$item}->{object}) {
            $fiji->{$item}->{object} = NACL::STask::Fiji->new(
                         command_interface => $ci,
                         tag               => $item,
                         program           => $fiji->{$item}->{fiji},
                       );

        }
        if ($fiji->{$item}->{status} ne 's') {
            eval {
                $fiji->{$item}->{object}->set();
                $fiji->{$item}->{status} = 's';

            };
        } else {
            print ntest::NTEST_STDOUT "fiji $item not set, can't clear\n";
        }


    } else {
        #exit
    }


}

sub _get_logs {
    $Log->enter() if $may_enter;
    my $self = shift;
    #my $trace = NACL::MTask::MCC::Log::TRACELOG->start_timer(); #metrics
    my %raw_opts = @_;

    # validate opts
    my %opts = validate_with(
        params => \%raw_opts,
        spec   => {
            nodes            => { type => ARRAYREF },
            paloma_info_path => { type => SCALAR,
                                  default =>
                                      '/usr/software/test/bin/paloma_info.pl',
                                },
            use_tool         => { type => SCALAR, default => 'p' },
            scraper_path     => { type => SCALAR,
                                  default =>
                                      '/usr/software/test/agnostic/san/' .
                                      'fit/ControllerScraper.py',
                                },
            log_path         => { type => SCALAR,
                                  default => Tharn::param('LOGDIR') . '/logs'
                                },
            compress         => { regex => qr/^[01]$/, default => 0 },
            admin_password   => { type => SCALAR | UNDEF, optional => 1 },
            diag_password    => { type => SCALAR | UNDEF, optional => 1 },
                  },
        );

    my $nodes = delete $opts{nodes};

    # Start log pulling sessions in parallel
    my @subtest_handles = ();
    foreach my $node (@{ $nodes }) {
        my $node_name = $node;
        #my $node_name = $node->get_name();
        $Log->comment("Fetching logs from : $node_name");

        my $cmd;

        if ($opts{use_tool} eq 's') {
            my $toolname = 'Controller Scraper';
            mprint(
                "Writing logs from $node_name to $opts{log_path} " .
                "with $toolname\n");
            $cmd = "$opts{scraper_path}";
            #$cmd .= ' -z' if $opts{compress}; #not an option
            $cmd .= ' -v';
            $cmd .= " -y $opts{admin_password}" if $opts{admin_password};
            $cmd .= " -z $opts{diag_password}" if $opts{diag_password};
            $cmd .= " -t $opts{log_path}" if $opts{log_path};
            $cmd .= " -n $node_name"; #or we can pass comma sep list??
        } else { #default to paloma
            my $toolname = 'paloma info';
            mprint(
                "Writing logs from $node_name to $opts{log_path} " .
                "with $toolname\n");
            $cmd = "$opts{paloma_info_path}";
            $cmd .= ' -z' if $opts{compress};
            $cmd .= " -a $opts{admin_password}" if $opts{admin_password};
            $cmd .= " -d $opts{diag_password}" if $opts{diag_password};
            $cmd .= " -p $opts{log_path}" if $opts{log_path};
            $cmd .= " -f $node_name"; #must be LAST (well really just node)
        }

        print "fetch logs command: $cmd\n";
        ## no critic (Modules::ProhibitConditionalUseStatements)
        #TODO this seems to fail on cyclsvl machines Could not create connection for: #login
        #Unexpected EOF 'awaiting prompts' while logging in on connection
        push @subtest_handles, subtest(
            sub {
                use NACL::C::Client;
                use Net::Domain qw(hostname);
                # Execute the command on client running this script
                my $client_hostname = hostname()
                        or croak 'Unable to get client hostname';
                $Log->comment("Using client: $client_hostname");

                my $client = NACL::C::Client->new( name => $client_hostname );
                $client->apiset->set_timeout( 'connectrec-timeout' => 3600 );
                $client->execute( command => $cmd );
            },
            '-bg',
            '-runid', $node_name . '_log_extraction' );
    }
    Subtest::wait_finish( subtests => \@subtest_handles );

    return;
}


1;
