package NACL::MTask::MCC::Network::FibreBridge_Impl;

use Role::Tiny;

use strict;
use warnings;

requires qw(L_get_info L_get_apiset L_get_name L_get_vendor_name);

1;

__END__

=head1 NAME

NACL::MTask::MCC::Network::FibreBridge_Impl

=head1 DESCRIPTION

A Role::Tiny role defining the interface for implementations of
Fibrebridge implementations.

=head1 SYNOPSIS

  # Define your own class conforming to the Fibre
  package My::FibreBridge;
  use Role::Tiny::With;
  with 'NACL::MTask::MCC::Network::FibreBridge_Impl';

  sub L_get_info {
     # Define your get_info command here
  }

  sub L_get_apiset {
     # Define your get_apiset here
  }

  sub L_get_name {
     # Define your get_name method here
  }

  sub L_get_vendor_name {
     # Define your get_vendor_name method here
  }

=head1 REQUIRED METHODS

These methods should be defined for all Fibrebridge implementations.

=head2 L_get_info()

Returns a hashref of parsed information from the Fibrebridge.

=head2 L_get_apiset()

Returns a NACL::APISet::Switch object for the Fibrebridge.

=head2 L_get_name()

Returns the name of the Fibrebridge.

=head2 L_get_vendor_name()

Returns the name of the Fibrebridge's vendor.

=cut
