use utf8;
package NACL::ResourceList::Schema::Result::Argument;

=head1 NAME

NACL::ResourceList::Schema::Result::Argument

=cut

use strict;
use warnings;

use base 'DBIx::Class::Core';

=head1 TABLE: C<Arguments>

=cut

__PACKAGE__->table("Arguments");

=head1 ACCESSORS

=head2 id

  data_type: 'integer'
  is_auto_increment: 1
  is_nullable: 0

=head2 command_seq_id

  data_type: 'integer'
  is_foreign_key: 1
  is_nullable: 1

=head2 argument

  data_type: 'varchar'
  is_nullable: 1
  size: 45

=head2 value

  data_type: 'varchar'
  is_nullable: 1
  size: 45

=cut

__PACKAGE__->add_columns(
  "id",
  { data_type => "integer", is_auto_increment => 1, is_nullable => 0 },
  "command_seq_id",
  { data_type => "integer", is_foreign_key => 1, is_nullable => 1 },
  "argument",
  { data_type => "varchar", is_nullable => 1, size => 245 },
  "value",
  { data_type => "longblob", is_nullable => 1 },
);

=head1 PRIMARY KEY

=over 4

=item * L</id>

=back

=cut

__PACKAGE__->set_primary_key("id");

=head1 RELATIONS

=head2 command_seq

Type: belongs_to

Related object: L<NACL::ResourceList::Schema::Result::CommandHistory>

=cut

__PACKAGE__->belongs_to(
  "command_seq",
  "NACL::ResourceList::Schema::Result::CommandHistory",
  { id => "command_seq_id" },
  {
    is_deferrable => 0,
    join_type     => "LEFT",
    on_delete     => "RESTRICT",
    on_update     => "CASCADE",
  },
);

1;
