use utf8;
package NACL::ResourceList::Schema::Result::Package;

=head1 NAME

NACL::ResourceList::Schema::Result::Package

=cut

use strict;
use warnings;

use base 'DBIx::Class::Core';

=head1 TABLE: C<Package>

=cut

__PACKAGE__->table("Package");

=head1 ACCESSORS

=head2 id

  data_type: 'integer'
  is_auto_increment: 1
  is_nullable: 0

=head2 package

  data_type: 'varchar'
  is_nullable: 1
  size: 60 

=cut

__PACKAGE__->add_columns(
  "id",
  { data_type => "integer", is_auto_increment => 1, is_nullable => 0 },
  "package",
  { data_type => "varchar", is_nullable => 1, size => 60 },
);

=head1 PRIMARY KEY

=over 4

=item * L</id>

=back

=cut

__PACKAGE__->set_primary_key("id");

=head1 UNIQUE CONSTRAINTS

=head2 C<package_unique>

=over 4

=item * L</package>

=back

=cut

__PACKAGE__->add_unique_constraint("package_unique", ["package"]);

=head1 RELATIONS

=head2 elements

Type: has_many

Related object: L<NACL::ResourceList::Schema::Result::Element>

=cut

__PACKAGE__->has_many(
  "elements",
  "NACL::ResourceList::Schema::Result::Element",
  { "foreign.package_id" => "self.id" },
  { cascade_copy => 0, cascade_delete => 0 },
);


1;
