#
# Copyright (c) 2013 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when the
##          call to NACL::STask::Client::Vlan->fetch fails because 
##          Vlan with given atrribute was found.
##
## @author  dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::STask::Exceptions::Client::Vlan::NotDeleted

=head1 EXAMPLES

=head2 Throwing exception

 my $found = NACL::CS::Client::Vlan->fetch(
        command_interface => $opts{command_interface},
        filter            => {'vlan-id' => $self->vlan_id()},
        allow_empty       => 1
    );
    if ($found) {
        $Log->exit();
        NACL::STask::Exceptions::Client::Vlan::NotDeleted->throw();
    }
=cut

package NACL::STask::Exceptions::Client::Vlan::NotDeleted;

use base 'NATE::BaseException';

1;
