# $Id:$
#
# Copyright (c) 2001-2012 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when 
##          a node is not in an expected SFO State .
##
## @author dl-nacl-dev@netapp.com
## @status public
## @pod here

=pod

=head1 Package Name

NACL::STask::Exceptions::UnexpectedSFOState

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception to be thrown when a node is not in one of the expected SFO states

=head1 NACL::STask::Exceptions::UnexpectedSFOState

=head2 Expected use

Use when a node is not in a expected SFO state

=head2 Base Class

NACL::Exceptions::UnexpectedState

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface details.

B<NACL/Exceptions/UnexpectedState>

=cut

package NACL::STask::Exceptions::UnexpectedSFOState;

## Note that the package inherits NACL::APISet::Exceptions::UnexpectedOutputException
## to provide backward compatibility with the old behaviour of NACL::STask::StorageFailover.pm

use base qw(NACL::Exceptions::UnexpectedState NACL::APISet::Exceptions::UnexpectedOutputException);


1;
