# Copyright (c) 2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary LunAttribute Task Module
## @author ng-ptefit-automation-core@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::STask::LunAttribute

=head1 DESCRIPTION

C<NACL::STask::LunAttribute> provides a number of well-defined but potentially
 complex or multi-step methods related to Volume Quota Policy in ONTAP.

 It is created on top of C<NACL::C::LunAttribute> component
 Since it is derived class of C<NACL::C::LunAttribute>,
 we can use all the methods of C<NACL::C::LunAttribute>
 from the object of this task.


=head1 METHODS

=head2 set

L<< NACL::STask::STask->create_method_builder(c_method_name => 'set')|lib-NACL-STask-STask-pm/create_method_builder >>

=head2 unset

L<< NACL::STask::STask->purge_method_builder(c_method_name => 'unset')|lib-NACL-STask-STask-pm/purge_method_builder >>

=cut

package NACL::STask::LunAttribute;

use base qw(NACL::C::LunAttribute NACL::STask::STask);

__PACKAGE__->create_method_builder(stask_method_name => 'set', c_method_name => 'set', if_exists => 0);
__PACKAGE__->purge_method_builder(stask_method_name => 'unset', c_method_name => 'unset', if_purged => 0);

1;
