=head1 NAME

NACL::STask::VolumeSnapshotAutodelete

=head1 DESCRIPTION

C<NACL::STask::VolumeSnapshotAutodelete> provides a number of well-defined but
potentially complex or multi-step methods related to Volume Snapshot Autodelete 
in ONTAP.

It builds on top of, and is a derived class of C<NACL::C::VolumeSnapshotAutodelete>,
and so it also provides methods that are more in the scope of
individual vserver-related commands.  See C<NACL::C::VolumeSnapshotAutodelete> for
details.  This also means that a C<NACL::STask::VolumeSnapshotAutodelete> object may
generally be used in place of a component object.


=head1 METHODS

=head2 modify

This accepts the same options and provides the same facilities as
L<NACL::C::VolumeSnapshotAutodelete::modify|lib-NACL-C-VolumeSnapshotAutodelete-pm/modify>.
Additionally, the STask provides the following facilities: C<nacltask_verify>.
The description of these features are present at:
L<Common modify options|lib-NACL-STask-STask-pm/Common_Modify_Options>.

=cut

package NACL::STask::VolumeSnapshotAutodelete;

use base qw(NACL::C::VolumeSnapshotAutodelete NACL::STask::STask);

__PACKAGE__->modify_method_builder();

1;
