=head1 NAME

NACL::STask::VserverCifsBranchcache

=head1 DESCRIPTION

C<NACL::STask::VserverCifsBranchcache> provides a number of well-defined but
potentially complex or multi-step methods related to Vserver Cifs Branchcache
in ONTAP.

It builds on top of, and is a derived class of C<NACL::C::VserverCifsBranchcache>,
and so it also provides methods that are more in the scope of
individual vserver-related commands.  See C<NACL::C::VserverCifsBranchcache> for
details.  This also means that a C<NACL::STask::VserverCifsBranchcache> object may
generally be used in place of a component object.


=head1 METHODS

=head2 create

This accepts the same options and provides the same facilities as
L<NACL::C::VserverCifsBranchcache::create|lib-NACL-C-VserverCifsBranchcache-pm/create>.
Additionally, the STask provides the following facilities: C<Cleanup>,
C<nacltask_verify>.  The description of these features are
present at:
L<Common Create options|lib-NACL-STask-STask-pm/Common_Create_Options>.

=head2 purge

This accepts the same options and provides the same facilities as
L<NACL::C::VserverCifsBranchcache::delete|lib-NACL-C-VserverCifsBranchcache-pm/delete>.
Additionally, the STask provides the following facilities: C<nacltask_verify>. 
The description of these features are present at:
L<Common Purge options|lib-NACL-STask-STask-pm/Common_Purge_Options>.

=cut

package NACL::STask::VserverCifsBranchcache;

use base qw(NACL::C::VserverCifsBranchcache NACL::STask::STask);

use strict;
use warnings;

__PACKAGE__->create_method_builder();
__PACKAGE__->purge_method_builder();

1;
