# Copyright (c) 2013-2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverFpolicyPolicyScope Task Module
## @author Shakeela Shaik(sshaik@netapp.com), dl-nacl-dev
## @status shared
## @pod here

=head1 NAME

NACL::STask::VserverFpolicyPolicyScope

=head1 DESCRIPTION

C<NACL::STask::VserverFpolicyPolicyScope> provides a number of well-defined but
potentially complex or multi-step methods related to Vserver Export Policy Rule
in ONTAP.

It builds on top of, and is a derived class of C<NACL::C::VserverFpolicyPolicyScope>,
and so it also provides methods that are more in the scope of
individual vserver-related commands.  See C<NACL::C::VserverFpolicyPolicyScope> for
details.  This also means that a C<NACL::STask::VserverFpolicyPolicyScope> object may
generally be used in place of a component object.


=head1 METHODS

=head2 create

This accepts the same options and provides the same facilities as
L<NACL::C::VserverFpolicyPolicyScope::create|lib-NACL-C-VserverFpolicyPolicyScope-pm/create>.
Additionally, the STask provides the following facilities: C<Cleanup>,
C<nacltask_verify>.  The description of these features are
present at:
L<Common Create options|lib-NACL-STask-STask-pm/Common_Create_Options>.

=head2 purge

This accepts the same options and provides the same facilities as
L<NACL::C::VserverFpolicyPolicyScope::delete|lib-NACL-C-VserverFpolicyPolicyScope-pm/delete>.
Additionally, the STask provides the following facilities: C<nacltask_verify>.
The description of these features are present at:
L<Common Purge options|lib-NACL-STask-STask-pm/Common_Purge_Options>.

=head2 parents

    @parents = $vs_policy_scope_obj->parents();

( Class or Instance method ) This method returns the list containing the names of
the parent objects of this resource. Used for finding dependencies between resources.

=cut

package NACL::STask::VserverFpolicyPolicyScope;

use base qw(NACL::C::VserverFpolicyPolicyScope NACL::STask::STask);

__PACKAGE__->create_method_builder();
__PACKAGE__->purge_method_builder();

sub parents {
    $Log->enter();
    $Log->exit();
    return qw(NACL::STask::VserverFpolicyPolicy);
}

1;
