# Copyright (c) 2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverIscsiIsns Task Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::STask::VserverIscsiIsns

=head1 DESCRIPTION

C<NACL::STask::VserverIscsiIsns> provides a number of well-defined but potentially
 complex or multi-step methods related to Volume Quota Policy in ONTAP.

 It is created on top of C<NACL::C::VserverIscsiIsns> component
 Since it is derived class of C<NACL::C::VserverIscsiIsns>,
 we can use all the methods of C<NACL::C::VserverIscsiIsns>
 from the object of this task.


=head1 METHODS

=head2 create 

L<< NACL::STask::STask->create_method_builder()|lib-NACL-STask-STask-pm/create_method_builder >>

=head2 modify

L<< NACL::STask::STask->modify_method_builder()|lib-NACL-STask-STask-pm/modify_method_builder >>

=head2 purge

L<< NACL::STask::STask->purge_method_builder()|lib-NACL-STask-STask-pm/purge_method_builder >>

=head2 stop

L<< NACL::STask::STask->purge_method_builder(c_method_name => 'stop')|lib-NACL-STask-STask-pm/purge_method_builder >>

=cut

package NACL::STask::VserverIscsiIsns;

use base qw(NACL::C::VserverIscsiIsns NACL::STask::STask);

__PACKAGE__->create_method_builder();
__PACKAGE__->purge_method_builder();
__PACKAGE__->modify_method_builder(if_modified => 1);
__PACKAGE__->purge_method_builder(c_method_name => 'stop',
            stask_method_name => 'stop', c_exception_name =>'NotStarted');


1;
