=head1 NAME

NACL::STask::VserverVscan

=head1 DESCRIPTION

C<NACL::STask::VserverVscan> provides a number of well-defined but
potentially complex or multi-step methods related to Vserver Export Policy Rule
in ONTAP.

It builds on top of, and is a derived class of C<NACL::C::VserverVscan>,
and so it also provides methods that are more in the scope of
individual vserver-related commands.  See C<NACL::C::VserverVscan> for
details.  This also means that a C<NACL::STask::VserverVscan> object may
generally be used in place of a component object.


=head1 METHODS

=head2 enable

This accepts the same options and provides the same facilities as
L<NACL::C::Vserver::enable|lib-NACL-C-VserverVscan-pm/enable>.
Additionally, the STask provides the following facilities: C<Cleanup>,
C<nacltask_verify>.  The description of these features are
present at:
L<Common Create options|lib-NACL-STask-STask-pm/Common_Create_Options>.

=head2 disable

This accepts the same options and provides the same facilities as
L<NACL::C::Vserver::disable|lib-NACL-C-VserverVscan-pm/disable>.
Additionally, the STask provides the following facilities: C<nacltask_verify>.
The description of these features are present at:
L<Common Purge options|lib-NACL-STask-STask-pm/Common_Purge_Options>.

=cut

package NACL::STask::VserverVscan;

use base qw(NACL::C::VserverVscan NACL::STask::STask);

__PACKAGE__->create_method_builder(
    stask_method_name => 'enable',
    c_method_name     => 'enable',
    c_exception_name  => 'AlreadyEnabled',
);

__PACKAGE__->purge_method_builder(
    stask_method_name => 'disable',
    c_method_name     => 'disable',
    c_exception_name  => 'AlreadyDisabled',
);

1;
