# Copyright (c) 2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverVscanOnAccessPolicy Task Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::STask::VserverVscanOnAccessPolicy

=head1 DESCRIPTION

C<NACL::STask::VserverVscanOnAccessPolicy> provides a number of well-defined but potentially
 complex or multi-step methods related to vserver vscan on-access policy in ONTAP.

 It is created on top of C<NACL::C::VserverVscanOnAccessPolicy> component
 Since it is derived class of C<NACL::C::VserverVscanOnAccessPolicy>,
 we can use all the methods of C<NACL::C::VserverVscanOnAccessPolicy>
 from the object of this task.


=head1 METHODS

=head2 create 

L<< NACL::STask::STask->create_method_builder()|lib-NACL-STask-STask-pm/create_method_builder >>

=head2 purge

L<< NACL::STask::STask->purge_method_builder()|lib-NACL-STask-STask-pm/purge_method_builder >>

=head2 enable 

L<< NACL::STask::STask->create_method_builder(c_method_name => 'enable')|lib-NACL-STask-STask-pm/create_method_builder >>

=head2 disable 

L<< NACL::STask::STask->purge_method_builder(c_method_name => 'disable')|lib-NACL-STask-STask-pm/purge_method_builder >>

=cut

package NACL::STask::VserverVscanOnAccessPolicy;

use base qw(NACL::C::VserverVscanOnAccessPolicy NACL::STask::STask);

__PACKAGE__->create_method_builder();
__PACKAGE__->purge_method_builder();
__PACKAGE__->create_method_builder(c_method_name => 'enable',
            stask_method_name => 'enable', c_exception_name =>'AlreadyEnabled');
__PACKAGE__->purge_method_builder(c_method_name => 'disable',
            stask_method_name => 'disable', c_exception_name =>'AlreadyDisabled');
1;
