#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

from NATE.ServiceAPI.Base import Base as NATEClient

class Base(NATEClient):
    def __init__(self, _generate_methods=True, executable=None, service_class=None, language='python', namespace=None, **args):
        language = language.lower();
        if((not executable) and (not service_class)):
            service_class = str(self.__module__).replace('ServiceAPI', 'Service');
            if(language == 'python'):
                args['service_class'] = service_class+'.Service';
            elif(language == 'perl'):
                service_class = service_class.replace('.','::');
                args['service_class'] = service_class;
        if(service_class):
            args['language'] = language;
        elif(executable):
            args['executable'] = executable;

        if('type' not in args):
            _type = service_class or str(self.__module__).replace('ServiceAPI', 'Service');
            args['type'] = _type.replace('.','::');
        super().__init__(**args);
        self._namespace = namespace or args['type'];
        if(_generate_methods):
            self._generate_capabilities(namespace = self._namespace); # This will auto-generate the Service's public APIs

    #get the namespace used to set up this service
    def namespace(self):return(self._namespace);
