#!/usr/software/bin/perl5.14.0

# $Id: //depot/prod/DOT/dev/test/lib/NACL/Tools/packet_capture_cleanup#1 $

#
# Copyright (c) 2016 NetApp, Inc., All Rights Reserved
# Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

use strict;
use Getopt::Long;

use File::Spec::Functions qw(catdir);
use FindBin qw($RealBin);
use lib catdir($RealBin, '..', '..', '..', 'nate', 'lib');
use Hostrec;
use Carp;

my $packet_capture_details         = '';
my $host_directory	= '';
GetOptions('path=s'   => \$packet_capture_details,
	   'host_directory=s'	=> \$host_directory,
);

if ( -e $packet_capture_details ) {
    open(my $fh, '<', $packet_capture_details) or die "Could not open file '$packet_capture_details' $!";
    while (my $row = <$fh>) {
        chomp $row;
        my @arr = split (":", $row);
        my $host = $arr[0];
        my $pids = $arr[2];
        $pids =~ s/,/ /g;
        my $command;

	my %conn_opts = (conntype => 'libssh-persist');
        # running packet capture processes needs to be killed on Linux and FuseN
        # configurations on ungraceful exit of ntest.
        # for windows and non-FuseN configurations there is no need to kill them
        # as on ungraceful termination packetcapture processes stops automatically.
        if ($arr[1] =~ /LINUX/){
            $command = "sudo kill -s 2 $pids";
	    $conn_opts{template} = 'ssh';
        } elsif ($arr[1] =~ /FUSEN/){
	    $command = "sudo kill $pids";
	    $conn_opts{template} = 'c-system';
        }
	eval {
	    my $hostp = Hostrec->new(id => $host, host_directory => $host_directory);
	    my $conn = $hostp->connect(%conn_opts);
	    $conn->execute(command => $command);
	};
	my $error = $@;
	print "There is some issue while executing command '$command' :: '$error'..." if ($error);
    }
    print "Removing the left over file '$packet_capture_details'...";
    close($fh);
    unlink $packet_capture_details and print "OK\n" or warn "Unable to delete '$packet_capture_details' because: $!\n";
}

