#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown if any internal
##          error occurs in the transit libraries
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::Transit::Exceptions::Internal

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception  that will be thrown if any internal error occurs in the transit 
libraries

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

=head1 NACL::Transit::Exceptions::Internal

=head2 Expected use

For internal use only. An exception for when an internal error occurs in the 
transit libraries

=head2 Usage

Same as for exceptions defined by BaseException

=head2 Base Class

NATE::BaseException

=cut

package NACL::Transit::Exceptions::Internal;
use base qw(NACL::Transit::Exceptions::TransitException);
1;
