#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown if
##          the a timeout occurs while listening for some ouptut
##          on the service
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::Transit::Exceptions::Timeout

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception to be thrown if a timeout occurs while listening for some ouptut 
on the service. This is an internal exception.

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

=head1 NACL::Transit::Exceptions::Timeout

=head2 Expected use

Internal use only for when a timeout occurs while listening for some ouptut 
on the service.

=head2 Usage

Same as for exceptions defined by BaseException

=head2 Base Class

NATE::BaseException

=cut

package NACL::Transit::Exceptions::Timeout;
use base qw(NACL::Transit::Exceptions::TransitException);
1;
