#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown if the required transit
##          operation did not proceed in the way it is supposed to or when it
##          cannot proceed.
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::Transit::Exceptions::TransitException

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

For when the required transit operation did not proceed in the way it is 
supposed to or when it cannot proceed.

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

=head1 NACL::Transit::Exceptions::TransitException

=head2 Expected use

For when the required transit operation did not proceed in the way it is 
supposed to or when it cannot proceed.

=head2 Usage

Same as for exceptions defined by BaseException

=head2 Base Class

NATE::BaseException

=cut

package NACL::Transit::Exceptions::TransitException;
use base qw(NATE::BaseException);
1;
