#
# Copyright (c) 2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown if we get an unexpected eof
##          while reading from the connection
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::Transit::Exceptions::UnexpectedEOF

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception to be thrown if we get an unexpected eof while reading from the 
connection

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

=head1 NACL::Transit::Exceptions::UnexpectedEOF

=head2 Expected use

An exception to be thrown if we get an unexpected eof while reading from the 
connection

=head2 Usage

Same as for exceptions defined by BaseException

=head2 Base Class

NATE::BaseException

=cut

package NACL::Transit::Exceptions::UnexpectedEOF;
use base qw(NACL::Transit::Exceptions::TransitException);
1;
