#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::Aggregate::WaflIron;

use strict;
use warnings;

use parent qw( NACL::AppBuilder::Xgen::Config::ONTAP );

use constant NUMBER_OF_AGGRS_TO_WAFLIRON => 1;

use NACL::AppBuilder::Xgen::Resource::Aggregate::WaflIron;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    # Call to generate wafliron resources.
    $self->generate_wafliron_resources(%args);

}

sub generate_wafliron_resources {
    my ($self, %args) = @_;

    my $aggr_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Aggregate");
    my @aggrs = @{$aggr_resources};
    my @wafliron;

    for (my $i = 0; $i < NUMBER_OF_AGGRS_TO_WAFLIRON; $i++) {
        my $aggr = shift(@aggrs);
        push(@aggrs, $aggr);

        my $wafliron_res = NACL::AppBuilder::Xgen::Resource::Aggregate::WaflIron->new( aggregate => $aggr->get_attribute("aggregate"));

        # connect the wafliron resource to the aggr's parent resource
        $wafliron_res->add_parent_resources(resources => [$aggr]);

        push(@wafliron, $wafliron_res);
    }
    $self->add_resources(resources => \@wafliron);
}

1;

