#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::Fpolicy::ExternalEngineConnection;

use strict;
use warnings;

use parent qw( NACL::UnitTest::AppBuilder::Xgen::Config::Fpolicy::FpolicyEnable );

use NACL::AppBuilder::Xgen::Resource::Fpolicy::ExternalEngineConnection;

# These are the constant values that determine what happens in the config.
use constant TOTAL_VSERVER_COUNT => 1;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    $self->generate_ext_engine_conn_resources(%args);

}

sub generate_ext_engine_conn_resources{
    my ($self, %args) = @_;

    my $fpolicy_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Fpolicy::Enable");
    my @fpolicy =  @{$fpolicy_resources};

    my $conn_res = NACL::AppBuilder::Xgen::Resource::Fpolicy::ExternalEngineConnection->new(vserver => "vs0",#$fpolicy[0]->get_attribute("vserver"),
                                                                                            'policy-name' => $fpolicy[0]->get_attribute("policy-name"),
                                                                                            'node' => 'sti13-vsim-ucs401m',
                                                                                            'server' => "1.1.1.1",
                                                                                            );

    # connect the vs resource to the aggr's cluster parent resource
    $conn_res->add_parent_resources(resources => [$fpolicy[0]]);
    $self->add_resources(resources => [$conn_res]);
}

1;
