#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::Fpolicy::Fpolicy;

use strict;
use warnings;

use parent qw( NACL::UnitTest::AppBuilder::Xgen::Config::Vserver );

use NACL::AppBuilder::Xgen::Resource::Vserver;
use NACL::AppBuilder::Xgen::Resource::Fpolicy::Policy;

# These are the constant values that determine what happens in the config.
use constant TOTAL_VSERVER_COUNT => 1;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    $self->generate_fpolicy_resources(%args);

}

sub generate_fpolicy_resources{
    my ($self, %args) = @_;

    my $vserver_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Vserver");
    my @vservers =  @{$vserver_resources};

    my $fpolicy_res = NACL::AppBuilder::Xgen::Resource::Fpolicy::Policy->new(vserver => $vservers[0]->get_attribute("vserver"),
                                                                             'policy-name' => "netapp",
                                                                             'events' => "event1",
                                                                             'engine' => "netapp",
                                                                            );

    # connect the vs resource to the aggr's cluster parent resource
    $fpolicy_res->add_parent_resources(resources => [$vservers[0]]);
    $self->add_resources(resources => [$fpolicy_res]);
}

1;

