#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::Fpolicy::FpolicyEnable;

use strict;
use warnings;

use parent qw( NACL::UnitTest::AppBuilder::Xgen::Config::Fpolicy::FpolicyScope );

use NACL::AppBuilder::Xgen::Resource::Fpolicy::Enable;

# These are the constant values that determine what happens in the config.
use constant TOTAL_VSERVER_COUNT => 1;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    $self->generate_fpolicy_enable_resources(%args);

}

sub generate_fpolicy_enable_resources{
    my ($self, %args) = @_;

    my $fpolicy_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Fpolicy::Policy::Scope");
    my @fpolicy =  @{$fpolicy_resources};

    my $fpolicy_enable_res = NACL::AppBuilder::Xgen::Resource::Fpolicy::Enable->new(vserver => $fpolicy[0]->get_attribute("vserver"),
                                                                                    'policy-name' => $fpolicy[0]->get_attribute("policy-name"),
                                                                                    'sequence-number' => "1",
                                                                                    );

    # connect the vs resource to the aggr's cluster parent resource
    $fpolicy_enable_res->add_parent_resources(resources => [$fpolicy[0]]);
    $self->add_resources(resources => [$fpolicy_enable_res]);
}

1;
