#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::Fpolicy::FpolicyScope;

use strict;
use warnings;

use parent qw( NACL::UnitTest::AppBuilder::Xgen::Config::Fpolicy::Fpolicy );

use NACL::AppBuilder::Xgen::Resource::Fpolicy::Policy::Scope;

# These are the constant values that determine what happens in the config.
use constant TOTAL_VSERVER_COUNT => 1;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    $self->generate_fpolicy_scope_resources(%args);

}

sub generate_fpolicy_scope_resources{
    my ($self, %args) = @_;

    my $fpolicy_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Fpolicy::Policy");
    my @fpolicy =  @{$fpolicy_resources};

    my $fpolicy_scope_res = NACL::AppBuilder::Xgen::Resource::Fpolicy::Policy::Scope->new(vserver => $fpolicy[0]->get_attribute("vserver"),
                                                                                          'policy-name' => $fpolicy[0]->get_attribute("policy-name")
                                                                                         );

    # connect the vs resource to the aggr's cluster parent resource
    $fpolicy_scope_res->add_parent_resources(resources => [$fpolicy[0]]);
    $self->add_resources(resources => [$fpolicy_scope_res]);
}

1;
