#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::Igroup::Initiator;

use strict;
use warnings;

use parent qw(NACL::UnitTest::AppBuilder::Xgen::Config::Igroup);

use NACL::AppBuilder::Xgen::Resource::Igroup::Initiator;
use NACL::AppBuilder::Xgen::Resource::Igroup;

use constant INITIATOR_NAME => 'iqn.1995-08.com.example:string';


sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    #Call to add initiator list to igroup
    $self->generate_initiator_resources(%args);
}

sub generate_initiator_resources {
    my ($self, %args) = @_;
    my $igroup_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Igroup");
    my @igroups = @{$igroup_resources};
    my $igroup = shift @igroups;

    my $igroup_name = $igroup->get_attribute("igroup");
    my $vserver_name = $igroup->get_attribute("vserver");

    my $initiator_resource = NACL::AppBuilder::Xgen::Resource::Igroup::Initiator->new(
           'vserver'   => $vserver_name,
           'igroup'    =>  $igroup_name,
           'initiator' => $self->INITIATOR_NAME,
       );
    $initiator_resource->add_parent_resources(resources => [$igroup]);
    $self->add_resources(resources => [ $initiator_resource ]);
}
1;
