#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::Portset;

use strict;
use warnings;

use parent qw(NACL::UnitTest::AppBuilder::Xgen::Config::Vserver);
use NACL::AppBuilder::Xgen::Resource::Portset;
use constant PORTSET_NAME => 'test_portset';

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);
    $self->generate_portset_resources(%args);
}


sub generate_portset_resources {
    my ($self, %args) = @_;
    my $vserver_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Vserver");
    my @vservers = @{$vserver_resources};
    my $vserver= shift @vservers;
    my $vserver_name = $vserver->get_attribute('vserver');

    my $portset_resource = NACL::AppBuilder::Xgen::Resource::Portset->new(
           'portset'  => $self->PORTSET_NAME,
           'vserver'  => $vserver_name,
       );
   $portset_resource->add_parent_resources(resources => [$vserver]);
   $self->add_resources(resources => [ $portset_resource ]);
}
1;
