#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::SecurityLogin;

use strict;
use warnings;

use parent qw(NACL::UnitTest::AppBuilder::Xgen::Config::Vserver);

use NACL::AppBuilder::Xgen::Resource::SecurityLogin;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);
    $self->generate_security_login_resources(%args);
}

sub generate_security_login_resources {
    my ($self, %args) = @_;
    my $vserver_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Vserver");
    my @vservers = @{$vserver_resources};
    my $vserver = shift @vservers;
    my $vserver_name = $vserver->get_attribute("vserver");

    my $security_login_resource = NACL::AppBuilder::Xgen::Resource::SecurityLogin->new(
           'vserver'  => 'vs0',
           'user-or-group-name' => 'ramya',
           'application' => 'ssh',
           'authmethod' => 'password',
           password => 'netapp1!',
       );
   $security_login_resource->add_parent_resources(resources => [$vserver]);
   $self->add_resources(resources => [ $security_login_resource ]);
}

1;
