
#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::SnapmirrorInitialize;

use strict;
use warnings;
use Data::Dumper qw(Dumper);

use parent qw( NACL::UnitTest::AppBuilder::Xgen::Config::Snapmirror);

use NACL::AppBuilder::Xgen::Resource::SnapmirrorInitialize;


use constant TOTAL_VSERVER_COUNT => 2;
use constant TOTAL_VOLUME_COUNT => 2;
use constant TOTAL_SNAPMIRROR_COUNT => 1;


sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);
    #Call to initialize snapmirror relationship
    $self->initialize_snapmirror_resources(%args);
}



sub initialize_snapmirror_resources {
    my ($self, %args) = @_;

    my $snapmirror_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Snapmirror");
    my @snapmirrors = @{$snapmirror_resources};
    my $snapmirror = shift @snapmirrors;

    my $src_volume = $snapmirror->get_attribute("source-volume");
    my $dst_volume = $snapmirror->get_attribute("destination-volume");
    my $src_vserver = $snapmirror->get_attribute("source-vserver");
    my $dst_vserver = $snapmirror->get_attribute("destination-vserver");
    my $snapmirror_initialize = NACL::AppBuilder::Xgen::Resource::SnapmirrorInitialize->new(
           'source-volume'        => $src_volume,
           'source-vserver'       => $src_vserver,
           'destination-volume'   => $dst_volume,
           'destination-vserver'  => $dst_vserver,
    );
    $snapmirror_initialize->add_parent_resources(resources => [$snapmirror]);
    push(my @snapmirror_initialize,$snapmirror_initialize);
    $self->add_resources(resources => \@snapmirror_initialize);

}
1;
