#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::Volume_Efficiency;

use strict;
use warnings;

use parent qw(NACL::UnitTest::AppBuilder::Xgen::Config::Volume);

use NACL::AppBuilder::Xgen::Resource::Volume::Efficiency;

use constant TOTAL_VOLUME_COUNT => 2;
use constant TOTAL_EFFICIENCY_COUNT => 2;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    #Call to enable volume efficiency
    $self->generate_volume_efficiency_resources(%args);
}



sub generate_volume_efficiency_resources {
    my ($self, %args) = @_;

    my $volume_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Volume");
    my @volume_resources = @{$volume_resources};
    my (@sis, $volume, $efficiency_resource);

    for( my $count = 0; $count < TOTAL_EFFICIENCY_COUNT; $count++ ) {
        $volume = shift @volume_resources;
        $efficiency_resource = NACL::AppBuilder::Xgen::Resource::Volume::Efficiency->new(
            volume   => $volume->get_attribute("volume"),
            vserver  => $volume->get_attribute("vserver"),
        );
        $efficiency_resource->add_parent_resources(resources => [$volume]);
        push(@sis,$efficiency_resource);
    }
    $self->add_resources(resources => \@sis);
}
1;
