#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::VserverVscanOnAccessPolicy;

use strict;
use warnings;

use parent qw(NACL::UnitTest::AppBuilder::Xgen::Config::Vserver);

use NACL::AppBuilder::Xgen::Resource::Vscan::OnAccessPolicy;

use constant POLICY_NAME => 'test_policy';


sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);
    #Call to create on access policy 
    $self->generate_on_access_resources(%args);
}

sub generate_on_access_resources {
    my ($self, %args) = @_;
    my $vserver_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Vserver");
    my @vservers = @{$vserver_resources};
    my $vserver = shift @vservers;
    my $vserver_name = $vserver->get_attribute("vserver");

    my $on_access_resource = NACL::AppBuilder::Xgen::Resource::Vscan::OnAccessPolicy->new(
           'vserver'  => $vserver_name,
           'policy-name'   => $self->POLICY_NAME,
           'protocol' => 'cifs'
       );
   $on_access_resource->add_parent_resources(resources => [$vserver]);
   $self->add_resources(resources => [ $on_access_resource ]);
}
1;
