#!/usr/software/bin/perl5.14.0

use strict;
use warnings;

use NACL::MTask::MCC::Menu;
use Test::More tests => 2, import => ['!subtest'];

use Test::MockObject;
use Test::MockObject::Extends;

MAIN: {
    test_mcc_filer();
}

sub test_mcc_filer {
    my $mprint_out = '';

    {
        no warnings 'redefine';

        *NACL::MTask::MCC::Menu::mprint = sub {
            $mprint_out .= join( '', @_ );
        };

    }

    my $menu = NACL::MTask::MCC::Menu->new( name => 'test', );

    $menu = Test::MockObject::Extends->new($menu);

    my $get_logs_nodes;

    $menu->set_series( 'get_input', '', 's' )
      ->set_always( 'get_variable', ['dpg-mcc'] )->mock(
        '_get_logs',
        sub {
            my $self = shift;
            my %in   = @_;
            $get_logs_nodes = $in{'nodes'};
        }
      );

    $menu->save_logs();

    $menu->called_ok('_get_logs');

    is_deeply(
        $get_logs_nodes,
        ['dpg-mcc.gdl.englab.netapp.com'],
        'node was expanded'
    );
}
