#!/usr/software/bin/perl5.14.0

use strict;
use warnings;

use Test::Most import => ['!subtest'];

use NACL::UnitTest::MTask::MCC::MockObject;
use NACL::UnitTest::MTask::MCC::TestUtils ':all';
use Carp;
use Params::Validate
    qw(validate validate_with BOOLEAN HASHREF OBJECT ARRAYREF SCALAR UNDEF);

MAIN: {
    test_use_mcc();
    test_validate_outage_window_latency();
    done_testing();
}

sub test_validate_outage_window_latency {

    my $drc = make_dr_coordinator();

    $drc->set_always('get_DR_state', 'switchover_completed');

    my ($cs_mod, $mock_cs) = mock_component_state_fetch(
        cs_class => 'NACL::CS::Statistics',
        cs_states => { 'value' => '25967ms' }
    );

    my ($comment, $warn) = ('', '');

    # Our mock log
    my $log = NATE::Log->new();

    $log->mock('comment', sub { $comment .= "$_[1]\n" });
    $log->mock('warn', sub { $warn .= "$_[1]\n" });

    $drc->validate_outage_window_latency();

    like($comment, qr/'25967'/, 'Found statistic');

}



